{     ,  
SysUtils, Classes,  ,    Exception, TList,
TStrings}


{---    --------------------------------------------------------}

{  }
type
  TListAndStrings = record
    Ptr: Pointer;           {}
    PtrEx: Pointer;         { }
    PtrExAlt: Pointer;      {  }
    List: TList;            {}
    ListEx: TList;          { }
    ListExAlt: TList;       {  }
    Strings: TStrings;      {}
    StringsEx: TStrings;    { }
    StringsExAlt: TStrings; {  }
  end;
  PListAndStrings = ^TListAndStrings;
{    StrBlock   Fields    Values,
Mode   , Params  ,  
GVCLUtil.StrBlockToListView}
type
  TStrBlockToFieldsValuesEvent = procedure(Sender: TObject;
    const StrBlock: string; Fields, Values: TStrings; const Mode,
    Params: string) of object;



{---    -----------------------------------------}

{ E   Exception  ,   
      - ,  ,  
   E,  NotIncludeClass = True    
  }
function ExceptionMessage(E: TObject; NotIncludeClass: Boolean): string;
{   ,   TExceptionEventProc,
     Error   ,  
   Exception   , Sender  ,
  ,    TCustomClassForm   ,
     ,  ,  
,  }
procedure ExceptionEventProc(Sender, Error: TObject);
{  Error,   Exception,  
   , ParentWindow   , Title 
 ,     }
procedure HandleException(ParentWindow: HWND; const Title: string;
  Error: TObject);

{ }
type
  EExceptionClass = class of Exception;
{    Msg,   ExceptionClass, 
, 'ERR'  DebugInfo.DebuggingClasses}
function ExceptionCreate(const Msg: string;
  ExceptionClass: EExceptionClass): Exception;
{ ValueIfTrue,  IfCase  True  ValueIfFalse 
  }
function IIfExceptionClass(IfCase: Boolean; const ValueIfTrue,
  ValueIfFalse: EExceptionClass): EExceptionClass;

{ ,        
   IsSysDebug  True (ExceptionDbg);  
(ExceptionStd)}
type
  ExceptionDbg = class(Exception)
  private
  protected
  public
    constructor Create(const Msg: string);
    destructor Destroy; override;
  end;
  ExceptionStd = {$IFNDEF NODEBUG_SYS} ExceptionDbg {$ELSE} Exception {$ENDIF};
{  ,        
   IsSysDebug  True (EConvertErrorDbg);  
 (EConvertErrorStd)}
type
  EConvertErrorDbg = class(Exception)
  private
  protected
  public
    constructor Create(const Msg: string);
    destructor Destroy; override;
  end;
  EConvertErrorStd = {$IFNDEF NODEBUG_SYS} EConvertErrorDbg
    {$ELSE} EConvertError {$ENDIF};

{     ,  }
type
  ENumProcError = class(ExceptionStd)
  private
    FSourMsg: string;
    FErrorCode: Integer;
    FProcName: string;
  protected
  public
    {  (SourMsg);   (ErrorCode);  
    (ProcName)}
    property SourMsg: string read FSourMsg write FSourMsg;
    property ErrorCode: Integer read FErrorCode write FErrorCode;
    property ProcName: string read FProcName write FProcName;
  end;
  ENumProcErrorClass = class of ENumProcError;
{    Msg,    ErrorCode   
ProcName,    ,  NumProcErrorClass,   nil,
 MsgOnly = True      Msg}
function NumProcErrorCreate(const Msg: string; ErrorCode: Integer;
  const ProcName: string; NumProcErrorClass: ENumProcErrorClass;
  MsgOnly: Boolean): ENumProcError;

{ Windows API}
type
  EWinAPIError = class(ENumProcError)
  private
    FWinErrorMsg: string;
  protected
  public
    { Windows  }
    property WinErrorMsg: string read FWinErrorMsg write FWinErrorMsg;
  end;
  EWinAPIErrorClass = class of EWinAPIError;
{  Windows API   Msg  ,  Windows,
   ErrorCode      
ProcName,    ,  NumProcErrorClass,  nil
  EWinAPIError,  MsgOnly = True   
  Msg}
function WinAPIErrorCreate(const Msg: string; ErrorCode: Integer;
  const ProcName: string; NumProcErrorClass: ENumProcErrorClass;
  MsgOnly: Boolean): ENumProcError;
{   Windows   Msg,  ProcName
(HandleWinAPIError); ,   ,   ,  
  Windows   Msg,  ProcName (CheckWinAPIError)}
procedure HandleWinAPIError(const Msg, ProcName: string);
procedure CheckWinAPIError(const Msg, ProcName: string);

{ "  "}
type
  ECanceled = class(ExceptionStd);

{ "  "}
type
  ENotSupported = class(ExceptionStd);

{  ,  ,  ,   }
type
  ENumProcClassError = class(ENumProcError)
  private
    FErrorClass: string;
  protected
  public
    {  }
    property ErrorClass: string read FErrorClass write FErrorClass;
  end;
  ENumProcClassErrorClass = class of ENumProcClassError;
{    Msg,    ErrorCode,  
ProcName,    ,    ErrorClass,  
   -  NumProcClassErrorClass,  MsgOnly = True
     Msg}
function NumProcClassErrorCreate(const Msg: string; ErrorCode: Integer;
  const ProcName, ErrorClass: string;
  NumProcClassErrorClass: ENumProcClassErrorClass;
  MsgOnly: Boolean): ENumProcClassError;

{   E (ExceptionSourMsg);    E
(ExceptionProcName);   E (ExceptionErrorCode);   E
(ExceptionErrorClass)}
function ExceptionSourMsg(E: TObject): string;
function ExceptionProcName(E: TObject): string;
function ExceptionErrorCode(E: TObject): Integer;
function ExceptionErrorClass(E: TObject): string;
{        (TExceptionDetails);
   ,     (TExceptionInfo)}
type
  TExceptionDetails = record
    SourMsg: string;
    ProcName: string;
    ErrorCode: Integer;
    ErrorClass: string;
  end;
  TExceptionInfo = record
    ErrorMsg: string;
    Details: TExceptionDetails;
  end;
{     E}
function ExceptionDetails(E: TObject): TExceptionDetails;

{     }
type
  EExceptionInfo = class(ENumProcClassError)
  private
    FErrorTime: TDateTime;
    FGlbProc: string;
  protected
  public
    {  (ErrorTime);  ,   
     (GlbProc)}
    property ErrorTime: TDateTime read FErrorTime write FErrorTime;
    property GlbProc: string read FGlbProc write FGlbProc;
  end;
  EExceptionInfoClass = class of EExceptionInfo;
{      Msg,   SourMsg,
 ErrorCode,  ProcName,   ErrorClass, 
ErrorTime,   GlbProc,  ExceptionInfoClass, 
 nil (ExceptionInfoCreate);    E    
, ,   GlbProc (ExceptionClone)}
function ExceptionInfoCreate(const Msg, SourMsg: string; ErrorCode: Integer;
  const ProcName, ErrorClass: string; ErrorTime: TDateTime; const GlbProc:
  string; ExceptionInfoClass: EExceptionInfoClass): EExceptionInfo;
function ExceptionClone(E: TObject; const GlbProc: string): EExceptionInfo;

{     }
type
  EExceptionList = class(ExceptionStd);
{      MsgList, BaseOperationNum - ,
    ,  1 (ExceptionListCreateByMsgList);
      MsgArray,   
GetStrFromArray, BaseOperationNum - ,    
,  1 (ExceptionListCreateByMsgArray);    
 ExceptionList, BaseOperationNum - ,    
,  1 (ExceptionListCreate)}
function ExceptionListCreateByMsgList(MsgList: TStrings;
  BaseOperationNum: Integer): EExceptionList;
function ExceptionListCreateByMsgArray(MsgArray: string;
  BaseOperationNum: Integer): EExceptionList;
function ExceptionListCreate(ExceptionList: TList;
  BaseOperationNum: Integer): EExceptionList;

{   ,    GetStrFromArray   
  (TExceptionsDetails, TExceptionsDetailsLists);
    (TExceptionsInfo, TExceptionsInfoLists);
    (TResultInfo, TResultInfoLists)}
type
  TExceptionsDetails = record
    SourMsgs: string;
    ProcNames: string;
    ErrorCodes: string;
    ErrorClasses: string;
  end;
  TExceptionsDetailsLists = record
    SourMsgList: TStrings;
    ProcNameList: TStrings;
    ErrorCodeList: TList;
    ErrorClassList: TStrings;
  end;
  TExceptionsInfo = record
    ErrorMsgs: string;
    Details: TExceptionsDetails;
  end;
  TExceptionsInfoLists = record
    ErrorMsgList: TStrings;
    DetailsLists: TExceptionsDetailsLists;
  end;
  TResultInfo = record
    ResultStr: string;
    Errors: TExceptionsInfo;
  end;
  TResultInfoLists = record
    ResultList: TStrings;
    ErrorList: TExceptionsInfoLists;
  end;
{   Value (ExceptionsDetails, ExceptionsInfo, ResultInfo)}
procedure InitExceptionsDetails(out Value: TExceptionsDetails);
procedure InitExceptionsInfo(out Value: TExceptionsInfo);
procedure InitResultInfo(out Value: TResultInfo);
{    Value  TExceptionsDetailsLists,
TExceptionsInfoLists, TResultInfoLists, 
(ClearExceptionsDetailsLists, ClearExceptionsInfoLists, ClearResultInfoLists);
     Value  TExceptionsDetailsLists,
TExceptionsInfoLists, TResultInfoLists, 
(CreateExceptionsDetailsLists, CreateExceptionsInfoLists,
CreateResultInfoLists);      Value 
TExceptionsDetailsLists, TExceptionsInfoLists, TResultInfoLists, 
(FreeExceptionsDetailsLists, FreeExceptionsInfoLists, FreeResultInfoLists)}
procedure ClearExceptionsDetailsLists(const Value: TExceptionsDetailsLists);
procedure ClearExceptionsInfoLists(const Value: TExceptionsInfoLists);
procedure ClearResultInfoLists(const Value: TResultInfoLists);
procedure CreateExceptionsDetailsLists(var Value: TExceptionsDetailsLists);
procedure CreateExceptionsInfoLists(var Value: TExceptionsInfoLists);
procedure CreateResultInfoLists(var Value: TResultInfoLists);
procedure FreeExceptionsDetailsLists(var Value: TExceptionsDetailsLists);
procedure FreeExceptionsInfoLists(var Value: TExceptionsInfoLists);
procedure FreeResultInfoLists(var Value: TResultInfoLists);
{     ExceptionDetails   
  ExceptionsDetails  ExceptionsDetailsLists , 
       AddExceptionDetails 
 ,        (AddExceptionDetails,
ListAddExceptionDetails);     E   
ErrorMsgs  ErrorMsgList ,  AddExceptionSeparate 
  GetStrFromArray,   ExceptionsDetails,  E 
nil,     ,    ,  E
  nil  ,     ,  
      ,  ListAddExceptionSeparate
,  -    (AddExceptionSeparate,
ListAddExceptionSeparate);      E 
    ExceptionsInfo  ExceptionsInfoLists
 (AddException, ListAddException)}
procedure AddExceptionDetails(const ExceptionDetails: TExceptionDetails;
  var ExceptionsDetails: TExceptionsDetails);
procedure ListAddExceptionDetails(const ExceptionDetails: TExceptionDetails;
  const ExceptionsDetailsLists: TExceptionsDetailsLists);
procedure AddExceptionSeparate(E: TObject; var ErrorMsgs: string;
  var ExceptionsDetails: TExceptionsDetails);
procedure ListAddExceptionSeparate(E: TObject; ErrorMsgList: TStrings;
  const ExceptionsDetailsLists: TExceptionsDetailsLists);
procedure AddException(E: TObject; var ExceptionsInfo: TExceptionsInfo);
procedure ListAddException(E: TObject;
  const ExceptionsInfoLists: TExceptionsInfoLists);

{    E   ;  E = nil,   
   ,     
ExceptionInfoType = 'MSG',    'PROC',   'CODE', 
 'CLASS',    dd.mm.yyyy hh:nn:ss.zzz  'TIME', 
,       'GLBPROC', 
    'LIB'}
function GetExceptionInfo(E: EExceptionInfo;
  const ExceptionInfoType: string): string;
{  E,   ,   , 
        DebugInfo, 
LastError,  IsRaiseException     
  , GlbProc   ,   
, DebugClass    ,   'ERROR'}
function HandleError(E: TObject; GlbProc: string;
  IsRaiseException: Boolean; var DebugInfo: TDebugInfo;
  var LastError: EExceptionInfo; const DebugClass: string): string;
{    Lib    GetLastError(''),
GetLastError('MSG'), GetLastError('PROC'), GetLastError('CODE'),
GetLastError('CLASS'), GetLastError('TIME'), GetLastError('GLBPROC'), 
   nil}
function LibExceptionInfo(const Lib: Variant): EExceptionInfo;

type
  {  ( ,  )}
  EIdError = class(ExceptionStd);
  { }
  EFormatError = class(ExceptionStd);

{   }
type
  TErrorObject = class(TObjectStd)
  private
    FIsFileSafe: Boolean;
    FFileSafeInfo: TFileSafeInfo;
    FReadOnlyFileSafeInfo: TFileSafeInfo;
    FWriteOnlyFileSafeInfo: TFileSafeInfo;
    FIsExceptionOnError: Boolean;
    FLastExceptionInfo: EExceptionInfo;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {        , 
    IsExceptionOnError      , 
     IsExceptionOnError = False,  IsShowMessage  
     ,   IsShowMessage = False,   LogFileName
          ,     '.',  
         ,   LogFileName = '',
    DebuggingClasses    ,    
     , '*' -  ,   DebuggingClasses = ''}
    procedure DefineLogging(IsExceptionOnError, IsShowMessage: Boolean;
      const LogFileName, DebuggingClasses: string);
    {    }
    procedure ClearLastError;
    {  ErrorInfoType     , 
    GGlbUtil.GetExceptionInfo}
    function GetLastError(const ErrorInfoType: string): string;
    {  E,      GlbProc}
    procedure ErrorHandle(const GlbProc: string; E: TObject);
    {  E,      GlbProc,
        'ERR'}
    procedure ErrHandle(const GlbProc: string; E: TObject);
    {}
    {      (IsFileSafe); 
            (FileSafeInfo); 
           (ReadOnlyFileSafeInfo);
           
    (WriteOnlyFileSafeInfo)}
    property IsFileSafe: Boolean read FIsFileSafe write FIsFileSafe;
    property FileSafeInfo: TFileSafeInfo
      read FFileSafeInfo write FFileSafeInfo;
    property ReadOnlyFileSafeInfo: TFileSafeInfo
      read FFileSafeInfo write FFileSafeInfo;
    property WriteOnlyFileSafeInfo: TFileSafeInfo
      read FFileSafeInfo write FFileSafeInfo;
    {      (IsExceptionOnError);
        (LastExceptionInfo)}
    property IsExceptionOnError: Boolean read FIsExceptionOnError;
    property LastExceptionInfo: EExceptionInfo read FLastExceptionInfo;
  end;

{  ,       
    IsSysDebug  True (TPersistentDbg); 
  (TPersistentStd)}
type
  TPersistentDbg = class(TPersistent)
  private
  protected
  public
    constructor Create;
    destructor Destroy; override;
  end;
  TPersistentStd = {$IFNDEF NODEBUG_SYS} TPersistentDbg {$ELSE} TPersistent
    {$ENDIF};



{---     ------------------------------------------------}

{ BufCount        SourBufs  
        DestBufs, 
BlockDirectRead      Windows 9x   
  ZwOpenSection  Windows NT/2000  ,  BlockDOSExeUse
        DOS Exe,
  ,      
  ,    
,  True,       
  ,   }
function ReadPhysicalMemory(BufCount: Integer; SourBufs, DestBufs:
  PBufInfoArray; BlockDirectRead, BlockDOSExeUse: Boolean): Boolean;

{     TSizedBufInfo,   nil,
SizedBufList,   nil,  ClearOnly  True  
    }
procedure FreeSizedBufList(SizedBufList: TList; ClearOnly: Boolean);



{---   ------------------------------------------------------}

{  S   ,   - EConvertError
(StrToBool),    V (VarToBool)}
function StrToBool(const S: string): Boolean;
function VarToBool(const V: Variant): Boolean;
{  S       ,
 Null,        
 ,  Null,   - EConvertError
(StrToNullBool),    V (VarToNullBool)}
function StrToNullBool(const S: string): TNullBool;
function VarToNullBool(const V: Variant): TNullBool;



{---   -------------------------------------------------------}

{  S,      ScaleOfNotation, 
 Value,     High(Integer)  
IsUnsigned  True,    = False, Value = 0,
IsUnsigned^ = False,  AllowUnsigned = True   High(Integer)
 ,  IsUnsigned    nil,   , 
  IsUnsigned,   ,   
  EConvertError}
function SNumToInt(const S: string; ScaleOfNotation: Integer;
  AllowUnsigned: Boolean; IsUnsigned: PBooleanStd): Integer;
{     S  ,   
, ,   '$'  '0x',   - EConvertError}
function DecToInt(const S: string): Integer;
{     S  ,   -
EConvertError,      '+' (StrToUnsignedInt);
      S  , 
 - EConvertError,     '+' (HexToUnsignedInt)}
function StrToUnsignedInt(const S: string): Cardinal;
function HexToUnsignedInt(const S: string): Cardinal;
{  S   Value,   - EConvertError, 
    ,  ,  High(Integer)
(VarToInt),     V (VarToInt)}
function StrToIntStd(const S: string): Integer;
function VarToInt(const V: Variant): Integer;
{  S       ,
 Null,        
 ,  Null,   
  EConvertError (StrToNullInt),  
  V (VarToNullInt)}
function StrToNullInt(const S: string): TNullInt;
function VarToNullInt(const V: Variant): TNullInt;

{      Value, ,
       , DecSep  
    , Digits   ,  Format,
 Null,  CurrToStrF,  FormatCurr  
Format,    
(FloatToStrThousandsFormat, CurrToStrThousandsFormat);   
      ,    ,
 CurrToStrF (CurrToStrThousands); ,   
 Value   ,     
    (VarCurrToStrThousands); ,    
 (CurrToStrThousandsInt)}
function FloatToStrThousandsFormat(Value: Extended; Digits: Integer;
  DecSep: Char; Format: TNullStr): string;
function CurrToStrThousandsFormat(Value: Currency; Digits: Integer;
  DecSep: Char; Format: TNullStr): string;
function CurrToStrThousands(Value: Currency): string;
function VarCurrToStrThousands(const Value: Variant): string;
function CurrToStrThousandsInt(Value: Currency): string;
{  S   ,     
     ,   '.', ',', '=', '-',
  - EConvertError (StrToFloatStd),   
 (StrToCurrStd),    V (VarToFloat, VarToCurr)}
function StrToFloatStd(const S: string): Extended;
function StrToCurrStd(const S: string): Currency;
function VarToFloat(const V: Variant): Extended;
function VarToCurr(const V: Variant): Currency;
{  S       ,
 Null,        
 ,  Null,   
  EConvertError (StrToNullFloat),   
(StrToNullCurr),    V (VarToNullFloat, VarToNullCurr)}
function StrToNullFloat(const S: string): TNullFloat;
function StrToNullCurr(const S: string): TNullCurr;
function VarToNullFloat(const V: Variant): TNullFloat;
function VarToNullCurr(const V: Variant): TNullCurr;

{ Guid     OLE}
function GuidToStrStd(Guid: TGuid): string;
{   ( ); LastId - 
; UsingIds -   ; IsCheck
,        UsingIds, 
IsCheck = False   LastId   ,  
    UsingIds  ,   
, IsCheck   True,  
  1,  IsCheck = True    
     UsingIds,    UsingIds
,    1   ;  
 ,  EIdError}
function CreateNewId(LastId: Integer; UsingIds: TList;
  var IsCheck: Boolean): Integer;
{   }
function GenerateGuid: TGuid;
{      , 
NoBraces = True  GUID    }
function GenerateGuidStr(NoBraces: Boolean): string;
{      , 
   }
function GenerateGuidHex: string;
{        }
function GenerateGuidBin: string;
{  ,   GUID  
 8        Windows, 
40 }
function GetUniqueId: string;
{ 28-     ,
 4       ,  4  
   ,  4   
   Windows,  16   GUID  
,     100   
       ,   
    CalcCRC   4-  
    }
function GetUniqueBin: string;
{    Mode    Base}
function GenIdMode(Mode: TIdMode; const Base: string): string;
{   MIME,    
yymmddhhnnss, , 8   
CalcCRC(GetUniqueBin), , 8    IP,
 "@",   , DivStr  , ,
'$'  '.', MaxLen,    ,   
,    ,    
      30 + 2 * Length(DivStr), , 40,
SocketAPI  ,     
 IP    IP,     
(MIMEMessageId);    MIME  
  ,   ,  
    'zzz', 'ssnn'  'hhddmmyy'   
,    8   
CalcCRC(GetUniqueBin), Prefix  , , '----=_NextPart_',
DivStr  , , '_', LastDivStr  
, , '.' (MIMEMultipartId)}
function MIMEMessageId(const DivStr: string; MaxLen: Integer;
  SocketAPI: TSocketAPI): string;
function MIMEMultipartId(const Prefix, DivStr, LastDivStr: string): string;



{---      ---------------------------------------------}

{    , 
DateTimeStrPrepare,     WinDateTime,   
  SInvalidDateTime}
function StrToWinDateTime(const S: string): TSystemTime;
{   S  Format,   
StrToWinDateTimeFormatConv       ,  
   SInvalidDateTime}
function StrToWinDateTimeFormat(const S, Format: string): TSystemTime;
{    , 
GGlbUtil.DateTimeStrPrepare,     DateTime,   
  EConvertError (StrToDateTimeStd),  
 V (VarToDateTime)}
function StrToDateTimeStd(const S: string): TDateTime;
function VarToDateTime(const V: Variant): TDateTime;
{   S  Format,   
GGlbUtil.WinDateTimeToStrFormat,        
 ,       Format,  
 ,       Value,  
 EConvertError (StrToDateTimeFormat)}
function StrToDateTimeFormat(const S, Format: string): TDateTime;
{  S        ,
 Null Value,       
  ,  Null,   
False, Value  Null (StrToNullDateTimeConv),   
 Windows (StrToNullWinDateTime),    V
(VarToNullDateTime)}
function StrToNullDateTime(const S: string): TNullDateTime;
function StrToNullWinDateTime(const S: string): TNullWinDateTime;
function VarToNullDateTime(const V: Variant): TNullDateTime;



{---    ----------------------------------------------------}

{  V       ,
 Null Value,   - EConvertError}
function VarToNullStr(const V: Variant): TNullStr;
{  S     AType  Null,   -
EConvertError}
function StrToType(const S: string; AType: TVarBaseType): Variant;

{  FormatStr   Args, 
ArgCount,    16 (FormatByStrings);   
StrArray   ArgStrArray,    16, 
StrArray, ArgStrArray     GetStrFromArray (FormatStrArray);
  FormatStr ArgCount    
ArgsStrArray  GetStrFromArray,    ArgCount
,  FormatStr ,  
  GetStrFromArray,   ArgCount 
 ,      
   (FormatStrRepeat)}
function FormatByStrings(const FormatStr: string; ArgCount: Integer;
  const Args: TStrArray16): string;
function FormatStrArray(const StrArray, ArgStrArray: string): string;
function FormatStrRepeat(const FormatStr: string; ArgCount: Integer;
  const ArgsStrArray: string): string;
{  S     BorderChar  ,
 StrToExportStr,    EConvertError}
function ExportStrToStr(const S: string; BorderChar: Char): string;

{           S
 ,    #13#10  #10, }
function AddLeadingSpace(const S: string): string;
{           
  S,  ,    #13#10  #10,
}
function DeleteLeadingSpace(const S: string): string;
{            S,
 ,    #13#10  #10, }
function DeleteTrailingSpaces(const S: string): string;
{         
      ,      
 ,     S,  , 
  #13#10  #10, }
function DeleteExcessiveSpace(const S: string): string;
{ ,   ,  ,
  ,     ,   
      ,   
          ,  
  ,     S,  , 
  #13#10  #10, }
function NormalizeColumns(const S: string): string;
{   Value        
Space    }
function SpacesToTab(const Value: string; Spaces: Integer): string;

{   }
type
  EPasStrConvertError = class(EConvertErrorStd);
{  ,      
 ;     
EPasStrConvertError}
function PasToStr(const S: string): string;
{ : cmConst -   , cmVariable - 
   , cmResource - -,
cmBinConst -      
, cmBinVariable -      
  , cmBinResource - -
   , cmArray -  
   }
type
  TPasConstMode = (cmConst, cmVariable, cmResource,
    cmBinConst, cmBinVariable, cmBinResource, cmArray);
{  UnitName    ,    
 ConstMode   StrName,    UnitName 
  ,    StrName  
 }
function StrToPasUnit(const S, UnitName, StrName: string;
  ConstMode: TPasConstMode): string;
{       }
procedure StrToPasUnitRun;
type
  {  DFM}
  TBinDFMHeaderInfo = record
    FormName: string;
    DataSize: Integer;
  end;
  {  DFM}
  TTextDFMHeaderInfo = record
    Signature: string;
    Reserved: Integer;
  end;
  { DFM: dfBinary - , dfText - }
  TDFMFormat = (dfBinary, dfText);
  {   DFM}
  TDFMHeaderInfo = record
    Format: TDFMFormat;
    BinHeaderInfo: TBinDFMHeaderInfo;
    TextHeaderInfo: TTextDFMHeaderInfo;
  end;
{  DFM- (EDFMError),  DFM (EBinDFMError),
 DFM (ETextDFMError)}
type
  EDFMError = class(ExceptionStd);
  EBinDFMError = class(EDFMError);
  ETextDFMError = class(EDFMError);
{   Value (InitBinDFMHeaderInfo, InitTextDFMHeaderInfo,
InitDFMHeaderInfo)}
procedure InitBinDFMHeaderInfo(out Value: TBinDFMHeaderInfo);
procedure InitTextDFMHeaderInfo(out Value: TTextDFMHeaderInfo);
procedure InitDFMHeaderInfo(out Value: TDFMHeaderInfo);
{   DFM-;
     }
function ReadBinDFMHeader(DFMStream: TStream): TBinDFMHeaderInfo;
{   DFM- ( 'object ');
     }
function ReadTextDFMHeader(DFMStream: TStream): TTextDFMHeaderInfo;
{  DFM-,  ;
      , 
DFM-  }
function ReadDFMHeader(DFMStream: TStream): TDFMHeaderInfo;
{   DFM-  }
function DFMToStr(DFMStream: TStream): string;
{ DFM-  }
function DFMFileToStr(const FileName: string): string;
type
  { DFM}
  TDFMForm = record
    FormName: string;    { }
    FormType: string;    { }
  end;
  { DFM}
  TDFMItem = record
    ObjectName: string;  { ,   }
    ParamName: string;   { }
    ParamIndex: Integer; {    (-1),  }
    ParamValue: string;  { }
  end;
  PDFMItem = ^TDFMItem;
{   Value (InitDFMForm, InitDFMItem)}
procedure InitDFMForm(out Value: TDFMForm);
procedure InitDFMItem(out Value: TDFMItem);
{  TDFMItem}
type
  TDFMItems = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TDFMItem;
    procedure SetItem(Index: Integer; const Value: TDFMItem);
    function GetItemPtr(Index: Integer): PDFMItem;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TDFMItem): Integer;
    procedure Insert(Index: Integer; const Value: TDFMItem);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TDFMItem read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PDFMItem read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{     DFM-}
function DFMToFormInfo(const DFMStr: string): TDFMForm;
{ DFM-,    DFMStr,   
,   ,    DFMItems,  
StringsOnly = True    }
procedure DFMToDFMItems(const DFMStr: string; StringsOnly: Boolean;
  DFMItems: TDFMItems);
{     ;  FillSpace = True
   }
procedure PasSourceDelComments(PasSource: TStrings; FillSpace: Boolean);
{   (  ),   pas-;
PasUnitsBeg -    , PasUnitsLen -  }
procedure PasSourceGetUnits(const PasSource: string;
  out PasUnitsBeg, PasUnitsLen: Integer; PasUnits: TStringList);
{    pas- (   
  ,    )}
procedure PasSourceAppendUnits(PasSource: TStrings;
  UnitsList: array of const);
{     pas-;    'LineNNNStrNNN'
  StrConstNames,   -  StrConsts;
IncludeRange -  ,     
(   -  ); ExcludeRange -  , 
 ;  : 'AZaz_';
 UpdateSource = True    PasSource}
procedure PasSourceGetStrConsts(PasSource, StrConstNames, StrConsts: TStrings;
  const ConstNamePrefix: string; MinStrLength: Integer;
  const IncludeRange, ExcludeRange: string; UpdateSource: Boolean);
{  ItemType  Pascal    Text,
 IncludeSimilar  True    , 
  IsPasItemTypeSimilar,    Items,   nil,
    Positions,   nil,  SkipEmpty
 True     ,   ,
 SkipFullEng  True    , 
      #128, MinLength  
 ,   ,  WritePos  True 
   , ,  (ExtractPasItems); 
 ItemType  Pascal      Mask,
  ,  SkipFullEng  True 
,        #128,
MinLength    ,     
   ,     
,      (ExtractPasFilesItems)}
function ExtractPasItems(const Text: string; ItemType: TPasItemType;
  IncludeSimilar: Boolean; Items: TStrings; Positions: TList; SkipEmpty,
  SkipFullEng: Boolean; MinLength: Integer; WritePos: Boolean): Integer;
function ExtractPasFilesItems(const Mask: string; ItemType: TPasItemType;
  SkipFullEng: Boolean; MinLength: Integer): string;



{---    ---------------------------------------------------}

{  V  ,   - EConvertError (VarToStrStd);
    (VarToWideStr)}
function VarToStrStd(const V: Variant): string;
function VarToWideStr(const V: Variant): WideString;
{  V     AType  Null,   -
EConvertError}
function VarToType(const V: Variant; AType: TVarBaseType): Variant;
{  FormatStr,   VarArg   VarArgType}
function VarFormat(const FormatStr: string; const VarArg: Variant;
  VarArgType: TVarBaseType): string;



{---     ---------------------------------------------}

{    ,       
    IsSysDebug  True (TListDbg);  
   (TListStd)}
type
  TListDbg = class(TList)
  private
  protected
  public
    constructor Create;
    destructor Destroy; override;
  end;
  TListStd = {$IFNDEF NODEBUG_SYS} TListDbg {$ELSE} TList {$ENDIF};

{     List,    nil,  0
(GetListCount);     List  Count, 
Capacity     Add (SetListCount); 
    NewValue     
Index     Count ,    
List,          
,      , 
   SetListCount,      
  0  Count - 1   
,   ,     
   (GetPointer, SetPointer)}
function GetListCount(List: TList): Integer;
procedure SetListCount(List: TList; Count: Integer);
function GetPointer(List: TList; Index, Count: Integer): Pointer;
procedure SetPointer(var List: TList; Index, Count: Integer;
  NewValue: Pointer);
{    List  ,   CapacityDelta 
    }
procedure ListCapacityDelta(List: TList; CapacityDelta: Integer);
{   List,    nil,    4-
}
function ListToStr(List: TList): string;
{ True,  List      nil (IsEmptyList);
 True,    List   nil (IsAllList)}
function IsEmptyList(List: TList): Boolean;
function IsAllList(List: TList): Boolean;
{        List,
  nil,     MinValue,   nil,
    MaxValue,   nil,  
         0}
procedure ListMinMax(List: TList; MinValue, MaxValue: PInteger);
{  ,   nil,  List,    
  Capacity}
procedure ListClearOrCreate(var List: TList; Capacity: Integer);

{  ,   ObjectList,    FirstIdx 
LastIdx;  IsTruncList = True     FirstIdx;
 IsFreeList = True       ObjectList
 nil}
procedure FreeObjectListRange(var ObjectList: TList;
  FirstIdx, LastIdx: Integer; IsTruncList, IsFreeList: Boolean);
{  ,   ObjectList;  IsFreeList = True 
     ObjectList  nil}
procedure FreeObjectList(var ObjectList: TList; IsFreeList: Boolean);
{   ObjectList  ,    
ObjectIdList    ,     ObjectList; 
True,       ObjectClass;  ObjectIdx
    ( )  (-1)  }
function FindObjectInList(ObjectList, ObjectIdList: TList;
  ObjectClass: TClass; ObjectId: Integer; out ObjectIdx: Integer): Boolean;
{   -  ListObjects  
    }
procedure ClipListsSize(ListObjects: array of const);

{    }
const
  MaxPtrListSize = High(Integer) div SizeOf(Pointer);
{  TLists: TPtrLists -  , TPtrList -   
}
type
  TPtrList = array[0..MaxPtrListSize - 1] of Pointer;
  PPtrList = ^TPtrList;
  TPtrLists = array[0..MaxPtrListSize - 1] of PPtrList;
  PPtrLists = ^TPtrLists;
{   : loUpdate -     
 , loInsert -      
        , loDelete -
      , loNew -  
  ,   ,    , 
   ,     ,  
 c loInsert, loAfterUpdate -    ,
loBeforeInsert -     , loAfterDelete -
   }
type
  TListOperation = (loUpdate, loInsert, loDelete, loNew, loAfterUpdate,
    loBeforeInsert, loAfterDelete);
{   List       
 'h'  ,   ,   }
function ListToShowStr(List: TList): string;

{  }
type
  TLists = class(TObjectStd)
  private
    FLists: PPtrLists;
    FColCapacity: Integer;
    FCapacity: Integer;
    FColCount: Integer;
    FCount: Integer;
  protected
    function CapacityDelta(Capacity: Integer): Integer;
    procedure SetColCapacity(NewColCapacity: Integer);
    procedure SetCapacity(NewCapacity: Integer);
    procedure SetColCount(NewColCount: Integer);
    procedure SetCount(NewCount: Integer);
    function GetItem(ColIndex, Index: Integer): Pointer;
    procedure SetItem(ColIndex, Index: Integer; NewValue: Pointer);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {      (Clear),  
         List,   
    nil,   List   nil,   
     (AddCol),    (Add),  
        ColIndex (InsertCol),   
       Index (Insert),    
    ColIndex (DeleteCol),     Index (Delete)}
    procedure Clear;
    function AddCol(List: TList): Integer;
    function Add(List: TList): Integer;
    procedure InsertCol(ColIndex: Integer; List: TList);
    procedure Insert(Index: Integer; List: TList);
    procedure DeleteCol(ColIndex: Integer);
    procedure Delete(Index: Integer);
    {}
    {   (ColCapacity),   
    (Capacity),   (ColCount),  
    (Count),      ColIndex,   
    Index,    (Items),    (Lists)}
    property ColCapacity: Integer read FColCapacity write SetColCapacity;
    property Capacity: Integer read FCapacity write SetCapacity;
    property ColCount: Integer read FColCount write SetColCount;
    property Count: Integer read FCount write SetCount;
    property Items[ColIndex, Index: Integer]: Pointer
      read GetItem write SetItem; default;
    property Lists: PPtrLists read FLists;
  end;
{   Lists    : , 
#13#10,          'h'  ,
     }
function ListsToShowStr(Lists: TLists): string;

{   }
type
  TIndexedItemInfo = record
    FirstIndex: Integer;
    LastIndex: Integer;
    FirstNumber: Integer;
    LastNumber: Integer;
  end;
{    }
type
  TCustomIndex = class(TObjectStd)
  private
    FDataSource: Pointer;
    FCount: Integer;
    FIsIndexed: Boolean;
    FIndexes: TList;
    FCompareList: TList;
    FPrevNumber: Integer;
    FNextNumber: Integer;
  protected
    {    }
    function GetItemCount: Integer; virtual; abstract;
    {    Item1Index  Item2Index, 
       ,     , 
      ,  }
    function CompareItems(Item1Index,
      Item2Index: Integer): Integer; virtual; abstract;
    {    Item1Index   
     Item2Ptr,  -  CompareItems}
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; virtual; abstract;
    {      , , 
        ,    , 
     ,      }
    procedure UpdateContent; virtual;
    {}
    { ;  IsFindByIndex = True    
    ItemIndex   ,     
     ItemPtr;  IncIndex ,   
           ,
          (+1)     
       Indexes;  SkipNumber   
    ( ),      ;  
      (    ),  
    PrevNumber  NextNumber    Indexes , 
         ,   ;
      , PrevNumber   NextNumber   
     ;   ,    SkipNumber 
    ,    SkipNumber,  PrevNumber  NextNumber 
        ,     2}
    function FindItem(IsFindByIndex: Boolean; ItemIndex: Integer;
      ItemPtr: Pointer; IncIndex, SkipNumber: Integer; out PrevNumber,
      NextNumber: Integer): Integer;
    {}
    function GetDataSource: Pointer;
    procedure SetDataSource(NewDataSource: Pointer);
    function GetCount: Integer;
    function GetIsIndexed: Boolean;
    procedure SetIsIndexed(NewIsIndexed: Boolean);
    function GetIndex(Number: Integer): Integer;
    function GetNumber(Index: Integer): Integer;
    function GetItem(ItemPtr: Pointer): Integer;
    function GetItemInfo(ItemPtr: Pointer): TIndexedItemInfo;
    function GetPrevNumber: Integer;
    function GetNextNumber: Integer;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { ,      - 
    (BuildIndex),   (ClearIndex),   
      Operation   Index  ,
      ,    ,  
        ,       (-1),
              
    ,      CurNumber,    
       ,     NewNumber, 
        CurNumber  NewNumber  (-1)
    (UpdateIndex);       
    ,  }
    procedure BuildIndex;
    procedure ClearIndex;
    function UpdateIndex(Operation: TListOperation; Index, CurNumber,
      NewNumber: Integer): Integer;
    {   Indexes}
    procedure DefineIndex(Indexes: TList);
    {}
    {    (DataSource);  
      (Count);     (IsIndexed); 
           Number,   0
    (Indexes);  ,     (Numbers);
    ,         ItemPtr,
        (-1),   ,   
    PrevNumber  NextNumber   ,   
     ,    ,     
     (Items);     ,  ,
       ItemPtr,     Items
    (ItemsInfo); ,       ,
        Items:     (PrevNumber)
         (NextNumber)}
    property DataSource: Pointer read GetDataSource write SetDataSource;
    property Count: Integer read GetCount;
    property IsIndexed: Boolean read GetIsIndexed write SetIsIndexed;
    property Indexes[Number: Integer]: Integer read GetIndex;
    property Numbers[Index: Integer]: Integer read GetNumber;
    property Items[ItemPtr: Pointer]: Integer read GetItem; default;
    property ItemsInfo[ItemPtr: Pointer]: TIndexedItemInfo read GetItemInfo;
    property PrevNumber: Integer read GetPrevNumber;
    property NextNumber: Integer read GetNextNumber;
  end;

{       }
type
  TCustomColIndex = class(TCustomIndex)
  private
    FIndexedCols: TList;
  protected
    function GetIndexedColCount: Integer;
    procedure SetIndexedColCount(NewIndexedColCount: Integer);
    function GetIndexedCol(Index: Integer): Integer;
    procedure SetIndexedCol(Index, NewColNumber: Integer);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { ,     (IndexedColCount)  
      , Index   0     
      (IndexesCols)}
    property IndexedColCount: Integer
      read GetIndexedColCount write SetIndexedColCount;
    property IndexedCols[Index: Integer]: Integer
      read GetIndexedCol write SetIndexedCol;
  end;

{  }
type
  TListIndex = class(TCustomIndex)
  private
    FCompareUnsigned: Boolean;
    FIndexCompareUnsigned: Boolean;
  protected
    function GetItemCount: Integer; override;
    function CompareItems(Item1Index,
      Item2Index: Integer): Integer; override;
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; override;
    procedure UpdateContent; override;
    {}
    function GetDataSource: TList;
    procedure SetDataSource(NewDataSource: TList);
    function GetCompareUnsigned: Boolean;
    function GetItem(Value: Pointer): Integer;
  public
    constructor Create;
    {}
    {   (DataSource);   - 
      ,  True,    ,  False, 
     False (CompareUnsigned);      Value
    (Items)}
    property DataSource: TList read GetDataSource write SetDataSource;
    property CompareUnsigned: Boolean
      read GetCompareUnsigned write FCompareUnsigned;
    property Items[Value: Pointer]: Integer read GetItem; default;
  end;

{    }
type
  TListsIndex = class(TCustomColIndex)
  private
    FCompareUnsigned: Boolean;
    FIndexCompareUnsigned: Boolean;
  protected
    function GetItemCount: Integer; override;
    function CompareItems(Item1Index,
      Item2Index: Integer): Integer; override;
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; override;
    procedure UpdateContent; override;  
    {}
    function GetDataSource: TLists;
    procedure SetDataSource(NewDataSource: TLists);
    function GetCompareUnsigned: Boolean;
    function GetItem(Values: TList): Integer;
  public
    constructor Create;
    {}
    {    (DataSource),   -
       ,  True,    , 
    False,   False (CompareUnsigned),    
     Values     ,  
      nil,   Values     nil
    (Items)}
    property DataSource: TLists read GetDataSource write SetDataSource;
    property CompareUnsigned: Boolean
      read GetCompareUnsigned write FCompareUnsigned;
    property Items[Values: TList]: Integer read GetItem; default;
  end;

{     : ismAny - ,
ismFirstIndex -   , ismLastIndex -   }
type
  TIndexedListSearchMode = (ismAny, ismFirstIndex, ismLastIndex);
{ ,    ; Operation - 
, Index -   ,    ,
Count -   }
type
  TListOperationEvent = procedure(Sender: TObject; Operation: TListOperation;
    Index, Count: Integer) of object;
{   }
type
  TCustomIndexedList = class(TObjectStd)
  private
    FActiveIndex: Integer;
    FLastSortIndex: Integer;
    FIsNumberKnown: Boolean;
    FItemNumber: Integer;
    FAddDuplicates: Boolean;
    FSearchMode: TIndexedListSearchMode;
    FLastItemInfo: TIndexedItemInfo;
    FListOperation: TListOperationEvent;
    FListOperationEventDisabled: Boolean;
  protected
    FIndexList: TList;
    {}
    {   (ListGetCapacity),   
    NewCapacity (ListSetCapacity),     
    (ListGetCount),      NewCount
    (ListSetCount),      Index, (ListGetItem),
         Index     ItemPtr
    (ListSetItem),   (ListClear),    
       Index (ListInsert),   c 
    Index   (ListDelete),  ,     
    (ListCreate),  ,     
    (ListDestroy),   (CreateIndex);   
     0}
    function ListGetCapacity: Integer; virtual; abstract;
    procedure ListSetCapacity(NewCapacity: Integer); virtual; abstract;
    function ListGetCount: Integer; virtual; abstract;
    procedure ListSetCount(NewCount: Integer); virtual; abstract;
    function ListGetItem(Index: Integer): Pointer; virtual; abstract;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); virtual; abstract;
    procedure ListClear; virtual; abstract;
    procedure ListInsert(Index: Integer); virtual; abstract;
    procedure ListDelete(Index: Integer); virtual; abstract;
    procedure ListCreate; virtual;
    procedure ListDestroy; virtual;
    function CreateIndex: TCustomIndex; virtual; abstract;
    procedure ListOperationHandler(Operation: TListOperation;
      Index, Count: Integer); virtual;
    {    ,  , 
     0,    0 (ListItemSize);   
     Index  ,     
    (ListExportItem),      Index  
    Value,       (ListImportItem)}
    function ListItemSize: Integer; virtual;
    function ListExportItem(Index: Integer): string; virtual;
    procedure ListImportItem(Index: Integer; const Value: string); virtual;
    {}
    procedure ListOperationProcessor(Operation: TListOperation;
      Index, Count: Integer);
    procedure SetCapacity(NewCapacity: Integer);
    procedure SetCount(NewCount: Integer);
    procedure SetItem(Index: Integer; NewItemPtr: Pointer);
    procedure SetActiveIndex(NewActiveIndex: Integer);
    function GetIsIndexed: Boolean;
    procedure SetIsIndexed(NewIsIndexed: Boolean);
    function GetIndex(Number: Integer): Integer;
    function GetNumber(Index: Integer): Integer;
    function GetSorted(Number: Integer): Pointer;
    function GetNearIndex: Integer;
    function GetNearNumber: Integer;
    function GetExportStr: string;
    procedure SetExportStr(const NewExportStr: string);
    procedure InsertFinish(Index: Integer; IsNumberKnown: Boolean;
      ItemNumber: Integer);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {    (Clear),     
    ItemPtr    ,  
     ,  AddDuplicates = False   
        ,   
      (Add),   ItemPtr   Index 
       (Insert),    
    Index    (Delete),  
     ItemPtr    ,   , 
    (-1),      ,  
       ,   NearNumber,  NearNumber
     ,  (-1) ,      ,
         SearchMode,  ,  
    ismAny,    LastItemInfo (IndexOf)}
    procedure Clear;
    function Add(ItemPtr: Pointer): Integer;
    procedure Insert(Index: Integer; ItemPtr: Pointer);
    procedure Delete(Index: Integer);
    function IndexOf(ItemPtr: Pointer): Integer;
    {    Indexes}
    procedure DefineIndex(Indexes: TList);
    {}
    {  (Capacity);     (Count); 
         Index,    (Items);
      ,   0,    
       (ActiveIndex);  ,  
     ,        
    ,    (IsIndexed);  
         Number,   0 (Indexes);
           Index, 
     0,    (Numbers);   
      Number,   0    (Sorted); 
         Sorted (LastSortIndex);  ,
          ,  
        IndexOf,  (-1),    ,
      (-1) (NearIndex);     NearIndex
     (-1),       (NearNumber); 
     ,   ItemNumber    ,  
    Add, Insert, Delete    Items, IsNumberKnown 
     False (IsNumberKnown);  IsNumberKnown = True   ,
        ,    
     ,    ,     ,
        ,   
      IndexOf,   NearNumber   
     ,      ,
           IsNumberKnown = True,
         ,   ItemNumber 
     ,     ,    
       -   ,  
    ,    Add, Insert, Delete    Items,
    IsNumberKnown   False,      
        (ItemNumber);   
    ,   False     Add
        ,   True
    (AddDuplicates);          
     ,       
    (ExportStr);   (SearchMode);    
       IndexOf   SearchMode,   ismAny
    (LastItemInfo);    ,  
     ,  ,  ,   
           
    (OnListOperation)}
    property Capacity: Integer read ListGetCapacity write SetCapacity;
    property Count: Integer read ListGetCount write SetCount;
    property Items[Index: Integer]: Pointer read ListGetItem write SetItem;
      default;
    property ActiveIndex: Integer read FActiveIndex write SetActiveIndex;
    property IsIndexed: Boolean read GetIsIndexed write SetIsIndexed;
    property Indexes[Number: Integer]: Integer read GetIndex;
    property Numbers[Index: Integer]: Integer read GetNumber;
    property Sorted[Number: Integer]: Pointer read GetSorted;
    property LastSortIndex: Integer read FLastSortIndex;
    property NearIndex: Integer read GetNearIndex;
    property NearNumber: Integer read GetNearNumber;
    property IsNumberKnown: Boolean read FIsNumberKnown write FIsNumberKnown;
    property ItemNumber: Integer read FItemNumber write FItemNumber;
    property AddDuplicates: Boolean read FAddDuplicates write FAddDuplicates;
    property ExportStr: string read GetExportStr write SetExportStr;
    property SearchMode: TIndexedListSearchMode
      read FSearchMode write FSearchMode;
    property LastItemInfo: TIndexedItemInfo read FLastItemInfo;
    property OnListOperation: TListOperationEvent
      read FListOperation write FListOperation;
  end;

{  }
type
  TIndexedList = class(TCustomIndexedList)
  private
    FList: TList;
    FListGetItemTemp: Pointer;
  protected
    function ListGetCapacity: Integer; override;
    procedure ListSetCapacity(NewCapacity: Integer); override;
    function ListGetCount: Integer; override;
    procedure ListSetCount(NewCount: Integer); override;
    function ListGetItem(Index: Integer): Pointer; override;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); override;
    procedure ListClear; override;
    procedure ListInsert(Index: Integer); override;
    procedure ListDelete(Index: Integer); override;
    procedure ListCreate; override;
    procedure ListDestroy; override;
    function CreateIndex: TCustomIndex; override;
    {}
    function ListItemSize: Integer; override;
    function ListExportItem(Index: Integer): string; override;
    procedure ListImportItem(Index: Integer; const Value: string); override;
    {}
    function GetItem(Index: Integer): Pointer;
    procedure SetItem(Index: Integer; const NewValue: Pointer);
    function GetSorted(Number: Integer): Pointer;
    function GetCompareUnsigned: Boolean;
    procedure SetCompareUnsigned(NewCompareUnsigned: Boolean);
  public
    constructor Create;
    {}
    function Add(Value: Pointer): Integer;
    procedure Insert(Index: Integer; Value: Pointer);
    function IndexOf(Value: Pointer): Integer;
    {}
    property Items[Index: Integer]: Pointer read GetItem write SetItem;
      default;
    property Sorted[Number: Integer]: Pointer read GetSorted;
    {   -       }
    property CompareUnsigned: Boolean
      read GetCompareUnsigned write SetCompareUnsigned;
  end;
{     IndexedList,    nil,
 0 (GetIndexedListCount);     
NewValue      Index    
Count ,     IndexedList 
GetPointer, SetPointer (GetIndexedPointer, SetIndexedPointer)}
function GetIndexedListCount(IndexedList: TIndexedList): Integer;
function GetIndexedPointer(IndexedList: TIndexedList; Index,
  Count: Integer): Pointer;
procedure SetIndexedPointer(var IndexedList: TIndexedList; Index,
  Count: Integer; NewValue: Pointer);
{   ( ); LastId - 
; UsingIds -   ; IsCheck
,        UsingIds, 
IsCheck = False   LastId   ,  
    UsingIds  ,   
, IsCheck   True,  
  1,  IsCheck = True    
     UsingIds,    UsingIds
,    1   ;  
 ,  EIdError}
function IndexedCreateNewId(LastId: Integer; UsingIds: TIndexedList;
  var IsCheck: Boolean): Integer;
{   IndexedList     
   'h'  ,   , 
 ;  IsSorted = True    
   }
function IndexedListToShowStr(IndexedList: TIndexedList;
  IsSorted: Boolean): string;
{  IndexedList      , 
DivStr}
function IndexedListToNumStr(IndexedList: TIndexedList;
  const DivStr: string): string;
{    4-  IntArray, 
   BaseIntArray,      
IndexedList,   ,    nil  
,    BaseIntArray  Null  
 IndexedList,    nil    IntArray,
   ExcludingProcessId     
}
function IntArrayRemoveExisting(const IntArray: string; const BaseIntArray:
  TNullStr; IndexedList: TIndexedList; ExcludingProcessId: DWORD): string;

{      ,
  }
type
  TCustomColIndexedList = class(TCustomIndexedList)
  private
    FNoDefValue: Boolean;
    FDefValuePtr: Pointer;
    FLastIndex: Integer;
    FValueIndexDefined: Boolean;
  protected
    FCurrentColIndex: Integer;
    {}
    {     (ListGetColCapacity); 
        NewColCapacity (ListSetColCapacity);
         (ListGetColCount); 
        (ListSetColCount);   
       ColIndex,  ,   
    ItemPtr,     ColIndex (ListDeleteCol); 
       Index ,    
    (ItemListGet);  ,    Item1Ptr 
    Item2Ptr,  True   (ItemsCompare)}
    function ListGetColCapacity: Integer; virtual; abstract;
    procedure ListSetColCapacity(NewColCapacity: Integer); virtual; abstract;
    function ListGetColCount: Integer; virtual; abstract;
    procedure ListSetColCount(NewColCount: Integer); virtual; abstract;
    procedure ListInsertCol(ColIndex: Integer;
      ItemPtr: Pointer); virtual; abstract;
    procedure ListDeleteCol(ColIndex: Integer); virtual; abstract;
    function ItemListGet(ItemListPtr: Pointer; Index: Integer): Pointer;
      virtual; abstract;
    function ItemsCompare(Item1Ptr, Item2Ptr: Pointer): Boolean;
      virtual; abstract;
    {}
    procedure ClearIndexes(ColIndexFrom: Integer);
    procedure SetColCapacity(NewColCapacity: Integer);
    procedure SetColCount(NewColCount: Integer);
    function GetItem(ColIndex, Index: Integer): Pointer;
    procedure SetItem(ColIndex, Index: Integer; NewItemPtr: Pointer);
    function GetSorted(ColIndex, Number: Integer): Pointer;
    function GetIndexedColCount: Integer;
    procedure SetIndexedColCount(NewIndexedColCount: Integer);
    function GetIndexedCol(Index: Integer): Integer;
    procedure SetIndexedCol(Index, NewIndexedCol: Integer);
    function GetValue(ItemListPtr: Pointer; ColIndex: Integer): Pointer;
    procedure SetValue(ItemListPtr: Pointer; ColIndex: Integer;
      NewValuePtr: Pointer);
    procedure SetLastIndex(NewLastIndex: Integer);
    function GetExportStr: string;
    procedure SetExportStr(const NewExportStr: string);
  public
    constructor Create;
    {}
    {     ItemPtr (AddCol),   
      ItemPtr     ColIndex (InsertCol),
        ColIndex (DeleteCol)}
    function AddCol(ItemPtr: Pointer): Integer;
    procedure InsertCol(ColIndex: Integer; ItemPtr: Pointer);
    procedure DeleteCol(ColIndex: Integer);
    {}
    {   (ColCapacity);   (ColCount);
        ColIndex   Index,  
     (Items);      ColIndex  
    Number,   0    (Sorted);  ,
         (IndexedColCount);   
    , Index   0      
     (IndexesCols);     ColIndex  ,
       Variants    ,   
    ,     DefValue,     ,
      ,      DefValue,
      ,  NoDefValue = True,     
        ,   
    ,   DefValue,   ,  
            
    OnListOperation   loNew,       
     ,   Values  IsNumberKnown  False (Values);
        DefValue   Values,   False
    (NoDefValue);         Values, 
        nil (DefValue);   
         Values  (-1),    ,
         Values   (LastIndex);
            Values,  True 
    Values   IndexOf,      LastIndex, 
     Values   False,   False (ValueIndexDefined)}
    property ColCapacity: Integer read ListGetColCapacity write SetColCapacity;
    property ColCount: Integer read ListGetColCount write SetColCount;
    property Items[ColIndex, Index: Integer]: Pointer
      read GetItem write SetItem; default;
    property Sorted[ColIndex, Number: Integer]: Pointer read GetSorted;
    property IndexedColCount: Integer
      read GetIndexedColCount write SetIndexedColCount;
    property IndexedCols[Index: Integer]: Integer
      read GetIndexedCol write SetIndexedCol;
    property Values[ItemListPtr: Pointer; ColIndex: Integer]: Pointer
      read GetValue write SetValue;
    property NoDefValue: Boolean read FNoDefValue write FNoDefValue;
    property DefValue: Pointer read FDefValuePtr write FDefValuePtr;
    property LastIndex: Integer read FLastIndex write SetLastIndex;
    property ValueIndexDefined: Boolean
      read FValueIndexDefined write FValueIndexDefined;
    property ExportStr: string read GetExportStr write SetExportStr;
  end;

{    ,  ,
  }
type
  TIndexedLists = class(TCustomColIndexedList)
  private
    FLists: TLists;
    FListGetItemTemp: Pointer;
    FItemListGetTemp: Pointer;
    FDefValue: Pointer;
    FValueCompareUnsigned: Boolean;
  protected
    function ListGetColCapacity: Integer; override;
    procedure ListSetColCapacity(NewColCapacity: Integer); override;
    function ListGetCapacity: Integer; override;
    procedure ListSetCapacity(NewCapacity: Integer); override;
    function ListGetColCount: Integer; override;
    procedure ListSetColCount(NewColCount: Integer); override;
    function ListGetCount: Integer; override;
    procedure ListSetCount(NewCount: Integer); override;
    function ListGetItem(Index: Integer): Pointer; override;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); override;
    procedure ListClear; override;
    procedure ListInsertCol(ColIndex: Integer;
      ItemPtr: Pointer); override;
    procedure ListInsert(Index: Integer); override;
    procedure ListDeleteCol(ColIndex: Integer); override;
    procedure ListDelete(Index: Integer); override;
    procedure ListCreate; override;
    procedure ListDestroy; override;
    function CreateIndex: TCustomIndex; override;
    function ItemListGet(ItemListPtr: Pointer; Index: Integer): Pointer;
      override;
    function ItemsCompare(Item1Ptr, Item2Ptr: Pointer): Boolean; override;
    {}
    function ListItemSize: Integer; override;
    function ListExportItem(Index: Integer): string; override;
    procedure ListImportItem(Index: Integer; const Value: string); override;
    {}
    function GetItem(ColIndex, Index: Integer): Pointer;
    procedure SetItem(ColIndex, Index: Integer; const NewValue: Pointer);
    function GetSorted(ColIndex, Number: Integer): Pointer;
    function GetValue(List: TList; ColIndex: Integer): Pointer;
    procedure SetValue(List: TList; ColIndex: Integer; NewValue: Pointer);
    function GetDefValue: Pointer;
    procedure SetDefValue(NewDefValue: Pointer);
    function GetCompareUnsigned: Boolean;
    procedure SetCompareUnsigned(NewCompareUnsigned: Boolean);
  public
    constructor Create;
    {}
    function AddCol(Values: TList): Integer;
    function Add(Values: TList): Integer;
    procedure InsertCol(ColIndex: Integer; Values: TList);
    procedure Insert(Index: Integer; Values: TList);
    function IndexOf(Values: TList): Integer;
    {}
    property Items[ColIndex, Index: Integer]: Pointer
      read GetItem write SetItem; default;
    property Sorted[ColIndex, Number: Integer]: Pointer read GetSorted;
    property Values[Values: TList; ColIndex: Integer]: Pointer
      read GetValue write SetValue;
    {    Values,    nil}
    property DefValue: Pointer read GetDefValue write SetDefValue;
    {         , 
     False (CompareUnsigned);   Values  DefValue, 
     False (ValueCompareUnsigned)}
    property CompareUnsigned: Boolean
      read GetCompareUnsigned write SetCompareUnsigned;
    property ValueCompareUnsigned: Boolean
      read FValueCompareUnsigned write FValueCompareUnsigned;
  end;
{   IndexedLists    : ,
 #13#10,        
 'h'  ,      ;  IsSorted =
True        }
function IndexedListsToShowStr(IndexedLists: TIndexedLists;
  IsSorted: Boolean): string;

{ ,        -}
type
  TPointerParams = class(TObjectStd)
  private
    FNames: Pointer; {TIndexedStrings}
    FValues: TList;
    FLastExists: Boolean;
    FLastIndex: Integer;
    FLastName: string;
  protected
    function GetCount: Integer;
    function GetName(Index: Integer): string;
    function GetValue(Index: Integer): Pointer;
    procedure SetValue(Index: Integer; const NewValue: Pointer);
    function GetItem(const ParamName: string): Pointer;
    procedure SetItem(const ParamName: string; const NewValue: Pointer);
    function GetLast: Pointer;
    procedure SetLast(const NewValue: Pointer);
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   (Clear);   ParamName,   ,
     (-1)}
    procedure Clear;
    function IndexOf(const ParamName: string): Integer;
    {}
    {  (Count);    Index (Names);  
     Index (Values);    ParamName,   
    ,    nil,   
    ,   nil  (Items); 
      ,     
     Items (Last);     
       ,   [cmCaseInsensitive, cmUseLangDriver,
    cmTrimed, cmNullAsNone, cmAllowUnassigned] (CompareMode);  
      0}
    property Count: Integer read GetCount;
    property Names[Index: Integer]: string read GetName;
    property Values[Index: Integer]: Pointer read GetValue write SetValue;
    property Items[const ParamName: string]: Pointer
      read GetItem write SetItem; default;
    property Last: Pointer read GetLast write SetLast;
    property CompareMode: TCompareMode read
      GetCompareMode write SetCompareMode;
  end;
{    PointerParams   
  ,  #13#10,     
       (  
),   ;  -    ++,
   ,  'h'  }
function PointerParamsToShowStr(PointerParams: TPointerParams): string;
{  OldPrefix  NewPrefix    PointerParams,
     }
function PtrParamsChangePrefix(const PointerParams: TPointerParams;
  const OldPrefix, NewPrefix: string): Integer;


type
  TPointerArrays = class;
  { ,     TPointerArrays}
  TPointerArray = class(TIndexedList)
  private
    FParent: TPointerArrays;
    FName: string;
  protected
  public
    {     Parent   Name, 
        Parent    nil}
    constructor Create(Parent: TPointerArrays; const Name: string);
    destructor Destroy; override;
    {}
    {      (Name)    
      (Parent)}
    property Name: string read FName;
    property Parent: TPointerArrays read FParent;
  end;
  {  }
  TPointerArrays = class(TObjectStd)
  private
    FNames: Pointer; {TIndexedStrings}
    FArrays: TIndexedList;
    FLastExists: Boolean;
    FLastIndex: Integer;
    FLastName: string;
    FIsInternalAdd: Boolean;
    FIsInternalDelete: Boolean;
    {}
    procedure AddItem(Item: TPointerArray);
    procedure DeleteItem(Item: TPointerArray);
  protected
    function GetCount: Integer;
    function GetName(Index: Integer): string;
    function GetArrays(Index: Integer): TPointerArray;
    function GetItem(const ArrayName: string): TPointerArray;
    function GetLast: TPointerArray;
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { ,   }
    procedure Clear;
    {}
    {  (Count);     Index (Names);
       Index (Arrays);     ArrayName (Items);
       Items  (Last);   
         ,   [cmCaseInsensitive,
    cmUseLangDriver, cmTrimed, cmNullAsNone, cmAllowUnassigned] (CompareMode);
        0}
    property Count: Integer read GetCount;
    property Names[Index: Integer]: string read GetName;
    property Arrays[Index: Integer]: TPointerArray read GetArrays;
    property Items[const ArrayName: string]: TPointerArray read GetItem;
      default;
    property Last: TPointerArray read GetLast;
    property CompareMode: TCompareMode read
      GetCompareMode write SetCompareMode;
  end;
{     PointerArrays   
      C++    (  
)         
  'h'     ,  }
function PointerArraysToShowStr(PointerArrays: TPointerArrays): string;

{ ,  TObjectList, OwnsObjects   True,
     TObjectList - 
    TList Delphi  ,  
      TList OwnsObjects   
,    }
type
  TObjList = class(TListStd)
  private
    FOwnsObjects: Boolean;
    FActiveIndex: Integer;
  protected
    {    Index     nil}
    procedure FreeItem(Index: Integer);
    {}
    function GetItem(Index: Integer): TObject;
    procedure SetItem(Index: Integer; AObject: TObject);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    function Add(AObject: TObject): Integer;
    procedure Clear; 
      {$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93}
      {$IFNDEF VER100} {$IFNDEF VER110} 
      override;
      {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}
    procedure Delete(Index: Integer);
    function Remove(AObject: TObject): Integer;
    function IndexOf(AObject: TObject): Integer;
    function FindInstanceOf(AClass: TClass; AExact: Boolean;
      AStartAt: Integer): Integer;
    procedure Insert(Index: Integer; AObject: TObject);
    property OwnsObjects: Boolean read FOwnsObjects write FOwnsObjects;
    property Items[Index: Integer]: TObject
      read GetItem write SetItem; default;
    property Count: Integer read GetCount write SetCount;
    {     ,   (-1)
    (ActiveIndex)}
    property ActiveIndex: Integer read FActiveIndex write FActiveIndex;
  end;
{     ObjList    
 ++   ,  }
function ObjListToShowStr(ObjList: TObjList): string;
{  AObject    ObjList,   
,    (SafeAddObject);  
    ObjList (SafeAddObjList);    
 ObjList (SafeAddList);     
 ObjList (SafeAddIndexedList)}
function SafeAddObject(ObjList: TObjList; AObject: TObject): TObject;
procedure SafeAddObjList(ObjList: TObjList);
procedure SafeAddList(ObjList: TObjList);
procedure SafeAddIndexedList(ObjList: TObjList);
{   ObjList     ObjList.ActiveIndex,
  , ,     ,
  ,      
ObjIsEmptyFunc, ,     IndexedStringsIsEmpty,
  ObjIsEmptyFunc  nil    ,
 nil,  LastOnly  True     
  (ObjListRemoveEmpty);     
ObjIndex    ObjList,     AObject
  ObjList.ActiveIndex,     ObjList,
     ObjList  nil,   
  AObject,   ObjList.ActiveIndex   
 ,   ,  
 ObjList.ActiveIndex  ,   ,  
        ,
  ObjList   ,     ,
,     ,   , 
    ObjIsEmptyFunc,   nil,  
        ObjListRemoveEmpty,
ObjCreateFunc,   nil,    ,  AObject
 nil,  ObjIndex  (-2) ObjList.ActiveIndex   
(ObjListActivate)}
procedure ObjListRemoveEmpty(ObjList: TObjList;
  ObjIsEmptyFunc: TObjIsEmptyFunc; LastOnly: Boolean);
function ObjListActivate(ObjList: TObjList; var AObject: TObject;
  ObjIsEmptyFunc: TObjIsEmptyFunc; ObjCreateFunc: TObjAccessFunc;
  ObjIndex: Integer): Integer;
{  }
type
  TNamedObjList = class(TObjList)
  private
    FObjectNames: Pointer; {TIndexedStrings}
    FLastObjectIndex: Integer;
  protected
    function FixedObjectNames: TObject;
    {}
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
    function GetObjectName(Index: Integer): string;
    procedure SetObjectName(Index: Integer; const NewObjectName: string);
    function GetObject(const ObjectName: string): TObject;
    procedure SetObject(const ObjectName: string; NewObject: TObject);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  AObject   ObjectName,  
     ,     ObjectName  ,
       ,     ,
       OwnsObjects (AddObject);   
      AObject   ObjectName,   
    ,  IsNewObjectName = True    ,
        ObjectName  ,  
      (AddNewObject);     ObjectName
        OwnsObjects,   
    ,      ,  (-1) (RemoveObject);
        ObjectName,   ,  (-1)
    (IndexOfObject)}
    function AddObject(AObject: TObject; const ObjectName: string): Integer;
    function AddNewObject(AObject: TObject; const ObjectName: string;
      IsNewObjectName: Boolean): Integer;
    function RemoveObject(const ObjectName: string): Integer;
    function IndexOfObject(const ObjectName: string): Integer;
    {}
    {   ,   [cmCaseInsensitive,
    cmUseLangDriver, cmTrimed, cmNullAsNone, cmAllowUnassigned] (CompareMode);
          Index (ObjectNames);   
      ObjectName,      , 
    ,      (Objects);  
        Objects ,     
     (-1) (LastObjectIndex)}
    property CompareMode: TCompareMode
      read GetCompareMode write SetCompareMode;
    property ObjectNames[Index: Integer]: string
      read GetObjectName write SetObjectName;
    property Objects[const ObjectName: string]: TObject
      read GetObject write SetObject;
    property LastObjectIndex: Integer read FLastObjectIndex;
  end;
{       }
type
  TCachedObjects = class(TObjectStd)
  private
    FObjList: TObjList;
    FLastIndex: Integer;
    FMaxCachedCount: Integer;
  protected
    FLockList: TList;
    {}
    function GetCount: Integer;
    function GetObject(Index: Integer): TObject;
    function GetLocked(Index: Integer): Boolean;
    {}
    {   Locked    Index}
    procedure SetLocked(Index: Integer; Locked: Boolean);
    {,   LockObject    , 
     CreateObject  nil,  LockObject  nil,
        CreateObject, LockObject 
         (CreateObject);  , 
        ,   IsLock = True,  
       (ClearObject);     Index
    (RemoveItem)}
    function CreateObject: TObject; virtual;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); virtual;
    procedure RemoveItem(Index: Integer); virtual;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {,   ,      
    }
    procedure Reset;
    {  AObject  ,  IsLock = True   
        (AddObject);   AObject 
    ,   ,    (RemoveObject);  ,
    ,          
    ,           UnlockObject,
          CreateObject  nil,
     nil (LockObject),      
    (UnlockObject)}
    procedure AddObject(AObject: TObject; IsLock: Boolean); virtual;
    procedure RemoveObject(AObject: TObject); virtual;
    function LockObject: TObject; virtual;
    procedure UnlockObject(AObject: TObject); virtual;
    {}
    {  (Count);    Index (Objects); 
        Index (Locked);    
     AddObject, RemoveObject, LockObject  UnlockObject,   0,
        ,  (-1),   (-1)
    (LastLockIndex);    , 
         UnlockObject  
        ,   ,   
    ,   (-1)  ,    (-1)
    (MaxCachedCount)}
    property Count: Integer read GetCount;
    property Objects[Index: Integer]: TObject read GetObject;
    property Locked[Index: Integer]: Boolean read GetLocked write SetLocked;
    property LastIndex: Integer read FLastIndex;
    property MaxCachedCount: Integer
      read FMaxCachedCount write FMaxCachedCount;
  end;
{     AObject  CachedObjects,    nil}
procedure UnlockObject(CachedObjects: TCachedObjects; AObject: TObject);
{  }
type
  TCachedLists = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockList: TList;
  end;
{     CachedLists,   nil  
}
function LockList(var CachedLists: TCachedLists): TList;
{  }
type
  TCachedObjLists = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockObjList: TObjList;
  end;
{     CachedObjLists,   nil  
}
function LockObjList(var CachedObjLists: TCachedObjLists): TObjList;
{  }
type
  TCachedPointersLists = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockLists: TLists;
  end;
{   }
type
  TCachedIndexedLists = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockIndexedList: TIndexedList;
  end;
{      CachedIndexedLists,
  nil   }
function LockIndexedList(var CachedIndexedLists:
  TCachedIndexedLists): TIndexedList;
{   }
type
  TCachedIndexedPointersLists = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockIndexedLists: TIndexedLists;
  end;
{         
}
type
  TSharedObjects = class(TCachedObjects)
  private
    FShareList: TList;
    FCounterList: TList;
    FTicksList: TList;
  protected
    function GetShared(Index: Integer): Boolean;
    function GetCounter(Index: Integer): Integer;
    function GetTick(Index: Integer): DWORD;
    {}
    procedure RemoveItem(Index: Integer); override;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {,   ,      
    ,   Ticks   Timeout , 
    Timeout  }
    procedure Reset(Timeout: Integer);
    procedure AddObject(AObject: TObject; IsLock: Boolean); override;
    procedure RemoveObject(AObject: TObject); override;
    procedure UnlockObject(AObject: TObject); override;
    {    Index   ,
            
     ,      ,
     Index = -1     ,    
     ,       
     LockObject   ,   CreateObject 
    (ShareObject);     
    AObject,      UnlockObject  
    RemoveObject       (UnshareObject)}
    function ShareObject(Index: Integer): TObject; virtual;
    function UnshareObject(AObject: TObject): Integer; virtual;
    {Ticks     Timeout ,   
       Timeout (Expire);   
    ,   Ticks     Timeout ,
       Timeout    
    (DeleteExpired)}
    procedure Expire(Timeout: Integer);
    procedure DeleteExpired(Timeout: Integer);
    {}
    {     Index   
    (Shared);       
    Index (Counters);        Windows
        Index (Ticks)}
    property Shared[Index: Integer]: Boolean read GetShared;
    property Counters[Index: Integer]: Integer read GetCounter;
    property Ticks[Index: Integer]: DWORD read GetTick;
  end;

{  , .  TUniversalParams}
type
  TLightUniversalInfo = record
    FieldStr1: string;
    FieldStr2: string;
    FieldStr3: string;
    FieldStr4: string;
    FieldStr5: string;
    FieldStr6: string;
    FieldStr7: string;
    FieldPtr1: Pointer;
    FieldPtr2: Pointer;
    FieldPtr3: Pointer;
    FieldVar1: Variant;
    FieldVar2: Variant;
  end;
  PLightUniversalInfo = ^TLightUniversalInfo;
{ }
type
  TUniversalInfo = record
    FieldBool1: Boolean;
    FieldBool2: Boolean;
    FieldBool3: Boolean;
    FieldBool4: Boolean;
    FieldBool5: Boolean;
    FieldNullBool1: TNullBool;
    FieldNullBool2: TNullBool;
    FieldNullBool3: TNullBool;
    FieldNullBool4: TNullBool;
    FieldNullBool5: TNullBool;
    FieldInt1: Integer;
    FieldInt2: Integer;
    FieldInt3: Integer;
    FieldInt4: Integer;
    FieldInt5: Integer;
    FieldNullInt1: TNullInt;
    FieldNullInt2: TNullInt;
    FieldNullInt3: TNullInt;
    FieldNullInt4: TNullInt;
    FieldNullInt5: TNullInt;
    FieldFloat1: Extended;
    FieldFloat2: Extended;
    FieldFloat3: Extended;
    FieldFloat4: Extended;
    FieldFloat5: Extended;
    FieldNullFloat1: TNullFloat;
    FieldNullFloat2: TNullFloat;
    FieldNullFloat3: TNullFloat;
    FieldNullFloat4: TNullFloat;
    FieldNullFloat5: TNullFloat;
    FieldCurr1: Currency;
    FieldCurr2: Currency;
    FieldCurr3: Currency;
    FieldCurr4: Currency;
    FieldCurr5: Currency;
    FieldNullCurr1: TNullCurr;
    FieldNullCurr2: TNullCurr;
    FieldNullCurr3: TNullCurr;
    FieldNullCurr4: TNullCurr;
    FieldNullCurr5: TNullCurr;
    FieldDateTime1: TDateTime;
    FieldDateTime2: TDateTime;
    FieldDateTime3: TDateTime;
    FieldDateTime4: TDateTime;
    FieldDateTime5: TDateTime;
    FieldNullDateTime1: TNullDateTime;
    FieldNullDateTime2: TNullDateTime;
    FieldNullDateTime3: TNullDateTime;
    FieldNullDateTime4: TNullDateTime;
    FieldNullDateTime5: TNullDateTime;
    FieldChar1: Char;
    FieldChar2: Char;
    FieldChar3: Char;
    FieldChar4: Char;
    FieldChar5: Char;
    FieldStr1: string;
    FieldStr2: string;
    FieldStr3: string;
    FieldStr4: string;
    FieldStr5: string;
    FieldWide1: WideString;
    FieldWide2: WideString;
    FieldWide3: WideString;
    FieldWide4: WideString;
    FieldWide5: WideString;
    FieldNullStr1: TNullStr;
    FieldNullStr2: TNullStr;
    FieldNullStr3: TNullStr;
    FieldNullStr4: TNullStr;
    FieldNullStr5: TNullStr;
    FieldNullWide1: TNullWide;
    FieldNullWide2: TNullWide;
    FieldNullWide3: TNullWide;
    FieldNullWide4: TNullWide;
    FieldNullWide5: TNullWide;
    FieldPtr1: Pointer;
    FieldPtr2: Pointer;
    FieldPtr3: Pointer;
    FieldPtr4: Pointer;
    FieldPtr5: Pointer;
    FieldVar1: Variant;
    FieldVar2: Variant;
    FieldVar3: Variant;
    FieldVar4: Variant;
    FieldVar5: Variant;
    FieldVar6: Variant;
    FieldVar7: Variant;
    FieldVar8: Variant;
    FieldVar9: Variant;
    FieldVar10: Variant;
  end;
  PUniversalInfo = ^TUniversalInfo;
{   Value (InitLightUniversalInfo, InitUniversalInfo)}
procedure InitLightUniversalInfo(out Value: TLightUniversalInfo);
procedure InitUniversalInfo(out Value: TUniversalInfo);
{  TUniversalInfo}
type
  TUniversalsInfo = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
    FOnChange: TNotifyEventStd;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TUniversalInfo;
    procedure SetItem(Index: Integer; const Value: TUniversalInfo);
    function GetItemPtr(Index: Integer): PUniversalInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TUniversalInfo): Integer;
    procedure Insert(Index: Integer; const Value: TUniversalInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TUniversalInfo read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PUniversalInfo read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
    {,    ,    }
    property OnChange: TNotifyEventStd read FOnChange write FOnChange;
  end;
{      TUniversalInfo}
type
  TUniversalsInfoRef = class(TObjectStd)
  private
    FRefs: TList;
    FIndexes: TList;
    FValues: TUniversalsInfo;
  protected
    procedure ClearStoreItem(Index, Count: Integer);
    {}
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetStoreCapacity: Integer;
    procedure SetStoreCapacity(NewStoreCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetStoreCount: Integer;
    function GetItem(Index: Integer): TUniversalInfo;
    procedure SetItem(Index: Integer; const NewValue: TUniversalInfo);
    function GetItemRef(Index: Integer): PUniversalInfo;
    procedure SetItemRef(Index: Integer; NewValuePtr: PUniversalInfo);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);    ,    ,
    ValuePtr,    (AddRef);   Value 
     Index (Insert);  ,   
    , ValuePtr,   Index (InsertRef);   
     Index (Delete)}
    procedure Clear;
    function Add(const Value: TUniversalInfo): Integer;
    function AddRef(const ValuePtr: PUniversalInfo): Integer;
    procedure Insert(Index: Integer; const Value: TUniversalInfo);
    procedure InsertRef(Index: Integer; const ValuePtr: PUniversalInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);     
    ,        
     (StoreCapacity);   (Count); 
         (StoreCount);  
       Index (Items)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property StoreCapacity: Integer
      read GetStoreCapacity write SetStoreCapacity;
    property Count: Integer read GetCount write SetCount;
    property StoreCount: Integer read GetStoreCount;
    property Items[Index: Integer]: TUniversalInfo read GetItem write SetItem;
      default;
    property ItemRefs[Index: Integer]: PUniversalInfo
      read GetItemRef write SetItemRef;
  end;
{   TUniversalInfo Value1  Value2,  0, 
, 1,   , (-1) ,   
}
function CompareUniversalInfo(const Value1, Value2: TUniversalInfo): Integer;
{   TUniversalInfo}
type
  TUniversalsInfoIndex = class(TCustomIndex)
  private
  protected
    function GetItemCount: Integer; override;
    function CompareItems(Item1Index, Item2Index: Integer): Integer; override;
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; override;
    {}
    function GetDataSource: TUniversalsInfo;
    procedure SetDataSource(NewDataSource: TUniversalsInfo);
    function GetItem(const Value: TUniversalInfo): Integer;
  public
    {   (DataSource);    
     P (Items)}
    property DataSource: TUniversalsInfo
      read GetDataSource write SetDataSource;
    property Items[const Value: TUniversalInfo]: Integer read GetItem; default;
  end;
{   TUniversalInfo}
type
  TIndexedUniversalsInfo = class(TCustomIndexedList)
  private
    FValues: TUniversalsInfo;
    FListGetItemTemp: TUniversalInfo;
  protected
    function ListGetCapacity: Integer; override;
    procedure ListSetCapacity(NewCapacity: Integer); override;
    function ListGetCount: Integer; override;
    procedure ListSetCount(NewCount: Integer); override;
    function ListGetItem(Index: Integer): Pointer; override;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); override;
    procedure ListClear; override;
    procedure ListInsert(Index: Integer); override;
    procedure ListDelete(Index: Integer); override;
    procedure ListCreate; override;
    procedure ListDestroy; override;
    function CreateIndex: TCustomIndex; override;
    {}
    function GetItem(Index: Integer): TUniversalInfo;
    procedure SetItem(Index: Integer; const NewValue: TUniversalInfo);
    function GetSorted(Number: Integer): TUniversalInfo;
  public
    constructor Create;
    {}
    function Add(const Value: TUniversalInfo): Integer;
    procedure Insert(Index: Integer; const Value: TUniversalInfo);
    function IndexOf(const Value: TUniversalInfo): Integer;
    {}
    property Items[Index: Integer]: TUniversalInfo read GetItem write SetItem;
      default;
    property Sorted[Number: Integer]: TUniversalInfo read GetSorted;
  end;
{ }
type
  TExtendedString = record
    Value: string;  {}
    Tag: string;    { }
    Flags: Integer; { }
  end;
  PExtendedString = ^TExtendedString;
{   Value (InitExtendedString);  
 TExtendedString   Value,   Tag, 
 Flags (ExtendedString)}
procedure InitExtendedString(out Value: TExtendedString);
function ExtendedString(const Value, Tag: string;
  Flags: Integer): TExtendedString;
{  TExtendedString}
type
  TExtendedStrings = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TExtendedString;
    procedure SetItem(Index: Integer; const Value: TExtendedString);
    function GetItemPtr(Index: Integer): PExtendedString;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TExtendedString): Integer;
    procedure Insert(Index: Integer; const Value: TExtendedString);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TExtendedString read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PExtendedString read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{   TExtendedString Value1  Value2,  0, 
, 1,   , (-1) ,   
}
function CompareExtendedStrings(const Value1,
  Value2: TExtendedString): Integer;
{   TExtendedString}
type
  TExtendedStringsIndex = class(TCustomIndex)
  private
  protected
    function GetItemCount: Integer; override;
    function CompareItems(Item1Index, Item2Index: Integer): Integer; override;
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; override;
    {}
    function GetDataSource: TExtendedStrings;
    procedure SetDataSource(NewDataSource: TExtendedStrings);
    function GetItem(const Value: TExtendedString): Integer;
  public
    {   (DataSource);    
     P (Items)}
    property DataSource: TExtendedStrings
      read GetDataSource write SetDataSource;
    property Items[const Value: TExtendedString]: Integer
      read GetItem; default;
  end;
{   TExtendedString}
type
  TIndexedExtendedStrings = class(TCustomIndexedList)
  private
    FValues: TExtendedStrings;
    FListGetItemTemp: TExtendedString;
  protected
    function ListGetCapacity: Integer; override;
    procedure ListSetCapacity(NewCapacity: Integer); override;
    function ListGetCount: Integer; override;
    procedure ListSetCount(NewCount: Integer); override;
    function ListGetItem(Index: Integer): Pointer; override;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); override;
    procedure ListClear; override;
    procedure ListInsert(Index: Integer); override;
    procedure ListDelete(Index: Integer); override;
    procedure ListCreate; override;
    procedure ListDestroy; override;
    function CreateIndex: TCustomIndex; override;
    {}
    function GetItem(Index: Integer): TExtendedString;
    procedure SetItem(Index: Integer; const NewValue: TExtendedString);
    function GetSorted(Number: Integer): TExtendedString;
  public
    constructor Create;
    {}
    function Add(const Value: TExtendedString): Integer;
    procedure Insert(Index: Integer; const Value: TExtendedString);
    function IndexOf(const Value: TExtendedString): Integer;
    {}
    property Items[Index: Integer]: TExtendedString read GetItem write SetItem;
      default;
    property Sorted[Number: Integer]: TExtendedString read GetSorted;
  end;

{      }
type
  TVarParamInfo = record
    ParamName: string;       { }
    ParamType: TVarBaseType; { }
  end;
  PVarParamInfo = ^TVarParamInfo;
{   Value (InitVarParamInfo);  
TVarParamInfo    ParamName   ParamType (VarParamInfo)}
procedure InitVarParamInfo(out Value: TVarParamInfo);
function VarParamInfo(const ParamName: string;
  ParamType: TVarBaseType): TVarParamInfo;
{  TVarParamInfo}
type
  TVarParamsInfo = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TVarParamInfo;
    procedure SetItem(Index: Integer; const Value: TVarParamInfo);
    function GetItemPtr(Index: Integer): PVarParamInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TVarParamInfo): Integer;
    procedure Insert(Index: Integer; const Value: TVarParamInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TVarParamInfo read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PVarParamInfo read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;

{  TProductVer}
type
  TProductVers = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TProductVer;
    procedure SetItem(Index: Integer; const Value: TProductVer);
    function GetItemPtr(Index: Integer): PProductVer;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TProductVer): Integer;
    procedure Insert(Index: Integer; const Value: TProductVer);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TProductVer read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PProductVer read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;



{---   ------------------------------------------------------------}

{     ,       
    IsSysDebug  True (TStringsDbg); 
     (TStringsStd)}
type
  TStringsDbg = class(TStrings)
  private
  protected
  public
    constructor Create;
    destructor Destroy; override;
  end;
  TStringsStd = {$IFNDEF NODEBUG_SYS} TStringsDbg {$ELSE} TStrings {$ENDIF};
{  ,        
   IsSysDebug  True (TStringListDbg);   
(TStringListStd)}
type
  TStringListDbg = class(TStringList)
  private
  protected
  public
    constructor Create;
    destructor Destroy; override;
  end;
  TStringListStd = {$IFNDEF NODEBUG_SYS} TStringListDbg
    {$ELSE} TStringList {$ENDIF};

{     Strings,    nil,
 0 (GetStringsCount);     Strings
 Count,  Capacity     Add
(SetStringsCount);    Strings   Capacity,
    80      Clear,
   Capacity ,   
     (StringsClear); 
    NewValue, ,  
  Index     Count , 
   Strings  GetPointer, SetPointer (GetString,
SetAString);   Value     Index  
Strings,          
,        (DefineString); 
   Index    Strings,   EStringListError
 TObject(-1),      
  (StringsObject);  Count    Index
    Strings,   
 ,       (StringsDelete)}
function GetStringsCount(Strings: TStrings): Integer;
procedure SetStringsCount(Strings: TStrings; Count: Integer);
procedure StringsClear(Strings: TStrings);
function GetString(Strings: TStrings; Index, Count: Integer): string;
procedure SetAString(var Strings: TStrings; Index, Count: Integer;
  const NewValue: string);
procedure DefineString(Strings: TStrings; Index: Integer; const Value: string);
function StringsObject(Strings: TStrings; Index: Integer): TObject;
function StringsDelete(Strings: TStrings; Index, Count: Integer): Integer;
{    Strings  ,   CapacityDelta 
    }
procedure StringsCapacityDelta(Strings: TStrings; CapacityDelta: Integer);
{ True,  Strings  nil      }
function IsEmptyStrings(Strings: TStrings): Boolean;
{  S   Strings,   CompareMode,  
   ,   0,    (-1)}
function StringsIndexOf(const S: string; Strings: TStrings;
  CompareMode: TCompareMode): Integer;
{         ;
    ,  DefValue}
function StringsExtract(Strings: TStrings; var Index: Integer;
  const DefValue: string): string;
{  ;   nil -    0 }
function CompareStrings(Strings1, Strings2: TStrings): Boolean;
{    DivStr   ,  
  Strings,  SkipEmpty = True   , 
IsTrim = True       ,   
    SkipEmpty = True,    }
procedure StrToStrings(const S: string; Strings: TStrings;
  const DivStr: string; SkipEmpty, IsTrim: Boolean);
{    ,    DivStr,
 SkipEmpty = True   ,    BegIdx,
 (-1)    0,  EndIdx,  (-1)  
  }
function StringsToStr(Strings: TStrings; const DivStr: string;
  SkipEmpty: Boolean; BegIdx {-1}, EndIdx: Integer {-1}): string;
{  Text       Lines (TextToLines);
    ,      
 #13#10 (TextNormalize);   Text  , 
    HeaderPrefix,     , 
     Filter,  ,   
,   ,  Text   
 TextNormalize (TextFilter);     
Text,    TextPos, HeaderPrefix   
, CategoryPrefix      , DivStr
      ,  HeaderDateTime 
,    ,  Header  , 
 ,  BodyLines,   nil,    ,
 Categories,   nil,   ,  CategoryValues,
  nil,   ,  False,
    ,   True}
procedure TextToLines(const Text: string; Lines: TStrings);
function TextNormalize(const Text: string): string;
function TextFilter(const Text, Filter, HeaderPrefix: string): string;
function PartFromText(const Text: string; var TextPos: Integer; HeaderPrefix,
  CategoryPrefix, DivStr: string; out HeaderDateTime: TNullDateTime;
  out Header: string; BodyLines, Categories,
  CategoryValues: TStrings): Boolean;
{  }
procedure SortStrings(Strings: TStrings);
{    ,       LineLen}
procedure StrToLines(const S: string; Strings: TStrings; LineLen: Integer);
{     Strings,   nil,  0,  
MinLength,   nil,    ,  
  0,   MaxLength,   nil, 
    }
function StringsLength(Strings: TStrings; MinLength,
  MaxLength: PInteger): Integer;
{    #0    #0#0 
PCharArray   Strings}
procedure PCharArrayToStrings(PCharArray: PChar; Strings: TStrings);
{   IEnumString EnumString   Strings}
procedure EnumStringToStrings(EnumString: IEnumString; Strings: TStrings);
{  ,   nil,  Strings,   
   Capacity}
procedure StringsClearOrCreate(var Strings: TStringList; Capacity: Integer);

{    }
function StringsToData(Strings: TStrings): string;
{    }
procedure DataToStrings(const Data: string; Strings: TStrings);
{      (  StringsToData)}
function ParamValueToData(const Param, Value: string): string;
{      (  DataToStrings)}
procedure DataToParamValue(const Data: string; var Param, Value: string);
{        Web}
function StringsToWebParams(Strings: TStrings): string;
{     Web   }
procedure WebParamsToStrings(const S: string; Strings: TStrings);
{    ,  , 
       }
function StringsToStrArray(Strings: TStrings): string;
{ ,  ,  
      ,   }
procedure StrArrayToStrings(const StrArray: string; Strings: TStrings);
{       1=1,
2=2  ..;  IsInMarks = True   
   ,     
#0..#31, ' ', '"', '''', ',', ';'}
function NameListsToStr(Params, Values: TStrings; IsInMarks: Boolean): string;
{,  NameListsToStr,     
}
procedure StrToNameLists(const S: string; Params, Values: TStrings);
{  ,    
NameListsToStr}
function NormNameListsStr(const S: string; IsInMarks: Boolean): string;
{  Params     Values   
 1=1, 2=2,...  NoValues 
  1, 2,..., ParamValueDivs  
   ,   ,   
, NextParamDivs     ,  
,  ,  Results   
      ,  , ParamPrefix
  , ParamPostfix -  , ValuePrefix -
 , ValuePostfix -  , ParamSpaceCharRange -
     CharInRange,  ExtractParam,
        
, ValueSpaceCharRange -   ,
ParamMarkableCharRange - ,      
 , ValueMarkableCharRange -   ,
ParamMarkChar -    ,  ,  
     ,  ,
  ,  ParamMarksIgnore = False,  , 
  ,   , , 
   ParamMarkForce = True, ValueMarkChar -  
,        
ValueMarksIgnore = False,    ValueMarkForce = True,
ParamValueDefDiv -      ,
NextParamDefDiv -        
 ,  SkipEmptyParams = True   ,
 SkipEmptyValues = True   }
function ParamsToStr(Params, Values, ParamValueDivs, NextParamDivs,
  Results: TStrings; NoValues: Boolean; const ParamPrefix, ParamPostfix,
  ValuePrefix, ValuePostfix, ParamSpaceCharRange, ValueSpaceCharRange,
  ParamMarkableCharRange, ValueMarkableCharRange: string; ParamMarkChar,
  ValueMarkChar: Char; const ParamValueDefDiv, NextParamDefDiv: string;
  ParamMarksIgnore, ParamMarkForce, ValueMarksIgnore, ValueMarkForce,
  SkipEmptyParams, SkipEmptyValues: Boolean): string;
{   S  1=1, 2=2,...
  Params,      Values,  
,  NoValues = True   ,    S
 1, 2...,   , 
ParamValueDivs,  ,     ,
 NextParamDivs    , ParamSpaceCharRange 
     ,  CharInRange, 
ExtractParam, ValueSpaceCharRange -     
, ParamMarkCharRange - ,    ,
ValueMarkCharRange - ,    ,
ParamValueDivCharRange - ,      ,
NextParamDivCharRange - ,      
  ,  ParamValueDivSkipLn = True, 
NextParamDivSkipLn = True       
,     #13  #10   #10
 #13      , 
SkipEmptyParams = True   , 
SkipEmptyValues = True   }
function StrToParams(const S, ParamSpaceCharRange, ValueSpaceCharRange,
  ParamMarkCharRange, ValueMarkCharRange, ParamValueDivCharRange,
  NextParamDivCharRange: string; ParamValueDivSkipLn,
  NextParamDivSkipLn, NoValues, SkipEmptyParams, SkipEmptyValues: Boolean;
  Params, Values, ParamValueDivs, NextParamDivs: TStrings): Integer;
{     Strings    StringLns;
      #13#10  #10}
procedure TextToLnStrings(const Text: string; Strings, StringLns: TStrings);
{  Strings    StringLns  }
function LnStringsToText(Strings, StringLns: TStrings): string;
{  Value     Template,   
    FieldChar, 
   ,       
  ,       
Value, Value         ,
   Fields,    True,  
 Value  Template  False,    
    Fields}
function ExtractByTemplate(const Value, Template: string; FieldChar: Char;
  Fields: TStrings): Boolean;
{    ReplaceValue   Value  
Strings,    ResStrings,     
  ResStrings    Value}
procedure ReplaceByStrings(const Value, ReplaceValue: string; Strings,
  ResStrings: TStrings);
{  Value    Strings,   
 ,    ,     
 True,  False}
function StringsInsertOrMoveFirst(Strings: TStrings;
  const Value: string): Boolean;
{     Template, Params  ,
    ,   '%',  
      Values,     
,  , Flags,   nil,    
,   Flags,  Ord(True),    
     ,  CheckOnly  True
        
  ,   ,    
   4- ,    ,   
 ,  Value  Flags     
     (PrepareReportNamedList); ,  '*'
          ,
         
(PrepareReportNamed)}
function PrepareReportNamedList(const Template: string; Params,
  Values: TStrings; Flags: TList; CheckOnly: Boolean): string;
function PrepareReportNamed(const Template: string; const Params,
  Values: array of const): string;

{    Strings       
 ++   ,  }
function StringsToShowStr(Strings: TStrings): string;
{  }
type
  TWideStrings = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): WideString;
    procedure SetItem(Index: Integer; const Value: WideString);
    function GetItemPtr(Index: Integer): PWideString;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: WideString): Integer;
    procedure Insert(Index: Integer; const Value: WideString);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: WideString read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PWideString read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;

{  }
type
  TStringsList = class(TObjectStd)
  private
    FItems: TLists;
  protected
    function GetColCapacity: Integer;
    procedure SetColCapacity(NewColCapacity: Integer);
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetColCount: Integer;
    procedure SetColCount(NewColCount: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(ColIndex, Index: Integer): string;
    procedure SetItem(ColIndex, Index: Integer; const NewValue: string);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {      (Clear),  
         Strings,   
    '',   Strings   nil,   
     (AddCol),    (Add),  
        ColIndex (InsertCol),   
       Index (Insert),    
    ColIndex (DeleteCol),     Index (Delete)}
    procedure Clear;
    function AddCol(Strings: TStrings): Integer;
    function Add(Strings: TStrings): Integer;
    procedure InsertCol(ColIndex: Integer; Strings: TStrings);
    procedure Insert(Index: Integer; Strings: TStrings);
    procedure DeleteCol(ColIndex: Integer);
    procedure Delete(Index: Integer);
    {}
    {   (ColCapacity),   
    (Capacity),   (ColCount),  
    (Count),      ColIndex,   
    Index,    (Items)}
    property ColCapacity: Integer read GetColCapacity write SetColCapacity;
    property Capacity: Integer read GetCapacity write SetCapacity;
    property ColCount: Integer read GetColCount write SetColCount;
    property Count: Integer read GetCount write SetCount;
    property Items[ColIndex, Index: Integer]: string
      read GetItem write SetItem; default;
  end;
{     StringsList    
 ,  #13#10,      
   ++     ,  }
function StringsListToShowStr(StringsList: TStringsList): string;

{  }
type
  TStringsIndex = class(TCustomIndex)
  private
    FCompareMode: TCompareMode;
    FIndexCompareMode: TCompareMode;
  protected
    function GetItemCount: Integer; override;
    function CompareItems(Item1Index,
      Item2Index: Integer): Integer; override;
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; override;
    procedure UpdateContent; override;
    {}
    function GetDataSource: TStrings;
    procedure SetDataSource(NewDataSource: TStrings);
    function GetCompareMode: TCompareMode;
    function GetItem(const Value: string): Integer;
  public
    constructor Create;
    {}
    {   (DataSource),  ,  
    [cmCaseInsensitive, cmUseLangDriver, cmTrimed, cmNullAsNone,
    cmAllowUnassigned] (CompareMode),      Value
    (Items)}
    property DataSource: TStrings read GetDataSource write SetDataSource;
    property CompareMode: TCompareMode read GetCompareMode write FCompareMode;
    property Items[const Value: string]: Integer read GetItem; default;
  end;

{    }
type
  TStringsListIndex = class(TCustomColIndex)
  private
    FCompareMode: TCompareMode;
    FIndexCompareMode: TCompareMode;
  protected
    function GetItemCount: Integer; override;
    function CompareItems(Item1Index,
      Item2Index: Integer): Integer; override;
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; override;
    procedure UpdateContent; override;
    {}
    function GetDataSource: TStringsList;
    procedure SetDataSource(NewDataSource: TStringsList);
    function GetCompareMode: TCompareMode;
    function GetItem(Values: TStrings): Integer;
  public
    constructor Create;
    {}
    {    (DataSource),  , 
     [cmCaseInsensitive, cmUseLangDriver, cmTrimed, cmNullAsNone,
    cmAllowUnassigned] (CompareMode),     
    Values,       (Items)}
    property DataSource: TStringsList read GetDataSource write SetDataSource;
    property CompareMode: TCompareMode read GetCompareMode write FCompareMode;
    property Items[Values: TStrings]: Integer read GetItem; default;
  end;

{  }
type
  TIndexedStrings = class(TCustomIndexedList)
  private
    FStrings: TStringList;
    FListGetItemTemp: string;
  protected
    function ListGetCapacity: Integer; override;
    procedure ListSetCapacity(NewCapacity: Integer); override;
    function ListGetCount: Integer; override;
    procedure ListSetCount(NewCount: Integer); override;
    function ListGetItem(Index: Integer): Pointer; override;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); override;
    procedure ListClear; override;
    procedure ListInsert(Index: Integer); override;
    procedure ListDelete(Index: Integer); override;
    procedure ListCreate; override;
    procedure ListDestroy; override;
    function CreateIndex: TCustomIndex; override;
    {}
    function ListExportItem(Index: Integer): string; override;
    procedure ListImportItem(Index: Integer; const Value: string); override;
    {}
    function GetItem(Index: Integer): string;
    procedure SetItem(Index: Integer; const NewValue: string);
    function GetSorted(Number: Integer): string;
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    {}
    function Add(const Value: string): Integer;
    procedure Insert(Index: Integer; const Value: string);
    function IndexOf(const Value: string): Integer;
    { ,   Value (  CompareMode), 
    (-1),   }
    function StartingFrom(const Value: string): Integer;
    {}
    property Items[Index: Integer]: string read GetItem write SetItem;
      default;
    property Sorted[Number: Integer]: string read GetSorted;
    {     }
    property CompareMode: TCompareMode
      read GetCompareMode write SetCompareMode;
  end;
  PIndexedStrings = ^TIndexedStrings;
  {     }
  TIndexedStringsAccessMethod = function: TIndexedStrings of object;
{    (TIndexedStrings)    
(TStrings)}
type
  TIndexedStringList = class(TStringsStd)
  private
    FIndexedStrings: TIndexedStrings;
    FObjectList: TList;
  protected
    function Get(Index: Integer): string; override;
    procedure Put(Index: Integer; const S: string); override;
    function GetObject(Index: Integer): TObject; override;
    procedure PutObject(Index: Integer; AObject: TObject); override;
    function GetCapacity: Integer; override;
    procedure SetCapacity(NewCapacity: Integer); override;
    function GetCount: Integer; override;
    procedure SetCount(NewCount: Integer);
  public
    {     }
    constructor Create(IndexedStrings: TIndexedStrings);
    destructor Destroy; override;
    {}
    procedure Clear; override;
    procedure Insert(Index: Integer; const S: string); override;
    procedure Delete(Index: Integer); override;
    function IndexOf(const S: string): Integer; override;
    {}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    {}
    {  ;     
    ,   ,    }
    property IndexedStrings: TIndexedStrings
      read FIndexedStrings write FIndexedStrings;
  end;
{     IndexedStrings,    nil,
 0 (GetIndexedStringsCount);     
NewValue      Index    
Count ,     IndexedStrings 
GetPointer, SetPointer (GetIndexedStrings, SetIndexedStrings)}
function GetIndexedStringsCount(IndexedStrings: TIndexedStrings): Integer;
function GetIndexedString(IndexedStrings: TIndexedStrings; Index,
  Count: Integer): string;
procedure SetIndexedString(var IndexedStrings: TIndexedStrings; Index,
  Count: Integer; const NewValue: string);
{    ,    DivStr,
 SkipEmpty = True   ,  IsSorted = True 
      
(IndexedStringsToStr);     Strings  
      ++   , 
,  IsSorted = True     
   (IndexedStringsToShowStr)}
function IndexedStringsToStr(IndexedStrings: TIndexedStrings;
  const DivStr: string; SkipEmpty, IsSorted: Boolean): string;
function IndexedStringsToShowStr(IndexedStrings: TIndexedStrings;
  IsSorted: Boolean): string;
{    Strings    
IndexedStrings}
procedure StringsToIndexedStrings(Strings: TStrings;
  IndexedStrings: TIndexedStrings);
{    DivStr    
    IndexedStrings,  SkipEmpty = True  
,  IsTrim = True       ,
       SkipEmpty = True,  
  (StrToIndexedStrings);  ,  ,
        ,
    (StrArrayToIndexedStrings)}
procedure StrToIndexedStrings(const S: string; IndexedStrings: TIndexedStrings;
  const DivStr: string; SkipEmpty, IsTrim: Boolean);
procedure StrArrayToIndexedStrings(const StrArray: string;
  IndexedStrings: TIndexedStrings);
{    Index   IndexedStrings,  
 Count,       ,   
          
,   Count,   ,   
 IndexedStrings  Count,     
IndexedStrings   Count (GetIndexedStringCheckOwerflow); 
 NewValue    Index   IndexedStrings, 
  Count,       ,
   NewValue,        
  ,   Count,    ,  
NewValue  Index      (Count - 1)  IndexedStrings
,    ,      
 (Index + 1),   ,      
 IndexedStrings  Count,      
   IndexedStrings  Count (SetIndexedStringCheckOwerflow)}
function GetIndexedStringCheckOwerflow(IndexedStrings: TIndexedStrings; Index,
  Count: Integer): string;
procedure SetIndexedStringCheckOwerflow(var IndexedStrings: TIndexedStrings;
  Index, Count: Integer; const NewValue: string);
{     IndexedStrings   
Strings,   nil,    BegIdx,    0,
 EndIdx,        
  }
procedure IndexedStringsAddStrings(IndexedStrings: TIndexedStrings;
  Strings: TStrings; BegIdx, EndIdx: Integer);
{   IndexedStrings   Mode,  
 ResIndexedStrings,  RemoveDuplicates  True  ,
 RemoveEmpty  True   }
procedure SortIndexedStrings(IndexedStrings, ResIndexedStrings:
  TIndexedStrings; Mode: TSortMode; RemoveDuplicates, RemoveEmpty: Boolean);
{ ,     IndexedStrings,  
     ExcludeValue    Value,
     Postfix    , 
 FirstNumber}
function FindUniqueByIndexedStrings(const Value, Postfix: string;
  FirstNumber: Integer; const ExcludeValue: string;
  IndexedStrings: TIndexedStrings): string;
{   Nums   Values   
,   UniqueValues,     
,   NumArrays}
procedure NumUniqueValues(Nums: TList; Values: TStrings;
  NumArrays: TObjList {TIndexedList}; UniqueValues: TIndexedStrings);
{      ObjList (SafeAddStringList); 
      ObjList
(SafeAddIndexedStringList)}
procedure SafeAddStringList(ObjList: TObjList);
procedure SafeAddIndexedStrings(ObjList: TObjList);
{     Strings,   nil,  
IndexedStrings,   nil  0 (StringsOrIndexedCount); 
   Index   Strings,   nil,  
IndexedStrings,   nil,      
(StringsOrIndexedGet)}
function StringsOrIndexedCount(Strings: TStrings;
  IndexedStrings: TIndexedStrings): Integer;
function StringsOrIndexedGet(Strings: TStrings;
  IndexedStrings: TIndexedStrings; Index: Integer): string;
{ True,     AObject
 TIndexedStrings  nil   0  (IndexedStringsIsEmpty);
    IndexOrMinTwo  IndexedStrings,  
 (-2)     IndexedStrings,  
 (-1)    ,   
  Param      TIndexedStrings
 ObjList         ObjList.ActiveIndex,
     Param   
(IndexedStringsObjListGet);     Index  IndexedStrings
  Value,    (-1)    ,
     Param     
TIndexedStrings  ObjList       
 ObjList.ActiveIndex,      Param
  (IndexedStringsObjListSet)}
function IndexedStringsIsEmpty(AObject: TObject): Boolean;
function IndexedStringsObjListGet(ObjList: TObjList;
  IndexedStrings: TIndexedStrings; IndexOrMinTwo: Integer;
  const Param: string): TVariant;
function IndexedStringsObjListSet(ObjList: TObjList;
  IndexedStrings: TIndexedStrings; Index: Integer;
  const Param, Value: string): Integer;
{  ,   nil,  IndexedStrings,  
    Capacity}
procedure IndexedStringsClearOrCreate(var IndexedStrings: TIndexedStrings;
  Capacity: Integer);
{ ListClearOrCreate     List1Ptr, List2Ptr, List3Ptr,
StringsClearOrCreate      Strings1Ptr, Strings2Ptr,
Strings3Ptr, Strings4Ptr, Strings5Ptr, Strings6Ptr, Strings7Ptr,
IndexedStringsClearOrCreate      
IndexedStrings1Ptr, IndexedStrings2Ptr, IndexedStrings3Ptr, 
  nil,   ,  Capacity}
procedure MultiListClearOrCreate(List1Ptr, List2Ptr, List3Ptr {TList},
  Strings1Ptr, Strings2Ptr, Strings3Ptr, Strings4Ptr, Strings5Ptr, Strings6Ptr,
  Strings7Ptr {TStringList}, IndexedStrings1Ptr, IndexedStrings2Ptr,
  IndexedStrings3Ptr {TIndexedStrings}: Pointer; Capacity: Integer);
{   Text     
  Categories, CategoryPrefix   ,    
  ,     DivStr  ,
    ,    
}
procedure TextCategories(const Text, CategoryPrefix, DivStr: string;
  Categories: TIndexedStrings);

{      ,   }
type
  TIndexedStringsList = class(TCustomColIndexedList)
  private
    FStringsList: TStringsList;
    FListGetItemTemp: string;
    FItemListGetTemp: string;
    FDefValue: string;
    FValueCompareMode: TCompareMode;
  protected
    function ListGetColCapacity: Integer; override;
    procedure ListSetColCapacity(NewColCapacity: Integer); override;
    function ListGetCapacity: Integer; override;
    procedure ListSetCapacity(NewCapacity: Integer); override;
    function ListGetColCount: Integer; override;
    procedure ListSetColCount(NewColCount: Integer); override;
    function ListGetCount: Integer; override;
    procedure ListSetCount(NewCount: Integer); override;
    function ListGetItem(Index: Integer): Pointer; override;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); override;
    procedure ListClear; override;
    procedure ListInsertCol(ColIndex: Integer;
      ItemPtr: Pointer); override;
    procedure ListInsert(Index: Integer); override;
    procedure ListDeleteCol(ColIndex: Integer); override;
    procedure ListDelete(Index: Integer); override;
    procedure ListCreate; override;
    procedure ListDestroy; override;
    function CreateIndex: TCustomIndex; override;
    function ItemListGet(ItemListPtr: Pointer; Index: Integer): Pointer;
      override;
    function ItemsCompare(Item1Ptr, Item2Ptr: Pointer): Boolean; override;
    {}
    function ListExportItem(Index: Integer): string; override;
    procedure ListImportItem(Index: Integer; const Value: string); override;
    {}
    function GetItem(ColIndex, Index: Integer): string;
    procedure SetItem(ColIndex, Index: Integer; const NewValue: string);
    function GetSorted(ColIndex, Number: Integer): string;
    function GetValue(Values: TStrings; ColIndex: Integer): string;
    procedure SetValue(Values: TStrings; ColIndex: Integer;
      const NewValue: string);
    function GetDefValue: string;
    procedure SetDefValue(const NewDefValue: string);
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    {}
    function AddCol(Values: TStrings): Integer;
    function Add(Values: TStrings): Integer;
    procedure InsertCol(ColIndex: Integer; Values: TStrings);
    procedure Insert(Index: Integer; Values: TStrings);
    function IndexOf(Values: TStrings): Integer;
    {}
    property Items[ColIndex, Index: Integer]: string
      read GetItem write SetItem; default;
    property Sorted[ColIndex, Number: Integer]: string read GetSorted;
    property Values[Values: TStrings; ColIndex: Integer]: string
      read GetValue write SetValue;
    {    Values,    ''}
    property DefValue: string read GetDefValue write SetDefValue;
    {     ,  
    [cmCaseInsensitive, cmUseLangDriver, cmTrimed, cmNullAsNone,
    cmAllowUnassigned] (CompareMode)     DefValue 
    Values,   [cmCaseInsensitive, cmUseLangDriver, cmTrimed,
    cmNullAsNone, cmAllowUnassigned] (ValueCompareMode)}
    property CompareMode: TCompareMode
      read GetCompareMode write SetCompareMode;
    property ValueCompareMode: TCompareMode
      read FValueCompareMode write FValueCompareMode;
  end;
{     IndexedStringsList  
  ,  ColDivStr, ,  DivStr,
 IsSorted = True       
}
function IndexedStringsListToStr(IndexedStringsList: TIndexedStringsList;
  const ColDivStr, DivStr: string; IsSorted: Boolean): string;
{     IndexedStringsList  
   ,  #13#10,     
    ++     , 
,  IsSorted = True     
  }
function IndexedStringsListToShowStr(IndexedStringsList: TIndexedStringsList;
  IsSorted: Boolean): string;
{  TextStr   IndexedStringsList,  -  
   }
procedure TextToIndexedStringsList(const TextStr: string;
  IndexedStringsList: TIndexedStringsList);
{  Text   Table      
 Categories, HeaderPrefix    , CategoryPrefix
    , DivStr   
  , DateTimeCategory     Categories,
 ,      , HeaderCategory
    Categories,  , 
    ,    
  PartFromText}
procedure TextToTable(const Text, HeaderPrefix, CategoryPrefix, DivStr,
  DateTimeCategory, HeaderCategory: string; Categories: TIndexedStrings;
  Table: TIndexedStringsList);
{  Table        
CommaSeparated, DivideChar  , , ';'  Excel,
BorderChar  ,  , , '"'  Excel,
       }
procedure TableToCommaSeparated(Table: TIndexedStringsList; DivideChar,
  BorderChar: Char; CommaSeparated: TStrings);

{ ,        }
type
  TStringParams = class(TObjectStd)
  private
    FNames: TIndexedStrings;
    FValues: TStringList;
    FLastExists: Boolean;
    FLastIndex: Integer;
    FLastName: string;
  protected
    function GetCount: Integer;
    function GetName(Index: Integer): string;
    function GetValue(Index: Integer): string;
    procedure SetValue(Index: Integer; const NewValue: string);
    function GetItem(const ParamName: string): string;
    procedure SetItem(const ParamName, NewValue: string);
    function GetLast: string;
    procedure SetLast(const NewValue: string);
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   (Clear);   ParamName,   ,
     (-1)}
    procedure Clear;
    function IndexOf(const ParamName: string): Integer;
    {}
    {  (Count);    Index (Names);  
     Index (Values);    ParamName,   
    ,    '',   
    ,   ''  (Items); 
      ,     
     Items (Last);     
       ,   [cmCaseInsensitive, cmUseLangDriver,
    cmTrimed, cmNullAsNone, cmAllowUnassigned] (CompareMode);  
      0}
    property Count: Integer read GetCount;
    property Names[Index: Integer]: string read GetName;
    property Values[Index: Integer]: string read GetValue write SetValue;
    property Items[const ParamName: string]: string
      read GetItem write SetItem; default;
    property Last: string read GetLast write SetLast;
    property CompareMode: TCompareMode read
      GetCompareMode write SetCompareMode;
  end;
{    StringParams   
  ,  #13#10,     
       ++    (
  ),   }
function StringParamsToShowStr(StringParams: TStringParams): string;
{  OldPrefix  NewPrefix    StringParams,
     }
function StrParamsChangePrefix(const StringParams: TStringParams;
  const OldPrefix, NewPrefix: string): Integer;

type
  TStringArrays = class;
  { ,     TStringArrays}
  TStringArray = class(TIndexedStrings)
  private
    FParent: TStringArrays;
    FName: string;
  protected
  public
    {     Parent   Name, 
        Parent    nil}
    constructor Create(Parent: TStringArrays; const Name: string);
    destructor Destroy; override;
    {}
    {      (Name)    
      (Parent)}
    property Name: string read FName;
    property Parent: TStringArrays read FParent;
  end;
  {  }
  TStringArrays = class(TObjectStd)
  private
    FNames: TIndexedStrings;
    FArrays: TIndexedList;
    FLastExists: Boolean;
    FLastIndex: Integer;
    FLastName: string;
    FIsInternalAdd: Boolean;
    FIsInternalDelete: Boolean;
    {}
    procedure AddItem(Item: TStringArray);
    procedure DeleteItem(Item: TStringArray);
  protected
    function GetCount: Integer;
    function GetName(Index: Integer): string;
    function GetArrays(Index: Integer): TStringArray;
    function GetItem(const ArrayName: string): TStringArray;
    function GetLast: TStringArray;
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { ,   }
    procedure Clear;
    {}
    {  (Count);     Index (Names);
       Index (Arrays);     ArrayName (Items);
       Items  (Last);   
         ,   [cmCaseInsensitive,
    cmUseLangDriver, cmTrimed, cmNullAsNone, cmAllowUnassigned] (CompareMode);
        0}
    property Count: Integer read GetCount;
    property Names[Index: Integer]: string read GetName;
    property Arrays[Index: Integer]: TStringArray read GetArrays;
    property Items[const ArrayName: string]: TStringArray read GetItem;
      default;
    property Last: TStringArray read GetLast;
    property CompareMode: TCompareMode read
      GetCompareMode write SetCompareMode;
  end;
{     StringArrays   
  ,  #13#10,     ++  
 (   ),   ,
      -  ,    
 ,   }
function StringArraysToShowStr(StringArrays: TStringArrays): string;

{    }
type
  TParamValues = class(TObjectStd)
  private
    FLastIndex: Integer;
    FOwnsParams: Boolean;
    FOwnsTypes: Boolean;
    FOwnsValues: Boolean;
    FParams: TIndexedStrings;
    FTypes: TIndexedList;
    FValues: TIndexedStrings;
  protected
    function ParamsGetFunc(Index: Integer; Data: Pointer): string;
    function ParamsAddFunc(const Value: string; Data: Pointer): Integer;
    function TypesGetFunc(Index: Integer; Data: Pointer): Pointer;
    function TypesAddFunc(Value: Pointer; Data: Pointer): Integer;
    function ValuesGetFunc(Index: Integer; Data: Pointer): string;
    function ValuesAddFunc(const Value: string; Data: Pointer): Integer;
    {}
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetCountTyped: Integer;
    procedure SetCountTyped(NewCountTyped: Integer);
    function GetParams: TIndexedStrings;
    procedure SetParams(NewParams: TIndexedStrings);
    function GetTypes: TIndexedList;
    procedure SetTypes(NewTypes: TIndexedList);
    function GetValues: TIndexedStrings;
    procedure SetValues(NewValues: TIndexedStrings);
    function GetItem(const Param: string): string;
    procedure SetItem(const Param, NewValue: string);
    function GetExportStr(IsTyped: Boolean): string;
    procedure SetExportStr(IsTyped: Boolean; const NewExportStr: string);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {    (Clear);   Param 
     Value,    ,   
    Param    Params,  Value   Values 
         Params,    Values 
    ,    (Add);  
    Param   Value   AType,    ,
       Add,   ReplaceIfExists = True  ,
          ,     
     ,     Params.AddDuplicates (AddTyped);
        Param,      
        ,  DefValue
    (ParamValue)}
    procedure Clear;
    function Add(const Param, Value: string): Integer;
    function AddTyped(const Param: string; AType: Integer;
      const Value: string; ReplaceIfExists: Boolean): Integer;
    function ParamValue(const Param, DefValue: string): string;
    {}
    {   ,     
         ,     
    Types (Count);  Count,   Types (CountTyped); 
     ,      
         ,   True
    (OwnsParams, OwnTypes, OwnValues);    , 
      ,      ,  ,
        True,   , 
           ,  
       nil    (Params, Types,
    Values);      Param (Items); 
       ParamValue    , (-1),
           (LastIndex);    
      ,  IsTyped = True    ,
        GetValueFromArray,  , 
       GetIntFromArray     , 
    ,       (ExportStr)}
    property Count: Integer read GetCount write SetCount;
    property CountTyped: Integer read GetCountTyped write SetCountTyped;
    property OwnsParams: Boolean read FOwnsParams write FOwnsParams;
    property OwnsTypes: Boolean read FOwnsTypes write FOwnsTypes;
    property OwnsValues: Boolean read FOwnsValues write FOwnsValues;
    property Params: TIndexedStrings read GetParams write SetParams;
    property Types: TIndexedList read GetTypes write SetTypes;
    property Values: TIndexedStrings read GetValues write SetValues;
    property Items[const Param: string]: string
      read GetItem write SetItem; default;
    property LastIndex: Integer read FLastIndex;
    property ExportStr[IsTyped: Boolean]: string
      read GetExportStr write SetExportStr;
  end;

{   }
type
  TStringsService = class(TObjectStd)
  private
    FLastStringsId: Integer;
    FCheckStringsId: Boolean;
    FStringsIds: TIndexedList;
    FStringsNames: TIndexedStrings;
    FStringsList: TObjList;
    FStringsValues: TObjList;
    FStringsRef: TIndexedStringList;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {,      ( 
        );    
        }
    function CreateStrings(const StringsName: string): Integer;
    function FindStrings(const StringsName: string): Integer;
    procedure DeleteStrings(StringsId: Integer);
    {}
    {    , , , ,
             StringsId}
    procedure SetStringCount(StringsId, Count: Integer);
    function GetStringCount(StringsId: Integer): Integer;
    function AddString(StringsId: Integer; const S: string): Integer;
    procedure DeleteString(StringsId, Index: Integer);
    function FindString(StringsId: Integer; const S: string): Integer;
    procedure SetString(StringsId, Index: Integer; const S: string);
    function GetString(StringsId, Index: Integer): string;
    {}
    { ()    ()    
      DivStr    ,   
       ,      LineLen}
    function StringsToText(StringsId: Integer): string;
    procedure TextToStrings(StringsId: Integer; const TextStr: string);
    function StringsToString(StringsId: Integer;
      const DivStr: string): string;
    procedure StringToStrings(StringsId: Integer; const S, DivStr: string);
    procedure StringToLines(StringsId: Integer; const S: string;
      LineLen: Integer);
    {    ,     
     ,   (   
    ) (StringsToArray)     
        (ArrayToStrings)}
    function StringsToStrArray(StringsId: Integer): string;
    procedure StrArrayToStrings(StringsId: Integer; const StrArray: string);
    {}
    {    ,     
          }
    procedure SetValue(StringsId, Index: Integer; const Value: string);
    function GetValue(StringsId, Index: Integer): string;
    function AddParamValue(StringsId: Integer; const S,
      Value: string): Integer;
    function ParamValue(StringsId: Integer; const S: string): string;
    {}
    { ()      () 
    (),   (),  ()  
       Web}
    function ParamsToData(StringsId: Integer): string;
    procedure DataToParams(StringsId: Integer; const DataStr: string);
    function ParamsToWebData(StringsId: Integer): string;
    procedure WebDataToParams(StringsId: Integer;
      const WebDataStr: string);
  end;

{  }
type
  TCachedStrings = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockStrings: TStringList;
  end;
{     CachedStrings,   nil  
}
function LockStrings(var CachedStrings: TCachedStrings): TStringList;
{  }
type
  TCachedStringsLists = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockStringsList: TStringsList;
  end;
{   }
type
  TCachedIndexedStrings = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockIndexedStrings: TIndexedStrings;
  end;
{      CachedIndexedStrings,
  nil   }
function LockIndexedStrings(var CachedIndexedStrings: TCachedIndexedStrings):
  TIndexedStrings;
{   }
type
  TCachedIndexedStringsLists = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockIndexedStringsList: TIndexedStringsList;
  end;

{   TextLines,  IsLoadVars   
 ,   SplitSetVar,  IsUseFirstVars  
  ,  ,    
VarLineIndexes,    VarNames,  -  VarValues, 
  -  VarNameBegIndexes,  -  VarNameEndIndexes, 
 -  VarValueBegIndexes,  -  VarValueEndIndexes, 
IsLoadFuncVars       FuncName  
IsFuncSubName = True - ,  FuncName,     
,       ,  - 
 ,  IsUseFirstFuncVars    
,  ,     
FuncVarLineIndexes,   -  FuncNames,   - 
FuncVarNames,  -  FuncVarValues,    
GetStrFromArray -  FuncOtherParamStrArrays,     - 
FuncNameBegIndexes,  -  FuncNameEndIndexes,    - 
FuncVarNameBegIndexes,    -  FuncVarNameEndIndexes, 
 -  FuncVarValueBegIndexes,  -  FuncVarValueEndIndexes, 
FuncParamOtherBegIndexes      
 Integer,  FuncParamOtherEndIndexes - }
procedure LoadVars(TextLines: TStrings; IsLoadVars, IsUseFirstVars: Boolean;
  VarLineIndexes: TList; VarNames: TIndexedStrings; VarValues: TStrings;
  VarNameBegIndexes, VarNameEndIndexes, VarValueBegIndexes,
  VarValueEndIndexes: TList; IsLoadFuncVars, IsUseFirstFuncVars: Boolean;
  const FuncName: string; IsFuncSubName: Boolean; FuncVarLineIndexes: TList;
  FuncNames: TStrings; FuncVarNames: TIndexedStrings; FuncVarValues,
  FuncOtherParamStrArrays: TStrings; FuncNameBegIndexes, FuncNameEndIndexes,
  FuncVarNameBegIndexes, FuncVarNameEndIndexes, FuncVarValueBegIndexes,
  FuncVarValueEndIndexes: TList; FuncParamOtherBegIndexes,
  FuncParamOtherEndIndexes: TStrings);
{   VarName     VarNames
   VarValues,    True,   
 VarValue,    ,   
  'b', 'Bool', 'Is'  , 'n', 'Num', 'Float' 
, 'd', 'Date', 'DateTime'  , 's', 'Str'  , 'v', 'Var'
  }
function RetrieveVarValue(const VarName: string; VarNames: TIndexedStrings;
  VarValues: TStrings; out VarValue: string): Boolean;
{    NewTextLines  
  CurrentTextLines,   LoadVars,  
  RetrieveVarValue,    
  ,    FuncName,  VarNames
 ,   VarValues -  ,   
  nil,     , 
CurrentTextLines = nil     NewTextLines 
 VarNames  VarValues, UnchangeableVarNames   
,     NewTextLines   
 CurrentTextLines}
procedure DefineVars(NewTextLines, CurrentTextLines: TStrings;
  const FuncName: string; VarNames: TIndexedStrings; VarValues: TStrings;
  UnchangeableVarNames: TIndexedStrings);

{   TextBlock   Fields   Values, 
  -   =,    
 :   ,     - ,
  ,      ,
:
1=1
2=2
3:5

4= 
      ,     ,
    ,   ,   
   }
procedure TextBlockToFieldsValues(const TextBlock: string; Fields,
  Values: TStrings);
{   DataBlock   Fields   Values,  
 -      ,  , 
  ,     ,  FirstFields 
   ,    DataBlock,  
  ,       
   ,   ,  
  ,      , 
FirstFields = nil ,    ,  CountDefined = True 
  ,    FirstFields,   
     ,    Fields,
  Values}
procedure DataBlockToFieldsValues(const DataBlock: string;
  FirstFields: TStrings; CountDefined: Boolean; Fields, Values: TStrings);

{        
GGlbUtil.GetExportStr, GGlbUtil.SetExportStr}
type
  TStringsExport = class(TObjectStd)
  private
    FConvertIndex: TConvertIntMethod;
    FParamsCount: TRetrieveIntMethod;
    FParamsClear: THandleMethod;
    FParamsGet: TStringsGetMethod;
    FParamsAdd: TStringsAddMethod;
    FDefParamsCount: Integer;
    FParams: TStringList;
    FIndexedParams: TIndexedStrings;
    FTypesClear: THandleMethod;
    FTypesGet: TListGetMethod;
    FTypesAdd: TListAddMethod;
    FTypes: TList;
    FIndexedTypes: TIndexedList;
    FValuesClear: THandleMethod;
    FValuesGet: TStringsGetMethod;
    FValuesAdd: TStringsAddMethod;
    FValues: TStringList;
    FIndexedValues: TIndexedStrings;
    FExcludeParam: TCheckStrMethod;
    FDefExcludeParam: TCheckStrMethod;
    FExcludeParams: TStringList;
    FExcludeIndexedParams: TIndexedStrings;
    FIsSorted: Boolean;
    FMode: TCompareMode;
    FData: Pointer;
  protected
    function ConvertIndexFunc(Value: Integer; Data: Pointer): Integer;
    function IndexedConvertIndexFunc(Value: Integer; Data: Pointer): Integer;
    function ParamsCountFunc(Data: Pointer): Integer;
    procedure ParamsClearFunc(Data: Pointer);
    function ParamsGetFunc(Index: Integer; Data: Pointer): string;
    function ParamsAddFunc(const Value: string; Data: Pointer): Integer;
    function IndexedParamsCountFunc(Data: Pointer): Integer;
    procedure IndexedParamsClearFunc(Data: Pointer);
    function IndexedParamsGetFunc(Index: Integer; Data: Pointer): string;
    function IndexedParamsAddFunc(const Value: string;
      Data: Pointer): Integer;
    procedure TypesClearFunc(Data: Pointer);
    function TypesGetFunc(Index: Integer; Data: Pointer): Pointer;
    function TypesAddFunc(Value, Data: Pointer): Integer;
    procedure IndexedTypesClearFunc(Data: Pointer);
    function IndexedTypesGetFunc(Index: Integer; Data: Pointer): Pointer;
    function IndexedTypesAddFunc(Value, Data: Pointer): Integer;
    procedure ValuesClearFunc(Data: Pointer);
    function ValuesGetFunc(Index: Integer; Data: Pointer): string;
    function ValuesAddFunc(const Value: string; Data: Pointer): Integer;
    procedure IndexedValuesClearFunc(Data: Pointer);
    function IndexedValuesGetFunc(Index: Integer; Data: Pointer): string;
    function IndexedValuesAddFunc(const Value: string;
      Data: Pointer): Integer;
    function ExcludeParamsFunc(const Value: string; Data: Pointer): Boolean;
    function ExcludeIndexedParamsFunc(const Value: string;
      Data: Pointer): Boolean;
    {}
    procedure SetExcludeParams(NewExcludeParams: TStringList);
    procedure SetExcludeIndexedParams(NewExcludeIndexedParams:
      TIndexedStrings);
    function GetExportStr: string;
    procedure SetExportStr(const NewExportStr: string);
  public
    {  ,     
    ParamsCount,  nil,   Params  IndexedParams,  nil,
     DefParamsCount,     
    ParamsClear,  nil,  ,   
      ParamsGet,  nil,  Params  IndexedParams,  nil,
      ,     
    ParamsAdd, ,       TypesClear, TypesGet,
    TypesAdd, Types, IndexedTypes, ,      
    ValuesClear, ValuesGet, ValuesAdd, Values,    
    ExcludeParam,  nil,  ,   ExcludeParams,
     nil,   ExcludeIndexedParams,  nil,  ,
    IsSorted        IndexedParams, Mode
           IndexedParams,   
       UpperTrimMode    
    Params  IndexedParams, Data  ,  }
    constructor Create(ParamsCount: TRetrieveIntMethod;
      ParamsClear: THandleMethod; ParamsGet: TStringsGetMethod;
      ParamsAdd: TStringsAddMethod; DefParamsCount: Integer;
      Params: TStringList; IndexedParams: TIndexedStrings;
      TypesClear: THandleMethod; TypesGet: TListGetMethod;
      TypesAdd: TListAddMethod; Types: TList; IndexedTypes: TIndexedList;
      ValuesClear: THandleMethod; ValuesGet: TStringsGetMethod;
      ValuesAdd: TStringsAddMethod; Values: TStringList;
      IndexedValues: TIndexedStrings; ExcludeParam: TCheckStrMethod;
      ExcludeParams: TStringList; ExcludeIndexedParams: TIndexedStrings;
      IsSorted: Boolean; Mode: TCompareMode; Data: Pointer);
    {}
    {  , ,   
    ExcludeParam  nil (ExcludeParams);   
      , ,    ExcludeParam
     nil   ExcludeParams  nil (ExcludeIndexedParams); 
          IndexedParams (IsSorted), 
          IndexedParams,   
       UpperTrimMode    
    Params  IndexedParams (Mode); ,   (Data);
       GGlbUtil.GetExportStr  ,   
    GGlbUtil.SetExportStr    (ExportStr)}
    property ExcludeParams: TStringList
      read FExcludeParams write SetExcludeParams;
    property ExcludeIndexedParams: TIndexedStrings
      read FExcludeIndexedParams write SetExcludeIndexedParams;
    property IsSorted: Boolean read FIsSorted write FIsSorted;
    property Mode: TCompareMode read FMode write FMode;
    property Data: Pointer read FData write FData;
    property ExportStr: string read GetExportStr write SetExportStr;
  end;



{---   --------------------------------------------------------}

{    }
type
  TVariants = class(TObjectStd)
  private
    FItems: TList;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): Variant;
    procedure SetItem(Index: Integer; const NewValue: Variant);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   (Clear),      V,
        (Add),   V 
     Index (Insert)      Index (Delete)}
    procedure Clear;
    function Add(const V: Variant): Integer;
    procedure Insert(Index: Integer; const V: Variant);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity),     (Count)  
         Index,    (Items); 
        Unassigned}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: Variant read GetItem write SetItem;
      default;
  end;
{     Variants,    nil,
 0 (GetVariantsCount);     
NewValue      Index   
 Count ,     Variants 
GetPointer, SetPointer (GetVariant, SetVariant);   
 Variants     Index   NewValue,
        ,
  Unassigned     (DefineVariant)}
function GetVariantsCount(Variants: TVariants): Integer;
function GetVariant(Variants: TVariants; Index, Count: Integer): Variant;
procedure SetVariant(var Variants: TVariants; Index, Count: Integer;
  const NewValue: Variant);
procedure DefineVariant(Variants: TVariants; Index: Integer;
  const NewValue: Variant);
{    Variants      
  ++   ,  }
function VariantsToShowStr(Variants: TVariants): string;
{   VarRecs    Vars
(VarRecsToVariants)   ,     MaxCount
,   MaxCount  ,    
(VarRecsToVariantsSized)}
procedure VarRecsToVariants(VarRecs: array of const; Vars: TVariants);
procedure VarRecsToVariantsSized(VarRecs: array of const; Vars: TVariants;
  MaxCount: Integer);

{  TNullVarValue}
type
  TNullVarValues = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TNullVarValue;
    procedure SetItem(Index: Integer; const Value: TNullVarValue);
    function GetItemPtr(Index: Integer): PNullVarValue;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TNullVarValue): Integer;
    procedure Insert(Index: Integer; const Value: TNullVarValue);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TNullVarValue read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PNullVarValue read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{     NullVarValues,    nil,
 0 (GetNullVarValuesCount);     
NewValue      Index    
Count ,     NullVarValues 
GetPointer, SetPointer (GetNullVarValues, SetNullVarValues)}
function GetNullVarValuesCount(const NullVarValues: TNullVarValues): Integer;
function GetNullVarValue(NullVarValues: TNullVarValues; Index,
  Count: Integer): TNullVarValue;
procedure SetNullVarValue(var NullVarValues: TNullVarValues; Index,
  Count: Integer; const NewValue: TNullVarValue);

{  }
type
  TVariantsList = class(TObjectStd)
  private
    FItems: TLists;
  protected
    function GetColCapacity: Integer;
    procedure SetColCapacity(NewColCapacity: Integer);
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetColCount: Integer;
    procedure SetColCount(NewColCount: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(ColIndex, Index: Integer): Variant;
    procedure SetItem(ColIndex, Index: Integer; const NewValue: Variant);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {      (Clear),  
         Variants,   
    Unassigned,   Variants   nil,  
      (AddCol),    (Add), 
         ColIndex (InsertCol),  
        Index (Insert),    
    ColIndex (DeleteCol),     Index (Delete)}
    procedure Clear;
    function AddCol(Variants: TVariants): Integer;
    function Add(Variants: TVariants): Integer;
    procedure InsertCol(ColIndex: Integer; Variants: TVariants);
    procedure Insert(Index: Integer; Variants: TVariants);
    procedure DeleteCol(ColIndex: Integer);
    procedure Delete(Index: Integer);
    {}
    {   (ColCapacity),   
    (Capacity),   (ColCount),  
    (Count),      ColIndex,   
    Index,    (Items)}
    property ColCapacity: Integer read GetColCapacity write SetColCapacity;
    property Capacity: Integer read GetCapacity write SetCapacity;
    property ColCount: Integer read GetColCount write SetColCount;
    property Count: Integer read GetCount write SetCount;
    property Items[ColIndex, Index: Integer]: Variant
      read GetItem write SetItem; default;
  end;
{     VariantsList   
  ,  #13#10,     
      ++   , 
}
function VariantsListToShowStr(VariantsList: TVariantsList): string;

{  }
type
  TVariantsIndex = class(TCustomIndex)
  private
    FCompareMode: TCompareMode;
    FIndexCompareMode: TCompareMode;
  protected
    function GetItemCount: Integer; override;
    function CompareItems(Item1Index,
      Item2Index: Integer): Integer; override;
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; override;
    procedure UpdateContent; override;
    {}
    function GetDataSource: TVariants;
    procedure SetDataSource(NewDataSource: TVariants);
    function GetCompareMode: TCompareMode;
    function GetItem(const Value: Variant): Integer;
  public
    constructor Create;
    {}
    {   (DataSource),  ,  
    [cmCaseInsensitive, cmUseLangDriver, cmTrimed, cmNullAsNone,
    cmAllowUnassigned] (CompareMode),      Value
    (Items)}
    property DataSource: TVariants read GetDataSource write SetDataSource;
    property CompareMode: TCompareMode read GetCompareMode write FCompareMode;
    property Items[const Value: Variant]: Integer read GetItem; default;
  end;

{    }
type
  TVariantsListIndex = class(TCustomColIndex)
  private
    FCompareMode: TCompareMode;
    FIndexCompareMode: TCompareMode;
  protected
    function GetItemCount: Integer; override;
    function CompareItems(Item1Index,
      Item2Index: Integer): Integer; override;
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; override;
    procedure UpdateContent; override;  
    {}
    function GetDataSource: TVariantsList;
    procedure SetDataSource(NewDataSource: TVariantsList);
    function GetCompareMode: TCompareMode;
    function GetItem(Values: TVariants): Integer;
  public
    constructor Create;
    {}
    {    (DataSource),  , 
     [cmCaseInsensitive, cmUseLangDriver, cmTrimed, cmNullAsNone,
    cmAllowUnassigned] (CompareMode),     
    Values,       (Items)}
    property DataSource: TVariantsList read GetDataSource write SetDataSource;
    property CompareMode: TCompareMode read GetCompareMode write FCompareMode;
    property Items[Values: TVariants]: Integer read GetItem; default;
  end;

{  }
type
  TIndexedVariants = class(TCustomIndexedList)
  private
    FValues: TVariants;
    FListGetItemTemp: Variant;
  protected
    function ListGetCapacity: Integer; override;
    procedure ListSetCapacity(NewCapacity: Integer); override;
    function ListGetCount: Integer; override;
    procedure ListSetCount(NewCount: Integer); override;
    function ListGetItem(Index: Integer): Pointer; override;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); override;
    procedure ListClear; override;
    procedure ListInsert(Index: Integer); override;
    procedure ListDelete(Index: Integer); override;
    procedure ListCreate; override;
    procedure ListDestroy; override;
    function CreateIndex: TCustomIndex; override;
    {}
    function ListExportItem(Index: Integer): string; override;
    procedure ListImportItem(Index: Integer; const Value: string); override;
    {}
    function GetItem(Index: Integer): Variant;
    procedure SetItem(Index: Integer; const NewValue: Variant);
    function GetSorted(Number: Integer): Variant;
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    {}
    function Add(const Value: Variant): Integer;
    procedure Insert(Index: Integer; const Value: Variant);
    function IndexOf(const Value: Variant): Integer;
    {}
    property Items[Index: Integer]: Variant read GetItem write SetItem;
      default;
    property Sorted[Number: Integer]: Variant read GetSorted;
    {     }
    property CompareMode: TCompareMode
      read GetCompareMode write SetCompareMode;
  end;
{     IndexedVariants,    nil,
 0 (GetIndexedVariantsCount);    
 NewValue      Index  
  Count ,     IndexedVariants
 GetPointer, SetPointer (GetIndexedVariants, SetIndexedVariants)}
function GetIndexedVariantsCount(IndexedVariants: TIndexedVariants): Integer;
function GetIndexedVariant(IndexedVariants: TIndexedVariants; Index,
  Count: Integer): Variant;
procedure SetIndexedVariant(var IndexedVariants: TIndexedVariants; Index,
  Count: Integer; const NewValue: Variant);
{    StringsList     
   ++   ,  ;  IsSorted =
True        }
function IndexedVariantsToShowStr(IndexedVariants: TIndexedVariants;
  IsSorted: Boolean): string;
{      ObjList (SafeAddVariants);
       ObjList
(SafeAddIndexedVariants)}
procedure SafeAddVariants(ObjList: TObjList);
procedure SafeAddIndexedVariants(ObjList: TObjList);

{    ,  ,   }
type
  TIndexedVariantsList = class(TCustomColIndexedList)
  private
    FValuesList: TVariantsList;
    FListGetItemTemp: Variant;
    FItemListGetTemp: Variant;
    FDefValue: Variant;
    FValueCompareMode: TCompareMode;
  protected
    function ListGetColCapacity: Integer; override;
    procedure ListSetColCapacity(NewColCapacity: Integer); override;
    function ListGetCapacity: Integer; override;
    procedure ListSetCapacity(NewCapacity: Integer); override;
    function ListGetColCount: Integer; override;
    procedure ListSetColCount(NewColCount: Integer); override;
    function ListGetCount: Integer; override;
    procedure ListSetCount(NewCount: Integer); override;
    function ListGetItem(Index: Integer): Pointer; override;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); override;
    procedure ListClear; override;
    procedure ListInsertCol(ColIndex: Integer;
      ItemPtr: Pointer); override;
    procedure ListInsert(Index: Integer); override;
    procedure ListDeleteCol(ColIndex: Integer); override;
    procedure ListDelete(Index: Integer); override;
    procedure ListCreate; override;
    procedure ListDestroy; override;
    function CreateIndex: TCustomIndex; override;
    function ItemListGet(ItemListPtr: Pointer; Index: Integer): Pointer;
      override;
    function ItemsCompare(Item1Ptr, Item2Ptr: Pointer): Boolean; override;
    {}
    function ListExportItem(Index: Integer): string; override;
    procedure ListImportItem(Index: Integer; const Value: string); override;
    {}
    function GetItem(ColIndex, Index: Integer): Variant;
    procedure SetItem(ColIndex, Index: Integer; const NewValue: Variant);
    function GetSorted(ColIndex, Number: Integer): Variant;
    function GetValue(Values: TVariants; ColIndex: Integer): Variant;
    procedure SetValue(Values: TVariants; ColIndex: Integer;
      const NewValue: Variant);
    function GetDefValue: Variant;
    procedure SetDefValue(const NewDefValue: Variant);
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    {}
    function AddCol(Values: TVariants): Integer;
    function Add(Values: TVariants): Integer;
    procedure InsertCol(ColIndex: Integer; Values: TVariants);
    procedure Insert(Index: Integer; Values: TVariants);
    function IndexOf(Values: TVariants): Integer;
    {}
    property Items[ColIndex, Index: Integer]: Variant
      read GetItem write SetItem; default;
    property Sorted[ColIndex, Number: Integer]: Variant read GetSorted;
    property Values[Values: TVariants; ColIndex: Integer]: Variant
      read GetValue write SetValue;
    {    Values,    Unassigned}
    property DefValue: Variant read GetDefValue write SetDefValue;
    {     ,  
    [cmCaseInsensitive, cmUseLangDriver, cmTrimed, cmNullAsNone,
    cmAllowUnassigned] (CompareMode)     DefValue 
    Values,   [cmCaseInsensitive, cmUseLangDriver, cmTrimed,
    cmNullAsNone, cmAllowUnassigned] (ValueCompareMode)}
    property CompareMode: TCompareMode
      read GetCompareMode write SetCompareMode;
    property ValueCompareMode: TCompareMode
      read FValueCompareMode write FValueCompareMode;
  end;
{     VariantsList   
  ,  #13#10,     
      ++   , 
;  IsSorted = True     
  }
function IndexedVariantsListToShowStr(IndexedVariantsList:
  TIndexedVariantsList; IsSorted: Boolean): string;

type
  { ,         
  Variant}
  TVariantParams = class(TObjectStd)
  private
    FNames: TIndexedStrings;
    FValues: TVariants;
    FLastExists: Boolean;
    FLastIndex: Integer;
    FLastName: string;
  protected
    function GetCount: Integer;
    function GetName(Index: Integer): string;
    function GetValue(Index: Integer): Variant;
    procedure SetValue(Index: Integer; const NewValue: Variant);
    function GetItem(const ParamName: string): Variant;
    procedure SetItem(const ParamName: string; const NewValue: Variant);
    function GetLast: Variant;
    procedure SetLast(const NewValue: Variant);
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   (Clear);   ParamName,   ,
     (-1)}
    procedure Clear;
    function IndexOf(const ParamName: string): Integer;
    {}
    {  (Count);    Index (Names);  
     Index (Values);    ParamName,   
    ,    Unassigned,   
    ,   Unassigned  (Items); 
      ,     
     Items (Last);     
       ,   [cmCaseInsensitive, cmUseLangDriver,
    cmTrimed, cmNullAsNone, cmAllowUnassigned] (CompareMode);  
      0}
    property Count: Integer read GetCount;
    property Names[Index: Integer]: string read GetName;
    property Values[Index: Integer]: Variant read GetValue write SetValue;
    property Items[const ParamName: string]: Variant
      read GetItem write SetItem; default;
    property Last: Variant read GetLast write SetLast;
    property CompareMode: TCompareMode read
      GetCompareMode write SetCompareMode;
  end;
  {  TVariantParams}
  TVariantParamsMethod = function: TVariantParams of object;
{  ParamName    Variant VariantParams, 
VariantParams = nil  Unassigned}
function VariantParam(VariantParams: TVariantParams;
  const ParamName: string): Variant;
{    VariantParams   
  ,  #13#10,     
       ++    (
  ),   }
function VariantParamsToShowStr(VariantParams: TVariantParams): string;
{  OldPrefix  NewPrefix    VariantParams,
     }
function VarParamsChangePrefix(const VariantParams: TVariantParams;
  const OldPrefix, NewPrefix: string): Integer;
{   VariantParams   ExportText,  
,   ,     
      VBVarImport,   ,
  ,    }
function ImportVariantParams(ExportText: string;
  VariantParams: TVariantParams): Integer;
{   ExportText  ImportVariantParams,  
    TVariantParams VariantParamsList,
 ,     VariantParamsNames,
         , 
    }
function ImportVariantParamsList(ExportText: string;
  VariantParamsNames: TIndexedStrings; VariantParamsList: TObjList): Integer;
{      VariantParams  
,        , 
    ,      ,
     ,    0,  
   Unassigned (VariantParams);  
   ExportText,     ImportVariantParams
     VariantParamsToVarArray (ImportVarArray)}
function VariantParamsToVarArray(VariantParams: TVariantParams): Variant;
function ImportVarArray(ExportText: string): Variant;

type
  TVariantArrays = class;
  { ,     TVariantArrays}
  TVariantArray = class(TIndexedVariants)
  private
    FParent: TVariantArrays;
    FName: string;
  protected
  public
    {     Parent   Name, 
        Parent    nil}
    constructor Create(Parent: TVariantArrays; const Name: string);
    destructor Destroy; override;
    {}
    {      (Name)    
      (Parent)}
    property Name: string read FName;
    property Parent: TVariantArrays read FParent;
  end;
  {  }
  TVariantArrays = class(TObjectStd)
  private
    FNames: TIndexedStrings;
    FArrays: TIndexedList;
    FLastExists: Boolean;
    FLastIndex: Integer;
    FLastName: string;
    FIsInternalAdd: Boolean;
    FIsInternalDelete: Boolean;
    {}
    procedure AddItem(Item: TVariantArray);
    procedure DeleteItem(Item: TVariantArray);
  protected
    function GetCount: Integer;
    function GetName(Index: Integer): string;
    function GetArrays(Index: Integer): TVariantArray;
    function GetItem(const ArrayName: string): TVariantArray;
    function GetLast: TVariantArray;
    function GetCompareMode: TCompareMode;
    procedure SetCompareMode(NewCompareMode: TCompareMode);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { ,   }
    procedure Clear;
    {}
    {  (Count);     Index (Names);
       Index (Arrays);     ArrayName (Items);
       Items  (Last);   
         ,   [cmCaseInsensitive,
    cmUseLangDriver, cmTrimed, cmNullAsNone, cmAllowUnassigned] (CompareMode);
        0}
    property Count: Integer read GetCount;
    property Names[Index: Integer]: string read GetName;
    property Arrays[Index: Integer]: TVariantArray read GetArrays;
    property Items[const ArrayName: string]: TVariantArray read GetItem;
      default;
    property Last: TVariantArray read GetLast;
    property CompareMode: TCompareMode read
      GetCompareMode write SetCompareMode;
  end;
{     VariantArrays   
  ,  #13#10,     ++  
 (   ),   ,
      -  ,    
 ,   }
function VariantArraysToShowStr(VariantArrays: TVariantArrays): string;

{    }
type
  TGlobalVars = class(TObjectStd)
  private
    FValues: TVariantParams;
    FArrays: TVariantArrays;
  protected
    function GetValues(const VarName: string): Variant;
    procedure SetValues(const VarName: string; const NewValue: Variant);
    function GetArrays(const ArrayName: string): TIndexedVariants;
    function GetLast: Variant;
    procedure SetLast(const NewValue: Variant);
    function GetLastArray: TIndexedVariants;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {    }
    procedure Clear;
    {}
    {    ,   VarName,  
         ,     ,
       Unassigned  }
    property Vars[const VarName: string]: Variant
      read GetValues write SetValues; default;
    {     ArrayName,      
          }
    property Arrays[const ArrayName: string]: TIndexedVariants read GetArrays;
    { ,      (Last)  
     (LastArray)}
    property Last: Variant read GetLast write SetLast;
    property LastArray: TIndexedVariants read GetLastArray;
  end;

{  }
type
  TCachedVariants = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockVariants: TVariants;
  end;
{     CachedVariants,   nil  
}
function LockVariants(var CachedVariants: TCachedVariants): TVariants;
{  }
type
  TCachedVariantsLists = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockVariantsList: TVariantsList;
  end;
{   }
type
  TCachedIndexedVariants = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockIndexedVariants: TIndexedVariants;
  end;
{      CachedIndexedVariants,
  nil   }
function LockIndexedVariants(var CachedIndexedVariants:
  TCachedIndexedVariants): TIndexedVariants;
{   }
type
  TCachedIndexedVariantsLists = class(TCachedObjects)
  private
  protected
    function CreateObject: TObject; override;
    procedure ClearObject(AObject: TObject; IsLock: Boolean); override;
  public
    {    ,    }
    function LockIndexedVariantsList: TIndexedVariantsList;
  end;

{     }
type
  EFunctionsError = class(ExceptionStd);
{   -}
type
  TVarFunctions = class(TObjectStd)
  private
    FCreateTicks: DWORD;
    FOwner: TVarFunctions;
    FFuncs: array[0..ObjVFuncMaxParam] of TStringParams;
    FVars: TVariantParams;
    FOwnsVars: Boolean;
  protected
    function GetFuncAddr(const FuncName: string; ParamCount: Integer): string;
    { }
    function CreateVars: TVariantParams; virtual;
    {      Vars,  
      }
    procedure Changed; virtual;
    {    Fnc, Fnc1, Fnc2, Fnc3, Fnc4, Fnc5, Fnc6,
    Fnc7, Fnc8, Fnc9, Fnc10, Fnc11, Fnc12, Fnc13, Fnc14, Fnc15, FuncName -
         ,  
     True,   ,    False}
    function ErrorHandler(E: TObject; const FuncName: string): Boolean;
      virtual;
    {}
    function GetVars: TVariantParams;
    procedure SetVars(NewVars: TVariantParams);
  public
    constructor Create; virtual;
    destructor Destroy; override;
    {}
    {     Vars,   
      (InitFinish)}
    procedure InitFinish; virtual;
    {}
    {      ParamCount,
     ,   ,   Procs, 
    ,  ,   Funcs,  
       TObjectVarXXX = function(...) of object, 
    RegisterInherited     }
    procedure RegisterFncs(ParamCount: Integer; Funcs: TStringParams;
      RegisterInherited: Boolean); virtual;
    {  FuncName   Param1, Param2, Param3, Param4,
    Param5, Param6, Param7, Param8, Param9, Param10, Param11, Param12, Param13,
    Param14, Param15,  ,   , 
       EFunctionsError (Fnc, Fnc1, Fnc2, Fnc3, Fnc4,
    Fnc5, Fnc6, Fnc7, Fnc8, Fnc9, Fnc10, Fnc11, Fnc12, Fnc13, Fnc14, Fnc15)}
    function Fnc(const FuncName: string): Variant;
    function Fnc1(const FuncName: string; const Param1: Variant): Variant;
    function Fnc2(const FuncName: string; const Param1, Param2:
      Variant): Variant;
    function Fnc3(const FuncName: string; const Param1, Param2, Param3:
      Variant): Variant;
    function Fnc4(const FuncName: string; const Param1, Param2, Param3, Param4:
      Variant): Variant;
    function Fnc5(const FuncName: string; const Param1, Param2, Param3, Param4,
      Param5: Variant): Variant;
    function Fnc6(const FuncName: string; const Param1, Param2, Param3, Param4,
      Param5, Param6: Variant): Variant;
    function Fnc7(const FuncName: string; const Param1, Param2, Param3, Param4,
      Param5, Param6, Param7: Variant): Variant;
    function Fnc8(const FuncName: string; const Param1, Param2, Param3, Param4,
      Param5, Param6, Param7, Param8: Variant): Variant;
    function Fnc9(const FuncName: string; const Param1, Param2, Param3, Param4,
      Param5, Param6, Param7, Param8, Param9: Variant): Variant;
    function Fnc10(const FuncName: string; const Param1, Param2, Param3,
      Param4, Param5, Param6, Param7, Param8, Param9, Param10:
      Variant): Variant;
    function Fnc11(const FuncName: string; const Param1, Param2, Param3,
      Param4, Param5, Param6, Param7, Param8, Param9, Param10, Param11:
      Variant): Variant;
    function Fnc12(const FuncName: string; const Param1, Param2, Param3,
      Param4, Param5, Param6, Param7, Param8, Param9, Param10, Param11,
      Param12: Variant): Variant;
    function Fnc13(const FuncName: string; const Param1, Param2, Param3,
      Param4, Param5, Param6, Param7, Param8, Param9, Param10, Param11,
      Param12, Param13: Variant): Variant;
    function Fnc14(const FuncName: string; const Param1, Param2, Param3,
      Param4, Param5, Param6, Param7, Param8, Param9, Param10, Param11,
      Param12, Param13, Param14: Variant): Variant;
    function Fnc15(const FuncName: string; const Param1, Param2, Param3,
      Param4, Param5, Param6, Param7, Param8, Param9, Param10, Param11,
      Param12, Param13, Param14, Param15: Variant): Variant;
    {}
    {- ,      
    RegisterFncs}
    property Owner: TVarFunctions read FOwner write FOwner;
    {    (Vars);  ,   
       Vars,  ,   False (OwnsVars)}
    property Vars: TVariantParams read GetVars write SetVars;
    property OwnsVars: Boolean read FOwnsVars write FOwnsVars;
  end;



{---  ------------------------------------------------------------------}

{  Stream       }
function StreamToStr(Stream: TStream): string;
{  DataStream       ,   
 ,       Data  IsFile = True
  Data  IsFile = False,  ErrorIfNoFile = True  
         (StreamStr)}
function StreamStr(DataStream: TStream; const Data: string; IsFile,
  ErrorIfNoFile: Boolean): string;
{    (   )    
      }
procedure StrToStream(const S: string; Stream: TStream);
{     SourStream     DestStream}
procedure MoveStream(SourStream, DestStream: TStream; BufSize: Integer);
{   }
procedure StreamToFile(Stream: TStream; const FileName: string;
  FileAppend: Boolean);
{   }
procedure FileToStream(Stream: TStream; const FileName: string;
  ErrorIfNoFile: Boolean);
{    (      )}
function AddValueToStream(Stream: TStream; const Value: string): string;
{     (   
   -   ,  );   
      ,  DefValue;  MaxValueLen
    ,   
   ( ,  MaxValueLen  )}
function GetValueFromStream(Stream: TStream; const DefValue: string;
  MaxValueLen: Integer): string;

{ ,     Strings,  StreamList}
procedure StringsToStreamList(Strings: TStrings; StreamList: TList);
{   StreamList       Strings}
procedure StreamListToStrings(StreamList: TList; Strings: TStrings);
{ StreamCount   TMemoryStream   
 StreamList}
procedure CreateMemoryStreams(StreamList: TList; StreamCount: Integer);
{    (  Mode)}
procedure FilesToStreamList(FileNames: TStrings; StreamList: TList;
  Mode: Word);

{  ;         4-
     ;    
    ;     , 
     ,     
,      (  0  ), 
  ; LastBlockLen   ,  LastBlockPos -
  ;  LastBlockLen = -1,     ( )
 ;    LastBlockLen  LastBlockPos  }
function StreamBlockRead(Stream: TStream;
  var LastBlockLen, LastBlockPos: Integer;
  var Buffer; Count: Integer): Integer;
{  StreamBlockRead;   ,  
    }
procedure StreamBlockReadBuffer(Stream: TStream;
  var LastBlockLen, LastBlockPos: Integer;
  var Buffer; Count: Integer);
{   4- ,     ;  Count
  0,    ;  IsFinalBlock = True   
   4- ,  0    }
function StreamBlockWrite(Stream: TStream;
  const Buffer; Count: Integer; IsFinalBlock: Boolean): Integer;
{  StreamBlockWrite;   ,  
    ;  IsFinalBlock = True  
 4- ,  0    }
procedure StreamBlockWriteBuffer(Stream: TStream;
  const Buffer; Count: Integer; IsFinalBlock: Boolean);
{   - 4- ,  0;
 ErrorIfCantWrite = True  ,   }
procedure StreamBlockWriteFinish(Stream: TStream; ErrorIfCantWrite: Boolean);

{   IsWrite  False    True Count
     Buffer     , , 
 Stream,         
 , ,   Cache  CacheSize,   
,        ,
         nil, 
      ,  
 ,   Buffer  nil   
          
  (CacheStreamRead);     IsWrite
 False    True    CacheStr  
 CachePos,   1, CacheSize    
  , ,   ,   
          0,  
  ,     TCacheStream
(CacheStrStreamRead)}
function CacheStreamReadOrWrite(Stream: TStream; var Cache: Pointer;
  var CacheSize: Integer; Buffer: Pointer; Count: Integer;
  IsWrite: Boolean): Integer;
function CacheStrStreamReadOrWrite(Stream: TStream; var CacheStr: string;
  var CachePos, CacheSize: Integer; Buffer: Pointer; Count: Integer;
  IsWrite: Boolean): Integer;
{    }
type
  TStreamCache = record
    Size: Integer;
    BufLen: Integer;
    BufPos: Integer;
    Buf: string;
    IsEnd: Boolean;
  end;
{  }
procedure StreamCacheInit(out StreamCache: TStreamCache; CacheSize: Integer);
{   ,     
  ,    }
procedure StreamCacheCorrect(var StreamCache: TStreamCache);
{     ; ,   
   }
function StreamRead(Stream: TStream; var StreamCache: TStreamCache;
  var Buffer; Count: Integer): Integer;
{     ; ,   
   ;  ,   
   }
procedure StreamReadBuffer(Stream: TStream; var StreamCache: TStreamCache;
  var Buffer; Count: Integer);
{  ,        }
function StreamPreRead(Stream: TStream; var StreamCache: TStreamCache;
  var Buffer; Count: Integer): Integer;
{     ; ,   
   }
function StreamWrite(Stream: TStream; var StreamCache: TStreamCache;
  const Buffer; Count: Integer): Integer;
{     ; ,   
   ;  ,   
   }
procedure StreamWriteBuffer(Stream: TStream; var StreamCache: TStreamCache;
  const Buffer; Count: Integer);
{      }
procedure StreamWriteFlush(Stream: TStream; var StreamCache: TStreamCache);
{ True,     Stream,  
StreamCache}
function StreamIsEnd(Stream: TStream; var StreamCache: TStreamCache): Boolean;
{ ,    StreamCache,    Stream}
function StreamPosition(Stream: TStream;
  const StreamCache: TStreamCache): Integer;
{    Stream,   StreamCache; 
  ;      #13,  #10,  #13#10,
 #10#13,      ;  IsPreRead = True 
 ,      ;  BytesRead, 
,    ,     
 ,  IsPreRead -     }
function StreamReadLn(Stream: TStream; var StreamCache: TStreamCache;
  IsPreRead: Boolean; BytesRead: PInteger): string;
{  S   Stream     StreamCache;
     }
procedure StreamWriteLn(Stream: TStream; var StreamCache: TStreamCache;
  const S: string);
{   Stream c  StreamCache   StreamReadLn 
    Template,     
  FieldChar,    
   ExtractByTemplate, IsHeader  True,   
 ,   ,  
HeaderDivStr,    IsHeader   False, 
  Fields,       DivStr,
 ,       ,  
,         True,
 False,         Fields,  Lines,
  nil,     ,  SkipHeaderOnly
 True    IsHeader  True  
,    False,   Template,
    Fields}
function StreamReadByTemplate(Stream: TStream; var StreamCache: TStreamCache;
  var IsHeader: Boolean; const Template: TStrings; const HeaderDivStr,
  DivStr: string; FieldChar: Char; Fields, Lines: TStrings;
  SkipHeaderOnly: Boolean): Boolean;

{  ,        
   IsSysDebug  True (TStreamDbg);    
(TStreamStd)}
type
  TStreamDbg = class(TStream)
  private
  protected
  public
    constructor Create;
    destructor Destroy; override;
  end;
  TStreamStd = {$IFNDEF NODEBUG_SYS} TStreamDbg {$ELSE} TStream {$ENDIF};
{   ,        
   IsSysDebug  True (TMemoryStreamDbg);  
  (TMemoryStreamStd)}
type
  TMemoryStreamDbg = class(TMemoryStream)
  private
  protected
  public
    constructor Create;
    destructor Destroy; override;
  end;
  TMemoryStreamStd = {$IFNDEF NODEBUG_SYS} TMemoryStreamDbg
    {$ELSE} TMemoryStream {$ENDIF};
{   ,        
   IsSysDebug  True (TFileStreamDbg);  
  (TFileStreamStd)}
type
  TFileStreamDbg = class(TFileStream)
  private
  protected
  public
    constructor Create(const FileName: string; Mode: Word);
    destructor Destroy; override;
  end;
  TFileStreamStd = {$IFNDEF NODEBUG_SYS} TFileStreamDbg
    {$ELSE} TFileStream {$ENDIF};

{            
            }
type
  TCacheStream = class(TStreamStd)
  private
    FStream: TStream;
    FCacheStr: string;
    FCachePos: Integer;
    FCacheSize: Integer;
    FMaxStreamSize: Integer;
    FNoWriteCache: Boolean;
    FPosition: Integer;
  protected
  public
    {      Stream   
    CacheStr    CachePos,   1, CacheSize  
       , MaxStreamSize   
      ,  (-1)     
      ,     
      ,      ,
     NoWriteCache  True     
            ,   
     CacheStr  }
    constructor Create(Stream: TStream; const CacheStr: string; CachePos,
      CacheSize, MaxStreamSize: Integer; NoWriteCache: Boolean);
    {}
    {  Buffer Count   ,      
    ,      Buffer , 
       CacheStrStreamRead (Read);    
    Count    Buffer,     
      CacheSize  ,  ,    
     ,  MaxStreamSize   (-1), MaxStreamSize
         ,   NoWriteCache
     True        
      ,       CacheStr
      (Write);      Offset   
    Origin    soFromBeginning, soFromCurrent
     soFromEnd,      
             
           CacheStrStreamRead  
     nil     ,    
           (Seek)}
    function Read(var Buffer; Count: LongInt): LongInt; override;
    function Write(const Buffer; Count: LongInt): LongInt; override;
    function Seek(Offset: LongInt; Origin: Word): LongInt; override;
    {}
    {  (Stream);  ,    ,
           (CacheStr); 
      ,   1 (CachePos);   
       (CacheSize);     ,
     (-1)      
    (MaxStreamSize);         
    (NoWriteCache)}
    property Stream: TStream read FStream;
    property CacheStr: string read FCacheStr;
    property CachePos: Integer read FCachePos;
    property CacheSize: Integer read FCacheSize;
    property MaxStreamSize: Integer read FMaxStreamSize;
    property NoWriteCache: Boolean read FNoWriteCache;
  end;
{ TFileStream        
  ,     }
type
  TDeferredFileStream = class(TStreamStd)
  private
    FFileName: string;
    FMode: Word;
    FFileStream: TFileStream;
  protected
    function FileStream: TFileStream;
    function GetOpened: Boolean;
    procedure SetSize(NewSize: LongInt); override;
  public
    {    , FileName   , Mode
       , , fmCreate, fmOpenRead, fmOpenWrite,
    fmOpenReadWrite     FileOpen  TFileStream,  
            }
    constructor Create(const FileName: string; Mode: Word);
    destructor Destroy; override;
    {}
    function Read(var Buffer; Count: LongInt): LongInt; override;
    function Write(const Buffer; Count: LongInt): LongInt; override;
    function Seek(Offset: LongInt; Origin: Word): LongInt; override;
    {}
    {  (FileName);   , , fmCreate,
    fmOpenRead, fmOpenWrite, fmOpenReadWrite     FileOpen
     TFileStream (Mode);  ,     (Opened)}
    property FileName: string read FFileName;
    property Mode: Word read FMode;
    property Opened: Boolean read GetOpened;
  end;

{     }
type
  TStreamsService = class(TObjectStd)
  private
    FLastStreamId: Integer;
    FCheckStreamId: Boolean;
    FStreams: TObjList;
    FStreamIds: TIndexedList;
    FLastIndex: Integer;
  protected
    function GetCount: Integer;
    function GetItem(Index: Integer): TStream;
    function GetIndex(StreamId: Integer): Integer;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { ,    (CreateStream); 
       StreamId (DeleteStream)}
    function CreateStream: Integer; virtual;
    procedure DeleteStream(StreamId: Integer); virtual;
    {     StreamId   (GetStream);
         StreamId   S
    (SetStream);        StreamId
    (GetStreamPos);        StreamId
     StreamPos (SetStreamPos);  Len    
     StreamId,    ,  
          (StreamRead); 
     S     StreamId (StreamWrite); 
        StreamId (StreamSize)}
    function GetStream(StreamId: Integer): string;
    procedure SetStream(StreamId: Integer; const S: string);
    function GetStreamPos(StreamId: Integer): Integer;
    procedure SetStreamPos(StreamId, StreamPos: Integer);
    function StreamRead(StreamId, Len: Integer): string;
    procedure StreamWrite(StreamId: Integer; const S: string);
    function StreamSize(StreamId: Integer): Integer;
    {}
    {  (Count);      Index (Items);
         StreamId,   
        (-1) (Indexes);  
        StreamId  (LastIndex)}
    property Count: Integer read GetCount;
    property Items[Index: Integer]: TStream read GetItem; default;
    property Indexes[StreamId: Integer]: Integer read GetIndex;
    property LastIndex: Integer read FLastIndex;
  end;

type
  {  }
  TExportVarType = (evtNull, evtInt, evtFloat, evtDate, evtString, evtBLOB);
  { }
  TExportVar = record
    VarType: TExportVarType;
    S: string;
  case TExportVarType of
    evtInt:   (I: Integer);
    evtFloat: (F: Extended);
    evtDate:  (D: TDateTime);
    evtBLOB:  (B: TStream);
  end;
{      Variant}
function ExportVarToVariant(const ExportVar: TExportVar): Variant;
{   Variant   }
function VariantToExportVar(const V: Variant): TExportVar;
{    <>=<>,<>=<>, ...
 <>,<>, ...;
    -    
 ,     -  ;
        :
 -  ,  '|' ('|'   - );
    -      ;
 -   'ddmmyyyyhhnnss'   'd';
  Null -     (  )}
type
  TExportWriter = class(TObjectStd)
  private
    FExportStream: TStream;
    FStreamCache: TStreamCache;
    FIsFirst: Boolean;
    FIsItemOpened: Boolean;
  protected
    procedure WriteNewItem;
    procedure WriteValueAsString(const S: string);
  public
    {    ExportStream,    
     ; CacheSize -  , , 16384}
    constructor Create(ExportStream: TStream; CacheSize: Integer);
    destructor Destroy; override;
    {}
    {  }
    procedure WriteParam(const ParamName: string);
    {}
    {     Integer, Float, Date, String  BLOB}
    procedure WriteInt(I: Integer);
    procedure WriteFloat(F: Extended);
    procedure WriteDate(D: TDateTime);
    procedure WriteString(const S: string);
    procedure WriteBLOB(B: TStream);
    {}
    {  (    )  
      }
    procedure WriteValue(const Value: TExportVar);
    procedure WriteParamValue(const ParamName: string;
      const Value: TExportVar);
    {}
    {  }
    procedure WriteNext;
  end;
{  ,    TExportWriter}
type
  TExportReader = class(TObjectStd)
  private
    FExportStream: TStream;
    FStreamCache: TStreamCache;
    FExportReaderStream: TStream;
    FIsFirst: Boolean;
    FIsItemOpened: Boolean;
    {}
    function ReadStreamBuffer(var Buffer; Size: Integer;
      IsFirst: Boolean): Integer;
  protected
    procedure ReadNewItem;
  public
    {    ExportStream,    
    ; CacheSize -  , , 16384}
    constructor Create(ExportStream: TStream; CacheSize: Integer);
    destructor Destroy; override;
    {}
    {   }
    function ReadParam: string;
    {   }
    function ReadValueType: TExportVarType;
    {}
    {   Integer, Float, Date, String  BLOB}
    function ReadInt: Integer;
    function ReadFloat: Extended;
    function ReadDate: TDateTime;
    function ReadString: string;
    function ReadBLOB: TStream;
    function ReadValue: TExportVar;
    function ReadParamValue(out ParamName: string): TExportVar;
    {}
    { True,   }
    function IsNext: Boolean;
    {   }
    procedure ReadNext;
    { True,   }
    function IsEnd: Boolean;
    {  ,   }
    procedure ReadBLOBFinish;
  end;

{     IStream}
type
  EInterfaceStreamError = class(EWinAPIError);
{  IStream    TStream}
type
  TInterfaceStream = class(TStreamStd)
  private
    FStream: IStream;
    FIsChanged: Boolean;
  public
    {     }
    constructor Create(Stream: IStream);
    destructor Destroy; override;
    {}
    function Read(var Buffer; Count: LongInt): LongInt; override;
    function Write(const Buffer; Count: LongInt): LongInt; override;
    function Seek(Offset: LongInt; Origin: Word): LongInt; override;
    {}
    { }
    property Stream: IStream read FStream;
  end;

{  IStream,   ISequentialStream  , 
 ,       2  }
type
  TInterfacedStream = class(TInterfacedObjectStd, IStream)
  private
    FStream: TStream;
    FFreeStream: Boolean;
    FFileName: string;
    FReadFileMode: Integer;
    FSeekFileMode: Integer;
    FWriteFileMode: Integer;
    FNotRewriteExisting: Boolean;
    FValue: string;
    FValueLength: Integer;
    FPosition: Integer;
    FFileState: TFileState;
    FFile: file;
  protected
  public
    {    Stream,  FreeStream  True 
       ,   Stream  nil, 
       FileName,      
            FileMode   
     ReadFileMode,      ,  
        FileMode  SeekFileMode,  
         ,   ,
    ,      ,     
    ,   NotRewriteExisting  True  ,  
     ,         FileMode
        WriteFileMode,   ReadFileMode,
    SeekFileMode  WriteFileMode  (-1)   
           FileMode,
            Value}
    constructor Create(Stream: TStream; FreeStream: Boolean;
      const FileName: string; ReadFileMode, SeekFileMode,
      WriteFileMode: Integer; NotRewriteExisting: Boolean;
      const Value: string);
    destructor Destroy; override;
    {}
    function Read(pv: Pointer; cb: LongInt; pcbRead: PLongInt): HRESULT;
      stdcall;
    function Write(pv: Pointer; cb: LongInt; pcbWritten: PLongInt): HRESULT;
      stdcall;
    function Seek(dlibMove: LargeInt; dwOrigin: LongInt;
      out libNewPosition: LargeInt): HRESULT; stdcall;
    function SetSize(libNewSize: LargeInt): HRESULT; stdcall;
    function CopyTo(stm: IStream; cb: LargeInt; out cbRead: LargeInt;
      out cbWritten: LargeInt): HRESULT; stdcall;
    function Commit(grfCommitFlags: LongInt): HRESULT; stdcall;
    function Revert: HRESULT; stdcall;
    function LockRegion(libOffset: LargeInt; cb: LargeInt;
      dwLockType: LongInt): HRESULT; stdcall;
    function UnlockRegion(libOffset: LargeInt; cb: LargeInt;
      dwLockType: LongInt): HRESULT; stdcall;
    function Stat(out statstg: TStatStg; grfStatFlag: LongInt): HRESULT;
      stdcall;
    function Clone(out stm: IStream): HRESULT; stdcall;
    {}
    {  nil,        (Stream); 
         (FreeStream);    
    ,       (FileName); 
        (ReadFileMode);    
     (SeekFileMode);     
     (WriteFileMode);       
       (NotRewriteExisting);   (Value);
       ,     
      ,     
    (ValueLength);  (Position);     
      (FileState)}
    property Stream: TStream read FStream;
    property FreeStream: Boolean read FFreeStream;
    property FileName: string read FFileName;
    property ReadFileMode: Integer read FReadFileMode;
    property SeekFileMode: Integer read FSeekFileMode;
    property WriteFileMode: Integer read FWriteFileMode;
    property NotRewriteExisting: Boolean read FNotRewriteExisting;
    property Value: string read FValue;
    property ValueLength: Integer read FValueLength;
    property Position: Integer read FPosition;
    property FileState: TFileState read FFileState;
  end;



{---  ----------------------------------------------------------------}

{  Hierarchy   Strings,   
  Prefix,   ,   }
procedure StrHierarchyToStrings(var Hierarchy: PHierarchy;
  const Prefix: string; Strings: TStrings);

{    Longest Common Subsequence
    -     IntList1
 IntList2,  IntLists     , 
      IntList1,   
       IntList2,  
       IntList1
     IntLists  ,   
      
  ,  ,      IntLists
   ,    
 IntList1  IntList2  ,   
         ,  
   , MaxCount,   ,
       IntLists,
    (-1), IntLists  (LCSHuntSzymanski)}
function LCSHuntSzymanski(const IntList1, IntList2: TList;
IntLists: TObjList {TList}; MaxCount: Integer): Integer;



{---  -----------------------------------------------------------------}

{   }
procedure DebugRun;



{---   -------------------------------------------------------}

{     }
type
  TProgressProcessing = class(TProgressInfo)
  private
    FWaitTime: Integer;
    FProcessMessages: TNotifyEventStd;
    FTicks: DWORD;
  protected
  public
    { ,  ,  , 
       }
    constructor Create(Name: string; MaxValue: Integer;
      ProcessMessages: TNotifyEventStd);
    {}
    {,     (Start);    
    ,    ,    
        WaitTime ,  True,   
       (ProcessMessages);   
       ProcessMessages,  True,    
      (Next);  ,   
      (Phase); ,     (Finish)}
    procedure Start;
    function ProcessMessages: Boolean;
    function Next: Boolean;
    procedure Phase;
    procedure Finish;
    {}
    {       ,  
    50,      ,   
      ProcessMessages   (WaitTime)}
    property WaitTime: Integer read FWaitTime write FWaitTime;
    { }
    property OnProcessMessages: TNotifyEventStd
      read FProcessMessages write FProcessMessages;
  end;

{        CmdLine  
Programs,         ,
DivStr    , , ',',  
,   CmdLine      }
procedure CmdLinePrograms(const CmdLine, DivStr: string; Programs: TStrings);

{ }
const
  faReadOnly  = $00000001;
  faHidden    = $00000002;
  faSysFile   = $00000004;
  faVolumeID  = $00000008;
  faDirectory = $00000010;
  faArchive   = $00000020;
  faAnyFile   = $0000003F;
{  FileName  ,     , 
, ,       }
function FileToStrExists(const FileName: string): string;
{   ;    ,  '?'
 '*',   ;      
;         ( 
)    FilePath;     
  }
function UniqueFileName(const FilePath, FileMask: string): string;
{   : flmFullNames -     ,
       ,   , flmNoFileNames - 
    , flmScanSubDirs -  ,
flmMaskedDirScan -      ,
  '*.*', flmIncludeDirNames -     , 
      ,   
         
  , flmDirsWithSlash -      ,
,      , flmStopOnFirstFile -  
    , flmStopOnFirstDir -  
    , flmCountFilesOnly -  
  ,  }
type
  TFileListMode = set of (flmFullNames, flmNoFileNames, flmScanSubDirs,
    flmMaskedDirScan, flmIncludeDirNames, flmDirsWithSlash, flmStopOnFirstFile,
    flmStopOnFirstDir, flmCountFilesOnly);
{ FilesList,  ,      
Mask   Mode,    ProcessMessages, 
,      ,  
flmCountFilesOnly -  , MaxCount   
    ,   flmCountFilesOnly - 
,       
, ProcessMessages          
,     ProcessMessages  
TProgressInfo,     LastProgress, LastSubProgress,
IsBeg, IsEnd,  :
Name -  'FILELIST',
ParamStr -  ,    ,
ParamNum -       ,
Info -     ,  TStrings
SubInfo -     ,     
 ,         , 
TStrings,
Step - , 0 -   , 1 -  ,
ItemName -     ,
MaxValue - (-1),      ,
SubMaxValue - (-1),    
Progress -     ,   
  Info,         ,
SubProgress -   }
function FileList(const Mask: string; Mode: TFileListMode;
  FilesList: TStrings; ProcessMessages: TNotifyEventStd;
  MaxCount: Integer): Integer;
{  : fcmNoKeepTime -     ,
fcmNoKeepAttr -     , fcmNoCreateDirs -
      ,    ,
    ,      
 ,     ,  
   , fcmNoDelConflictFiles -  
      , fcmNoDelIfDir -  
,      ,  
}
type
  TFileCopyMode = set of (fcmNoKeepTime, fcmNoKeepAttr, fcmNoCreateDirs,
    fcmNoDelConflictFiles, fcmNoDelIfDir);
{  :
rmAlways -    ,
rmNever -     ,    ,
rmIfNewer -       ,
rmIfDifSize -   ,     
 ,
rmIfDifTimeOrSize -   ,     
  }
type
  TFileReplaceMode = (frmAlways, frmNever, frmIfNewer,
    frmIfDifSize, frmIfDifTimeOrSize);
{  SourName  DestName   Mode   
ReplaceMode,    ProcessMessages,  ,
    ,     
  ,     ProcessMessages 
TProgressInfo     ,    
   fcmNoDeleteIfDir ProcessMessages    
DeleteDir,       TProgressInfo 
 LastProgress, IsBeg, IsEnd,  :
Name - 'COPYFILE',
ParamStr -  SourName,
SubParamStr -  DestName,
MaxValue -     ,  IsBeg = True  ,  0,
   , MaxValue   (-1),
Progress -   }
function CopyFile(const SourName, DestName: string; Mode: TFileCopyMode;
  ReplaceMode: TFileReplaceMode; ProcessMessages: TNotifyEventStd): Integer;
{ ,   SourMask    DestMask,
       ListMode,   
flmFullNames,  flmIncludeDirNames, flmDirsWithSlash,  
 flmScanSubDirs,      
DestMask    MaskFileName,   flmMaskedDirScan  ListMode -
    ,    
CopyMode    ReplaceMode,   
ProcessMessages,  ,     
,     ProcessMessages   
TProgressInfo,      LastProgress, IsBeg,
IsEnd,  :
Name - 'COPYFILES',
ParamStr -   SourMask,
SubParamStr -   DestMask,
Info -     ,
MaxValue -    
Progress -     }
function CopyFiles(const SourMask, DestMask: string; ListMode: TFileListMode;
  CopyMode: TFileCopyMode; ReplaceMode: TFileReplaceMode;
  ProcessMessages: TNotifyEventStd): Integer;
{  SourName  DestName,    
   ,     CopyFile,
   ProcessMessages,  
   ,  SkipCopy  True  
,         
DestVer, BorderVer    ,   IsCrossBorderVer,
 ,   ,      
 ,         }
function CopyFileIfNewVer(const SourName, DestName: string;
  ProcessMessages: TNotifyEventStd; SkipCopy: Boolean; DestVer: PProductVer;
  const BorderVer: TProductVer; IsCrossBorderVer: PBooleanStd): Boolean;
{ True,      ,   Mask,
   Mode,   FileList, 
   ProcessMessages,  ,  Mode
  flmStopOnFirstFile, flmCountFilesOnly  
flmNoFileNames}
function IsFilesExist(const Mask: string; Mode: TFileListMode;
  ProcessMessages: TNotifyEventStd): Boolean;
{   ,    False,
   ProcessMessages,  , 
    FileList  ProcessMessages  
[flmScanSubDirs, flmIncludeDirNames, flmDirsWithSlash],  
ClearOnly = True   DirName -  ,  DirName 
,    ,  ClearOnly = True  FilesOnly = True
  ,    ,  ExcludeFileMasks
        ,
  ,     ";",   
        """",
    ProcessMessages   TProgressInfo,
   : LastProgress, IsBegin, IsEnd,  :
Sender -     ,   ,
Name - 'DELETEDIR',
ParamNum -   ClearOnly = False,   ClearOnly = True 
FilesOnly = False,   ClearOnly = True  FilesOnly = True
ParamStr -  DirName,
 FileList, DirName    ,
Info -     ,
SubInfo -   ,     ,
SubComment -  ,   ,
MaxValue -       ,
Progress -  ,      
}
function DeleteDir(const DirName: string; ClearOnly, FilesOnly: Boolean;
  ProcessMessages: TNotifyEventStd; const ExcludeFileMasks: string): Boolean;
{ GGlbUtil.SafeAccessFile,  IsFileSafe = False  FileName,
   , BaseSafeAccessMode   ,  
IsMulti  ,   ,  
      ,   
   ,    ECanceled}
function AskSafeAccessFile(const FileName: string; IsFileSafe: Boolean;
  const SafeInfo: TFileSafeInfo; BaseSafeAccessMode: TFileSafeAccessMode;
  IsMulti: Boolean; Wnd: HWND; IsShowDialogs,
  IsFindNotExisting: Boolean): string;
{       FileName,  ,
  ,   ,   
EInOutError,  AllowRetry  True    
 ,     ,   
  }
procedure CheckFileDrive(const FileName: string; AllowRetry: Boolean);
{  ,    Mask   Mode, 
 MaxSize  ,    False,  True}
function CheckFilesSize(const Mask: string; Mode: TFileListMode;
  MaxSize: Comp): Boolean;
{ ,   SourMask,    
      DestMask,   
 DestFiles,  TStringList  ,  ,
  SourFilesLists}
function MasksToFiles(const SourMask, DestMask: string;
  DestFiles: TIndexedStrings; SourFilesLists: TObjList {TStringList}): Integer;
{  NearSubDirs   ,    
        SubDir,  
    ,    ,  ExcludeDefined  
   SubDir}
procedure NearSubDirList(const SubDir: string; NearSubDirs: TStrings;
  ExcludeDefined: Boolean);
{   FileName    SubStrings,   nil, 
   IndexedSubStrings    CompareMode, BegPos
     ,   0, EndPos  ,
  0,   (-1)     ,
  Overlapped        ,
        BegPos, 
,     ,  (-1),   ,
 SearchEndPos,   nil,     
  ,   FoundSubStrIdx,   nil,  
 SubStrings    (-1),     
}
function FindInFile(const FileName: string; SubStrings: TStrings;
  IndexedSubStrings: TIndexedStrings; CompareMode: TCompareMode; BegPos,
  EndPos: Integer; Overlapped: Boolean; SearchEndPos,
  FoundSubStrIdx: PInteger): Integer;
{  : cdtTemp -    ,
cdtTempIE -     Internet Explorer, dtTempFF - 
   Mozilla FireFox, cdtDriverCache -   Windows,
cdtDLLCache -   Windows, cdtIEUpdates - 
 Internet Explorer, cdtUpdates -  Windows, cdtRecent - 
, cdtHistory - , cdtCookies - cookies ,
cdtRecycleBin - }
type
  TCleaningDirType = (cdtTemp, cdtTempIE, cdtTempFF, cdtDriverCache,
    cdtDLLCache, cdtIEUpdates, cdtUpdates, cdtRecent, cdtHistory, cdtCookies,
    cdtRecycleBin);
{  CleaningDirs    ,  TempDirs
 True      
Internet Explorer  ,  PatchUninstallDirs  True
  'Driver Cache\i386'   Windows,
'dllcache'   Windows, 'ie7updates'  
Windows,   ,     '$'  
 Windows,  HistoryDirs  True   'Recent',
'History'  'Cookies'  ,  TempDirs   
  'Recycler'    ,  TCleaningDirType
     CleaningDirTypes,   nil}
procedure CleaningDirList(TempDirs, PatchUninstallDirs, HistoryDirs: Boolean;
  CleaningDirs: TStrings; CleaningDirTypes: TList);
{       LinkFileName,  
   (LinkToInfo);   LinkFileName
  LinkInfo,    True,  False (InfoToLink)}
function LinkToInfo(const LinkFileName: string): TLinkInfo;
function InfoToLink(const LinkFileName: string;
  const LinkInfo: TLinkInfo): Boolean;

type
  {  }
  TFileAccess = (facReadOnly, facWriteOnly, facReadWrite);
  {  }
  TFileInfo = record
    F: file;
    IsOpened: Boolean;
    FileName: string;
    IsTemp: Boolean;
    FileSize: Integer;
    FileAccess: TFileAccess;
  end;
{  }
procedure FIInit(var FI: TFileInfo);
{ }
procedure FICreate(var FI: TFileInfo; FileName: string);
{  }
procedure FICreateTemp(var FI: TFileInfo;
  NamePrefix, NamePostfix: string; Digits: Integer);
{ }
procedure FIOpen(var FI: TFileInfo; IsTemp: Boolean; FileAccess: TFileAccess);
{  }
procedure FIOpenNew(var FI: TFileInfo; FileName: string;
  IsTemp: Boolean; FileAccess: TFileAccess);
{   (-1) -    ,  
  }
function FISize(var FI: TFileInfo): Integer;
{ ;      ,   }
procedure FIClose(var FI: TFileInfo);
{  FI,  ,    ,  IsCleanDelete
     }
procedure FIDelete(var FI: TFileInfo; IsCleanDelete: Boolean);
{     FI    NamePrefix,
 NamePostfix,     Digits 
,    Value}
procedure FIMakeTemp(var FI: TFileInfo; NamePrefix, NamePostfix: string;
  Digits: Integer; const Value: string);

type
  {    FileName   BlockPos  BlockLen}
  TFileLoadMethod = function(const FileName: string; BlockPos,
    BlockLen: Integer): string of object;
  {     }
  TFileCacheInfo = record
    Content: string;                     {}
    CRC: string;                         { }
    VarArray: Variant;                   {  }
    VariantParamsNames: TIndexedStrings; { }
    VariantParamsList: TObjList;         { }
  end;
  TFileOperations = class;
  {   ,   TFileOperations}
  TFileOperationsCache = class(TObjectStd)
  private
    FThreadSafe: Boolean;
    FMaxCachedFiles: Integer;
    FMaxCachedFileLists: Integer;
    FCriticalSection: TCriticalSectionRec;
    FFileOperationsList: TList; {TFileOperations}
    FCachedFileNames: TIndexedStrings;
    FCachedFileContents: TStringList;
    FCachedFileMilliseconds: TList;
    FCachedFileCRCs: TStringList;
    FCachedFileVarArrays: TVariants;
    FCachedFileVarParamsNamesLists: TObjList; {TIndexedStrings}
    FCachedFileVarParamsLists: TObjList; {TObjList, TVariantParams}
    FCachedFileListMasks: TIndexedStrings;
    FCachedFileListContents: TStringList;
    FCachedFileListMilliseconds: TList;
  protected
    procedure SetMaxCachedFiles(NewMaxCachedFiles: Integer);
    procedure SetMaxCachedFileLists(NewMaxCachedFileLists: Integer);
  public
    { ,  ThreadSafe = True  }
    constructor Create(ThreadSafe: Boolean);
    destructor Destroy; override;
    {}
    {    FileOperations,  
     ,     
    FileOperationsCache   TFileOperations,   
        FileOperationsCache  TFileOperations
    (RegisterFileOperations);     
    FileOperations,       (-1),   
    ,     FileOperationsCache  
    TFileOperations  nil    
    (UnregisterFileOperations)}
    function RegisterFileOperations(FileOperations: TFileOperations): Integer;
    function UnregisterFileOperations(FileOperations:
      TFileOperations): Integer;
    {}
    {    FileName,     
     Milliseconds  ,      
           ,  
    Milliseconds = 0  ,   Milliseconds = -1
       ,   ,     ,
        ,     , 
       ,     
     FileLoadMethod,  RetrieveCRC = True   
      CRC,    ,
     RetrieveVarArray = True   , 
       ImportVarArray,   , 
    RetrieveVarParamLists   TVariantParams 
    VariantParamsList     VariantParamsNames ,
       FileName   ImportVariantParamsList}
    function FileInfoCached(const FileName: string; Milliseconds: Integer;
      FileLoadMethod: TFileLoadMethod; RetrieveCRC, RetrieveVarArray,
      RetrieveVarParamLists: Boolean): TFileCacheInfo;
    {     FileMask,  ExtractByMask = True 
     ExtractStrBySimpleMask      
    ,     GetStrFromArray, Milliseconds
          ,  
    Milliseconds = 0  ,   Milliseconds = -1
          ,   ,  
      ,     ,    
    }
    function FileListCached(const FileMask: string; ExtractByMask: Boolean;
      Milliseconds: Integer): string;
    {}
    {   (ThreadSafe);  
     ,    DefMaxCachedItems (MaxCachedFiles);
        ,   
    DefMaxCachedItems (MaxCachedFileLists)}
    property ThreadSafe: Boolean read FThreadSafe;
    property MaxCachedFiles: Integer
      read FMaxCachedFiles write SetMaxCachedFiles;
    property MaxCachedFileLists: Integer
      read FMaxCachedFileLists write SetMaxCachedFileLists;
  end;
  {  ,      }
  TFileOperations = class(TObjectStd)
  private
    FExternalLib: string;
    FExternalLibVar: Variant;
    FExternalLibVarDefined: Boolean;
    FIsFileSafe: Boolean;
    FFileSafeInfo: TFileSafeInfo;
    FReadOnlyFileSafeInfo: TFileSafeInfo;
    FWriteOnlyFileSafeInfo: TFileSafeInfo;
    FFileName: string;
    FFileOperationsCache: TFileOperationsCache;
    FFileOperationsCacheOwned: Boolean;
  protected
    function GetFileOperationsCache: TFileOperationsCache;
    procedure SetFileOperationsCache(NewFileOperationsCache:
      TFileOperationsCache);
    {    (ExternalLibClear); 
      (ExternalLibVar);    
    ,     
    (ExternalLibCheck)}
    function ExternalLibClear: Variant;
    function ExternalLibVar: Variant;
    procedure ExternalLibCheck;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {      (Reset),   
    (ExternalLibReset)}
    procedure Reset;
    procedure ExternalLibReset;
    {  BlockLen ,    BlockPos,   0, 
     FileName   ,   ; 
    IsFileSafe         ,  
       -   ;   
    ,    ECanceled;  BlockLen 
    (-1),    }
    function FileLoad(const FileName: string; BlockPos,
      BlockLen: Integer): string;
    {  S   FileName   BlockPos;  BlockPos 
    (-1),     ;    , 
    ;  IsNew = True       
    ;         
     FileLoad;  IsFindNotExisting,     ,
        '_1', '_2'  ..,    
      ;    }
    function FileSave(const FileName, S: string; BlockPos: Integer; IsNew,
      IsFindNotExisting: Boolean): string;
    {  SourFileName   DestFileName;  
      ,     
    FileLoad}
    procedure FileCopy(const SourFileName, DestFileName: string);
    {  FileName;      
      FileLoad}
    function FileDelete(const FileName: string): Boolean;
    {   ,   FileNames  
        ,  ,  
     ;      ;
             
     FileLoad}
    function FilesLoad(const FileNames: string): string;
    {   ,   FileNames  
        ,  ,  
     ;       
         FileBlocks;  IsFindNotExisting,    
    ,     '_1', '_2'  ..,   
       ;     
     FileNames}
    function FilesSave(const FileNames, FileBlocks: string;
      IsFindNotExisting: Boolean): string;
    {  ,   FileNames     
     ,  ,   
    ,  True,     }
    function FilesDelete(const FileNames: string): Boolean;
    {  FileName,      
    Milliseconds  ,      
           ,  
    Milliseconds = 0  ,   Milliseconds = -1
       ,   ,     ,
        ,     , 
     ,      
    FileLoad}
    function FileToStrCached(const FileName: string;
      Milliseconds: Integer): string;
    {    FileName,    
     FileToStrCached,   Milliseconds = -1  
    ,      4-   
    4-    }
    function FileCRCCached(const FileName: string;
      Milliseconds: Integer): string;
    {  ,    FileName 
     ImportVarArray,     FileToStrCached,
      Milliseconds = -1   Unassigned}
    function FileVarArrayCached(const FileName: string;
      Milliseconds: Integer): Variant;
    {   TVariantParams  VariantParamsList 
      VariantParamsNames,    FileName 
     ImportVariantParamsList,    
    FileToStrCached,   Milliseconds = -1   nil}
    procedure FileVarParamListsCached(const FileName: string;
      Milliseconds: Integer; out VariantParamsNames: TIndexedStrings;
      out VariantParamsList: TObjList);
    {     FileMask,  ExtractByMask = True 
     ExtractStrBySimpleMask      
    ,     GetStrFromArray, Milliseconds
          ,  
    Milliseconds = 0  ,   Milliseconds = -1
          ,   ,  
      ,     ,    
    }
    function FileListCached(const FileMask: string; ExtractByMask: Boolean;
      Milliseconds: Integer): string;
    {}
    { ActiveX-   ,   ,
       }
    property ExternalLib: string read FExternalLib write FExternalLib;
    {      (IsFileSafe); 
            (FileSafeInfo); 
           (ReadOnlyFileSafeInfo);
           
    (WriteOnlyFileSafeInfo)}
    property IsFileSafe: Boolean read FIsFileSafe write FIsFileSafe;
    property FileSafeInfo: TFileSafeInfo
      read FFileSafeInfo write FFileSafeInfo;
    property ReadOnlyFileSafeInfo: TFileSafeInfo
      read FReadOnlyFileSafeInfo write FReadOnlyFileSafeInfo;
    property WriteOnlyFileSafeInfo: TFileSafeInfo
      read FWriteOnlyFileSafeInfo write FWriteOnlyFileSafeInfo;
    {    ,    
      }
    property FileName: string read FFileName;
    { ,          
    ,   ,      nil,
     ,      ,   
            ,
           , 
         nil    
     ,       
        }
    property FileOperationsCache: TFileOperationsCache
      read GetFileOperationsCache write SetFileOperationsCache;
  end;
{      ,  
(FileOperationsCache);      , 
 (FileOperationsReset)}
function FileOperationsCache: TFileOperationsCache;
procedure FileOperationsCacheReset;
{      (FileOperations);   
  (FileOperationsReset)}
function FileOperations: TFileOperations;
procedure FileOperationsReset;

{ :    ,   ,   }
type
  TLogType = (ltOneFile, ltMonthFile, ltDayFile);
{ }
type
  TLogging = class(TObjectStd)
  private
    FLogFile: TextFile;
    FLogFileOpened: Boolean;
    FLogFileName: string;
    FLogMask: string;
    FLogType: TLogType;
    FLogNames: TStringList;
    FLogDateTimes: TStringList;
    {}
    function GetFileName(DateTime: TDateTime): string;
    function GetLogDateTime(const LogFileName: string;
      DefDateTime: TDateTime; var IsCorrectName: Boolean): TDateTime;
    procedure OpenLogFile(DateTime: TDateTime);
    procedure CloseLogFile;
    procedure GetLogs(LogNames, LogDateTimes: TStrings);
    function GetLogCount: Integer;
    function GetLogNames(Index: Integer): string;
    function GetLogDateTimes(Index: Integer): TDateTime;
  public
    constructor Create(const LogMask: string; LogType: TLogType);
    destructor Destroy; override;
    {}
    {   ;  #10  #13     }
    procedure AddLine(const S: string; DateTime: TDateTime;
      IsDateTimePrefixed: Boolean);
    {   ;  True,    
     }
    function GetOldLogs(OldLogsList: TStrings;
      ExpireDateTime: TDateTime): Boolean;
    {}
    { -,    }
    property LogCount: Integer read GetLogCount;
    property LogNames[Index: Integer]: string read GetLogNames;
    property LogDateTimes[Index: Integer]: TDateTime read GetLogDateTimes;
  end;
{   ;  True,     
}
function GetOldLogs(const LogMask: string; LogType: TLogType;
  OldLogsList: TStringList; ExpireDateTime: TDateTime): Boolean;

{   ini-,        
   IsSysDebug  True (TIniFileDbg);  
 ini- (TIniFileStd)}
type
  TIniFileDbg = class(TIniFile)
  private
  protected
  public
    constructor Create(const FileName: string);
    destructor Destroy; override;
  end;
  TIniFileStd = {$IFNDEF NODEBUG_SYS} TIniFileDbg {$ELSE} TIniFile {$ENDIF};

{ ini-    ,    }
type
  TStreamIniSection = class(TObjectStd)
  private
    FLastIndex: Integer;
    FLastDeleted: Boolean;
    FFinalLinesCount: Integer;
    FPreferredIndex: Integer;
    FIsChanged: Boolean;
    FOnChange: TNotifyEventStd;
    FDefExportIsSorted: Boolean;
    FDefExportMode: TCompareMode;
    FLines: TStringList; {     }
    FLineIsKey: TList;
    FKeys: TIndexedStrings;
    FValues: TIndexedStrings;
    FLastText: TStringList;
    FExport: TStringsExport;
  protected
    procedure KeysClearFunc(Data: Pointer);
    function KeysAddFunc(const Value: string; Data: Pointer): Integer;
    function GetCount: Integer;
    function GetKey(Index: Integer): string;
    procedure SetKey(Index: Integer; const NewKey: string);
    function GetValue(Index: Integer): string;
    procedure SetValue(Index: Integer; const NewValue: string);
    function GetItem(const Key, DefValue: string): string;
    procedure SetItem(const Key, DefValue, NewValue: string);
    function GetItemKey(const Value, DefKey: string): string;
    procedure SetItemKey(const Value, DefKey, NewKey: string);
    function GetText: string;
    procedure SetText(const NewText: string);
    procedure SetFinalLinesCount(NewFinalLinesCount: Integer);
    procedure SetIsChanged(NewIsChanged: Boolean);
    function GetExport: TStringsExport;
    function GetKeySorted(Index: Integer): string;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { }
    procedure Clear;
    {     Stream   StreamCache, 
    StopOnNextSection = True     
     ,  True,      (Load);
         Stream   StreamCache (Save);
               Section
    (Assign);  ,  IsAlign  True  
    ,        ,
     IsAlign  False    ,
     UseIndent  True       (Align)}
    function Load(Stream: TStream; var StreamCache: TStreamCache;
      StopOnNextSection: Boolean): Boolean;
    procedure Save(Stream: TStream; var StreamCache: TStreamCache);
    procedure Assign(Section: TStreamIniSection);
    procedure Align(IsAlign, UseIndent: Boolean);
    { True,         
          (IsEmpty); 
      Key  (-1),    (IndexOf);  
       Value  (-1),    (IndexOfValue);
           (-1),    
      (KeyIndexToIndex);   Key   Value
      ,       , 
       (Add);   LineStr  FinalLinesCount
       ,     (AddLine);
      Key   Value     KeyIndex,
              ,
        (Insert);   LineStr
        Index,      
        FinalLinesCount    ,
        (InsertLine);  
      KeyIndex (Delete);     Index (DeleteLine)}
    function IsEmpty: Boolean;
    function IndexOf(const Key: string): Integer;
    function IndexOfValue(const Value: string): Integer;
    function KeyIndexToIndex(KeyIndex: Integer): Integer;
    function Add(const Key, Value: string): Integer;
    function AddLine(const LineStr: string): Integer;
    function Insert(KeyIndex: Integer; const Key, Value: string): Integer;
    function InsertLine(Index: Integer; const LineStr: string): Integer;
    procedure Delete(KeyIndex: Integer);
    procedure DeleteLine(Index: Integer);
    {}
    {  (Count);     Index (Keys); 
         Index (Values);    
       ,     IsChanged,  
         (KeyStrings);   
        ,     IsChanged,
           (ValueStrings);
       Key,     DefValue, ,
      ,    ,   DefValue,  
    ,  DefValue,   (Items);   
    Value,     DefKey, ,   ,
       ,   DefKey,   ,
     DefKey,   (ItemKeys);  ,  
       0 (Text);     
       ,     ,
     (-1) (LastIndex);      LastIndex ,
    ,         Items
    (LastDeleted);        (FinalLinesCount);
      ,     
             
    ,   (-1),     ,  
         (-1) (PreferredIndex); 
             (IsChanged);
       ,      
     (AnExport);    (KeysSorted)}
    property Count: Integer read GetCount;
    property Keys[Index: Integer]: string read GetKey write SetKey;
    property Values[Index: Integer]: string read GetValue write SetValue;
    property KeyStrings: TIndexedStrings read FKeys;
    property ValueStrings: TIndexedStrings read FValues;
    property Items[const Key, DefValue: string]: string
      read GetItem write SetItem; default;
    property ItemKeys[const Value, DefKey: string]: string
      read GetItemKey write SetItemKey;
    property Text: string read GetText write SetText;
    property LastIndex: Integer read FLastIndex;
    property LastDeleted: Boolean read FLastDeleted;
    property FinalLinesCount: Integer
      read FFinalLinesCount write SetFinalLinesCount;
    property PreferredIndex: Integer
      read FPreferredIndex write FPreferredIndex;
    property IsChanged: Boolean read FIsChanged write SetIsChanged;
    property AnExport: TStringsExport read GetExport;
    property KeysSorted[Index: Integer]: string read GetKeySorted;
  end;
{  ini-    ,    }
type
  TStreamIni = class(TObjectStd)
  private
    FSectionNames: TIndexedStrings;
    FSections: TObjList; {TStreamIniSection}
    FLastSectionIndex: Integer;
    FLastKeyIndex: Integer;
    FPreferredSectionIndex: Integer;
    FPreferredKeyIndex: Integer;
    FIsChanged: Boolean;
    FInMarks: Boolean;
    FIsAlign: TNullBool;
    FCheckCmdLine: Boolean;
    FIsLoad: Boolean;
    FMemoryStream: TMemoryStream;
    FExport: TStringsExport;
  protected
    {  ini-   ,  IsDefine = False   
      ,  NewIniStr ,  IsDefine = True
     ,  NewIniStr,   }
    function AccessIniStr(IsDefine: Boolean;
      const NewIniStr: string): string; virtual;
    procedure SectionOnChange(Sender: TObject);
    procedure SectionsClearFunc(Data: Pointer);
    function SectionsAddFunc(const Value: string; Data: Pointer): Integer;
    function SectionExportsGetFunc(Index: Integer; Data: Pointer): string;
    function SectionExportsAddFunc(const Value: string;
      Data: Pointer): Integer;
    function GetSectionCount: Integer;
    function GetSectionName(Index: Integer): string;
    procedure SetSectionName(Index: Integer; const NewSectionName: string);
    function GetSection(Index: Integer): TStreamIniSection;
    function GetItem(const Section, Key, DefValue: string): string;
    procedure SetItem(const Section, Key, DefValue, NewValue: string);
    function GetItemKey(const Section, Value, DefKey: string): string;
    procedure SetItemKey(const Section, Value, DefKey, NewKey: string);
    function GetValue(const SectionKey: string): string;
    procedure SetValue(const SectionKey, NewValue: string);
    function GetSectionText(const Section, DefValue: string): string;
    procedure SetSectionText(const Section, DefValue, NewText: string);
    procedure SetIsChanged(NewIsChanged: Boolean);
    function GetIniStr: string;
    procedure SetIniStr(const NewIniStr: string);
    function MemoryStream: TMemoryStream;
    function GetExport: TStringsExport;
    function GetSectionNameSorted(Index: Integer): string;
    function GetWholeKeysCount: Integer;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { ini}
    procedure Clear;
    {  ini-   Stream,   CacheSize
    (Load),   ini-  ,   CacheSize
    (Save)}
    procedure Load(Stream: TStream; CacheSize: Integer); virtual;
    procedure Save(Stream: TStream; CacheSize: Integer); virtual;
    {   SectionName,    ,
     (-1),  AddIfNotExists  True  ,
         (IndexOfSection);   SectionName
       ,     
    (AddSection);     SectionName    
    SectionIndex (InsertSection);     SectionIndex
    (DeleteSection)}
    function IndexOfSection(const SectionName: string;
      AddIfNotExists: Boolean): Integer;
    function AddSection(const SectionName: string): TStreamIniSection;
    function InsertSection(SectionIndex: Integer;
      const SectionName: string): TStreamIniSection;
    procedure DeleteSection(SectionIndex: Integer);
    {}
    { ,       
       (SectionCount);     Index, 
            
    (SectionNames);       Index (Sections);
       Key  Section     DefValue,
     ,      ,  DefValue, 
    ,     DefValue,  ,  
        ,    (Items);
       Value  Section     DefKey,
     ,      ,  DefKey, 
    ,     DefKey,  ,  
        ,    (ItemKeys);
        , SectionKey      '.'
     ,       (Values); 
     Section,      0,  
        DefValue,     
       DefValue  ,  
              
     ,  ,     Section
         DefValue  
    (SectionTexts);       
    (LastSectionIndex);       
          (LastKeyIndex); 
     ,        
           ,  
    (-1),     ,    
       (-1) (PreferredSectionIndex); 
     ,        
           ,
      (-1),     ,   
        (-1) (PreferredKeyIndex);  
            (IsChanged);  
           ,   ,
             
    (InMarks);   True       
     ,       
    ,   False    ,
     InMarks  True      ,
        Null (IsAlign);   True
        Items     ini 
            GetCmdPrm  ,
       ,   ,
     ,   ,     False
    (IniStr);    ,    
     ,      
      (AnExport);      }
    property SectionCount: Integer read GetSectionCount;
    property SectionNames[Index: Integer]: string
      read GetSectionName write SetSectionName;
    property Sections[Index: Integer]: TStreamIniSection read GetSection;
    property Items[const Section, Key, DefValue: string]: string
      read GetItem write SetItem; default;
    property ItemKeys[const Section, Value, DefKeys: string]: string
      read GetItemKey write SetItemKey;
    property Values[const SectionKey: string]: string
      read GetValue write SetValue;
    property SectionTexts[const Section, DefValue: string]: string
      read GetSectionText write SetSectionText;
    property LastSectionIndex: Integer read FLastSectionIndex;
    property LastKeyIndex: Integer read FLastKeyIndex;
    property PreferredSectionIndex: Integer
      read FPreferredSectionIndex write FPreferredSectionIndex;
    property PreferredKeyIndex: Integer
      read FPreferredKeyIndex write FPreferredKeyIndex;
    property IsChanged: Boolean read FIsChanged write SetIsChanged;
    property InMarks: Boolean read FInMarks write FInMarks;
    property IsAlign: TNullBool read FIsAlign write FIsAlign;
    property CheckCmdLine: Boolean read FCheckCmdLine write FCheckCmdLine;
    property IniStr: string read GetIniStr write SetIniStr;
    property AnExport: TStringsExport read GetExport;
    property SectionNamesSorted[Index: Integer]: string
      read GetSectionNameSorted;
    property WholeKeysCount: Integer read GetWholeKeysCount;
  end;
  {    ini-    }
  TStreamIniAccessMethod = function: TStreamIni of object;
{ Value   IniSection,  FindPrefix    ,
 1 ,      , 
    0   (FindInIni);    Value,
   FindPrefix    ,  1 ,
  IniSection,      ,
    ReplacePrefix   
(ReplaceByIni)}
function FindInIni(const Value: string; IniSection: TStreamIniSection;
  const FindPrefix: string): Integer;
function ReplaceByIni(const Value: string; IniSection: TStreamIniSection;
  const FindPrefix, ReplacePrefix: string): string;
{  AdditionalIni,   MainIni,  MainIni,
 AllowAddKeys  True     MainIni 
  ,   AllowRewriteValues  True 
     AdditionalIni,    ,
 MainIni  nil  ini-   MainIniFileName,
 AdditionalIni  nil  ini-   AdditionalFileName,
 CopySectionParamsStrArray   GetStrFromArray   
  ,      ..   
ini-,  ,    ,   
  ini-}
procedure MergeIni(MainIni, AdditionalIni: TStreamIni; const MainIniFileName,
  AdditionalIniFileName: string; AllowAddKeys, AllowRewriteValues: Boolean;
  const CopySectionParamsStrArray: string);
{  TextStr  ,     
SectionPrefix,    '[',   
SectionPostfix,    ']',   
      SectionNames,    
   ,    Sections,  
   TStringList,      
     ,     
     ,        
 }
procedure TextToSections(const TextStr, SectionPrefix, SectionPostfix: string;
  SectionNames: TIndexedStrings; Sections: TObjList {TStringList});
{   Ini  ,     
ParamGroupPrefix  ,   0,    ParamIds,
  nil,     'ID',  
 ParamCaptions,   nil,     'CAPTION', 
  ParamTypes,   nil,     'TYPE', 
  ParamDatas,   nil,     'DATA'}
procedure LoadIniParams(Ini: TStreamIni; const ParamGroupPrefix: string;
  ParamIds: TIndexedStrings; ParamCaptions: TStringList; ParamTypes: TList;
  ParamDatas: TStringList);
{ PrepareReportNamed,     
IniSectionName ini-  Ini,   nil  ini-
  IniFileName,  AdditionalParamsValues   , ,
 ,       
   ,       ini-,
   ,     
 ,  '*'      ini-
          
 ,        
 ,  ,   ini-    
 '*' ,   AdditionalParamsValues    
 '*' ,       '*' 
     ,   
    ini-     '**'   , 
        '*' , 
,         ,
 CheckOnly  True   ,    
      ,    
,    4-    
   ,      AdditionalParamsValues
      , , ,
 ,  ,     Template 
,    }
function PrepareReportNamesIniSection(const Template: string; Ini: TStreamIni;
  const IniFileName, IniSectionName: string;
  const AdditionalParamsValues: array of const; CheckOnly: Boolean): string;

{TIniSection -     ini-,     
  ,     ,  
      }
type
  TIniSection = class(TObjectStd)
  private
    FTempStrings: TStringList;
    FIniFile: TIniFile;
    FSectionName: string;
    FExcludeProps: TStringList;
    FPropList: TStringList;
    FDefPropValue: string;
  protected
    function TempStrings: TStringList;
    function CompareProps(const Prop1, Prop2: string): Boolean;
    function IsPropExcluded(const PropName: string): Boolean;
    procedure ReadPropList;
    procedure FreePropList;
    {}
    function GetPropCount: Integer;
    function GetProps(Index: Integer): string;
    function GetPropValues(const PropName: string): string;
    procedure SetPropValues(const PropName: string; const Value: string);
    {}
    {    ,   }
    procedure UpdateFile;
    {}
    property IniFile: TIniFile read FIniFile;
    property SectionName: string read FSectionName;
    property ExcludedProps: TStringList read FExcludeProps;
  public
    { ;   ,   ExcludeProps,
    ;   ExcludeProps   nil}
    constructor Create(IniFile: TIniFile;
      const SectionName: string; ExcludeProps: TStringList);
    destructor Destroy; override;
    {}
    {    ; ,  
    ExcludeProps,  }
    function IsPropExists(const PropName: string): Boolean;
    { ;      ExcludeProps
    }
    procedure DeleteProp(const PropName: string);
    {}
    { ,   ,    
       ExcludeProps;     }
    property DefPropValue: string read FDefPropValue write FDefPropValue;
    { }
    property PropCount: Integer read GetPropCount;
    { }
    property Props[Index: Integer]: string read GetProps;
    { ;     
    ;     ExcludeProps }
    property PropValues[const PropName: string]: string
      read GetPropValues write SetPropValues; default;
  end;

{ ini,    : 4- 
, 4-   ,  , 4- 
  , 4-  ,    }
type
  TBinaryIniReader = class(TObjectStd)
  private
    FStream: TStream;
    FStreamCache: TStreamCache;
    FSectionCount: Integer;
    FSectionIndex: Integer;
    FSectionName: string;
    FParamCount: Integer;
    FParamIndex: Integer;
    FParamName: string;
    FParamSplitted: Boolean;
    FParamStr: string;
    FValueStr: string;
    FIsEnd: Boolean;
    FIsBreak: Boolean;
    FMaxLength: Integer;
  protected
    function ReadCount: Integer;
    function ReadItem(IsBreak: PBooleanStd): string;
    {}
    function GetParamStr: string;
    function GetValueStr: string;
    {}
    procedure InitVars; virtual;
  public
    {    Stream   
    StreamCache}
    constructor Create(Stream: TStream; var StreamCache: TStreamCache);
    {}
    {       Stream  
     StreamCache}
    procedure Reset(Stream: TStream; var StreamCache: TStreamCache);
    {  ,      ,  
     True,     ini,   False}
    function ReadNext: Boolean;
    {}
    {    (Stream);   (StreamCache);
     , (-1)        
    ini (SectionCount);  , (-1)      
      ini (SectionIndex);  ,    
         ini (SectionName);   
     , (-1)     (ParamCount);  
      (-1)        
     ini (ParamIndex);  , ,    
    (ParamName);     '=' (ParamStr); 
       '=' (ValueStr);    ini
    (IsEnd);  ,     ,   
        ,  (IsBreak);  
    , ,       ,
     '='   ,   0,   
     (MaxLength)}
    property Stream: TStream read FStream;
    property StreamCache: TStreamCache read FStreamCache;
    property SectionCount: Integer read FSectionCount;
    property SectionIndex: Integer read FSectionIndex;
    property SectionName: string read FSectionName;
    property ParamCount: Integer read FParamCount;
    property ParamIndex: Integer read FParamIndex;
    property ParamName: string read FParamName;
    property ParamStr: string read GetParamStr;
    property ValueStr: string read GetValueStr;
    property IsEnd: Boolean read FIsEnd;
    property IsBreak: Boolean read FIsBreak;
    property MaxLength: Integer read FMaxLength write FMaxLength;
  end;
{}
{ ini     TBinaryIniReader}
type
  TBinaryIniWriter = class(TObjectStd)
  private
    FStream: TStream;
    FStreamCache: TStreamCache;
    FSectionCount: Integer;
    FSectionIndex: Integer;
    FSectionName: string;
    FParamCount: Integer;
    FParamIndex: Integer;
    FParamName: string;
    FParamSplitted: Boolean;
    FParamStr: string;
    FValueStr: string;
    FIsEnd: Boolean;
    FIsBreak: Boolean;
  protected
    procedure SetSectionCount(SectionCount: Integer);
    procedure SetParamCount(ParamCount: Integer);
    function GetParamStr: string;
    function GetValueStr: string;
    {}
    procedure WriteCount(const Count: Integer);
    procedure WriteItem(const ItemStr: string);
    {}
    procedure InitVars; virtual;
  public
    {    Stream   
    StreamCache}
    constructor Create(Stream: TStream; var StreamCache: TStreamCache);
    destructor Destroy; override;
    {}
    {        Stream  
     StreamCache}
    procedure Reset(Stream: TStream; var StreamCache: TStreamCache);
    {  Section,       
      SectionCount (WriteSection);    Param,
               
      ParamCount (WriteParam);   Param  
    Value,           
       ParamCount (WriteValue);  , 
      StreamCache   ,  ,  
          ,   
            , 
           ,  
      IsBreak = True,    ini  ,
     ,  ini  ,   Reset  
        ,     (WriteFinish)}
    procedure WriteSection(const SectionName: string);
    procedure WriteParam(const ParamName: string);
    procedure WriteValue(const ParamStr, ValueStr: string);
    procedure WriteFinish;
    {}
    {    (Stream);   (StreamCache);
     ,   (-1),    
     (SectionCount);  ,   (-1),   0
    (SectionIndex);    (SectionName);   
    ,         (-1), 
         (ParamCount);  
    ,         (-1),  
    0 (ParamIndex);    (ParamName);  
      '=' (ParamStr);     '='
    (ValueStr);      ini   
     WriteFinish,  ,     
    WriteFinish  ,  WriteFinish   
          (IsEnd);  
    ,    WriteFinish   
    (IsBreak)}
    property Stream: TStream read FStream;
    property StreamCache: TStreamCache read FStreamCache;
    property SectionCount: Integer read FSectionCount write SetSectionCount;
    property SectionIndex: Integer read FSectionIndex;
    property SectionName: string read FSectionName;
    property ParamCount: Integer read FParamCount write SetParamCount;
    property ParamIndex: Integer read FParamIndex;
    property ParamName: string read FParamName;
    property ParamStr: string read GetParamStr;
    property ValueStr: string read GetValueStr;
    property IsEnd: Boolean read FIsEnd;
    property IsBreak: Boolean read FIsBreak;
  end;
{   ini-  TBinaryIniReader    }
type
  TStreamBinIni = class(TStreamIni)
  private
    FReader: TBinaryIniReader;
    FWriter: TBinaryIniWriter;
    FIsTextIni: Boolean;
  protected
    function AccessIniStr(IsDefine: Boolean;
      const NewIniStr: string): string; override;
    function GetMaxLength: Integer;
    procedure SetMaxLength(NewMaxLength: Integer);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    procedure Load(Stream: TStream; CacheSize: Integer); override;
    procedure Save(Stream: TStream; CacheSize: Integer); override;
    {}
    {       TBinaryIniReader,
      0,     (MaxLength); 
           ini,  
    False (IsTextIni)}
    property MaxLength: Integer read GetMaxLength write SetMaxLength;
    property IsTextIni: Boolean read FIsTextIni write FIsTextIni;
  end;
{   ini  TBinaryIniReader  
 ini (BinIniToIni);    ini 
 ini  TBinaryIniReader (IniToBinIni)}
function BinIniToIni(const Value: string): string;
function IniToBinIni(const Value: string): string;
{   ini Data  TBinaryIniReader 
   MsgLabel,   ,  CRC  , 
CalcCRC,    ini,  IgnoreMsgLabel 
 ,  IgnoreCRC   CRC,  
IsMsgLabelError,  ,    ,  
IsCRCError,  , -  CRC,     ini
        
 (BinIniToIni);    ini   ini
 TBinaryIniReader     MsgLabel,   ,  CRC
 ,  CalcCRC (IniToBinIni)}
function CRCBinIniToIni(const MsgLabel, Data: string; IgnoreMsgLabel,
  IgnoreCRC: Boolean; IsMsgLabelError, IsCRCError: PBooleanStd): string;
function IniToCRCBinIni(const MsgLabel, Data: string): string;

{   %_%  Value   
 VariantParams,   ,  StreamIni.Values, %%   %,
 ,     ,   
     VariantParams  StreamIni.Values,
 ClearOnEmpty = True   ,  EmptyFound,   nil,
 True,  False,  VariantParams  nil , 
     ,   StreamIni,
(FormatByVariantParams);  FormatByVariantParams  
  Value  GetStrFromArray,     
    ,   
  DivStr  ,   Count,   nil,
    (FormatStrArrayByVariantParams)}
function FormatByVariantParams(const Value: string; VariantParams:
  TVariantParams; StreamIni: TStreamIni; ConvertFunc: TConvertFunc;
  ClearOnEmpty: Boolean; EmptyFound: PBooleanStd): string;
function FormatStrArrayByVariantParams(const Value: string;
  VariantParams: TVariantParams; StreamIni: TStreamIni;
  ConvertFunc: TConvertFunc; const DivStr: string; Count: PInteger): string;



{---  ------------------------------------------------------------------}

{  TRegistry,      
  Windows NT, : KEY_ALL_ACCESS  
KEY_READ or KEY_WRITE,  KEY_CREATE_LINK,   KEY_ALL_ACCESS,
, Borland Delphi Visual Component Library, Copyright (c) 1995,98 Inprise
Corporation}
type
  ERegistryExceptionStd = class(ExceptionStd);
  TRegKeyInfoStd = record
    NumSubKeys: Integer;
    MaxSubKeyLen: Integer;
    NumValues: Integer;
    MaxValueLen: Integer;
    MaxDataLen: Integer;
    FileTime: TFileTime;
  end;
  TRegDataInfoStd = record
    RegData: TRegDataTypeStd;
    DataSize: Integer;
  end;
  TRegistryStd = class(TObjectStd)
  private
    FCurrentKey: HKEY;
    FRootKey: HKEY;
    FLazyWrite: Boolean;
    FCurrentPath: string;
    FCloseRootKey: Boolean;
    procedure SetRootKey(Value: HKEY);
  protected
    procedure ChangeKey(Value: HKey; const Path: string);
    function GetBaseKey(Relative: Boolean): HKey;
    function GetData(const Name: string; Buffer: Pointer;
      BufSize: Integer; var RegData: TRegDataTypeStd): Integer;
    function GetKey(const Key: string): HKEY;
    procedure PutData(const Name: string; Buffer: Pointer; BufSize: Integer;
      RegData: TRegDataTypeStd);
    procedure SetCurrentKey(Value: HKEY);
  public
    constructor Create;
    destructor Destroy; override;
    procedure CloseKey;
    function CreateKey(const Key: string): Boolean;
    function DeleteKey(const Key: string): Boolean;
    function DeleteValue(const Name: string): Boolean;
    function GetDataInfo(const ValueName: string;
      var Value: TRegDataInfoStd): Boolean;
    function GetDataSize(const ValueName: string): Integer;
    function GetDataType(const ValueName: string): TRegDataTypeStd;
    function GetKeyInfo(var Value: TRegKeyInfoStd): Boolean;
    procedure GetKeyNames(Strings: TStrings);
    procedure GetValueNames(Strings: TStrings);
    function HasSubKeys: Boolean;
    function KeyExists(const Key: string): Boolean;
    function LoadKey(const Key, FileName: string): Boolean;
    procedure MoveKey(const OldName, NewName: string; Delete: Boolean);
    function OpenKey(const Key: string; CanCreate: Boolean): Boolean;
    function OpenKeyReadOnly(const Key: String): Boolean;
    function ReadCurrency(const Name: string): Currency;
    function ReadBinaryData(const Name: string; var Buffer;
      BufSize: Integer): Integer;
    function ReadBool(const Name: string): Boolean;
    function ReadDate(const Name: string): TDateTime;
    function ReadDateTime(const Name: string): TDateTime;
    function ReadFloat(const Name: string): Double;
    function ReadInteger(const Name: string): Integer;
    function ReadString(const Name: string): string;
    function ReadTime(const Name: string): TDateTime;
    function RegistryConnect(const UNCName: string): Boolean;
    procedure RenameValue(const OldName, NewName: string);
    function ReplaceKey(const Key, FileName, BackUpFileName: string): Boolean;
    function RestoreKey(const Key, FileName: string): Boolean;
    function SaveKey(const Key, FileName: string): Boolean;
    function UnLoadKey(const Key: string): Boolean;
    function ValueExists(const Name: string): Boolean;
    procedure WriteCurrency(const Name: string; Value: Currency);
    procedure WriteBinaryData(const Name: string; var Buffer;
      BufSize: Integer);
    procedure WriteBool(const Name: string; Value: Boolean);
    procedure WriteDate(const Name: string; Value: TDateTime);
    procedure WriteDateTime(const Name: string; Value: TDateTime);
    procedure WriteFloat(const Name: string; Value: Double);
    procedure WriteInteger(const Name: string; Value: Integer);
    procedure WriteString(const Name, Value: string);
    procedure WriteExpandString(const Name, Value: string);
    procedure WriteMultiString(const Name, Value: string);
    procedure WriteTime(const Name: string; Value: TDateTime);
    property CurrentKey: HKEY read FCurrentKey;
    property CurrentPath: string read FCurrentPath;
    property LazyWrite: Boolean read FLazyWrite write FLazyWrite;
    property RootKey: HKEY read FRootKey write SetRootKey;
  end;

{    RootKey   ;
     HKEY_CURRENT_USER}
function RootKeyToHKey(const RootKey: string): HKEY;
{    Key   ;
     'HKEY_CURRENT_USER'}
function HKeyToRootKey(Key: HKEY): string;
{        FullValueName  :
   RootKey,    KeyNames,  
ValueName, :
RegParamSplit('HKEY_CURRENT_USER\SOFTWARE\MyApp\MyParam') ->
('HKEY_CURRENT_USER', '\SOFTWARE\MyApp\', 'MyParam'),
RegParamSplit('HKEY_CURRENT_USER\MyParam') ->
('HKEY_CURRENT_USER', '\', 'MyParam'),
RegParamSplit('MyParam') -> ('', '', 'MyParam'),
RegParamSplit('\SOFTWARE\MyApp\MyParam') ->
('', '\SOFTWARE\MyApp\', 'MyParam'),
RegParamSplit('\MyParam') -> ('', '\', 'MyParam'),
RegParamSplit('HKEY_CURRENT_USER\SOFTWARE\MyApp\') ->
('HKEY_CURRENT_USER', '\SOFTWARE\MyApp\', ''),
RegParamSplit('any_value\MyParam') -> ('any_value', '\', 'MyParam')}
procedure RegistryNameSplit(const FullValueName: string;
  out RootKey, KeyNames, ValueName: string);

{    Registry;  RetrieveFullName = True
      ,     
   }
function RegistryCurrentKey(Registry: TRegistryStd;
  RetrieveFullName: Boolean): string;
{     KeyName   Registry,  True
 ,   ,  ReadOnly  True  
  }
function RegistryOpenKey(Registry: TRegistryStd; const KeyName: string;
  ReadOnly: Boolean): Boolean;
{    KeyName ( -  , ,
MyAppKey\MySubKey  ,         
 , , \SOFTWARE\MyAppKey\MySubKey)  
  ,    ,   Registry;
 True,     ,   ;  
    ,   False;   
   ,    ;  Registry = nil,
       ,  
KeyName      , 
'HKEY_CURRENT_USER\SOFTWARE\MyApp'}
function RegistryCreateKey(Registry: TRegistryStd;
  const KeyName: string): Boolean;
{    KeyName ( -  , ,
MyAppKey\MySubKey  ,         
 , , \SOFTWARE\MyAppKey\MySubKey)   
     Registry;  True,    
 (  );     
 ,    ;  Registry = nil,  
     ,   KeyName
     , 
'HKEY_CURRENT_USER\SOFTWARE\MyApp'}
function RegistryDeleteKey(Registry: TRegistryStd;
  const KeyName: string): Boolean;
{ True,        ,  }
function RegistryKeyIsEmpty(Registry: TRegistryStd): Boolean;
{ True,     Registry    (
  ,    )   False  
      ;     
   ,         }
function RegistryKeyIsNoValues(Registry: TRegistryStd): Boolean;
{   : remNotSaveKeyNames -   
 , remNotSaveKeyValues -     ,
remNotSaveSubKeys -      (  
     ,    
remNotSaveKeyNames)}
type
  TRegistryExportMode = set of (remNotSaveKeyNames, remNotSaveKeyValues,
    remNotSaveSubKeys);
{    : rimNotAdd -   
, rimNotModify -   , rimNotDelete -
  }
type
  TRegistryImportMode = set of (rimNotAdd, rimNotModify, rimNotDelete);
{      Registry;  ValueNames 
 ,  Values -   (  Integer  
 ),  ValueTypes -  (TRegDataTypeStd) }
procedure RegistryExportKeyValues(Registry: TRegistryStd;
  ValueNames, Values: TStrings; ValueTypes: TList);
{      Registry;  ValueNames  
,  Values -   (  Integer  
 ),  ValueTypes   (TRegDataTypeStd)
;    ,    ,  
  ValueNames   False,     -
True}
function RegistryImportKeyValues(Registry: TRegistryStd;
  ValueNames, Values: TStrings; ValueTypes: TList;
  FirstIndex, LastIndex: Integer; ValueMode: TRegistryImportMode): Boolean;
{     Registry   Mode; 
ParentKeyIndexes   -  ,  
  KeyNames (   0,    
 ParentKeyIndexes   (-1));  ValueKeyIndexes   
 ,     ValueNames,   -  Values
(Integer   4- ),   (TRegDataTypeStd) - 
ValueTypes;   False,     
 ,       - True;   
      -     
 -     }
function RegistryExportKey(Registry: TRegistryStd; ParentKeyIndexes: TList;
  KeyNames: TStrings; ValueKeyIndexes: TList; ValueNames, Values: TStrings;
  ValueTypes: TList; Mode: TRegistryExportMode): Boolean;
{     Registry   
 KeyMode     ValueMode;  ParentKeyIndexes
  -  ,    
KeyNames (   0,  ,    (  
 ) ,    ParentKeyIndexes  (-1)); 
ValueKeyIndexes   ,   , 
 ValueNames ( ), Values ( ,  Integer - 4-
), ValueTypes (     TRegDataTypeStd);  
   ,     False, 
  - True}
function RegistryImportKey(Registry: TRegistryStd; ParentKeyIndexes: TList;
  KeyNames: TStrings; ValueKeyIndexes: TList; ValueNames, Values: TStrings;
  ValueTypes: TList; KeyMode, ValueMode: TRegistryImportMode): Boolean;
{       
RegistryExportKey:    ParentKeyIndexes, 
 KeyNames,   ValueKeyIndexes,  
ValueNames,  Values,  TRegDataTypeStd  ValueTypes  ,
 ParentKeyIndexes  KeyNames  nil   ,
 ValueNames, Values  ValueTypes  nil   ,
  ValueKeyIndexes  nil    ;
   }
function RegistryExportListsToStr(ParentKeyIndexes: TList;
  KeyNames: TStrings; ValueKeyIndexes: TList; ValueNames, Values: TStrings;
  ValueTypes: TList): string;
{  S        
RegistryExportKey:    ParentKeyIndexes, 
 KeyNames,   ValueKeyIndexes,  
ValueNames,  Values,  TRegDataTypeStd  ValueTypes,  S
 ,   RegistryExportListsToStr,  ParentKeyIndexes
 KeyNames  nil   ,  ValueNames, Values 
ValueTypes  nil   ,   ValueKeyIndexes
 nil    ,   }
function StrToRegistryExportLists(const S: string; ParentKeyIndexes: TList;
  KeyNames: TStrings; ValueKeyIndexes: TList; ValueNames, Values: TStrings;
  ValueTypes: TList): string;
{    RegistryExportListsToStr  
regedit.exe   , MainKeyName   
(RegistryExportListsToRegEditStr);    
StrToRegistryExportLists   regedit.exe   ,
StrPos     S,  MainKeyName   ,
     ,    
 True,     ,    
,   False     ,  SubKeyNames,
  nil,       ,
 LastBinaryValue,   nil,     
(RegEditStrToRegistryExportLists)}
function RegistryExportListsToRegEditStr(const MainKeyName: string;
  ParentKeyIndexes: TList; KeyNames: TStrings; ValueKeyIndexes: TList;
  ValueNames, Values: TStrings; ValueTypes: TList): string;
function RegEditStrToRegistryExportLists(const S: string; var StrPos: Integer;
  out MainKeyName: string; ParentKeyIndexes: TList; KeyNames: TStrings;
  ValueKeyIndexes: TList; ValueNames, Values: TStrings; ValueTypes: TList;
  SubKeyNames: TIndexedStrings; LastBinaryValue: TStrings): Boolean;
{       
RegistryExportKey:    ParentKeyIndexes, 
 KeyNames,   ValueKeyIndexes,  
ValueNames,  Values,  TRegDataTypeStd  ValueTypes  
   :
'K idx ParentKeyIndexes[idx] KeyNames[idx]'   
'V ValueKeyIndexes[idx] ValueTypes[idx] ValueNames[idx] = Values[idx]' 
,  idx -    KeyNames, ValueNames,  
,   ,   ,  '='  ValueNames
,  Values         ,
    ++   }
function RegistryExportListsToDisplayStr(ParentKeyIndexes: TList;
  KeyNames: TStrings; ValueKeyIndexes: TList; ValueNames, Values: TStrings;
  ValueTypes: TList): string;

{  KeyName       , 
IsRemoveKey = True      ;   
,   ;     
   ,    IsError  True, 
False,      nil,    ;  
 KeyName: 'HKEY_CURRENT_USER\SOFTWARE\MyApp' (    )}
function RegistryKeyToStr(const KeyName: string; IsRemoveKey: Boolean;
  IsError: PBooleanStd): string;
{   KeyName    S;  IsAppendKey = True
      ,     S;
 S = ''  IsAppendKey = False,  KeyName  ;  
          
False,     True;    KeyName:
'HKEY_CURRENT_USER\SOFTWARE\MyApp' (    )}
function StrToRegistryKey(const KeyName, S: string;
  IsAppendKey: Boolean): Boolean;
{     regedit.exe   , 
 RegistryKeyToStr (RegistryKeyToRegEditStr);   
   regedit.exe   ,  
StrToRegistryKey,  KeyNames,   nil,    ,
   ,     ,   
  True,        False
(RegEditStrToRegistryKey)}
function RegistryKeyToRegEditStr(const KeyName: string; IsRemoveKey: Boolean;
  IsError: PBooleanStd): string;
function RegEditStrToRegistryKey(const S: string;
  IsAppendKey: Boolean; KeyNames: TStrings): Boolean;
{  ValueName     Registry,  
 ,  DefValue,   Integer  
    ,   ValueType,   nil,
  }
function RegistryReadValue(Registry: TRegistryStd; const ValueName,
  DefValue: string; ValueType: PRegDataType): string;
{  ValueName     Registry   
 Integer,        
   ,  Null}
function RegistryReadValueInt(Registry: TRegistryStd;
  const ValueName: string): TNullInt;
{  Value   ValueName   ValueType   
 Registry;  ValueType = rdInteger Value   
   ,    0}
procedure RegistryWriteValue(Registry: TRegistryStd; const ValueName,
  Value: string; ValueType: TRegDataTypeStd);
{        FullKeyName}
procedure RegistryGetSubKeys(const FullKeyName: string; SubKeys: TStrings);
{  Values       FullKeyName,
 IsClear   ,   Values   nil}
procedure RegistryGetValues(const FullKeyName: string; Values: TStrings;
  IsClear: Boolean);
{  FullValueName  ,     
    DefValue,   ValueType, 
 nil,   ,  FullValueName   
'HKEY_CURRENT_USER\SOFTWARE\MyApp\MyParam'}
function RegistryGetValue(const FullValueName, DefValue: string;
  ValueType: PRegDataType): string;
{  FullValueName  ;    ,
 Value;  ,    ,  , 
;   Value  DefValue  ; 
DeleteEmptyKey = True  ,      
(     ),  ; ValueType 
   ( ValueType = rdInteger Value  DefValue
  ,    0);     
   False (  ExceptionOnKeyOpenError = True -
   ERegistryExceptionStd),   
  - True;  FullValueName:
'HKEY_CURRENT_USER\SOFTWARE\MyApp\MyParam'}
function RegistrySetValue(const FullValueName, Value, DefValue: string;
  ValueType: TRegDataTypeStd; DeleteEmptyKey,
  ExceptionOnKeyOpenError: Boolean): Boolean;
{ : vcmNull -   , vcmDefined -  ,
vcmError -      (TValueCacheMode)   
}
type
  TValueCacheMode = (vcmNull, vcmDefined, vcmError);
  TValueCache = record
    Mode: TValueCacheMode;
    Value: string;
  end;
{ TValueCache}
function ValueCache(Mode: TValueCacheMode; const Value: string): TValueCache;
{  FullValueName      
  ;        
 DefValue;     ValueCache, 
        
;  FullValueName: 'HKEY_CURRENT_USER\SOFTWARE\MyApp\MyParam'}
function RegistryGetCached(const FullValueName, DefValue: string;
  var ValueCache: TValueCache): string;
{  FullValueName      
  ;    ,  Value;  ,
   ,  ,  ;  
Value  DefValue  ;  DeleteEmptyKey = True  , 
     (     ), 
; ValueType     ( ValueType =
rdInteger Value  DefValue   ,    0);
        False (
 ExceptionOnKeyOpenError = True -   
ERegistryExceptionStd),      - True;  
 ValueCache,        
    ,    , 
,      ;  FullValueName:
'HKEY_CURRENT_USER\SOFTWARE\MyApp\MyParam'}
function RegistrySetCached(const FullValueName, Value, DefValue: string;
  ValueType: TRegDataTypeStd; var ValueCache: TValueCache; DeleteEmptyKey,
  ExceptionOnKeyOpenError: Boolean): Boolean;
{       Strings   Value,
   Null,   FilePath,    ,
   FileName,    ,    
RegistryKeyName,      Registry  nil,  
 ,      RegistryValueName,  
   Registry  nil,    ,  
  Index,        
True       False}
function DefineStringIfExists(Strings: TStrings; var Index: Integer;
  const Value: TNullStr; const FilePath, FileName, RegistryKeyName,
  RegistryValueName: string; Registry: TRegistryStd): Boolean;
{          
KeyName   RegCommonKey,    , 
   ,      ,
 NotDelete  True    ,  ForceRestore
 True      (RegistryKeyBackup);
   KeyName,  RegistryKeyBackup,
    ,     
  ,    ,  IsAppend  True
       ,
        ,
 ForceRestore  True     
(RegistryKeyRestore)}
procedure RegistryKeyBackup(const KeyName: string; NotDelete,
  ForceBackup: Boolean);
procedure RegistryKeyRestore(const KeyName: string; IsAppend,
  ForceRestore: Boolean);



{---   -------------------------------------------------------------}

{   SQL-   SQL-
SQLBlock,   SentencesInBlock ,   SQL-
SQLBlocks,   TotalSentences     
TotalSize ,      ' OR ',
   SQL-   ,    TotalSentences 
,    True,     
     SQL-,  
    False,  SQL-  
 StringsToStr(SQLBlocks, '', False, -1, -1)}
function AddSQLBlock(const SQLBlock: string; SentencesInBlock: Integer;
  SQLBlocks: TStrings; var TotalSentences, TotalSize: Integer): Boolean;
{    "WHERE" SQL-,    Params
 ,    ,  CompPrefixes,
  -     ,    
 DefSQLCompTypePrefixes,       
,      TSQLCompareType,   -
,    ,     
EngLettersToStr,   ,     
, , '_'  '.',       
,          
 wctEqualNum, wctNotEqualNum,      
 ,   ,   ,   
 ,  SkipEmpty    ,
  ,   ExcludeParams,  ExcludeParams
  nil,        
    'AND', GroupPrefix   ,
     'OR',   
DefSQLWhereGroupPrefix}
function BuildWhere(Params: TStringParams; ExcludeParams: TIndexedStrings;
  const CompPrefixes: TSQLCompTypeNames; const GroupPrefix: string;
  SkipEmpty: Boolean): string;
{ SQL-   Fields,   Aliases, 
  Values,   Table,    Other,
   True,   False}
function ParseSQL(const SQL: string; Fields, Aliases: TStrings;
  Values: TVariants; out Table, Other: string): Boolean;
{  SQL-  CommandType  TableName  
 FieldNames,   TVarBaseType FieldTypes     
 TableData,   NullValue, , ,  
  '(null)',     Null,  
  Null      ,
  TableData  nil    VarTableData,  
NullValue ,       
   SQL-   ,  
  ,       
  , SQLDivider   SQL-, ,
'GO',     SQL-  ';', LineLength 
   ,  SQLs  SQL-,
      ,    SQLDivider,
  ,   ,  SQLHeader,   nil, 
 SQL-,       SQLs ,
     SQLHeader  ,  
,     #0,  CommandType  sctData
     SQL-   
  TableName   ,      
        ,  ,
 ,   ,    
,  ,       ,
      (TableToSQLs);
  SQL-  CommandType  TableStr,  
    ,    
 #9     StrToVarBaseType,   
        '*', ,  
,        ,
    ,   ,
       , ,
   '0x', NullValue, ,    '(null)', 
,  Null,   Null  
      , SQLDivider  
SQL-, , 'GO',     SQL-  ';',
LineLength      (TableStrToSQLs);
 ,  SQL- SQL   ADO Connection,
  ,   ConnectionString, CommandType  
SQL-, KeyFields    , '1',   
 , '0'   ,  , SQLDivider  
SQL-, , 'GO',     SQL-  ';',
LineLength     , SQLsFileName 
    SQL-,  IsAppend  ,
   ,    
SQL- (ADOTableToSQLs);   ADO Connection,   ,
  Connectiontring,     Tables, 
 nil,        Selects,   nil,
   ,  ,  , 
 SQLs,   nil,   SQLDivider,    
SQL-  ';',      
(ADOTableListToSQLs)}
procedure TableToSQLs(CommandType: TSQLCommandType; const TableName: string;
  FieldNames: TStrings; FieldTypes: TList {TVarBaseType};
  TableData: TIndexedStringsList; const NullValue: string;
  VarTableData: TIndexedVariantsList; const SQLDivider: string;
  LineLength: Integer; SQLs, SQLHeader: TStrings);
function TableStrToSQLs(CommandType: TSQLCommandType; TableStr,
  NullValue, SQLDivider: string; LineLength: Integer): string;
function ADOTableToSQLs(const Connection: Variant; const ConnectionString,
  SQL: string; CommandType: TSQLCommandType; const KeyFields,
  SQLDivider: string; LineLength: Integer; const SQLsFileName: string;
  IsAppend: Boolean): Integer;
function ADOTableListToSQLs(const Connection: Variant; const ConnectionString,
  SQLDivider: string; Tables, Selects, SQLs: TStrings): Integer;

{ ODBC}
type
  EODBCError = class(EWinAPIError);
  EODBCErrorClass = class of EODBCError;
{  ODBC   Msg  ,    ,
   ErrorCode    ProcName,  
 ,  EODBCErrorClass,  nil   EODBCError,
 MsgOnly = True      Msg}
function ODBCErrorCreate(const Msg: string; ErrorCode: Integer;
  const ProcName: string; ODBCErrorClass: EODBCErrorClass;
  MsgOnly: Boolean): EODBCError;
{}
{ ODBC}
type
  TODBCAPI = class(TObjectStd)
  private
    FProc: TFarProc;
    FLastResult: Integer;
    FLastError: Integer;
    FODBC32DLL: TDLLLoadInfo;
    FODBCCP32DLL: TDLLLoadInfo;
    FSQLAllocEnv: TDLLProcInfo;
    FSQLFreeEnv: TDLLProcInfo;
    FSQLDataSources: TDLLProcInfo;
    FSQLConfigDataSource: TDLLProcInfo;
    FSQLDrivers: TDLLProcInfo;
    FEnvironmentHandle: TSQLEnv;
    FDriverDescriptions: TIndexedStrings;
    FDriverAttributes: TIndexedStrings;
    FServerNames: TIndexedStrings;
    FDescriptions: TIndexedStrings;
  protected
    function LoadODBC32Proc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    function LoadODBCCP32Proc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    {}
    {  ODBC}
    function SQLAllocEnv: TSQLEnv;
    procedure SQLFreeEnv(EnvironmentHandle: TSQLEnv);
    function SQLDataSources(EnvironmentHandle: TSQLEnv; Direction: Integer;
      out ServerName, Description: string; ServerNameStrings,
      DescriptionStrings: TIndexedStrings): Boolean;
    procedure SQLConfigDataSource(ParentWindow: HWND; Request: Integer;
      const DriverString, Attributes: string);
    function SQLDrivers(EnvironmentHandle: TSQLEnv; IsFirst: Boolean;
      out DriverDescription, DriverAttributes: string;
      DriverDescriptionStrings,
      DriverAttributesStrings: TIndexedStrings): Boolean;
      { ODBC  2}
    {}
    function GetEnvironmentHandle: TSQLEnv;
    function GetDriverDescriptions: TIndexedStrings;
    function GetDriverAttributes: TIndexedStrings;
    function GetServerNames: TIndexedStrings;
    function GetDescriptions: TIndexedStrings;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {     DSN   
    ,  }
    procedure Reset;
    {}
    {   DSN,       ,
      Attributes,    #0,  
      Driver,   ,  ,  
    DriverSubstring,   ,     Driver,
            Reset (AddDSN);
     DSN   dBase,  DSN 'dBASE Files'   
    (AddDBASE)}
    procedure AddDSN(const Driver, DriverSubstring, DSN, Attributes: string);
    procedure AddDBASE;
    {}
    {   (LastResult);   
    (LastError);   (EnvironmentHandle);  
      ,  #0,  (DriverDescriptions,
    DriverAttributes);   ,   DSN,  
     ,  (ServerNames, Descriptions)}
    property LastResult: Integer read FLastResult;
    property LastError: Integer read FLastError;
    property EnvironmentHandle: TSQLEnv read GetEnvironmentHandle;
    property DriverDescriptions: TIndexedStrings read GetDriverDescriptions;
    property DriverAttributes: TIndexedStrings read GetDriverAttributes;
    property ServerNames: TIndexedStrings read GetServerNames;
    property Descriptions: TIndexedStrings read GetDescriptions;
  end;
{       ODBC,  
    }
function ODBCAPI: TODBCAPI;
{    ODBC }
procedure ODBCAPIReset;

type
  {    : dwmNotCheckExist -    
    ,    , dwmNotAdd - 
   , dwmNotUpdate -   , dwmNotDelete - 
   }
  TDatabaseWriteMode = set of (dwmNotCheckExist, dwmNotAdd, dwmNotUpdate,
    dwmNotDelete);
  {}
  TCustomDatabaseAccess = class;
  TRecordsetAccess = class;
  {  : rtpBeforeRecordReading -   ,
  rtpAfterRecordReading -   }
  TReadTablePhase = (rtpBeforeRecordReading, rtpAfterRecordReading);
  {  : wtpBeforeRecordAdding -   ,
  wtpBeforeRecordUpdating -   , wtpBeforeRecordDeleting -
    }
  TWriteTablePhase = (wtpBeforeRecordAdding, wtpBeforeRecordUpdating,
    wtpBeforeRecordDeleting);
  {       Recordset   Table, 
  Phase,   RecordIndex,     ExcludingFields,
     Phase = wtpBeforeRecordAdding, IsStop - 
  ,   False, IsSkip -  ,   False}
  TReadTableEvent = procedure(Sender: TObject; Table: TIndexedVariantsList;
    Phase: TReadTablePhase; RecordIndex: Integer;
    ExcludingFields: PBooleanArray; Recordset: TRecordsetAccess;
    var IsStop, IsSkip: Boolean) of object;
  {       Recordset   Table, 
  Phase,   RecordIndex,     ExcludingFields,
     Phase = wtpBeforeRecordUpdating, IsStop - 
  ,   False, IsSkip -  ,   False}
  TWriteTableEvent = procedure(Sender: TObject; Table: TIndexedVariantsList;
    Phase: TWriteTablePhase; RecordIndex: Integer;
    ExcludingFields: PBooleanArray; Recordset: TRecordsetAccess;
    var IsStop, IsSkip: Boolean) of object;
  {}
  {     }
  EDatabaseAccessError = class(ENumProcError);
  {   }
  TRecordsetAccess = class(TObjectStd)
  private
    FDatabaseAccess: TCustomDatabaseAccess;
    FActive: Boolean;
    FSQL: string;
    FIsReadOnly: Boolean;
    FIsBatch: Boolean;
    FIsBatchChanged: Boolean;
    FIsNamesTypesLoaded: Boolean;
    FNames: TIndexedStrings;
    FTypes: TList;
    FLastFieldIndex: Integer;
    FOpenTicks: DWORD;
    FOpenMilliseconds: Integer;
    FCOM: Variant;
    FCOMInterface: string;
    FCOMProperties: TStringList;
    FCOMAliases: TStringList;
    FCOMValues: TVariants;
    FCOMIndex: Integer;
    FBlockAutoCommit: Boolean;
    FStreamedFieldIndex: Integer;
    FStreamedFieldPosition: Integer;
    FStreamedFieldValue: string;
    FStreamedFieldIsWrite: Boolean;
    FStreamedFieldNotSaved: Boolean;
  protected
    procedure LoadNamesTypes;
    function Database: TCustomDatabaseAccess;
    {}
    procedure SetActive(NewActive: Boolean);
    function GetFieldCount: Integer;
    function GetField(Index: Integer): Variant;
    procedure SetField(Index: Integer; const NewValue: Variant);
    function GetFieldType(Index: Integer): TVarBaseType;
    function GetFieldName(Index: Integer): string;
    function GetFieldSize(Index: Integer): Integer;
    function GetFieldFixed(Index: Integer): Boolean;
    function GetBLOBField(Index: Integer): Variant;
    procedure SetBLOBField(Index: Integer; const Value: Variant);
    function GetFieldIndex(const FieldName: string): Integer;
    function GetNames: TIndexedStrings;
    function GetTypes: TList;
    function GetFieldByName(const FieldName: string): Variant;
    procedure SetFieldByName(const FieldName: string; const NewValue: Variant);
    function GetFieldByIndex(FieldIndex: Integer): Variant;
    procedure SetFieldByIndex(FieldIndex: Integer; const NewValue: Variant);
    function GetCOMProperties: TStringList;
    function GetCOMAliases: TStringList;
    function GetCOMValues: TVariants;
    {}
    {    }
    procedure FinishField;
    {      ,  ,  
    ,      }
    procedure InitVars; virtual;
  public
    {       DatabaseAccess}
    constructor Create(DatabaseAccess: TCustomDatabaseAccess);
    destructor Destroy; override;
    {}
    { -         
      (Clear);      SQL   
     IsReadOnly, IsBatch (Open); ,   
           
       (Close); ,    (EoF);
        (MoveNext);  ,  
         Update (AddNew);  
         (Update);  
            
       (UpdateBatch);    
    , Update     (Delete);  
    (CancelUpdate);      
          (CancelBatch);  IsReadOnly
     False  ,    ,
      ,     IsReadOnly
    (DetectReadOnly);  BLOB-   FieldIndex,  Size
    ,  Size = -1,  FieldSizes[Index] 
    (ReadBLOB);  BLOB-   FieldIndex (ClearBLOB); 
     BLOB-  Value (WriteBLOB);    Value
     BLOB-   FieldIndex (AppendBLOB);  
    Size , , ,  ,   
        FieldIndex  (ReadField,
    ClearField, WriteField, AppendField, FlushField)}
    procedure Clear; virtual;
    procedure Open;
    procedure Close;
    function EoF: Boolean;
    procedure MoveNext;
    procedure AddNew;
    procedure Update;
    procedure UpdateBatch;
    procedure Delete;
    procedure CancelUpdate;
    procedure CancelBatch;
    function DetectReadOnly: Boolean;
    function ReadBLOB(FieldIndex, Size: Integer): string;
    procedure ClearBLOB(FieldIndex: Integer);
    procedure WriteBLOB(FieldIndex: Integer; const Value: string);
    procedure AppendBLOB(FieldIndex: Integer; const Value: string);
    function ReadField(FieldIndex, Size: Integer): string;
    procedure ClearField(FieldIndex: Integer);
    procedure WriteField(FieldIndex: Integer; const Value: string);
    procedure AppendField(FieldIndex: Integer; const Value: string);
    procedure FlushField(FieldIndex: Integer);
    {}
    {    (DatabaseAccess);     (Active);
     (SQL);   ,   True (IsReadOnly);
          ,   False
    (IsBatch);  True,        
        Update,      UpdateBatch
     CancelBatch (IsBatchChanged);   (FieldCount);
        Index (Fields);   (FieldTypes); 
    (FieldNames);  ,     
    BLOB- (FieldSizes);     
    (FieldFixed);   FieldName (FieldIndexes)}
    property DatabaseAccess: TCustomDatabaseAccess read FDatabaseAccess;
    property Active: Boolean read FActive write SetActive;
    property SQL: string read FSQL write FSQL;
    property IsReadOnly: Boolean read FIsReadOnly write FIsReadOnly;
    property IsBatch: Boolean read FIsBatch write FIsBatch;
    property IsBatchChanged: Boolean read FIsBatchChanged;
    property FieldCount: Integer read GetFieldCount;
    property Fields[Index: Integer]: Variant read GetField write SetField;
    property FieldTypes[Index: Integer]: TVarBaseType read GetFieldType;
    property FieldNames[Index: Integer]: string read GetFieldName;
    property FieldSizes[Index: Integer]: Integer read GetFieldSize;
    property FieldFixed[Index: Integer]: Boolean read GetFieldFixed;
    property BLOBFields[Index: Integer]: Variant
      read GetBLOBField write SetBLOBField;
    property FieldIndexes[const FieldName: string]: Integer read GetFieldIndex;
    {  (Names);   (Types);      
    FieldName,    BLOB- (FieldsByName); 
          FieldIndex,   0, 
      BLOB- (FieldsByIndex);    
    (LastFieldIndex)}
    property Names: TIndexedStrings read GetNames;
    property Types: TList read GetTypes;
    property FieldsByName[const FieldName: string]: Variant
      read GetFieldByName write SetFieldByName; default;
    property FieldsByIndex[FieldIndex: Integer]: Variant
      read GetFieldByIndex write SetFieldByIndex;
    property LastFieldIndex: Integer read FLastFieldIndex;
    { GetTickCount     ,   ,
     0 (OpenTicks); ,     
      (OpenMilliseconds)}
    property OpenTicks: DWORD read FOpenTicks;
    property OpenMilliseconds: Integer read FOpenMilliseconds;
    {}
    {COM-   , ,   (COM); 
    COM- (COMInterface);  COM-   
    (COMProperties);  ,   COM- (COMAliases);
      ,   Unassigned,   COM-
    (COMValues);   COM- (COMIndex)}
    property COM: Variant read FCOM write FCOM;
    property COMInterface: string read FCOMInterface write FCOMInterface;
    property COMProperties: TStringList read GetCOMProperties;
    property COMAliases: TStringList read GetCOMAliases;
    property COMValues: TVariants read GetCOMValues;
    property COMIndex: Integer read FCOMIndex write FCOMIndex;
  end;
  {}
  {    SQL: esmIgnoreErrors -  ,
  esmNoTransactions -   , esmNoAutoCommit - 
      ,      }
  TExecSQLsMode = set of (esmIgnoreErrors, esmNoTransactions, esmNoAutoCommit);
  { : itPrimaryKey -  , itUnique -  ,
  itIndex - }
  TIndexType = (itPrimaryKey, itUnique, itIndex);
  {   }
  TDatabaseAccessSettings = record
    Size: Integer;              { }
    Database: PChar;            { , : '', 'INTERBASE'  'ISO'}
    ConnectionTimeout: Integer; { , 0 - }
    CommandTimeout: Integer;    { , 0 - }
    Login: PChar;               {}
    Password: PChar;            {}
    MaxBLOBSize: Integer;       {  BLOB, 0 - }
  end;
  PDatabaseAccessSettings = ^TDatabaseAccessSettings;
  {   ,  }
  TCustomDatabaseAccess = class(TObjectStd)
  private
    FDatabase: string;
    FDatabaseType: TDatabaseType;
    FIsConnectionParamsDefined: Boolean;
    FConnected: Boolean;
    FTransactionCounter: Integer;
    FRecordsets: TIndexedList;
    FRecordset: TRecordsetAccess;
    FIsAutoCommit: Boolean;
    FIsClientCursor: Boolean;
    FEqualMark: string;
    FAltDateFormat: Boolean;
    FSQLEncoding: TEncoding;
    FIsWideBLOBs: Boolean;
    FMaxBLOBSize: Integer;
    FCOM: Variant;
    FFileFieldsPath: string;
    FFileFields: TIndexedStrings;
    FBinLists: TCachedLists;
    FFoundLists: TCachedLists;
    FIndexedColLists: TCachedLists;
    FNotUpdatedLists: TCachedIndexedLists;
    FSQLLists: TCachedStrings;
    FVarLists: TCachedVariants;
    FSchema: TNullStr;
    FTables: TIndexedStrings;
    FColumns: TObjList; {TIndexedStrings}
    FColumnTypes: TObjList; {TIndexedList}
    FColumnsFixed: TObjList; {TIndexedList}
    FColumnsNullable: TObjList; {TIndexedList}
    FColumnSizes: TObjList; {TIndexedList}
    FIndexes: TObjList; {TIndexedStrings}
    FIndexTypes: TObjList; {TIndexedList}
    FIndexesColumns: TObjList; {TObjList, TIndexedStrings}
  protected
    FConnection: Variant;
    FNotOwnConnection: Boolean;
    FConnectionString: string;
    FConnectionTimeout: Integer;
    FCommandTimeout: Integer;
    FLogin: string;
    FPassword: string;
    {}
    function Recordsets: TIndexedList;
    procedure ClearRecordsets;
    procedure AddRecordset(Recordset: TRecordsetaccess);
    procedure RemoveRecordset(Recordset: TRecordsetAccess);
    procedure SetDatabase(const NewDatabase: string);
    function GetDatabaseType: TDatabaseType;
    function GetConnection: Variant;
    procedure SetConnection(const NewConnection: Variant);
    procedure SetConnectionString(const NewConnectionString: string);
    procedure SetConnected(NewConnected: Boolean);
    function GetInTransaction: Boolean;
    procedure SetInTransaction(NewInTransaction: Boolean);
    function GetRecordset: TRecordsetAccess;
    function GetSettings: TDatabaseAccessSettings;
    procedure SetSettings(NewSettings: TDatabaseAccessSettings);
    function GetFileFields: TIndexedStrings;
    function GetSchema: string;
    function GetTables: TIndexedStrings;
    function GetColumns(TableIndex: Integer): TIndexedStrings;
    function GetColumnTypes(TableIndex: Integer): TIndexedList;
    function GetColumnsFixed(TableIndex: Integer): TIndexedList;
    function GetColumnsNullable(TableIndex: Integer): TIndexedList;
    function GetColumnSizes(TableIndex: Integer): TIndexedList;
    function GetIndexes(TableIndex: Integer): TIndexedStrings;
    function GetIndexTypes(TableIndex: Integer): TIndexedList;
    function GetIndexesColumns(TableIndex, Index: Integer): TIndexedStrings;
    {}
    {         
    ,     ,  
    IsConnectionParamsDefined = True}
    procedure RetrieveConnectionParams; virtual;
    {}
    {      Connected (DoSetConnected);
       (DoCreateRecordset);   
       Recordset (DoGetFieldCount);     Index
    (DoGetField);     Index (DoSetField);  
     (DoGetFieldType);  (DoGetFieldName);  
    (DoGetFieldSize);     
    (DoGetFieldFixed);    SQL,  IsReadOnly = True 
     ,  IsBatch = True    
       (DoOpen);  (DoClose); 
    (DoAddNew);  (DoUpdate);   (DoUpdateBatch);
     (DoDelete);   (DoCancelUpdare);  
     (DoCancelBatch); ,    ,
      ,      ,   
            False
    (DoDetectReadOnly); ,     (DoEoF); 
       (DoMoveNext);   BLOB- Size 
    (DoReadBLOB);  BLOB- (DoClearBLOB),   Value
    (DoAppendBLOB)}
    procedure DoSetConnected(Connected: Boolean); virtual; abstract;
    function DoCreateRecordset: TRecordsetAccess; virtual;
    function DoGetFieldCount(Recordset:
      TRecordsetAccess): Integer; virtual; abstract;
    function DoGetField(Recordset: TRecordsetAccess;
      Index: Integer): Variant; virtual; abstract;
    procedure DoSetField(Recordset: TRecordsetAccess; Index: Integer;
      const NewValue: Variant); virtual; abstract;
    function DoGetFieldType(Recordset: TRecordsetAccess;
      Index: Integer): TVarBaseType; virtual; abstract;
    function DoGetFieldName(Recordset: TRecordsetAccess;
      Index: Integer): string; virtual; abstract;
    function DoGetFieldSize(Recordset: TRecordsetAccess;
      Index: Integer): Integer; virtual; abstract;
    function DoGetFieldFixed(Recordset: TRecordsetAccess;
      Index: Integer): Boolean; virtual; abstract;
    procedure DoOpen(Recordset: TRecordsetAccess; const SQL: string;
      IsReadOnly, IsBatch: Boolean); virtual; abstract;
    procedure DoClose(Recordset: TRecordsetAccess); virtual; abstract;
    procedure DoAddNew(Recordset: TRecordsetAccess); virtual; abstract;
    procedure DoUpdate(Recordset: TRecordsetAccess); virtual; abstract;
    procedure DoUpdateBatch(Recordset: TRecordsetAccess); virtual; abstract;
    procedure DoDelete(Recordset: TRecordsetAccess); virtual; abstract;
    procedure DoCancelUpdate(Recordset: TRecordsetAccess); virtual; abstract;
    procedure DoCancelBatch(Recordset: TRecordsetAccess); virtual; abstract;
    function DoDetectReadOnly(Recordset: TRecordsetAccess): Boolean;
      virtual; abstract;
    function DoEoF(Recordset: TRecordsetAccess): Boolean; virtual; abstract;
    procedure DoMoveNext(Recordset: TRecordsetAccess); virtual; abstract;
    function DoReadBLOB(Recordset: TRecordsetAccess; FieldIndex,
      Size: Integer): string; virtual; abstract;
    procedure DoClearBLOB(Recordset: TRecordsetAccess;
      FieldIndex: Integer); virtual; abstract;
    procedure DoAppendBLOB(Recordset: TRecordsetAccess; FieldIndex: Integer;
      const Value: string); virtual; abstract;
    {}
    {  ReadTable, WriteTable, ExecSQL, ExecSQLs}
    procedure DoReadTable(const SQL: string; Table: TIndexedVariantsList;
      FirstRow, LastRow: Integer; ReadTableEvent: TReadTableEvent;
      FieldNames: TIndexedStrings; FieldTypes: TList); virtual;
    function DoWriteTable(const SQL: string; Table: TIndexedVariantsList;
      Mode: TDatabaseWriteMode; WriteTableEvent: TWriteTableEvent;
      FieldNames: TIndexedStrings; FieldTypes: TList; ErrorClass: TClass;
      ErrorRows: TList; const Errors: TExceptionsInfoLists;
      IsBatch: Boolean): Integer; virtual;
    function DoExecSQL(const SQL: string): Integer; virtual; abstract;
    {}
    {  BeginTrans, CommitTrans, RollbackTrans   
       }
    procedure DoBeginTrans; virtual;
    procedure DoCommitTrans; virtual;
    procedure DoRollbackTrans; virtual;
    {}
    {    (DoGetSchema);    Schema
        Tables (DoGetTables);   
    (DoGetTableColumns);    (DoGetTableIndexes)}
    function DoGetSchema: string; virtual;
    procedure DoGetTables(const Schema: string; Tables: TIndexedStrings);
      virtual;
    procedure DoGetTableColumns(const Schema, Table: string;
      Columns: TIndexedStrings; ColumnTypes, ColumnsFixed, ColumnsNullable,
      ColumnSizes: TIndexedList); virtual;
    procedure DoGetTableIndexes(const Schema, Table: string;
      Indexes: TIndexedStrings; IndexTypes: TIndexedList {TIndexType};
      IndexesColumns: TObjList {TIndexedStrings}); virtual;
    {}
    {   ,     
    dtUndefined}
    function DoDetectDatabaseType: TDatabaseType; virtual;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { ,    Null  Connection, 
     ConnectionString  }
    procedure Reset; virtual;
    {}
    {  ,     
      (Connect);   ,   
       Recordset (Disconnect)}
    procedure Connect;
    procedure Disconnect;
    {}
    {  True,      
    ,   ,      
      ,     
    RetrieveConnectionParams   True}
    function CanConnect: Boolean; virtual;
    {       , 
      ,    IsReadOnly = True,
    SQL = '' (ObtainRecordset),    ObtainRecordset  
           SQL    
    (OpenReadRecordset),    ObtainRecordset   
          SQL     ,
     IsBatch  True     
    (OpenWriteRecordset)}
    function ObtainRecordset: TRecordsetAccess;
    function OpenReadRecordset(const SQL: string): TRecordsetAccess;
    function OpenWriteRecordset(const SQL: string;
      IsBatch: Boolean): TRecordsetAccess;
    {  SQL,     
      ,       
    ,  IfOnly = True     
     ,    Unassigned,  Unassigned
     ,  SQL      
      }
    function SQLToVar(const SQL: string; IfOnly: Boolean): Variant;
    {}
    {    SQL    Table, 
      FirstRow  LastRow,   0,  FirstRow  
     ,  LastRow   -  , 
        ReadTableEvent,   nil, 
    FieldNames,   nil,   ,  FieldTypes, 
     nil,     (ReadTable); 
        SQL   Table   Mode, 
     dwmNotDelete   dwmNotCheckExist  Mode ,
      ,      Table,   ,
         , 
        WriteTableEvent,   nil, 
    FieldNames,   nil,   ,  FieldTypes, 
     nil,    ,   ErrorClass
        ,    
     ,       Errors,
          ErrorRows,   nil,
     IsBatch  True      
      (WriteTable);   SQL, 
     ,  ,     deadlock
           
    ,      ,
       CommandTimeout ,   
     30 ,    ,  AltDateFormat  False  
         'conver'  'mismatch', 
    SQL- SQLAltDateFormat,   , AltDateFormat 
     True (ExecSQL);      ,  
    RetrieveConnectionParams,    ,  DoReadTable,
    DoWriteTable, DoExecSQL}
    procedure ReadTable(const SQL: string; Table: TIndexedVariantsList;
      FirstRow, LastRow: Integer; ReadTableEvent: TReadTableEvent;
      FieldNames: TIndexedStrings; FieldTypes: TList);
    function WriteTable(const SQL: string; Table: TIndexedVariantsList;
      Mode: TDatabaseWriteMode; WriteTableEvent: TWriteTableEvent;
      FieldNames: TIndexedStrings; FieldTypes: TList; ErrorClass: TClass;
      ErrorRows: TList; const Errors: TExceptionsInfoLists;
      IsBatch: Boolean): Integer;
    function ExecSQL(const SQL, SQLAltDateFormat: string): Integer;
    {    SQLs    
    Mode,    esmIgnoreErrors     ErrorMessages,
    MaxErrorCount    ,  
          
    EDatabaseAccessError,  ErrorMessages ,  
    ProcessMessages,  , 'GO'     
    ,        ,
    'BEGIN TRANSACTION', 'START TRANSACTION'  'TRANSACTION' 
    , 'COMMIT'  'COMMIT TRANSACTION' , 'ROLLBACK' 
    'ROLLBACK TRANSACTION' ,   
    ,  'GO'    ,   RecordsAffected,
      nil,   ,  ,
        ProcessMessages   TProgressInfo,
        LastProgress, IsBeg, IsEnd,  :
    Name -  'EXECSQLS',
    Source -  SQLs,
    Info -  ErrorMessages,
    ItemName -   ,
    Progress -   ,
    SubProgress -    SQLs}
    function ExecSQLs(const SQLs: TStream; Mode: TExecSQLsMode;
      ErrorMessages: TStrings; MaxErrorCount: Integer;
      ProcessMessages: TNotifyEventStd; RecordsAffected: PInteger): Integer;
    {  SQL-,    SQL-,
    SQLPrefix   SQL-,    ExecSQL
     SQLPrefixAltDateFormat,  SQLBlocks,   nil,
      SQL-,      
    ' OR ',       
    SQL- ,    SQL-  SQLBlocks
       SQL-,   ,  
    SQL-  SQLBlocksAdditional,   nil,  
      SQLBlocks  SQLBlocksAdditional,   ,
    SentencesInBlock       SQL-,
    ,    ,   RecordsAffected,
      nil,   ,  ,
      ,   ProcessMessages,
      nil,     ProcessMessages  
    TProgressInfo,     LastProgress, IsBeg, IsEnd,
     :
    Name -  'EXECSQLBLOCKS',
    ParamStr -  SQLPrefix,
    SubParamStr -  SQLPrefixAltDateFormat,
    Source -  SQLBlocks,
    Info -  SQLBlocksAdditional,
    ItemName -   ,
    Progress -   }
    function ExecSQLBlocks(const SQLPrefix, SQLPrefixAltDateFormat: string;
      SQLBlocks, SQLBlocksAdditional: TStrings; SentencesInBlock: Integer;
      ProcessMessages: TNotifyEventStd; RecordsAffected: PInteger): Integer;
    { ,   SQL   TableName,
      ,      ParseSQL,  
    SQL-  CommandType, KeyFields   4- 
      ,    ,   
          , SQLDivider 
     SQL-, , 'GO',     SQL-
     ';', LineLength     ,
       FirstRow  LastRow,   0,  FirstRow 
       ,  LastRow   -  ,
     SQLs  SQL-,      
    ,    SQLDivider,   ,   ,
         SQL-    SQLs
     Prefix,    SQL-,
        ProcessMessages   TProgressInfo,
        LastProgress, IsBeg, IsEnd,  :
    Name -  'EXPORTSQLS',
    ParamNum -  Ord(CommandType),
    ParamStr -  SQL,
    SubParamStr -  Table,
    Destination -  SQLs,
    ItemName -   ,
    MinValue -   ,   FirstRow,    ,
    MaxValue -   , LastRow,    ,
    Progress -      ,
    SubProgress -     SQLs}
    function ExportSQLs(const TableName, SQL: string;
      CommandType: TSQLCommandType; const KeyFields, SQLDivider: string;
      LineLength, FirstRow, LastRow: Integer; const Prefix: string;
      SQLs: TStream; ProcessMessages: TNotifyEventStd): Integer;
    { ,  , ,  dBase,  
           
    ,       ,
    TableName   , ColumnNames     
    , TableCreateSQL     SQL-   
    ,  ';'    'GO', WhereStr  
           , TempTableName
       ,      
       '_TMP',     
      ,    , TempTableCreateSQL 
       SQL-,  ';'    'GO'
       ,    
    TableCreateSQL,      TableName 
     TempTableName}
    procedure PackTable(const TableName, ColumnNames, TableCreateSQL, WhereStr,
      TempTableName, TempTableCreateSQL: string;
      ProcessMessages: TNotifyEventStd); virtual;
    {}
    {  (BeginTrans),    
     (CommitTrans),   (RollbackTrans); 
       -    
    ,          
        ,     True, 
       ,    , 
      False;       , 
      RetrieveConnectionParams,    
    ,         DoBeginTrans,
    DoCommitTrans, DoRollbackTrans      
    }
    function BeginTrans: Boolean;
    function CommitTrans: Boolean;
    function RollbackTrans: Boolean;
    {}
    {     Schema,  Table  Columns,
        ColumnTypes,    
    ColumnsFixed,     Null ColumnsNullable,
       ColumnSizes (TableColumns);  
      Schema,  Table  Indexes,  TIndexType 
     IndexTypes,    IndexesColumns (TableIndexes); 
     ,  ClearSchema = True   , 
     ClearTableIndex  NullInt(True, -1)    ,
       ClearTableIndex,   Null,  
      ,    ClearColumns  True 
       ,  ClearIndexes  True  
       (ClearSchemaCache)}
    procedure TableColumns(const Schema, Table: string;
      Columns: TIndexedStrings; ColumnTypes, ColumnsFixed, ColumnsNullable,
      ColumnSizes: TIndexedList);
    procedure TableIndexes(const Schema, Table: string;
      Indexes: TIndexedStrings; IndexTypes: TIndexedList {TIndexType};
      IndexesColumns: TObjList {TIndexedStrings});
    procedure ClearSchemaCache(ClearSchema: Boolean;
      const ClearTableIndex: TNullInt; ClearColumns, ClearIndexes: Boolean);
    {}
    {      SQL,    
    ,   '-',    IsAutoCommit = False,
    IsClientCursor = False, EqualMark = '=', SQLEncoding = enWindows,
    IsWideBLOBs = False,       'UNIVERSAL'
            
     IsAutoCommit = True, IsClientCursor = True, 
    'INTERBASE'    Interbase- 
    IsAutoCommit = True, IsClientCursor = True, EqualMark = 'STARTING',
     'AUTOCOMMIT'  IsAutoCommit = True,  'NOAUTOCOMMIT'
     IsAutoCommit = False,  'SERVERCURSOR' 
    IsClientCursor = False,  'CLIENTCURSOR' 
    IsClientCursor = True,  'EQUALCOMPARE'  EqualMark = '=',
     'STARTINGCOMPARE'  EqualMark = 'STARTING', 
    'ANSIBLOBS'  IsWideBLOBs = False,  'WIDEBLOBS'
     IsWideBLOBs = True,  'WIN', 'DOS', 'KOI', 'ISO'  'UTF'
      SQLEncoding  StrToEncoding (Database);
    , ,      , 
        ,     
           
    dtUndefined,        
       ,     
      ,    
      DoDetectDatabaseType (DatabaseType); ,
         ,   
      Null,        
           (Connection);  
     ,       (ConnectionString);
       ,   0,    ,
        , , 15   ADO
    (ConnectionTimeout);     ,  0,
       ,     ,
    , 30   ADO (CommandTimeout);     ,
    ,   (Login);     ,
    ,   (Password);   
    BLOB-,   0,    ,
         EDatabaseAccessError (MaxBLOBSize);
     True,     
    (IsConnectionParamsDefined);  True,   
      (Connected);  True,   
    (IsTransaction);   ObtainRecordset  
      ,   ,  ObtainRecordset
    (Recordset);       (Settings);
           
    Recordset,        
     ,       
     ,      ,   
      False,  Database,  'INTERBASE',
     True (IsAutoCommit);    ,
      False,  Database,  'INTERBASE', 
     True (IsClientCursor); ,      
     ,   '=',  'INTERBASE' 
     'STARTING' (EqualMark);   ,
     DateTimeSQLFormats  DateTimeSQLFormatsAlt
    (AltDateFormat); ,    Windows-1251 
    SQL-       ,
      enWindows,     (SQLEncoding); 
     BLOB-    ,   False (IsWideBLOBs);
    COM-   ,     
     TRecordsetAccess, ,   ObtainRecordset,  
       (COM);      
      ,  ,     
      (FileFieldsPath); ,     
     (FileFields)}
    property Database: string read FDatabase write SetDatabase;
    property DatabaseType: TDatabaseType
      read GetDatabaseType write FDatabaseType;
    property Connection: Variant read GetConnection write SetConnection;
    property ConnectionString: string
      read FConnectionString write SetConnectionString;
    property ConnectionTimeout: Integer
      read FConnectionTimeout write FConnectionTimeout;
    property CommandTimeout: Integer
      read FCommandTimeout write FCommandTimeout;
    property Login: string read FLogin write FLogin;
    property Password: string read FPassword write FPassword;
    property MaxBLOBSize: Integer read FMaxBLOBSize write FMaxBLOBSize;
    property IsConnectionParamsDefined: Boolean
      read FIsConnectionParamsDefined;
    property Connected: Boolean read FConnected write SetConnected;
    property InTransaction: Boolean read GetInTransaction
      write SetInTransaction;
    property Recordset: TRecordsetAccess read GetRecordset;
    property Settings: TDatabaseAccessSettings
      read GetSettings write SetSettings;
    property IsAutoCommit: Boolean read FIsAutoCommit write FIsAutoCommit;
    property IsClientCursor: Boolean
      read FIsClientCursor write FIsClientCursor;
    property EqualMark: string read FEqualMark write FEqualMark;
    property AltDateFormat: Boolean read FAltDateFormat write FAltDateFormat;
    property SQLEncoding: TEncoding read FSQLEncoding write FSQLEncoding;
    property IsWideBLOBs: Boolean read FIsWideBLOBs write FIsWideBLOBs;
    property COM: Variant read FCOM write FCOM;
    property FileFieldsPath: string read FFileFieldsPath write FFileFieldsPath;
    property FileFields: TIndexedStrings read GetFileFields;
    {}
    {     (Schema);  (Tables); ,
      ,   ,  
      Null,      TableIndex,
     (Columns, ColumnTypes, ColumnsFixed, ColumnsNullable,
    ColumnSizes); ,  TIndexType ,  
        TableIndex,    Index,
     (Indexes, IndexTypes, IndexesColumns)}
    property Schema: string read GetSchema;
    property Tables: TIndexedStrings read GetTables;
    property Columns[TableIndex: Integer]: TIndexedStrings read GetColumns;
    property ColumnTypes[TableIndex: Integer]: TIndexedList
      read GetColumnTypes;
    property ColumnsFixed[TableIndex: Integer]: TIndexedList
      read GetColumnsFixed;
    property ColumnsNullable[TableIndex: Integer]: TIndexedList
      read GetColumnsNullable;
    property ColumnSizes[TableIndex: Integer]: TIndexedList
      read GetColumnSizes;
    property Indexes[TableIndex: Integer]: TIndexedStrings read GetIndexes;
    property IndexTypes[TableIndex: Integer]: TIndexedList read GetIndexTypes;
    property IndexesColumns[TableIndex, Index: Integer]: TIndexedStrings
      read GetIndexesColumns;
  end;
  {     (TDatabaseAccessMethod); 
       ,  DatabaseNames  
  ,  DatabasesAccess      
  (TDatabasesAccessMethod)}
  TDatabaseAccessMethod = function: TCustomDatabaseAccess of object;
  TDatabasesAccessMethod = procedure(out DatabaseNames: TIndexedStrings;
    out DatabasesAccess: TObjList) of object;
{ True,      DatabaseAccess   nil,
    ,   DatabaseAccess.CanConnect  True}
function DatabaseCanConnect(DatabaseAccess: TCustomDatabaseAccess): Boolean;
{        
TableName  DatabaseAccess   IdField   WhereStr  
 SQL-   'WHERE' - WhereAfter,  
 IdPrefix,    ,  UseUniqueId
     GUID,  GetUniqueId,
   ,  LibGenId}
function GenNextId(DatabaseAccess: TCustomDatabaseAccess; const IdPrefix,
  TableName, IdField, WhereStr, WhereAfter: string;
  UseUniqueId: Boolean): string;
{  Value     VariantParams  StreamIni
 FormatByVariantParams,      Options
      DatabaseAccess  
   TCustomDatabaseAccess.SQLToStr   
   Vars   Name   True, Options  
   ,   - 'IFDEF'  
    Vars  ,    
     , 'IFUNDEF'   
   Vars  ,      
    , 'ALLOWEMPTY'   
 VariantParams   FormatByVariantParams, 'PARAMSPREPARED' 
  SQLStr    SQL-  
FormatByVariantParams  , 'SQL'   SQL-,
'SQLONLY'   SQL-     
          , 
,  StrToRecodeType     
RecodeType (FormatByVariantParamsSQL);  FormatByVariantParamsSQL
  Value  GetStrFromArray    - 
  Vars,  -    FormatByVariantParamsSQL,
 -        VariantParams,
StreamIni   DatabaseAccess,    Vars,
   FormatByVariantParamsSQL   True
(FormatByVariantParamsSQL)}
function FormatByVariantParamsSQL(const Name: string; Vars: TVariantParams;
  const Options, Value: string; VariantParams: TVariantParams;
  StreamIni: TStreamIni; DatabaseAccess: TCustomDatabaseAccess): Boolean;
function FormatStrArrayByVariantParamsSQL(Vars: TVariantParams;
  const Value: string; VariantParams: TVariantParams;
  StreamIni: TStreamIni; DatabaseAccess: TCustomDatabaseAccess): Integer;
{    SourRecordset  DestRecordset,
  Fields,   nil,  IsExclude  False
    Fields,   nil,  IsExclude  True,
   DestRecordset,   SourRecordset, 
 Null,  True,      
 DestRecordset}
function RecordsetCopyValues(SourRecordset, DestRecordset: TRecordsetAccess;
  Fields: TIndexedStrings; IsExclude: Boolean): Boolean;

{ }
type
  TTableState = set of (tasLoaded, tasSaved);
{  }
type
  TTableAccess = class(TObjectStd)
  private
    FDatabaseAccess: TCustomDatabaseAccess;
    FSQL: string;
    FIsBatch: Boolean;
    FTableData: TIndexedVariantsList;
    FState: TTableState;
    FFirstRow: Integer;
    FLastRow: Integer;
    FNoCreate: Boolean;
    FNoDuplicates: Boolean;
    FReadTableEvent: TReadTableEvent;
    FWriteTableEvent: TWriteTableEvent;
    FLoadFieldsInfo: Boolean;
    FFieldNames: TIndexedStrings;
    FFieldTypes: TList;
    FErrorClass: TClass;
    FErrorRows: TList;
    FErrorsCreated: Boolean;
    FErrors: TExceptionsInfoLists;
    FCachedStrings: TCachedStrings;
  protected
    function EmptyFieldNamesOrNil: TIndexedStrings;
    function EmptyFieldTypesOrNil: TList;
    {,  SQL   ,   
     SQL-,     }
    procedure RetrieveSQL(var SQL: string); virtual;
    {}
    function GetSQL: string;
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(ColIndex, RecIndex: Integer): Variant;
    procedure SetItem(ColIndex, RecIndex: Integer; const NewValue: Variant);
    function GetExportStr: string;
    procedure SetExportStr(const NewExportStr: string);
    function GetFieldNames: TIndexedStrings;
    function GetFieldTypes: TList;
    function GetErrorRows: TList;
    function GetErrors: TExceptionsInfoLists;
  public
    {      DatabaseAccess   SQL}
    constructor Create(DatabaseAccess: TCustomDatabaseAccess;
      const SQL: string);
    destructor Destroy; override;
    {}
    {  ,    TableData  
     (Clear);     TableData (Load); , 
     ,     (Loaded);  
    ,    False (LoadFirst); , 
    ,     (LoadedFirst);  
          TableData  (LoadMore);
            TableData ,
    SQLPrefix   SQL-,  SQLBlocks  
    SQL-,       ' OR ',  
         SQL- ,
       SQL-  SQLBlocks   
    SQL-,   SQL-   SQLPostfix,
    SentencesInSQL   SQL-    ,
    ,     (LoadSQLBlocks);  
     TableData  ,  NoCreate    ,
         , 
         (Save); ,  
     ,      (Saved);  Save,
      ,     (SaveLoaded);
        TableData  ,  
      ,  NoDuplicates  
            
        ,    , 
       (Append); ,   ,
         (Appended)}
    procedure Clear; virtual;
    procedure Load;
    procedure Loaded;
    function LoadFirst: Boolean;
    function LoadedFirst: Boolean;
    procedure LoadMore;
    procedure LoadSQLBlocks(const SQLPrefix: string; SQLBlocks: TStrings;
      SQLPostfix: string; SentencesInBlock: Integer);
    function Save: Integer;
    function Saved: Integer;
    function SaveLoaded: Integer;
    function Append: Integer;
    function Appended: Integer;
    {}
    {    (DatabaseAccess);  (SQL);   
       ,   False (IsBatch); 
     (TableData);  (State)}
    property DatabaseAccess: TCustomDatabaseAccess
      read FDatabaseAccess write FDatabaseAccess;
    property SQL: string read GetSQL write FSQL;
    property IsBatch: Boolean read FIsBatch write FIsBatch;
    property TableData: TIndexedVariantsList read FTableData;
    property State: TTableState read FState;
    {       Load,   0, (-1) - 
    ,   (-1) (FirstRow),     
      Load,   0, (-1) -  ,   (-1) (LastRow),
           Save,  
    False (NoCreate),       
    Append,   Append      
        ,   False (NoDuplicates)}
    property FirstRow: Integer read FFirstRow write FFirstRow;
    property LastRow: Integer read FLastRow write FLastRow;
    property NoCreate: Boolean read FNoCreate write FNoCreate;
    property NoDuplicates: Boolean read FNoDuplicates write FNoDuplicates;
    {  (Count);       
    ColIndex,   0,   RecIndex,   0 (Items); 
       ,    ,  ,
             , 
     ,    (ExportStr)}
    property Count: Integer read GetCount write SetCount;
    property Items[ColIndex, RecIndex: Integer]: Variant
      read GetItem write SetItem; default;
    property ExportStr: string read GetExportStr write SetExportStr;
    {}
    {    ,   False (LoadFieldsInfo);
       (FieldNames);    (FieldTypes)}
    property LoadFieldsInfo: Boolean read FLoadFieldsInfo
      write FLoadFieldsInfo;
    property FieldNames: TIndexedStrings read GetFieldNames;
    property FieldTypes: TList read GetFieldTypes;
    {}
    {    (ReadTableEvent)   (WriteTableEvent)}
    property ReadTableEvent: TReadTableEvent
      read FReadTableEvent write FReadTableEvent;
    property WriteTableEvent: TWriteTableEvent
      read FWriteTableEvent write FWriteTableEvent;
    {}
    { ,    , , EOleException
     ADO (ErrorClass);     
       (ErrorRows);    
    (Errors)}
    property ErrorClass: TClass read FErrorClass write FErrorClass;
    property ErrorRows: TList read GetErrorRows;
    property Errors: TExceptionsInfoLists read GetErrors;
  end;

{      }
type
  TMemoryDatabaseAccess = class(TCustomDatabaseAccess)
  private
    FFieldCount: Integer;
    FFieldNames: TIndexedStrings;
    FFieldTypes: TList;
    FFieldValues: TNullVarValues;
    FFieldSizes: TList;
    FFieldFixed: TList;
    FIsEoF: Boolean;
    FAppendFieldIndex: Integer;
    FAppendFieldPosition: Integer;
    FLastRecordset: TRecordsetAccess;
    FLastSQL: string;
    FLastReadOnly: Boolean;
    FLastExecSQL: string;
    FLastExecCount: Integer;
    FOnConnect: TNotifyEventStd;
    FOnDisconnect: TNotifyEventStd;
    FOnOpen: TNotifyEventStd;
    FOnClose: TNotifyEventStd;
    FOnMoveNext: TNotifyEventStd;
    FOnAddNew: TNotifyEventStd;
    FOnUpdate: TNotifyEventStd;
    FOnDelete: TNotifyEventStd;
    FOnCancelUpdate: TNotifyEventStd;
    FOnExecSQL: TNotifyEventStd;
    {}
    function GetFieldCount: Integer;
    procedure SetFieldCount(NewFieldCount: Integer);
    function GetFieldName(Index: Integer): string;
    procedure SetFieldName(Index: Integer; const NewFieldName: string);
    function GetFieldType(Index: Integer): TVarBaseType;
    procedure SetFieldType(Index: Integer; NewFieldType: TVarBaseType);
    function GetFieldSize(Index: Integer): Integer;
    procedure SetFieldSize(Index, NewFieldSize: Integer);
    function GetFieldFixed(Index: Integer): Boolean;
    procedure SetFieldFixed(Index: Integer; NewFieldFixed: Boolean);
    function GetFieldValue(Index: Integer): TNullVarValue;
    procedure SetFieldValue(Index: Integer;
      const NewFieldValue: TNullVarValue);
  protected
    procedure DoSetConnected(Connected: Boolean); override;
    function DoGetFieldCount(Recordset: TRecordsetAccess): Integer; override;
    function DoGetField(Recordset: TRecordsetAccess;
      Index: Integer): Variant; override;
    procedure DoSetField(Recordset: TRecordsetAccess; Index: Integer;
      const NewValue: Variant); override;
    function DoGetFieldType(Recordset: TRecordsetAccess;
      Index: Integer): TVarBaseType; override;
    function DoGetFieldName(Recordset: TRecordsetAccess;
      Index: Integer): string; override;
    function DoGetFieldSize(Recordset: TRecordsetAccess;
      Index: Integer): Integer; override;
    function DoGetFieldFixed(Recordset: TRecordsetAccess;
      Index: Integer): Boolean; override;
    procedure DoOpen(Recordset: TRecordsetAccess;
      const SQL: string; IsReadOnly, IsBatch: Boolean); override;
    procedure DoClose(Recordset: TRecordsetAccess); override;
    procedure DoAddNew(Recordset: TRecordsetAccess); override;
    procedure DoUpdate(Recordset: TRecordsetAccess); override;
    procedure DoUpdateBatch(Recordset: TRecordsetAccess); override;
    procedure DoDelete(Recordset: TRecordsetAccess); override;
    procedure DoCancelUpdate(Recordset: TRecordsetAccess); override;
    procedure DoCancelBatch(Recordset: TRecordsetAccess); override;
    function DoDetectReadOnly(Recordset: TRecordsetAccess): Boolean; override;
    function DoEoF(Recordset: TRecordsetAccess): Boolean; override;
    procedure DoMoveNext(Recordset: TRecordsetAccess); override;
    function DoReadBLOB(Recordset: TRecordsetAccess; FieldIndex,
      Size: Integer): string; override;
    procedure DoClearBLOB(Recordset: TRecordsetAccess;
      FieldIndex: Integer); override;
    procedure DoAppendBLOB(Recordset: TRecordsetAccess; FieldIndex: Integer;
      const Value: string); override;
    {}
    function DoExecSQL(const SQL: string): Integer; override;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (FieldCount); , ,   ,
       ,     Index
    (FieldNames, FieldTypes, FieldSizes, FieldFixed, FieldValues);  
    ,      False (IsEoF); 
            BLOB,   
      (-1),      (AppendFieldIndex);
       ,      , 
        0 (AppendFieldPosition)}
    property FieldCount: Integer read GetFieldCount write SetFieldCount;
    property FieldNames[Index: Integer]: string read GetFieldName
      write SetFieldName;
    property FieldTypes[Index: Integer]: TVarBaseType read GetFieldType
      write SetFieldType;
    property FieldSizes[Index: Integer]: Integer read GetFieldSize
      write SetFieldSize;
    property FieldFixed[Index: Integer]: Boolean read GetFieldFixed
      write SetFieldFixed;
    property FieldValues[Index: Integer]: TNullVarValue read GetFieldValue
      write SetFieldValue;
    property IsEoF: Boolean read FIsEoF write FIsEoF;
    property AppendFieldIndex: Integer
      read FAppendFieldIndex write FAppendFieldIndex;
    property AppendFieldPosition: Integer
      read FAppendFieldPosition write FAppendFieldPosition;
    {      , ,
      ,     (LastRecordset); 
     SQL-      (LastSQL); 
            SQL-
         (LastReadOnly);  SQL-
      (LastExecSQL);  ,  
    SQL-  ,      
    OnExecSQL  0,      
    (LastExecCount)}
    property LastRecordset: TRecordsetAccess
      read FLastRecordset write FLastRecordset;
    property LastSQL: string read FLastSQL write FLastSQL;
    property LastReadOnly: Boolean read FLastReadOnly write FLastReadOnly;
    property LastExecSQL: string read FLastExecSQL write FLastExecSQL;
    property LastExecCount: Integer read FLastExecCount write FLastExecCount;
    {     ,   
     FieldValues,  IsEoF (OnMoveNext);    
     (OnAddNew);        
     FieldValues (OnUpdate);       
     (OnDelete);      
        (OnCancelUpdate);    
    SQL- LastExecSQL,  LastExecCount   
     ,    0 (OnExecSQL)}
    property OnMoveNext: TNotifyEventStd read FOnMoveNext write FOnMoveNext;
    property OnAddNew: TNotifyEventStd read FOnAddNew write FOnAddNew;
    property OnUpdate: TNotifyEventStd read FOnUpdate write FOnUpdate;
    property OnDelete: TNotifyEventStd read FOnDelete write FOnDelete;
    property OnCancelUpdate: TNotifyEventStd
      read FOnCancelUpdate write FOnCancelUpdate;
    property OnExecSQL: TNotifyEventStd read FOnExecSQL write FOnExecSQL;
  end;

{     ADO}
type
  TADODatabaseAccess = class;
  {}
  {  ADO}
  TADORecordsetAccess = class(TRecordsetAccess)
  private
    FRecordset: Variant;
    FIsRecordsetInvalid: Boolean;
  protected
    function GetDatabaseAccess: TADODatabaseAccess;
  public
    { , DatabaseAccess     , Recordset -
         ADO}
    constructor Create(DatabaseAccess: TADODatabaseAccess;
      const Recordset: Variant);
    destructor Destroy; override;
    {}
    {    (DatabaseAccess),     
    ADO (Recordset)}
    property DatabaseAccess: TADODatabaseAccess read GetDatabaseAccess;
    property Recordset: Variant read FRecordset;
  end;
  {}
  {    ADO}
  TADODatabaseAccess = class(TCustomDatabaseAccess)
  private
  protected
    procedure DoSetConnected(Connected: Boolean); override;
    function DoCreateRecordset: TRecordsetAccess; override;
    function DoGetFieldCount(Recordset: TRecordsetAccess): Integer; override;
    function DoGetField(Recordset: TRecordsetAccess;
      Index: Integer): Variant; override;
    procedure DoSetField(Recordset: TRecordsetAccess; Index: Integer;
      const NewValue: Variant); override;
    function DoGetFieldType(Recordset: TRecordsetAccess;
      Index: Integer): TVarBaseType; override;
    function DoGetFieldName(Recordset: TRecordsetAccess;
      Index: Integer): string; override;
    function DoGetFieldSize(Recordset: TRecordsetAccess;
      Index: Integer): Integer; override;
    function DoGetFieldFixed(Recordset: TRecordsetAccess;
      Index: Integer): Boolean; override;
    procedure DoOpen(Recordset: TRecordsetAccess;
      const SQL: string; IsReadOnly, IsBatch: Boolean); override;
    procedure DoClose(Recordset: TRecordsetAccess); override;
    procedure DoAddNew(Recordset: TRecordsetAccess); override;
    procedure DoUpdate(Recordset: TRecordsetAccess); override;
    procedure DoUpdateBatch(Recordset: TRecordsetAccess); override;
    procedure DoDelete(Recordset: TRecordsetAccess); override;
    procedure DoCancelUpdate(Recordset: TRecordsetAccess); override;
    procedure DoCancelBatch(Recordset: TRecordsetAccess); override;
    function DoDetectReadOnly(Recordset: TRecordsetAccess): Boolean; override;
    function DoEoF(Recordset: TRecordsetAccess): Boolean; override;
    procedure DoMoveNext(Recordset: TRecordsetAccess); override;
    function DoReadBLOB(Recordset: TRecordsetAccess; FieldIndex,
      Size: Integer): string; override;
    procedure DoClearBLOB(Recordset: TRecordsetAccess;
      FieldIndex: Integer); override;
    procedure DoAppendBLOB(Recordset: TRecordsetAccess; FieldIndex: Integer;
      const Value: string); override;
    {}
    function DoExecSQL(const SQL: string): Integer; override;
    procedure DoBeginTrans; override;
    procedure DoCommitTrans; override;
    procedure DoRollbackTrans; override;
    {}
    function DoGetSchema: string; override;
    procedure DoGetTables(const Schema: string; Tables: TIndexedStrings);
      override;
    procedure DoGetTableColumns(const Schema, Table: string;
      Columns: TIndexedStrings; ColumnTypes, ColumnsFixed, ColumnsNullable,
      ColumnSizes: TIndexedList); override;
    procedure DoGetTableIndexes(const Schema, Table: string;
      Indexes: TIndexedStrings; IndexTypes: TIndexedList {TIndexType};
      IndexesColumns: TObjList {TIndexedStrings}); override;
    {}
    {         
     ADODatabaseType}
    function DoDetectDatabaseType: TDatabaseType; override;
  public
    { , Connection - ,    Null,
           
         ,   
     , ConnectionString -    }
    constructor Create(const Connection: Variant;
      const ConnectionString: string);
    {}
    function ObtainRecordset: TADORecordsetAccess;
  end;
  {}
  {      COM-}
  TCOMDatabaseAccess = class(TCustomDatabaseAccess)
  private
  protected
    procedure DoSetConnected(Connected: Boolean); override;
    function DoCreateRecordset: TRecordsetAccess; override;
    function DoGetFieldCount(Recordset: TRecordsetAccess): Integer; override;
    function DoGetField(Recordset: TRecordsetAccess;
      Index: Integer): Variant; override;
    procedure DoSetField(Recordset: TRecordsetAccess; Index: Integer;
      const NewValue: Variant); override;
    function DoGetFieldType(Recordset: TRecordsetAccess;
      Index: Integer): TVarBaseType; override;
    function DoGetFieldName(Recordset: TRecordsetAccess;
      Index: Integer): string; override;
    function DoGetFieldSize(Recordset: TRecordsetAccess;
      Index: Integer): Integer; override;
    function DoGetFieldFixed(Recordset: TRecordsetAccess;
      Index: Integer): Boolean; override;
    procedure DoOpen(Recordset: TRecordsetAccess;
      const SQL: string; IsReadOnly, IsBatch: Boolean); override;
    procedure DoClose(Recordset: TRecordsetAccess); override;
    procedure DoAddNew(Recordset: TRecordsetAccess); override;
    procedure DoUpdate(Recordset: TRecordsetAccess); override;
    procedure DoUpdateBatch(Recordset: TRecordsetAccess); override;
    procedure DoDelete(Recordset: TRecordsetAccess); override;
    procedure DoCancelUpdate(Recordset: TRecordsetAccess); override;
    procedure DoCancelBatch(Recordset: TRecordsetAccess); override;
    function DoDetectReadOnly(Recordset: TRecordsetAccess): Boolean; override;
    function DoEoF(Recordset: TRecordsetAccess): Boolean; override;
    procedure DoMoveNext(Recordset: TRecordsetAccess); override;
    function DoReadBLOB(Recordset: TRecordsetAccess; FieldIndex,
      Size: Integer): string; override;
    procedure DoClearBLOB(Recordset: TRecordsetAccess;
      FieldIndex: Integer); override;
    procedure DoAppendBLOB(Recordset: TRecordsetAccess; FieldIndex: Integer;
      const Value: string); override;
    {}
    function DoExecSQL(const SQL: string): Integer; override;
  public
    constructor Create;
  end;
  {}
  {    ADO    COM-}
  TCOMADODatabaseAccess = class(TADODatabaseAccess)
  private
    FCOMDatabase: TCOMDatabaseAccess;
  protected
    function COMDatabase: TCOMDatabaseAccess;
    {}
    function DoCreateRecordset: TRecordsetAccess; override;
    function DoGetFieldCount(Recordset: TRecordsetAccess): Integer; override;
    function DoGetField(Recordset: TRecordsetAccess;
      Index: Integer): Variant; override;
    procedure DoSetField(Recordset: TRecordsetAccess; Index: Integer;
      const NewValue: Variant); override;
    function DoGetFieldType(Recordset: TRecordsetAccess;
      Index: Integer): TVarBaseType; override;
    function DoGetFieldName(Recordset: TRecordsetAccess;
      Index: Integer): string; override;
    function DoGetFieldSize(Recordset: TRecordsetAccess;
      Index: Integer): Integer; override;
    function DoGetFieldFixed(Recordset: TRecordsetAccess;
      Index: Integer): Boolean; override;
    procedure DoOpen(Recordset: TRecordsetAccess;
      const SQL: string; IsReadOnly, IsBatch: Boolean); override;
    procedure DoClose(Recordset: TRecordsetAccess); override;
    procedure DoAddNew(Recordset: TRecordsetAccess); override;
    procedure DoUpdate(Recordset: TRecordsetAccess); override;
    procedure DoUpdateBatch(Recordset: TRecordsetAccess); override;
    procedure DoDelete(Recordset: TRecordsetAccess); override;
    procedure DoCancelUpdate(Recordset: TRecordsetAccess); override;
    procedure DoCancelBatch(Recordset: TRecordsetAccess); override;
    function DoDetectReadOnly(Recordset: TRecordsetAccess): Boolean; override;
    function DoEoF(Recordset: TRecordsetAccess): Boolean; override;
    procedure DoMoveNext(Recordset: TRecordsetAccess); override;
  public
    constructor Create(const Connection: Variant;
      const ConnectionString: string);
    destructor Destroy; override;
  end;

{   SQLTable   SQLWhere   SourDatabase
  DestDatabase,       Table,
  nil,       , 
   (TableCopy);  ,  
 ,      Newest   Step  
SQLTable    SQLDateField,  SQLWhere   Database
(TableOldest);      Oldest,   
     DetectStep,  Newest   Step  
SQLTable    SQLDateField,  SQLWhere   Database,
  EventLog,   nil (TableDelete)}
function TableCopy(SourDatabase, DestDatabase: TCustomDatabaseAccess;
  const SQLTable, SQLWhere: string; Table: TTableAccess;
  IsClear: Boolean): Integer;
function TableOldest(Database: TCustomDatabaseAccess; Newest, Step: TDateTime;
  const SQLTable, SQLDateField, SQLWhere: string): TDateTime;
function TableDelete(Database: TCustomDatabaseAccess; Oldest, Newest,
  Step, DetectStep: TDateTime; const SQLTable, SQLDateField,
  SQLWhere: string; EventLog: TEventLogProc): Integer;

{     ADO ConnectionString,
ParentHandle    ,   
      True,  ConnectionString
   ,   False, 
ConnectionString   (ConnectionStringDlg);   
ADO ConnectionString  UDL- UDLFileName,   
     , , STG_E_PATHNOTFOUND,
STG_E_ACCESSDENIED, STG_E_INVALIDNAME (ConnectionStringToUDL); 
UDL- UDLFileName   ConnectionString,   
     , , STG_E_FILENOTFOUND,
STG_E_INVALIDNAME, STG_E_ACCESSDENIED, STG_E_INVALIDHEADER,  
   (UDLToConnectionString)}
function ConnectionStringDlg(ParentHandle: HWND;
  var ConnectionString: string): Boolean;
function ConnectionStringToUDL(const UDLFileName,
  ConnectionString: string): HRESULT;
function UDLToConnectionString(const UDLFileName: string;
  out ConnectionString: string): HRESULT;



{---  --------------------------------------------------------------------}

{    }
type
  EWinSockError = class(EWinAPIError);
  EWinSockErrorClass = class of EWinSockError;
{       Msg,   
  ,  ,  Windows, SysMsg,  
   ,     ErrorCode
      ProcName,    ,
 WinSockErrorClass,  nil   EWinSockError,
          
  EDLLError   ,  MsgOnly = True 
    Msg}
function WinSockErrorCreate(const Msg, SysMsg: string; ErrorCode: Integer;
  const ProcName: string; WinSockErrorClass: EWinAPIErrorClass;
  MsgOnly: Boolean): EWinAPIError;
{   Host  IP- Address,  Service  
Port,  Data     ,   
  EWinSockError,  
 SocketAPI,      , Timeout 
   , (-1)   }
function SocketConnectSend(SocketAPI: TSocketAPI; const Host, Address,
  Service: string; Port: Integer; const Data: string;
  Timeout: Integer {-1}): string;
{     NTP,   
  EWinSockError,   
SocketAPI,      , HostPort  
  ,     'time.windows.com',
     123, Timeout   
 , (-1)   ,  ,
0  25 ,       0}
function NTPTime(SocketAPI: TSocketAPI; const HostPort: string;
  Timeout: Integer): TDateTime;
{   MAC-,   LanNumbers,   nil,
   LAN,    MACAddresses,   nil, 
 MAC-    LAN}
function MACAddress(LANNumber: TList; MACAddresses: TStrings): string;

{ Simple MAPI}
type
  ESimpleMAPIError = class(ENumProcError)
  private
    FSimpleMAPIErrorMsg: string;
  protected
  public
    {   Simple MAPI}
    property SimpleMAPIErrorMsg: string
      read FSimpleMAPIErrorMsg write FSimpleMAPIErrorMsg;
  end;
  ESimpleMAPIErrorClass = class of ESimpleMAPIError;
{  Simple MAPI   Msg    MAPI, 
  ,    ErrorCode    ProcName,
   ,  MAPIErrorClass,  nil  
EMAPIError,  MsgOnly = True      Msg}
function SimpleMAPIErrorCreate(const Msg: string; ErrorCode: Integer;
  const ProcName: string; SimpleMAPIErrorClass: ESimpleMAPIErrorClass;
  MsgOnly: Boolean): ESimpleMAPIError;
{  E-mail    , 
   ,       
, ParentHandle    , ,
Application.Handle, EmailsTo   E-mail   
 , EmailsCopy   E-mail  ,
EmailsBlindCopy   E-mail   , Subject
  , Body   , AttachFileStrArray 
     GetStrFromArray,  
 True,      False,
     ESimpleMAPIError, 
Simple MAPI,   ,    
   MAPILogOn,       
, 'HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows Messaging Subsystem\
Profiles\DefaultProfile'  'HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows NT\
CurrentVersion\Windows Messaging Subsystem\Profiles\DefaultProfile'}
function SendEMail(ParentHandle: HWND; const EmailsTo, EmailsCopy,
  EmailsBlindCopy, Subject, Body, AttachFileStrArray: string): Boolean;

{    SMTP: smtpsNone -  
  , smtpsConnectWaitingAnswer -   
, smtpsHeloSending -   HELO  EHLO,
smtpsHeloWaitingAnswer -     HELO  EHLO,
smtpsAuthSending -   AUTH, smtpsAuthWaitingAnswer - 
   AUTH, smtpsAuthLoginSending -   ,
smtpsAuthLoginWaitingAnswer -     ,
smtpsAuthPasswordSending -   ,
smtpsAuthPasswordWaitingAnswer -     ,
smtpsMailFromSending -   MAIL FROM, smtpsMailFromWaitingAnswer -
    MAIL FROM, smtpsRcptToSending -  
 RCPT TO, smtpsRcptToWaitingAnswer -    
 RCPT TO, smtpsDataSending -   DATA,
smtpsDataWaitingAnswer -     DATA,
smtpsMessageSending -   , smtpsMessageEndSending - 
  , smtpsMessageWaitingAnswer -  
     , smtpsRsetSending -  
RSET    , smtpsRsetWaitingAnswer -  
  RSET, smtpsQuitSending -   QUIT,
smtpsQuitWaitingAnswer -     QUIT, smtpsFinished -
  }
type
  TSMTPState = (smtpsNone, smtpsConnectWaitingAnswer, smtpsHeloSending,
    smtpsHeloWaitingAnswer, smtpsAuthSending, smtpsAuthWaitingAnswer,
    smtpsAuthLoginSending, smtpsAuthLoginWaitingAnswer,
    smtpsAuthPasswordSending, smtpsAuthPasswordWaitingAnswer,
    smtpsMailFromSending, smtpsMailFromWaitingAnswer, smtpsRcptToSending,
    smtpsRcptToWaitingAnswer, smtpsDataSending, smtpsDataWaitingAnswer,
    smtpsMessageSending, smtpsMessageEndSending, smtpsMessageWaitingAnswer,
    smtpsRsetSending, smtpsRsetWaitingAnswer, smtpsQuitSending,
    smtpsQuitWaitingAnswer, smtpsFinished);
{   SMTP: srmFull -  , srmStatusOnly - 
 ,    , srmDataOnly -  
    ,   
 ,       
}
type
  TSMTPResetMode = (srmFull, srmStatusOnly, srmDataOnly);
{   SMTP      ,
}
type
  TSMTP = class
  private
    FOwnSocketAPI: Boolean;
    FSocketAPI: TSocketAPI;
    FMessageIdx: Integer;
    FState: TSMTPState;
    FStateTicks: DWORD;
    FStateStep: Integer;
    FErrorState: TSMTPState;
    FErrorReply: string;
    FHostName: string;
    FLogin: string;
    FPassword: string;
    FPlainAuth: Boolean;
    FNotLastMessage: Boolean;
    FFromEmail: string;
    FRcptEmails: TStringList;
    FData: string;
    FMsgId: string;
    FMsgEncoding: TEncoding;
    FMsgFromName: string;
    FMsgFromEmail: string;
    FMsgReplyToName: string;
    FMsgReplyToEmail: string;
    FMsgToNames: TStringList;
    FMsgToEmails: TStringList;
    FMsgCCNames: TStringList;
    FMsgCCEmails: TStringList;
    FMsgBCCEmails: TStringList;
    FMsgSubject: string;
    FMsgDate: TDateTime;
    FMsgExtraHeaders: TStringList;
    FMsgText: string;
    FMsgAttachNames: TStringList;
    FMsgAttachBodies: TStringList;
    FOnStateChange: TClientSocketEvent;
    FReadCache: string;
    FReadCachePos: Integer;
    FReadCacheLines: TStringList;
    FMsgLines: TStringList;
  protected
    procedure WhenHostLookupComplete(Sender: TObject; const Address: string;
      ErrorCode: Integer);
    procedure WhenServLookupComplete(Sender: TObject; Port: Word;
      ErrorCode: Integer);
    procedure WhenClientSocketConnect(Sender: TObject; ErrorCode: Integer);
    procedure WhenClientSocketDisconnect(Sender: TObject; ErrorCode: Integer);
    procedure WhenClientSocketRead(Sender: TObject; const Data: string;
      ErrorCode: Integer);
    procedure WhenClientSocketWrite(Sender: TObject; ErrorCode: Integer);
    procedure WhenClientSocketSendCached(Sender: TObject; Sent, Size,
      ErrorCode: Integer);
    procedure StateChange(State: TSMTPState; StateStep, ErrorCode: Integer;
      IsHandleState: Boolean);
    procedure HandleErrorReply(const ErrorReply: string;
      AllowDisconnect: Boolean);
    procedure HandleState(const Reply: string; BeforeAnswer: Boolean);
    {}
    function GetSocketAPI: TSocketAPI;
    procedure SetSocketAPI(NewSocketAPI: TSocketAPI);
    function GetRcptEmails: TStringList;
    function GetMsgToNames: TStringList;
    function GetMsgToEmails: TStringList;
    function GetMsgCCEmails: TStringList;
    function GetMsgCCNames: TStringList;
    function GetMsgBCCEmails: TStringList;
    function GetMsgExtraHeaders: TStringList;
    function GetMsgAttachNames: TStringList;
    function GetMsgAttachBodies: TStringList;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   ,     
      SMTP, Mode     (Reset); 
      Data   FromEmail   RcptEmails,
          
     ,    MsgPrepare (Send);
        Data, FromEmail  RcptEmails  
     MsgFromName, MsgFromEmail, MsgToNames, MsgToEmails, MsgSubject,
    MsgText   (MsgPrepare)}
    procedure Reset(Mode: TSMTPResetMode);
    procedure Send;
    procedure MsgPrepare;
    {}
    {  ,    ,    ,
          (SocketAPI);  ,
      0,   NotLastMessage  True  
    smtpsMessageWaitingAnswer   smtpsRsetSending, 
           (MessageIdx);
     (State);       (StateTicks);
        (ErrorState);  ,  
      ,       (ErrorReply)}
    property SocketAPI: TSocketAPI read GetSocketAPI write SetSocketAPI;
    property MessageIdx: Integer read FMessageIdx;
    property State: TSMTPState read FState;
    property StateTicks: DWORD read FStateTicks;
    property StateStep: Integer read FStateStep;
    property ErrorState: TSMTPState read FErrorState;
    property ErrorReply: string read FErrorReply;
    { ,      
    (HostName); ,       
     (Login); ,      
      (Password);    
     (PlainAuth);    ,   False
    (NotLastMessage); e-mail  (FromEmail); e-mail 
    (RcptEmails);    MIME (Data)}
    property HostName: string read FHostName write FHostName;
    property Login: string read FLogin write FLogin;
    property Password: string read FPassword write FPassword;
    property PlainAuth: Boolean read FPlainAuth write FPlainAuth;
    property NotLastMessage: Boolean
      read FNotLastMessage write FNotLastMessage;
    property FromEmail: string read FFromEmail write FFromEmail;
    property RcptEmails: TStringList read GetRcptEmails;
    property Data: string read FData write FData;
    { ,     (MsgId);
      (MsgEncoding);   (MsgFromName); e-mail
     (MsgFromEmail); ,     
      (MsgReplyToName); e-mail,     
      (MsgReplyToEmail);  (MsgToNames); 
    e-mail  (MsgToEmails);   (MsgCCNames);
     e-mail   (MsgCCEmails); e-mail 
      (MsgBCCEmails);  (MsgSubject); ,  
      (MsgDate);  , , Outlook
    Express   'X-Priority: 3', 'X-MSMail-Priority: Normal',
    'X-Mailer: Microsoft Outlook Express 6.00.2800.1807',
    'X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2800.1896'
    (MsgExtraHeaders);   (MsgText);   
    (MsgAttachNames);    
    (MsgAttachBodies)}
    property MsgId: string read FMsgId write FMsgId;
    property MsgEncoding: TEncoding read FMsgEncoding write FMsgEncoding;
    property MsgFromName: string read FMsgFromName write FMsgFromName;
    property MsgFromEmail: string read FMsgFromEmail write FMsgFromEmail;
    property MsgReplyToName: string read FMsgReplyToName write FMsgReplyToName;
    property MsgReplyToEmail: string
      read FMsgReplyToEmail write FMsgReplyToEmail;
    property MsgToNames: TStringList read GetMsgToNames;
    property MsgToEmails: TStringList read GetMsgToEmails;
    property MsgCCNames: TStringList read GetMsgCCNames;
    property MsgCCEmails: TStringList read GetMsgCCEmails;
    property MsgBCCEmails: TStringList read GetMsgBCCEmails;
    property MsgSubject: string read FMsgSubject write FMsgSubject;
    property MsgDate: TDateTime read FMsgDate write FMsgDate;
    property MsgExtraHeaders: TStringList read GetMsgExtraHeaders;
    property MsgText: string read FMsgText write FMsgText;
    property MsgAttachNames: TStringList read GetMsgAttachNames;
    property MsgAttachBodies: TStringList read GetMsgAttachBodies;
    {,     State,   
      smtpsRsetSending    
        MsgPrepare}
    property OnStateChange: TClientSocketEvent
      read FOnStateChange write FOnStateChange;
  end;
{ SMTP}
type
  ESMTPError = class(ExceptionStd)
  private
    FSourMsg: string;
    FState: TSMTPState;
    FReply: string;
    FIsAuth: Boolean;
  protected
  public
    {  (SourMsg);  (State);  (Reply); 
      (IsAuth)}
    property SourMsg: string read FSourMsg write FSourMsg;
    property State: TSMTPState read FState write FState;
    property Reply: string read FReply write FReply;
    property IsAuth: Boolean read FIsAuth write FIsAuth;
  end;
  ESMTPErrorClass = class of ESMTPError;
{  SMTP    Msg,    
State     Reply,   
IsAuth,   SMTPErrorClass,   nil,  MsgOnly  True
     Msg}
function SMTPErrorCreate(const Msg: string; State: TSMTPState;
  const Reply: string; IsAuth: Boolean; SMTPErrorClass: ESMTPErrorClass;
  MsgOnly: Boolean): ESMTPError;
{   SMTP     
, SocketAPI      ,  
nil  , Login  , Password  ,  
  ,   ,  PlainAuth
 True      , Encoding
 ,  enKOI, Host    IP-
SMTP-,      ,  
  25, Timeout      ,
 (-1)   ,  NotLastMessage 
True   ,       ,
         
     smtpsRsetSending,   
    TSMTP,    
,  MsgPrepare,   NotLastMessage  False
   , OnStateChange,   nil, 
   , Id   ,
   , HostName   ,
      , FromName 
 , FromAddress  e-mail , ReplyToName  ,
      , ReplyToEmail  e-mail,
      , ToName   ,
  , ToEmails   e-mail
,   , CCName   
,   , CCAddress   e-mail
 ,   , BCCAddress  e-mail
  ,   , ExtraHeaders 
 ,   , Subject  ,
Text   , AttachNames    ,
  , AttachBodies,   nil,  
  ,    EWinSockError
 SMTPError}
procedure SendMailAuth(SocketAPI: TSocketAPI; const Login, Password: string;
  PlainAuth: Boolean; Encoding: TEncoding; const Host: string;
  Timeout: Integer; NotLastMessage: Boolean; OnStateChange: TClientSocketEvent;
  const Id, HostName, FromName, FromAddress, ReplyToName, ReplyToAddress,
  ToName, ToAddress, CCName, CCAddress, BCCAddress, ExtraHeaders, Subject,
  Text, AttachNames: string; AttachBodies: TStrings);

{    POP3: pop3sNone -  
  , pop3sConnectWaitingAnswer -   
, pop3sUserSending -   USER, pop3sUserWaitingAnswer -
    USER, pop3sPassSending -   PASS,
pop3sPassWaitingAnswer -     PASS,
pop3sStatSending -   STAT, pop3sStatWaitingAnswer - 
   STAT, pop3sListSending -   LIST,
pop3sListWaitingAnswer -     LIST,
pop3sRetrSending -   RETR, pop3sRetrWaitingAnswer - 
   RETR, pop3sDeleSending -   DELE,
pop3sDeleWaitingAnswer -     DELE,
pop3sQuitSending -   QUIT, pop3sQuitWaitingAnswer - 
   QUIT, pop3sFinished -   }
type
  TPOP3State = (pop3sNone, pop3sConnectWaitingAnswer, pop3sUserSending,
    pop3sUserWaitingAnswer, pop3sPassSending, pop3sPassWaitingAnswer,
    pop3sStatSending, pop3sStatWaitingAnswer, pop3sListSending,
    pop3sListWaitingAnswer, pop3sRetrSending, pop3sRetrWaitingAnswer,
    pop3sDeleSending, pop3sDeleWaitingAnswer, pop3sQuitSending,
    pop3sQuitWaitingAnswer, pop3sFinished);
{   POP3: srmFull -  , srmStatusOnly - 
 ,    , prmMsgOnly -  
 }
type
  TPOP3ResetMode = (prmFull, prmStatusOnly, prmMsgOnly);
{   POP3}
type
  TPOP3 = class
  private
    FOwnSocketAPI: Boolean;
    FSocketAPI: TSocketAPI;
    FMessageIdx: Integer;
    FState: TPOP3State;
    FStateTicks: DWORD;
    FStateStep: Integer;
    FErrorState: TPOP3State;
    FErrorReply: string;
    FLogin: string;
    FPassword: string;
    FTotalOctetSize: Integer;
    FMessageOctetSizes: TList;
    FMsgId: string;
    FMsgEncoding: TEncoding;
    FMsgFromName: string;
    FMsgFromEmail: string;
    FMsgReplyToName: string;
    FMsgReplyToEmail: string;
    FMsgToNames: TStringList;
    FMsgToEmails: TStringList;
    FMsgCCNames: TStringList;
    FMsgCCEmails: TStringList;
    FMsgSubject: string;
    FMsgDate: TDateTime;
    FMsgMIMEVersion: string;
    FMsgPartBoundaryIds: TIndexedStrings;
    FMsgPartBodies: TObjList; {TStringList}
    FMsgContentTypes: TStringList;
    FMsgContentTypeNames: TStringList;
    FMsgContentTypeCharsets: TStringList;
    FMsgContentTypeBoundaries: TStringList;
    FMsgContentTypeExtraFields: TObjList; {TIndexedStrings}
    FMsgContentTypeExtraValues: TObjList; {TStringList}
    FMsgContentTransferEncodings: TStringList;
    FMsgContentTransferEncodingExtraFields: TObjList; {TIndexedStrings}
    FMsgContentTransferEncodingExtraValues: TObjList; {TStringList}
    FMsgContentDispositions: TStringList;
    FMsgContentDispositionFileNames: TStringList;
    FMsgContentDispositionExtraFields: TObjList; {TIndexedStrings}
    FMsgContentDispositionExtraValues: TObjList; {TStringList}
    FMsgContentLengths: TStringList;
    FMsgContentLengthExtraFields: TObjList; {TIndexedStrings}
    FMsgContentLengthExtraValues: TObjList; {TStringList}
    FMsgExtraFields: TObjList; {TIndexedStrings}
    FMsgExtraValues: TObjList; {TStringList}
    FMsgText: string;
    FMsgAttachNames: TIndexedStrings;
    FMsgAttachBodies: TStringList;
    FMsgAttachContentIndexes: TList;
    FOnStateChange: TClientSocketEvent;
    FReadCache: string;
    FReadCachePos: Integer;
    FReadCacheLines: TStringList;
    FMsgBoundaryIds: TStringList;
    FMsgBoundaryIndexes: TList;
  protected
    procedure WhenHostLookupComplete(Sender: TObject; const Address: string;
      ErrorCode: Integer);
    procedure WhenServLookupComplete(Sender: TObject; Port: Word;
      ErrorCode: Integer);
    procedure WhenClientSocketConnect(Sender: TObject; ErrorCode: Integer);
    procedure WhenClientSocketDisconnect(Sender: TObject; ErrorCode: Integer);
    procedure WhenClientSocketRead(Sender: TObject; const Data: string;
      ErrorCode: Integer);
    procedure WhenClientSocketWrite(Sender: TObject; ErrorCode: Integer);
    procedure WhenClientSocketSendCached(Sender: TObject; Sent, Size,
      ErrorCode: Integer);
    procedure StateChange(State: TPOP3State; StateStep, ErrorCode: Integer;
      IsHandleState: Boolean);
    procedure HandleErrorReply(const ErrorReply: string;
      AllowDisconnect: Boolean);
    procedure HandleState(const Reply: string; BeforeAnswer: Boolean);
    {}
    function GetSocketAPI: TSocketAPI;
    procedure SetSocketAPI(NewSocketAPI: TSocketAPI);
    function GetMessageCount: Integer;
    function GetMessageOctetSizes(MessageIdx: Integer): Integer;
    function GetData: string;
    procedure SetData(const NewData: string);
    function GetMsgToNames: TStringList;
    function GetMsgToEmails: TStringList;
    function GetMsgCCEmails: TStringList;
    function GetMsgCCNames: TStringList;
    function GetMsgPartCount: Integer;
    function GetMsgPartBoundaryIds: TIndexedStrings;
    function GetMsgPartBody(PartIdx: Integer): TStringList;
    function GetMsgContentType(PartIdx: Integer): string;
    function GetMsgContentTypeName(PartIdx: Integer): string;
    function GetMsgContentTypeCharset(PartIdx: Integer): string;
    function GetMsgContentTypeBoundary(PartIdx: Integer): string;
    function GetMsgContentTypeExtraFields(PartIdx: Integer): TIndexedStrings;
    function GetMsgContentTypeExtraValues(PartIdx: Integer): TStringList;
    function GetMsgContentTransferEncoding(PartIdx: Integer): string;
    function GetMsgContentTransferEncodingExtraFields(PartIdx: Integer):
      TIndexedStrings;
    function GetMsgContentTransferEncodingExtraValues(PartIdx: Integer):
      TStringList;
    function GetMsgContentDisposition(PartIdx: Integer): string;
    function GetMsgContentDispositionFileName(PartIdx: Integer): string;
    function GetMsgContentDispositionExtraFields(PartIdx: Integer):
      TIndexedStrings;
    function GetMsgContentDispositionExtraValues(PartIdx: Integer):
      TStringList;
    function GetMsgContentLength(PartIdx: Integer): string;
    function GetMsgContentLengthExtraFields(PartIdx: Integer): TIndexedStrings;
    function GetMsgContentLengthExtraValues(PartIdx: Integer): TStringList;
    function GetMsgExtraFields(PartIdx: Integer): TIndexedStrings;
    function GetMsgExtraValues(PartIdx: Integer): TStringList;
    function GetMsgAttachNames: TIndexedStrings;
    function GetMsgAttachBodies: TStringList;
    function GetMsgAttachContentIndexes: TList;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   ,     
      POP3, Mode     (Reset); 
     ,      
      ,    
     pop3sRetrWaitingAnswer     
      MsgParse (Receive);     MsgId,
    MsgEncoding, MsgFromName, MsgFromEmail, MsgToNames, MsgToEmails,
    MsgSubject, MsgText, MsgAttachNames, MsgAttachBodies    ,
      Data (MsgParse)}
    procedure Reset(Mode: TPOP3ResetMode);
    procedure Receive;
    procedure MsgParse;
    {}
    {  ,    ,    ,
          (SocketAPI);  ,
      0,     (-1),   
     ,  pop3sRetrSending (MessageIdx);  (State);
          (StateTicks);   
     (ErrorState);  ,  ,  '-ERR', 
        (ErrorReply)}
    property SocketAPI: TSocketAPI read GetSocketAPI write SetSocketAPI;
    property MessageIdx: Integer read FMessageIdx;
    property State: TPOP3State read FState;
    property StateTicks: DWORD read FStateTicks;
    property StateStep: Integer read FStateStep;
    property ErrorState: TPOP3State read FErrorState;
    property ErrorReply: string read FErrorReply;
    {  (Login);   (Password); 
          (TotalOctetSize); 
     (MessageCount);      MessageIdx
      (MessageOctetSizes);    MIME (Data)}
    property Login: string read FLogin write FLogin;
    property Password: string read FPassword write FPassword;
    property TotalOctetSize: Integer read FTotalOctetSize;
    property MessageCount: Integer read GetMessageCount;
    property MessageOctetSizes[MessageIdx: Integer]: Integer
      read GetMessageOctetSizes;
    property Data: string read GetData write SetData;
    {  (MsgId);     
        (MsgEncoding);  
    (MsgFromName); e-mail  (MsgFromEmail); ,   
        (MsgReplyToName); e-mail,    
       (MsgReplyToEmail);  (MsgToNames);
     e-mail  (MsgToEmails);  
    (MsgCCNames);  e-mail   (MsgCCEmails); 
    (MsgSubject); ,     (MsgDate);  MIME
    ,  '1.0' (MsgMIMEVersion);   ,
      (MsgPartCount);   ,  
        (MsgPartBoundaryIds); 
      PartIdx   (MsgPartBodies); 
        PartIdx (MsgContentTypes);  
       PartIdx (MsgContentTypeNames);   
      PartIdx (MsgContentTypeCharsets);  
      PartIdx (MsgContentTypeBoundaries);   
         PartIdx (MsgContentTypeExtraFields);
            PartIdx
    (MsgContentTypeExtraValues);    
      PartIdx (MsgContentTransferEncodings);   
          PartIdx
    (MsgContentTransferEncodingExtraFields);   
          PartIdx
    (MsgContentTransferEncodingExtraValues);   
       PartIdx (MsgContentDispositions);  
        PartIdx (MsgContentDispositionFileNames);
            
    PartIdx (MsgContentDispositionExtraFields);   
          PartIdx
    (MsgContentDispositionExtraValues);     
    PartIdx (MsgContentLengths);     
       PartIdx (MsgContentLengthExtraFields); 
           PartIdx
    (MsgContentLengthExtraValues);      
    PartIdx (MsgExtraFields);      
    PartIdx (MsgExtraValues);   (MsgText);  
    ,   , , 'ATT00000.htm',
    'ATT00001.rtf' (MsgAttachNames);   
     (MsgAttachBodies);  ,   
    (MsgAttachContentIndexes)}
    property MsgId: string read FMsgId write FMsgId;
    property MsgEncoding: TEncoding read FMsgEncoding write FMsgEncoding;
    property MsgFromName: string read FMsgFromName write FMsgFromName;
    property MsgFromEmail: string read FMsgFromEmail write FMsgFromEmail;
    property MsgReplyToName: string read FMsgReplyToName write FMsgReplyToName;
    property MsgReplyToEmail: string
      read FMsgReplyToEmail write FMsgReplyToEmail;
    property MsgToNames: TStringList read GetMsgToNames;
    property MsgToEmails: TStringList read GetMsgToEmails;
    property MsgCCNames: TStringList read GetMsgCCNames;
    property MsgCCEmails: TStringList read GetMsgCCEmails;
    property MsgSubject: string read FMsgSubject write FMsgSubject;
    property MsgDate: TDateTime read FMsgDate write FMsgDate;
    property MsgMIMEVersion: string read FMsgMIMEVersion write FMsgMIMEVersion;
    property MsgPartCount: Integer read GetMsgPartCount;
    property MsgPartBoundaryIds: TIndexedStrings read GetMsgPartBoundaryIds;
    property MsgPartBodies[PartIdx: Integer]: TStringList read GetMsgPartBody;
    property MsgContentTypes[PartIdx: Integer]: string read GetMsgContentType;
    property MsgContentTypeNames[PartIdx: Integer]: string
      read GetMsgContentTypeName;
    property MsgContentTypeCharsets[PartIdx: Integer]: string
      read GetMsgContentTypeCharset;
    property MsgContentTypeBoundaries[PartIdx: Integer]: string
      read GetMsgContentTypeBoundary;
    property MsgContentTypeExtraFields[PartIdx: Integer]: TIndexedStrings
      read GetMsgContentTypeExtraFields;
    property MsgContentTypeExtraValues[PartIdx: Integer]: TStringList
      read GetMsgContentTypeExtraValues;
    property MsgContentTransferEncodings[PartIdx: Integer]: string
      read GetMsgContentTransferEncoding;
    property MsgContentTransferEncodingExtraFields[PartIdx: Integer]:
      TIndexedStrings read GetMsgContentTransferEncodingExtraFields;
    property MsgContentTransferEncodingExtraValues[PartIdx: Integer]:
      TStringList read GetMsgContentTransferEncodingExtraValues;
    property MsgContentDispositions[PartIdx: Integer]: string
      read GetMsgContentDisposition;
    property MsgContentDispositionFileNames[PartIdx: Integer]: string
      read GetMsgContentDispositionFileName;
    property MsgContentDispositionExtraFields[PartIdx: Integer]:
      TIndexedStrings read GetMsgContentDispositionExtraFields;
    property MsgContentDispositionExtraValues[PartIdx: Integer]: TStringList
      read GetMsgContentDispositionExtraValues;
    property MsgContentLengths[PartIdx: Integer]: string
      read GetMsgContentLength;
    property MsgContentLengthExtraFields[PartIdx: Integer]: TIndexedStrings
      read GetMsgContentLengthExtraFields;
    property MsgContentLengthExtraValues[PartIdx: Integer]: TStringList
      read GetMsgContentLengthExtraValues;
    property MsgExtraFields[PartIdx: Integer]: TIndexedStrings
      read GetMsgExtraFields;
    property MsgExtraValues[PartIdx: Integer]: TStringList
      read GetMsgExtraValues;
    property MsgText: string read FMsgText write FMsgText;
    property MsgAttachNames: TIndexedStrings read GetMsgAttachNames;
    property MsgAttachBodies: TStringList read GetMsgAttachBodies;
    property MsgAttachContentIndexes: TList read GetMsgAttachContentIndexes;
    {,     State,   
      pop3sRetrWaitingAnswer   MsgParse  
    }
    property OnStateChange: TClientSocketEvent
      read FOnStateChange write FOnStateChange;
  end;
{ POP3}
type
  EPOP3Error = class(ExceptionStd)
  private
    FSourMsg: string;
    FState: TPOP3State;
    FReply: string;
  protected
  public
    {  (SourMsg);  (State);  (Reply)}
    property SourMsg: string read FSourMsg write FSourMsg;
    property State: TPOP3State read FState write FState;
    property Reply: string read FReply write FReply;
  end;
  EPOP3ErrorClass = class of EPOP3Error;
{  POP3    Msg,    
State     Reply,   POP3ErrorClass,
  nil,  MsgOnly  True      Msg}
function POP3ErrorCreate(const Msg: string; State: TPOP3State;
  const Reply: string; POP3ErrorClass: EPOP3ErrorClass;
  MsgOnly: Boolean): EPOP3Error;
{   SMTP      , SocketAPI
     ,   nil  , Login
 , Password  , Host    IP-
POP3-,      ,  
  110, Timeout      ,
 (-1)   , OnStateChange,   nil, 
   ,     
  TPOP3,     
 pop3sRetrWaitingAnswer     
  MsgParse,    EWinSockError  POP3Error}
procedure ReceiveMailAuth(SocketAPI: TSocketAPI; const Login, Password,
  Host: string; Timeout: Integer; OnStateChange: TClientSocketEvent);



{--- Web- ------------------------------------------------------------}

{       }
type
  TWinInetStatusInfo = record
    StatusError: string; {  ,    }
    StatusCode: Integer; {  }
    StatusMsg: string;   {   }
  end;
{    }
type
  EWinInetError = class(EWinAPIError)
  private
    FStatusInfo: TWinInetStatusInfo;
  protected
  public
    {   }
    property StatusInfo: TWinInetStatusInfo read FStatusInfo write FStatusInfo;
  end;
  EWinInetErrorClass = class of EWinInetError;
{   Value (InitWinInetStatusInfo);  
          , 
  , StatusError,    StatusCode,
    StatusMsg (WinInetStatusInfo)}
procedure InitWinInetStatusInfo(out Value: TWinInetStatusInfo);
function WinInetStatusInfo(const StatusError: string; StatusCode: Integer;
  const StatusMsg: string): TWinInetStatusInfo;
function InternetServiceTypeToService(InternetServiceType:
  TInternetServiceType): Integer;
{     Msg,    
 ,   StatusError,   
StatusMsg,    ,  ProcName,
 WinInetErrorClass,  nil   EWinInetError,
 MsgOnly = True      Msg, Dict  
,      ,  ,
          ,  
  Unassigned (WinInetErrorCreate)}
function WinInetErrorCreate(const Msg: string; ErrorCode: Integer;
  const StatusError, StatusMsg: string; const ProcName: string;
  WinInetErrorClass: EWinInetErrorClass; MsgOnly: Boolean;
  const Dict: Variant): EWinInetError;
{    }
type
  EJSProxyError = class(EWinAPIError);
{ WinInet API}
type
  TWinInetAPI = class(TObjectStd)
  private
    FProc: TFarProc;
    FLastError: Integer;
    FWinInetDLL: TDLLLoadInfo;
    FJSProxyDLL: TDLLLoadInfo;
    FInternetGetConnectedState: TDLLProcInfo;
    FInternetGoOnline: TDLLProcInfo;
    FInternetGoOnlineA: TDLLProcInfo;
    FInternetAttemptConnect: TDLLProcInfo;
    FInternetOpen: TDLLProcInfo;
    FInternetCloseHandle: TDLLProcInfo;
    FInternetGetLastResponseInfo: TDLLProcInfo;
    FInternetConnect: TDLLProcInfo;
    FInternetQueryOption: TDLLProcInfo;
    FInternetSetOption: TDLLProcInfo;
    FInternetErrorDlg: TDLLProcInfo;
    FInternetReadFile: TDLLProcInfo;
    FInternetWriteFile: TDLLProcInfo;
    FInternetGetProxyInfo: TDLLProcInfo;
    FHttpOpenRequest: TDLLProcInfo;
    FHttpAddRequestHeaders: TDLLProcInfo;
    FHttpSendRequest: TDLLProcInfo;
    FHttpSendRequestEx: TDLLProcInfo;
    FHttpEndRequest: TDLLProcInfo;
    FHttpQueryInfo: TDLLProcInfo;
    FFindFirstUrlCacheEntry: TDLLProcInfo;
    FFindNextUrlCacheEntry: TDLLProcInfo;
    FDeleteUrlCacheEntry: TDLLProcInfo;
    FStatusCode503ServiceUnavailError: string;
    FDict: Variant;
  protected
    function LoadWinInetProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    function LoadJSProxyProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    procedure DownloadProcessMessagesHandler(Sender: TObject);
    procedure DownloadShowModalHandler(Sender: TObject);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   WinInet}
    function InternetGetConnectedState(out Flags: DWORD): Boolean;
    function InternetGoOnline(const URL: string; ParentWindow: HWND;
      Flags: DWORD): BOOL;
    function InternetAttemptConnect(Reserved: DWORD;
      HandleError: Boolean): DWORD;
    function InternetOpen(const BrowserAgent: string; AccessType: DWORD;
      const Proxy, ProxyBypass: string; Flags: DWORD): THInternet;
    procedure InternetCloseHandle(InetHandle: THInternet);
    function InternetGetLastResponseInfo(out Error: DWORD): string;
    function InternetConnect(InetHandle: THInternet;
      const ServerName: string; ServerPort: Integer; const UserName,
      Password: string; Service, Flags, Context: DWORD;
      ErrorOnEmptyServerName: Boolean): THInternet;
    function InternetQueryOption(InetHandle: THInternet;
      Option: DWORD): TSizedBufInfo;
    procedure InternetSetOption(InetHandle: THInternet; Option: DWORD;
      Buffer: Pointer; BufferLength: DWORD);
    function InternetErrorDlg(Wnd: HWND; Request: THInternet; Error,
      Flags: DWORD; Data: Pointer): DWORD {ERROR_SUCCESS, ERROR_CANCELLED,
      ERROR_INTERNET_FORCE_RETRY};
    function InternetReadFile(FileRequestHandle: THInternet;
      NumberOfBytesToRead: Integer): string;
    function InternetWriteFile(FileRequestHandle: THInternet; Buf: Pointer;
      Len: Integer; ExceptIfWrittenNotEqualSend: Boolean): Integer;
    function InternetGetProxyInfo(const Url, Host: string): string;
    function HttpOpenRequest(ConnectHandle: THInternet; const Verb,
      ObjectNameLink, HTTPVersion, ReferrerLink: string;
      AcceptMediaTypes: Pointer {PLPSTR}; Flags, Context: DWORD): THInternet;
    procedure HttpAddRequestHeaders(RequestHandle: THInternet;
      const Headers: string; Modifiers: DWORD);
    procedure HttpSendRequest(RequestHandle: THInternet; const Headers,
      OptionalDataParams: string);
    { Internet Explorer 4.0+}
    procedure HttpSendRequestEx(RequestHandle: THInternet; BuffersIn,
      BuffersOut: PInternetBuffers; Flags, Context: DWORD);
    { Internet Explorer 4.0+}
    procedure HttpEndRequest(RequestHandle: THInternet;
      BuffersOut: PInternetBuffers; Flags, Context: DWORD);
    function HttpQueryInfo(RequestHandle: THInternet; InfoLevel: DWORD;
      HeaderIndex: PDWORD): string;
    { Internet Explorer 3.0+}
    function FindFirstUrlCacheEntry(const UrlSearchPattern: string;
      out EnumHandle: THandle): TSizedBufInfo {TInternetCacheEntryInfo};
    { Internet Explorer 3.0+}
    function FindNextUrlCacheEntry(EnumHandle: THandle): TSizedBufInfo
      {TInternetCacheEntryInfo};
    { Internet Explorer 3.0+}
    function DeleteUrlCacheEntry(const UrlName: string;
      IgnoreErrors: Boolean): Boolean;
    {}
    {    Msg,  ErrorCode, 
     ProcName,   ,  ERROR_INTERNET_EXTENDED_ERROR,
       ,  
    InternetGetLastResponseInfo (ErrorCreate);    
           RequestHandle,
     ExceptOnError = True      HTTP_OK 
          
    EWinInetError    (QueryStatusCode)}
    function ErrorCreate(const Msg: string; ErrorCode: Integer;
      const ProcName: string): EWinInetError;
    function QueryStatusCode(RequestHandle: THInternet;
      ExceptOnError: Boolean): TWinInetStatusInfo;
    {}
    {  }
    function ProxyInfo: TProxyInfo;
    {  Data  ,    
    FileRequestHandle,        
      BlockSize,    ,  
     BlockSize       ,
     AllowDialogs = True   , ,
     , ParentHandle    ,
     ClientCertRetreive,  ,    
     ,      InetHandle
       Caller,  ,   nil, 
     ,  NoErrorDialog  True  
      , ,   ,
       , Caller   , 
      ProcessMessages,     ProcessMessages
      TProgressInfo,    
    LastProgress, IsBeg, IsEnd,
     :
    Sender -    ,
    Receiver -  Caller,
    Name - 'INETSEND',
    ParamNum -     ,   BlockSize,
    Data -    FileRequestHandle,
    Step - 0 -  , 1 -    ,
    2 -    , 3 -    , 4 - 
     ,
    MaxValue -     ,
    Progress -   }
    procedure SendRequest(FileRequestHandle: THInternet; const Data: string;
      BlockSize: Integer; AllowDialogs: Boolean; ParentHandle: HWND;
      Caller: TObject; ProcessMessages: TNotifyEventStd;
      ClientCertRetrieve: TCertContextRetrieveEvent; NoErrorDialog: Boolean);
    {   ,   InternetReadFile, 
      FileRequestHandle,     
     BlockSize ,    , 
      ,  CheckSize  True   
    ,        
     ,  ResStream   nil  
      Stream,   ,  
     ProcessMessages,     ProcessMessages 
     TProgressInfo,     LastProgress, IsBeg,
    IsEnd,  :
    Sender -     ,
    Receiver -  Caller,
    Name - 'INETRECV',
    ParamNum -     ,   BlockSize,
    Data -    FileRequestHandle,
    Step - 0 -   ,    , 1 - 
      ,
    MaxValue -     ,  , 
        (-1),
    Progress -   }
    function RetrieveAnswer(FileRequestHandle: THInternet; BlockSize: Integer;
      ProcessMessages: TNotifyEventStd; CheckSize: Boolean;
      ResStream: TStream; Caller: TObject): string;
    { Link - ://[[:]@][:][/][?] -
       -  ,   ,
      Data,  'POST',   SendRequest, 
     ,     RetrieveAnswer,  
       ,   HTTP_OK, 
      EWinInetError,    , 
      ,     BlockSize,
           ,
      Login  Password      ,
    ,       
          Link,  AllowDialogs = True
          ,  
    , ParentHandle    , ContentType
       ,   ,
      ictUndefined      ,
      ictURLEncoded     
       URLEncoded,  ClientCertRetrieve,  ,
         ,  
      Caller,  ,   nil, 
     , Method    ,  
       'POST',  CheckSize = True  
     ,        
     ,  ResStream   nil  
      ResStream,   , Timeout  
       ,   0  
     ,  NoErrorDialog = True     ,
    ,   ,    , Proxy
      ,  ,  Null, 
      ,   
    ProcessMessages,     ProcessMessages  
    TProgressInfo,     LastProgress, IsBeg, IsEnd,
     :
    Sender -    ,
    Receiver -  Caller,
    Name - 'INETPOST',
    ParamNum -     ,   BlockSize,
    ParamStr -   Link,
    Step - 0 -  , 1 -      Internet,
    2 -    , 3 -    ,
    4 -    , 5 -   ,
    6 -      , 7 -  
      , 8 -   , 9 -  
        , 10 -   
        Internet}
    function Post(const Link, Data: string; BlockSize: Integer;
      var Login, Password: string; AllowDialogs: Boolean; ParentHandle: HWND;
      Caller: TObject; ContentType: TInternetContentType; ProcessMessages:
      TNotifyEventStd; ClientCertRetrieve: TCertContextRetrieveEvent;
      const Method: string; CheckSize: Boolean; ResStream: TStream;
      Timeout: DWORD; NoErrorDialog: Boolean; const Proxy: TNullStr): string;
    {   ,      Link,
     'GET',  AllowDialogs = True   ,
    ParentHandle    ,  
          Prefix, 
        ,     CharRange
     CharInRange    NotInRange  True,
            }
    function PostExtract(const Link: string; AllowDialogs: Boolean;
      ParentHandle: HWND; const Prefix, CharRange: string;
      NotInRange: Boolean): string;
    {    Link, BlockSize   ,
           2048 ,
    AllowDialogs = True      
     ,      
    ECanceled, Title     ,  
     , ParentHandle   
    ,   ,  ResStream   nil 
       ResStream,   }
    function DownloadDlg(const Link: string; BlockSize: Integer;
      AllowDialogs: Boolean; const Title: string; ParentHandle: HWND;
      ResStream: TStream): string;
    {    Name   Data    Link
     GET, MaxLinkSize    , 
       2048 ,     
    240 ,       "name", 
      Base64     "data",  
    "append"  "1" ,      ,
            ,   
     DateTimeExportSortFormat  ,     
    <_><_>_yyyymmddhhnnss<.> - Uploaded OK,
    AllowDialogs    , ParentHandle 
      ,      
     ,     }
    function UploadByParts(const Link, Name, Data: string;
      MaxLinkSize: Integer; AllowDialogs: Boolean; ParentHandle: HWND): string;
    {}
    {  ,    True,   
            False,
    CacheEntryTypeFlags       
      ,   , , NORMAL_CACHE_ENTRY -
      ,   , COOKIE_CACHE_ENTRY -
    Cookies, URLHISTORY_CACHE_ENTRY -  ,   
      , ExcludeCacheEntryTypeFlags  
           ,   
    ,   ,    }
    function BrowserCacheClear(const CacheEntryTypeFlags,
      ExcludeCacheEntryTypeFlags: string): Boolean;
    {}
    {  Windows API (LastError); ,   
         503 " ",  
         (StatusCode503ServiceUnavailError);
     ,      ,
     ,         
     ,    Unassigned (Dict)}
    property LastError: Integer read FLastError;
    property StatusCode503ServiceUnavailError: string
      read FStatusCode503ServiceUnavailError
      write FStatusCode503ServiceUnavailError;
    property Dict: Variant read FDict write FDict;
  end;
{}
{       Windows API; 
     }
function WinInetAPI: TWinInetAPI;
{    Windows API }
procedure WinInetAPIReset;
{}
{ ,     Microsoft ISA Server,
        ,   
 }
const
  ISAServerBlockSize = 10 * 1024 * 1024;
{ -  DownloadAndRun}
const
  DownloadAndRunMapFilePrefix = 'DWNLRUN_';
{      Link, Name   ,
Ver     ,      
   RegInstallKeyName,     
    RegInstallVerParamPostfix,  
 ,       , 
    ,    UpdateVer  True
       Ver, 
True,      ,   ,  
 ,      -  ,
   DownloadAndRunMapFilePrefix   
 ,    , TempDir   
 ,     GetTmpDir, DestFileName 
  ,       }
function DownloadAndRun(Wnd: HWND; const Link, Name: string;
  const Ver: TProductVer; UpdateVer: Boolean; const TempDir,
  DestFileName: string): Boolean;

{   -      
      ,  
  Params,     ParamPrefix,  
 ,    ParamPrefix   
ExcludeParams,     nil,     
  RemovePrefix,   ,   
AddPrefix,         : 
IsLink -   ,  '&',   
 ,     HTMLl-}
function BuildWebParams(Params: TStringParams; const ParamPrefix: string;
  ExcludeParams: TIndexedStrings; const RemovePrefix, AddPrefix: string;
  IsLink: Boolean): string;

type
  {     }
  TCustomWWWAccess = class(TObjectStd)
  private
    FVars: TVariantParams;
    FOwnsVars: Boolean;
    FFormName: string;
    FRequest: TStringParams;
    FServerVars: TStringParams;
    FIsBinary: Boolean;
    FBinaryParams: TNullStr;
  protected
    {      Vars,
       Vars,      (LoadVars);
          FormName,   
            (FormNameDefine);
         ItemName  FormName, 
    IsDefined     ItemValue,   
    ItemValue,  True,     
    ,        Request, 
     ,  True (ItemOperation);  
    ,       (GetRequest);
       ,     
      (GetServerVars)}
    procedure LoadVars; virtual;
    procedure FormNameDefine(var FormName: string); virtual;
    function ItemOperation(const ItemName: string; var ItemValue: string;
      IsDefine: Boolean): Boolean; virtual;
    function CreateRequest: TStringParams; virtual;
    function CreateServerVars: TStringParams; virtual;
    {}
    function GetVars: TVariantParams;
    procedure SetVars(NewVars: TVariantParams);
    procedure SetFormName(const FormName: string);
    function GetItem(const ItemName: string): string;
    procedure SetItem(const ItemName, ItemValue: string);
    function GetRequest: TStringParams;
    function GetServerVars: TStringParams;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  S,       ,
     False,    Write (Alert);   S,
          ,  False,
       False (Write);   S   
    ,    S   #13#10   Write
    (WriteLn);  ,  IsFull = False -  
     ,       ,
     False,    False (CacheOff); 
    ,       , 
    False,    False (Clear);  ,  
        ,  False,  
     False (Flush);      ,
          ,  False,
       Flush (Stop);    URL,  
        ,  False,  
     False (Redirect);  FieldName   
    AlgName,     'SCOM',   ALG_SIGNALCOM, -
    -,      ,  ,  
    ,   ,   - Null,  
     Unassigned (CertificateField);  IP  
     HTTP_REMOTE_ADDR,     ,  
     REMOTE_ADDR (IP)}
    function Alert(const S: string): Boolean; virtual;
    function Write(const S: string): Boolean; virtual;
    function WriteLn(const S: string): Boolean; virtual;
    function CacheOff(IsFull: Boolean): Boolean; virtual;
    function Clear: Boolean; virtual;
    function Flush: Boolean; virtual;
    function Stop: Boolean; virtual;
    function Redirect(const URL: string): Boolean; virtual;
    function CertificateField(const AlgName, FieldName: string): Variant;
      virtual;
    function IP: string; virtual;
    {}
    {  ,        
           ,  
        (Vars);  ,    
    ,   (FormName);    
    ItemName,         Request
    (Values);   ,     
     (Request);   ,   
       (ServerVars);  ,   False, 
     True        
      :  , ,  ,
       ,  Request,     Write 
    WriteLn     ,   ,
     HTML-       <div> (IsBinary);
         (BinaryParams)}
    property Vars: TVariantParams read GetVars write SetVars;
    property FormName: string read FFormName write SetFormName;
    property Items[const ItemName: string]: string
      read GetItem write SetItem; default;
    property Request: TStringParams read GetRequest;
    property ServerVars: TStringParams read GetServerVars;
    property IsBinary: Boolean read FIsBinary write FIsBinary;
    property BinaryParams: TNullStr read FBinaryParams write FBinaryParams;
  end;
  {  TWWWAccess}
  TWWWAccessMethod = function: TCustomWWWAccess of object;

{   ASP}
type
  TASPAccess = class(TCustomWWWAccess)
  private
    FApplicationObject: Variant;
    FObjectContextObject: Variant;
    FRequestObject: Variant;
    FResponseObject: Variant;
    FServerObject: Variant;
    FSessionObject: Variant;
    FCertificate: TVariantParams;
    FCookies: TStringParams;
    FApplication: TStringParams;
    FBinaryParamBlocks: TStringList;
    FSubjectFields: TStringList;
    FSubjectValues: TStringList;
    FSubjectResults: TStringList;
    FIssuerFields: TStringList;
    FIssuerValues: TStringList;
    FIssuerResults: TStringList;
    FOnBinCertNameToStr: TConvertMethod;
  protected
    {  ASP  Vars['ASPApplication'],
    Vars['ASPObjectContext'], Vars['ASPRequest'], Vars['ASPResponse'],
    Vars['ASPServer'], Vars['ASPSession']   ApplicationObject,
    ObjectContextObject, RequestObject, ResponseObject, ServerObject,
    SessionObject }
    procedure LoadVars; override;
    function CreateRequest: TStringParams; override;
    function CreateServerVars: TStringParams; override;
    {}
    function GetCertificate: TVariantParams;
    function GetCookies: TStringParams;
    function GetApplication: TStringParams;
    function GetSession(const KeyName: string): string;
    procedure SetSession(const KeyName, Value: string);
    procedure SetRequestObject(const NewRequestObject: Variant);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    function Alert(const S: string): Boolean; override;
    function Write(const S: string): Boolean; override;
    function CacheOff(IsFull: Boolean): Boolean; override;
    function Clear: Boolean; override;
    function Flush: Boolean; override;
    function Stop: Boolean; override;
    function Redirect(const URL: string): Boolean; override;
    function CertificateField(const AlgName, FieldName: string): Variant;
      override;
    {  POST,    -  
    (PostParams);   POST ParamName (PostParam)}
    function PostParams: string;
    function PostParam(const ParamName: string): string;
    {}
    {  (Certificate),  Cookies (Cookies),
      (ServerVars),   (Application), 
         KeyName (Session)}
    property Certificate: TVariantParams read GetCertificate;
    property Cookies: TStringParams read GetCookies;
    property Application: TStringParams read GetApplication;
    property Session[const KeyName: string]: string
      read GetSession write SetSession;
    {}
    {   ADO:  (ApplicationObject),  
    (ObjectContextObject),   (RerquestObject), 
     (ResponseObject),  (ServerObject),  (SessionObject)}
    property ApplicationObject: Variant
      read FApplicationObject write FApplicationObject;
    property ObjectContextObject: Variant
      read FObjectContextObject write FObjectContextObject;
    property RequestObject: Variant read FRequestObject write SetRequestObject;
    property ResponseObject: Variant
      read FResponseObject write FResponseObject;
    property ServerObject: Variant read FServerObject write FServerObject;
    property SessionObject: Variant read FSessionObject write FSessionObject;
    {}
    {        
       (OnBinCertNameToStr)}
    property OnBinCertNameToStr: TConvertMethod
      read FOnBinCertNameToStr write FOnBinCertNameToStr;
  end;
{   Params      }
function HTMLFormParams(Params: TStringParams): string;

{   DHTML}
type
  TDHTMLAccess = class(TCustomWWWAccess)
  private
    FWindowObject: Variant;
    FDocumentObject: Variant;
    FFormObject: Variant;
    FIsUserDefinedFormObject: Boolean;
  protected
    {  DHTML  Vars['DHTMWindow'], Vars['DHTMLDocument']
      WindowObject, DocumentObject }
    procedure LoadVars; override;
    procedure FormNameDefine(var FormName: string); override;
    function ItemOperation(const ItemName: string; var ItemValue: string;
      IsDefine: Boolean): Boolean; override;
    {}
    function GetDocumentObject: Variant;
    function GetFormCount: Integer;
    function GetFormObjects(const FormName: string): Variant;
    function GetFormObjectByIndex(FormIndex: Integer): Variant;
    function GetFormItem(const FormObject: Variant;
      const ItemName: string): string;
    procedure SetFormItem(const FormObject: Variant; const ItemName,
      ItemValue: string);
    function GetFormObject: Variant;
    procedure SetFormObject(const NewFormObject: Variant);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  S}
    function Alert(const S: string): Boolean; override;
    {}
    {   DHTML:   (WindowObject),  ,
           (DocumentObject),
         FormName (FormObjects)}
    property WindowObject: Variant
      read FWindowObject write FWindowObject;
    property DocumentObject: Variant
      read GetDocumentObject write FDocumentObject;
    property FormCount: Integer read GetFormCount;
    property FormObjects[const FormName: string]: Variant read GetFormObjects;
    property FormObjectsByIndex[FormIndex: Integer]: Variant
      read GetFormObjectByIndex;
    {    ItemName  FormObject}
    property FormItems[const FormObject: Variant; const ItemName: string]:
      string read GetFormItem write SetFormItem;
    {  ,      
    FormName,      ,    }
    property FormObject: Variant read GetFormObject write SetFormObject;
  end;
{   ItemName  FormObject,  IsDefine  True
     ItemValue,  IsDefine  False
     ItemValue,  
    ,     ,    
,        ,
, <div>,    HTML    HTML,   <br>
  ,  IsBinary  True    
 ,     
 ,        
   ,     , ,
   GetStrFromArray   ,  ,
  ,        ,  
 True,       ,  False}
function HTMLItemDef(const FormObject: Variant; const ItemName: string;
  var ItemValue: string; IsDefine, IsBinary: Boolean): Boolean;

type
  {        
     ,    
  PrefixStr,    ,   LineLen, 
      PrefixLine,    
   PostfixLine,   AssignMark,    
   ValueStr,     
   AssignPrefix,     
  AssignPostfix,      EmptyPrefix, 
   EmptyValue}
  TJSCachedLongStrConfig = record
    PrefixStr: string;
    PostfixStr: string;
    LineLen: Integer;
    PrefixLine: string;
    PostfixLine: string;
    AssignMark: string;
    ValueStr: string;
    AssignPrefix: string;
    AssignPostfix: string;
    EmptyPrefix: string;
    EmptyValue: string;
  end;
{   Value}
procedure InitJSCachedLongStrConfig(out Value: TJSCachedLongStrConfig);
type
  {  -}
  TWebPage = class(TVarFunctions)
  private
    FWWW: TCustomWWWAccess;
    FOwnsWWW: Boolean;
    FIsSelfPageVars: Boolean;
    FPageVars: TVariantParams;
    FDict: Variant;
  protected
    {  TCustomWWWAccess,    
    TDHTMLAccess}
    function CreateWWW: TCustomWWWAccess; virtual;
    {}
    function GetWWW: TCustomWWWAccess;
    procedure SetWWW(NewWWW: TCustomWWWAccess);
    function GetPageVars: TVariantParams;
    procedure SetPageVars(NewPageVars: TVariantParams);
    function GetT(Module, Section, Index: Integer;
      const DefValue: string): string;
    {}
    { ,  WWW <> nil,  WWW.Alert   True
      False,  ,     ,
        FncX, FuncName -  ,   FncX}
    function ErrorHandler(E: TObject; const FuncName: string): Boolean;
      override;
  public
    constructor Create; override;
    destructor Destroy; override;
    {}
    {  ,    VarName,
       ,    Unassigned,  
    ,        
    ,  DefValue}
    function GetVar(const VarName: string; const DefValue: Variant): Variant;
    function VGetVar(const VarName, DefValue: Variant): Variant;
    {   ParamName}
    function Request(const ParamName: string): string;
    function VRequest(const ParamName: Variant): Variant;
    {,    ParamName  ParamValue}
    procedure SetRequest(const ParamName, ParamValue: string);
    function VSetRequest(const ParamName, ParamValue: Variant): Variant;
    {}
    procedure RegisterFncs(ParamCount: Integer; Funcs: TStringParams;
      RegisterInherited: Boolean); override;
    {}
    {   WWW,       (WWW);
          WWW   nil,  
    False (OwnsWWW);    ,   ,
            
    (PageVars);  ,     
    ,  ,        
      ,    Unassigned (Dict); 
         Module,   Section,
     Index,   ,  DefValue}
    property WWW: TCustomWWWAccess read GetWWW write SetWWW;
    property OwnsWWW: Boolean read FOwnsWWW write FOwnsWWW;
    property Vars: TVariantParams read GetVars write SetVars;
    property PageVars: TVariantParams read GetPageVars write SetPageVars;
    property Dict: Variant read FDict write FDict;
    property T[Module, Section, Index: Integer;
      const DefValue: string]: string read GetT;
  end;
  {}
  { -}
  TWebPageClass = class of TWebPage;
  {}
  {  -  }
  TSrvWebPage = class(TWebPage)
  private
    FCachedStrings: TCachedStrings;
    FJSStringCache: TNamedObjList; {TParamValues}
    FJSLongStrConfigRetireved: Boolean;
    FJSLongStrConfig: TJSCachedLongStrConfig;
    FLogonInfoDefined: Boolean;
    FLogonInfo: TLogonInfo;
  protected
    function JSStringCache: TNamedObjList;
    {}
    {  TASPAccess}
    function CreateWWW: TCustomWWWAccess; override;
    {  ,      
      ,     
    '''param1''=''value1'' ''param2''=''value2''',   
      ,      
    GetVar('CommonParams', '')}
    function GetCommonParams: string; virtual;
    {   ,     
     ,  GetStrFromArray,   
     Vars['PublicParams']  PageVars['PublicParams']}
    function GetPublicParams: string; virtual;
    {  Error   ErrorPage,   GoErrorPage,
       ,  IsDone  True 
      ,   False,  
        }
    procedure PageErrorHandler(var Error, ErrorPage: string;
      var IsDone: Boolean); virtual;
    {         
         , 
      PrefixStr = 'StringsAdd("', PostfixStr = '");',
    LineLen = 80, PrefixLine = 'StringsClear();', PostfixLine = 'var ',
    AssignMark = '=', ValueStr = 'DecodeStr(StringsText());StringsClear();',
    AssignPrefix := 'var ', AssignPostfix := ';', EmptyPrefix := 'var ',
    EmptyValue := '"";'      ,
      GetVar('JSClientObject', '')     
    (DefaultJSLongStrConfig);     
           
    ,     GetVar('JSLongStrConfig', '')
      GetStrFromArray,    
    DefaultJSLongStrConfig,      
    (RetrieveJSLongStrConfig)}
    function DefaultJSLongStrConfig: TJSCachedLongStrConfig; virtual;
    function RetrieveJSLongStrConfig: TJSCachedLongStrConfig; virtual;
    {      Subject, 
     Issuer,   SerialNumber,   ,
        '',  OrgId   
    ,  ,    ''}
    function CertLogin(const Subject, Issuer, SerialNumber: string;
      out OrgId: string): string; virtual;
    {}
    {      (LinkCommonParams); 
         (FormCommonParams);  
        (LinkPublicParams, FormPublicParams)}
    function LinkCommonParams: string;
    function FormCommonParams: string;
    function LinkPublicParams: string;
    function FormPublicParams: string;
  public
    constructor Create; override;
    destructor Destroy; override;
    {}
    {  ,      'ul'
     'login'='<>'; 'id'='<>'; 'psw'='<>',
        GetStrFromArray,    Base64,  
         ,   'ul' 
    ,   'login'  'psw', GetVar('AuthMethods', '')
       GetStrFromArray   ,
          , 'PASSWORD' -
      , 'SUBJECTCN' -    'SubjectCN'
    , 'CERTFIELDS' -   'Subject'  'Issuer'
    }
    function LogonInfo: TLogonInfo;
    {     S   JSLongString 
      ParamStr,     CacheName  ,
             S   
       ,     
    ParamStr   ,    S  
      ParamStr  ,  
       Config}
    function JSCachedLongString(const ParamStr, S, CacheName: string;
      const Config: TJSCachedLongStrConfig): string;
    {        
        , 
       GetVar('JSLongStrConfig', '')  
    GetStrFromArray}
    function JSLongStrConfig: TJSCachedLongStrConfig;
    {}
    { ,    2048    
    }
    function LinkStr: string;
    function VLinkStr: Variant;
    {     LinkStr (AddCommonParams); 
       (WriteCommonParams);   
    ,       (AddPublicParams,
    WritePublicParams),    ParamName 
    PageVars['PublicParams']}
    function AddCommonParams(const LinkStr: string): string;
    function VAddCommonParams(const LinkStr: Variant): Variant;
    procedure WriteCommonParams;
    function VWriteCommonParams: Variant;
    function AddPublicParams(const LinkStr: string): string;
    function VAddPublicParams(const LinkStr: Variant): Variant;
    procedure WritePublicParams;
    function VWritePublicParams: Variant;
    procedure RegisterPublicParam(const ParamName: string);
    function VRegisterPublicParam(const ParamName: Variant): Variant;
    {    GetVar('ErrorPage', ''),  
       GetVar('ErrorParam', 'serr'),   
    ,    ,    ,  
     ,     ,   ,
         GetVar('Error', ''),   , 
       }
    procedure GoErrorPage;
    function VGoErrorPage: Variant;
    {TASPAccess.CertificateField   GetVar('AuthAlg', '') 
     FieldName,  TASPAccess.CertificateField  
    'SerialNumber', 'SubjectCN', 'Subject', 'IssuerCN', 'Issuer', 'Certificate'
      ,   GetVar('Demo' + CertField, ''),
     CertField -   ,     ,  
      , CertificateField('CertExists')  True, ,  
      , CertificateField('Demo')  True,   
         GetVar('Demo' + CertField, '')
       GetVar('Demo' + CertField, Null)  }
    function CertificateField(const FieldName: string): Variant;
    function VCertificateField(const FieldName: Variant): Variant;
    { CommonName       'A'..'Z', 'a'..'z',
    '0'..'9', '_',   GetVar('LoginLen', MaxLoginLen) ,
      ,    }
    function ExtractLogin(const CommonName: string): string;
    function VExtractLogin(const CommonName: Variant): Variant;
    {  CommonName  ,  
    ExtractLogin,  PartNum = 0   , 
           ,
       , }
    function ExtractComment(const CommonName: string;
      PartNum: Integer): string;
    function VExtractComment(const CommonName, PartNum: Variant): Variant;
    {ExtractLogin(CertificateField('SubjectCN'))}
    function Login: string;
    function VLogin: Variant;
    {ExtractComment(CertificateField('SubjectCN'), PartNum)}
    function Comment(PartNum: Integer): string;
    function VComment(const PartNum: Variant): Variant;
    {  ,  IsFull = True  
    ,       True}
    function CacheOff(IsFull: Boolean): Boolean;
    function VCacheOff(const IsFull: Variant): Variant;
    {   S   Base64   LineLen ,
      PrefixStr   PostfixStr  }
    function JSLongString(const S, PrefixStr, PostfixStr: string;
      LineLen: Integer): string;
    function VJSLongString(const S, PrefixStr, PostfixStr, LineLen: Variant):
      Variant;
    {   JSCachedLongString    ParamStr
     S,    CacheName  ,
         JSLongStrConfig}
    function JSLongStr(const ParamStr, S, CacheName: string): string;
    function VJSLongStr(const ParamStr, S, CacheName: Variant): Variant;
    {   CacheName,   CacheName   }
    procedure ClearJSStrCache(const CacheName: string);
    function VClearJSStrCache(const CacheName: Variant): Variant;
    {}
    {      ParamCount,
     ,   ,   Procs, 
    ,  ,   Funcs,  
       TObjectVarXXX = function(...) of object, 
    RegisterInherited     }
    procedure RegisterFncs(ParamCount: Integer; Funcs: TStringParams;
      RegisterInherited: Boolean); override;
  end;
  {}
  { -  }
  TSrvWebPageClass = class of TSrvWebPage;



{---      -----------------------------------}

{       FontList (GetFontList);
,        GetStrFromArray
(GetFonts)}
procedure GetFontList(FontList: TStrings);
function GetFonts: string;

{    CodePages,   nil,  InstalledOnly
 True     , 
   ,  MaxCharSizes,   nil, 
    0,  ,  DefaultChars,
  nil,    ,  
, , '?',    ,  
,  LeadBytes,   nil,      12 ,
  5      
 6- ,  UnicodeDefaultChars,   nil,  
  ,      
  ,  CodePageCodes,   nil,   ,
       CodePage, 
 ,    ,  CodePageNames,   nil, 
    ,    
  ,       
 IECodePages     HKEY_CLASSES_ROOT\Mime\Database\,
   , ,
  10000 (1   ) - '10000 (MAC - Roman)',
  10001 (2   ) - '10001 (MAC - Japanese)',
  10002 (2   ) -
'10002 (MAC - Traditional Chinese Big5)',
  10003 (2   ) - '10003 (MAC - Korean)',
  10004 (1   ) - '10004 (MAC - Arabic)',
  10005 (1   ) - '10005 (MAC - Hebrew)',
  10006 (1   ) - '10006 (MAC - Greek I)',
  10007 (1   ) - '10007 (MAC - Cyrillic)',
  10008 (2   ) -
'10008 (MAC - Simplified Chinese GB 2312)',
  10010 (1   ) - '10010 (MAC - Romania)',
  10017 (1   ) - '10017 (MAC - Ukraine)',
  10021 (1   ) - '10021 (MAC - Thai)',
  10029 (1   ) - '10029 (MAC - Latin II)',
  10079 (1   ) - '10079 (MAC - Icelandic)',
  10081 (1   ) - '10081 (MAC - Turkish)',
  10082 (1   ) - '10082 (MAC - Croatia)',
  1026 (1   ) -
'1026  (IBM EBCDIC - Turkish (Latin-5))',
  1047 (1   ) -
'1047  (IBM EBCDIC - Latin-1/Open System)',
  1140 (1   ) -
'1140  (IBM EBCDIC - U.S./Canada (37 + Euro))',
  1141 (1   ) -
'1141  (IBM EBCDIC - Germany (20273 + Euro))',
  1142 (1   ) -
'1142  (IBM EBCDIC - Denmark/Norway (20277 + Euro))',
  1143 (1   ) -
'1143  (IBM EBCDIC - Finland/Sweden (20278 + Euro))',
  1144 (1   ) -
'1144  (IBM EBCDIC - Italy (20280 + Euro))',
  1145 (1   ) -
'1145  (IBM EBCDIC - Latin America/Spain (20284 + Euro))',
  1146 (1   ) -
'1146  (IBM EBCDIC - United Kingdom (20285 + Euro))',
  1147 (1   ) -
'1147  (IBM EBCDIC - France (20297 + Euro))',
  1148 (1   ) -
'1148  (IBM EBCDIC - International (500 + Euro))',
  1149 (1   ) -
'1149  (IBM EBCDIC - Icelandic (20871 + Euro))',
  1250 (1   ) - '1250  (ANSI - Central Europe)',
  1251 (1   ) - '1251  (ANSI - Cyrillic)',
  1252 (1   ) - '1252  (ANSI - Latin I)',
  1253 (1   ) - '1253  (ANSI - Greek)',
  1254 (1   ) - '1254  (ANSI - Turkish)',
  1255 (1   ) - '1255  (ANSI - Hebrew)',
  1256 (1   ) - '1256  (ANSI - Arabic)',
  1257 (1   ) - '1257  (ANSI - Baltic)',
  1258 (1   ) - '1258  (ANSI/OEM - Viet Nam)',
  1361 (2   ) - '1361  (Korean - Johab)',
  20000 (2   ) - '20000 (CNS - Taiwan)',
  20001 (2   ) - '20001 (TCA - Taiwan)',
  20002 (2   ) - '20002 (Eten - Taiwan)',
  20003 (2   ) - '20003 (IBM5550 - Taiwan)',
  20004 (2   ) - '20004 (TeleText - Taiwan)',
  20005 (2   ) - '20005 (Wang - Taiwan)',
  20105 (1   ) -
'20105 (IA5 IRV International Alphabet No.5)',
  20106 (1   ) - '20106 (IA5 German)',
  20107 (1   ) - '20107 (IA5 Swedish)',
  20108 (1   ) - '20108 (IA5 Norwegian)',
  20127 (1   ) - '20127 (US-ASCII)',
  20261 (2   ) - '20261 (T.61)',
  20269 (1   ) -
'20269 (ISO 6937 Non-Spacing Accent)',
  20273 (1   ) - '20273 (IBM EBCDIC - Germany)',
  20277 (1   ) -
'20277 (IBM EBCDIC - Denmark/Norway)',
  20278 (1   ) -
'20278 (IBM EBCDIC - Finland/Sweden)',
  20280 (1   ) - '20280 (IBM EBCDIC - Italy)',
  20284 (1   ) -
'20284 (IBM EBCDIC - Latin America/Spain)',
  20285 (1   ) -
'20285 (IBM EBCDIC - United Kingdom)',
  20290 (1   ) -
'20290 (IBM EBCDIC - Japanese Katakana Extended)',
  20297 (1   ) - '20297 (IBM EBCDIC - France)',
  20420 (1   ) - '20420 (IBM EBCDIC - Arabic)',
  20423 (1   ) - '20423 (IBM EBCDIC - Greek)',
  20424 (1   ) - '20424 (IBM EBCDIC - Hebrew)',
  20833 (1   ) -
'20833 (IBM EBCDIC - Korean Extended)',
  20838 (1   ) - '20838 (IBM EBCDIC - Thai)',
  20866 (1   ) - '20866 (Russian - KOI8)',
  20871 (1   ) - '20871 (IBM EBCDIC - Icelandic)',
  20880 (1   ) -
'20880 (IBM EBCDIC - Cyrillic (Russian))',
  20905 (1   ) - '20905 (IBM EBCDIC - Turkish)',
  20924 (1   ) -
'20924 (IBM EBCDIC - Latin-1/Open System (1047 + Euro))',
  20932,
  20936,
  20949,
  21025 (1   ) -
'21025 (IBM EBCDIC - Cyrillic (Serbian, Bulgarian))',
  21027 (1   ) - '21027 (Ext Alpha Lowercase)',
  21866 (1   ) - '21866 (Ukrainian - KOI8-U)',
  28591 (1   ) - '28591 (ISO 8859-1 Latin I)',
  28592 (1   ) -
'28592 (ISO 8859-2 Central Europe)',
  28593 (1   ) - '28593 (ISO 8859-3 Latin 3)',
  28594 (0   ) - '28594 (ISO 8859-4 Baltic)',
  28595 (1   ) - '28595 (ISO 8859-5 Cyrillic)',
  28596 (1   ) - '28596 (ISO 8859-6 Arabic)',
  28597 (1   ) - '28597 (ISO 8859-7 Greek)',
  28598 (1   ) -
'28598 (ISO 8859-8 Hebrew: Visual Ordering)',
  28599 (1   ) - '28599 (ISO 8859-9 Latin 5)',
  28605 (1   ) - '28605 (ISO 8859-15 Latin 9)',
  37 (1   ) - '37    (IBM EBCDIC - U.S./Canada)',
  38598 (1   ) -
'38598 (ISO 8859-8 Hebrew: Logical Ordering)',
  437 (1   ) - '437   (OEM - United States)',
  500 (1   ) - '500   (IBM EBCDIC - International)',
  51949 (2   ) - '51949 (EUC-Korean)',
  50220,
  50221,
  50222,
  50225,
  50227,
  50229,
  52936,
  57002,
  57003,
  57004,
  57005,
  57006,
  57007,
  57008,
  57009,
  57010,
  57011,
  708 (1   ) - '708   (Arabic - ASMO)',
  720 (1   ) - '720   (Arabic - Transparent ASMO)',
  737 (1   ) - '737   (OEM - Greek 437G)',
  775 (1   ) - '775   (OEM - Baltic)',
  850 (1   ) - '850   (OEM - Multilingual Latin I)',
  852 (1   ) - '852   (OEM - Latin II)',
  855 (0   ) - '855   (OEM - Cyrillic)',
  857 (1   ) - '857   (OEM - Turkish)',
  858 (1   ) -
'858   (OEM - Multilingual Latin I + Euro)',
  860 (1   ) - '860   (OEM - Portuguese)',
  861 (1   ) - '861   (OEM - Icelandic)',
  862 (1   ) - '862   (OEM - Hebrew)',
  863 (1   ) - '863   (OEM - Canadian French)',
  864 (1   ) - '864   (OEM - Arabic)',
  865 (1   ) - '865   (OEM - Nordic)',
  866 (1   ) - '866   (OEM - Russian)',
  869 (1   ) - '869   (OEM - Modern Greek)',
  870 (1   ) -
'870   (IBM EBCDIC - Multilingual/ROECE (Latin-2))',
  874 (1   ) - '874   (ANSI/OEM - Thai)',
  875 (1   ) - '875   (IBM EBCDIC - Modern Greek)',
  932 (2   ) -
'932   (ANSI/OEM - Japanese Shift-JIS)',
  936 (2   ) -
'936   (ANSI/OEM - Simplified Chinese GBK)',
  949 (2   ) - '949   (ANSI/OEM - Korean)',
  950 (2   ) -
'950   (ANSI/OEM - Traditional Chinese Big5)'
  65000 (5   ) - '65000 (UTF-7)'
  65001 (4   ) - '65001 (UTF-8)'}
function SystemCodePages(CodePages: TStrings; InstalledOnly: Boolean;
  MaxCharSizes: TList; DefaultChars, LeadBytes, UnicodeDefaultChars: TStrings;
  CodePageCodes: TList; CodePageNames: TStrings): Integer;
{  ,    Internet Explorer 4
 , Flag        
  MIMECONTF_XXXX,    
 ,         
, LangId      ,
,    MakeLangId, LangId 
 Internet Explorer 5,       0
     ,  Flags,   nil,  
  ,  CodePages,   nil,  
 ,  FamilyCodePages,   nil   ,
           
FixedWidthFonts  ProportionalFonts,     
  CodePages,  Descriptions,   nil,  
 ,    ,  WebCharsets,   nil,
   ,   -,
   MIME    BodyCharsets,  
WebCharsets    ,  HeaderCharsets,
  nil,    ,   
e-mail,    MIME    BodyCharsets,
 BodyCharsets,   nil,    ,
   e-mail,     ,
   HeaderCharsets  BodyCharsets   
      ,  FixedWidthFonts,   nil,
   ,    
   ,  ProportionalFonts,   nil, 
   ,    
   ,  GDICharsets,   nil,  
 Windows,   , ,
  708 ( 1256) - ' (ASMO 708)' -
 'ASMO-708' (  GDI 178),
  720 ( 1256) - ' (DOS)' -
 'DOS-720' (  GDI 178),
  28596 ( 1256) - ' (ISO)' -
 'iso-8859-6' (  GDI 178),
  1256 ( 1256) - ' (Windows)' -
 'windows-1256' (  GDI 178),
  28594 ( 1257) - ' (ISO)' -
 'iso-8859-4' (  GDI 186),
  1257 ( 1257) - ' (Windows)' -
 'windows-1257' (  GDI 186),
  852 ( 1250) - ' (DOS)' -
 'ibm852' (  GDI 238),
  28592 ( 1250) - ' (ISO)' -
 'iso-8859-2' (  GDI 238),
  1250 ( 1250) - ' (Windows)' -
 'windows-1250' (  GDI 238),
  936 ( 936) - '  (GB2312)' -
 'gb2312' (  GDI 134),
  52936 ( 936) - '  (HZ)' -
 'hz-gb-2312' (  GDI 134),
  950 ( 950) - '  (Big5)' -
 'big5' (  GDI 136),
  866 ( 1251) - ' (DOS)' -
 'cp866' (  GDI 204),
  28595 ( 1251) - ' (ISO)' -
 'iso-8859-5' (  GDI 204),
  20866 ( 1251) - ' (KOI8-R)' -
 'koi8-r' (  GDI 204),
  21866 ( 1251) - ' (KOI8-U)' -
 'koi8-ru' (  GDI 204),
  1251 ( 1251) - ' (Windows)' -
 'windows-1251' (  GDI 204),
  28597 ( 1253) - ' (ISO)' -
 'iso-8859-7' (  GDI 161),
  1253 ( 1253) - ' (Windows)' -
 'windows-1253' (  GDI 161),
  862 ( 1255) - ' (DOS)' -
 'DOS-862' (  GDI 177),
  38598 ( 1255) - ' (ISO-Logical)' -
 'iso-8859-8-i' (  GDI 177),
  28598 ( 1255) - ' (ISO-Visual)' -
 'iso-8859-8' (  GDI 177),
  1255 ( 1255) - ' (Windows)' -
 'windows-1255' (  GDI 177),
  50932 ( 932) - ' ()' -
 '_autodetect' (  GDI 128),
  51932 ( 932) - ' (EUC)' -
 'euc-jp' (  GDI 128),
  50220 ( 932) - ' (JIS)' -
 'iso-2022-jp' (  GDI 128),
  50221 ( 932) - ' ( 
 JIS)' -  'csISO2022JP'  '_iso-2022-jp$ESC' ( GDI 128),
  50222 ( 932) - ' ( 
 JIS - SO/SI)' -  'iso-2022-jp'  '_iso-2022-jp$SIO' (GDI 128),
  932 ( 932) - ' (Shift-JIS)' -
 'shift_jis' (  GDI 128),
  949 ( 949) - '' -
 'ks_c_5601-1987' (  GDI 129),
  50949 ( 949) - ' ()' -
 '_autodetect_kr' (  GDI 129),
  51949 ( 949) - ' (EUC)' -
 'euc-kr' (  GDI 129),
  50225 ( 949) - ' (ISO)' -
 'iso-2022-kr' (  GDI 129),
  28593 ( 1254) - ' 3 (ISO)' -
 'iso-8859-3' (  GDI 162),
  874 ( 874) - ' (Windows)' -
 'windows-874' (  GDI 222),
  1254 ( 1254) - ' (Windows)' -
 'iso-8859-9' (  GDI 162),
  1200 ( 1200) - '' -
 'unicode' (  GDI 1),
  1201 ( 1200) - ' (Big-Endian)' -
 'unicodeFFFE' (  GDI 1),
  65000 ( 1200) - ' (UTF-7)' -
 'utf-7' (  GDI 1),
  65001 ( 1200) - ' (UTF-8)' -
 'utf-8' (  GDI 1),
  50000 ( 50000) - '' -
 'x-user-defined' (  GDI 1),
  1258 ( 1258) - ' (Windows)' -
 'windows-1258' (  GDI 163),
  1252 ( 1252) - '' -
 'iso-8859-1' (  GDI 0)}
function IECodePages(Flag: DWORD; LangId: Word; Flags, CodePages,
  FamilyCodePages: TList; Descriptions, WebCharsets, HeaderCharsets,
  BodyCharsets, FixedWidthFonts, ProportionalFonts: TStrings;
  GDICharsets: TList): Integer;
{  ,     
,   SystemCodePages  IECodePages, 
   ,  CodePageStrings  
    ,    CodePageCodes  
       IECodePages 
  ,    }
function CodePages(CodePageStrings: TStrings; MaxCharSizes: TList;
  DefaultChars, LeadBytes, UnicodeDefaultChars: TStrings;
  CodePageCodes: TIndexedList; CodePageNames: TStrings; Flags,
  FamilyCodePages: TList; Descriptions, WebCharsets, HeaderCharsets,
  BodyCharsets, FixedWidthFonts, ProportionalFonts: TStrings;
  GDICharsets: TList): Integer;
{  Value   SourEncoding   DestEncoding,
   Intetnet Explorer 4,    
  ,  Null,   
   GGlbUtil.ChangeEncoding}
function WinChangeCodePage(const Value: string; SourEncoding,
  DestEncoding: Integer): TNullStr;
{  Value,        ,
 DivStr         
    CodePage1    CodePage2,   
True,  False,         
   WebCharset   CodePages  
,    }
function StrToCodePages(const Value, DivStr: string; out CodePage1,
  CodePage2: Integer): Boolean;

{       FileName,  Types,
  nil,   ,  NamedTypes,   nil, 
  ,  Names,   nil,   ,
 IntNames,   nil,    ,  Languages 
,     ,    True}
function EnumResources(const FileName: string; Types: TList; NamedTypes,
  Names: TStrings; IntNames: TList; Languages: TList): Boolean;

{  TProductInfo}
type
  TProductsInfo = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TProductInfo;
    procedure SetItem(Index: Integer; const Value: TProductInfo);
    function GetItemPtr(Index: Integer): PProductInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TProductInfo): Integer;
    procedure Insert(Index: Integer; const Value: TProductInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TProductInfo read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PProductInfo read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
  PProductsInfo = ^TProductsInfo;
{      , 
   ProductNameStrArray    GetStrFromArray, 
    ,      
 VerDetectFileName      
    ,     
     ProductsInfo,   nil,  
     ,     , ,
   ProductNameStrArray      
   ,     
    ProductsInfo,    
     Index,   0,   
        ,
ProductDirMask      ,   
,    }
function UninstallProductInfo(const ProductNameStrArray,
  VerDetectFileName: string; Index: Integer; ProductsInfo: PProductsInfo;
  const ProductDirMask: string): TProductInfo;
{  COM-}
function COMFileName(const ClassName: string): string;
{ COM-, , 'JScript'  'VBScript'}
function COMClassVer(const ClassName: string): TProductVer;
{ COM-, , 'ADODB.Connection' 
'MSScriptControl.ScriptControl'}
function COMVer(const ClassName: string): TProductVer;
{    CplName, 
 Internet Explorer  4.0  ,    OLE,
  CplName     ,
  'FileRun'   , ,
  'FindComputer'    ,
  'FindFiles'    ,
  'Help'  ,
  'MinimizeAll'   ,
  'RefreshMenu'  ,
  'SetTime'    ,
  'ShutdownWindows'    Windows,
  'TrayProperties'    ,
  'UndoMinimizeALL'   ,
  'access.cpl'   .  ,
  'appwiz.cpl'      ,
  'bdeadmin.cpl'   . BDE,  ,
  'cpconfig.cpl'   .   ,
  'desk.cpl'    ,
  'fax.cpl'    ,
  'hdwwiz.cpl'     . ,
  'hotplug.dll'    . ,
  'inetcpl.cpl'     ,
  'input.cpl'     ,
  'intl.cpl'    ,
  'irprops.cpl'     ,
  'joy.cpl'     ,
  'liccpa.cpl'    ,
  'main.cpl'    ,
  'mmsys.cpl'      ,
  'ncpa.cpl'     ,
  'odbccp32.cpl'    ODBC,
  'sticpl.cpl'      ,
  'sysdm.cpl'    ,
  'telephon.cpl'      ,
  'timedate.cpl'      ,
  'wuaucpl.cpl'    . }
procedure ControlPanelRun(const CplName: string);
{       %1    
AppName,         ,
     CLSID ClassId  ,  
        Program Files,
 DirName      AppName   DirName, 
  ,  AppOnly  True   
  ,    CheckExists  True  
  ,     }
function AppShell(const AppName, ClassId, DirName: string;
  AppOnly, CheckExists: Boolean): string;
{   Internet Explorer,  :
'"C:\Program Files\Internet Explorer\IEXPLORE.EXE" "%1"',  AppOnly
 True      ,  
 CheckExists  True     ,  
   (IEShell);   Internet Explorer,
     (IEVer);   Internet
Explorer,   Text      ,
 . http://support.microsoft.com/kb/164539/EN-US/ (IEFriendlyVer)}
function IEShell(AppOnly, CheckExists: Boolean): string;
function IEVer: TProductVer;
function IEFriendlyVer: TProductVer;

{     RunClear  True,
FAR  FarClear  True,  True    }
function AutoCompleteClear(RunClear, FarClear: Boolean): Boolean;
{    FormsClear  True,  
 PasswordsClear  True    URLsClear  True
 Internet Explorer,  True    }
function IEAutoCompleteClear(FormsClear, PasswordsClear,
  URLsClear: Boolean): Boolean;
{    FormsClear  True,  
 PasswordsClear  True,    URLsClear  True,
   SessionClear  True, cookies  CookiesClear  True
 Mozilla FireFox,  True    }
function FFAutoCompleteClear(FormsClear, PasswordsClear, URLsClear,
  SessionClear, CookiesClear: Boolean): Boolean;
{        Internet Explorer,  IsRead
 True   ,  TExtPageSetup.Value 
         , 
         LangId,
 IsRead  False     TExtPageSetup.Value,
  Value,   Null,    Value,
   True   IsWrite,  ,   
  IsWrite,  ,  False,   
  ,      , 
     TExtPageSetup.ExtValue ,  
,    }
function IEPageSetup(const Value: TNullPageSetup;
  IsRead: Boolean): TExtPageSetup;

{  : ptmTerminate -  , ptmClose -
   , ptmCountOnly -  }
type
  TProcessTerminateMode = (ptmTerminate, ptmClose, ptmCountOnly);
{      }
type
  TSpaceInfo = record
    FreeAvailable: LONGLONG; {   }
    TotalSpace: LONGLONG;    { }
    TotalFree: LONGLONG;     {   }
  end;
{  Windows API}
type
  EWindowsAPIError = class(EWinAPIError);
{}
{     ServiceControlCode   
 (ServiceControlCodeToStr),     ServiceCode
   (ServiceStateToStr)}
function ServiceControlCodeToStr(ServiceControlCode: DWORD): string;
function ServiceStateToStr(ServiceState: DWORD): string;
{}
{         }
const
  DefServiceTimeoutMS = 120000;
{ Windows API}
type
  TWindowsAPI = class(TObjectStd)
  private
    FProc: TFarProc;
    FLastError: Integer;
    FAdvAPIDLL: TDLLLoadInfo;
    FKernelDLL: TDLLLoadInfo;
    FNTDLLDLL: TDLLLoadInfo;
    FPSAPIDLL: TDLLLoadInfo;
    FUXThemeDLL: TDLLLoadInfo;
    FGetDiskFreeSpaceEx: TDLLProcInfo;
    FOpenProcessToken: TDLLProcInfo;
    FLookupPrivilegeValue: TDLLProcInfo;
    FAdjustTokenPrivileges: TDLLProcInfo;
    FLogonUser: TDLLProcInfo;
    FCreateProcessAsUser: TDLLProcInfo;
    FZwQuerySystemInformation: TDLLProcInfo;
    FCreateToolhelp32Snapshot: TDLLProcInfo;
    FProcess32First: TDLLProcInfo;
    FProcess32Next: TDLLProcInfo;
    FGetModuleFileNameEx: TDLLProcInfo;
    FEnumProcesses: TDLLProcInfo;
    FOpenThemeData: TDLLProcInfo;
    FCloseThemeData: TDLLProcInfo;
    FDrawThemeBackground: TDLLProcInfo;
    FOpenSCManager: TDLLProcInfo;
    FOpenService: TDLLProcInfo;
    FCloseServiceHandle: TDLLProcInfo;
    FGetServiceDisplayName: TDLLProcInfo;
    FGetServiceKeyName: TDLLProcInfo;
    FStartService: TDLLProcInfo;
    FControlService: TDLLProcInfo;
    FQueryServiceStatus: TDLLProcInfo;
    FQueryServiceConfig: TDLLProcInfo;
    FEnumServicesStatus: TDLLProcInfo;
    FEnumDependentServices: TDLLProcInfo;
    FBeginUpdateResource: TDLLProcInfo;
    FEndUpdateResource: TDLLProcInfo;
    FUpdateResource: TDLLProcInfo;
    FMachineName: string;
    FMsgs: TIndexedList;
    FMsgNames: TIndexedStrings;
    FProcessNamesLoaded: Boolean;
    FProcessNamesNoPathLoaded: Boolean;
    FProcessNames: TIndexedStrings;
    FProcessNamesNoPath: TIndexedStrings;
    FProcessNameList: TStringList;
    FProcessIds: TIndexedList;
    FProcessIdList: TList;
    FSkipSubProcessNames: TStringList;
  protected
    function LoadAdvAPIProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    function LoadKernelProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    function LoadNTDLLProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    function LoadPSAPIProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    function LoadUXThemeProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    {}
    function GetMsgs: TIndexedList;
    function GetMsgNames: TIndexedStrings;
    function GetDiskSpaceInfo(const DirectoryName: string): TSpaceInfo;
    function GetProcessNames: TIndexedStrings;
    function GetProcessNamesNoPath: TIndexedStrings;
    function GetProcessIds: TIndexedList;
    function IsProcess(ProcessIndex: Integer; const ProcessName,
      SkipSubStrArray: string; var Path, Name: TNullStr;
      var SkipSubProcessNamesDefined: Boolean;
      var SkipSubProcessNames: TStringList; IsClear: Boolean): Boolean;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {     }
    function GetDiskFreeSpaceEx(const DirectoryName: string;
      var FreeAvailable, TotalSpace: TLargeInteger;
      TotalFree: PLargeInteger; AllowAlternativeDetect,
      IgnoreError: Boolean): Boolean;
    {}
    {       }
    function OpenProcessToken(ProcessHandle: THandle;
      DesiredAccess: DWORD): THandle;
    function LookupPrivilegeValue(SystemName: string;
      PrivilegeName: PChar): TLargeInteger;
    procedure AdjustTokenPrivileges(TokenHandle: THandle; DisableAllPrivileges:
      Boolean; const NewState: TTokenPrivilegesStd; BufferLength: DWORD;
      PreviousState: PTokenPrivilegesStd; ReturnLength: PDWORD);
    procedure AdjustPrivileges(PrivilegeName: PChar);
    function LogonUser(UserName, Domain, Password: string;
      LogonType, LogonProvider: DWORD): THandle;
    function CreateProcessAsUser(Token: THandle;
      const ApplicationName, CommandLine: string;
      ProcessAttributes: PSecurityAttributes;
      ThreadAttributes: PSecurityAttributes;
      InheritHandles: BOOL; CreationFlags: DWORD; Environment: Pointer;
      const CurrentDirectory: string;
      const StartupInfo: TStartupInfo): TProcessInformation;
    function ZwQuerySystemInformation(SystemInformationClass:
      SYSTEM_INFORMATION_CLASS): string;
    procedure ZwProcessList(ProcessNames: TStrings; ProcessIds: TList);
    function CreateToolhelp32Snapshot(Flags, ProcessId: DWORD): THandle;
    function Process32First(Snapshot: THandle;
      out PE: TProcessEntry32): Boolean;
    function Process32Next(Snapshot: THandle;
      var PE: TProcessEntry32; IgnoreError: Boolean): Boolean;
    procedure SnapshotProcessList(ProcessNames: TStrings; ProcessIds: TList;
      AllowIncludePath: Boolean);
    function GetModuleFileNameEx(Process: THandle; Module: HMODULE;
      IgnoreError: Boolean): string;
    function EnumProcesses: string;
    procedure EnumProcessList(ProcessNames: TStrings; ProcessIds: TList;
      IncludePath: Boolean);
    {}
    {        Windows XP}
    function OpenThemeData(Wnd: HWND; const ClassList: string): HTHEME;
    function CloseThemeData(Theme: HTHEME): HRESULT;
    function DrawThemeBackground(Theme: HTHEME; DC: HDC; PartId,
      StateId: Integer; const Rect: TRect; ClipRect: PRect): HRESULT;
    {}
    {     }
    function OpenSCManager(const MachineName, DatabaseName: string;
      DesiredAccess: DWORD): TSCHandle;
    function OpenService(ManagerHandle: TSCHandle; const ServiceName: string;
      DesiredAccess: DWORD): TSCHandle;
    procedure CloseServiceHandle(Handle: TSCHandle);
    function GetServiceDisplayName(ManagerHandle: TSCHandle;
      const ServiceName: string): string;
    function GetServiceKeyName(ManagerHandle: TSCHandle;
      const DisplayName: string): string;
    procedure StartService(ServiceHandle: TSCHandle;
      NumServiceArgs: DWORD; ServiceArgVectors: Pointer);
    function ControlService(ServiceHandle: TSCHandle;
      Control: DWORD): TServiceStatus;
    function QueryServiceStatus(ServiceHandle: TSCHandle): TServiceStatus;
    function QueryServiceConfig(ServiceHandle: TSCHandle): TServiceConfig;
    function EnumServicesStatus(ManagerHandle: TSCHandle;
      ServiceType, ServiceState: DWORD; ServiceNames, DisplayNames,
      ServiceStatuses: TStrings): Integer;
    function EnumDependentServices(ServiceHandle: TSCHandle;
      ServiceState: DWORD; ServiceNames, DisplayNames,
      ServiceStatuses: TStrings): Integer;
    {}
    {     ,   
          
      ,    }
    function BeginUpdateResource(const FileName: string;
      DeleteExistingResources: Boolean): THandle;
    procedure EndUpdateResource(Update: THandle; Discard: Boolean;
      const FileName: string);
    procedure UpdateResource(Update: THandle; AType, Name: PChar;
      Language: Word; const Data, FileName: string;
      DeleteExistingResources: Boolean);
    {}
    {     :  , 
       ,    
    (SafeQueryServiceConfig);        
     TimeoutMS      ,
        DefServiceTimeoutMS  ,
         ,  WaitOnly  
     ,   ,     ,  
    ,      , 
     ProcessMessagesEvent     ,
       ,   Abort    
       False,  True    ,
     ServiceStatus       
    (TimeoutStartService, TimeoutControlService)}
    function SafeQueryServiceConfig(ServiceHandle: TSCHandle): TServiceConfig;
    function TimeoutStartService(ServiceHandle: TSCHandle;
      NumServiceArgs: DWORD; ServiceArgVectors: Pointer; TimeoutMS: DWORD;
      WaitOnly: Boolean; ProcessMessagesEvent: TNotifyEventStd;
      out ServiceStatus: TServiceStatus): Boolean;
    function TimeoutControlService(ServiceHandle: TSCHandle; Control: DWORD;
      TimeoutMS: DWORD; WaitOnly: Boolean; ProcessMessagesEvent:
      TNotifyEventStd; out ServiceStatus: TServiceStatus): Boolean;
    {}
    {     CmdLine   UserName,
      Domain,  Password,    CmdShow,
     WaitFinished    }
    procedure RunProcessAsUser(const UserName, Domain, Password,
      CmdLine: string; CmdShow: UINT; WaitFinished: Boolean);
    {    ProcessNames,  ,  
     ProcessIds,  ,  AllowIncludePath = True
         ,  Windows NT,
       
    http://www.rsdn.ru/article/qna/baseserv/enumproc.xml}
    procedure ProcessList(ProcessNames: TStrings; ProcessIds: TList;
      AllowIncludePath: Boolean);
    {  ,   ProcessNames, ProcessNamesNoPath
     ProcessIds (ClearProcessList);      ProcessNames
     ProcessIds   ,  ,  ,
       ProcessId (ProcessIdToName);   
      ProcessNames, ProcessNamesNoPath  ProcessIds 
         ProcessName,   ,
     0,      '[System Process]'
    (ProcessNameToId); ,  ,   
    ProcessName,     ,   ,
    SkipSubStrArray     GetStrFromArray,
              
        (ProcessNameToFullName); 
       ProcessName,     
     ProcessNames, ProcessNamesNoPath  ProcessIds , 
         ,  TerminateAll  True
         ,  
    ,    , SkipSubStrArray 
       GetStrFromArray,   
            
      , Mode   
    (TerminateProcessByName);      ProcessName,
       WndClass       WndClass
       ,    WndText  
      WndText   ,  
       0,   ,   
        ProcessIdToName,  Restart  True
      , ,   explorer.exe
    ProcessFindWindow('explorer.exe', 'Progman', '') ->  ,
      ProcessId,   nil,   ,
          
    (ProcessFindWindow);       
    WindowHandle (WindowToProcessName)}
    procedure ClearProcessList;
    function ProcessIdToName(ProcessId: DWORD): string;
    function ProcessNameToId(const ProcessName: string): DWORD;
    function ProcessNameToFullName(const ProcessName,
      SkipSubStrArray: string): string;
    function TerminateProcessByName(const ProcessName: string;
      TerminateAll: Boolean; const SkipSubStrArray: string;
      Mode: TProcessTerminateMode): Integer;
    function ProcessFindWindow(const ProcessName, WndClass,
      WndText: string; Restart: Boolean; ProcessId: PDWORD): HWND;
    function WindowToProcessName(WindowHandle: HWND): string;
    {}
    { True,     
    (ServicesSupported);  True,   ServiceName 
    (ServiceExists);  True,   ServiceName  
        (ServiceRunning);  True,  
    ServiceName  (ServiceStopped);   ServiceName 
     ,   ,    
    , DependentServiceStrArray,    
     GetStrFromArray,      
    TimeoutMS ,    
    DefServiceTimeoutMS,  AllowWaitOnly  True  
     ,      ,  True, 
            ,
       , False,    ,   
                ,
    ProcessMessages,  ,    
      ,      
    Abort  ,       
     Abort (RunService);   ServiceName  
             
    TimeoutMS ,    
    DefServiceTimeoutMS,  AllowWaitOnly  True  
     ,      ,  DependentServiceStrArray
       ,   
      ,  ,      ,
      GetStrFromArray,  True,   
          , False,  
     , ProcessMessages,  ,  
        ,    
      Abort  ,     
       EAbort (StopService);  
    ServiceName, CPU1000MHzTimeoutMS     
          1000 MHz,  AllowWaitOnly
     True    ,     
    ,  RunAlreadyStopped  True   ,
        , ProcessMessages,  , 
         ,  
     True,        
            False}
    function ServicesSupported: Boolean;
    function ServiceExists(const ServiceName: string): Boolean;
    function ServiceRunning(const ServiceName: string): Boolean;
    function ServiceStopped(const ServiceName: string): Boolean;
    function RunService(const ServiceName: string; TimeoutMS: DWORD;
      AllowWaitOnly: Boolean; const DependentServiceStrArray: string;
      ProcessMessages: TNotifyEventStd): Boolean;
    function StopService(const ServiceName: string; TimeoutMS: DWORD;
      AllowWaitOnly: Boolean; out DependentServiceStrArray: string;
      ProcessMessages: TNotifyEventStd): Boolean;
    function RestartService(const ServiceName: string;
      CPU1000MHzTimeoutMS: DWORD; AllowWaitOnly, RunAlreadyStopped: Boolean;
      ProcessMessages: TNotifyEventStd): Boolean;
    {}
    {   Windows Msg   ,  
       DefMsgName,   IsError,  ,
          (MsgToName);   
    Windows MsgName   ,    
     DefMsg,   IsError,  ,     
     (NameToMsg)}
    function MsgToName(Msg: UINT; const DefMsgName: string;
      IsError: PBooleanStd): string;
    function NameToMsg(const MsgName: string; DefMsg: UINT;
      IsError: PBooleanStd): UINT;
    {}
    {  Windows API (LastError);  ,  
       ,    ,
        (MachineName)}
    property LastError: Integer read FLastError;
    property MachineName: string read FMachineName write FMachineName;
    {    Windows (Msgs);   
     Windows (MsgNames)}
    property Msgs: TIndexedList read GetMsgs;
    property MsgNames: TIndexedStrings read GetMsgNames;
    {         
    DirectoryName,       
      }
    property DiskSpaceInfo[const DirectoryName: string]: TSpaceInfo
      read GetDiskSpaceInfo;
    {  ,  ,  ,   
          ClearProcessList
    (ProcessNames);      (ProcessNamesNoPath);
        (ProcessIds)}
    property ProcessNames: TIndexedStrings read GetProcessNames;
    property ProcessNamesNoPath: TIndexedStrings read GetProcessNamesNoPath;
    property ProcessIds: TIndexedList read GetProcessIds;
  end;
{}
{       Windows API, 
     }
function WindowsAPI: TWindowsAPI;
{    Windows API}
procedure WindowsAPIReset;
{}
{         
' | '    ,      
WindowsAPI.ProcessIdToName}
function GetProcessInfo(Value: Pointer): string;

{  }
type
  TComponentServices = class(TObjectStd)
  private
    FCat: Variant;
    FCatMachineName: string;
    FMachineName: string;
  protected
    function Cat(IsConnect: Boolean): Variant;
  public
    constructor Create;
    {}
    { True,     (Supported);
     True,       AppName
    (IsApplicationExists)}
    function Supported: Boolean;
    function IsApplicationExists(const AppName: string): Boolean;
    {  AppName,    
      \ Login,  Passsword,  ,
        ,   
     ComponentStrArray,   GetStrFromArray,
       ,     , , 
     ,      , 
    True,        
    (InstallApplication);   AppName,  False,
         (UninstallApplication)}
    function InstallApplication(const AppName, Login, Password,
      ComponentStrArray: string): Boolean;
    function UninstallApplication(const AppName: string): Boolean;
    {  AppName (RunApplication);  
    AppName (StopApplication)}
    procedure RunApplication(const AppName: string);
    procedure StopApplication(const AppName: string);
    {}
    { ,      ,
       ,    (MachineName)}
    property MachineName: string read FMachineName write FMachineName;
  end;
{}
{        ;
      }
function ComponentServices: TComponentServices;
{     }
procedure ComponentServicesReset;

{  ,  NoWriteConsole  True  
       ,  RaiseExceptions  True
    ,   
 ,     ,   
}
function SrvUtilsRun(NoWriteConsole, RaiseExceptions: Boolean): Boolean;
{      ,    -
      ,   
     ,    
 ,     ,  
  ,    ,   
  ,        ,
   ,      log,  
 ini-  ,      ini,
    ini-
[FILE]
;  ,       
;    
CheckFile1=dbg*.log
[TEXT]
;  ,     
SearchText1=Access violation
[RUN]
; ,       
RunFile=restart.bat
;   ,    ,  
CheckPeriodMS=1000
;       
RunWaitMS=600000
;   ini-  
IniUpdateMS=60000
;            
;  (-1),   
RunTimeMS=86390000
;     
LogFile=TxtCheck.log
[LASTSIZE]
;        , (-1) - }
procedure TxtCheckRun;



{---    -------------------------------------------------}

{    }
type
  EProcessError = class(EWinAPIError);
{ ;   }
function ProcessOpen(const CmdLine: string;
  CmdShow: UINT): TProcessInformation;
{  ;   }
function ProcessWait(const ProcessInformation: TProcessInformation): DWORD;
{  }
procedure ProcessClose(const ProcessInformation: TProcessInformation);
{ ,  WaitFinished = True ,  
 ,    ,    
 ,  ,   ProcessId,   nil, 
 }
function RunProcess(const CmdLine: string; CmdShow: UINT;
  WaitFinished: Boolean; ProcessId: PDWORD): DWORD;
{  FileName     CmdLineParams, 
          ,  WaitWindow = True
   , WaitMilliseconds  
    ,    
 True,      ,  False}
function RunProcessChecked(const FileName, CmdLineParams: string;
  WaitWindow: Boolean; WaitMilliseconds: Integer): Boolean;
{   ;     
TerminateProcess = True}
type
  TIdleProc = procedure(var TerminateProcess: Boolean);
  TIdleMethod = procedure(var TerminateProcess: Boolean) of object;
{      ,  
 ;    ,    
 ;  }
function RunProcessIdle(const CmdLine: string; CmdShow: UINT;
  WaitFinished: Boolean; IdleProc: TIdleProc; IdleMethod: TIdleMethod): DWORD;

{    }
type
  EDocumentError = class(EWinAPIError);
{  DocName   DocParam,    
   , , 'http://www.xxx.com/xxx',
'mailto:xxx@xxx.com', ShowCmd   , ,
SW_SHOWDEFAULT      , SW_HIDE  ,
DefaultDir     (OpenDocumentPrm);  
DocName (OpenDocument);     
    ,    
    ECanceled (SafeOpenDocument)}
procedure OpenDocumentPrm(const DocName, DocParam: string;
  ShowCmd {SW_SHOWDEFAULT}: Integer; const DefaultDir: string);
procedure OpenDocument(const DocName: string);
procedure SafeOpenDocument(const DocName: string);
{    AppName,    
     CLSID ClassId,  ,  
        Program Files,
 DirName      AppName   DirName,
       AppShell, Param
   ,    
     AppName   Param,  
  Param}
procedure OpenDocumentByApp(const AppName, ClassId, DirName, Param: string);
{  Link   Internet Explorer,   
    }
procedure OpenLinkByIE(const Link: string);
{         Link,
   }
procedure SafeReopenLink(const Link: string);
{ bat-:
@copy *.bcw result.tmp
@start /WAIT .\cleartgs.exe
@del /Q *.bcw
@del /Q *.tmp}
procedure ClearTgsRun;

{    DLL}
type
  EDLLError = class(EWinAPIError);
  EDLLLoadError = class(EDLLError);
  EDLLProcError = class(EDLLError);
{ DLL}
function LoadDLL(const FileName: string): HMODULE;
{ DLL}
procedure FreeDLL(Module: HMODULE);
{    DLL}
function GetDLLProc(Module: HMODULE; const ProcName: string): TFarProc;
{  DLLLoadInfo}
procedure InitDLLLoadInfo(out Value: TDLLLoadInfo);
{   (     ,
  );      ,
        
   }
function LoadDLLSafe(const FileName: string;
  var DLLLoadInfo: TDLLLoadInfo): HMODULE;
{  (   )}
procedure FreeDLLSafe(var DLLLoadInfo: TDLLLoadInfo);
{  DLLProcInfo}
procedure InitDLLProcInfo(out Value: TDLLProcInfo);
{   (      ,
  );       ,
        
   }
function GetDLLProcSafe(Module: HMODULE; const ProcName: string;
  var DLLProcInfo: TDLLProcInfo): TFarProc;
{    ;     
 ,      ;  
        
   ;     ,  
   }
function LoadDLLProcSafe(const DLLName, ProcName: string;
  var DLLLoadInfo: TDLLLoadInfo; var DLLProcInfo: TDLLProcInfo): TFarProc;
{    OCX}
type
  EOCXError = class(EDLLError);
{ ActiveX- FileName (RegisterOCX)    
 (UnregisterOCX)}
procedure RegisterOCX(const FileName: string);
procedure UnregisterOCX(const FileName: string);
{    Groups   Index   
        
   ,   'HKEY_',   
 ,    ,     
(StartupGroups);     Entries   Group,
            ,
          , 
  ,  ,    
 ,         
,            
     ,     ,
        ,  
   'Services',     
,  NoSystem  True   ,
           
,           
   ,  ,      'VxDs',
         
    ,   'All'    Groups
  nil     ,   
 GroupIndexes,   nil,    AllCombine  True 
      ,    
      ,   
-       , 
   ,    GroupEntries,   nil,  
 ,  FileNames,   nil,    ,
 FileGroupIndexes,   nil,   ,
 FileEntryIndexes,   nil,   ,
 FileMainFlags,   nil,      
,     
(StartupEntries);       Entries
  Group,     FileNames, 
 Entries,    ,   FileEntryIndexes,
  nil,    ,  StartupEntries,
  'All'   Groups  GroupIndexes   nil 
     GroupIndexes    Groups, 
   FileGroupIndexes,   nil,  
      FileMainFlags,   nil,
 NoSystem  True      , 
(StartupFiles);   EntryName   EntryValue  
 Entry   Group   StartupEntries, 
True    False     (GetStartupEntry);
  EntryValue      EntryName
  EntryIndex   Entries    Group  
StartupEntries,  IsDelete  ,  EntryValue ,
 True    False      ,
          (SetStartupEntry)}
procedure StartupGroups(Groups: TStrings; var Index: Integer);
function StartupEntries(const Group: string; Groups, Entries: TStrings;
  GroupIndexes: TList; NoSystem, AllCombine: Boolean; GroupEntries,
  FileNames: TStrings; FileGroupIndexes, FileEntryIndexes,
  FileMainFlags: TList): Integer;
procedure StartupFiles(const Group: string; Groups: TStrings; GroupIndexes:
  TList; Entries: TStrings; BegIndex, EndIndex: Integer; FileNames: TStrings;
  FileGroupIndexes, FileEntryIndexes, FileMainFlags: TList; NoSystem: Boolean);
function GetStartupEntry(const Group, Entry: string; out EntryName,
  EntryValue: string): Boolean;
function SetStartupEntry(const Group: string; Entries: TStrings; EntryIndex:
  Integer; const EntryName, EntryValue: string; IsDelete: Boolean): Boolean;

{ ,    :  ,
 ,  }
const
  WM_DATAREQUEST = WM_USER + 427;
  WM_DATAANSWER = WM_USER + 428;
  WM_DATATERMINATE = WM_USER + 429;
{  ,   ErrorCode  
TWndDataAnswerEvent: ,    ,  
   ,    , 
 ,    ,    ,
  }
const
  WNDDATA_OK = 0;
  WNDDATA_BUFEMPTY = 1;
  WNDDATA_BUFHEADERTRUNCATED = 2;
  WNDDATA_BUFLENCHANGED = 3;
  WNDDATA_REQUESTIDCHANGED = 4;
  WNDDATA_ANSWERWNDINCORRECT = 5;
  WNDDATA_DATATYPEINCORRECT = 6;
  WNDDATA_MOREDATA = 7;
{ ,       }
type
  EWndDataError = class(ENumProcError);
{     }
procedure CheckWndDataError(ErrorCode: Integer);
{   ; AnswerLen    Answer -
 ,        ;
 ErrorCode    - WNDDATA_XXXX   
   ; UserData    ,
  SendRequest,    }
type
  TWndDataAnswerEvent = procedure(Sender: TObject;
    RequestId: Integer; AnswerWnd: HWND;
    ErrorCode, AnswerLen: Integer; const Answer: string;
    UserData: Pointer) of object;
{     TerminateRequest; UserData  
 ,   SendRequest,    }
type
  TWndDataTerminateEvent = procedure(Sender: TObject;
    RequestId: Integer; AnswerWnd: HWND; UserData: Pointer) of object;
{     }
type
  TWndDataRequest = class(TObjectStd)
  private
    FSelfWnd: HWND;
    FProcessId: DWORD;
    FOnAnswer: TWndDataAnswerEvent;
    FOnTerminate: TWndDataTerminateEvent;
    FRequests: TList;
    FLastRequestId: Integer;
  protected
  public
    constructor Create(SelfWnd: HWND);
    destructor Destroy; override;
    {}
    { ,   SelfWnd   WM_DATAANSWER}
    procedure WMDataAnswer(var Message: TMessage); message WM_DATAANSWER;
    {   AnswerWnd; AnswerLen -    
    ;   }
    function SendRequest(AnswerWnd: HWND; const Request: string;
      AnswerLen: Integer; UserData: Pointer): Integer;
    { ,     ;  False,
       }
    function TerminateRequest(RequestId: Integer): Boolean;
    {}
    {  }
    property SelfWnd: HWND read FSelfWnd;
    {,    }
    property OnAnswer: TWndDataAnswerEvent
      read FOnAnswer write FOnAnswer;
    {,    }
    property OnTerminate: TWndDataTerminateEvent
      read FOnTerminate write FOnTerminate;
  end;
{   ; AnswerLen -   ,
  }
type
  TWndDataRequestEvent = procedure(Sender: TObject;
    const Request: string; AnswerLen: Integer; var Answer: string) of object;
{        }
type
  TWndDataAnswer = class(TObjectStd)
  private
    FSelfWnd: HWND;
    FOnRequest: TWndDataRequestEvent;
    FAnswers: TList;
  protected
  public
    constructor Create(SelfWnd: HWND);
    destructor Destroy; override;
    {}
    {     WM_DATAREQUEST 
    WM_DATATERMINATE }
    procedure WMDataRequest(var Message: TMessage); message WM_DATAREQUEST;
    procedure WMDataTerminate(var Message: TMessage); message WM_DATATERMINATE;
    {}
    {  }
    property SelfWnd: HWND read FSelfWnd;
    {,    }
    property OnRequest: TWndDataRequestEvent
      read FOnRequest write FOnRequest;
  end;

{:   ;   
 WNDDATA_XXXX}
const
  WNDDATA_VARHEADERTRUNCATED = 8;
type
  {   ;  TWndDataAnswerEvent}
  TVarSizeAnswerEvent = procedure(Sender: TObject;
    RequestId: Integer; AnswerWnd: HWND; ErrorCode: Integer;
    const Answer: string; UserData: Pointer) of object;
{        
  }
type
  TVarSizeRequest = class(TObjectStd)
  private
    FSelfWnd: HWND;
    FOnAnswer: TVarSizeAnswerEvent;
    FOnTerminate: TWndDataTerminateEvent;
    FRepeats: TList;
    FLastTerminateIsRepeat: Boolean;
    FLastTerminateRequestId: Integer;
    FRequest: TWndDataRequest;
  protected
    procedure Answer(Sender: TObject; RequestId: Integer; AnswerWnd: HWND;
      ErrorCode, AnswerLen: Integer; const Answer: string; UserData: Pointer);
    procedure Terminate(Sender: TObject; RequestId: Integer; AnswerWnd: HWND;
      UserData: Pointer);
  public
    constructor Create(SelfWnd: HWND);
    destructor Destroy; override;
    {}
    procedure WMDataAnswer(var Message: TMessage); message WM_DATAANSWER;
    function SendRequest(AnswerWnd: HWND; const Request: string;
      AnswerLen: Integer; UserData: Pointer): Integer;
    function TerminateRequest(RequestId: Integer): Boolean;
    {}
    property SelfWnd: HWND read FSelfWnd;
    property OnAnswer: TVarSizeAnswerEvent
      read FOnAnswer write FOnAnswer;
    property OnTerminate: TWndDataTerminateEvent
      read FOnTerminate write FOnTerminate;
  end;
{   ,  TWndDataRequestEvent}
type
  TVarSizeRequestEvent = procedure(Sender: TObject; const Request: string;
    var Answer: string) of object;
{        }
type
  TVarSizeAnswer = class(TObjectStd)
  private
    FSelfWnd: HWND;
    FOnRequest: TVarSizeRequestEvent;
    FOverfills: TList;
    FAnswer: TWndDataAnswer;
  protected
    procedure Request(Sender: TObject; const Request: string;
      AnswerLen: Integer; var Answer: string);
  public
    constructor Create(SelfWnd: HWND);
    destructor Destroy; override;
    {}
    procedure WMDataRequest(var Message: TMessage); message WM_DATAREQUEST;
    procedure WMDataTerminate(var Message: TMessage); message WM_DATATERMINATE;
    {}
    property SelfWnd: HWND read FSelfWnd;
    property OnRequest: TVarSizeRequestEvent
      read FOnRequest write FOnRequest;
  end;

{        }
type
  ERequestWndError = class(ExceptionStd);
{       }
type
  TRequestWnd = class(TObjectStd)
  private
    FSelfWnd: HWND;
    FHandleCloseMsg: Boolean;
    FHandleForeignMsgs: Boolean;
    FAbortTerminate: Boolean;
    FRequest: TVarSizeRequest;
    FIsWaitingAnswer: Boolean;
    FRequestId: Integer;
    FAnswerWnd: HWND;
    FIsAnswerReceived: Boolean;
    FAnswerErrorCode: Integer;
    FAnswerStr: string;
    FOnTick: TNotifyEventStd;
  protected
    procedure WndProc(var Message: TMessage);
    procedure Answer(Sender: TObject; RequestId: Integer; AnswerWnd: HWND;
      ErrorCode: Integer; const Answer: string; UserData: Pointer);
  public
    { ;       }
    constructor Create;
    destructor Destroy; override;
    {}
    {   }
    function Request(Wnd: HWND; const S: string): string;
    {   ( )}
    procedure Terminate;
    {}
    {   }
    property SelfWnd: HWND read FSelfWnd;
    {        ;
      True}
    property HandleCloseMsg: Boolean
      read FHandleCloseMsg write FHandleCloseMsg;
    {  ,   ;  False 
      ;   False}
    property HandleForeignMsgs: Boolean
      read FHandleForeignMsgs write FHandleForeignMsgs;
    {  Abort     ( 
    );   False}
    property AbortTerminate: Boolean
      read FAbortTerminate write FAbortTerminate;
    {  ,    }
    property OnTick: TNotifyEventStd read FOnTick write FOnTick;
  end;
{  S   Wnd;  ;  
  TRequestWnd}
function RequestWnd(Wnd: HWND; const S: string): string;
{        }
type
  TAnswerWnd = class(TObjectStd)
  private
    FWndClass: string;
    FWndName: string;
    FSelfWnd: HWND;
    FHandleCloseMsg: Boolean;
    FHandleForeignMsgs: Boolean;
    FAbortTerminate: Boolean;
    FAnswer: TVarSizeAnswer;
    FIsWaitingRequest: Boolean;
    FOnRequest: TVarSizeRequestEvent;
    FOnTick: TNotifyEventStd;
  protected
    procedure WndProc(var Message: TMessage);
    procedure Request(Sender: TObject;
      const Request: string; var Answer: string);
  public
    { ;       WndClass 
     WndName}
    constructor Create(const WndClass, WndName: string);
    destructor Destroy; override;
    {}
    {   ;    Terminate}
    procedure Answer;
    {   }
    procedure Terminate;
    {}
    {   }
    property SelfWnd: HWND read FSelfWnd;
    {  }
    property WndClass: string read FWndClass;
    {  }
    property WndName: string read FWndName;
    {        ;
      True}
    property HandleCloseMsg: Boolean
      read FHandleCloseMsg write FHandleCloseMsg;
    {  ,   ;  False 
      ;   False}
    property HandleForeignMsgs: Boolean
      read FHandleForeignMsgs write FHandleForeignMsgs;
    {  Abort     ( 
    Answer  ,  );   False}
    property AbortTerminate: Boolean
      read FAbortTerminate write FAbortTerminate;
    {,    }
    property OnRequest: TVarSizeRequestEvent
      read FOnRequest write FOnRequest;
    {  ,    }
    property OnTick: TNotifyEventStd read FOnTick write FOnTick;
  end;
{    WndClass   WndName    
  OnRequest; OnTick    ; 
     TAnswerWnd;    
  (Sender as TAnswerWnd).Terminate}
procedure AnswerWnd(const WndClass, WndName: string;
  OnRequest: TVarSizeRequestEvent; OnTick: TNotifyEventStd);

{    }
type
  EWaitWndError = class(ExceptionStd);
{  , ,  , }
type
  TWaitWnd = class(TObjectStd)
  private
    FDispatchMessages: Boolean;
    FSelfWnd: HWND;
    FHandleCloseMsg: Boolean;
    FHandleForeignMsgs: Boolean;
    FIsWaiting: Boolean;
    FVarParam: Variant;
    FOnTick: TNotifyEventStd;
    FOnHandleMessage: THandleMessageMethod;
  protected
    {  }
    FParams: TUniversalParams;
    {}
    procedure WndProc(var Message: TMessage);
    function ProcessMessage: Boolean;
    {}
    function TimeCheckHandler(AObject: TObject): Boolean;
    function WindowCheckHandler(AObject: TObject): Boolean;
    function WindowCheckVisible(AObject: TObject): Boolean;
    function ProcessWindowCheckHandler(AObject: TObject): Boolean;
    function ProcessFinishCheckHandler(AObject: TObject): Boolean;
    function FileCheckHandler(AObject: TObject): Boolean;
    function ReadableFileCheckHandler(AObject: TObject): Boolean;
    function WritableFileCheckHandler(AObject: TObject): Boolean;
    function MsgHandleCheckHandler(AObject: TObject): Boolean;
    function TimeServiceStateCheckHandler(AObject: TObject): Boolean;
    function WaitObjectCheckHandler(AObject: TObject): Boolean;
    function SocketFinishedCheckHandler(AObject: TObject): Boolean;
    function SMTPFinishedCheckHandler(AObject: TObject): Boolean;
    function POP3FinishedCheckHandler(AObject: TObject): Boolean;
  public
    { ,    ,     
      }
    constructor Create;
    destructor Destroy; override;
    {}
    {     Message  TMessage, 
       }
    procedure DefaultHandler(var Message); override;
    {   Error,   
      }
    procedure HandleException(Error: TObject);
    {}
    {,   CheckHandlerFunc   True,  ,
       CheckHandlerMethod   True,  }
    procedure Wait(CheckHandlerFunc: TCheckHandlerFunc;
      CheckHandlerMethod: TCheckHandlerMethod);
    {      Milliseconds
    (WaitTime);      WndClass   WndName
    (WaitWindow)}
    procedure WaitTime(Milliseconds: Integer);
    procedure WaitWindow(const WndClass, WndName: string);
    {,   Wnd     
     IsVisible = True     IsVisible = False
    (WaitWindowVisible);        
      Caption      ProcessHandle
      ProcessId,      0,
      ,   , Count  
      ,   Less  True  Count 
           , Timeout
         ,   
        (WaitProcessWindow);   
    ProcessHandle,     (WaitProcessFinish);
      CmdLine   CmdShow    ,
        (WaitRunProcess);  
    CmdLine   CmdShow     ,  
    ,    WindowLimit    
          Timeout ,  
      500 ,   WindowLimit   
    ,   , ,      
    WindowLimit ,      0,  WindowLimit
            
    (WaitRunProcessWindow)}
    procedure WaitWindowVisible(Wnd: HWND; IsVisible: Boolean);
    function WaitProcessWindow(ProcessHandle: THandle; ProcessId: DWORD;
      Count: Integer {1}; Less: Boolean; Timeout: DWORD;
      const Caption: string): HWND;
    function WaitProcessFinish(ProcessHandle: THandle): DWORD;
    function WaitRunProcess(const CmdLine: string; CmdShow: UINT): DWORD;
    function WaitRunProcessWindow(const CmdLine: string; CmdShow: UINT;
      WindowLimit: Integer; Timeout: DWORD): HWND;
    {   FileName (WaitFile);   ,
        FileName (WaitReadableFile); 
     ,     
      (WaitWritableFile)}
    procedure WaitFile(const FileName: string);
    procedure WaitReadableFile(const FileName: string);
    procedure WaitWritableFile(const FileName: string);
    {     RequestFile   
        AnswerFile   MsgHandle,   
     ExitFile, Wnd     
    (WaitMsgHandle);    Milliseconds   
    ServiceHandle   ServiceState,   
         WindowsAPI
    (WaitTimeServiceState); ,   'closed'  VarObject
     True (WaitObjectClosed)}
    procedure WaitMsgHandle(Wnd: HWND; const RequestFile, AnswerFile,
      ExitFile: string);
    procedure WaitTimeServiceState(Milliseconds: Integer;
      WindowsAPI: TWindowsAPI; ServiceHandle: TSCHandle; ServiceState: DWORD);
    procedure WaitObjectClosed(const VarObject: Variant);
    {   ,    
        SocketAPI, Timeout  
     , (-1)   }
    procedure WaitSocketFinished(SocketAPI: TSocketAPI; Timeout: Integer);
    {       SMTP, Timeout
          , (-1) 
      (WaitSMTPFinished);   
        POP3, Timeout    
      , (-1)   
    (WaitPOP3Finished)}
    procedure WaitSMTPFinished(SMTP: TSMTP; Timeout: Integer);
    procedure WaitPOP3Finished(POP3: TPOP3; Timeout: Integer);
    {    ,  Wait, 
      ,   IsWaiting  True, 
      EWaitWndError    
    (StartCheck);  ,    ,  
     OnTick,   Sender    , 
    ""     OnTick Abort (Terminate)}
    procedure StartCheck;
    procedure Terminate;
    {}
    { Dispatch     
      ,   False,      
     DefaultHandler}
    property DispatchMessages: Boolean
      read FDispatchMessages write FDispatchMessages;
    {    (SelfWnd);  True, 
         ,     
       (IsWaiting);   
     (Params);    Variant (VarParam)}
    property SelfWnd: HWND read FSelfWnd;
    property IsWaiting: Boolean read FIsWaiting;
    property Params: TUniversalParams read FParams write FParams;
    property VarParam: Variant read FVarParam write FVarParam;
    {        , 
     True (HandleCloseMsg);   , 
     ,  False    ,   False
    (HandleForeignMsgs)}
    property HandleCloseMsg: Boolean
      read FHandleCloseMsg write FHandleCloseMsg;
    property HandleForeignMsgs: Boolean
      read FHandleForeignMsgs write FHandleForeignMsgs;
    {  ,     (OnTick);
      (OnHandleMessage)}
    property OnTick: TNotifyEventStd read FOnTick write FOnTick;
    property OnHandleMessage: THandleMessageMethod
      read FOnHandleMessage write FOnHandleMessage;
  end;
{      ;    ,
 ;     CodePtr  CodeLen, 
       ,      
  ,  ;       CmdLine;
    CmdShow (   
  SW_SHOWDEFAULT);  WndClass  WndName 
 ,   Request     ,
 -   ;   -   TRequestWnd}
function ProcessRequestWnd(CodePtr: Pointer; CodeLen: Integer;
  const CmdLine: string; CmdShow: UINT; const WndClass, WndName,
  Request: string): string;

{ ,    , 
 ,        ,
    1,    
    ,   ,  
          
 ,       
   ,       
,    ,  
    }
const
  WM_SAFERUNTIMER = WM_USER + 210; {1234}
{ ,      , 
,    ,      ,
   ,      
  ,      WM_SAFERUNTIMER,
     'h'}
const
  SafeRunWndParamName = 'SafeRunWnd';
{     }
type
  TSafeRunWnd = class(TWaitWnd)
  private
    FRestart: Boolean;
    FTimeout: Integer;
    FLastTicks: DWORD;
    {}
    procedure WMSafeRunTimer(var Message: TMessage); message WM_SAFERUNTIMER;
  protected
    function SafeRunCheckHandler(AObject: TObject): Boolean;
  public
    {  ,   DispatchMessages  True}
    constructor Create;
    {}
    {  CmdLine   CmdShow    
    ,        
    WM_SAFERUNTIMER  ,  ,   
       WM_SAFERUNTIMER   ,
            
    SafeRunWndParamName,    }
    procedure WaitSafeRun(const CmdLine: string; CmdShow: UINT);
    {}
    { ,   ,   False
    (Restart);    WM_SAFERUNTIMER  ,
        ,  
       ,   0 (Timeout)}
    property Restart: Boolean read FRestart;
    property Timeout: Integer read FTimeout;
  end;
{ ,    TSafeRunWnd,  
      }
procedure SafeRunRun;

{       TRequestWnd}
type
  EProcessFuncCallError = class(ExceptionStd);
{           TRequestWnd}
type
  TFuncProcessInfo = record
    CodePtr: Pointer;
    CodeLen: Integer;
    CmdLine: string;
    CmdShow: UINT;
    WndClass: string;
    WndName: string;
  end;
  PFuncProcessInfo = ^TFuncProcessInfo;
{   Value}
procedure InitFuncProcessInfo(out Value: TFuncProcessInfo);
{   }
function FuncProcessInfo(CodePtr: Pointer; CodeLen: Integer;
  const CmdLine: string; CmdShow: UINT;
  const WndClass, WndName: string): TFuncProcessInfo;
{       TRequestWnd; 
  ,  ,     
;  FuncParams = nil,  ,   ;
 FuncResults = nil,  }
procedure ProcessFuncCall(const ProcessInfo: TFuncProcessInfo;
  const FuncName: string; FuncParams, FuncResults: TStrings);
{     ;  ;
 FuncResults   ,   ;
  FuncResults = nil,   }
function FuncCall(const ProcessInfo: TFuncProcessInfo;
  const FuncName: string; FuncParams: array of const;
  FuncResults: TStringList): string;
{     ;
 ProcResults   ,   ;
  ProcResults = nil,   }
procedure ProcCall(const ProcessInfo: TFuncProcessInfo;
  const ProcName: string; ProcParams: array of const;
  ProcResults: TStringList);
{   ;    TAnswerWnd;
      ;   
  HandleCall  }
type
  TFuncCallHandler = class(TObjectStd)
  private
    FWndClass: string;
    FWndName: string;
    FIdleWaitMs: Integer;
    FLastCallMs: DWORD;
    FHandlingCallsNum: Integer;
    FIsTerminating: Boolean;
  protected
    procedure Request(Sender: TObject;
      const Request: string; var Answer: string);
    procedure Tick(Sender: TObject);
    {   FuncName c  FuncParams;
      ,   IsFuncFound  True
    (  False);  FuncResults    
     (   ) -     
    ,   }
    procedure HandleCall(const FuncName: string; FuncParams: TStrings;
      var IsFuncFound: Boolean; FuncResults: TStrings); virtual;
    {   }
    procedure HandleTick; virtual;
  public
    { ;     -   ,
        ,   ,   
    ,    ; 0 -   }
    constructor Create(const WndClass, WndName: string;
      IdleWaitMs: Integer); virtual;
    {  ;     WndClass  
    WndName}
    procedure Run;
    {}
    {    }
    property WndClass: string read FWndClass;
    property WndName: string read FWndName;
    {  ,   ,   
    ,    ; 0 -   }
    property IdleWaitMs: Integer read FIdleWaitMs;
    {    IsTerminating = True  
     }
    property IsTerminating: Boolean read FIsTerminating write FIsTerminating;
  end;
{    }
type
  TFuncCallHandlerClass = class of TFuncCallHandler;
{     FuncCallHandlerClass;
   -   WndClass   WndName; 
   ,   ,   
,    ; 0 -   }
procedure RunFuncCallHandler(const WndClass, WndName: string;
  IdleWaitMs: Integer; FuncCallHandlerClass: TFuncCallHandlerClass);

{ -   WebInstallerDir   
Original,   ,    LastName,  FirstName
  MiddleName    ..  MakeOriginal}
procedure ConfigWebInstaller(const WebInstallerDir, Original,
  LastName, FirstName, MiddleName: string);


  
{---  COM -------------------------------------------------------------}

{ IDispatch}
type
  EDispatchError = class(EWinAPIError)
  private
    FArgNum: Integer;
    FSource: string;
    FDescription: string;
    FSCode: HRESULT;
    FSCodeMsg: string;
    FDispId: TDispID;
    FDispName: string;
  protected
  public
    {   (ArgNum);   (Source); 
     (Description);    , 
        (SCode);   , 
    SCode (SCodeMsg);     (ADispId); 
      (DispName)}
    property ArgNum: Integer read FArgNum write FArgNum;
    property Source: string read FSource write FSource;
    property Description: string read FDescription write FDescription;
    property SCode: HRESULT read FSCode write FSCode;
    property SCodeMsg: string read FSCodeMsg write FSCodeMsg;
    property ADispId: TDispID read FDispId write FDispId;
    property DispName: string read FDispName write FDispName;
  end;
  EDispatchErrorClass = class of EDispatchError;
{  IDispatch   Msg,   ErrorCode, 
ProcName,    ArgNum,   Source,
  Description,       
  SCode,     SCode SCodeMsg, 
   ADispId,    DispName,  
DispatchErrorClass,  MsgOnly = True      Msg}
function DispatchErrorCreate(const Msg: string; ErrorCode: Integer;
  const ProcName: string; ArgNum: Integer; const Source, Description: string;
  SCode: HRESULT; ADispId: TDispID; const DispName: string;
  DispatchErrorClass: EDispatchErrorClass; MsgOnly: Boolean): EDispatchError;
{}
{    Name   AType,  
DISPATCH_METHOD, DISPATCH_PROPERTYGET, DISPATCH_PROPERTYPUT,  
AnInterface,    ArgCount,  OleVariant Args,
 ReturnResult = True  ,   Unassigned
(DispatchInvoke);     CallStr  AVar,
 ReturnResult = True    AVar   
      ,  ReturnResult = False
 Unassigned,  CallStr    
 ,  ,     ,
     ,     
,       
  ,      ,
        , ,
'SomeSubObject("SomeName", 1.34e10, True).SomeProp["NewValue"]' (DispatchCall)}
function DispatchInvoke(AnInterface: IDispatch; const Name: string;
  AType: Word; ArgCount: Integer; Args: PVariantArgList;
  ReturnResult: Boolean): OleVariant;
function DispatchCall(AVar: OleVariant; const CallStr: string;
  ReturnResult: Boolean): OleVariant;

{    RetrieveVars = False   
RetrieveVars = True  Strings     TypeInfo,  
TypeInfo    nil,     
,    , ,  
     }
function TypeInfoNames(TypeInfo: ITypeInfo; RetrieveVars: Boolean;
  Strings: TStrings): HRESULT;
{    IDispatch,   
   TObject.Dispatch    
 ,  DispID }
type
  TDispatchObject = class(TCustomDispatchObject)
  private
    FUnknownDispId: Integer;
    FDispIds: TIndexedList;
    FNames: TIndexedStrings;
  protected
    function GetIDsOfNamesHandler(const IID: TGUID; Names: Pointer;
      NameCount, LocaleId: Integer; DispIds: Pointer): HRESULT;
    function InvokeHandler(ADispId: Integer; const IID: TGUID;
      LocaleId: Integer; Flags: Word; var Params; VarResult, ExcepInfo,
      ArgErr: Pointer): HRESULT;
    {   DispID  ADispId,  Name}
    procedure RegisterMethod(ADispId: Integer; const Name: string);
    { DispID      Names  Name, 
      UnknownDispId}
    function UnknownNameToDispId(const Name: string): Integer; virtual;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   ,     
    ipUnknownMethod   UnknownMethod}
    procedure DefaultHandler(var Message); override;
    {   ,    DispID  0,  
      DefaultHandler,  UnknownMethod
    (DefaultMethod);   ,   
       irNotSupported (UnknownMethod)}
    procedure DefaultMethod(var Message: TInvokeInfo); virtual;
    procedure UnknownMethod(var Message: TInvokeInfo); virtual;
    {   IDispatch,   
    TDispatchedObjectRef}
    function GetInterface: IDispatch; override;
    { DispID ADispId    }
    function DispIdToName(ADispId: Integer): string;
    {}
    {        ,
      DISPID_UNKNOWN,     
      (UnknownDispId);  DispID 
       (DispIds);     
    (Names)}
    property UnknownDispId: Integer read FUnknownDispId write FUnknownDispId;
    property DispIds: TIndexedList read FDispIds;
    property Names: TIndexedStrings read FNames;
  end;
  {       IDispatch}
  TCustomDispatchObjectMethod = function: TCustomDispatchObject of object;

{ COM-,        
   IsSysDebug  True (TAutoObjectDbg);  COM-
(TAutoObjectStd)}
type
  TAutoObjectDbg = class(TAutoObject)
  private
  protected
  public
    procedure Initialize; override;
    destructor Destroy; override;
  end;
  TAutoObjectStd = {$IFNDEF NODEBUG_SYS} TAutoObjectDbg
    {$ELSE} TAutoObject {$ENDIF};
{ }
type
  TSafetyAutoObject = class(TAutoObjectStd, IObjectSafety)
  private
    FEnabledOptions: DWORD;
    FSupportedOptions: DWORD;
    FFailNotSupported: Boolean;
  protected
    function GetInterfaceSafetyOptions(const IID: TIID; pdwSupportedOptions,
      pdwEnabledOptions: PDWORD): HRESULT; stdcall;
    function SetInterfaceSafetyOptions(const IID: TIID; dwOptionSetMask,
      dwEnabledOptions: DWORD): HRESULT; stdcall;
  public
    procedure Initialize; override;
    {}
    {   ,   0,   
       (EnabledOptions);  
     ,     ,  
    INTERFACESAFE_FOR_UNTRUSTED_CALLER or INTERFACESAFE_FOR_UNTRUSTED_DATA
    (SupportedOptions);   E_FAIL    
       ,   False,    
      (FailNotSupported)}
    property EnabledOptions: DWORD read FEnabledOptions write FEnabledOptions;
    property SupportedOptions: DWORD
      read FSupportedOptions write FSupportedOptions;
    property FailNotSupported: Boolean
      read FFailNotSupported write FFailNotSupported;
  end;
{}
{$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
{$IFNDEF VER110} {$IFNDEF VER120} {$IFNDEF VER125}
{ }
type
  TSafetyEnumVariantObject = class(TSafetyAutoObject, IEnumVariant)
  private
    FVariants: TVariants;
    FCurrentIndex: DWORD;
    FOwnsVariants: Boolean;
  protected
    function Next(celt: LongWord; var rgvar : OleVariant;
      out pceltFetched: LongWord): HResult; stdcall;
    function Skip(celt: LongWord): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out Enum: IEnumVariant): HResult; stdcall;
    {}
    function GetVariants: TVariants;
    procedure SetVariants(NewVariants: TVariants);
    function GetCurrentIndex: DWORD;
  public
    procedure Initialize; override;
    destructor Destroy; override;
    {}
    { ,  ,   ,
          ,     OwnsVariants
     True,     ,   ,
     OwnsVariants  False,  ,   
       True,   nil   ,
        (Variants);    (CurrentIndex);
          Variants,   
           Variants
      (OwnsVariants)}
    property Variants: TVariants read GetVariants write SetVariants;
    property CurrentIndex: DWORD read GetCurrentIndex write FCurrentIndex;
    property OwnsVariants: Boolean read FOwnsVariants write FOwnsVariants;
  end;
{$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}
{}
{     IUnknown}
type
  TErrAutoObject = class(TAutoObjectStd)
  private
    FErrorObject: TErrorObject;
  protected
  public
    procedure Initialize; override;
    destructor Destroy; override;
    {}
    {  }
    property ErrorObject: TErrorObject read FErrorObject;
  end;
{}
{   }
type
  TErrSafetyAutoObject = class(TSafetyAutoObject)
  private
    FErrorObject: TErrorObject;
  protected
  public
    procedure Initialize; override;
    destructor Destroy; override;
    {}
    {  }
    property ErrorObject: TErrorObject read FErrorObject;
  end;
{}
{      }
type
  TMetafileErrSafetyAutoObject = class(TErrSafetyAutoObject, IViewObject)
  private
    FFreezeHandle: LongInt;
    FMetafileHandle: THandle;
    FMetafileData: string;
    FPrevPageSetup: TNullPageSetup;
    FPageSetup: TPageSetup;
  protected
    procedure SetMetafileData(const NewMetafileData: string);
    {}
    function Draw(dwDrawAspect, lindex: LongInt; pvAspect: Pointer;
      ptd: PDVTargetDevice; hicTargetDev, hdcDraw: HDC; prcBounds: PRect;
      prcWBounds: PRect; fnContinue: TContinueFunc;
      dwContinue: LongInt): HRESULT; stdcall;
    function GetColorSet(dwDrawAspect, lindex: LongInt;
      pvAspect: Pointer; ptd: PDVTargetDevice; hicTargetDev: HDC;
      out colorSet: PLogPalette): HRESULT; stdcall;
    function Freeze(dwDrawAspect, lindex: LongInt; pvAspect: Pointer;
      out dwFreeze: LongInt): HRESULT; stdcall;
    function Unfreeze(dwFreeze: LongInt): HRESULT; stdcall;
    function SetAdvise(aspects, advf: LongInt;
      const advSink: IAdviseSink): HRESULT; stdcall;
    function GetAdvise(pAspects, pAdvf: PLongInt;
      out advSink: IAdviseSink): HRESULT; stdcall;
  public
    procedure Initialize; override;
    destructor Destroy; override;
    {}
    {      Internet Explorer Value,  
          ,  
       ,      
    ,        
     }
    procedure DefineIEPageSetup(const Value: TPageSetup);
    {}
    {  }
    property MetafileData: string read FMetafileData write SetMetafileData;
  end;

{     ,     
,        }
type
  EScriptError = class(ENumProcError)
  private
    FLineNum: Integer;
    FCharPos: Integer;
    FCodeLine: string;
    FScriptSource: string;
  protected
  public
    {  (LineNum);    (CharPos); 
     ,   (CodeLine);   (ScriptSource)}
    property LineNum: Integer read FLineNum write FLineNum;
    property CharPos: Integer read FCharPos write FCharPos;
    property CodeLine: string read FCodeLine write FCodeLine;
    property ScriptSource: string read FScriptSource write FScriptSource;
  end;
  EScriptErrorClass = class of EScriptError;
  EActiveScriptError = class(EScriptError);
{      Msg,  ErrorCode, 
  ProcName,   LineNum,  CharPos,
     CodeLine,  
  ScriptSource,   ScriptErrorClass, 
 nil,  MsgOnly = True      Msg}
function ScriptErrorCreate(const Msg: string; ErrorCode: Integer;
  const ProcName: string; LineNum, CharPos: Integer; const CodeLine,
  ScriptSource: string; ScriptErrorClass: EScriptErrorClass;
  MsgOnly: Boolean): EScriptError;
{   IActiveScriptSite  Windows Scripting hosts}
type
  TActiveScriptSite = class(TInterfacedObjectStd, IActiveScriptSite)
  private
    FErrorCode: HRESULT;
    FErrorLineNum: Integer;
    FErrorCharPos: Integer;
    FErrorLine: string;
    FErrorSource: string;
    FErrrorDescrption: string;
    FItemNames: TIndexedStrings;
    FItemInterfaces: TList; {IUnknown}
    FItemTypesInfo: TList; {ITypeInfo}
  protected
    function GetLCID(out plcid: LCID): HRESULT; stdcall;
    function GetItemInfo(pstrName: LPCOLESTR; dwReturnMask: DWORD;
      out ppiunkItem: IUnknown; out ppti: ITypeInfo): HRESULT; stdcall;
    function GetDocVersionString(out pbstrVersion: WideString): HRESULT;
      stdcall;
    function OnScriptTerminate(const pvarResult: OleVariant;
      const pexcepinfo: TExcepInfo): HRESULT; stdcall;
    function OnStateChange(ssScriptState: TScriptState): HRESULT; stdcall;
    function OnScriptError(const pscripterror: IActiveScriptError): HRESULT;
      stdcall;
    function OnEnterScript: HRESULT; stdcall;
    function OnLeaveScript: HRESULT; stdcall;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {       
    ,        
    EActiveScriptError, ProcName    }
    procedure CheckError(const ProcName: string);
    {        Name,
     Item,    TypeInfo,    }
    procedure AddNamedItem(const Name: string;
      Item: IUnknown; TypeInfo: ITypeInfo);
    {}
    {  OLE (ErrorCode);       
      ,   1,    
            
      (ErrorLineNum);    ,   1
    (ErrorCharPos);  ,   (ErrorLine); 
       (ErrorSource);    (ErrrorDescrption)}
    property ErrorCode: HRESULT read FErrorCode write FErrorCode;
    property ErrorLineNum: Integer read FErrorLineNum write FErrorLineNum;
    property ErrorCharPos: Integer read FErrorCharPos write FErrorCharPos;
    property ErrorLine: string read FErrorLine write FErrorLine;
    property ErrorSource: string read FErrorSource write FErrorSource;
    property ErrrorDescrption: string
      read FErrrorDescrption write FErrrorDescrption;
  end;
  TActiveScriptSiteClass = class of TActiveScriptSite;
{   TActiveScriptSiteWindow, 
  ,  Windows Scripting hosts}
type
  TActiveScriptSiteWindow = class(TActiveScriptSite, IActiveScriptSiteWindow)
  private
    FParentWindow: HWND;
  protected
    function GetWindow(out phwnd: HWND): HRESULT; stdcall;
    function EnableModeless(fEnable: BOOL): HRESULT; stdcall;
  public
    constructor Create;
    {}
    {  }
    property ParentWindow: HWND read FParentWindow write FParentWindow;
  end;
{      }
type
  TCustomScriptAccess = class(TObjectStd)
  private
    FScriptLang: string;
    FParentWindow: HWND;
    FBlockDialogs: Boolean;
    FScriptDispatchDefined: Boolean;
    FScriptDispatch: Variant;
    FScriptFuncNames: TIndexedStrings;
    FScriptVarNames: TIndexedStrings;
    FThreadScriptAccess: TCustomScriptAccess;
  protected
    {    ,   ,  
     Unassigned (ScriptDispatch);    
    ,      (ScriptFuncNames); 
       ,     
    (ScriptVarNames);   , ,   
      (CreateClone);    Clone
    (InitClone)}
    function CreateScriptDispatch: Variant; virtual;
    function CreateScriptFuncNames: TIndexedStrings; virtual;
    function CreateScriptVarNames: TIndexedStrings; virtual;
    function CreateClone: TCustomScriptAccess; virtual;
    procedure InitClone(var Clone: TCustomScriptAccess); virtual;
    {}
    function GetScriptDispatch: Variant;
    function GetScriptFuncNames: TIndexedStrings;
    function GetScriptVarNames: TIndexedStrings;
    function GetThreadScriptAccess: TCustomScriptAccess;
    procedure SetThreadScriptAccess(NewThreadScriptAccess:
      TCustomScriptAccess);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {        
         ,  
      }
    procedure CheckError; virtual;
    {  , ,     }
    function Clone: TCustomScriptAccess;
    {  ScriptText,  IsExpression = True  
    ,  ,     ,
     Null}
    function ParseScriptText(const ScriptText: string;
      IsExpression: Boolean): OleVariant; virtual;
    {        Name,
     Item,    TypeInfo,    ,
        }
    procedure AddNamedItem(const Name: string;
      Item: IUnknown; TypeInfo: ITypeInfo); virtual;
    {}
    { ,  'VBScript'  'JScript' (ScriptLang); 
      ,   False (BlockDialogs); 
     (ParentWindow);    ,   
    (ScriptDispatch);     (ScriptFuncNames);
        (ScriptVarNames);   
    ,    Clone,    
        ,   nil (ThreadScriptAccess)}
    property ScriptLang: string read FScriptLang write FScriptLang;
    property BlockDialogs: Boolean read FBlockDialogs write FBlockDialogs;
    property ParentWindow: HWND read FParentWindow write FParentWindow;
    property ScriptDispatch: Variant read GetScriptDispatch;
    property ScriptFuncNames: TIndexedStrings read GetScriptFuncNames;
    property ScriptVarNames: TIndexedStrings read GetScriptVarNames;
    property ThreadScriptAccess: TCustomScriptAccess
      read GetThreadScriptAccess write SetThreadScriptAccess;
  end;
  {         }
  TCustomScriptAccessMethod = function: TCustomScriptAccess of object;
{      Windows Scripting hosts, 
 TActiveScriptXXXX,    ScriptLang, 
 ,   'JScript'}
type
  TActiveScriptAccess = class(TCustomScriptAccess)
  private
    FScriptParsed: Boolean;
    FScriptLangCLSID: TNullGuid;
    FActiveScriptSite: TActiveScriptSite;
    FActiveScript: IActiveScript;
    FActiveScriptParse: IActiveScriptParse;
    FActiveScriptDispatch: IDispatch;
  protected
    {}
    function CreateScriptDispatch: Variant; override;
    function CreateScriptFuncNames: TIndexedStrings; override;
    function CreateScriptVarNames: TIndexedStrings; override;
    function CreateClone: TCustomScriptAccess; override;
    procedure InitClone(var Clone: TCustomScriptAccess); override;
    {}
    function GetActiveScriptSite: TActiveScriptSite;
    function GetActiveScript: IActiveScript;
    function GetActiveScriptParse: IActiveScriptParse;
    {}
    function ScriptLangCLSID: TGUID;
    function ActiveScriptDispatch: IDispatch;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {       
    ActiveScriptSite,  ,    
      EActiveScriptError    }
    procedure CheckError; override;
    {  , ,     ,
         ScriptDispatch   CoInitialize(nil)
      CoUninitialize  }
    function Clone: TActiveScriptAccess;
    {  ScriptText,  IsExpression = True  
    ,  }
    function ParseScriptText(const ScriptText: string;
      IsExpression: Boolean): OleVariant; override;
    {        Name,
     Item,    TypeInfo,    }
    procedure AddNamedItem(const Name: string;
      Item: IUnknown; TypeInfo: ITypeInfo); override;
    {}
    {  (ActiveScriptSite);   (ActiveScript); 
      (ActiveScriptParse)}
    property ActiveScriptSite: TActiveScriptSite read GetActiveScriptSite;
    property ActiveScript: IActiveScript read GetActiveScript;
    property ActiveScriptParse: IActiveScriptParse read GetActiveScriptParse;
    property ThreadScriptAccess: TCustomScriptAccess
      read GetThreadScriptAccess write SetThreadScriptAccess;
  end;



{---  ------------------------------------------------------------}

const
  {WinIoCtl.h}
  {Define the various device type values. Note that values used by Microsoft
  Corporation are in the range 0-32767, and 32768-65535 are reserved for use
  by customers}
  FILE_DEVICE_BEEP                = $00000001;
  FILE_DEVICE_CD_ROM              = $00000002;
  FILE_DEVICE_CD_ROM_FILE_SYSTEM  = $00000003;
  FILE_DEVICE_CONTROLLER          = $00000004;
  FILE_DEVICE_DATALINK            = $00000005;
  FILE_DEVICE_DFS                 = $00000006;
  FILE_DEVICE_DISK                = $00000007;
  FILE_DEVICE_DISK_FILE_SYSTEM    = $00000008;
  FILE_DEVICE_FILE_SYSTEM         = $00000009;
  FILE_DEVICE_INPORT_PORT         = $0000000A;
  FILE_DEVICE_KEYBOARD            = $0000000B;
  FILE_DEVICE_MAILSLOT            = $0000000C;
  FILE_DEVICE_MIDI_IN             = $0000000D;
  FILE_DEVICE_MIDI_OUT            = $0000000E;
  FILE_DEVICE_MOUSE               = $0000000F;
  FILE_DEVICE_MULTI_UNC_PROVIDER  = $00000010;
  FILE_DEVICE_NAMED_PIPE          = $00000011;
  FILE_DEVICE_NETWORK             = $00000012;
  FILE_DEVICE_NETWORK_BROWSER     = $00000013;
  FILE_DEVICE_NETWORK_FILE_SYSTEM = $00000014;
  FILE_DEVICE_NULL                = $00000015;
  FILE_DEVICE_PARALLEL_PORT       = $00000016;
  FILE_DEVICE_PHYSICAL_NETCARD    = $00000017;
  FILE_DEVICE_PRINTER             = $00000018;
  FILE_DEVICE_SCANNER             = $00000019;
  FILE_DEVICE_SERIAL_MOUSE_PORT   = $0000001A;
  FILE_DEVICE_SERIAL_PORT         = $0000001B;
  FILE_DEVICE_SCREEN              = $0000001C;
  FILE_DEVICE_SOUND               = $0000001D;
  FILE_DEVICE_STREAMS             = $0000001E;
  FILE_DEVICE_TAPE                = $0000001F;
  FILE_DEVICE_TAPE_FILE_SYSTEM    = $00000020;
  FILE_DEVICE_TRANSPORT           = $00000021;
  FILE_DEVICE_UNKNOWN             = $00000022;
  FILE_DEVICE_VIDEO               = $00000023;
  FILE_DEVICE_VIRTUAL_DISK        = $00000024;
  FILE_DEVICE_WAVE_IN             = $00000025;
  FILE_DEVICE_WAVE_OUT            = $00000026;
  FILE_DEVICE_8042_PORT           = $00000027;
  FILE_DEVICE_NETWORK_REDIRECTOR  = $00000028;
  FILE_DEVICE_BATTERY             = $00000029;
  FILE_DEVICE_BUS_EXTENDER        = $0000002A;
  FILE_DEVICE_MODEM               = $0000002B;
  FILE_DEVICE_VDM                 = $0000002C;
  FILE_DEVICE_MASS_STORAGE        = $0000002D;
  FILE_DEVICE_SMB                 = $0000002E;
  FILE_DEVICE_KS                  = $0000002F;
  FILE_DEVICE_CHANGER             = $00000030;
  FILE_DEVICE_SMARTCARD           = $00000031;
  FILE_DEVICE_ACPI                = $00000032;
  FILE_DEVICE_DVD                 = $00000033;
  FILE_DEVICE_FULLSCREEN_VIDEO    = $00000034;
  FILE_DEVICE_DFS_FILE_SYSTEM     = $00000035;
  FILE_DEVICE_DFS_VOLUME          = $00000036;
  {}
  {Define the method codes for how buffers are passed for I/O and FS controls}
  METHOD_BUFFERED   = 0;
  METHOD_IN_DIRECT  = 1;
  METHOD_OUT_DIRECT = 2;
  METHOD_NEITHER    = 3;
  {}
  {The FILE_READ_ACCESS and FILE_WRITE_ACCESS constants are also defined in
  ntioapi.h as FILE_READ_DATA and FILE_WRITE_DATA. The values for these
  constants *MUST* always be in sync}
  FILE_ANY_ACCESS   = 0;
  FILE_READ_ACCESS  = $0001; {file & pipe}
  FILE_WRITE_ACCESS = $0002; {file & pipe}
  {}
  {IoControlCode values for disk devices}
  IOCTL_DISK_BASE = FILE_DEVICE_DISK;
  {IOCTL support for SMART drive fault prediction}
  {DFP_GET_VERSION = $00074080}
  SMART_GET_VERSION = (IOCTL_DISK_BASE * $10000) + ($0020 * $4) +
    (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  {DFP_SEND_DRIVE_COMMAND = $0007c084}
  SMART_SEND_DRIVE_COMMAND = (IOCTL_DISK_BASE * $10000) + ($0021 * $4) +
    (METHOD_BUFFERED) + ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) * $4000);
  {DFP_RECEIVE_DRIVE_DATA = $0007c088}
  SMART_RCV_DRIVE_DATA = (IOCTL_DISK_BASE * $10000) + ($0022 * $4) +
    (METHOD_BUFFERED) + ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) * $4000);
  {}
  {Smart.h}
  {Miscellaneous}
  MAX_IDE_DRIVES = 4; {Max number of drives assuming primary/secondary,
                      master/slave topology}
  READ_ATTRIBUTE_BUFFER_SIZE = 512;
  IDENTIFY_BUFFER_SIZE       = 512;
  READ_THRESHOLD_BUFFER_SIZE = 512;
  {}
  {Valid values for the bCommandReg member of IDEREGS}
  IDE_ATAPI_ID               = $A1; {returns ID sector for ATAPI}
  IDE_ID_FUNCTION            = $EC; {returns ID sector for ATA}
  IDE_EXECUTE_SMART_FUNCTION = $B0; {performs SMART cmd.}
  {}
  {Cylinder register values required when issuing SMART command}
  SMART_CYL_LOW = $4F;
  SMART_CYL_HI  = $C2;
  {}
  {Feature register defines for SMART "sub commands"}
  SMART_READ_ATTRIBUTE_VALUES = $D0; {ATA4: Renamed}
  SMART_READ_ATTRIBUTE_THRESHOLDS = $D1; {obsoleted in ATA4!}
  SMART_ENABLE_DISABLE_ATTRIBUTE_AUTOSAVE = $D2;
  SMART_SAVE_ATTRIBUTE_VALUES = $D3;
  SMART_EXECUTE_OFFLINE_IMMEDIATE = $D4; {ATA4}
  {Vendor specific commands}
  SMART_ENABLE_SMART_OPERATIONS = $D8;
  SMART_DISABLE_SMART_OPERATIONS = $D9;
  SMART_RETURN_SMART_STATUS = $DA;
  {}
  {Scsi.h}
  {SCSI IO Device Control Codes}
  FILE_DEVICE_SCSI = $0000001B;
  {SMART support in atapi}
  IOCTL_SCSI_MINIPORT_SMART_VERSION = (FILE_DEVICE_SCSI * $10000) + $0500;
  IOCTL_SCSI_MINIPORT_IDENTIFY = (FILE_DEVICE_SCSI * $10000) + $0501;
  IOCTL_SCSI_MINIPORT_READ_SMART_ATTRIBS = (FILE_DEVICE_SCSI * $10000) + $0502;
  IOCTL_SCSI_MINIPORT_READ_SMART_THRESHOLDS =
    (FILE_DEVICE_SCSI * $10000) + $0503;
  IOCTL_SCSI_MINIPORT_ENABLE_SMART = (FILE_DEVICE_SCSI * $10000) + $0504;
  IOCTL_SCSI_MINIPORT_DISABLE_SMART = (FILE_DEVICE_SCSI * $10000) + $0505;
  IOCTL_SCSI_MINIPORT_RETURN_STATUS = (FILE_DEVICE_SCSI * $10000) + $0506;
  IOCTL_SCSI_MINIPORT_ENABLE_DISABLE_AUTOSAVE =
    (FILE_DEVICE_SCSI * $10000) + $0507;
  IOCTL_SCSI_MINIPORT_SAVE_ATTRIBUTE_VALUES =
    (FILE_DEVICE_SCSI * $10000) + $0508;
  IOCTL_SCSI_MINIPORT_EXECUTE_OFFLINE_DIAGS =
    (FILE_DEVICE_SCSI * $10000) + $0509;
  IOCTL_SCSI_MINIPORT_ENABLE_DISABLE_AUTO_OFFLINE =
    (FILE_DEVICE_SCSI * $10000) + $050A;
  {}
  {NTDDStor.h}
  {IoControlCode values for storage devices}
  IOCTL_STORAGE_BASE = FILE_DEVICE_MASS_STORAGE;
  {The following device control codes are common for all class drivers, they
  should be used in place of the older IOCTL_DISK, IOCTL_CDROM and IOCTL_TAPE
  common codes}
  IOCTL_STORAGE_CHECK_VERIFY = (IOCTL_STORAGE_BASE * $10000) + ($0200 * $4) +
    (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  IOCTL_STORAGE_CHECK_VERIFY2 = (IOCTL_STORAGE_BASE * $10000) + ($0200 * $4) +
    (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_STORAGE_MEDIA_REMOVAL = (IOCTL_STORAGE_BASE * $10000) + ($0201 * $4) +
    (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  IOCTL_STORAGE_EJECT_MEDIA = (IOCTL_STORAGE_BASE * $10000) + ($0202 * $4) +
    (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  IOCTL_STORAGE_LOAD_MEDIA = (IOCTL_STORAGE_BASE * $10000) + ($0203 * $4) +
    (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  IOCTL_STORAGE_LOAD_MEDIA2 = (IOCTL_STORAGE_BASE * $10000) + ($0203 * $4) +
    (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_STORAGE_RESERVE = (IOCTL_STORAGE_BASE * $10000) + ($0204 * $4) +
    (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  IOCTL_STORAGE_RELEASE = (IOCTL_STORAGE_BASE * $10000) + ($0205 * $4) +
    (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  IOCTL_STORAGE_FIND_NEW_DEVICES = (IOCTL_STORAGE_BASE * $10000) +
    ($0206 * $4) + (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  IOCTL_STORAGE_EJECTION_CONTROL = (IOCTL_STORAGE_BASE * $10000) +
    ($0250 * $4) + (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_STORAGE_MCN_CONTROL = (IOCTL_STORAGE_BASE * $10000) + ($0251 * $4) +
    (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_STORAGE_GET_MEDIA_TYPES = (IOCTL_STORAGE_BASE * $10000) +
    ($0300 * $4) + (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_STORAGE_GET_MEDIA_TYPES_EX = (IOCTL_STORAGE_BASE * $10000) +
    ($0301 * $4) + (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_STORAGE_GET_MEDIA_SERIAL_NUMBER = (IOCTL_STORAGE_BASE * $10000) +
    ($0304 * $4) + (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_STORAGE_RESET_BUS = (IOCTL_STORAGE_BASE * $10000) + ($0400 * $4) +
    (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  IOCTL_STORAGE_RESET_DEVICE = (IOCTL_STORAGE_BASE * $10000) + ($0401 * $4) +
    (METHOD_BUFFERED) + (FILE_READ_ACCESS * $4000);
  IOCTL_STORAGE_GET_DEVICE_NUMBER = (IOCTL_STORAGE_BASE * $10000) +
    ($0420 * $4) + (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_STORAGE_PREDICT_FAILURE = (IOCTL_STORAGE_BASE * $10000) +
    ($0440 * $4) + (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  {end_winioctl}
  IOCTL_STORAGE_QUERY_PROPERTY = (IOCTL_STORAGE_BASE * $10000) + ($0500 * $4) +
    METHOD_BUFFERED + (FILE_ANY_ACCESS * $4000);
  {}
  {Define the different storage bus types, bus types below 128 (0x80)
  are reserved for Microsoft use, STORAGE_BUS_TYPE values}
  BusTypeUnknown     = $00;
  BusTypeScsi        = $01;
  BusTypeAtapi       = $02;
  BusTypeAta         = $03;
  BusType1394        = $04;
  BusTypeSsa         = $05;
  BusTypeFibre       = $06;
  BusTypeUsb         = $07;
  BusTypeRAID        = $08;
  BusTypeMaxReserved = $7F;
  {}
  {NTDDScsi.h}
  {Types of queries, STORAGE_QUERY_TYPE values}
  PropertyStandardQuery = 0;   {retrieves the descriptor}
  PropertyExistsQuery = 1;     {test whether the descriptor is supported}
  PropertyMaskQuery = 2;       {get mask of writeable fields in the descriptor}
  PropertyQueryMaxDefined = 3; {use to validate the value}
  {some initial property id's, STORAGE_PROPERTY_ID values}
  StorageDeviceProperty = 0;
  StorageAdapterProperty = 1;
  {Device Name - this string is the name of the device, it is the name that
  should be passed to NtOpenFile when accessing the device, note - for devices
  that support multiple units, it should be suffixed with the Ascii
  representation of the unit number}
  IOCTL_SCSI_BASE = FILE_DEVICE_CONTROLLER;
  {NtDeviceIoControlFile IoControlCode values for this device, warning -
  remember that the low two bits of the code specify how the buffers are passed
  to the driver!}
  IOCTL_SCSI_PASS_THROUGH = (IOCTL_SCSI_BASE * $10000) + ($0401 * $4) +
    (METHOD_BUFFERED) + ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) * $4000);
  IOCTL_SCSI_MINIPORT = (IOCTL_SCSI_BASE * $10000) + ($0402 * $4) +
    (METHOD_BUFFERED) + ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) * $4000);
  IOCTL_SCSI_GET_INQUIRY_DATA = (IOCTL_SCSI_BASE * $10000) + ($0403 * $4) +
    (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_SCSI_GET_CAPABILITIES = (IOCTL_SCSI_BASE * $10000) + ($0404 * $4) +
    (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_SCSI_PASS_THROUGH_DIRECT = (IOCTL_SCSI_BASE * $10000) + ($0405 * $4) +
    (METHOD_BUFFERED) + ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) * $4000);
  IOCTL_SCSI_GET_ADDRESS = (IOCTL_SCSI_BASE * $10000) + ($0406 * $4) +
    (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_SCSI_RESCAN_BUS = (IOCTL_SCSI_BASE * $10000) + ($0407 * $4) +
    (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_SCSI_GET_DUMP_POINTERS = (IOCTL_SCSI_BASE * $10000) + ($0408 * $4) +
    (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_SCSI_FREE_DUMP_POINTERS = (IOCTL_SCSI_BASE * $10000) + ($0409 * $4) +
    (METHOD_BUFFERED) + (FILE_ANY_ACCESS * $4000);
  IOCTL_IDE_PASS_THROUGH = (IOCTL_SCSI_BASE * $10000) + ($040A * $4) +
    (METHOD_BUFFERED) + ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) * $4000);
{}
type
  {GETVERSIONOUTPARAMS contains the data returned from the
  Get Driver Version function}
  _GETVERSIONOUTPARAMS = packed record
    bVersion: Byte;                   {binary driver version}
    bRevision: Byte;                  {binary driver revision}
    bReserved: Byte;                  {not used}
    bIDEDeviceMap: Byte;              {bit map of IDE devices}
    fCapabilities: DWORD;             {bit mask of driver capabilities}
    dwReserved: array[0..3] of DWORD; {for future use}
  end;
  GETVERSIONOUTPARAMS = _GETVERSIONOUTPARAMS;
  TGetVersionOutParams = GETVERSIONOUTPARAMS;
  PGetVersionOutParams = ^TGetVersionOutParams;
  {}
  {IDE registers}
  _IDEREGS = packed record
    bFeaturesReg: Byte;     {used for specifying SMART "commands"}
    bSectorCountReg: Byte;  {IDE sector count register}
    bSectorNumberReg: Byte; {IDE sector number register}
    bCylLowReg: Byte;       {IDE low order cylinder value}
    bCylHighReg: Byte;      {IDE high order cylinder value}
    bDriveHeadReg: Byte;    {IDE drive/head register}
    bCommandReg: Byte;      {actual IDE command}
    bReserved: Byte;        {reserved for future use, must be zero}
  end;
  IDEREGS = _IDEREGS;
  TIDERegs = IDEREGS;
  PIDERegs = ^TIDERegs;
  {}
  {The input parameters for the Send Command to Drive function}
  _SENDCMDINPARAMS = packed record
    cBufferSize: DWORD;               {buffer size in bytes}
    irDriveRegs: TIDERegs;            {structure with drive register values}
    bDriveNumber: Byte;               {physical drive number, 0-3}
    bReserved: array[0..2] of Byte;   {reserved for future expansion}
    dwReserved: array[0..3] of DWORD; {for future use}
    bBuffer: array[0..0] of Byte;     {input buffer}
  end;
  SENDCMDINPARAMS = _SENDCMDINPARAMS;
  TSendCmdInParams = SENDCMDINPARAMS;
  PSendCmdInParams = ^TSendCmdInParams;
  {}
  {Status returned from driver}
  _DRIVERSTATUS = packed record
    bDriverError: Byte;               {error code from driver, 0 - no error}
    bIDEStatus: Byte;                 {IDE Error register,
                                      if bDriverError is SMART_IDE_ERROR}
    bReserved: array[0..1] of Byte;   {reserved for future expansion}
    dwReserved: array[0..1] of DWORD; {reserved for future expansion}
  end;
  DRIVERSTATUS = _DRIVERSTATUS;
  TDriverStatus = _DRIVERSTATUS;
  PDriverStatus = ^TDriverStatus;
  {}
  {Structure returned by SMART IOCTL for several commands}
  _SENDCMDOUTPARAMS = packed record
    cBufferSize: DWORD;           {size of bBuffer in bytes}
    DriverStatus: TDriverStatus;  {driver status structure}
    bBuffer: array[0..0] of Byte; {buffer for data read from the drive}
  end;
  SENDCMDOUTPARAMS = _SENDCMDOUTPARAMS;
  TSendCmdOutParams = SENDCMDOUTPARAMS;
  PSendCmdOutParams = ^TSendCmdOutParams;
  {}
  _IDSECTOR = packed record
    wGenConfig: Word;
    wNumCyls: Word;
    wReserved: Word;
    wNumHeads: Word;
    wBytesPerTrack: Word;
    wBytesPerSector: Word;
    wSectorsPerTrack: Word;
    wVendorUnique: array[0..2] of Word;
    sSerialNumber: array[0..19] of Char;
    wBufferType: Word;
    wBufferSize: Word;
    wECCSize: Word;
    sFirmwareRev: array[0..7] of Char;
    sModelNumber: array[0..39] of Char;
    wMoreVendorUnique: Word;
    wDoubleWordIO: Word;
    wCapabilities: Word;
    wReserved1: Word;
    wPIOTiming: Word;
    wDMATiming: Word;
    wBS: Word;
    wNumCurrentCyls: Word;
    wNumCurrentHeads: Word;
    wNumCurrentSectorsPerTrack: Word;
    ulCurrentSectorCapacity: DWORD;
    wMultSectorStuff: Word;
    ulTotalAddressableSectors: DWORD;
    wSingleWordDMA: Word;
    wMultiWordDMA: Word;
    bReserved: array[0..127] of Byte;
  end;
  IDSECTOR = _IDSECTOR;
  TIDSector = IDSECTOR;
  PIDSector = ^TIDSector;
  {}
  _SRB_IO_CONTROL = packed record
    HeaderLength: DWORD;
    Signature: array[0..7] of Char;
    Timeout: DWORD;
    ControlCode: DWORD;
    ReturnCode: DWORD;
    Length: DWORD;
  end;
  SRB_IO_CONTROL = _SRB_IO_CONTROL;
  TSrbIoControl = SRB_IO_CONTROL;
  PSrbIoControl = ^TSrbIoControl;
  {}
  {Define the different storage bus types, bus types below 128 (0x80)
  are reserved for Microsoft use}
  _STORAGE_BUS_TYPE = Integer;
  STORAGE_BUS_TYPE = _STORAGE_BUS_TYPE;
  TStorageBusType = STORAGE_BUS_TYPE;
  {}
  {Property Query Structures}
  {IOCTL_STORAGE_QUERY_PROPERTY, Input Buffer - a STORAGE_PROPERTY_QUERY
  structure which describes what type of query is being done, what property
  is being queried for, and any additional parameters which a particular
  property query requires, Output Buffer - contains a buffer to place the
  results of the query into, since all property descriptors can be cast into
  a STORAGE_DESCRIPTOR_HEADER, the IOCTL can be called once with a small buffer
  then again using a buffer as large as the header reports is necessary}
  {Types of queries}
  _STORAGE_QUERY_TYPE = Integer;
  STORAGE_QUERY_TYPE = _STORAGE_QUERY_TYPE;
  TStorageQueryType = STORAGE_QUERY_TYPE;
  {Some initial property id's}
  _STORAGE_PROPERTY_ID = Integer;
  STORAGE_PROPERTY_ID = _STORAGE_PROPERTY_ID;
  TStoragePropertyId = STORAGE_PROPERTY_ID;
  {Query structure - additional parameters for specific queries can follow
  the header}
  _STORAGE_PROPERTY_QUERY = record
    {ID of the property being retrieved}
    PropertyId: TStoragePropertyId;
    {Flags indicating the type of query being performed}
    QueryType: TStorageQueryType;
    {Space for additional parameters if necessary}
    AdditionalParameters: array[0..0] of Char;
  end;
  STORAGE_PROPERTY_QUERY = _STORAGE_PROPERTY_QUERY;
  TStoragePropertyQuery = STORAGE_PROPERTY_QUERY;
  PStoragePropertyQuery = ^TStoragePropertyQuery;
  {Standard property descriptor header, all property pages should use this
  as their first element or should contain these two elements}
  _STORAGE_DESCRIPTOR_HEADER = packed record
    Version: DWORD;
    Size: DWORD;
  end;
  STORAGE_DESCRIPTOR_HEADER = _STORAGE_DESCRIPTOR_HEADER;
  TStorageDescriptorHeader = STORAGE_DESCRIPTOR_HEADER;
  PStorageDescriptorHeader = ^TStorageDescriptorHeader;
  {Device property descriptor - this is really just a rehash of the inquiry
  data retrieved from a scsi device, this may only be retrieved from a target
  device, sending this to the bus will result in an error}
  _STORAGE_DEVICE_DESCRIPTOR = packed record
    {Sizeof(_STORAGE_DEVICE_DESCRIPTOR)}
    Version: DWORD;
    {Total size of the descriptor, including the space for additional
    data and id strings}
    Size: DWORD;
    {The SCSI-2 device type}
    DeviceType: Char;
    {The SCSI-2 device type modifier, if any, - this may be zero}
    DeviceTypeModifier: Char;
    {Flag indicating whether the device's media (if any) is removable, this
    field should be ignored for media-less devices}
    RemovableMedia: Boolean;
    {Flag indicating whether the device can support mulitple outstanding
    commands, the actual synchronization in this case is the responsibility
    of the port driver}
    CommandQueueing: Boolean;
    {Byte offset to the zero-terminated ascii string containing the device's
    vendor id string, for devices with no such ID this will be zero}
    VendorIdOffset: DWORD;
    {Byte offset to the zero-terminated ascii string containing the device's
    product id string, for devices with no such ID this will be zero}
    ProductIdOffset: DWORD;
    {Byte offset to the zero-terminated ascii string containing the device's
    product revision string, for devices with no such string this will be zero}
    ProductRevisionOffset: DWORD;
    {Byte offset to the zero-terminated ascii string containing the device's
    serial number, for devices with no serial number this will be zero}
    SerialNumberOffset: DWORD;
    {Contains the bus type, as defined above, of the device, it should be used
    to interpret the raw device properties ending this structure, if any}
    BusType: TStorageBusType;
    {The number of bytes of bus-specific data which have been appended to
    this descriptor}
    RawPropertiesLength: DWORD;
    {Place holder for the first byte of the bus specific property data}
    RawDeviceProperties: array[0..0] of Char;
  end;
  STORAGE_DEVICE_DESCRIPTOR = _STORAGE_DEVICE_DESCRIPTOR;
  TStorageDeviceDescriptor = STORAGE_DEVICE_DESCRIPTOR;
  PStorageDeviceDescriptor = ^TStorageDeviceDescriptor;
  {Serial number record}
  _MEDIA_SERAL_NUMBER_DATA = packed record
    SerialNumberLength: DWORD;
    Result: DWORD;
    Reserved: array[0..1] of DWORD;
    SerialNumberData: array[0..0] of Char;
  end;
  MEDIA_SERAL_NUMBER_DATA = _MEDIA_SERAL_NUMBER_DATA;
  TMedialSerialNumberData = MEDIA_SERAL_NUMBER_DATA;
  PMedialSerialNumberData = ^TMedialSerialNumberData;

{      : cuiCPUUsage -
  , cuiNumberOfThreads -  ,
cuiNumberOfDOSVirtualMachines -    DOS,
cuiBytesReadPerSecond -      ,
cuiBytesWrittenPerSecond -      , cuiDirty -
, cuiReadsPerSecond -    , cuiWritesPerSecond -
   }
type
  TCPUUsageItem = (cuiCPUUsage, cuiNumberOfThreads,
    cuiNumberOfDOSVirtualMachines, cuiBytesReadPerSecond,
    cuiBytesWrittenPerSecond, cuiDirty, cuiReadsPerSecond,
    cuiWritesPerSecond);
{      }
function GetCPUUsageInfo(Item: TCPUUsageItem): Integer;
{  BIOS}
type
  TBIOSInfo = record
    Version: string;      {}
    Copyright: string;    {}
    Date: string;         {}
    SerialNumber: string; { }
  end;
  PBIOSInfo = ^TBIOSInfo;
{   Value}
procedure InitBIOSInfo(out Value: TBIOSInfo);
{    BIOS: bdmDebug -   ,
 ,      , bdmMemoryWin9X -
     Windows 9x, bdmMemSectionWinNT -  
  ZwOpenSection  Windows NT/2000  , bdmDOSExe -  
     DOS-, bdmDateRegistryWin9X - 
    Windows 9x, bdmDateRegistryWinNT -    
 Windows NT/2000  , bdmVersionRegistryWinNT -    
 Windows NT/2000  }
type
  TBIOSInfoDetectMethods = set of (bdmDebug, bdmMemoryWin9X,
    bdmMemSectionWinNT, bdmDOSExe, bdmDateRegistryWin9X, bdmDateRegistryWinNT,
    bdmVersionRegistryWinNT);
{   BIOS, ExcludedMethods   
  (BIOSInfo);      Info
 BIOS,   AsIdentifier = True -  :
Date-Version-SerialNumber, ,
02/16/96-Award Modular BIOS v4.50PG-02/17/96-i430FX-2A59CT4AC-00,
  ,    (BIOSInfoToStr);
    BIOSInfoToStr     BIOS
,  BIOSInfo (BIOSInfoStr)}
function BIOSInfo(ExcludedMethods: TBIOSInfoDetectMethods): TBIOSInfo;
function BIOSInfoToStr(const Info: TBIOSInfo; AsIdentifier: Boolean): string;
function BIOSInfoStr(ExcludedMethods: TBIOSInfoDetectMethods;
  AsIdentifier: Boolean): string;
type
  {   }
  THDDItemInfo = record
    ModelNumber: string;  {}
    FirmwareRev: string;  {}
    SerialNumber: string; { }
  end;
  {   }
  THDDInfo = array[0..3] of THDDItemInfo;
  PHDDInfo = ^THDDInfo;
{   Value (InitHDDItemInfo, InitHDDInfo)}
procedure InitHDDItemInfo(out Value: THDDItemInfo);
procedure InitHDDInfo(out Value: THDDInfo);
{     : hdmDebug - 
 ,  ,      ,
hdmSmartWin9X -   SmartVsd.vxd  Windows 9x, hdmSmartWinNT -
    Smart  Windows NT/2000  , 
 , hdmSCSIMiniportWinNT -   Smart 
SCSI Miniport  Windows NT/2000  , hdmStoragePropWinNT -   
, hdmVXDWin9X -     vxd-,
  DiskId32 (freeware)  Windows 9x, hdmRegistryWinNT - 
   Windows NT/2000  , hdmMediaSerialWinNT -  
      Windows NT/2000  }
type
  THDDInfoDetectMethods = set of (hdmDebug, hdmSmartWin9X, hdmSmartWinNT,
    hdmSCSIMiniportWinNT, hdmStoragePropWinNT, hdmVXDWin9X, hdmRegistryWinNT,
    hdmMediaSerialWinNT);
{     , ExcludedMethods 
    (HDDInfo);   
  Info   ,   AsIdentifier = True -  
   : ModelNumber-FirmwareRev-SerialNumber, ,
FUJITSU MPA3043ATU-9517-01126571,
  ,    (HDDInfoToStr);
    HDDInfoToStr     
 ,  HDDInfo (HDDInfoStr)}
function HDDInfo(ExcludedMethods: THDDInfoDetectMethods): THDDInfo;
function HDDInfoToStr(const Info: THDDInfo; AsIdentifier: Boolean): string;
function HDDInfoStr(ExcludedMethods: THDDInfoDetectMethods;
  AsIdentifier: Boolean): string;
{   PCI    Names,   ,
        ,  
     }
procedure PCIDrivers(Names: TStrings);
{      Setup API,   Windows 98/NT,
ParentHandle    ,  PresendOnly
   ,  DeviceGUIDs,   nil,
      ,
 DeviceInstanceIds,   nil,   ,
 DeviceDescs,   nil,  ,  FriendlyNames,   nil,
   ,   
,  PresentOnly  True   
,  RemovableOnly  True   
 (DeviceList);      
DeviceName   ,     DeviceGUID,
  nil,    ,   
       GUID_NULL  
  ,     
 GGlbUtil.DeviceEject (DeviceNameToInstanceId)}
function DeviceList(ParentHandle: HWND; PresentOnly, RemovableOnly: Boolean;
  DeviceGUIDs, DeviceInstanceIds, DeviceDescs,
  FriendlyNames: TIndexedStrings): Integer;
function DeviceNameToInstanceId(const DeviceName: string;
  DeviceGUID: PGUID): string;
type
  {   : siiCPU -   , siiBIOS -
    BIOS, siiHDD -    }
  TSystemInfoItem = (siiCPU, siiBIOS, siiHDD);
  TSystemInfoItems = set of TSystemInfoItem;
  PSystemInfoItems = ^TSystemInfoItems;
  {      }
  TSystemInfoDetectMethods = record
    Items: TSystemInfoItems;
    CPUMethods: TCPUInfoDetectMethods;
    BIOSMethods: TBIOSInfoDetectMethods;
    HDDMethods: THDDInfoDetectMethods;
  end;
  PSystemInfoDetectMethods = ^TSystemInfoDetectMethods;
  {      }
  TSystemInfo = record
    CPUInfo: TCPUInfo;
    BIOSInfo: TBIOSInfo;
    HDDInfo: THDDInfo;
  end;
{   Value (InitSystemInfoDetectMethods, InitSystemInfo);
        
    CPUInfo, BIOS BIOSInfo,   HDDInfo
(ASystemInfo)}
procedure InitSystemInfoDetectMethods(out Value: TSystemInfoDetectMethods);
procedure InitSystemInfo(out Value: TSystemInfo);
function SystemInfo(const CPUInfo: TCPUInfo; const BIOSInfo: TBIOSInfo;
  const HDDInfo: THDDInfo): TSystemInfo;
{   ,     
,   ExcludedMethods,   nil (SystemInfo); 
    Info  ,  , 
 ExcludedItems,  AsIdentifier = True     ";",
  : CPU:CPUIdentifier|BIOS:BIOSIdentifier|HDD:HDDIdentifier,
  ,   :
CPU:GenuineIntel-0000068A-0387F9FF-0000C30C-9C8895C0|BIOS:02/16/96-Award
Modular BIOS v4.50PG-02/17/96-i430FX-2A59CT4AC-00|HDD:FUJITSU
MPA3043ATU-9517-01126571 (SystemInfoToStr);    
SystemInfo         SystemInfoToStr
(SystemInfoStr)}
function GetSystemInfo(ExcludedMethods: PSystemInfoDetectMethods): TSystemInfo;
function SystemInfoToStr(const Info: TSystemInfo;
  ExcludedItems: TSystemInfoItems; AsIdentifier: Boolean): string;
function SystemInfoStr(ExcludedMethods: PSystemInfoDetectMethods;
  AsIdentifier: Boolean): string;
{        
}
procedure SysIdRun;
{  ,    "|"  ";"}
type
  TSysId = record
    CPUId: string;  {  }
    BIOSId: string; {  BIOS}
    HDDId: string;  {   }
  end;
  PSysId = ^TSysId;
{   Value}
procedure InitSysId(out Value: TSysId);
{ True,      SysId 
(SysIdIsEmpty);     SystemInfo   
  (SystemInfoToSysId);   
 SysId  ,  .  SystemInfo (SysIdToStr); 
 S     (StrToSysId);  
  SysId     
BaseSysId,     ,  
      , 
    , ..    ,
  (SysIdCompare);     SysId,
  ,   ExcludedItems,   
(SysIdExclude);       SysId
(SysIdExcluded)}
function SysIdIsEmpty(const SysId: TSysId): Boolean;
function SystemInfoToSysId(const SystemInfo: TSystemInfo): TSysId;
function SysIdToStr(const SysId: TSysId): string;
function StrToSysId(const S: string): TSysId;
function SysIdCompare(const SysId, BaseSysId: TSysId): TSetCompare;
function SysIdExclude(const SysId: TSysId;
  ExcludedItems: TSystemInfoItems): TSysId;
function SysIdExcluded(const SysId: TSysId): TSystemInfoItems;
{  TSysId}
type
  TSysIds = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TSysId;
    procedure SetItem(Index: Integer; const Value: TSysId);
    function GetItemPtr(Index: Integer): PSysId;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TSysId): Integer;
    procedure Insert(Index: Integer; const Value: TSysId);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TSysId read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PSysId read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{     SysIds,  ,
 ,      SystemInfoToStr   "; ",
,     ,    
(SysIdsToStr);    S   
 SysIds, ,     ,  
  (StrToSysIds)}
function SysIdsToStr(SysIds: TSysIds): string;
procedure StrToSysIds(const S: string; SysIds: TSysIds);
{     }
type
  ESysIdError = class(ExceptionStd);
{       
SysIdsStr,     , 
 ExcludedMethods,   ,  TempSysIds   
   TSysIds    , 
 nil       
,  SysIdsStr   SysIdsToStr,    
 'All',   , 
,       ,
  ,      
  ,     SysId,   
  ,   SysId   , 
   ,    SysId
(CheckSysId); ,      ESysIdError
(VerifySysId);     SysIdsStr 
CheckSysId,  IsAddSysId = True    
 ,    CheckSysId,   
 ,   ExcludedMethods,   
    ,   ExcludedMethods,
       , 
SysIdsStr   'All',  TempSysIds    
  TSysIds    ,   nil 
      , 
     SysIdsStr    
  SysId,   ,   SysId  
,     , 
  SysId (UpdateSysId)}
function CheckSysId(const SysIdsStr: string; ExcludedMethods:
  PSystemInfoDetectMethods; TempSysIds: TSysIds; var SysId: TSysId): string;
procedure VerifySysId(const SysIdsStr: string; ExcludedMethods:
  PSystemInfoDetectMethods; TempSysIds: TSysIds; var SysId: TSysId);
function UpdateSysId(var SysIdsStr: string; IsAddSysId: Boolean;
  ExcludedMethods: PSystemInfoDetectMethods; TempSysIds: TSysIds;
  var SysId: TSysId): Boolean;



{---  --------------------------------------------------------------------}

{     }
type
  EWindowError = class(EWinAPIError);
{  , Wnd  ,   
,      0  ,    
  EWinAPIError,     
 }
function CheckWndError(Wnd: HWND): HWND;

{    -    Message-PRO
    }
type
  TMProSignAltForm = class(TMProCustomSignForm)
  private
    FKeysHidden: Boolean;
    FAltNames: TIndexedStrings;
    FAltIsPSEs: TList;
    FAltPrivateKeys: TStrings;
    FAltPSEPrivateKeys: TStrings;
    FAltCertificates: TStrings;
    FAltCACertificates: TStrings;
    procedure WMCommand(var Message: TWMCommand); message WM_COMMAND;
  protected
    FTextNames: HWND;
    FListBoxNames: HWND;
    FButtonKeys: HWND;
    {}
    function GetStoredIsPSE: Boolean; override;
    procedure SetStoredIsPSE(NewStoredIsPSE: Boolean); override;
    function GetStoredPrivateKey: string; override;
    procedure SetStoredPrivateKey(const NewStoredPrivateKey:
      string); override;
    function GetStoredPSEPrivateKey: string; override;
    procedure SetStoredPSEPrivateKey(const NewStoredPSEPrivateKey:
      string); override;
    function GetStoredCertificate: string; override;
    procedure SetStoredCertificate(const NewStoredCertificate:
      string); override;
    function GetStoredCACertificate: string; override;
    procedure SetStoredCACertificate(const NewStoredCACertificate:
      string); override;
  public
    {    TMProSignForm,
    AltNames    , AltIsPSEs, AltPrivateKeys,
    AltPSEPrivateKeys, AltCertificates, AltCACertificates  
     IsPSE, PrivateKey, PSEPrivateKey, Certificate, CACertificate
      , AltIndex   
      (-1),   ,   
    , KeysHidden      
     }
    constructor Create(ParentHandle: HWND; const Title: string; IsPSE: Boolean;
      const PrivateKey, PSEPrivateKey, Certificate, CACertificate,
      Data: string; IsMulti: Boolean; const ServerHost, UserName, Mode,
      Params: string; AltNames: TIndexedStrings; AltIsPSEs: TList;
      AltPrivateKeys, AltPSEPrivateKeys, AltCertificates,
      AltCACertificates: TStrings; var AltIndex: Integer; KeysHidden: Boolean);
    destructor Destroy; override;
    {}
    { , AltNames    ,
    AltIsPSEs, AltPrivateKeys, AltPSEPrivateKeys, AltCertificates,
    AltCACertificates      IsPSE,
    PrivateKey, PSEPrivateKey, Certificate, CACertificate  
     (AltNames, AltIsPSEs, AltPrivateKeys, AltPSEPrivateKets,
    AltCertificates, AltCACertificates);     
      (KeysHidden)}
    property AltNames: TIndexedStrings read FAltNames;
    property AltIsPSEs: TList read FAltIsPSEs;
    property AltPrivateKeys: TStrings read FAltPrivateKeys;
    property AltPSEPrivateKeys: TStrings read FAltPSEPrivateKeys;
    property AltCertificates: TStrings read FAltCertificates;
    property AltCACertificates: TStrings read FAltCACertificates;
    property KeysHidden: Boolean read FKeysHidden;
  end;
{     - 
MProSignDlg, AltNames    , AltIsPSEs,
AltPrivateKeys, AltPSEPrivateKeys, AltCertificates, AltCACertificates 
  IsPSE, PrivateKey, PSEPrivateKey, Certificate,
CACertificate      ,   
 False, AltIndex      (-1),
  ,    , KeysHidden 
      }
function MProSignAltDlg(ParentHandle: HWND; const Title: string;
  var IsPSE: Boolean; var PrivateKey, PSEPrivateKey, Certificate,
  CACertificate: string; const Data: string; IsMulti: Boolean;
  const ServerHost, UserName, Mode, Params: string; AltNames: TIndexedStrings;
  AltIsPSEs: TList; AltPrivateKeys, AltPSEPrivateKeys, AltCertificates,
  AltCACertificates: TStrings; var AltIndex: Integer; var KeysHidden: Boolean;
  OnException: TExceptionEventStd; OnDefineData: TDefineDataEvent;
  OnCertificateView: TMProCertificateViewEvent;
  OnResetKeys: TMProResetKeysEvent): Boolean;

{   : cdptTemp - ,  ,
cdptStored - , cdptProtectedStored -   
}
type
  TOperDlgParamType = (odptNotStored, odptStored, odptProtectedStored);
{     }
type
  TCustomOperDlg = class(TObjectStd)
  private
    FBaseRegistryKey: string;
    FClassRegistryKey: string;
    FValues: TParamValues;
    FAltNames: TIndexedStrings;
    FAltValues: TObjList; {TParamValues}
    FRegistryPartComment: string;
    FRegistryPartAltComment: string;
  protected
    {      RegistryKey,
        RegistryPartComment,
      UseAlt  True    
    RegistryPartAltComment,  CheckSupported  True  ,
          ,   
        ,  }
    function RegistryPartNum(const RegistryKey: string;
      CheckSupported, UseAlt: Boolean): string;
    {   ,    256-
     DefaultKey}
    function ProtectKey: string; virtual;
    {    E,   ,  
     ,       
       'ParentHandle'  Values}
    procedure ShowError(E: TObject); virtual;
    {     ,  
     BaseRegistryKey, ClassRegistryKey,    
       'GroupRegistryKey'  'UserRegistryKey'
     Values,     ,   
    'UserRegistryKey' ,  'GroupRegistryKey' ,  
       'GroupRegistryKey' 
     'Default',   Name    
      }
    function RegistryKey(const Name: string): string; virtual;
    { ,   Values,    RegistryKey,
     ,      RC6,
     DestValues   nil     DestValues}
    procedure LoadValues(const RegistryKey: string;
      Values, DestValues: TParamValues); virtual;
    { ,   Values,    RegistryKey,
            
    ,  E  ,    
     nil,   ,  DestValues   nil 
      DestValues}
    procedure SaveValues(const RegistryKey: string;
      Values, DestValues: TParamValues; const E: TObject); virtual;
    { ,    Data,  Values,
        AltNames    
    AltValues  TParamValues,    AltIndex,
     ,    (-1),     
      KeysHidden,     True,
     False}
    function ShowDlg(const Data: string; Values: TParamValues;
      AltNames: TIndexedStrings; AltValues: TObjList {TParamValues};
      var AltIndex: Integer; var KeysHidden: Boolean): Boolean;
      virtual; abstract;
    { ,    Data,  Values,
        AltValues  TParamValues,
       AltIndex,  ,    
    }
    function DoExecute(const Data: string; Values: TParamValues;
      AltValues: TObjList {TParamValues}; AltIndex: Integer): string;
      virtual; abstract;
    {}
    {,   ,    
        ,    TOperDlgParamType,
          
     }
    function GetValues: TParamValues;
    {  }
    function GetAltNames: TIndexedStrings;
    function GetAltValues(Index: Integer): TParamValues;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {    ,    Data,
      'NotShowDialog'  Values  '1'  
        ,    ,
         ,   
     ,      
      ECanceled,      
     ,  EExceptionInfo    
    ,    ,   
     Values,      odptProtectedStored
    }
    function Execute(const Data: string): string;
    {}
    {  ,   RegCommonKey (BaseRegistryKey);
        ,    ClassName  
    'T' ,   (ClassRegistryKey);  ,
      TOperDlgParamType,    
    'GroupRegistryKey', 'UserRegistryKey', 'ParentHandle', 'NotShowDialog'
    (Values);     
      ,  (AltNames, AltValues); ,
          
    (RegistryPartComment);      
         (RegistryPartAltComment)}
    property BaseRegistryKey: string
      read FBaseRegistryKey write FBaseRegistryKey;
    property ClassRegistryKey: string
      read FClassRegistryKey write FClassRegistryKey;
    property Values: TParamValues read GetValues;
    property AltNames: TIndexedStrings read GetAltNames;
    property AltValues[Index: Integer]: TParamValues read GetAltValues;
    property RegistryPartComment: string
      read FRegistryPartComment write FRegistryPartComment;
    property RegistryPartAltComment: string
      read FRegistryPartAltComment write FRegistryPartAltComment;
  end;

{ GDI+}  
type
  EGDIPlusError = class(EWinAPIError);
  EGDIPlusErrorClass = class of EGDIPlusError;
{  GDI+   Msg  ,    ,
   ErrorCode    ProcName,  
 ,  GDIPlusErrorClass,  nil  
EGDIPlusError,  MsgOnly = True      Msg}
function GDIPlusErrorCreate(const Msg: string; ErrorCode: TGDIPlusStatus;
  const ProcName: string; GDIPlusErrorClass: EGDIPlusErrorClass;
  MsgOnly: Boolean): EGDIPlusError;
{ GDI+ API}
type
  TGDIPlusAPI = class(TObjectStd)
  private
    FProc: TFarProc;
    FLastError: TGDIPlusStatus;
    FLastResult: TGDIPlusStatus;
    FIsInitCalled: Boolean;
    FIsInited: Boolean;
    FInitToken: ULONG;
    FGDIPlusDLL: TDLLLoadInfo;
    FGDIPlusStartup: TDLLProcInfo;
    FGDIPlusShutdown: TDLLProcInfo;
    FGDIPCreateBitmapFromStream: TDLLProcInfo;
    FGDIPCreateBitmapFromFile: TDLLProcInfo;
    FGDIPCreateHBITMAPFromBitmap: TDLLProcInfo;
  protected
    function LoadGDIPlusProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   GDI+}
    function GDIPlusStartup(Input: PGDIPlusStartupInput;
      Output: PGdiplusStartupOutput): ULONG;
    procedure GDIPlusShutdown(Token: ULONG);
    function GDIPCreateBitmapFromStream(Stream: IStream): TGDIPlusBitmap;
    function GDIPCreateBitmapFromFile(const FileName:
      string): TGDIPlusBitmap;
    function GDIPCreateHBitmapFromBitmap(Bitmap: TGDIPlusBitmap;
      Background: TGDIPlusARGB): HBITMAP;
    {}
    {     , 
          , 
        }
    procedure Init;
    {    Background   Stream, 
      (StreamToBitmap);     Background
      FileName,    (FileToBitmap)}
    function StreamToBitmap(Stream: IStream;
      Background: TGDIPlusARGB): HBITMAP;
    function FileToBitmap(const FileName: string;
      Background: TGDIPlusARGB): HBITMAP;
    {}
    {  GDI+}
    property LastError: TGDIPlusStatus read FLastError;
  end;
{}
{       GDI+;  
    }
function GDIPlusAPI: TGDIPlusAPI;
{    GDI+ }
procedure GDIPlusAPIReset;



{---       ----------------------}

type
  {  }
  ECryptoError = class(ENumProcError);
  {  }
  ECryptoVerifyError = class(ECryptoError);
{     E,     ECryptoError, 
IsVerifyError = True -  ECryptoVerifyError}
function IsCryptoError(E: TObject; IsVerifyError: Boolean): Boolean;

{    }
type
  ECRCError = class(Exception);
{     Stream   
 ,  Stream = nil  CRC  ,   $FFFFFFFF}
function StreamCRC(Stream: TStream): DWORD;
{        }
type
  ECRCVerifyError = class(ECryptoVerifyError);
{    Data,   IsFileName = True - 
  Data,  ErrorIfNoFile = True  ,   
,  CRCs       
   : 1:CRC1;2:CRC2  ..,   
 ,    ECRCVerifyError,
 ErrorIfNoFile = False,    ,    CRC  ,
  0  $FFFFFFFF ,  DataCRCStr    DataLenPtr,
 ,      , ,
 CRC     CRCFunc,    ,
   CRCMethod,    ,   
}
procedure VerifyCRC(CRCFunc: TCalcFunc; CRCMethod: TCalcMethod;
  const Data: string; IsFileName, ErrorIfNoFile: Boolean;
  const CRCs: string; out DataCRCStr: string; DataLenPtr: PInteger);

{      }
{}
{   
procedure StringProtectDemo;
  var
    s: string;
begin
  //    (  ProtectStr 
  //   ,    
  //           
  //   )
  s := ProtectStr('some_string', TBlowfishProtectAlgorithm,
    DefaultInitVector, 'testkey!', True);
  //
  //   
  s := UnprotectStr(s, TBlowfishProtectAlgorithm,
    DefaultInitVector, 'testkey!', True);
  //
  if s <> 'some_string' then
    raise Exception.Create('String Protection Failed');
end;}
{}
{   :
procedure StreamProtectDemo;
  var
    s: string;
    protected_file: TFileStream;
    unprotected_stream: TStreamProtect;
begin
  //        ;    
  //    
  protected_file := TFileStreamStd.Create('C:\StreamProtect.test', fmCreate);
  //
  //      , 
  //  /     ( 
  // CreateStreamProtect    , 
  //       )
  unprotected_stream := CreateStreamProtect(protected_file, True, True, True,
    True, TBlowfishProtectAlgorithm, DefaultInitVector, 'testkey!', True);
  //
  //      "ABCDEFGHabcdefghHIJ";
  //    ,      
  s := 'ABCDEFGHabcdefghHIJ';
  unprotected_stream.Write(s[1], Length(s));
  //
  //   ;      
  //   (     
  //  )
  unprotected_stream.Free;
  //
  //    ;    "ABCDEFGHabcdefghHIJ"
  //   
  protected_file := TFileStreamStd.Create('C:\StreamProtect.test',
    fmOpenReadWrite);
  //
  //      (5-   False,   
  //         )
  unprotected_stream := CreateStreamProtect(protected_file, True, True, True,
    False, TBlowfishProtectAlgorithm, DefaultInitVector, 'testkey!', True);
  //
  //  6   3-    ;
  //        
  //  ,       
  unprotected_stream.Position := 3;
  SetLength(s, 6);
  FillChar(s[1], Length(s), 0);
  unprotected_stream.Read(s[1], 6); //  "DEFGHa"
  //
  //  5    17;   
  // "ABCDEFGHabcdefghHIJ"   "ABCDEFGHabcdefghHqwer"
  s := 'qwert';
  unprotected_stream.Position := 17;
  unprotected_stream.Write(s[1], Length(s)); //  "IJ"  "qwer"
  unprotected_stream.Position := 0;
  //
  //  
  unprotected_stream.Free;
end;}
{}
{:         
,   -  }

{        ;
    ,   
           }
type
  TCustomProtectAlgorithm = class(TObjectStd)
  private
    FIsKeysCaching: Boolean;
    FMaxCachedKeys: Integer;
    FCachedAlgorithmData: TList;
    FCachedInitVectors: TStringList;
    FCachedKeys: TStringList;
    FCacheLastIndex: Integer;
  protected
    { ;    }
    FAlgorithmName: string;
    {       ;
      0  High(Integer) ;   
      }
    FMinInitVectorLen: Integer;
    FMaxInitVectorLen: Integer;
    FMinKeyLen: Integer;
    FMaxKeyLen: Integer;
    { AlgorithmData^  ; 0 -   
     ; (-1) -       ;
      (-1);    }
    FAlgorithmDataSize: Integer;
    {}
    procedure SetMaxCachedKeys(NewMaxCachedKeys: Integer);
    function CacheFind(out AlgorithmData: Pointer;
      const InitVector, Key: string): Integer;
    procedure CacheAdd(AlgorithmData: Pointer;
      const InitVector, Key: string);
    {}
    {    ;  
    ;      }
    procedure AlgInit(var AlgorithmData: Pointer;
      InitVector, Key: string); virtual;
    { ;      }
    procedure AlgDone(AlgorithmData: Pointer); virtual;
    { ;      ( )
        }
    procedure AlgCorrectVectorKey(var InitVector, Key: string); virtual;
    {   ;   
        FAlgorithmDataSize    , 
    FAlgorithmDataSize > 0      
    (  )}
    function AlgCloneData(var AlgorithmData: Pointer): Pointer; virtual;
  public
    constructor Create; virtual;
    destructor Destroy; override;
    {}
    {     ()  
     (  );   AlgorithmData;
      IsKeysCaching = True    , 
        AlgorithmData;
            ;
             MaxCachedKeys
       ;
       ( , )  
       }
    procedure AlgorithmInit(out AlgorithmData: Pointer;
      const InitVector, Key: string); virtual;
    {    , 
      AlgorithmData}
    procedure AlgorithmDone(var AlgorithmData: Pointer); virtual;
    {       }
    function ProtectStr(var AlgorithmData: Pointer; const S: string): string;
      virtual; abstract;
    function UnprotectStr(var AlgorithmData: Pointer; const S: string): string;
      virtual; abstract;
    {}
    { }
    property AlgorithmName: string read FAlgorithmName;
    {        }
    property MinInitVectorLen: Integer read FMinInitVectorLen;
    property MaxInitVectorLen: Integer read FMaxInitVectorLen;
    property MinKeyLen: Integer read FMinKeyLen;
    property MaxKeyLen: Integer read FMaxKeyLen;
    {   (  - True)  
       (  - 64)}
    property IsKeysCaching: Boolean read FIsKeysCaching write FIsKeysCaching;
    property MaxCachedKeys: Integer read FMaxCachedKeys write SetMaxCachedKeys;
  end;
{}
{      }
type
  TProtectAlgorithmClass = class of TCustomProtectAlgorithm;

{   }
function ProtectStr(const S: string; ProtectAlgorithm: TProtectAlgorithmClass;
  const InitVector, Key: string; AllowKeysCaching: Boolean): string;
{}
{     }
function UnprotectStr(const S: string; ProtectAlgorithm:
  TProtectAlgorithmClass; const InitVector, Key: string;
  AllowKeysCaching: Boolean): string;
{}
{     ;
   True}
function ProtectAlgorithmTest(ProtectAlgorithm:
  TProtectAlgorithmClass): Boolean;
{}
{     ;
 IsProtecting = True   ,  -  ;
StrSize   ,  Iterations -   ;
  ,   }
function ProtectAlgorithmSpeed(ProtectAlgorithm: TProtectAlgorithmClass;
  IsProtecting: Boolean; StrSize, Iterations: Integer): Extended;
{}
{     ProtectableStrToStr,
StrToProtectableStr}
const
  ProtectedHeader = 'HNOTEPAD PASSWORD PROTECTED TEXT FILE' + #26;
{     Value   ,
ProtectedHeader    , ParentHandle 
  , Title   , ProtectAlgorithm
  ,  Password     ,
    (ProtectableStrToStr);   Value
    , ProtectedHeader  
 , ProtectAlgorithm   ,  Password
 ,       (StrToProtectableStr)}
function ProtectableStrToStr(const Value, ProtectedHeader: string;
  ParentHandle: HWND; const Title: string; ProtectAlgorithm:
  TProtectAlgorithmClass; out Password: string): string;
function StrToProtectableStr(const Value, ProtectedHeader: string;
  ProtectAlgorithm: TProtectAlgorithmClass; const Password: string): string;
{}  
{  Value  IsDecrypt  False    Value
 IsDecrypt  True    TRC6ProtectAlgorithm,
  DefInitVector,  DefKeyBase}
function CryptStr(const Value: string; IsDecrypt: Boolean): string;

{   ;  
     }
type
  TProtectAlgorithmManager = class(TObjectStd)
  private
    FProtectAlgorithms: TList;
    FProtectAlgorithmsLastIndex: Integer;
  protected
    function GetAlgoritms(ProtectAlgorithm: TProtectAlgorithmClass):
      TCustomProtectAlgorithm;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   (     )  }
    procedure RemoveAlgorithm(ProtectAlgorithm: TProtectAlgorithmClass);
    {  }
    procedure RemoveAllAlgorithms;
    {}
    {        
     ;   - ;   - 
      ,      ;
        }
    property Algorithms[ProtectAlgorithm: TProtectAlgorithmClass]:
      TCustomProtectAlgorithm read GetAlgoritms; default;
  end;
{}
{      (   
  ,        ;
      )}
function ProtectAlgorithms: TProtectAlgorithmManager;
{   }
procedure ProtectAlgorithmsReset;

{ }
const
  {}
  DefaultSubAlgorithm = 0;
  {    ,    
  /    }
  NotChainingSubAlgorithm = 1;
{}
{       
}
type
  TCustomBlockProtectAlgorithm = class(TCustomProtectAlgorithm)
  private
  protected
    { ;     1;   
    }
    FBlockSize: Integer;
  public
    constructor Create; override;
    {}
    {,       
    }
    procedure ProtectBlocks(var AlgorithmData: Pointer;
      SubAlgorithm: Integer; var Blocks; BlockCount: Integer);
      virtual; abstract;
    procedure UnprotectBlocks(var AlgorithmData: Pointer;
      SubAlgorithm: Integer; var Blocks; BlockCount: Integer);
      virtual; abstract;
    { (     )}
    procedure AlgorithmReset(var AlgorithmData: Pointer); virtual;
    {}
    function ProtectStr(var AlgorithmData: Pointer; const S: string): string;
      override;
    function UnprotectStr(var AlgorithmData: Pointer; const S: string): string;
      override;
    {}
    {       }
    property BlockSize: Integer read FBlockSize;
  end;

{      }
type
  TStringProtect = class(TObjectStd)
  private
    FProtectAlgorithm: TCustomProtectAlgorithm;
    FInitVector: string;
    FKey: string;
    FAlgorithmData: Pointer;
    FIsAlgorithmInited: Boolean;
  protected
    procedure SetInitVector(NewInitVector: string);
    procedure SetKey(NewKey: string);
    {}
    procedure AlgorithmInit;
    procedure AlgorithmDone;
  public
    constructor Create(ProtectAlgorithm: TCustomProtectAlgorithm;
      const InitVector, Key: string);
    destructor Destroy; override;
    {}
    { ,    }
    function ProtectStr(S: string): string;
    function UnprotectStr(S: string): string;
    {}
    {  }
    property ProtectAlgorithm: TCustomProtectAlgorithm read FProtectAlgorithm;
    {   }
    property InitVector: string read FInitVector write SetInitVector;
    property Key: string read FKey write SetKey;
  end;
{}
{      ,
       }
function CreateStringProtect(ProtectAlgorithmClass: TProtectAlgorithmClass;
  const InitVector, Key: string): TStringProtect;

{        
}
type
  TKeyAccess = class(TObjectStd)
  private
    FAlg: TProtectAlgorithmClass;
    FInitVector: string;
    FKeyEncodeCode: Integer;
    FKeyEncodeStep: Integer;
    FKeyEncodeAdd: Integer;
    FKey: string;
    FKeyEncoded: string;
    FAllowKeysCaching: Boolean;
  protected
    function GetKey: string;
    function GetKeyEncoded: string;
  public
    constructor Create;
    {}
    {   S    (ProtectStr);
           S (UnprotectStr)}
    function ProtectStr(const S: string): string;
    function UnprotectStr(const S: string): string;
    {}
    {    ,  
    TBlowfishProtectAlgorithm (Alg);   
      64 ,   DefaultInitVector (InitVector); 
      ,   DefKeyEncodeCodeBase,
    DefKeyEncodeStepBase, DefKeyEncodeAddBase (KeyEncodeCode, KeyEncodeStep,
    KeyEncodeAdd);     256 ,   ,
          KeyEncoded,  
        DefKeyDataBase (Key);  
       256 ,    DefKeyEncodedBase
    (KeyEncoded);      
    ,   True (AllowKeysCaching)}
    property Alg: TProtectAlgorithmClass read FAlg write FAlg;
    property InitVector: string read FInitVector write FInitVector;
    property KeyEncodeCode: Integer read FKeyEncodeCode write FKeyEncodeCode;
    property KeyEncodeStep: Integer read FKeyEncodeStep write FKeyEncodeStep;
    property KeyEncodeAdd: Integer read FKeyEncodeAdd write FKeyEncodeAdd;
    property Key: string read GetKey write FKey;
    property KeyEncoded: string read GetKeyEncoded write FKeyEncoded;
    property AllowKeysCaching: Boolean
      read FAllowKeysCaching write FAllowKeysCaching;
  end;

type
  EStreamProtectError = class(ECryptoError);
  EStreamProtectIncorrOper = class(EStreamProtectError);
{}
{     ,  
  ,       
,          ,  
 -  ,      ,
   -    Seek   ,
           
,   ,    ,  
 - , IsSourceEmpty = True,    Seek}
type
  TStreamProtect = class(TStreamStd)
  public
    FSourceStream: TStream;
    FFreeSourceOnDestroy: Boolean;
    FAllowSeek: Boolean;
    FInitVector: string;
    FKey: string;
    FBlockSize: Integer;
    FIsInited: Boolean;
    FProtectType: Integer;
    FProtectBlockNum: Integer;
    FProtectAlgorithm: TCustomProtectAlgorithm;
    FAlgorithmData: Pointer;
    FSubAlgorithm: Integer;
    FAllowKeysCaching: Boolean;
    {}
    FPhisicalPos: Integer;
    FPhisicalSize: Integer;
    {}
    FBlockCount: Integer;
    FFinalBlockSize: Integer;
    FLastReadCache: string;
    FLastReadBlock: Integer;
    FReadCache: string;
    FWriteCache: string;
    FBlockCache: string;
    FSaveCache: string;
    {}
    FBlockNum: Integer;
    FBlockPos: Integer;
    FBlock: string;
    FBlockLen: Integer;
    FIsSaved: Boolean;
  protected
    procedure SetProtectType(NewProtectType: Integer);
    procedure SetProtectBlockNum(NewProtectBlockNum: Integer);
    {}
    procedure InitProtect;
    procedure DoneProtect;
    {   }
    procedure InitAlgorithm(const InitVector, Key: string);
    procedure DoneAlgorithm;
    {}
    function PhisicalRead(Position: Integer;
      var Buffer; BufferSize: Integer): Integer;
    function PhisicalWrite(Position: Integer;
      var Buffer; BufferSize: Integer): Integer;
    function PhisicalSeek(Position: Integer): Integer;
    function PhisicalReadBlocks(BlockNum: Integer;
      var Blocks; var BlockCount: Integer): Integer;
    procedure PhisicalWriteBlocks(BlockNum: Integer;
      var Blocks; var BlockCount, FinalBlockSize: Integer);
    function ReadBlocks(BlockNum: Integer;
      var Blocks; var BlockCount: Integer): Integer;
    procedure WriteBlocks(BlockNum: Integer;
      var Blocks; var BlockCount, FinalBlockSize: Integer);
    procedure SaveBlock;
    {}
    procedure ProtectBlocks(BlockNum: Integer;
      var Blocks; BlockCount: Integer);
    procedure UnprotectBlocks(BlockNum: Integer;
      var Blocks; BlockCount: Integer);
    {         
       }
    procedure ProtectBlocksAlgorithm(var Blocks; BlockCount: Integer);
    procedure UnprotectBlocksAlgorithm(var Blocks; BlockCount: Integer);
    {}
    property ProtectType: Integer read FProtectType write SetProtectType;
    property ProtectBlockNum: Integer
      read FProtectBlockNum write SetProtectBlockNum;
  public
    {SourceStream - , , ,
    FreeSourceOnDestroy -  True,  SourceStream 
        ,
    AllowSeek -  True,    Seek,
    IsSourceBegin -  True,  SourceStream.Position = 0,
    IsSourceEmpty -  True,  SourceStream.Size = 0,
    ProtectAlgorithm -   ,   ,
    InitVector -  ,  ,
    Key -    ,
    AllowKeysCaching -  True,    }
    constructor Create(SourceStream: TStream;
      FreeSourceOnDestroy, AllowSeek, IsSourceBegin, IsSourceEmpty: Boolean;
      const ProtectAlgorithm: TCustomProtectAlgorithm; InitVector, Key: string;
      AllowKeysCaching: Boolean);
    destructor Destroy; override;
    {}
    function Read(var Buffer; Count: LongInt): LongInt; override;
    function Write(const Buffer; Count: LongInt): LongInt; override;
    function Seek(Offset: LongInt; Origin: Word): LongInt; override;
    {}
    { Read  Write       - 
    ,   ,  
       ,   Read  Write 
      ,      
      , ResetBuffers  ,    
      ,    }
    procedure ResetBuffers;
    {}
    property SourceStream: TStream read FSourceStream;
    property AllowSeek: Boolean read FAllowSeek;
    property InitVector: string read FInitVector;
    property Key: string read FKey;
    property BlockSize: Integer read FBlockSize;
    property FreeSourceOnDestroy: Boolean read FFreeSourceOnDestroy;
  end;
{}
{  TStreamProtect   
  ,  AllowKeysCaching = True 
    ,
  - .     TStreamProtect}
function CreateStreamProtect(SourceStream: TStream;
  FreeSourceOnDestroy, AllowSeek, IsSourceBegin, IsSourceEmpty: Boolean;
  ProtectAlgorithmClass: TProtectAlgorithmClass;
  InitVector, Key: string; AllowKeysCaching: Boolean): TStreamProtect;

{       Blowfish
c 8-       56 ,
   448 ,   8 ,  64 }
type
  TBlowfishProtectAlgorithm = class(TCustomBlockProtectAlgorithm)
  private
  protected
    procedure AlgInit(var AlgorithmData: Pointer;
      InitVector, Key: string); override;
    procedure AlgDone(AlgorithmData: Pointer); override;
  public
    constructor Create; override;
    {}
    procedure ProtectBlocks(var AlgorithmData: Pointer;
      SubAlgorithm: Integer; var Blocks; BlockCount: Integer); override;
    procedure UnprotectBlocks(var AlgorithmData: Pointer;
      SubAlgorithm: Integer; var Blocks; BlockCount: Integer); override;
    procedure AlgorithmReset(var AlgorithmData: Pointer); override;
  end;

{       RC6
c 16-       256 ,
   2048 ,   16 ,  128 }
type
  TRC6ProtectAlgorithm = class(TCustomBlockProtectAlgorithm)
  private
  protected
    procedure AlgInit(var AlgorithmData: Pointer;
      InitVector, Key: string); override;
    procedure AlgDone(AlgorithmData: Pointer); override;
  public
    constructor Create; override;
    {}
    procedure ProtectBlocks(var AlgorithmData: Pointer;
      SubAlgorithm: Integer; var Blocks; BlockCount: Integer); override;
    procedure UnprotectBlocks(var AlgorithmData: Pointer;
      SubAlgorithm: Integer; var Blocks; BlockCount: Integer); override;
    procedure AlgorithmReset(var AlgorithmData: Pointer); override;
  end;

{       GOST
c 8-      32 ,
  256 ,   8 ,  64 }
type
  TGOSTProtectAlgorithm = class(TCustomBlockProtectAlgorithm)
  private
  protected
    procedure AlgInit(var AlgorithmData: Pointer;
      InitVector, Key: string); override;
    procedure AlgDone(AlgorithmData: Pointer); override;
  public
    constructor Create; override;
    {}
    procedure ProtectBlocks(var AlgorithmData: Pointer;
      SubAlgorithm: Integer; var Blocks; BlockCount: Integer); override;
    procedure UnprotectBlocks(var AlgorithmData: Pointer;
      SubAlgorithm: Integer; var Blocks; BlockCount: Integer); override;
    procedure AlgorithmReset(var AlgorithmData: Pointer); override;
  end;

{  X500    Strings (X500ToStrings);   X500
   Strings,    Index,   Index
      X500 (StringsToX500)}
procedure X500ToStrings(const X500: TX500; Strings: TStrings);
procedure StringsToX500(Strings: TStrings; var Index: Integer;
  var X500: TX500);
{   X500Fields    X500Values  
 X500  AFormat,    X500Divs  
        ,
     ,  Results
       ,   
(X500ParamsToStr);   X500 X500Str   X500Fields,
 X500Values,      X500Div,
 X500Div ,     (StrToX500Params)}
function X500ParamsToStr(X500Fields, X500Values, X500Divs, Results: TStrings;
  AFormat: TX500Format): string;
function StrToX500Params(const X500Str: string; X500Fields, X500Values,
  X500Divs: TStrings): Integer;
{  X500    X500 X500Fields    X500Values
(X500ToParams);    X500 X500Fields    X500Values
   TX500 (ParamsToX500);   X500  
X500  AFormat     Variation
(X500ToStr);   X500Str   TX500 (StrToX500);
  X500 X500Str     AFormat, 
   Variation (X500StrConvert);  
 Field   X500 X500Str,  Sorted = True   
      X500ParamsField (X500Field); 
 X500 X500Fields    X500Values  
 TX500,    TX500.OtherFields  ,   
,          , 
    X500OtherFields  X500OtherValues
(X500ParamsToOther);    Field    X500Fields 
    X500Values,  
   X500ParamsToOther,      ,
     TX500 (X500ParamsField)}
procedure X500ToParams(const X500: TX500; X500Fields, X500Values: TStrings);
function ParamsToX500(X500Fields, X500Values: TStrings): TX500;
function X500ToStr(const X500: TX500; AFormat: TX500Format;
  Variation: TX500FieldVariation): string;
function StrToX500(const X500Str: string): TX500;
function X500StrConvert(const X500Str: string; AFormat: TX500Format;
  Variation: TX500FieldVariation): string;
function X500Field(const X500Str, Field: string; Sorted: Boolean): TNullStr;
function X500ParamsToOther(X500Fields, X500Values: TStrings;
  X500OtherFields, X500OtherValues: TIndexedStrings): TX500;
function X500ParamsField(X500Fields, X500Values: TStrings;
  const Field: string): TNullStr;
{  TNullX500}
type
  TNullX500List = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TNullX500;
    procedure SetItem(Index: Integer; const Value: TNullX500);
    function GetItemPtr(Index: Integer): PNullX500;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TNullX500): Integer;
    procedure Insert(Index: Integer; const Value: TNullX500);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TNullX500 read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PNullX500 read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{   TNullX500}
type
  TNullX500Index = class(TCustomIndex)
  private
  protected
    function GetItemCount: Integer; override;
    function CompareItems(Item1Index, Item2Index: Integer): Integer; override;
    function CompareWithItem(Item1Index: Integer;
      Item2Ptr: Pointer): Integer; override;
    {}
    function GetDataSource: TNullX500List;
    procedure SetDataSource(NewDataSource: TNullX500List);
    function GetItem(const Value: TNullX500): Integer;
  public
    {   (DataSource);    
     P (Items)}
    property DataSource: TNullX500List
      read GetDataSource write SetDataSource;
    property Items[const Value: TNullX500]: Integer read GetItem; default;
  end;
{   TNullX500}
type
  TIndexedNullX500List = class(TCustomIndexedList)
  private
    FValues: TNullX500List;
    FListGetItemTemp: TNullX500;
  protected
    function ListGetCapacity: Integer; override;
    procedure ListSetCapacity(NewCapacity: Integer); override;
    function ListGetCount: Integer; override;
    procedure ListSetCount(NewCount: Integer); override;
    function ListGetItem(Index: Integer): Pointer; override;
    procedure ListSetItem(Index: Integer; ItemPtr: Pointer); override;
    procedure ListClear; override;
    procedure ListInsert(Index: Integer); override;
    procedure ListDelete(Index: Integer); override;
    procedure ListCreate; override;
    procedure ListDestroy; override;
    function CreateIndex: TCustomIndex; override;
    {}
    function GetItem(Index: Integer): TNullX500;
    procedure SetItem(Index: Integer; const NewValue: TNullX500);
    function GetSorted(Number: Integer): TNullX500;
  public
    constructor Create;
    {}
    function Add(const Value: TNullX500): Integer;
    procedure Insert(Index: Integer; const Value: TNullX500);
    function IndexOf(const Value: TNullX500): Integer;
    {}
    property Items[Index: Integer]: TNullX500 read GetItem write SetItem;
      default;
    property Sorted[Number: Integer]: TNullX500 read GetSorted;
  end;

{  TCertificateFindInfo}
type
  TCertificateFindsInfo = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
    FOnChange: TNotifyEventStd;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TCertificateFindInfo;
    procedure SetItem(Index: Integer; const Value: TCertificateFindInfo);
    function GetItemPtr(Index: Integer): PCertificateFindInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TCertificateFindInfo): Integer;
    procedure Insert(Index: Integer; const Value: TCertificateFindInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TCertificateFindInfo
      read GetItem write SetItem; default;
    property ItemPtrs[Index: Integer]: PCertificateFindInfo read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
    {,    ,    }
    property OnChange: TNotifyEventStd read FOnChange write FOnChange;
  end;



{---  -------------------------------------------------------------}

{  ,  SCommon}
type
  { -   : , , }
  TMoneyClone = (mcOI, mcOR, mcMR);
  { : , , }
  TGender  = (gdM, gdW, gdN);
{}
{   }
type
  TAmtAsWordsLang = class(TObjectStd)
  private
    FIni: TStreamIni;
    FLangCode: string;
    FLangCodeIndex: Integer;
    FCntOfValTrans: Integer;
    FGenderCnt: Integer;
    FCloneCnt: Integer;
    FRateList: TStringList;
    FSmllNumInf: Integer;
    FSmllNumSup: Integer;
    FSmllNumCnt: Integer;
    FSmllNumList: TStringList;
    FMedNumInf: Integer;
    FMedNumSup: Integer;
    FMedNumCnt: Integer;
    FMedNumList: TStringList;
    FTriadeInf: Integer;
    FTriadeSup: Integer;
    FTriadsCnt: Integer;
    FTriadsList: TStringList;
  protected
    function GetValGender(const ACode: string): TGender;
    function GetMelGender(const ACode: string): TGender;
    {}
    function GetValName(const ACode: string; AClone: TMoneyClone): string;
    function GetMelName(const ACode: string; AClone: TMoneyClone): string;
    {}
    procedure NumToProp(const NumStr: string; AGender: TGender;
      var Dest: string; var Clone: TMoneyClone);
    procedure Triada(ANum: Integer; AGender: TGender; var Str: string;
      var Clone: TMoneyClone);
  public
    {  }
    constructor Create(const LangCode: string; LangCodeIndex: Integer;
      Ini: TStreamIni);
    destructor Destroy; override;
    {}
    {    ,   NumStr, RateCode 
    , , '', 'USD',   ,  '',  
     NumStr    (AmtAsWords)}
    function AmtAsWords(const NumStr, RateCode: string): string;
    {}
    { ini-}
    property Ini: TStreamIni read FIni;
    {  }
    property LangCode: string read FLangCode;
    {  }
    property LangCodeIndex: Integer read FLangCodeIndex;
    {}
    {  }
    property CntOfValTrans: Integer read FCntOfValTrans;
    {   }
    property GenderCnt: Integer read FGenderCnt;
    {   : 1 - , 2 - , 10 -  (
     3 -  )  1 - dollar, 2 - dollars, 10 - dollars (
     2 -  )}
    property CloneCnt: Integer read FCloneCnt;
    {}
    {   }
    property RateList: TStringList read FRateList;
    {}
    {     }
    property SmllNumInf: Integer read FSmllNumInf;
    property SmllNumSup: Integer read FSmllNumSup;
    {     }
    property SmllNumCnt: Integer read FSmllNumCnt;
    {       : 1-9)}
    property SmllNumList: TStringList read FSmllNumList;
    {}
    {     }
    property MedNumInf: Integer read FMedNumInf;
    property MedNumSup: Integer read FMedNumSup;
    {     }
    property MedNumCnt: Integer read FMedNumCnt;
    {  : 10-20  20, 30, 40, 50, 60, 70, 80, 90)}
    property MedNumList: TStringList read FMedNumList;
    {}
    {    }
    property TriadeInf: Integer read FTriadeInf;
    property TriadeSup: Integer read FTriadeSup;
    {  }
    property TriadsCnt: Integer read FTriadsCnt;
    {     }
    property TriadsList: TStringList read FTriadsList;
  end;
{}
{  }
type
  TAmtAsWordsLangs = class(TStringListStd)
  private
    FIni: TStreamIni;
  protected
  public
    constructor Create(const IniStr: string);
    destructor Destroy; override;
    {}
    { ,   NumStr, LangCode   ,
    , 'RUSS_LANG', 'ENG_LANG',   ,  'RUSS_LANG',
    RateCode  , , '', 'USD',   , 
    '',    NumStr    (AmtAsWords)}
    function AmtAsWords(const NumStr, LangCode, RateCode: string): string;
    {}
    { ini-}
    property Ini: TStreamIni read FIni;
  end;
{}
{ ini-       ,
22.06.2002}
const
  DefAmtAsWordsIniStr =
    '[CLIENT_LANGUAGES]'#13#10 +
    ';  '#13#10 +
    'LANGUAGE_COUNT=2'#13#10 +
    ''#13#10 +
    ';    ...'#13#10 +
    'LANGUAGE1=RUSS_LANG'#13#10 +
    'LANGUAGE2=ENG_LANG'#13#10 +
    ';       ...'#13#10 +
    ''#13#10 +
    '[RUSS_LANG_ITEMS]'#13#10 +
    'RUSS_LANG_RATECNT=44'#13#10 +
    ';    ...'#13#10 +
    'RUSS_LANG_RATE1=AUD'#13#10 +
    'RUSS_LANG_RATE2=ATS'#13#10 +
    'RUSS_LANG_RATE3=BEF'#13#10 +
    'RUSS_LANG_RATE4=CAD'#13#10 +
    'RUSS_LANG_RATE5=DKK'#13#10 +
    'RUSS_LANG_RATE6=FIM'#13#10 +
    'RUSS_LANG_RATE7=FRF'#13#10 +
    'RUSS_LANG_RATE8=DEM'#13#10 +
    'RUSS_LANG_RATE9=ITL'#13#10 +
    'RUSS_LANG_RATE10=JPY'#13#10 +
    'RUSS_LANG_RATE11=KZT'#13#10 +
    'RUSS_LANG_RATE12=NGL'#13#10 +
    'RUSS_LANG_RATE13=NOK'#13#10 +
    'RUSS_LANG_RATE14=SGD'#13#10 +
    'RUSS_LANG_RATE15=SEK'#13#10 +
    'RUSS_LANG_RATE16=CHF'#13#10 +
    'RUSS_LANG_RATE17='#13#10 +
    'RUSS_LANG_RATE18=GBP'#13#10 +
    'RUSS_LANG_RATE19=USD'#13#10 +
    'RUSS_LANG_RATE20=BRB'#13#10 +
    'RUSS_LANG_RATE21=EKU'#13#10 +
    'RUSS_LANG_RATE22=EUR'#13#10 +
    'RUSS_LANG_RATE23=036'#13#10 +
    'RUSS_LANG_RATE24=040'#13#10 +
    'RUSS_LANG_RATE25=056'#13#10 +
    'RUSS_LANG_RATE26=124'#13#10 +
    'RUSS_LANG_RATE27=208'#13#10 +
    'RUSS_LANG_RATE28=246'#13#10 +
    'RUSS_LANG_RATE29=250'#13#10 +
    'RUSS_LANG_RATE30=280'#13#10 +
    'RUSS_LANG_RATE31=380'#13#10 +
    'RUSS_LANG_RATE32=392'#13#10 +
    'RUSS_LANG_RATE33=398'#13#10 +
    'RUSS_LANG_RATE34=528'#13#10 +
    'RUSS_LANG_RATE35=578'#13#10 +
    'RUSS_LANG_RATE36=702'#13#10 +
    'RUSS_LANG_RATE37=752'#13#10 +
    'RUSS_LANG_RATE38=756'#13#10 +
    'RUSS_LANG_RATE39=810'#13#10 +
    'RUSS_LANG_RATE40=826'#13#10 +
    'RUSS_LANG_RATE41=840'#13#10 +
    'RUSS_LANG_RATE42=906'#13#10 +
    'RUSS_LANG_RATE43=954'#13#10 +
    'RUSS_LANG_RATE44=978'#13#10 +
    ';        (3)'#13#10 +
    'RUSS_LANG_RODECNT=3'#13#10 +
    ';       (3)'#13#10 +
    'RUSS_LANG_CLONECNT=3'#13#10 +
    '; ,  ,        '#13#10 +
    'RUSS_LANG_SMLLNUM_INF=1'#13#10 +
    'RUSS_LANG_SMLLNUM_SUP=9'#13#10 +
    'RUSS_LANG_SMLLNUM_CNT=9'#13#10 +
    ';'#13#10 +
    'RUSS_LANG_S0=0:'#13#10 +
    'RUSS_LANG_S1=1:,,'#13#10 +
    'RUSS_LANG_S2=2:,,'#13#10 +
    'RUSS_LANG_S3=3:'#13#10 +
    'RUSS_LANG_S4=4:'#13#10 +
    'RUSS_LANG_S5=5:'#13#10 +
    'RUSS_LANG_S6=6:'#13#10 +
    'RUSS_LANG_S7=7:'#13#10 +
    'RUSS_LANG_S8=8:'#13#10 +
    'RUSS_LANG_S9=9:'#13#10 +
    ''#13#10 +
    '; ,  ,        '#13#10 +
    'RUSS_LANG_MEDIUM_INF=11'#13#10 +
    'RUSS_LANG_MEDIUM_SUP=900'#13#10 +
    'RUSS_LANG_MEDIUM_CNT=27'#13#10 +
    ''#13#10 +
    'RUSS_LANG_M1=10:'#13#10 +
    'RUSS_LANG_M2=11:'#13#10 +
    'RUSS_LANG_M3=12:'#13#10 +
    'RUSS_LANG_M4=13:'#13#10 +
    'RUSS_LANG_M5=14:'#13#10 +
    'RUSS_LANG_M6=15:'#13#10 +
    'RUSS_LANG_M7=16:'#13#10 +
    'RUSS_LANG_M8=17:'#13#10 +
    'RUSS_LANG_M9=18:'#13#10 +
    'RUSS_LANG_M10=19:'#13#10 +
    'RUSS_LANG_M11=20:'#13#10 +
    'RUSS_LANG_M12=30:'#13#10 +
    'RUSS_LANG_M13=40:'#13#10 +
    'RUSS_LANG_M14=50:'#13#10 +
    'RUSS_LANG_M15=60:'#13#10 +
    'RUSS_LANG_M16=70:'#13#10 +
    'RUSS_LANG_M17=80:'#13#10 +
    'RUSS_LANG_M18=90:'#13#10 +
    'RUSS_LANG_M19=100:'#13#10 +
    'RUSS_LANG_M20=200:'#13#10 +
    'RUSS_LANG_M21=300:'#13#10 +
    'RUSS_LANG_M22=400:'#13#10 +
    'RUSS_LANG_M23=500:'#13#10 +
    'RUSS_LANG_M24=600:'#13#10 +
    'RUSS_LANG_M25=700:'#13#10 +
    'RUSS_LANG_M26=800:'#13#10 +
    'RUSS_LANG_M27=900:'#13#10 +
    ''#13#10 +
    '; ,  ,        '#13#10 +
    'RUSS_LANG_TRIAD_INF=1000'#13#10 +
    'RUSS_LANG_TRIAD_SUP=1000000000000000'#13#10 +
    'RUSS_LANG_TRIAD_CNT=5'#13#10 +
    'RUSS_LANG_TRIAD1=1000:2:,,'#13#10 +
    'RUSS_LANG_TRIAD2=1000000:1:,,'#13#10 +
    'RUSS_LANG_TRIAD3=1000000000:1:,,'#13#10 +
    'RUSS_LANG_TRIAD4=1000000000000:1:,,'#13#10 +
    'RUSS_LANG_TRIAD5=1000000000000000:1:,,'#13#10 +
    ''#13#10 +
    ''#13#10 +
    'RUSS_LANG_RATEMAGOR_036=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_036=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_040=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_040=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_056=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_056=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_124=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_124=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_208=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_208=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_246=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_246=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_250=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_250=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_280=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_280=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_380=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_380=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_392=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_392=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_398=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_398=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_528=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_528=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_578=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_578=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_702=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_702=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_752=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_752=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_756=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_756=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_810=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_810=2:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_826=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_826=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_840=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_840=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_906=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_906=2:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_954=3:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_954=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_978=3:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_978=2:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_AUD=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_AUD=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_ATS=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_ATS=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_BEF=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_BEF=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_CAD=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_CAD=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_DKK=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_DKK=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_FIM=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_FIM=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_FRF=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_FRF=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_DEM=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_DEM=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_ITL=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_ITL=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_JPY=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_JPY=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_KZT=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_KZT=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_NGL=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_NGL=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_NOK=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_NOK=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_SGD=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_SGD=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_SEK=2:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_SEK=3:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_CHF=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_CHF=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_=2:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_GBP=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_GBP=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_USD=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_USD=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_BRB=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_BRB=2:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_EKU=3:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_EKU=1:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_EKU=1:,,'#13#10 +
    'RUSS_LANG_RATEMAGOR_EUR=3:,,'#13#10 +
    'RUSS_LANG_RATEMINOR_EUR=2:,,'#13#10 +
    ''#13#10 +
    ''#13#10 +
    '[ENG_LANG_ITEMS]'#13#10 +
    'ENG_LANG_RATECNT=2'#13#10 +
    ';    ...'#13#10 +
    'ENG_LANG_RATE1='#13#10 +
    'ENG_LANG_RATE2=USD'#13#10 +
    'ENG_LANG_RATE3=FIM'#13#10 +
    ';        (2)'#13#10 +
    'ENG_LANG_RODECNT=3'#13#10 +
    ';       (2)'#13#10 +
    'ENG_LANG_CLONECNT=3'#13#10 +
    '; ,  ,        '#13#10 +
    'ENG_LANG_SMLLNUM_INF=1'#13#10 +
    'ENG_LANG_SMLLNUM_SUP=9'#13#10 +
    'ENG_LANG_SMLLNUM_CNT=9'#13#10 +
    ';'#13#10 +
    'ENG_LANG_S0=0:zero'#13#10 +
    'ENG_LANG_S1=1:one'#13#10 +
    'ENG_LANG_S2=2:two'#13#10 +
    'ENG_LANG_S3=3:three'#13#10 +
    'ENG_LANG_S4=4:four'#13#10 +
    'ENG_LANG_S5=5:five'#13#10 +
    'ENG_LANG_S6=6:six'#13#10 +
    'ENG_LANG_S7=7:seven'#13#10 +
    'ENG_LANG_S8=8:eight'#13#10 +
    'ENG_LANG_S9=9:nine'#13#10 +
    ''#13#10 +
    '; ,  ,        '#13#10 +
    'ENG_LANG_MEDIUM_INF=11'#13#10 +
    'ENG_LANG_MEDIUM_SUP=900'#13#10 +
    'ENG_LANG_MEDIUM_CNT=27'#13#10 +
    ''#13#10 +
    'ENG_LANG_M1=10:ten'#13#10 +
    'ENG_LANG_M2=11:eleven'#13#10 +
    'ENG_LANG_M3=12:twelve'#13#10 +
    'ENG_LANG_M4=13:thirteen'#13#10 +
    'ENG_LANG_M5=14:fourteen'#13#10 +
    'ENG_LANG_M6=15:fifteen'#13#10 +
    'ENG_LANG_M7=16:sixteen'#13#10 +
    'ENG_LANG_M8=17:seventeen'#13#10 +
    'ENG_LANG_M9=18:eighteen'#13#10 +
    'ENG_LANG_M10=19:nineteen'#13#10 +
    'ENG_LANG_M11=20:twenty'#13#10 +
    'ENG_LANG_M12=30:thirty'#13#10 +
    'ENG_LANG_M13=40:fourty'#13#10 +
    'ENG_LANG_M14=50:fifty'#13#10 +
    'ENG_LANG_M15=60:sixty'#13#10 +
    'ENG_LANG_M16=70:seventy'#13#10 +
    'ENG_LANG_M17=80:eighty'#13#10 +
    'ENG_LANG_M18=90:ninety'#13#10 +
    'ENG_LANG_M19=100:one hundred'#13#10 +
    'ENG_LANG_M20=200:two hundreds'#13#10 +
    'ENG_LANG_M21=300:three hundreds'#13#10 +
    'ENG_LANG_M22=400:four hundreds'#13#10 +
    'ENG_LANG_M23=500:five hundreds'#13#10 +
    'ENG_LANG_M24=600:six hundreds'#13#10 +
    'ENG_LANG_M25=700:seven hundreds'#13#10 +
    'ENG_LANG_M26=800:eight hundreds'#13#10 +
    'ENG_LANG_M27=900:nine hundreds'#13#10 +
    ''#13#10 +
    '; ,  ,        '#13#10 +
    'ENG_LANG_TRIAD_INF=1000'#13#10 +
    'ENG_LANG_TRIAD_SUP=1000000000000000'#13#10 +
    'ENG_LANG_TRIAD_CNT=5'#13#10 +
    'ENG_LANG_TRIAD1=1000:1:thousand,thousands'#13#10 +
    'ENG_LANG_TRIAD2=1000000:1:million,millions'#13#10 +
    'ENG_LANG_TRIAD3=1000000000:1:billion,billions'#13#10 +
    'ENG_LANG_TRIAD4=1000000000000:1:trillion,trillions'#13#10 +
    'ENG_LANG_TRIAD5=1000000000000000:1:trilliard,trilliards'#13#10 +
    ''#13#10 +
    'ENG_LANG_RATEMAGOR_=1:rouble,roubles'#13#10 +
    'ENG_LANG_RATEMINOR_=1:copec,copecs'#13#10 +
    'ENG_LANG_RATEMAGOR_USD=1:dollar,dollars'#13#10 +
    'ENG_LANG_RATEMINOR_USD=1:cent,cents';
{}
{ }
type
  TAmtAsWords = class(TObjectStd)
  private
    FIniStr: string;
    FIniChangeTicks: TNullInt;
    FLangs: TAmtAsWordsLangs;
    FIniFileName: string;
    FIniTimeout: Integer;
    FFileOperations: TFileOperations;
  protected
    function GetAmtAsWords(const NumStr, LangCode, RateCode: string): string;
    function GetIniStr: string;
    procedure SetIniStr(const NewIniStr: string);
    function GetIniDefined: Boolean;
    function GetLangs: TAmtAsWordsLangs;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { ,   NumStr, LangCode   ,
    , 'RUSS_LANG', 'ENG_LANG',   ,  'RUSS_LANG',
    RateCode  , , '', 'USD',   , 
    '' (AmtAsWords);   ini-   
    ,   ,  DefAmtAsWordsIniStr (IniStr);
     True,  IniStr    
    (IniDefined);     IniStr    
     Windows,   (IniChangeTicks);   
         (Langs);  ini-
        ,  
      IniStr   ,    
    (IniFileName);   ,    
     IniFileName,   0 (IniTimeout);  
        (FileOperations)}
    property AmtAsWords[const NumStr, LangCode, RateCode: string]: string
      read GetAmtAsWords; default;
    property IniStr: string read GetIniStr write SetIniStr;
    property IniDefined: Boolean read GetIniDefined;
    property IniChangeTicks: TNullInt read FIniChangeTicks;
    property Langs: TAmtAsWordsLangs read GetLangs;
    property IniFileName: string read FIniFileName write FIniFileName;
    property IniTimeout: Integer read FIniTimeout write FIniTimeout;
    property FileOperations: TFileOperations
      read FFileOperations write FFileOperations;
  end;
{}
{  ini-     
,    DefAmtAsWordsIniStr (GetAmtAsWordsIniStr);
  ini-     
 IniStr,     DefAmtAsWordsIniStr
(SetAmtAsWordsIniStr);  True,    ini-
       
  (AmtAsWordsIniDefined);     IniStr
     Windows,  
(AmtAsWordsIniChangeTicks);  ini-  
    IniFileName,    
    ,      
   IniTimeout  ,   
 FileOperations,   (AmtAsWordsIniDefine);  ,
  NumStr, LangCode   , , 'RUSS_LANG',
'ENG_LANG',   ,  'RUSS_LANG',    - ,
'ENG_LANG' - , RateCode  , , '', 'USD', 
 ,  '',    NumStr   
(AmtAsWords);     ,   
  ini-    IniStr, 
  ,  DefAmtAsWordsIniStr (AmtAsWordsIni)}
function GetAmtAsWordsIniStr: string;
procedure SetAmtAsWordsIniStr(const IniStr: string);
function AmtAsWordsIniDefined: Boolean;
function AmtAsWordsIniChangeTicks: TNullInt;
procedure AmtAsWordsIniDefine(const IniFileName: string; IniTimeout: Integer;
  FileOperations: TFileOperations);
function AmtAsWords(const NumStr, LangCode, RateCode: string): string;
function AmtAsWordsIni(const NumStr, LangCode, RateCode,
  IniStr: string): string;

{$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
{  Data     Delphi ZLib,
CompressionLevel   , clNone - , clFastest - ,
clDefault -  , clMax - ,  ,  
 (ZLibCompress);    CompressedData  
  DecompressedSize ,   
(ZLibDecompress)}
function ZLibCompress(const Data: string;
  CompressionLevel: TCompressionLevel): string;
function ZLibDecompress(const CompressedData: string;
  DecompressedSize: Integer): string;
{  Data   ZLib    CompressionLevel,  clNone
 ZLib  ,       
 Comment,   CRC ,   ,
        
   (CRCCompress);   CRCCompress 
CompressedData,  CompressionLevel   ,  Comment
  ,   CRCError,  , 
True   CRC    ,    
 , False  ,      
(CRCDecompress);   SourFileName   
 DestFileName         
  (ZLibFileCompress);   DestFileName,
 ZLibFileCompress,     SourFileName
(ZLibFileDecompress)}
function CRCCompress(const Data: string; CompressionLevel: TCompressionLevel;
  const Comment: string): string;
function CRCDecompress(const CompressedData: string;
  out CompressionLevel: TCompressionLevel; out Comment: string;
  CRCError: PBooleanStd): string;
procedure ZLibFileCompress(const SourFileName, DestFileName: string);
procedure ZLibFileDecompress(const SourFileName, DestFileName: string);
{$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}

{      Stream,   
   FileInfo,    
FileInfo.CheckOnly  True,     
,   }
type
  TNextFileNameFunc = function(Stream: TStream;
    var FileInfo: TPackFileInfo): TConvertCode;
{   }
type
  TExtractFileListInfo = record
    FileName: string;                 {  }
    Prefix: string;                   {     }
    ProcessMessages: TNotifyEventStd; {  }
    FilesList: TStrings;              {    }
    FileTimes {TDateTime}: TStrings;  {    }
    FileSizes: TList;                 {    }
  end;
  PExtractFileListInfo = ^TExtractFileListInfo;
{   Value}
procedure InitExtractFileListInfo(out Value: TExtractFileListInfo);
{  FileInfo   zip-,  Footers,   nil,
  ,       ,
 FileInfo       FileInfo.Format,
0      8   
     'Deflated',  
          FileInfo.Name, 
 FileInfo.Time,      ,  
FileInfo.Attr,   faArchive,   FileInfo.Size, 
  FileInfo.PackedSize,   ,
      CalcCRC,  
 ,   FileInfo.Encrypted  False,   
FileInfo.Comment,  ,   ,  
FileInfo.CacheStr, FileInfo.CachePos, FileInfo.CacheSize   
 ,        TZipStream
     ,   ,
       , WriteFootersOnly  
 Footers,   True     
,  FileInfo ,    
 SciZipFile.pas 1.3 Copyright 2005 Patrik Spanel, scilib@sendme.cz,
Marcin Wojda Marcin@sacer.com.pl added exceptions and try finally blocks, 
  zip- http://www.pkware.com/company/standards/appnote/appnote.txt
(ZipAddFileInfo);       Stream
zip-          rar-,
,       FileInfo,
    FileInfo.CheckOnly  True,   
  ,  NoBackRead  True  
  ,   ,   
   C++ plugin' FAR manager 1.70 (C) Eugene Roshal, FAR Group
(ZipNextFileName, RarNextFileName);   FilesList,   nil, 
     FileName cab-    
 NextFileNameFunc, ,    
 ,  cab-   ,     
  Prefix,  FileTimes,   nil,   
 TDateTime,  FileSizes,   nil,     
 ,   True,    zip-,
 False,        
      ,  
  ,       (ExtractCABFileList,
ExtractFileList);        
   FilesPath   Mode (FileListInfo); 
    Mode    FilesList,  
 FilesList        ,  
 FoundFilesList,     Prefix (FilesNoSubList); 
   FilesList,  FileTimes,   nil,  TDateTime,
 FileSizes,   nil,     
SearchingFilesList,  SearchingFileTimes,   nil, 
TDateTime,  SearchingFileSizes,   nil,  
       ,   StrictOnly  True
  ,   , ,   
,   FoundFilesList   Prefix, 
    SearchingFoundFilesList,   nil,  
SearchingPrefix,  SearchingFoundFilesList  nil    
   ,   FoundFilesList    
, Path       FilesList, SearchingPath  
    FoundSearchingFilesList,    
  (SearchFileList)}
procedure ZipAddFileInfo(Stream: TStream; const FileInfo: TPackFileInfo;
  Footers: TStrings; WriteFootersOnly: Boolean);
function ZipNextFileNameMode(Stream: TStream; var FileInfo: TPackFileInfo;
  NoBackRead: Boolean): TConvertCode;
function ZipNextFileName(Stream: TStream;
  var FileInfo: TPackFileInfo): TConvertCode;
function RarNextFileName(Stream: TStream;
  var FileInfo: TPackFileInfo): TConvertCode;
function ExtractCABFileList(const FileName, Prefix: string;
  ProcessMessages: TNotifyEventStd; FilesList, FileTimes {TDateTime}: TStrings;
  FileSizes: TList): Boolean;
function ExtractFileList(const FileName, Prefix: string; NextFileNameFunc:
  TNextFileNameFunc; ProcessMessages: TNotifyEventStd; FilesList,
  FileTimes {TDateTime}: TStrings; FileSizes: TList): Boolean;
procedure FileListInfo(const FilesPath, Prefix: string;
  Mode: TFileListInfoMode; ProcessMessages: TNotifyEventStd; FilesList,
  FileTimes {TDateTime}: TStrings; FileSizes: TList);
procedure FilesNoSubList(FilesList: TStrings; const Prefix: string;
  Mode: TFileListInfoMode; FoundFilesList: TStrings);
procedure SearchFileList(FilesList, FileTimes: TStrings; FileSizes: TList;
  SearchingFilesList, SearchingFileTimes: TStrings; SearchingFileSizes: TList;
  const Prefix, SearchingPrefix, Path, SearchingPath: string;
  StrictOnly: Boolean; FoundFilesList, FoundSearchingFilesList: TStrings);
type
  {  zip-}
  EZipError = class(Exception);
  {  zip-}
  EUnzipError = class(Exception);
type
  {        zip-}
  TCustomZipStream = class(TCacheStream)
  private
    FFileInfo: PPackFileInfo;
    FIsUnzip: Boolean;
    FCRC: DWORD;
    FPackStream: TCacheStream;
  protected
    {       Stream  IsUnzip
     False     Stream   , ,
           
     #$78#$9C}
    class function CreatePackerStream(Stream: TStream;
      IsUnzip: Boolean): TStream; virtual; abstract;
  public
    {    Stream zip-,  FileInfo 
       ,  IsUnzip  False 
     ,   True  , FileInfo.Format 
    , 0   , 8  
       'Deflated', FileInfo.Name   
      , FileInfo.Size, FileInfo.PackedSize  FileInfo.CRC
      ,     
     , ,    
       ,      
     ,        
       ECRCError, FileInfo.Encrypted 
          False, FileInfo.CacheStr
      , FileInfo.CachePos    ,
    FileInfo.CacheSize         
                 
        ,      
           
    ZipAddFileInfo(Stream, FileInfo, Footers, False),   
       ZipNextFileNameMode(Stream, FileInfo, True),
             
     pfcSuccess       FileInfo.Name,
      ,  FileInfo.Encrypted  True 
       FileInfo.Format  EZipError  
      EUnzipError   }
    constructor Create(Stream: TStream; var FileInfo: TPackFileInfo;
      IsUnzip: Boolean);
    destructor Destroy; override;
    {}
    {     Buffer  Count ,
          ,   
       (Read);    
     Buffer  Count ,   
      ,      
    (Write)}
    function Read(var Buffer; Count: LongInt): LongInt; override;
    function Write(const Buffer; Count: LongInt): LongInt; override;
    {}
    {      (FileInfo);  
    (IsUnzip);      (CRC)}
    property FileInfo: PPackFileInfo read FFileInfo;
    property IsUnzip: Boolean read FIsUnzip;
    property CRC: DWORD read FCRC;
  end;
{$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
type
  {   zip-}
  TZipStream = class(TCustomZipStream)
  private
  protected
    class function CreatePackerStream(Stream: TStream;
      IsUnzip: Boolean): TStream; override;
  public
    constructor Create(Stream: TStream; var FileInfo: TPackFileInfo);
  end;
  {   zip-}
  TUnzipStream = class(TCustomZipStream)
  private
  protected
    class function CreatePackerStream(Stream: TStream;
      IsUnzip: Boolean): TStream; override;
  public
    constructor Create(Stream: TStream; var FileInfo: TPackFileInfo);
  end;
{    zip- ZipStream,     
  , FileName     ,
       , FileTime    
, FileAttr   , , faArchive,   
      faDirectory, FileComment
 ,   , FileBodyStream  
   ,  ZipFooters   ,
    ,  IsLastWrite  True 
    ZipStream  ZipFooters,  
 ZipStream         
  ,       
 (ZipAddStream);      zip-
ZipStream,  FileName     ,  
 ,      ,  FileTime  
  ,  FileAttr   ,  faArchive,
  faDirectory  ,  FileComment  ,
 ,  FileBodyStream,   nil,   ,
   nil    , 
      ,   
         ,   
   ,     FileBodyStream  
nil   ,      FileBodyStream  nil
          
 ,      , ZipReadInfo  ZipCacheStr
      ,     
,  IsFirstRead      True,  
 False (ZipNextStream)}
procedure ZipAddStream(ZipStream: TStream; const FileName: string;
  FileTime: TDateTime; FileAttr: DWORD; const FileComment: string;
  FileBodyStream: TStream; ZipFooters: TStrings; IsLastWrite: Boolean);
function ZipNextStream(ZipStream: TStream; out FileName: string;
  out FileTime: TDateTime; out FileAttr: DWORD; out FileComment: string;
  FileBodyStream: TStream; var ZipReadInfo, ZipCacheStr: string;
  IsFirstRead: Boolean): Boolean;
{    zip-    FileNames,
  nil,          
     , FileTimes,   nil,  
,    , FileAttrs,   nil, 
 ,    faArchive, FileComments,
  nil,  ,   , FileBodies 
  (ZipPack);     zip- ZipStr,
 FileNames,   nil,      
     ,  FileTimes,   nil,  
   TDateTime,  FileAttrs,   nil  
,  FileComments,   nil,  ,  FileBodies,
  nil,    ,  nil 
  (ZipUnpack)}
function ZipPack(FileNames: TIndexedStrings; FileTimes: TStrings {TDateTime};
  FileAttrs: TList; FileComments, FileBodies: TStrings): string;
procedure ZipUnpack(const ZipStr: string; FileNames: TIndexedStrings;
  FileTimes: TStrings {TDateTime}; FileAttrs: TList; FileComments,
  FileBodies: TStrings);
{   FilesOrSubDirsList  zip-   ZipStream,
BaseDirOrFullFileName     ,
 FilesOrSubDirsList     
 BaseDirOrFullFileName,      
,         
    ZipStream,   ZipStream  nil,
      zip-   ZipFileName,
   BaseDirOrFullFileName     ,
 ZipStream   nil  ZipFileName ,  
 FilesOrSubDirsList  nil,      
BaseDirOrFullFileName     BaseDirOrFullFileName,
       ,  
    }
function ZipPackFiles(ZipStream: TStream; const ZipFileName,
  BaseDirOrFullFileName: string; FilesOrSubDirsList: TStrings): Integer;
{  zip- ZipStream   BaseDirOrFullFileName,
     ,   
  ,     
 FilesOrSubDirsList,   nil,  NotUnpack  True 
     ,   ZipStream
 nil,       zip-   ZipFileName,
 ZipStream   nil  ZipFileName ,
 SearchFilesOrSubDirsList   nil   ,
      ,    
       ,  
    ,  SearchFilesOrSubDirsList
 nil      BaseDirOrFullFileName 
      BaseDirOrFullFileName,
 SearchFilesOrSubDirsList   nil  BaseDirOrFullFileName
     ,   ,
      }
function ZipUnpackFiles(ZipStream: TStream; const ZipFileName,
  BaseDirOrFullFileName: string; FilesOrSubDirsList: TStrings;
  SearchFilesOrSubDirsList: TIndexedStrings; NotUnpack: Boolean): Integer;
{ ,     
  SelfUnpackRun, ,  4    
,    ,     
ZLibDecompress}
const
  SelfUnpackData: array[0..67006] of Byte = (
    $00,$F0,$01,$00,$78,$9C,$CC,$BD,$7D,$5C,$D4,$55,$F6,$38,$FE,$9E,
    $99,$37,$30,$C0,$E8,$A0,$E2,$33,$26,$D5,$58,$2A,$5A,$12,$5A,$EA,
    $E8,$36,$02,$83,$F8,$3C,$82,$28,$3E,$60,$91,$8A,$48,$A6,$2E,$BC,
    $47,$6D,$F3,$61,$D8,$91,$D6,$37,$B7,$D9,$D8,$1E,$F6,$D3,$7E,$B6,
    $76,$75,$AB,$FD,$B4,$66,$2D,$95,$25,$9A,$D5,$C8,$20,$0F,$6A,$86,
    $68,$8A,$62,$49,$6A,$75,$C7,$37,$29,$29,$C9,$80,$A3,$F3,$3D,$E7,
    $BE,$EF,$00,$56,$9B,$ED,$3F,$BF,$D7,$CF,$E2,$7D,$EE,$C3,$B9,$E7,
    $9E,$7B,$EF,$B9,$E7,$9E,$FB,$38,$33,$16,$D8,$04,$AD,$20,$08,$A2,
    $60,$14,$02,$01,$41,$28,$13,$D4,$7F,$16,$61,$80,$70,$DB,$7F,$1A,
    $41,$D8,$1B,$25,$74,$1F,$BC,$2B,$FC,$D3,$3B,$CB,$34,$D3,$3F,$BD,
    $B3,$A4,$64,$4E,$EE,$8A,$82,$D8,$35,$F9,$AB,$97,$E7,$67,$3F,$11,
    $FB,$84,$BD,$40,$8A,$7D,$6C,$59,$6C,$BE,$7D,$55,$AC,$7D,$D5,$D2,
    $65,$F9,$B1,$F3,$56,$AC,$4A,$78,$A0,$5B,$84,$E9,$A1,$DB,$13,$FF,
    $FF,$E6,$9F,$CD,$2A,$08,$D3,$35,$7A,$A1,$FF,$E2,$C4,$E1,$C1,$B0,
    $46,$E1,$8F,$85,$91,$1A,$6D,$7F,$E1,$8F,$50,$C0,$C5,$6A,$58,$FD,
    $CB,$E0,$8E,$02,$C7,$36,$80,$50,$3B,$CC,$AD,$65,$55,$C0,$FE,$89,
    $1D,$04,$B5,$1D,$1E,$2D,$FB,$46,$31,$74,$06,$A3,$84,$60,$48,$E7,
    $BF,$5A,$8D,$F0,$B1,$01,$60,$2C,$60,$DF,$F3,$73,$1C,$6A,$05,$B1,
    $DF,$2F,$14,$A0,$59,$23,$FC,$52,$F4,$7F,$FA,$97,$34,$2B,$D9,$8A,
    $B0,$E5,$19,$5E,$2E,$2C,$AB,$78,$2B,$4E,$AC,$20,$3C,$9A,$3C,$69,
    $CE,$24,$74,$6F,$EB,$26,$A8,$65,$EF,$0E,$F0,$39,$CD,$2D,$78,$16,
    $41,$70,$27,$A6,$A7,$33,$F7,$C8,$BE,$F0,$29,$E5,$F1,$DB,$6E,$C5,
    $83,$7F,$EE,$FB,$56,$2C,$CD,$96,$B2,$05,$B5,$CC,$B5,$9C,$DE,$B6,
    $9F,$D2,$BB,$4F,$5A,$59,$80,$6E,$44,$13,$1A,$79,$FC,$DB,$3F,$43,
    $2F,$5F,$A5,$C7,$EA,$00,$EA,$82,$55,$FA,$DB,$3F,$A1,$67,$BB,$2F,
    $7F,$D9,$CA,$D5,$4B,$04,$5E,$97,$80,$34,$A0,$0B,$9F,$B7,$E0,$15,
    $E4,$2F,$41,$0F,$B6,$45,$B0,$4D,$0E,$FE,$14,$EF,$96,$00,$9B,$DA,
    $D2,$2C,$FF,$5F,$C2,$FB,$FF,$E1,$3F,$31,$CA,$22,$44,$84,$A6,$4B,
    $F9,$2B,$56,$2D,$8F,$02,$77,$64,$C4,$BC,$15,$4B,$97,$A9,$FE,$5C,
    $F0,$FF,$D2,$3F,$8C,$0F,$8A,$CC,$F1,$11,$16,$A1,$11,$FE,$2E,$C0,
    $1F,$85,$BF,$33,$F0,$F7,$5A,$9C,$45,$28,$83,$3F,$01,$DC,$61,$73,
    $66,$3D,$96,$B7,$6C,$89,$24,$41,$9A,$B0,$A0,$A7,$33,$83,$D0,$F4,
    $27,$0B,$A4,$65,$4F,$08,$C2,$0B,$10,$64,$D4,$4F,$C9,$58,$F5,$F8,
    $AA,$D5,$EB,$56,$61,$54,$47,$9D,$BA,$55,$90,$D2,$81,$1B,$18,$92,
    $7B,$74,$92,$40,$DC,$81,$21,$4B,$39,$7C,$94,$C3,$45,$1C,$66,$72,
    $38,$87,$43,$1B,$87,$D3,$39,$4C,$E5,$30,$99,$43,$0B,$87,$13,$38,
    $1C,$CB,$E1,$06,$0E,$47,$73,$B8,$9E,$C3,$51,$1C,$8E,$E0,$70,$28,
    $87,$26,$0E,$63,$39,$8C,$E1,$B0,$1F,$87,$D1,$1C,$46,$71,$68,$E0,
    $50,$CF,$A1,$C8,$A1,$C4,$A1,$C0,$A1,$BF,$56,$85,$3E,$0E,$5B,$38,
    $7C,$86,$C7,$6F,$E5,$70,$0B,$87,$CD,$3C,$BE,$89,$C3,$9D,$3C,$FC,
    $0D,$0E,$5F,$E3,$70,$1B,$87,$2F,$73,$F8,$12,$87,$2F,$30,$98,$EE,
    $AC,$D8,$F7,$61,$04,$54,$FD,$1C,$3A,$3B,$10,$08,$5C,$4B,$36,$8D,
    $D0,$48,$21,$C6,$DD,$8B,$4C,$A3,$88,$C7,$59,$91,$BC,$D0,$83,$B8,
    $94,$E7,$71,$81,$C3,$46,$0E,$CF,$70,$58,$CF,$E1,$71,$0E,$6B,$39,
    $3C,$CC,$60,$FA,$DC,$8F,$E7,$EC,$9A,$24,$38,$7F,$23,$D8,$C7,$E7,
    $26,$87,$0A,$42,$9E,$40,$DF,$80,$CC,$48,$75,$51,$8D,$3D,$24,$C1,
    $BD,$78,$A1,$67,$BB,$0D,$10,$64,$8D,$DC,$0D,$61,$42,$1D,$29,$D7,
    $B9,$5D,$C9,$FB,$45,$72,$87,$DC,$4F,$0E,$4D,$74,$B6,$2F,$B5,$37,
    $91,$50,$12,$25,$F7,$01,$DC,$12,$59,$90,$2D,$A2,$07,$E9,$92,$2B,
    $A4,$9E,$BE,$02,$A4,$8A,$DC,$9C,$10,$E9,$23,$DB,$F4,$64,$AE,$28,
    $DB,$0C,$A4,$97,$1C,$25,$67,$8A,$72,$A2,$28,$EB,$4A,$35,$18,$67,
    $13,$89,$5E,$8E,$90,$67,$8B,$A4,$37,$32,$24,$47,$BD,$8A,$C0,$93,
    $3E,$77,$5E,$C6,$6C,$F2,$BD,$1C,$6D,$22,$94,$64,$09,$44,$34,$61,
    $4E,$80,$2D,$CF,$15,$89,$99,$24,$E9,$49,$AD,$2E,$DD,$60,$EE,$63,
    $8F,$26,$1E,$BA,$1B,$19,$4F,$D2,$CB,$A1,$24,$C9,$A0,$49,$11,$95,
    $3E,$A4,$8F,$6E,$AE,$68,$2E,$B7,$77,$83,$C8,$FF,$65,$91,$18,$4E,
    $CE,$9A,$15,$7B,$39,$39,$41,$0E,$D0,$0C,$08,$DC,$E2,$B6,$8B,$09,
    $6E,$39,$74,$41,$D6,$23,$C0,$88,$CB,$22,$60,$9E,$CE,$0A,$1F,$A9,
    $27,$D7,$C9,$03,$40,$CF,$DC,$9C,$BF,$92,$1C,$D1,$4D,$15,$09,$D5,
    $3D,$6E,$30,$7F,$BA,$6E,$B1,$B9,$D9,$3E,$90,$24,$8A,$1A,$C8,$3E,
    $51,$1C,$96,$64,$70,$3E,$65,$10,$EC,$C9,$90,$C9,$18,$A0,$A7,$98,
    $49,$04,$C9,$17,$75,$47,$88,$4F,$F7,$94,$C1,$FC,$99,$3D,$64,$58,
    $81,$41,$B9,$87,$44,$00,$05,$D9,$60,$8A,$6B,$93,$37,$98,$44,$D2,
    $33,$AE,$56,$4E,$37,$90,$E3,$90,$A8,$F6,$66,$90,$09,$C5,$50,$AA,
    $51,$F4,$64,$A0,$F9,$BA,$BD,$28,$C1,$3D,$5F,$E5,$A8,$04,$F8,$21,
    $A7,$49,$73,$E1,$4D,$1C,$31,$36,$86,$7D,$8C,$40,$31,$14,$56,$A2,
    $DD,$50,$F8,$0D,$F4,$C7,$80,$5C,$20,$E6,$69,$72,$71,$E0,$98,$0B,
    $ED,$E7,$BB,$01,$25,$F5,$C9,$E6,$A2,$80,$74,$37,$39,$56,$96,$09,
    $F5,$48,$57,$AA,$79,$F4,$CA,$15,$1C,$D8,$C6,$44,$67,$A3,$A7,$00,
    $0D,$CA,$AD,$0B,$E6,$91,$41,$4E,$41,$9B,$D1,$AA,$24,$11,$33,$C8,
    $13,$19,$BD,$5C,$74,$67,$D0,$D7,$3B,$48,$DA,$07,$FF,$38,$63,$15,
    $71,$6E,$06,$75,$00,$92,$AC,$73,$9A,$85,$CE,$6C,$7F,$B8,$F1,$93,
    $6C,$1F,$E3,$D9,$76,$94,$0D,$EA,$BA,$49,$9E,$6E,$12,$A1,$8D,$AB,
    $92,$4D,$7A,$A8,$C1,$40,$42,$9D,$3C,$C7,$64,$80,$16,$17,$4D,$BA,
    $03,$72,$B2,$29,$8A,$0C,$42,$72,$CA,$6C,$68,$F2,$02,$BD,$F9,$D2,
    $BA,$14,$52,$A9,$4B,$32,$98,$21,$66,$9D,$D9,$2C,$99,$F4,$05,$A2,
    $0C,$DF,$60,$A0,$61,$AD,$08,$89,$0C,$3C,$D3,$B9,$F4,$B2,$9F,$49,
    $61,$44,$55,$C8,$68,$A0,$82,$8A,$0D,$6A,$BD,$18,$8B,$74,$B6,$F0,
    $3A,$12,$B6,$FF,$1F,$49,$36,$89,$90,$6B,$94,$73,$83,$C9,$20,$48,
    $FD,$D1,$4B,$E6,$98,$F4,$72,$14,$B8,$0C,$71,$C0,$16,$F8,$50,$5C,
    $9D,$15,$D1,$8C,$71,$95,$EF,$16,$CE,$37,$A9,$25,$17,$0B,$BF,$16,
    $9A,$03,$01,$5D,$B4,$A9,$B0,$3C,$60,$84,$FA,$39,$87,$5E,$28,$86,
    $1E,$69,$C9,$43,$E1,$AB,$8F,$3B,$C0,$A9,$90,$31,$AC,$38,$13,$C8,
    $62,$3D,$D9,$64,$D0,$5D,$37,$2B,$6B,$B5,$E4,$0B,$F3,$06,$93,$7E,
    $AD,$48,$E0,$6B,$BE,$BE,$F6,$0E,$AC,$57,$30,$10,$E2,$AE,$CF,$4B,
    $A7,$F7,$F0,$02,$04,$B9,$54,$22,$C8,$83,$85,$37,$19,$E7,$FB,$9C,
    $15,$06,$C6,$11,$F6,$39,$EC,$2B,$F5,$E4,$2A,$B4,$90,$91,$B5,$10,
    $72,$30,$DA,$44,$14,$1D,$E7,$0E,$EA,$53,$D6,$90,$03,$71,$00,$26,
    $05,$99,$18,$DB,$C1,$44,$8C,$A9,$40,$47,$62,$4C,$E6,$CB,$05,$5A,
    $72,$03,$58,$88,$C9,$C5,$A1,$94,$31,$F0,$D6,$F5,$AE,$35,$88,$C3,
    $6E,$07,$03,$EE,$9F,$F4,$9B,$2B,$C4,$F7,$51,$2E,$44,$15,$56,$05,
    $1E,$06,$36,$BE,$15,$DC,$90,$73,$96,$A0,$24,$98,$9F,$32,$6C,$1E,
    $41,$8E,$90,$93,$D0,$A9,$E8,$5E,$90,$48,$50,$3B,$92,$8D,$A4,$B0,
    $8E,$94,$D2,$D1,$91,$7E,$03,$AD,$D3,$04,$19,$2A,$63,$A0,$27,$7C,
    $61,$AF,$81,$9E,$5A,$45,$5B,$FD,$2A,$FA,$9D,$E4,$30,$EB,$B9,$E7,
    $01,$C1,$39,$C1,$24,$D8,$5F,$87,$00,$D0,$05,$A1,$F4,$1D,$55,$B0,
    $42,$79,$B7,$51,$EB,$03,$65,$CB,$60,$22,$ED,$A4,$F9,$67,$59,$D2,
    $62,$0E,$52,$88,$B9,$40,$6F,$FF,$01,$3F,$F3,$80,$45,$E3,$1F,$FF,
    $0C,$E5,$73,$41,$CB,$92,$93,$71,$D0,$45,$93,$F4,$20,$55,$B4,$01,
    $F3,$87,$8E,$2B,$48,$09,$10,$65,$70,$41,$43,$02,$17,$59,$D7,$59,
    $28,$30,$FD,$0E,$86,$12,$DE,$DC,$74,$C8,$0D,$56,$D9,$D8,$56,$DE,
    $92,$0E,$6A,$A4,$92,$BE,$D0,$41,$66,$74,$17,$32,$7D,$82,$64,$8C,
    $45,$39,$20,$FE,$B7,$90,$3A,$ED,$EF,$20,$A5,$A4,$92,$C7,$F5,$E6,
    $1F,$EC,$E3,$B1,$22,$C7,$10,$28,$D7,$49,$48,$FC,$5B,$35,$2F,$E7,
    $58,$41,$1A,$8A,$FA,$D1,$C2,$AA,$93,$39,$82,$35,$1A,$85,$FA,$AF,
    $1D,$6A,$34,$8C,$53,$0A,$8A,$31,$F6,$3F,$A8,$22,$D2,$06,$42,$EC,
    $7A,$89,$D5,$CD,$79,$56,$37,$A3,$4D,$BA,$66,$10,$20,$70,$9A,$BF,
    $2C,$58,$48,$3E,$23,$27,$E2,$8E,$01,$91,$BF,$DC,$60,$DC,$41,$59,
    $CA,$B0,$3A,$69,$16,$10,$25,$8B,$4C,$62,$51,$83,$34,$B8,$83,$6B,
    $0F,$93,$57,$EC,$38,$32,$76,$23,$E8,$A4,$00,$F5,$6A,$A9,$A3,$B1,
    $C4,$6A,$DA,$17,$91,$21,$D4,$BC,$61,$C0,$0D,$32,$93,$41,$9A,$12,
    $EA,$32,$72,$0F,$F6,$B7,$08,$4B,$03,$0F,$2C,$95,$EF,$CA,$1D,$8B,
    $78,$E3,$DA,$02,$01,$C7,$C4,$29,$A5,$60,$0F,$4B,$11,$6A,$D0,$7D,
    $10,$A4,$2A,$98,$67,$D0,$C5,$C8,$FD,$1E,$5D,$2F,$A0,$6B,$3D,$B8,
    $72,$7D,$46,$36,$96,$9D,$F1,$05,$02,$AF,$96,$E0,$08,$37,$11,$BF,
    $82,$74,$7F,$99,$0E,$A5,$B7,$37,$FA,$12,$6A,$E4,$E9,$BF,$6F,$B1,
    $4C,$D4,$80,$C6,$B3,$37,$95,$AD,$C7,$71,$C7,$22,$CA,$C2,$AB,$5B,
    $C0,$55,$19,$32,$0A,$95,$45,$82,$7B,$C1,$FC,$F9,$4B,$E5,$A8,$DC,
    $A3,$C0,$D6,$8F,$D8,$F8,$37,$10,$F7,$78,$B3,$C1,$F4,$56,$BE,$DE,
    $86,$D8,$59,$58,$86,$74,$C7,$44,$74,$0B,$C6,$2D,$87,$21,$27,$2C,
    $D1,$DB,$03,$82,$25,$FA,$11,$81,$1C,$20,$A0,$E6,$23,$6C,$47,$86,
    $6C,$74,$B4,$0F,$85,$98,$71,$CC,$75,$5E,$CF,$A0,$EE,$4C,$D2,$DB,
    $E8,$10,$88,$26,$03,$B9,$D2,$FA,$46,$AD,$02,$D9,$17,$AC,$82,$CD,
    $BE,$60,$15,$D8,$C1,$C5,$C6,$ED,$22,$B7,$D4,$17,$46,$CC,$DE,$36,
    $46,$FD,$44,$6B,$47,$B0,$DD,$DB,$51,$B2,$F7,$07,$FC,$A4,$64,$9F,
    $03,$A2,$EA,$3A,$D6,$8A,$65,$DC,$D8,$07,$CA,$D8,$B0,$30,$CB,$93,
    $6E,$0E,$C1,$CA,$B1,$87,$E3,$10,$DC,$1B,$9D,$38,$72,$A7,$EA,$0B,
    $DB,$50,$59,$6D,$1E,$0B,$83,$6D,$DF,$A2,$9A,$27,$75,$CE,$FD,$BA,
    $FD,$6D,$5A,$56,$28,$54,$E6,$5B,$5B,$14,$53,$67,$30,$19,$84,$E1,
    $F2,$1C,$D2,$42,$04,$59,$2B,$DB,$44,$E8,$AD,$41,$07,$E8,$11,$D2,
    $1B,$CB,$A0,$44,$91,$A9,$7A,$F3,$FE,$FC,$30,$DD,$54,$03,$80,$3E,
    $A4,$67,$61,$3B,$86,$DB,$A9,$AA,$84,$74,$AC,$72,$49,$39,$C8,$30,
    $39,$E8,$F4,$8A,$AE,$18,$8D,$B3,$3D,$6A,$83,$B1,$4A,$17,$26,$08,
    $0E,$72,$94,$6E,$07,$45,$BF,$D0,$E3,$6C,$17,$37,$18,$C8,$C1,$C2,
    $1A,$50,$5A,$0E,$59,$2F,$47,$2E,$F4,$04,$42,$4C,$C8,$77,$AD,$F3,
    $22,$0C,$C3,$85,$E7,$40,$56,$37,$83,$53,$D3,$7B,$28,$2B,$6F,$88,
    $20,$80,$EE,$70,$B6,$1B,$36,$74,$77,$1E,$D4,$42,$57,$71,$8B,$F4,
    $20,$74,$4A,$46,$29,$A2,$93,$92,$AE,$DC,$19,$7B,$13,$C6,$01,$4E,
    $07,$22,$BE,$C2,$88,$C2,$36,$FC,$4A,$5C,$53,$A2,$99,$4E,$4E,$17,
    $9E,$C7,$3C,$E2,$3C,$A4,$3A,$A1,$47,$6B,$39,$E8,$BD,$40,$30,$1E,
    $32,$13,$AE,$69,$34,$52,$2C,$52,$31,$90,$7C,$7D,$5C,$A5,$79,$8D,
    $3E,$18,$0B,$E6,$98,$40,$8B,$01,$5F,$F7,$25,$F1,$74,$E8,$58,$52,
    $9F,$10,$20,$BA,$7F,$09,$98,$4D,$E4,$10,$A4,$AC,$F3,$E9,$EA,$89,
    $EE,$0D,$AD,$BD,$17,$B9,$0A,$3A,$26,$13,$52,$90,$14,$3D,$86,$3A,
    $EF,$BE,$49,$AA,$3A,$C7,$2B,$1F,$2A,$42,$C0,$F8,$5F,$C4,$A8,$07,
    $65,$42,$0E,$80,$6E,$23,$B5,$2E,$C3,$43,$71,$47,$A1,$C8,$9B,$45,
    $E2,$8B,$BB,$49,$2A,$E3,$0E,$38,$7D,$86,$8D,$3D,$51,$D5,$C6,$A5,
    $EB,$75,$A8,$65,$8E,$A1,$42,$36,$42,$C8,$49,$28,$AE,$2B,$45,$A4,
    $E5,$10,$40,$46,$98,$8A,$BE,$63,$86,$CB,$28,$F2,$79,$DC,$09,$A0,
    $BC,$06,$29,$1F,$D0,$61,$BF,$87,$84,$60,$99,$95,$17,$44,$B8,$A2,
    $1F,$8A,$AB,$A5,$3B,$30,$06,$CD,$9D,$57,$AE,$05,$02,$A5,$1A,$AE,
    $A5,$B1,$3C,$30,$5E,$90,$B3,$72,$01,$28,$0E,$5D,$A5,$93,$1A,$E4,
    $35,$7A,$30,$75,$50,$9A,$1E,$22,$27,$8A,$EA,$40,$68,$CA,$75,$FB,
    $DB,$55,$59,$22,$C9,$25,$2D,$20,$BB,$51,$CC,$23,$2F,$2A,$69,$91,
    $17,$8A,$F2,$40,$65,$3C,$88,$78,$92,$28,$F7,$02,$8B,$74,$81,$A8,
    $8C,$80,$E4,$13,$04,$61,$43,$37,$36,$70,$68,$55,$13,$AF,$EF,$76,
    $14,$56,$79,$10,$13,$D9,$2E,$D8,$7C,$EC,$72,$4E,$DC,$8A,$BD,$70,
    $93,$45,$75,$18,$36,$1A,$D4,$26,$00,$59,$12,$94,$B8,$ED,$18,$E6,
    $AC,$D6,$92,$DE,$CF,$20,$11,$ED,$76,$04,$28,$18,$EA,$98,$F3,$2A,
    $7A,$01,$20,$96,$3A,$EE,$38,$2B,$9A,$49,$B3,$6B,$82,$E9,$F5,$D7,
    $89,$9F,$6E,$53,$55,$BA,$1E,$94,$26,$EB,$9C,$43,$7F,$60,$4A,$53,
    $5F,$D4,$C0,$AA,$2E,$8D,$84,$99,$EB,$0B,$22,$18,$AD,$61,$61,$9A,
    $C9,$22,$09,$D3,$C1,$E7,$AA,$4E,$32,$19,$CC,$95,$05,$7A,$AA,$87,
    $9A,$0B,$06,$83,$E5,$D9,$C3,$49,$C5,$BD,$28,$58,$54,$07,$29,$9C,
    $AB,$45,$88,$61,$1C,$90,$C9,$22,$63,$A1,$54,$E3,$AC,$88,$0A,$8E,
    $C9,$AA,$21,$7B,$DC,$95,$24,$D2,$45,$3E,$75,$C8,$94,$22,$49,$05,
    $9D,$D7,$61,$F9,$2A,$5A,$6C,$0D,$36,$16,$A8,$A3,$77,$3D,$39,$EC,
    $82,$11,$D5,$43,$3F,$EC,$9A,$E0,$9E,$1F,$25,$50,$E9,$27,$D4,$15,
    $B9,$A1,$85,$DC,$BA,$FD,$3E,$ED,$44,$14,$F7,$CD,$7D,$54,$DD,$4A,
    $E6,$FC,$BE,$A5,$A8,$CE,$AE,$E7,$DA,$F5,$22,$74,$54,$66,$63,$36,
    $7F,$82,$2D,$F0,$D1,$56,$A6,$E0,$36,$C0,$17,$86,$5D,$E3,$1F,$B7,
    $60,$3F,$19,$CC,$6C,$ED,$4D,$4F,$A1,$28,$2C,$14,$21,$7C,$B3,$8F,
    $F4,$95,$13,$F5,$E6,$C1,$92,$28,$0F,$56,$96,$70,$A9,$E8,$06,$62,
    $56,$84,$C6,$7C,$3D,$54,$E0,$4C,$F0,$F4,$53,$39,$0B,$4B,$70,$7B,
    $B7,$02,$1D,$B3,$5D,$D8,$FC,$DA,$30,$BB,$E0,$DC,$08,$CD,$A8,$D7,
    $D9,$A1,$65,$64,$AB,$C0,$9A,$4C,$33,$86,$D5,$D3,$89,$60,$C7,$56,
    $35,$81,$F3,$92,$A8,$19,$83,$9D,$5F,$99,$0E,$85,$1E,$80,$72,$9D,
    $AE,$27,$E5,$71,$95,$D0,$09,$40,$77,$1C,$D3,$9D,$78,$8E,$CE,$81,
    $AA,$56,$7A,$92,$2B,$E6,$C1,$F6,$10,$02,$C2,$13,$C6,$84,$35,$F6,
    $26,$F1,$FC,$47,$6A,$59,$7C,$4C,$83,$4A,$65,$BD,$96,$0F,$0B,$F6,
    $5E,$B4,$57,$1B,$63,$38,$02,$19,$F3,$7B,$E7,$80,$9E,$4A,$A8,$C9,
    $C8,$5D,$74,$27,$8E,$12,$F1,$4B,$E5,$3B,$7F,$A4,$8C,$2D,$57,$A0,
    $19,$3C,$61,$CE,$F3,$7E,$E7,$75,$C3,$C6,$90,$0F,$71,$6D,$A6,$F0,
    $3A,$D6,$85,$F1,$D9,$E7,$99,$31,$DB,$D9,$06,$5D,$2B,$5F,$7A,$12,
    $1A,$B3,$52,$E7,$41,$36,$13,$45,$73,$AD,$7D,$C0,$2D,$98,$DD,$98,
    $72,$0E,$C8,$1B,$0A,$5B,$60,$76,$72,$A8,$8B,$7A,$66,$43,$A5,$9C,
    $FC,$6C,$0B,$89,$90,$67,$F8,$C8,$0C,$1F,$5A,$8B,$F0,$05,$03,$9B,
    $A4,$E9,$83,$C5,$05,$DE,$79,$89,$15,$51,$33,$88,$29,$CF,$FB,$7A,
    $08,$82,$17,$DB,$D2,$3C,$08,$1B,$78,$F3,$D4,$61,$0C,$06,$FB,$54,
    $37,$1D,$F3,$F2,$9E,$A2,$B6,$C8,$20,$D6,$22,$C7,$7E,$81,$E8,$29,
    $28,$A8,$F2,$00,$B4,$CC,$3E,$9C,$5F,$58,$FD,$1D,$E3,$D6,$92,$3B,
    $7F,$32,$6E,$0D,$FA,$1E,$47,$AB,$CF,$8C,$38,$22,$13,$AB,$1F,$5A,
    $60,$FE,$FC,$2C,$94,$53,$68,$87,$D9,$AA,$EE,$74,$BF,$8A,$FD,$3A,
    $D8,$18,$83,$E9,$D3,$AD,$AC,$31,$FA,$A8,$FD,$5D,$0F,$CC,$57,$59,
    $FD,$08,$BC,$D9,$BC,$61,$B4,$77,$FF,$87,$86,$F9,$3F,$34,$A9,$AF,
    $42,$83,$93,$3B,$AE,$79,$B4,$76,$A3,$4A,$22,$1C,$D3,$FE,$00,$9F,
    $40,$37,$36,$CE,$78,$98,$8E,$86,$4E,$3B,$2C,$04,$CB,$73,$CD,$A3,
    $91,$AC,$04,$15,$1D,$B1,$E9,$71,$98,$D1,$B7,$96,$EB,$50,$97,$F3,
    $E4,$38,$E1,$F7,$7E,$80,$CD,$5A,$19,$57,$6E,$B6,$E9,$6F,$09,$FF,
    $1B,$7C,$74,$30,$17,$A4,$12,$74,$4D,$75,$58,$C1,$16,$26,$3E,$F3,
    $44,$AC,$47,$FB,$88,$61,$83,$D4,$5A,$C5,$0A,$2E,$54,$75,$1A,$A8,
    $C2,$4D,$21,$74,$E0,$75,$66,$1D,$5B,$FD,$54,$86,$DA,$F1,$16,$61,
    $06,$51,$D7,$CA,$B5,$52,$0C,$1F,$01,$DB,$C5,$A0,$CE,$8B,$44,$9D,
    $F7,$90,$53,$AF,$51,$86,$91,$2A,$E7,$7A,$B0,$DA,$22,$D1,$B8,$0C,
    $75,$AE,$D7,$1B,$6E,$C1,$E9,$05,$25,$D0,$9D,$A6,$14,$6A,$90,$1C,
    $83,$8E,$78,$3F,$58,$74,$DB,$31,$B6,$6B,$2B,$85,$DF,$FD,$93,$56,
    $5A,$77,$19,$5B,$69,$58,$F7,$2E,$AD,$94,$D5,$61,$AF,$83,$06,$72,
    $56,$86,$39,$BF,$F1,$3B,$6F,$82,$B0,$B3,$F5,$4A,$42,$9D,$DF,$89,
    $64,$23,$D8,$ED,$AC,$C0,$07,$74,$55,$A4,$DE,$7C,$D3,$F8,$8C,$13,
    $E3,$4E,$C6,$9D,$00,$E3,$D5,$CC,$CA,$6D,$1F,$0B,$F6,$ED,$B0,$10,
    $26,$52,$A2,$49,$13,$D2,$45,$F8,$8C,$AE,$E9,$D0,$9C,$2C,$94,$47,
    $0F,$63,$D1,$A4,$D5,$9B,$80,$11,$F5,$D7,$74,$5A,$5C,$27,$80,$22,
    $69,$A2,$4D,$34,$BA,$95,$A9,$3E,$C3,$86,$81,$E4,$0B,$18,$7D,$C1,
    $BC,$AE,$D6,$CA,$3A,$E2,$41,$A5,$BF,$0F,$E2,$BC,$37,$31,$EF,$56,
    $6F,$AB,$DA,$50,$55,$68,$E9,$72,$1E,$96,$B3,$D1,$02,$A6,$A1,$E2,
    $86,$74,$B4,$E0,$79,$3E,$E0,$52,$B3,$0E,$F6,$86,$7E,$0C,$4F,$0D,
    $D3,$8D,$E9,$D2,$31,$90,$9E,$86,$C9,$0A,$B1,$0A,$43,$50,$36,$22,
    $9B,$65,$3B,$A8,$75,$EF,$3F,$50,$EB,$CF,$06,$ED,$01,$4C,$9D,$45,
    $86,$67,$40,$BD,$97,$83,$F9,$85,$73,$1C,$83,$C9,$0C,$96,$F9,$C6,
    $EE,$30,$05,$25,$A7,$B1,$7C,$90,$A3,$32,$82,$4E,$BD,$C6,$6C,$71,
    $71,$18,$94,$01,$0B,$D4,$1D,$EA,$AF,$92,$40,$11,$0B,$41,$84,$94,
    $F1,$3A,$98,$1F,$42,$09,$C1,$50,$50,$EE,$0B,$5A,$15,$77,$AA,$56,
    $85,$07,$46,$02,$9C,$9F,$78,$E8,$39,$A6,$B0,$A4,$70,$CC,$D6,$DB,
    $0D,$27,$E8,$6E,$A5,$FF,$7F,$64,$33,$B8,$6E,$11,$EC,$73,$57,$BA,
    $EA,$BE,$BE,$2D,$5D,$75,$DF,$9F,$B8,$85,$FC,$E2,$90,$FF,$60,$21,
    $27,$7F,$07,$DC,$9F,$00,$16,$CE,$B2,$95,$04,$29,$44,$CE,$F2,$2B,
    $0F,$82,$AC,$BD,$8A,$33,$0F,$1F,$34,$08,$15,$89,$10,$EC,$61,$E6,
    $E6,$8D,$5A,$52,$59,$14,$90,$7A,$C0,$CC,$E8,$D0,$9F,$E8,$54,$0D,
    $9B,$EA,$07,$40,$F6,$E5,$8D,$9D,$22,$F9,$F2,$90,$9F,$88,$E4,$85,
    $26,$14,$C9,$3F,$47,$DE,$22,$92,$A0,$37,$C0,$7E,$8E,$08,$F4,$36,
    $6D,$83,$6E,$ED,$96,$34,$1E,$68,$83,$3C,$60,$D9,$53,$A2,$86,$0F,
    $65,$E1,$76,$08,$D7,$7A,$D3,$58,$38,$D1,$17,$D5,$48,$0F,$80,$EE,
    $ED,$67,$93,$AB,$03,$BD,$47,$00,$C2,$7C,$48,$D9,$5F,$66,$38,$F7,
    $01,$8E,$1C,$85,$11,$3C,$A5,$82,$14,$71,$69,$1C,$52,$44,$D9,$E4,
    $5A,$35,$2B,$4C,$F1,$2D,$A4,$40,$BB,$A4,$71,$33,$E9,$26,$02,$A7,
    $40,$56,$B7,$20,$70,$34,$B5,$D8,$31,$FB,$1E,$8B,$F0,$64,$24,$ED,
    $99,$00,$65,$73,$A0,$1D,$E0,$35,$83,$86,$3C,$74,$B8,$BA,$E6,$E4,
    $67,$D5,$9F,$1E,$69,$A8,$3F,$78,$EA,$F4,$99,$2F,$BE,$3C,$DB,$F8,
    $D5,$79,$E1,$C2,$D7,$D0,$AF,$6C,$69,$B3,$E9,$85,$07,$04,$C1,$59,
    $C6,$56,$8D,$E7,$2F,$C8,$04,$8E,$E3,$DD,$5E,$B4,$4B,$30,$0F,$1B,
    $AD,$84,$D8,$67,$19,$2D,$F4,$D3,$DD,$E0,$8D,$AF,$23,$5B,$31,$40,
    $2E,$61,$DF,$6A,$A0,$33,$77,$9E,$5C,$29,$9F,$94,$AB,$C7,$B5,$AE,
    $EB,$25,$DD,$0F,$03,$C5,$FA,$E1,$57,$5F,$97,$F7,$3B,$BF,$D2,$5D,
    $7D,$ED,$91,$C5,$1E,$97,$D4,$DD,$EF,$DA,$60,$F4,$63,$44,$8F,$1B,
    $3C,$C6,$59,$A9,$73,$56,$41,$3C,$D4,$28,$8C,$FF,$85,$15,$22,$A8,
    $4C,$1B,$4A,$84,$A2,$49,$2A,$D6,$41,$83,$8A,$13,$62,$D7,$FE,$E0,
    $30,$DF,$65,$8F,$74,$3C,$A5,$B9,$CB,$1E,$E2,$F4,$68,$95,$6F,$40,
    $BC,$86,$38,$DA,$EF,$B2,$0F,$4C,$52,$42,$B6,$46,$8B,$96,$A4,$E2,
    $5E,$5B,$EA,$A4,$10,$0C,$6A,$76,$98,$05,$49,$DF,$19,$EE,$68,$8F,
    $5D,$1B,$36,$11,$07,$C3,$0D,$9F,$82,$79,$79,$E4,$4F,$F4,$CE,$28,
    $6C,$F4,$C2,$0A,$0C,$63,$EB,$00,$20,$87,$79,$60,$38,$27,$B8,$33,
    $72,$3F,$BA,$17,$E5,$6C,$D4,$52,$39,$96,$1E,$F1,$82,$55,$96,$E1,
    $A7,$39,$CC,$94,$48,$B8,$06,$6E,$10,$95,$4C,$E6,$73,$6E,$F4,$0B,
    $92,$2E,$45,$51,$3A,$44,$A6,$02,$12,$BA,$40,$79,$9E,$01,$A5,$E5,
    $F1,$AE,$02,$1D,$AF,$80,$21,$CD,$A4,$04,$E7,$D0,$85,$15,$3E,$34,
    $6F,$AF,$30,$9B,$E4,$8E,$DC,$10,$90,$3B,$17,$F4,$39,$1B,$CC,$40,
    $37,$79,$71,$35,$15,$58,$AB,$A4,$7F,$C0,$71,$E9,$0E,$3A,$C7,$CB,
    $44,$17,$8D,$53,$2F,$A6,$F2,$C1,$EC,$59,$8F,$6B,$1B,$BA,$69,$8A,
    $B7,$B0,$42,$0F,$89,$83,$FD,$C7,$59,$41,$5D,$56,$6A,$A3,$DB,$69,
    $20,$60,$DC,$6D,$6D,$7E,$DC,$3D,$21,$47,$67,$BD,$02,$20,$BE,$2E,
    $87,$64,$B4,$68,$6A,$57,$B8,$29,$74,$3D,$70,$5F,$D3,$D4,$CA,$21,
    $C9,$20,$29,$E4,$6B,$E0,$C9,$E1,$CB,$CE,$D7,$3B,$7C,$BF,$5B,$A7,
    $73,$D0,$58,$9C,$CF,$34,$19,$FE,$7A,$6A,$82,$E9,$AF,$A7,$46,$8E,
    $02,$01,$3B,$0B,$73,$F1,$BF,$9E,$1A,$61,$9A,$9F,$B9,$00,$E3,$26,
    $C6,$B0,$AE,$10,$1A,$E8,$8D,$8E,$B2,$3A,$94,$A9,$6F,$BB,$09,$AA,
    $2D,$3B,$5B,$3E,$B2,$FF,$92,$56,$BA,$87,$E8,$C9,$80,$71,$A7,$EC,
    $D6,$99,$52,$6F,$92,$2A,$92,$05,$22,$78,$C6,$3A,$DD,$7A,$67,$B9,
    $7E,$A6,$FD,$9C,$12,$0A,$9A,$D1,$59,$2E,$2E,$76,$7E,$A3,$93,$1E,
    $2C,$D6,$8F,$8F,$B0,$8F,$9A,$29,$F5,$2A,$4E,$D5,$8C,$9F,$AA,$B1,
    $0F,$99,$29,$E9,$8B,$53,$B5,$E3,$A7,$6A,$ED,$03,$E2,$71,$29,$78,
    $F1,$D8,$53,$F6,$A8,$B1,$37,$EC,$86,$FD,$DE,$A8,$FD,$4A,$14,$F8,
    $B4,$63,$6F,$60,$99,$E7,$C9,$55,$5B,$3F,$95,$AB,$F7,$37,$46,$E5,
    $C8,$D5,$F2,$51,$94,$A5,$F0,$AB,$6F,$CA,$47,$51,$C8,$76,$3C,$E2,
    $29,$59,$D1,$1B,$8B,$18,$B2,$45,$AF,$4F,$94,$99,$B3,$F5,$9C,$5C,
    $AB,$8E,$1D,$69,$CE,$A6,$68,$F9,$33,$B9,$F2,$2F,$F1,$B5,$C3,$6A,
    $F7,$E0,$70,$19,$DF,$10,$5F,$D7,$FA,$BD,$B3,$7C,$D4,$D6,$E8,$98,
    $24,$98,$36,$7C,$5F,$74,$6D,$63,$48,$A5,$18,$33,$32,$69,$EB,$E0,
    $C9,$64,$BA,$29,$BA,$B0,$2D,$20,$E0,$E8,$B8,$07,$C1,$B0,$53,$9B,
    $C2,$84,$59,$81,$D2,$D8,$AB,$3B,$8A,$93,$63,$02,$5B,$C3,$26,$4F,
    $B3,$5F,$73,$56,$F4,$63,$6D,$21,$1F,$8D,$AF,$F3,$FE,$0F,$76,$18,
    $96,$97,$5C,$69,$03,$0D,$50,$10,$EF,$8E,$6F,$F8,$E4,$F0,$E1,$C3,
    $86,$E2,$3B,$52,$1C,$D7,$63,$25,$DF,$FB,$82,$E3,$FA,$48,$69,$85,
    $E3,$7A,$9C,$94,$E3,$B8,$6E,$C2,$CF,$7A,$29,$DB,$71,$3D,$53,$5A,
    $E4,$B8,$3E,$CA,$DE,$8B,$E1,$AD,$97,$66,$61,$C8,$D4,$2D,$0D,$52,
    $AC,$22,$C2,$77,$B4,$43,$19,$E5,$B8,$1E,$BE,$6E,$C4,$38,$DF,$BA,
    $A1,$2E,$D1,$A1,$71,$6B,$EA,$01,$73,$4B,$83,$FD,$9B,$9B,$9F,$4A,
    $51,$45,$EE,$0D,$3D,$E7,$C7,$5F,$93,$1F,$40,$4E,$52,$94,$D0,$D6,
    $FA,$4D,$CD,$EB,$2F,$2D,$1C,$F6,$A5,$D2,$74,$F3,$00,$E0,$29,$FB,
    $3E,$01,$C6,$8C,$2C,$85,$74,$D6,$71,$3D,$3B,$5F,$E7,$50,$62,$55,
    $9A,$6B,$23,$1D,$4A,$0F,$C7,$F5,$90,$75,$B5,$0E,$4F,$04,$90,$AF,
    $D9,$DF,$28,$06,$89,$7F,$AE,$FC,$CB,$13,$18,$B2,$46,$DD,$6B,$48,
    $68,$00,$59,$BD,$04,$74,$9C,$BE,$30,$7B,$4C,$9E,$86,$9E,$03,$F7,
    $10,$01,$2A,$66,$A2,$00,$A2,$20,$85,$31,$EB,$DE,$AE,$7D,$4F,$43,
    $3C,$41,$D9,$6C,$31,$EE,$0E,$11,$B6,$E1,$70,$EF,$83,$BE,$61,$CB,
    $D3,$E4,$09,$B9,$99,$71,$16,$21,$17,$A7,$C0,$F4,$EB,$6F,$D8,$9A,
    $E1,$0C,$EC,$77,$F1,$71,$C1,$7E,$57,$65,$6D,$41,$85,$E2,$B2,$B6,
    $D8,$5C,$56,$1F,$74,$10,$48,$23,$41,$2C,$28,$5D,$1B,$DD,$FB,$0D,
    $0E,$2D,$BC,$CB,$8D,$0D,$86,$BE,$F0,$0D,$EA,$E6,$76,$98,$2B,$2B,
    $97,$73,$B6,$63,$86,$39,$43,$DC,$01,$10,$79,$5F,$8E,$F3,$DC,$C3,
    $39,$91,$E5,$39,$AF,$62,$20,$CA,$BD,$90,$3E,$2B,$65,$CE,$BC,$49,
    $69,$D6,$45,$89,$AB,$F3,$57,$66,$AF,$5A,$BA,$28,$79,$D9,$CA,$35,
    $B9,$2B,$16,$A5,$CD,$99,$2E,$A4,$D8,$32,$66,$64,$17,$3C,$3E,$37,
    $7B,$A5,$7D,$19,$2A,$C2,$86,$F3,$D0,$1D,$30,$A5,$AA,$DB,$4E,$92,
    $35,$C7,$E3,$6B,$8A,$BB,$4F,$52,$B5,$19,$E8,$45,$62,$A9,$A7,$D7,
    $61,$E8,$93,$CB,$33,$BD,$CB,$05,$DE,$1F,$64,$8F,$5C,$49,$1E,$24,
    $73,$DD,$64,$ED,$19,$D0,$DA,$61,$74,$06,$18,$BD,$72,$7D,$D1,$35,
    $BB,$97,$7E,$03,$C8,$EA,$BC,$08,$D4,$95,$1E,$26,$81,$D4,$04,$9D,
    $19,$DC,$46,$5A,$00,$8E,$A5,$CF,$E2,$7C,$5F,$70,$56,$18,$3C,$F4,
    $71,$16,$01,$86,$59,$9A,$86,$8F,$27,$61,$44,$FF,$AE,$26,$30,$DB,
    $8F,$F3,$24,$C8,$E4,$E4,$9B,$64,$5A,$7D,$BC,$7B,$F6,$7E,$AF,$76,
    $CA,$D5,$37,$E7,$B3,$0E,$20,$D7,$CA,$E7,$C8,$B4,$32,$18,$0B,$34,
    $B3,$C9,$C2,$33,$A0,$37,$44,$32,$50,$F9,$6E,$DC,$71,$69,$D0,$42,
    $12,$E9,$F4,$88,$A4,$20,$AA,$E8,$9A,$14,$4A,$9E,$8A,$96,$47,$8F,
    $75,$7A,$62,$A6,$D8,$21,$D2,$7E,$5E,$5D,$0F,$85,$3C,$A2,$88,$30,
    $AE,$56,$D2,$13,$CB,$19,$68,$99,$AB,$30,$F8,$20,$AF,$F3,$9E,$C7,
    $75,$50,$F2,$54,$2D,$0C,$9C,$DD,$8C,$BB,$8D,$B3,$9D,$55,$DA,$9C,
    $2B,$FF,$96,$22,$E6,$B3,$3C,$20,$B9,$27,$53,$E3,$1E,$56,$4D,$16,
    $4D,$F6,$3F,$82,$E3,$C9,$6C,$22,$D0,$2A,$10,$8F,$F9,$99,$92,$36,
    $70,$7E,$BE,$F7,$C3,$EB,$AC,$5F,$94,$05,$02,$82,$03,$20,$D2,$0C,
    $FE,$A5,$E7,$90,$01,$39,$E1,$0D,$52,$DF,$1C,$98,$B1,$B8,$0B,$A2,
    $6C,$90,$F4,$19,$48,$9A,$09,$23,$F9,$A9,$85,$81,$AF,$16,$12,$7D,
    $20,$BB,$D9,$53,$92,$36,$3B,$7D,$4B,$DD,$06,$5D,$C0,$D6,$12,$5F,
    $07,$73,$E5,$A8,$A5,$64,$80,$DC,$5F,$5E,$A1,$AF,$9A,$24,$8E,$1B,
    $69,$11,$E4,$49,$86,$A5,$72,$C4,$C2,$F9,$0B,$3C,$DE,$DF,$E0,$98,
    $9E,$6C,$1A,$41,$2C,$06,$28,$50,$77,$A8,$B4,$42,$1B,$D4,$5A,$26,
    $45,$BB,$9B,$0E,$15,$D5,$31,$8C,$44,$05,$D2,$7C,$C8,$2B,$3A,$2E,
    $64,$7A,$B6,$D4,$6D,$D6,$78,$6C,$69,$E8,$A3,$0B,$32,$41,$3F,$4E,
    $D4,$43,$C3,$6B,$D6,$46,$A1,$00,$82,$08,$9E,$6D,$FF,$AE,$3B,$4D,
    $3F,$CF,$CA,$A1,$C6,$09,$52,$1F,$9B,$2D,$6D,$4E,$9E,$16,$62,$2F,
    $60,$EC,$18,$88,$75,$56,$E8,$33,$3D,$73,$98,$A0,$37,$62,$D8,$9D,
    $2C,$4C,$CC,$F4,$04,$E9,$85,$DB,$02,$05,$A2,$F7,$34,$2A,$8A,$8E,
    $3C,$C2,$6C,$E9,$DE,$6A,$3E,$D6,$42,$D3,$F5,$27,$93,$34,$8E,$71,
    $5E,$C9,$E0,$18,$A7,$D8,$0D,$C6,$8F,$DD,$93,$26,$29,$30,$F3,$0A,
    $D1,$EC,$EF,$C8,$5B,$B3,$36,$06,$07,$ED,$CF,$20,$D1,$6C,$35,$B7,
    $AF,$30,$B7,$F7,$A0,$4F,$CE,$87,$E1,$BB,$0B,$5E,$8F,$34,$35,$FE,
    $1C,$C6,$3F,$0F,$F1,$0B,$3C,$25,$B6,$B4,$60,$AC,$51,$65,$FF,$3C,
    $46,$AE,$C5,$C8,$4C,$56,$37,$30,$32,$B5,$5A,$44,$5C,$5D,$32,$16,
    $F5,$84,$EA,$2C,$1C,$FB,$25,$60,$10,$5B,$3F,$92,$1A,$2D,$AD,$F2,
    $53,$9C,$57,$90,$DE,$06,$B4,$3A,$EA,$8C,$5B,$9A,$71,$2A,$03,$D3,
    $7C,$E3,$96,$6F,$D0,$D8,$C5,$8D,$19,$B0,$33,$0B,$C7,$1D,$69,$BF,
    $DC,$5D,$7A,$88,$1E,$B9,$89,$CB,$B3,$06,$AC,$B1,$B5,$C3,$78,$D5,
    $AD,$8B,$C5,$45,$62,$DB,$6C,$3A,$EC,$1C,$2A,$14,$21,$D3,$B8,$65,
    $07,$5A,$11,$E5,$6C,$5F,$25,$D5,$A0,$8C,$EA,$70,$AA,$49,$35,$6B,
    $EF,$08,$26,$ED,$6D,$83,$91,$53,$9F,$36,$DB,$46,$9B,$BE,$62,$89,
    $A1,$C0,$D2,$6A,$67,$AA,$A8,$4D,$8F,$6F,$80,$19,$C2,$52,$32,$30,
    $1D,$2A,$07,$F8,$18,$9A,$27,$D8,$72,$D3,$EF,$B7,$08,$69,$F4,$5F,
    $80,$4A,$36,$98,$86,$52,$FF,$30,$60,$B6,$14,$7B,$99,$BC,$0D,$BF,
    $64,$B5,$9E,$3C,$22,$56,$4D,$16,$37,$03,$9E,$D3,$13,$42,$97,$E3,
    $F2,$DB,$79,$EF,$4E,$28,$36,$FD,$0C,$90,$C9,$56,$86,$D6,$43,$2E,
    $61,$70,$92,$DE,$FB,$5B,$28,$7D,$99,$86,$DB,$42,$B7,$D4,$D5,$AA,
    $8E,$BA,$92,$06,$FB,$E9,$47,$B8,$50,$D0,$5B,$CF,$6B,$09,$BB,$31,
    $D6,$92,$3D,$C2,$3B,$19,$25,$D4,$D2,$8F,$60,$5D,$E9,$D9,$A2,$C7,
    $54,$91,$CC,$0F,$71,$FD,$36,$5C,$3E,$40,$42,$41,$68,$93,$E4,$CB,
    $D0,$E3,$1E,$86,$BE,$E8,$93,$1E,$22,$A9,$F5,$E6,$59,$F5,$F6,$BE,
    $C4,$72,$9C,$CC,$43,$05,$84,$63,$67,$B8,$25,$91,$D9,$E7,$52,$3F,
    $B2,$F9,$0C,$A4,$09,$D8,$6B,$9D,$95,$FA,$69,$76,$37,$5A,$D6,$5E,
    $D6,$0E,$C9,$30,$7C,$75,$6D,$B7,$49,$01,$D6,$62,$90,$67,$0C,$1D,
    $7F,$A3,$B3,$4D,$3A,$2B,$96,$B7,$C9,$8B,$8D,$C1,$36,$F9,$5B,$B0,
    $4D,$A2,$B1,$4D,$EE,$FD,$85,$A6,$C8,$6E,$EC,$68,$8A,$95,$F1,$0D,
    $5D,$9A,$00,$DB,$65,$2E,$B6,$43,$C3,$28,$6C,$87,$3B,$01,$6F,$21,
    $6B,$88,$82,$A1,$3F,$69,$08,$68,$85,$B0,$78,$56,$A5,$7A,$7A,$18,
    $2A,$39,$B0,$44,$F4,$9A,$B0,$D3,$4E,$1E,$FA,$73,$ED,$E0,$6D,$FF,
    $51,$3B,$60,$75,$F2,$B6,$90,$06,$43,$9D,$56,$25,$8A,$8F,$C6,$AB,
    $DB,$4E,$24,$4F,$0F,$3D,$88,$7E,$8C,$54,$8F,$62,$1D,$A9,$09,$89,
    $7B,$C1,$9C,$8C,$79,$73,$D3,$B1,$1F,$87,$E5,$69,$72,$B1,$BA,$D2,
    $BC,$2B,$CF,$AA,$7D,$11,$68,$8E,$AA,$B2,$88,$9F,$01,$0D,$5A,$71,
    $2F,$64,$AA,$66,$1D,$21,$AB,$AC,$24,$1A,$9C,$8F,$8A,$37,$78,$7B,
    $77,$23,$89,$7A,$3A,$0F,$38,$62,$EB,$9E,$F1,$6E,$67,$45,$F4,$52,
    $12,$35,$9F,$F4,$94,$7B,$74,$66,$87,$B6,$F3,$53,$3F,$43,$48,$4F,
    $07,$41,$CA,$05,$64,$A9,$69,$44,$BC,$1B,$C6,$36,$7D,$66,$16,$35,
    $23,$AB,$E7,$3C,$60,$66,$4F,$57,$37,$7A,$80,$FF,$A5,$B2,$36,$70,
    $B4,$DC,$80,$7C,$C3,$94,$D6,$BB,$94,$EB,$32,$18,$6B,$49,$86,$9E,
    $68,$27,$3E,$27,$08,$EE,$CD,$23,$A4,$45,$13,$FF,$88,$8E,$DE,$D2,
    $BC,$91,$30,$9E,$B8,$A5,$45,$23,$FF,$80,$55,$32,$31,$55,$9A,$A9,
    $3C,$1A,$F2,$DB,$40,$E0,$61,$27,$D5,$E6,$3F,$28,$8D,$52,$D2,$26,
    $FE,$19,$31,$7B,$48,$13,$47,$3E,$8F,$98,$F7,$A5,$4A,$BD,$52,$25,
    $93,$32,$7E,$E4,$0D,$F4,$DE,$EF,$A4,$13,$A5,$7B,$94,$11,$A5,$D5,
    $CA,$F0,$D2,$1A,$E5,$9E,$D2,$4F,$95,$BB,$4A,$3F,$53,$EE,$00,$FF,
    $80,$D2,$93,$4A,$9F,$D2,$23,$4A,$CF,$D2,$7A,$A5,$7B,$E9,$69,$25,
    $A2,$F4,$94,$12,$5A,$7A,$50,$D1,$96,$06,$86,$A0,$B1,$44,$D2,$0C,
    $CC,$56,$CE,$2A,$17,$6F,$ED,$23,$58,$E4,$A0,$FC,$18,$99,$0D,$4C,
    $4D,$5F,$32,$E1,$91,$D6,$20,$A2,$9F,$16,$E1,$1E,$06,$34,$25,$4A,
    $4D,$8F,$04,$94,$1A,$E5,$0B,$75,$17,$A9,$D0,$CC,$E4,$39,$3D,$9A,
    $24,$F5,$93,$06,$75,$6A,$A0,$EB,$D0,$67,$E5,$7A,$55,$07,$5D,$46,
    $8B,$39,$DD,$40,$FB,$62,$EF,$EB,$26,$A8,$33,$23,$A8,$36,$D4,$49,
    $65,$A7,$90,$B3,$D9,$D1,$58,$79,$F7,$82,$55,$1C,$EF,$86,$FA,$05,
    $4B,$63,$29,$89,$80,$AA,$95,$F5,$D0,$D8,$87,$1F,$80,$C1,$24,$57,
    $2F,$87,$BC,$A1,$AE,$D5,$42,$FD,$33,$27,$A0,$8C,$AB,$B6,$EB,$89,
    $00,$88,$1E,$12,$EE,$6C,$0B,$48,$FA,$71,$1A,$FB,$0F,$44,$50,$E7,
    $61,$B8,$AF,$33,$77,$DE,$27,$AF,$B1,$65,$56,$3D,$F4,$E1,$54,$F2,
    $88,$81,$AC,$11,$71,$F2,$7A,$2D,$21,$38,$79,$2D,$6A,$D8,$D4,$73,
    $9A,$0C,$11,$C9,$5F,$8A,$80,$A3,$0D,$D4,$16,$35,$6C,$BE,$14,$B4,
    $68,$94,$68,$6F,$21,$4A,$50,$29,$D4,$1B,$DD,$0C,$5D,$94,$1E,$81,
    $0F,$48,$4F,$16,$B3,$A7,$80,$FE,$F6,$9D,$EA,$96,$CD,$34,$32,$2A,
    $A1,$81,$AC,$67,$D4,$E7,$8E,$0E,$52,$37,$5F,$DD,$14,$4D,$C4,$B3,
    $49,$F2,$A0,$52,$15,$0D,$E8,$9B,$AF,$6E,$6E,$EA,$42,$FF,$4E,$A4,
    $6F,$43,$FA,$83,$91,$FE,$AA,$0E,$FA,$72,$08,$92,$8E,$77,$CB,$21,
    $98,$56,$EE,$BD,$0B,$0B,$92,$28,$CA,$21,$B1,$50,$83,$F4,$C4,$4D,
    $DC,$87,$1A,$8A,$B3,$00,$9A,$CF,$C6,$AE,$F4,$B9,$A4,$9F,$6B,$8D,
    $48,$52,$44,$D2,$07,$86,$EC,$31,$30,$47,$65,$0A,$E8,$12,$5B,$B3,
    $EF,$12,$37,$13,$EA,$4C,$53,$2D,$6B,$9D,$95,$86,$69,$F6,$26,$75,
    $DF,$95,$84,$8C,$05,$52,$1F,$26,$83,$10,$A8,$76,$38,$58,$E1,$0E,
    $B0,$C2,$7B,$4D,$03,$FD,$78,$85,$84,$58,$30,$CF,$FC,$9E,$B8,$0D,
    $87,$CE,$E7,$86,$D5,$7E,$68,$43,$33,$B2,$DC,$79,$CE,$58,$FC,$DC,
    $22,$70,$02,$EA,$7E,$2A,$DA,$BF,$63,$B6,$94,$5A,$EB,$83,$F6,$E1,
    $77,$64,$19,$7C,$03,$EB,$62,$02,$EB,$62,$C9,$43,$7B,$70,$15,$EA,
    $EA,$EB,$8F,$2C,$8E,$77,$FF,$81,$65,$D9,$5A,$DF,$DF,$6D,$A9,$C1,
    $1E,$84,$4A,$E1,$43,$4C,$F7,$31,$86,$7F,$32,$01,$3E,$8E,$A7,$4C,
    $82,$BD,$8F,$F3,$61,$41,$EA,$41,$FA,$CA,$B5,$09,$75,$72,$5F,$42,
    $03,$9F,$43,$80,$FD,$B2,$73,$A2,$85,$4D,$81,$26,$D3,$87,$03,$A8,
    $3A,$53,$99,$AF,$CF,$DE,$D1,$C0,$4B,$59,$CC,$BB,$C0,$EE,$C3,$31,
    $50,$37,$1F,$0D,$04,$1B,$34,$C6,$31,$31,$6A,$1B,$5B,$CC,$80,$A1,
    $75,$0E,$B8,$72,$11,$0B,$AC,$E7,$45,$0D,$6C,$33,$C0,$A2,$E6,$A5,
    $B5,$47,$E0,$A9,$9A,$90,$04,$B7,$9C,$64,$60,$6B,$97,$10,$A8,$59,
    $1B,$82,$13,$BD,$41,$24,$09,$AC,$7A,$A9,$0F,$7D,$A2,$0F,$54,$42,
    $52,$14,$B1,$45,$99,$6D,$A2,$14,$9A,$46,$47,$01,$0D,$BA,$9C,$23,
    $DB,$75,$81,$F4,$A1,$C8,$B6,$14,$42,$5B,$71,$BB,$DC,$2C,$80,$88,
    $86,$DA,$E8,$45,$30,$30,$88,$6E,$2E,$69,$26,$D7,$79,$1D,$2C,$56,
    $9E,$B1,$AD,$CE,$97,$56,$AC,$5E,$55,$10,$9B,$B4,$7A,$CD,$93,$F9,
    $2B,$96,$E7,$4A,$B1,$43,$97,$0C,$8B,$8D,$1F,$37,$36,$61,$C4,$B8,
    $71,$B1,$DC,$20,$56,$97,$A5,$41,$1E,$B0,$5E,$BC,$9F,$03,$55,$CF,
    $B3,$AC,$41,$BC,$5E,$36,$BB,$89,$02,$9B,$36,$A6,$8A,$9D,$F8,$22,
    $53,$7D,$53,$36,$44,$35,$07,$A6,$FA,$EC,$11,$36,$57,$A2,$8F,$86,
    $5D,$06,$C3,$0D,$65,$03,$CC,$D3,$13,$A4,$17,$60,$0E,$A8,$D2,$75,
    $60,$76,$67,$98,$7A,$44,$FC,$F2,$12,$AE,$58,$8B,$33,$ED,$A7,$31,
    $2F,$C0,$33,$01,$C6,$A4,$CD,$03,$C0,$00,$4B,$F4,$D3,$45,$6C,$D8,
    $C9,$4C,$23,$A9,$7E,$FA,$C6,$65,$B4,$4A,$14,$B1,$39,$90,$E8,$FB,
    $03,$E6,$1D,$FD,$63,$5A,$CF,$5D,$42,$79,$84,$98,$08,$A4,$B1,$E9,
    $17,$30,$73,$2F,$71,$1B,$CB,$BD,$29,$C6,$E6,$74,$87,$D3,$87,$91,
    $0D,$B7,$7E,$81,$6C,$F3,$57,$59,$7C,$A8,$A2,$2B,$C5,$28,$C1,$03,
    $6A,$A1,$44,$B5,$B1,$4F,$C0,$7C,$D1,$47,$0F,$43,$C1,$E5,$36,$B9,
    $0A,$2C,$E7,$70,$B9,$5C,$6E,$A6,$BD,$2E,$A3,$BE,$A1,$CD,$A8,$76,
    $CC,$9D,$67,$09,$0A,$2B,$04,$54,$5D,$A7,$C8,$45,$9C,$B2,$6F,$0E,
    $87,$F9,$FB,$A7,$80,$A2,$2C,$07,$D3,$16,$54,$F5,$C6,$11,$CC,$92,
    $C4,$25,$64,$D0,$7B,$06,$5B,$7A,$06,$FA,$E9,$A5,$53,$90,$A6,$B9,
    $E8,$DA,$A6,$6E,$E4,$38,$A9,$22,$47,$68,$21,$9E,$11,$4A,$50,$ED,
    $CE,$3C,$81,$63,$55,$33,$2C,$8C,$4F,$A8,$A3,$8F,$00,$06,$86,$CE,
    $25,$61,$41,$2A,$6F,$40,$3C,$E4,$0F,$B4,$D5,$F6,$4B,$93,$CF,$ED,
    $C1,$02,$D1,$84,$00,$B3,$F9,$E2,$6B,$A0,$46,$EE,$4C,$1B,$1F,$21,
    $F5,$85,$09,$B7,$D4,$03,$A6,$DA,$52,$E4,$F8,$A9,$3A,$29,$04,$26,
    $E5,$0A,$4D,$4C,$4C,$94,$8F,$2E,$18,$76,$D4,$2B,$72,$3B,$94,$E1,
    $8F,$4C,$CB,$31,$47,$48,$B1,$39,$66,$40,$EE,$0B,$5F,$51,$EA,$0E,
    $DF,$50,$4C,$A3,$57,$2E,$38,$CB,$B5,$EA,$FF,$2C,$E5,$51,$AF,$17,
    $97,$38,$D4,$B4,$C5,$11,$89,$5E,$3C,$BF,$01,$F3,$75,$DB,$6C,$F9,
    $64,$BC,$FB,$CA,$DB,$76,$6D,$EB,$D1,$4C,$CD,$FE,$CC,$47,$BC,$DB,
    $31,$82,$D1,$0F,$21,$53,$FD,$90,$CE,$7D,$33,$D8,$2E,$92,$8E,$58,
    $FC,$1E,$88,$79,$18,$D7,$C9,$8C,$5B,$CE,$81,$A0,$F3,$96,$20,$4F,
    $FA,$C9,$5C,$BF,$A6,$7D,$DC,$11,$A9,$2F,$7D,$0C,$26,$90,$72,$33,
    $99,$E9,$27,$BD,$34,$ED,$74,$CB,$77,$4C,$8B,$79,$E8,$34,$08,$26,
    $3A,$B9,$4D,$A1,$48,$23,$1B,$29,$6C,$03,$0A,$E6,$28,$69,$91,$59,
    $2F,$75,$07,$DB,$E6,$4F,$37,$50,$9C,$BC,$78,$D6,$0B,$E9,$1E,$93,
    $8F,$D8,$48,$92,$5F,$97,$E2,$A7,$DF,$E2,$E6,$41,$15,$34,$6F,$3D,
    $99,$E6,$A7,$F1,$40,$52,$6E,$67,$59,$E8,$D2,$FD,$F4,$2E,$F0,$66,
    $CA,$ED,$30,$FF,$D1,$05,$66,$F9,$E8,$34,$55,$6D,$7A,$E4,$83,$5E,
    $0B,$26,$3B,$E8,$9D,$82,$D5,$96,$3E,$37,$CD,$26,$1F,$8B,$77,$93,
    $E9,$2F,$44,$E1,$72,$9C,$6E,$92,$7F,$AA,$FD,$0A,$75,$01,$8A,$0D,
    $E6,$84,$C9,$2F,$47,$CB,$57,$70,$5D,$10,$E4,$5A,$73,$84,$1E,$69,
    $0A,$04,$A6,$D9,$BD,$0B,$32,$81,$55,$1D,$C8,$28,$FD,$01,$46,$FC,
    $05,$8B,$17,$66,$BA,$4C,$2F,$04,$1A,$F9,$5E,$2E,$2E,$A8,$8D,$AB,
    $35,$6E,$79,$16,$97,$00,$AF,$49,$B9,$C0,$C1,$E3,$24,$C5,$4F,$E6,
    $F9,$87,$D5,$AE,$D3,$6A,$CA,$D3,$F6,$5F,$C4,$A5,$97,$EE,$64,$F0,
    $B8,$53,$F6,$CC,$A9,$52,$6F,$32,$53,$04,$7B,$16,$3C,$D3,$40,$1D,
    $3B,$AB,$F4,$53,$D9,$D2,$4B,$A5,$E8,$AC,$12,$17,$38,$CF,$E9,$A4,
    $BB,$10,$77,$EC,$29,$FB,$A4,$A9,$52,$DF,$B1,$37,$EC,$E3,$A7,$4A,
    $51,$85,$E7,$C1,$12,$13,$0A,$BF,$C2,$2F,$24,$BC,$57,$E3,$56,$EE,
    $66,$19,$28,$31,$90,$15,$80,$DE,$0B,$7E,$6E,$35,$A6,$63,$CE,$18,
    $41,$6C,$BE,$44,$EC,$77,$16,$1F,$9B,$A7,$6A,$3D,$42,$D9,$47,$E3,
    $61,$7A,$C7,$74,$C5,$08,$EC,$85,$D2,$3D,$E9,$B2,$07,$BB,$76,$A1,
    $1F,$67,$CB,$D0,$46,$BD,$48,$2A,$74,$4E,$48,$94,$EA,$C3,$6E,$BE,
    $5F,$01,$F1,$EE,$B5,$50,$AE,$65,$E5,$06,$22,$23,$49,$A6,$1F,$A6,
    $AF,$F7,$4C,$DD,$30,$70,$DC,$E9,$8D,$83,$87,$1D,$2B,$AA,$D9,$D0,
    $7F,$DC,$A9,$CD,$3D,$34,$E5,$CC,$3E,$5C,$04,$84,$94,$1E,$F1,$75,
    $CA,$D7,$F2,$29,$45,$61,$41,$D9,$30,$E2,$2F,$04,$73,$C3,$03,$C9,
    $2D,$90,$73,$3C,$AF,$3F,$32,$CB,$3F,$0F,$44,$67,$EA,$FA,$81,$C5,
    $A1,$29,$C3,$8E,$6E,$8A,$06,$61,$8C,$92,$0F,$41,$E4,$D1,$AB,$FF,
    $7C,$64,$B1,$64,$00,$0A,$4D,$0B,$E2,$DD,$8A,$1E,$3A,$FE,$02,$D9,
    $37,$AC,$B6,$F3,$BC,$12,$4A,$5E,$7C,$00,$88,$A5,$12,$1D,$90,$BD,
    $DB,$B9,$DE,$A7,$B1,$0F,$72,$52,$BD,$B3,$3C,$DC,$26,$37,$D2,$91,
    $17,$41,$30,$40,$85,$C8,$3A,$79,$8D,$BF,$52,$1C,$25,$28,$43,$E5,
    $5A,$FA,$57,$5C,$4F,$AE,$62,$29,$A2,$E4,$76,$28,$DF,$B8,$EF,$37,
    $68,$E5,$EF,$69,$C3,$45,$A6,$37,$CA,$DA,$3B,$F5,$46,$A9,$C6,$3B,
    $EE,$62,$50,$AF,$76,$57,$F5,$AA,$2D,$8D,$B6,$7D,$8E,$9A,$94,$F1,
    $C0,$84,$1F,$49,$19,$54,$5D,$6A,$A3,$67,$3E,$E7,$DA,$93,$AA,$7C,
    $A2,$09,$B4,$0F,$D7,$25,$B1,$37,$19,$B7,$BC,$83,$B3,$C2,$34,$1B,
    $7D,$EB,$73,$5C,$5F,$31,$6E,$F9,$4B,$80,$F5,$B7,$F4,$E2,$A9,$1A,
    $2C,$90,$4B,$8A,$88,$20,$1B,$22,$42,$61,$6C,$4E,$11,$35,$F5,$A4,
    $27,$45,$FB,$1B,$A4,$65,$D6,$E6,$A6,$0E,$5D,$A6,$EA,$BE,$F8,$BA,
    $E2,$D0,$E2,$B9,$9A,$F8,$1A,$87,$2F,$42,$1A,$EA,$F0,$45,$4A,$77,
    $3B,$7C,$06,$74,$75,$93,$1E,$74,$F8,$BA,$4B,$B3,$1C,$3E,$A3,$64,
    $74,$F8,$7A,$48,$11,$A5,$5A,$9C,$79,$3C,$01,$83,$84,$8C,$0B,$0D,
    $B3,$36,$FB,$14,$AB,$1C,$29,$4F,$13,$E5,$69,$7A,$79,$9A,$C1,$E9,
    $89,$9A,$B5,$F9,$B2,$F2,$40,$86,$FC,$39,$99,$73,$5F,$84,$5C,$AF,
    $5B,$74,$9F,$96,$4C,$BF,$2F,$14,$F2,$C7,$F9,$FE,$AC,$CD,$34,$4B,
    $89,$86,$58,$35,$46,$BE,$42,$A7,$B2,$D0,$66,$7E,$56,$8B,$29,$33,
    $EF,$63,$CC,$F6,$F8,$A5,$B2,$B4,$74,$94,$45,$AE,$C7,$94,$CE,$36,
    $C1,$B8,$E5,$0B,$AC,$B6,$1F,$97,$0A,$CB,$14,$8F,$65,$4A,$C1,$32,
    $65,$62,$99,$1E,$C3,$32,$3D,$05,$65,$32,$6E,$61,$66,$AA,$AF,$87,
    $71,$0B,$98,$D2,$B8,$DA,$9A,$59,$AA,$F5,$96,$50,$A8,$F7,$36,$8D,
    $5C,$BF,$39,$82,$B6,$80,$A6,$F7,$16,$E2,$40,$75,$90,$1A,$DA,$40,
    $16,$D7,$AB,$31,$61,$F4,$01,$54,$F9,$79,$10,$3C,$09,$1D,$D9,$72,
    $3D,$14,$9D,$CE,$08,$13,$84,$59,$9B,$AF,$2A,$69,$3F,$57,$FE,$CC,
    $60,$F9,$47,$77,$2D,$7F,$1F,$5E,$7E,$E5,$0E,$24,$21,$D2,$E1,$46,
    $95,$84,$51,$AE,$97,$AF,$60,$C0,$77,$7A,$0C,$F8,$1E,$99,$F3,$94,
    $A8,$F5,$D3,$9D,$DB,$66,$F3,$32,$98,$E0,$BA,$8B,$27,$69,$5C,$1B,
    $34,$11,$64,$B5,$1F,$B4,$D2,$2C,$DF,$6C,$32,$4B,$1C,$B6,$7F,$53,
    $A4,$5C,$AE,$69,$D6,$9C,$A6,$D3,$A1,$3C,$64,$B2,$48,$FA,$92,$9E,
    $C5,$11,$8E,$36,$AC,$8E,$B6,$48,$69,$A2,$A3,$CD,$20,$4D,$71,$B4,
    $75,$93,$32,$1C,$6D,$DD,$A5,$35,$8E,$36,$A8,$0E,$07,$56,$47,$5B,
    $0F,$B5,$5E,$4A,$B5,$6C,$96,$59,$F8,$2D,$24,$8F,$0E,$D5,$D4,$53,
    $33,$9E,$2B,$C2,$55,$3B,$65,$A3,$1A,$90,$77,$23,$18,$B0,$D2,$C5,
    $02,$C2,$41,$74,$CB,$F0,$3A,$83,$B2,$10,$46,$87,$A9,$9A,$80,$14,
    $A1,$85,$BF,$50,$32,$1D,$1A,$30,$5C,$C5,$C9,$86,$E8,$4C,$C5,$CC,
    $E2,$21,$5C,$3B,$5B,$3E,$AA,$46,$8C,$C0,$F5,$20,$E5,$2E,$9E,$57,
    $77,$A0,$C4,$48,$F7,$90,$8F,$AA,$41,$B1,$7A,$1E,$A4,$9B,$0C,$7A,
    $4E,$3F,$C3,$58,$14,$8D,$8B,$4F,$50,$D2,$08,$57,$B4,$4E,$D3,$4C,
    $97,$00,$A7,$5D,$CE,$FC,$A9,$62,$40,$56,$9A,$A2,$8B,$8D,$1D,$C5,
    $4E,$C2,$62,$A7,$61,$B1,$B3,$B1,$D8,$1B,$59,$B1,$FF,$14,$2C,$F6,
    $CB,$9D,$C5,$2E,$FE,$06,$3B,$31,$E9,$43,$AD,$AD,$AC,$1B,$82,$72,
    $9D,$61,$BF,$E4,$45,$39,$61,$C1,$AB,$FC,$5D,$82,$95,$DF,$61,$6B,
    $D1,$08,$18,$98,$40,$0C,$9C,$95,$51,$18,$96,$03,$45,$9C,$05,$0D,
    $63,$D4,$62,$24,$99,$A5,$0F,$AC,$13,$E9,$12,$60,$59,$37,$58,$F7,
    $D0,$0C,$FB,$45,$E8,$38,$10,$2E,$B7,$D1,$84,$9B,$38,$95,$2C,$9E,
    $AC,$D1,$2D,$0A,$D3,$EA,$A4,$30,$ED,$0C,$FB,$D7,$A0,$60,$30,$97,
    $D1,$DD,$90,$62,$30,$97,$68,$0C,$83,$04,$7D,$C2,$3A,$43,$9B,$90,
    $5B,$54,$87,$25,$5D,$6C,$93,$EF,$C9,$69,$B4,$4D,$EC,$E1,$A4,$92,
    $C6,$5F,$43,$F9,$E4,$B6,$C9,$3D,$3F,$B2,$4D,$E6,$31,$AB,$22,$ED,
    $68,$C7,$DE,$84,$72,$ED,$16,$AB,$44,$8D,$7F,$00,$E3,$29,$A9,$24,
    $9F,$82,$55,$52,$73,$4D,$B5,$4A,$32,$C0,$02,$E5,$F1,$3D,$8F,$DE,
    $62,$95,$30,$7D,$96,$27,$E0,$36,$88,$1C,$63,$22,$A2,$C9,$46,$FB,
    $21,$85,$5A,$72,$84,$78,$D8,$59,$EB,$05,$C1,$33,$BF,$9C,$DF,$7A,
    $08,$FF,$BA,$95,$99,$3E,$1E,$7A,$06,$1C,$6C,$95,$79,$63,$5C,$2E,
    $02,$36,$7B,$9C,$0B,$11,$7F,$80,$0E,$C8,$56,$8A,$69,$61,$2D,$B8,
    $D4,$59,$E5,$3F,$6B,$71,$EB,$44,$19,$CA,$0C,$A5,$74,$16,$BB,$04,
    $83,$28,$18,$4C,$54,$66,$91,$38,$F5,$67,$11,$53,$D1,$5B,$D5,$D5,
    $7E,$2A,$ED,$E1,$DD,$7E,$01,$3A,$53,$A9,$D1,$FB,$17,$06,$A3,$BC,
    $7F,$42,$88,$DB,$2A,$51,$AD,$E5,$78,$F0,$D5,$3E,$D4,$D9,$AE,$CF,
    $BF,$BB,$B0,$1D,$4F,$0C,$4B,$DD,$0B,$DB,$35,$00,$ED,$FD,$03,$43,
    $E8,$7B,$93,$84,$1C,$54,$E5,$30,$30,$78,$0F,$B5,$04,$02,$CC,$E3,
    $B1,$D1,$84,$5A,$B6,$7E,$88,$03,$3A,$AE,$00,$E4,$38,$C7,$EA,$F3,
    $87,$DB,$D2,$72,$0A,$C7,$0A,$1A,$5C,$01,$1D,$AB,$D1,$48,$7A,$1B,
    $35,$00,$9A,$12,$15,$E8,$8D,$74,$14,$3D,$10,$A1,$4F,$B7,$A0,$D9,
    $92,$E3,$1C,$AF,$2F,$E8,$41,$22,$64,$3D,$99,$AA,$97,$53,$E1,$6B,
    $90,$53,$0D,$9E,$9C,$C2,$F1,$90,$3C,$1A,$80,$46,$63,$BF,$D7,$46,
    $1B,$B0,$BB,$04,$86,$34,$43,$6A,$92,$A6,$0F,$BF,$C5,$30,$46,$4E,
    $34,$B2,$4D,$EF,$61,$2C,$C1,$20,$F1,$C6,$67,$81,$40,$B8,$DB,$58,
    $14,$C3,$ED,$3E,$B6,$6E,$DF,$CC,$76,$65,$5D,$1B,$9B,$67,$EF,$11,
    $D9,$EC,$61,$3E,$08,$4E,$BD,$CB,$DA,$4C,$5D,$20,$C8,$B8,$5E,$7F,
    $3C,$31,$B8,$5E,$0F,$A1,$81,$DE,$4D,$90,$97,$2B,$03,$DA,$08,$CC,
    $D7,$DF,$E0,$96,$6D,$70,$8D,$BE,$21,$11,$B7,$C5,$9A,$E9,$0C,$2D,
    $6E,$8B,$CD,$03,$7B,$5B,$69,$86,$FA,$C5,$A5,$78,$B6,$A7,$A0,$32,
    $1D,$C6,$CE,$EB,$A8,$3B,$07,$B7,$F0,$D0,$86,$A2,$92,$43,$74,$39,
    $23,$A1,$84,$61,$39,$81,$6A,$69,$BA,$32,$0F,$B7,$7B,$C9,$67,$F4,
    $63,$F5,$54,$CF,$EA,$9C,$2A,$6B,$B3,$20,$CC,$43,$E9,$05,$66,$E7,
    $42,$6E,$36,$7A,$FA,$08,$0E,$7D,$30,$2B,$9A,$88,$AB,$01,$1E,$9A,
    $82,$C0,$DA,$2C,$EB,$88,$D5,$27,$27,$E9,$89,$D5,$0F,$73,$2E,$65,
    $34,$A7,$84,$47,$CA,$95,$7B,$B9,$67,$B9,$4A,$B6,$5F,$07,$C1,$74,
    $FA,$4C,$90,$DA,$65,$D5,$EE,$43,$EE,$D9,$DE,$35,$9E,$16,$91,$AD,
    $7E,$92,$A8,$C7,$8D,$C2,$3B,$6F,$B0,$BC,$4E,$DF,$C0,$06,$D7,$09,
    $1A,$96,$8B,$9E,$EF,$13,$C3,$9C,$B8,$1E,$17,$7A,$62,$6F,$70,$61,
    $7E,$4F,$45,$D3,$0B,$72,$81,$3E,$78,$0E,$A8,$29,$5D,$B6,$36,$E5,
    $10,$2D,$39,$95,$63,$AE,$B7,$77,$23,$D6,$26,$5A,$0B,$68,$DE,$23,
    $28,$2C,$13,$05,$8D,$7D,$7E,$8E,$F3,$BA,$5E,$8D,$78,$13,$F8,$F4,
    $BE,$8F,$11,$AC,$FC,$58,$C9,$2F,$B1,$8D,$F7,$8C,$DC,$15,$C9,$1D,
    $8D,$03,$6D,$62,$6D,$22,$87,$E8,$BF,$6E,$76,$D9,$38,$39,$9B,$AC,
    $36,$CA,$A8,$1B,$B8,$6F,$52,$DE,$84,$8D,$82,$CB,$EF,$1A,$FB,$E2,
    $9C,$89,$20,$82,$20,$68,$3E,$BD,$3D,$02,$73,$E9,$8D,$55,$93,$D6,
    $91,$45,$CE,$1E,$BD,$40,$B3,$6E,$AA,$D9,$1C,$F9,$51,$36,$94,$FE,
    $5C,$26,$87,$FC,$98,$49,$16,$CB,$44,$E5,$65,$D0,$4D,$5C,$03,$84,
    $3A,$64,$82,$0B,$13,$D6,$34,$BD,$B7,$ED,$7B,$30,$C8,$65,$8F,$B3,
    $29,$2A,$A7,$4A,$34,$81,$26,$6D,$DC,$83,$BD,$8A,$7E,$CD,$56,$76,
    $E8,$D3,$DF,$B3,$33,$0A,$60,$66,$39,$2B,$A2,$16,$AA,$7B,$D2,$F9,
    $7E,$34,$91,$58,$1F,$1A,$10,$58,$63,$08,$AC,$D1,$07,$D6,$88,$81,
    $51,$4C,$B0,$E5,$73,$F4,$7F,$50,$0D,$57,$44,$75,$9D,$57,$D0,$AB,
    $50,$9A,$54,$B6,$96,$12,$B0,$EB,$E9,$F7,$6D,$EA,$F2,$54,$89,$F7,
    $64,$2B,$EB,$97,$F4,$AF,$1A,$B6,$26,$C8,$DA,$A2,$11,$ED,$85,$19,
    $3E,$72,$05,$1B,$38,$CB,$4F,$06,$12,$AB,$9E,$8C,$2D,$0A,$6C,$1E,
    $50,$14,$D8,$18,$56,$2A,$D2,$DF,$37,$A2,$4C,$F9,$C9,$09,$5A,$81,
    $4D,$91,$8A,$87,$81,$40,$1A,$9A,$C1,$6A,$8D,$74,$2A,$22,$D8,$B8,
    $D6,$66,$27,$9E,$5F,$2E,$4E,$D1,$68,$2A,$49,$8A,$56,$B6,$52,$92,
    $82,$CB,$BB,$22,$19,$A5,$68,$13,$AE,$91,$AA,$D6,$27,$A8,$6C,$BD,
    $40,$AC,$17,$FE,$D2,$1A,$30,$5B,$A9,$84,$64,$E3,$70,$25,$D5,$7A,
    $41,$0F,$64,$42,$9C,$66,$8D,$7D,$8C,$9C,$D5,$68,$DE,$D8,$BC,$71,
    $10,$98,$FF,$FD,$F1,$7C,$89,$9E,$9C,$34,$FE,$3B,$83,$EA,$CA,$C9,
    $8C,$E6,$B8,$CF,$20,$FB,$89,$78,$7C,$D0,$DA,$48,$32,$2E,$D0,$BF,
    $9D,$C5,$63,$EB,$8D,$CA,$E2,$40,$24,$50,$A5,$8F,$9C,$65,$2A,$14,
    $04,$DF,$DA,$64,$DE,$D8,$B4,$51,$27,$6F,$6C,$02,$32,$C3,$49,$46,
    $13,$92,$60,$D4,$12,$6A,$E8,$1B,$E7,$B0,$24,$4D,$36,$92,$E1,$27,
    $3D,$D5,$2C,$8E,$D0,$93,$68,$BD,$F4,$21,$33,$00,$73,$06,$25,$C7,
    $60,$C6,$87,$85,$15,$68,$5F,$E0,$AF,$4A,$87,$D6,$06,$0C,$34,$B2,
    $19,$F7,$94,$4E,$C6,$65,$34,$33,$7A,$56,$6A,$FC,$B7,$B5,$59,$E7,
    $01,$9A,$73,$70,$61,$7F,$A3,$4F,$B3,$E9,$3E,$A7,$55,$2F,$06,$66,
    $F8,$66,$15,$05,$36,$DC,$35,$B9,$CA,$DA,$C2,$D6,$03,$AC,$7A,$1B,
    $B1,$B6,$B8,$44,$27,$81,$2A,$3E,$C1,$CE,$B0,$06,$AC,$2D,$B3,$EC,
    $DF,$60,$A7,$E9,$A7,$F6,$31,$5C,$39,$74,$CF,$71,$8A,$26,$91,$E6,
    $B1,$B9,$24,$3B,$3B,$91,$A0,$DA,$C8,$CD,$81,$29,$3E,$50,$76,$72,
    $B5,$6A,$2E,$CC,$89,$08,$45,$FB,$19,$4C,$6D,$40,$09,$03,$9B,$4A,
    $84,$C1,$08,$CC,$74,$2A,$7D,$89,$52,$82,$6B,$4E,$FD,$00,$81,$E9,
    $40,$A8,$D9,$E8,$E6,$C0,$34,$9F,$BD,$BB,$2D,$4D,$3E,$18,$48,$F2,
    $D1,$57,$71,$E4,$C9,$94,$41,$B2,$4A,$9C,$15,$17,$F2,$62,$F0,$0C,
    $3A,$E8,$C6,$45,$07,$61,$F4,$DA,$60,$8A,$C2,$83,$02,$F6,$50,$5C,
    $9C,$84,$66,$73,$3B,$2B,$62,$80,$1E,$E9,$1D,$B3,$0D,$17,$1F,$A5,
    $FE,$E6,$44,$51,$8A,$30,$27,$EA,$A5,$10,$73,$A2,$C1,$2E,$92,$C4,
    $28,$0F,$E9,$59,$54,$67,$FF,$D6,$A3,$84,$DA,$68,$66,$4D,$20,$50,
    $1C,$A5,$1E,$4E,$58,$64,$BF,$8C,$FD,$BC,$B0,$A2,$94,$4F,$6B,$A1,
    $42,$A1,$B8,$56,$5F,$EE,$A2,$29,$16,$81,$6E,$AC,$51,$CF,$2C,$4A,
    $96,$DC,$95,$E0,$4F,$A7,$52,$0D,$9E,$67,$6B,$71,$6E,$6C,$11,$A4,
    $11,$EA,$99,$81,$22,$3C,$04,$6A,$C3,$5D,$CF,$40,$46,$0B,$88,$52,
    $EF,$2E,$21,$74,$25,$E0,$7B,$7B,$E3,$E6,$82,$D5,$EF,$18,$BB,$C8,
    $3E,$16,$E1,$7A,$CD,$22,$63,$91,$A0,$06,$3A,$DD,$5A,$A6,$DF,$48,
    $BD,$C3,$0C,$66,$F1,$45,$DC,$67,$4D,$D2,$D0,$39,$9D,$41,$27,$D1,
    $B0,$0A,$05,$79,$77,$7A,$B4,$E4,$6A,$9C,$DD,$EF,$4A,$D1,$30,$E2,
    $3C,$1F,$1A,$85,$79,$BC,$C4,$13,$0E,$0C,$B0,$83,$0A,$55,$71,$1E,
    $52,$AB,$3B,$91,$58,$D8,$8E,$3C,$1A,$9F,$7D,$0E,$A2,$2D,$B6,$74,
    $35,$89,$AE,$12,$46,$A4,$6A,$90,$D0,$A2,$0F,$6E,$E2,$D8,$CC,$E9,
    $3C,$5A,$CD,$CE,$51,$5C,$0F,$48,$CB,$D3,$E9,$34,$16,$7F,$0E,$E3,
    $E9,$6E,$74,$CF,$D5,$E8,$CA,$2D,$13,$91,$DA,$E6,$D4,$CA,$2D,$63,
    $30,$C9,$22,$8E,$10,$A4,$6A,$B1,$D1,$0D,$5D,$92,$39,$C0,$6D,$D1,
    $35,$93,$B3,$58,$8C,$22,$5C,$20,$E9,$5A,$33,$69,$98,$9B,$D5,$C7,
    $75,$F7,$E3,$CB,$F2,$57,$2D,$5B,$99,$F0,$C0,$7D,$4B,$57,$AE,$44,
    $59,$9A,$BC,$4C,$9A,$BE,$7A,$D5,$72,$5B,$B6,$94,$3B,$33,$FB,$89,
    $65,$EC,$5E,$2D,$6B,$A7,$C6,$9B,$D8,$4E,$D0,$4C,$BC,$F2,$CF,$DF,
    $64,$76,$06,$3D,$54,$15,$08,$54,$5A,$2F,$09,$B8,$41,$9D,$FB,$B0,
    $60,$44,$D3,$69,$C2,$34,$8B,$90,$AB,$C1,$7D,$ED,$6E,$D5,$6C,$B8,
    $B8,$A3,$6B,$6C,$66,$47,$EC,$E5,$2A,$B6,$EB,$9D,$8F,$1A,$74,$FA,
    $D4,$CE,$5D,$6F,$1A,$C2,$76,$BD,$A9,$CD,$65,$BD,$C4,$6C,$19,$35,
    $3B,$7A,$48,$2D,$84,$CF,$46,$3F,$62,$29,$A5,$01,$5D,$91,$72,$D7,
    $4F,$C3,$4D,$70,$88,$FD,$7B,$55,$17,$E5,$9B,$3E,$95,$87,$3E,$59,
    $85,$DA,$F7,$2C,$98,$AC,$CA,$65,$B5,$19,$59,$19,$E8,$24,$08,$CF,
    $0B,$71,$59,$AF,$DA,$F2,$74,$34,$A6,$0A,$83,$2E,$55,$02,$81,$6B,
    $8E,$8F,$10,$01,$24,$E1,$DF,$68,$FA,$6E,$BC,$2A,$D8,$23,$1C,$1B,
    $2F,$81,$FF,$EF,$42,$47,$0D,$D0,$5E,$55,$D8,$78,$AA,$4F,$57,$AF,
    $68,$A6,$39,$CC,$F7,$49,$11,$AA,$1F,$06,$AE,$E6,$A0,$4B,$7A,$22,
    $09,$13,$4B,$31,$C8,$6E,$3A,$3D,$0C,$39,$E0,$7E,$63,$90,$CC,$CE,
    $4A,$75,$E5,$CB,$9E,$82,$19,$49,$16,$64,$27,$9D,$FE,$F3,$47,$58,
    $4F,$07,$B1,$62,$2B,$AD,$3F,$08,$2A,$CE,$EF,$7F,$84,$F3,$18,$C3,
    $C1,$F3,$36,$D8,$BE,$E9,$AB,$73,$A4,$75,$D9,$F9,$CB,$3A,$F6,$F8,
    $A7,$AF,$5E,$92,$BD,$72,$19,$BB,$B7,$FC,$93,$38,$BE,$FF,$DF,$05,
    $45,$A0,$91,$EA,$DE,$10,$BD,$9B,$EF,$E9,$93,$FA,$32,$3C,$F0,$49,
    $8D,$B8,$AC,$DA,$3B,$16,$97,$A2,$F1,$76,$E2,$AB,$E8,$62,$F6,$2A,
    $19,$83,$4E,$50,$AD,$77,$91,$B9,$78,$90,$76,$E0,$76,$F4,$13,$81,
    $61,$EC,$C5,$B4,$60,$41,$7B,$4F,$B1,$CD,$7F,$3C,$B3,$2E,$DD,$4B,
    $22,$40,$51,$0D,$24,$F3,$45,$A8,$AF,$68,$B0,$AE,$34,$B2,$36,$88,
    $B7,$1F,$F0,$A0,$0F,$A2,$0E,$39,$15,$3C,$9F,$A4,$9E,$11,$06,$49,
    $64,$84,$41,$65,$80,$6E,$15,$A4,$71,$28,$44,$93,$A7,$07,$85,$88,
    $64,$F9,$A0,$8D,$03,$E9,$62,$C7,$82,$7F,$84,$77,$14,$E8,$61,$FA,
    $87,$AF,$99,$F8,$93,$60,$42,$7B,$15,$3F,$F8,$1A,$D4,$63,$72,$D4,
    $AB,$31,$EA,$39,$07,$B4,$6B,$F0,$74,$66,$5D,$46,$EE,$99,$E9,$C1,
    $8D,$05,$D4,$FC,$16,$91,$4A,$81,$2E,$22,$76,$7E,$3A,$3B,$7D,$61,
    $0E,$C1,$84,$76,$03,$1B,$1C,$18,$11,$65,$F0,$76,$A6,$1A,$DD,$52,
    $1F,$12,$65,$CE,$F0,$C3,$5C,$03,$C7,$15,$E0,$26,$94,$E0,$BD,$92,
    $8B,$1E,$EF,$2C,$B0,$A4,$95,$72,$7E,$A6,$13,$AC,$6E,$7F,$F0,$68,
    $94,$34,$B1,$F0,$29,$11,$AF,$16,$6F,$1C,$DE,$69,$E1,$93,$24,$F8,
    $D3,$C1,$D0,$B3,$B5,$1D,$DB,$7A,$53,$45,$C7,$9C,$64,$DE,$45,$A0,
    $13,$01,$D3,$8F,$74,$91,$0E,$54,$D8,$54,$43,$E4,$67,$BA,$6E,$5D,
    $4F,$21,$DA,$80,$4D,$AF,$EE,$6D,$EB,$65,$8C,$D1,$CF,$66,$61,$E2,
    $7C,$68,$85,$D0,$D9,$44,$03,$D1,$9E,$92,$C0,$90,$6A,$76,$E7,$35,
    $A1,$4E,$B6,$45,$C9,$36,$43,$9A,$CB,$16,$95,$C6,$EC,$8A,$E8,$C0,
    $28,$BA,$D8,$C3,$BA,$9F,$2E,$C1,$ED,$A1,$7B,$3D,$B8,$63,$F5,$84,
    $74,$D5,$03,$BE,$D9,$C4,$66,$28,$AA,$DB,$34,$20,$A1,$06,$AC,$F1,
    $D9,$B8,$89,$3A,$3B,$4D,$4D,$92,$AE,$26,$81,$F6,$98,$EF,$A1,$4F,
    $83,$47,$69,$0D,$E0,$8E,$62,$29,$A8,$59,$7A,$A2,$1C,$8C,$11,$BB,
    $C6,$43,$9F,$80,$08,$CF,$5C,$D2,$0C,$D6,$43,$8A,$41,$4E,$89,$22,
    $29,$E2,$C8,$77,$00,$43,$8A,$4C,$95,$62,$53,$A5,$FB,$BC,$53,$34,
    $EA,$FB,$0F,$8E,$BD,$38,$EC,$EE,$C1,$55,$A0,$AA,$94,$98,$0D,$33,
    $2C,$82,$72,$2F,$86,$5B,$D4,$70,$BC,$75,$A7,$18,$31,$C0,$7D,$0B,
    $E2,$9B,$80,$58,$95,$62,$AA,$67,$20,$F6,$0D,$00,$8E,$4D,$A9,$D0,
    $A3,$DF,$16,$F0,$DA,$50,$2E,$4E,$ED,$67,$E7,$C1,$5C,$C0,$95,$92,
    $6A,$A3,$A9,$E5,$58,$B2,$80,$71,$8B,$82,$66,$54,$68,$E1,$26,$F1,
    $BD,$93,$B8,$6D,$F7,$2A,$78,$03,$33,$C5,$3C,$21,$F0,$20,$9D,$00,
    $38,$16,$E3,$96,$1A,$08,$1A,$89,$4B,$20,$05,$30,$2A,$A2,$32,$B2,
    $41,$9C,$4D,$8D,$7B,$8B,$D1,$26,$C7,$81,$2E,$CB,$C0,$F5,$67,$3C,
    $5D,$9B,$06,$08,$7D,$01,$61,$41,$AA,$B1,$88,$B0,$69,$82,$B9,$BC,
    $60,$BA,$63,$5F,$28,$46,$0E,$90,$74,$16,$E5,$32,$F6,$EA,$B8,$72,
    $A4,$14,$8A,$94,$A4,$E5,$E0,$6A,$D9,$8F,$35,$95,$A5,$DC,$05,$A5,
    $40,$F6,$81,$A9,$77,$B1,$7E,$C4,$BC,$6B,$8A,$36,$EF,$07,$BA,$6B,
    $3F,$E3,$59,$32,$33,$7E,$59,$D5,$F5,$85,$64,$45,$FB,$59,$ED,$47,
    $39,$7D,$5A,$7B,$18,$94,$1C,$EB,$21,$C1,$0D,$CD,$F8,$20,$5D,$00,
    $51,$55,$29,$AC,$1D,$CA,$56,$60,$B5,$79,$B9,$8F,$36,$42,$8C,$D2,
    $E0,$DA,$8A,$1C,$C9,$A9,$D1,$D0,$A6,$7A,$DE,$60,$55,$16,$3D,$96,
    $04,$DA,$58,$4E,$8D,$AA,$B2,$F4,$6B,$06,$72,$72,$6A,$8C,$9C,$1A,
    $2B,$A7,$9A,$5C,$96,$54,$90,$AA,$81,$EF,$FF,$BE,$38,$22,$71,$AB,
    $DE,$B2,$A5,$46,$EA,$D1,$E1,$0A,$BB,$F9,$A9,$9D,$A6,$6E,$1D,$8A,
    $77,$98,$0B,$DB,$91,$73,$BB,$3E,$60,$8B,$81,$AE,$D0,$DD,$53,$D8,
    $CE,$D8,$6D,$2D,$C3,$E3,$43,$DE,$E7,$4F,$80,$68,$77,$45,$8A,$FD,
    $19,$A4,$55,$88,$84,$3A,$09,$31,$2F,$B2,$98,$EE,$CE,$76,$ED,$BA,
    $FE,$2A,$CD,$48,$E2,$09,$A4,$9B,$C0,$A1,$5D,$E8,$A1,$89,$27,$50,
    $E6,$26,$DA,$4A,$27,$09,$52,$33,$4B,$AE,$28,$EC,$EE,$75,$33,$39,
    $0D,$9A,$AA,$F0,$22,$16,$4C,$8A,$70,$B6,$EB,$D6,$F5,$A7,$FF,$C2,
    $D1,$BC,$52,$5E,$2C,$06,$E6,$F6,$63,$D3,$1D,$F1,$04,$53,$58,$65,
    $39,$A8,$FB,$5A,$3F,$07,$52,$DF,$EF,$C5,$FC,$94,$8F,$F7,$22,$83,
    $CA,$EE,$BD,$28,$1B,$4A,$29,$4E,$16,$0B,$D7,$B3,$36,$B1,$DF,$47,
    $D6,$47,$EB,$D6,$E3,$D1,$F5,$38,$9B,$C1,$7C,$74,$73,$1F,$8D,$CD,
    $10,$77,$D0,$36,$9B,$1C,$BC,$FA,$9A,$CA,$60,$C2,$FC,$4C,$E5,$B4,
    $26,$D5,$C0,$4E,$51,$4D,$C4,$BD,$33,$7B,$34,$2E,$57,$E2,$AD,$F2,
    $CC,$05,$F3,$39,$21,$69,$37,$6B,$18,$EA,$C0,$6C,$4F,$D0,$27,$3F,
    $C7,$D3,$44,$CA,$A7,$E4,$E0,$DE,$95,$A0,$5C,$9C,$6D,$96,$4D,$77,
    $3A,$BD,$16,$DB,$EC,$3D,$16,$C4,$FA,$1D,$EE,$68,$DE,$A9,$EF,$38,
    $C2,$6A,$EF,$06,$C8,$9F,$17,$D5,$18,$9F,$7D,$14,$E7,$B5,$F3,$33,
    $C1,$24,$C5,$3D,$89,$34,$5C,$F7,$4F,$68,$28,$1E,$10,$77,$68,$53,
    $24,$A8,$85,$A3,$6C,$1A,$B5,$20,$93,$1C,$5A,$98,$E8,$C5,$BB,$D9,
    $7B,$77,$E2,$9E,$24,$F6,$24,$76,$9F,$C5,$BB,$0A,$86,$97,$60,$D1,
    $EE,$20,$A9,$06,$73,$AA,$7E,$63,$B8,$2E,$35,$7A,$6B,$8F,$80,$C5,
    $E0,$B1,$A5,$A9,$45,$BA,$77,$41,$A6,$72,$4E,$2D,$4A,$4F,$28,$C9,
    $97,$37,$B1,$24,$C1,$82,$D4,$B0,$82,$78,$77,$1F,$07,$16,$DF,$3D,
    $CE,$CE,$D8,$A4,$B9,$66,$07,$68,$3C,$56,$F7,$71,$75,$93,$06,$F7,
    $4A,$16,$00,$8F,$8A,$00,$75,$D9,$3C,$9B,$B4,$3B,$6B,$02,$A5,$C2,
    $95,$B7,$5B,$8F,$4E,$21,$ED,$0B,$E2,$8E,$92,$CA,$D9,$54,$83,$6B,
    $5A,$A0,$EB,$4E,$3E,$B2,$D8,$8B,$F6,$32,$AE,$BD,$6F,$48,$95,$AC,
    $13,$85,$68,$E8,$A0,$AE,$CD,$38,$78,$D4,$3A,$CF,$0D,$76,$45,$3F,
    $D7,$30,$22,$A3,$3A,$CD,$22,$7C,$59,$B3,$9F,$86,$48,$26,$0C,$35,
    $4A,$06,$35,$FC,$66,$BA,$1A,$2E,$42,$80,$E8,$68,$18,$61,$7D,$61,
    $0E,$06,$78,$5A,$EB,$19,$9D,$8D,$89,$3F,$A6,$D1,$86,$34,$1A,$7F,
    $4A,$A3,$0D,$69,$54,$77,$A1,$D1,$E6,$69,$18,$F9,$31,$A4,$F0,$9C,
    $BA,$E4,$11,$D4,$7F,$8E,$C0,$E6,$0E,$D7,$C3,$DC,$B5,$4D,$6B,$E1,
    $AE,$EA,$90,$A0,$AB,$5D,$CF,$5D,$96,$97,$0D,$DC,$65,$F3,$18,$B9,
    $CB,$D4,$D2,$53,$75,$39,$FE,$FC,$52,$1F,$D5,$15,$BB,$EF,$E3,$FE,
    $AA,$6B,$E8,$E3,$97,$62,$54,$57,$9B,$F6,$C5,$58,$E6,$B2,$EC,$4E,
    $DA,$7B,$37,$73,$45,$BD,$7E,$9C,$DE,$C3,$5C,$C3,$BF,$DD,$F2,$A7,
    $E1,$E8,$72,$B4,$C4,$7E,$F3,$FE,$48,$74,$6D,$8B,$FF,$D7,$23,$E7,
    $47,$A1,$4B,$FC,$A4,$66,$E0,$1F,$47,$A3,$EB,$C0,$7D,$FB,$FE,$F1,
    $CE,$43,$E0,$B2,$AC,$1D,$FF,$78,$E4,$97,$E3,$C1,$45,$65,$F1,$EE,
    $AA,$E2,$DF,$80,$EB,$B1,$9D,$07,$94,$F5,$6F,$4D,$02,$ED,$F9,$BB,
    $BE,$BB,$EF,$39,$59,$0F,$F3,$DB,$92,$9D,$AB,$1E,$58,$FF,$F4,$1F,
    $52,$2D,$C2,$AE,$79,$11,$0F,$F7,$C9,$FD,$17,$18,$63,$DB,$BF,$3B,
    $7C,$64,$60,$F9,$B1,$99,$96,$6D,$5B,$A2,$2D,$D9,$B3,$E7,$6F,$49,
    $B3,$54,$BF,$DE,$BF,$64,$CF,$EB,$AB,$5F,$CF,$B0,$8C,$37,$C6,$B6,
    $DC,$FB,$EC,$A1,$23,$99,$96,$2D,$E1,$2F,$F8,$D6,$8F,$7B,$B8,$70,
    $91,$E5,$EB,$C8,$3D,$0F,$9E,$0C,$7B,$76,$FB,$23,$96,$B3,$33,$97,
    $8B,$9F,$D6,$5C,$A9,$79,$CC,$F2,$E7,$BB,$0A,$AD,$96,$0D,$AB,$FD,
    $CB,$2C,$7F,$7B,$7F,$4D,$DC,$1B,$6F,$1D,$78,$65,$85,$E5,$F3,$7F,
    $7E,$16,$98,$32,$78,$7D,$F9,$31,$CB,$AB,$D1,$7F,$3D,$D0,$E7,$CD,
    $F7,$2E,$4F,$9C,$D4,$F8,$8C,$D7,$51,$33,$79,$EF,$F3,$6F,$4C,$DA,
    $D1,$F7,$9B,$CD,$71,$DB,$FB,$7C,$D0,$33,$F1,$F1,$8C,$7B,$C7,$B9,
    $5A,$D7,$34,$6E,$48,$1C,$55,$33,$E1,$7C,$E0,$CF,$69,$C5,$DF,$26,
    $FE,$F1,$CB,$B6,$57,$AE,$2B,$9B,$76,$CC,$4E,$7A,$E6,$FE,$BC,$45,
    $FD,$FD,$F7,$D4,$7D,$98,$B4,$F6,$FC,$E1,$2B,$C3,$EE,$DF,$52,$78,
    $4F,$72,$5D,$44,$49,$83,$70,$EF,$6B,$7F,$2F,$49,$EE,$BB,$C3,$F7,
    $76,$D4,$F9,$03,$15,$ED,$C9,$F3,$5F,$2E,$F5,$86,$BD,$5C,$7C,$65,
    $A9,$F5,$F8,$D5,$56,$E5,$AB,$A9,$BF,$7B,$F1,$33,$EB,$63,$FF,$78,
    $31,$EC,$4C,$FD,$6F,$CA,$C6,$A5,$54,$FD,$A9,$FB,$3F,$DF,$DE,$D6,
    $FF,$FC,$AB,$29,$7D,$0D,$F6,$C2,$A7,$ED,$6B,$6B,$52,$67,$5C,$F8,
    $BF,$E7,$C7,$99,$C7,$94,$BD,$FB,$5D,$FA,$D7,$59,$13,$0F,$64,$99,
    $C9,$DF,$9E,$5B,$F0,$CF,$E6,$ED,$B1,$EE,$39,$AF,$3F,$F3,$50,$36,
    $59,$40,$EA,$87,$64,$C9,$6D,$0D,$CB,$7D,$57,$EF,$FD,$E4,$1F,$D5,
    $59,$5F,$38,$56,$FD,$F5,$7F,$62,$8B,$B5,$69,$8F,$56,$0C,$B1,$37,
    $CF,$FF,$7C,$D5,$63,$3D,$C6,$BC,$7D,$F0,$A9,$34,$1B,$DE,$07,$6E,
    $35,$99,$60,$88,$C7,$63,$23,$4B,$4D,$06,$5D,$35,$11,$4D,$CC,$71,
    $74,$FE,$FC,$72,$BD,$F0,$2B,$50,$32,$C0,$58,$4A,$C0,$23,$23,$D1,
    $64,$BA,$A9,$5F,$64,$8D,$5D,$1F,$59,$27,$2D,$8A,$6C,$90,$32,$23,
    $EB,$9E,$8C,$68,$3D,$DD,$5A,$EF,$3C,$2D,$38,$3F,$D3,$44,$D6,$80,
    $EF,$54,$6B,$83,$F3,$94,$E0,$6C,$D5,$10,$2F,$D3,$26,$90,$32,$E1,
    $DA,$D1,$C6,$A3,$75,$47,$4F,$1C,$3D,$69,$BE,$91,$1F,$B9,$4E,$34,
    $5F,$CD,$0F,$89,$BB,$3A,$F0,$86,$E5,$DC,$B7,$0B,$5B,$3D,$D8,$65,
    $A5,$30,$4E,$05,$8F,$4F,$40,$8E,$AD,$57,$13,$EA,$94,$AB,$73,$89,
    $64,$32,$DC,$2D,$99,$F4,$CE,$9B,$01,$7B,$0F,$D2,$1C,$79,$05,$1F,
    $65,$10,$1C,$F6,$10,$B0,$4D,$53,$3D,$8B,$03,$10,$85,$7F,$74,$21,
    $74,$E6,$BB,$DD,$9C,$D3,$1F,$F1,$79,$3F,$F0,$19,$C7,$79,$F9,$45,
    $56,$6E,$C9,$FA,$67,$8B,$9C,$05,$A4,$E6,$FF,$A4,$C8,$61,$BC,$C8,
    $BF,$AA,$BC,$A8,$71,$FE,$63,$99,$9F,$83,$9C,$AF,$FC,$EA,$42,$CF,
    $FF,$85,$42,$27,$00,$A7,$F7,$FF,$9A,$42,$AB,$1A,$B0,$6B,$FE,$8E,
    $B6,$D8,$0D,$3D,$1C,$6D,$96,$0D,$21,$09,$75,$60,$8E,$91,$DA,$63,
    $E7,$00,$18,$5F,$2F,$3F,$D6,$E8,$E9,$88,$0B,$DD,$DF,$3E,$98,$94,
    $7B,$48,$F9,$5F,$8E,$F9,$3C,$C6,$B7,$6A,$8F,$B5,$7B,$7E,$9C,$AE,
    $3C,$A1,$EE,$18,$65,$71,$17,$D9,$1A,$11,$1A,$D7,$5F,$CE,$0B,$1A,
    $D7,$81,$90,$11,$78,$79,$E7,$A1,$32,$1C,$4C,$E9,$46,$DC,$F1,$60,
    $E7,$3E,$0A,$C0,$45,$EF,$01,$5B,$A5,$2C,$1A,$EF,$89,$2C,$FD,$0E,
    $77,$3E,$D0,$B5,$00,$5D,$2D,$EF,$81,$CB,$F6,$5D,$17,$BB,$F9,$6B,
    $A0,$E8,$F1,$CE,$40,$1B,$DF,$97,$D5,$91,$4F,$6D,$66,$30,$1F,$E7,
    $48,$CC,$47,$63,$74,$EE,$63,$06,$D2,$AB,$78,$0C,$83,$1F,$1A,$01,
    $80,$27,$DA,$2B,$43,$A6,$C2,$57,$5B,$19,$32,$4D,$05,$D3,$01,$E8,
    $72,$AA,$42,$30,$2F,$5C,$0E,$0C,$C1,$EC,$35,$E8,$88,$66,$D7,$C2,
    $AA,$42,$62,$D8,$4D,$63,$AD,$A3,$2A,$04,$97,$94,$4B,$40,$87,$55,
    $85,$E0,$92,$ED,$56,$E6,$6A,$E6,$61,$B4,$5F,$9D,$7A,$85,$86,$3E,
    $0C,$0E,$7A,$13,$3E,$AC,$B0,$7B,$CF,$00,$73,$D4,$7B,$8D,$97,$58,
    $F5,$9E,$06,$2F,$7D,$B3,$2C,$10,$78,$75,$14,$D6,$C7,$6F,$F7,$80,
    $6B,$04,$BA,$76,$B7,$80,$CB,$C4,$B8,$E5,$25,$3E,$99,$89,$25,$5E,
    $58,$AF,$96,$98,$AB,$FC,$C0,$90,$0A,$FE,$96,$8D,$9B,$C3,$7D,$1C,
    $96,$71,$B8,$4B,$3D,$77,$5E,$86,$17,$BC,$F0,$4C,$A4,$73,$E2,$71,
    $3C,$DA,$63,$8F,$28,$3B,$87,$43,$E6,$F2,$2F,$02,$81,$5C,$8C,$CB,
    $B3,$D0,$4F,$82,$B7,$3D,$0D,$6A,$DC,$34,$88,$53,$0C,$E9,$DB,$8F,
    $B3,$4B,$ED,$B8,$1F,$2A,$0F,$BA,$B0,$8B,$CD,$D5,$8A,$BB,$D5,$E2,
    $31,$A1,$10,$8C,$DA,$52,$63,$1F,$BA,$94,$F4,$1E,$81,$23,$A7,$F8,
    $7B,$0F,$2D,$41,$32,$21,$6A,$22,$89,$3D,$4C,$23,$69,$3C,$24,$04,
    $53,$7A,$60,$8E,$A9,$86,$9C,$82,$F9,$9E,$7A,$9B,$A3,$F3,$16,$C7,
    $F6,$33,$2C,$CD,$50,$4C,$5F,$41,$F7,$5F,$46,$6E,$E4,$41,$6E,$9C,
    $05,$35,$D8,$23,$B6,$EF,$02,$C7,$AB,$E8,$2B,$2B,$DD,$86,$F7,$F1,
    $AF,$E0,$4C,$45,$CF,$6E,$9F,$97,$E0,$72,$02,$12,$DB,$8B,$51,$69,
    $72,$08,$52,$92,$13,$C5,$AA,$44,$9C,$0C,$0A,$55,$89,$EC,$9D,$2D,
    $5A,$CC,$AC,$14,$3A,$EF,$34,$5B,$A7,$E4,$32,$33,$69,$41,$A7,$6C,
    $36,$EE,$EA,$52,$E1,$A9,$0B,$B0,$C2,$2F,$9E,$50,$2B,$9C,$B8,$9D,
    $23,$31,$5A,$E3,$09,$0C,$39,$5C,$A7,$D6,$6D,$35,$87,$15,$1C,$BA,
    $39,$DC,$C7,$61,$19,$87,$BB,$38,$2C,$E5,$70,$27,$87,$6F,$70,$F8,
    $1A,$87,$DB,$38,$7C,$99,$C3,$97,$38,$7C,$81,$C3,$12,$0E,$9F,$E1,
    $70,$2B,$87,$5B,$38,$74,$70,$B8,$81,$C3,$F5,$1C,$4A,$1C,$AE,$E1,
    $70,$25,$87,$B9,$1C,$2E,$E5,$F0,$51,$0E,$17,$71,$98,$C9,$E1,$1C,
    $0E,$6D,$1C,$4E,$E7,$30,$95,$C3,$64,$0E,$2D,$1C,$4E,$E0,$70,$2C,
    $87,$A3,$39,$1C,$C5,$E1,$08,$0E,$87,$72,$68,$E2,$30,$96,$C3,$18,
    $0E,$FB,$71,$18,$CD,$61,$14,$87,$06,$0E,$F5,$1C,$8A,$1C,$0A,$1C,
    $FA,$B9,$EC,$FB,$38,$6C,$09,$BE,$17,$C5,$61,$13,$87,$94,$C3,$0B,
    $1C,$36,$72,$78,$86,$C3,$7A,$0E,$8F,$73,$58,$CB,$E1,$E1,$60,$7A,
    $9E,$DF,$05,$0E,$1B,$39,$3C,$C3,$61,$3D,$87,$C7,$19,$04,$E5,$58,
    $02,$66,$ED,$77,$6C,$A9,$05,$CF,$99,$81,$4C,$A1,$C5,$DE,$82,$01,
    $36,$7A,$03,$97,$A9,$9A,$59,$E4,$69,$B6,$4E,$AB,$42,$88,$61,$0B,
    $58,$1F,$B3,$30,$2E,$B3,$3F,$2C,$EA,$94,$59,$DA,$55,$66,$FD,$8B,
    $50,$66,$1F,$3C,$DE,$29,$B3,$94,$C9,$2C,$4F,$37,$32,$AB,$33,$5D,
    $53,$D7,$74,$A3,$B3,$30,$DD,$CD,$63,$9D,$E9,$9A,$58,$BA,$64,$08,
    $EF,$6E,$90,$B2,$97,$5B,$33,$93,$AC,$B6,$29,$33,$53,$66,$C5,$42,
    $47,$C2,$19,$B1,$81,$BF,$8E,$86,$50,$CF,$21,$BB,$44,$8A,$F5,$CD,
    $CB,$DD,$1C,$6C,$97,$63,$BC,$5D,$98,$9F,$5D,$7E,$34,$BE,$E0,$E6,
    $7B,$54,$C8,$D7,$81,$2E,$7C,$35,$77,$E5,$EB,$30,$E3,$2B,$A7,$0B,
    $5F,$CD,$5D,$CB,$73,$A3,$4B,$BA,$96,$AE,$E9,$C4,$C5,$98,$EE,$BE,
    $2E,$E9,$5A,$BA,$A6,$1B,$B3,$B8,$33,$9D,$AF,$6B,$BA,$09,$2C,$DD,
    $B5,$BA,$CE,$74,$3E,$96,$0E,$F5,$49,$73,$40,$10,$10,$7E,$CF,$E1,
    $15,$0E,$AF,$72,$D8,$C2,$E1,$0F,$1C,$5E,$E3,$B0,$95,$43,$1F,$87,
    $6D,$1C,$B6,$73,$78,$9D,$43,$3F,$87,$37,$38,$BC,$C9,$61,$80,$C3,
    $46,$0E,$BF,$E2,$F0,$1C,$87,$E7,$39,$BC,$C0,$E1,$D7,$1C,$7E,$C3,
    $E1,$B7,$1C,$52,$0E,$BD,$1C,$5E,$E4,$50,$E1,$B0,$89,$C3,$EF,$38,
    $BC,$C4,$E1,$65,$0E,$6B,$39,$3C,$CA,$61,$1D,$87,$C7,$38,$3C,$CE,
    $E1,$E7,$1C,$9E,$E0,$F0,$24,$87,$F5,$1C,$9E,$E2,$F0,$34,$87,$0D,
    $1C,$9E,$E1,$F0,$0B,$0E,$BF,$E4,$F0,$2C,$87,$6E,$0E,$F7,$73,$58,
    $CE,$A1,$87,$C3,$0A,$0E,$0F,$70,$58,$C9,$61,$15,$87,$D5,$1C,$D6,
    $70,$78,$90,$C3,$43,$1C,$1E,$E6,$F0,$53,$0E,$8F,$70,$F8,$19,$87,
    $A5,$1C,$BE,$C3,$E1,$BB,$1C,$BE,$C7,$E1,$2E,$0E,$DF,$E7,$F0,$03,
    $0E,$77,$73,$58,$C6,$E1,$1E,$0E,$F7,$72,$F8,$21,$87,$FB,$38,$FC,
    $88,$C3,$8F,$39,$FC,$84,$C3,$6D,$01,$21,$D8,$5F,$7E,$78,$B4,$53,
    $7E,$FD,$B7,$F4,$FF,$47,$59,$FF,$AF,$ED,$94,$5F,$3F,$93,$5F,$43,
    $B6,$45,$88,$08,$9F,$93,$B2,$62,$E5,$32,$5C,$9B,$2F,$89,$01,$7F,
    $F7,$88,$39,$E9,$CB,$B2,$F3,$97,$E4,$A6,$2D,$5B,$92,$A9,$51,$5F,
    $22,$D4,$67,$AB,$BD,$78,$4B,$76,$70,$52,$79,$AB,$3B,$F8,$EF,$CF,
    $1C,$2F,$06,$7A,$FD,$ED,$DE,$46,$EC,$CE,$52,$B0,$77,$0E,$B9,$CE,
    $08,$B7,$AE,$5F,$B2,$6C,$0D,$9E,$A2,$6D,$FA,$19,$DA,$5D,$FF,$61,
    $3C,$9E,$77,$19,$9B,$FD,$9F,$F3,$B1,$39,$78,$3E,$D6,$D4,$65,$D9,
    $6B,$3A,$48,$97,$A4,$3E,$F6,$CB,$B4,$31,$9E,$3D,$79,$FA,$2B,$68,
    $1B,$AC,$B3,$EC,$D2,$AC,$9C,$19,$CB,$9E,$58,$9D,$FF,$24,$E8,$AD,
    $D7,$6E,$43,$FB,$B5,$C7,$6E,$CF,$77,$B0,$7E,$22,$AD,$53,$56,$01,
    $75,$6B,$7E,$FE,$EA,$7C,$FF,$6D,$E8,$FA,$FF,$0B,$BA,$E1,$56,$EB,
    $7A,$69,$59,$FE,$AA,$EC,$95,$C4,$3D,$67,$C9,$2F,$D3,$C5,$78,$A4,
    $5B,$FA,$D8,$ED,$E9,$F6,$EC,$A0,$DB,$59,$D7,$BB,$6E,$43,$7F,$D7,
    $7F,$41,$3F,$1C,$EA,$43,$AD,$0D,$E2,$36,$2C,$FD,$65,$BA,$18,$8F,
    $74,$73,$97,$DC,$9E,$6E,$84,$35,$79,$C5,$DA,$C4,$27,$17,$2C,$CB,
    $5F,$5D,$B2,$F4,$36,$74,$97,$FE,$17,$74,$23,$AD,$69,$D9,$AB,$96,
    $2F,$63,$1C,$EF,$BB,$0D,$DD,$7D,$FF,$05,$5D,$03,$D6,$C3,$AC,$B5,
    $CB,$F2,$73,$56,$AE,$5E,$07,$32,$D7,$6F,$D9,$2F,$D3,$C6,$F8,$5F,
    $5B,$C7,$11,$D6,$19,$D9,$52,$2E,$63,$B9,$64,$CD,$6D,$E8,$AE,$E1,
    $74,$0F,$2F,$FD,$35,$74,$A7,$AC,$5A,$9B,$BD,$72,$C5,$D2,$59,$6B,
    $4A,$AA,$6F,$43,$B7,$FA,$BF,$A0,$1B,$69,$C5,$66,$83,$F6,$5B,$B1,
    $74,$59,$6C,$CE,$2F,$D3,$C5,$F8,$5F,$4B,$37,$DC,$1A,$AC,$60,$E2,
    $5E,$7F,$1B,$BA,$EB,$FF,$0B,$BA,$11,$D6,$0C,$7C,$10,$1A,$09,$97,
    $D4,$DE,$86,$6E,$6D,$CE,$AF,$D7,$43,$C6,$60,$FD,$DA,$56,$AF,$58,
    $05,$9D,$70,$C4,$F2,$5F,$A6,$8D,$F1,$A8,$A7,$7F,$8D,$BE,$30,$04,
    $69,$27,$65,$17,$48,$20,$6F,$5B,$6F,$43,$7B,$EB,$7F,$41,$BB,$9B,
    $35,$69,$F5,$2A,$A8,$E9,$60,$BF,$BE,$70,$1B,$DA,$18,$FF,$6B,$65,
    $39,$CA,$3A,$69,$C9,$92,$65,$05,$05,$73,$57,$AC,$5E,$99,$8D,$DA,
    $08,$78,$4F,$CE,$FD,$65,$FA,$18,$FF,$EB,$FB,$8A,$2D,$1F,$04,$6F,
    $E5,$B2,$E5,$CB,$4A,$5E,$BE,$0D,$DD,$97,$FF,$0B,$BA,$DD,$AD,$E9,
    $52,$F6,$92,$C7,$83,$02,$58,$E2,$BB,$0D,$6D,$DF,$7F,$41,$3B,$1C,
    $EB,$5B,$CA,$5F,$BD,$32,$89,$B8,$6D,$2B,$7E,$99,$2E,$C6,$FF,$FA,
    $76,$9C,$9B,$9D,$BF,$22,$BB,$43,$3F,$EF,$BC,$0D,$ED,$9D,$FF,$05,
    $6D,$68,$C7,$82,$82,$65,$EC,$72,$4D,$4A,$36,$54,$F7,$52,$68,$47,
    $43,$DE,$2F,$D3,$C7,$F8,$5F,$4B,$BF,$BB,$75,$D2,$63,$05,$52,$7E,
    $F6,$12,$95,$F9,$92,$DC,$DB,$D0,$CE,$FD,$AF,$68,$83,$AE,$CE,$C1,
    $8E,$A3,$D2,$AE,$B8,$0D,$6D,$8C,$FF,$F5,$F6,$01,$7B,$56,$9E,$11,
    $8E,$79,$FC,$97,$E9,$62,$FC,$AF,$E5,$B9,$A7,$35,$3D,$3B,$67,$D9,
    $92,$EC,$95,$5D,$C6,$71,$7C,$15,$16,$2D,$35,$BC,$2F,$6A,$01,$5A,
    $3D,$7A,$CE,$99,$B4,$44,$5A,$B1,$76,$D9,$9C,$DC,$FC,$65,$D9,$4B,
    $27,$E5,$E7,$67,$3F,$A9,$E7,$79,$21,$EE,$CE,$2E,$FC,$EC,$FC,$19,
    $DE,$3E,$86,$B0,$B1,$C2,$ED,$ED,$C4,$7E,$7F,$EC,$6A,$27,$4E,$80,
    $54,$43,$91,$8B,$39,$33,$EC,$2B,$A5,$15,$69,$90,$33,$B0,$B8,$D2,
    $5E,$00,$8C,$CC,$CB,$5F,$21,$2D,$4B,$7F,$72,$D5,$92,$DC,$FC,$D5,
    $AB,$56,$FC,$6E,$59,$7E,$09,$7F,$77,$84,$1F,$73,$44,$F3,$F8,$C1,
    $95,$41,$F3,$78,$EE,$3C,$F5,$BD,$91,$33,$78,$CA,$6C,$86,$FF,$5D,
    $CD,$F6,$09,$A0,$59,$E8,$2B,$3D,$05,$81,$A6,$1E,$E8,$B2,$9E,$38,
    $71,$A5,$FA,$F0,$C8,$92,$83,$78,$D2,$E3,$87,$0A,$7E,$C2,$52,$7D,
    $77,$84,$9D,$9F,$9D,$BF,$47,$3D,$1C,$91,$50,$43,$8E,$D1,$7D,$FB,
    $70,$93,$4F,$3D,$8B,$3B,$77,$5E,$3A,$DE,$8F,$08,$57,$8F,$C7,$85,
    $D7,$01,$48,$F3,$CB,$FB,$C7,$1D,$5D,$AB,$95,$8F,$8E,$AB,$B9,$FA,
    $4F,$69,$78,$F1,$E2,$00,$BE,$17,$A1,$77,$5C,$C7,$97,$42,$94,$D8,
    $E2,$CD,$01,$47,$00,$FD,$01,$F4,$5F,$8E,$1D,$7B,$5D,$AA,$37,$7E,
    $E0,$31,$7E,$70,$72,$58,$ED,$C2,$47,$16,$7B,$4A,$C6,$D5,$4A,$FD,
    $81,$60,$DF,$70,$BC,$7F,$95,$EA,$37,$4F,$F5,$DB,$0D,$F4,$79,$F5,
    $95,$67,$5D,$A9,$86,$DF,$AD,$62,$8F,$C8,$55,$D2,$C8,$C3,$78,$B6,
    $A5,$92,$56,$7D,$8A,$D0,$43,$AF,$1F,$52,$E1,$6E,$F4,$E3,$83,$C5,
    $60,$73,$D3,$99,$DF,$E1,$49,$2E,$2D,$DE,$2B,$9C,$4D,$4E,$93,$E3,
    $F4,$95,$7D,$FC,$D5,$39,$2D,$F1,$2C,$50,$CF,$74,$E3,$F3,$C7,$7C,
    $2B,$3B,$4F,$97,$87,$4F,$6A,$E1,$A5,$F4,$FD,$54,$24,$62,$91,$69,
    $FB,$24,$C1,$E6,$3C,$AF,$23,$E2,$2B,$FD,$D0,$89,$E7,$06,$90,$3E,
    $ED,$F6,$9D,$7A,$1E,$03,$F7,$52,$83,$89,$B5,$EA,$31,$68,$41,$70,
    $03,$1B,$A3,$18,$DA,$37,$4D,$81,$00,$7B,$87,$70,$B6,$DA,$4E,$79,
    $EA,$9A,$DF,$BC,$B9,$E9,$74,$DA,$25,$56,$AE,$B0,$2A,$D1,$84,$32,
    $45,$44,$D3,$02,$FE,$66,$E1,$4F,$71,$37,$FF,$3C,$2E,$DB,$79,$A7,
    $77,$5D,$52,$D7,$4D,$16,$34,$B1,$F3,$FB,$EC,$4D,$3E,$A5,$9F,$2B,
    $A9,$9F,$8D,$24,$45,$DB,$A8,$A7,$49,$4D,$4B,$7B,$02,$CB,$CA,$C3,
    $24,$A9,$DF,$DD,$49,$51,$F6,$C6,$39,$AE,$A4,$11,$36,$FA,$34,$44,
    $A6,$BB,$92,$B4,$EC,$2E,$B6,$8D,$AE,$6E,$C2,$67,$AC,$C7,$CA,$49,
    $22,$A0,$C9,$49,$7A,$57,$92,$C1,$95,$9E,$BC,$47,$C4,$D3,$94,$AB,
    $0F,$A2,$E0,$F0,$B7,$FC,$E6,$91,$53,$C4,$D7,$5A,$E7,$3C,$77,$87,
    $9C,$1E,$C5,$B2,$AA,$A2,$BF,$C1,$06,$A1,$D3,$91,$44,$B3,$5C,$10,
    $ED,$BC,$19,$90,$FA,$40,$45,$3C,$1E,$50,$8F,$E0,$48,$F8,$4E,$EC,
    $83,$50,$3B,$4A,$18,$FD,$43,$93,$2A,$55,$C1,$73,$DD,$A4,$BE,$83,
    $DD,$68,$C6,$AE,$14,$0E,$C8,$B8,$C9,$B9,$D0,$C3,$CA,$05,$F5,$02,
    $8D,$9E,$14,$8D,$3B,$F5,$DD,$6C,$F4,$AC,$12,$08,$54,$25,$E1,$41,
    $FD,$00,$3F,$97,$CF,$5E,$9E,$F4,$05,$0F,$C1,$45,$BB,$36,$DC,$A1,
    $BE,$1A,$F6,$AF,$7E,$D0,$B1,$B4,$F6,$90,$59,$8A,$36,$21,$A0,$BE,
    $56,$A9,$9E,$E3,$E7,$52,$74,$A0,$46,$7D,$E9,$89,$3A,$0E,$E1,$F1,
    $EE,$A2,$C0,$A6,$A1,$C5,$8B,$7E,$13,$D8,$D2,$20,$0D,$84,$F4,$07,
    $E8,$2B,$1A,$B6,$80,$DC,$9D,$BD,$AF,$BB,$48,$25,$16,$3A,$6B,$56,
    $51,$60,$73,$3D,$A9,$EA,$F2,$36,$31,$69,$07,$72,$C7,$CA,$5E,$5B,
    $8D,$FD,$8C,$95,$78,$9E,$6B,$AE,$06,$3A,$4F,$60,$33,$10,$5F,$7E,
    $48,$BD,$F3,$C5,$F5,$07,$6E,$11,$2F,$1A,$2F,$A8,$67,$95,$69,$3A,
    $B1,$EA,$71,$CB,$3D,$C1,$ED,$CA,$68,$4E,$73,$65,$B4,$C0,$9F,$0F,
    $FE,$FC,$D0,$B6,$BF,$51,$D4,$43,$98,$FE,$D6,$27,$7C,$09,$75,$B2,
    $95,$CA,$19,$4D,$C4,$DA,$92,$50,$97,$66,$23,$56,$4A,$32,$9A,$A8,
    $1E,$8F,$E7,$CC,$30,$C8,$1A,$7C,$DD,$DC,$DA,$DC,$25,$E6,$D2,$05,
    $8C,$89,$52,$63,$3C,$EC,$50,$64,$94,$50,$22,$B7,$CB,$55,$C8,$56,
    $60,$94,$FB,$CA,$DB,$65,$78,$74,$72,$58,$B5,$7C,$D2,$53,$32,$77,
    $9E,$7C,$42,$AE,$92,$0F,$8E,$6B,$5D,$D7,$43,$8A,$DB,$EF,$D5,$5E,
    $7D,$5D,$7D,$18,$87,$BF,$BE,$14,$70,$6D,$30,$06,$C0,$7F,$E3,$EA,
    $6B,$CE,$4B,$3A,$E7,$65,$9D,$7C,$94,$21,$E1,$DB,$4B,$20,$A2,$EC,
    $F1,$A6,$43,$A3,$DC,$45,$35,$52,$C8,$95,$B7,$ED,$9A,$49,$C3,$0E,
    $C9,$AD,$40,$B1,$5D,$3E,$A5,$D2,$3A,$C5,$68,$ED,$90,$6B,$17,$2E,
    $7E,$84,$BD,$0B,$02,$69,$4E,$42,$AA,$43,$F1,$EE,$F0,$1A,$E9,$81,
    $2B,$6F,$43,$82,$53,$F2,$C9,$F8,$3A,$D0,$1C,$A6,$E2,$94,$C0,$2D,
    $6F,$0C,$15,$CF,$0B,$38,$DA,$D1,$DF,$8E,$FE,$8B,$B1,$C3,$6A,$A5,
    $FA,$20,$1D,$5B,$97,$F2,$B4,$1E,$7D,$64,$6B,$2D,$14,$0B,$55,$AA,
    $5D,$27,$FB,$52,$1F,$41,$B9,$C1,$63,$A6,$1E,$FA,$EC,$AE,$40,$40,
    $EE,$E7,$74,$8B,$EC,$8E,$31,$2E,$F8,$F3,$87,$E3,$3D,$EC,$EC,$31,
    $69,$4E,$81,$16,$3E,$82,$4D,$77,$04,$54,$1D,$AE,$57,$06,$65,$C5,
    $59,$51,$CF,$5E,$2F,$F7,$39,$AF,$0F,$5E,$1B,$F2,$E1,$60,$20,$4E,
    $8E,$4D,$C5,$F7,$48,$FB,$80,$3C,$68,$EC,$9A,$69,$A4,$82,$1C,$22,
    $27,$28,$56,$67,$A5,$18,$23,$90,$0A,$39,$D9,$14,$5B,$99,$6C,$32,
    $85,$BA,$E6,$98,$62,$89,$F8,$D1,$D8,$ED,$F8,$20,$30,$9D,$DC,$8E,
    $E7,$8A,$87,$AA,$FD,$9C,$49,$A0,$07,$92,$C5,$1F,$EB,$D4,$25,$C0,
    $CD,$89,$0A,$94,$6A,$26,$1B,$CF,$A4,$27,$34,$C8,$59,$78,$9A,$1D,
    $9A,$E6,$88,$0E,$1A,$73,$A3,$3F,$DE,$2D,$5B,$7D,$B2,$B5,$45,$B6,
    $36,$83,$9E,$EC,$3E,$EE,$88,$14,$B1,$D3,$E1,$1B,$22,$75,$DF,$31,
    $D5,$7E,$45,$F6,$C5,$59,$FD,$DE,$37,$74,$82,$00,$E1,$57,$58,$38,
    $75,$2D,$BE,$29,$67,$35,$6D,$B5,$2A,$0E,$DF,$48,$7B,$08,$84,$9F,
    $DE,$49,$51,$5F,$39,$7C,$E3,$ED,$11,$72,$96,$0F,$42,$AA,$77,$2A,
    $67,$E5,$AC,$0B,$1F,$62,$3D,$3A,$7C,$F7,$D9,$23,$20,$6C,$D7,$4E,
    $BA,$00,$B0,$E4,$AC,$46,$D9,$7E,$66,$76,$1A,$C5,$77,$AB,$17,$90,
    $AC,$0B,$C3,$0E,$15,$68,$E3,$1B,$1C,$1B,$95,$91,$F6,$88,$61,$07,
    $0B,$44,$CD,$51,$68,$B3,$D7,$FE,$70,$28,$E8,$C6,$27,$8E,$3A,$7D,
    $20,$2D,$78,$02,$35,$22,$CD,$65,$6D,$A1,$78,$4F,$60,$C1,$7C,$62,
    $3F,$E3,$4D,$04,$17,$10,$F1,$0D,$97,$EE,$72,$F8,$46,$E5,$4F,$70,
    $F8,$C6,$AD,$7B,$E8,$F1,$86,$08,$07,$1D,$65,$FC,$C0,$AD,$F1,$40,
    $FE,$BA,$9D,$CA,$85,$4C,$6F,$5C,$80,$9D,$3E,$33,$5B,$F5,$EB,$7A,
    $06,$AC,$3E,$92,$65,$70,$6C,$F0,$88,$02,$89,$F1,$48,$C0,$05,$A0,
    $9D,$D9,$E9,$31,$9D,$DD,$BA,$9F,$BD,$91,$40,$B2,$7C,$E6,$2C,$FD,
    $BA,$45,$88,$68,$37,$B8,$46,$7F,$49,$42,$8D,$1F,$2C,$16,$03,$A6,
    $57,$FA,$14,$80,$45,$2B,$59,$84,$05,$00,$7F,$0B,$F0,$7E,$BB,$45,
    $D8,$0E,$B0,$07,$C0,$EF,$79,$78,$F0,$EF,$5D,$F0,$7F,$0E,$7F,$71,
    $10,$E7,$E0,$71,$7B,$00,$AE,$02,$18,$EF,$A6,$16,$BC,$27,$0A,$BD,
    $70,$C6,$99,$61,$47,$E9,$97,$F8,$64,$75,$56,$2D,$89,$92,$7B,$E1,
    $9B,$C5,$E9,$A2,$A3,$2D,$59,$EA,$E1,$68,$CB,$90,$86,$3B,$DA,$32,
    $ED,$B5,$7B,$D8,$B5,$A5,$BB,$5B,$F1,$D9,$7B,$20,$D6,$BB,$75,$A0,
    $33,$5D,$14,$5A,$17,$8A,$14,$DF,$7E,$2D,$1D,$39,$69,$E6,$D6,$50,
    $0F,$BB,$C6,$EE,$B2,$FF,$1B,$D4,$F9,$6C,$A2,$C3,$F3,$68,$FD,$CE,
    $07,$02,$F3,$9F,$73,$94,$8F,$72,$B4,$8F,$CF,$D7,$39,$CA,$C3,$66,
    $6E,$ED,$D3,$19,$1B,$82,$2F,$B5,$C8,$3A,$C8,$2D,$BC,$D6,$7E,$D0,
    $35,$E3,$DF,$C3,$BE,$27,$19,$8D,$CE,$F6,$A8,$B5,$1A,$CF,$B0,$83,
    $6B,$23,$34,$47,$4B,$47,$01,$DD,$A9,$76,$DC,$A6,$4C,$96,$7A,$23,
    $3B,$77,$01,$3B,$C6,$22,$3C,$ED,$AD,$B2,$D4,$37,$DC,$FD,$64,$F7,
    $D6,$FA,$9F,$61,$E3,$EF,$FC,$42,$7D,$97,$AC,$C3,$DD,$F6,$8B,$AE,
    $19,$7F,$FF,$A5,$6C,$D2,$8D,$45,$78,$E0,$95,$9D,$48,$51,$BD,$47,
    $C1,$9B,$E3,$1C,$AB,$59,$6B,$94,$CB,$B1,$F1,$23,$F1,$F2,$82,$BD,
    $45,$49,$8C,$AF,$51,$11,$4A,$F1,$78,$7E,$E5,$4E,$E3,$07,$D5,$CA,
    $98,$8F,$1D,$63,$2D,$82,$12,$F2,$71,$23,$00,$16,$F9,$3C,$46,$96,
    $E3,$FD,$90,$13,$C4,$DE,$2C,$37,$2B,$91,$2C,$78,$03,$4B,$13,$7E,
    $4D,$DA,$4B,$66,$FA,$CD,$33,$1A,$D7,$69,$3C,$64,$46,$A3,$4A,$EF,
    $51,$16,$07,$3D,$65,$94,$1B,$C2,$CE,$33,$35,$34,$4B,$6E,$1B,$F6,
    $FD,$23,$10,$6F,$33,$16,$59,$20,$BE,$CA,$DA,$88,$86,$1C,$AB,$03,
    $6F,$14,$D4,$C6,$6E,$8D,$A2,$DD,$2D,$C8,$95,$EF,$41,$B6,$93,$A5,
    $87,$DF,$D3,$38,$DA,$AC,$D2,$D8,$F7,$B4,$8E,$B6,$14,$A9,$E7,$7B,
    $3A,$47,$DB,$4C,$09,$72,$9E,$61,$2C,$D2,$42,$EA,$F7,$C4,$B2,$9E,
    $28,$66,$19,$8D,$E3,$CA,$D7,$0E,$D9,$8B,$6A,$1C,$E2,$EC,$03,$8D,
    $1F,$F4,$D6,$BF,$8F,$AF,$69,$13,$6B,$E3,$5E,$DC,$26,$70,$FA,$7A,
    $AE,$0D,$29,$33,$82,$2B,$DD,$06,$92,$FF,$AC,$7C,$C5,$F8,$C1,$67,
    $74,$72,$0C,$74,$A7,$FD,$2E,$FB,$B3,$1E,$1B,$5E,$6E,$B8,$E4,$C6,
    $D3,$E5,$B4,$39,$C0,$C6,$06,$A6,$9F,$0D,$02,$7F,$AB,$81,$7C,$CF,
    $06,$94,$4A,$3A,$A3,$9D,$9D,$E0,$35,$D8,$D8,$A9,$F7,$23,$A0,$2F,
    $4E,$D2,$AF,$AE,$A3,$9A,$D1,$81,$A5,$C2,$F7,$B2,$F1,$DC,$25,$99,
    $A1,$FF,$D3,$1F,$8E,$B2,$83,$C0,$EC,$5E,$02,$3B,$83,$CC,$1E,$C4,
    $73,$56,$B4,$A4,$CF,$95,$67,$F8,$64,$B0,$09,$9B,$3F,$D4,$46,$B1,
    $D3,$DC,$F4,$70,$39,$BE,$AB,$D9,$F9,$02,$32,$39,$14,$77,$D0,$BC,
    $7F,$A3,$09,$E3,$4A,$CB,$F9,$B1,$61,$96,$E9,$0C,$3F,$68,$3B,$57,
    $D1,$B5,$CB,$81,$00,$CD,$C1,$87,$9A,$F1,$BC,$26,$7D,$A6,$5C,$BD,
    $61,$05,$71,$E6,$F2,$0D,$49,$CA,$28,$5D,$03,$B0,$3B,$00,$9F,$77,
    $AF,$04,$FD,$79,$A3,$82,$5D,$70,$A0,$CB,$7E,$4A,$8A,$84,$D2,$C1,
    $F8,$BE,$06,$26,$DC,$58,$43,$4E,$3C,$47,$6B,$D1,$F0,$EC,$EE,$7A,
    $11,$B3,$C0,$47,$F6,$F6,$B9,$51,$21,$AA,$A7,$F8,$D3,$0B,$2B,$70,
    $CC,$24,$A7,$D1,$B4,$C2,$3D,$D3,$39,$26,$7D,$5A,$9E,$60,$43,$EF,
    $28,$30,$4B,$5A,$A0,$AB,$28,$9A,$D4,$22,$F7,$A6,$EE,$C5,$73,$C4,
    $80,$E3,$E2,$9D,$F9,$57,$1C,$17,$BB,$49,$DF,$91,$E3,$F8,$48,$E3,
    $6F,$DD,$EC,$64,$A7,$BA,$5F,$CA,$EA,$44,$60,$D7,$B7,$A1,$82,$B3,
    $F4,$2A,$41,$97,$C0,$EF,$BC,$B6,$9D,$47,$D3,$63,$53,$4F,$52,$3D,
    $C5,$F5,$22,$CB,$14,$6C,$10,$48,$AF,$84,$33,$35,$FD,$DC,$27,$9D,
    $5C,$B1,$71,$61,$B6,$3A,$2A,$E4,$69,$D5,$BB,$64,$F3,$68,$99,$4A,
    $20,$A4,$58,$34,$29,$68,$5F,$F2,$37,$7A,$67,$B3,$DB,$20,$7E,$F6,
    $3C,$76,$96,$1E,$86,$FB,$28,$B0,$98,$C1,$A0,$3E,$C1,$6C,$23,$7C,
    $77,$A1,$1B,$9E,$80,$15,$CB,$A0,$DE,$86,$7D,$CE,$A4,$61,$3E,$36,
    $2B,$DB,$F7,$AA,$99,$CD,$FE,$E1,$01,$0D,$B0,$F1,$1B,$D6,$77,$3C,
    $31,$F8,$D4,$79,$F6,$60,$ED,$87,$D8,$E3,$3E,$1E,$0A,$E2,$F7,$49,
    $26,$7C,$32,$F2,$22,$F1,$F5,$B3,$3D,$96,$ED,$F8,$F0,$ED,$54,$57,
    $52,$72,$2A,$7D,$92,$1D,$FE,$CA,$68,$C1,$F1,$ED,$E3,$40,$80,$A1,
    $34,$DB,$F6,$AC,$09,$A2,$8C,$4D,$A5,$73,$55,$94,$66,$30,$E3,$DE,
    $04,$94,$24,$67,$15,$DE,$03,$74,$5E,$EF,$66,$7F,$5B,$CD,$60,$2B,
    $66,$F0,$1A,$7C,$5C,$49,$21,$7B,$50,$69,$FC,$A5,$B5,$4D,$CE,$F0,
    $65,$E4,$85,$BA,$AC,$4D,$B6,$3D,$DB,$54,$5A,$D0,$D0,$4E,$77,$3C,
    $BB,$13,$35,$1F,$75,$64,$25,$CD,$62,$19,$86,$E2,$B1,$F3,$3D,$FB,
    $BA,$20,$0D,$67,$FB,$7B,$80,$44,$21,$CB,$B1,$5D,$B3,$D4,$DB,$5F,
    $EE,$98,$9F,$9C,$5B,$8F,$F3,$13,$AA,$3E,$48,$7D,$EE,$23,$9C,$A4,
    $D8,$CA,$A0,$41,$14,$7E,$18,$3F,$F8,$76,$4A,$C2,$35,$C6,$A5,$12,
    $EA,$BC,$1E,$26,$0D,$4E,$72,$4E,$78,$A5,$FA,$7D,$7C,$44,$A3,$D9,
    $25,$32,$17,$C9,$D0,$D3,$87,$A0,$F9,$3E,$66,$A3,$44,$25,$F6,$1A,
    $6C,$C3,$2E,$6F,$37,$BA,$9E,$0C,$56,$EC,$2D,$B4,$46,$20,$AD,$0B,
    $EF,$E3,$D1,$81,$66,$98,$28,$21,$9D,$CB,$1F,$33,$C9,$4E,$A8,$A3,
    $FF,$BA,$0A,$2D,$20,$B2,$68,$46,$B8,$83,$ED,$17,$9E,$54,$A7,$55,
    $06,$C6,$F1,$DF,$76,$B3,$EB,$4B,$EC,$3D,$47,$C8,$56,$E5,$39,$4F,
    $60,$D9,$3E,$F4,$BB,$CE,$AB,$70,$7E,$1B,$FD,$BF,$AF,$40,$85,$4E,
    $87,$B0,$BD,$91,$D0,$4D,$E9,$F4,$1B,$2C,$2B,$76,$20,$97,$9A,$AF,
    $AA,$36,$B3,$D3,$7D,$C3,$49,$75,$05,$13,$F2,$C4,$B9,$74,$1D,$E0,
    $DB,$72,$9B,$A0,$96,$E8,$4E,$98,$EB,$ED,$C5,$86,$29,$A3,$C0,$4F,
    $15,$B3,$33,$C1,$D8,$99,$6A,$6F,$C9,$D3,$CD,$A5,$33,$19,$E2,$50,
    $E0,$8B,$3A,$1B,$BB,$4C,$00,$7F,$F3,$3B,$95,$D3,$C7,$F6,$21,$A7,
    $2D,$1F,$20,$A7,$8B,$E7,$E3,$41,$8B,$E0,$9C,$38,$5E,$50,$F7,$5F,
    $6A,$B8,$14,$A2,$14,$23,$E7,$3D,$37,$04,$39,$67,$D5,$05,$AD,$78,
    $C7,$3E,$BC,$4A,$04,$A5,$F8,$0A,$72,$D8,$33,$14,$E2,$F7,$86,$63,
    $29,$9E,$F6,$77,$29,$85,$1D,$9F,$9B,$66,$25,$30,$FE,$7E,$22,$84,
    $E4,$6C,$AF,$00,$76,$73,$9C,$54,$94,$BA,$39,$DD,$57,$73,$F0,$71,
    $21,$FE,$0A,$F8,$16,$B7,$34,$46,$B9,$BB,$38,$F9,$8E,$C0,$88,$C9,
    $D2,$80,$11,$B1,$52,$1F,$97,$D5,$57,$3C,$E7,$8E,$00,$5D,$04,$F5,
    $4A,$32,$7C,$90,$67,$77,$94,$1C,$10,$B3,$9B,$1F,$E1,$95,$81,$4D,
    $75,$5E,$1F,$E3,$05,$BA,$16,$1A,$33,$5E,$BC,$A4,$82,$04,$D8,$AB,
    $42,$C6,$57,$43,$9A,$B7,$4D,$12,$0A,$4C,$AC,$83,$B0,$9F,$19,$C1,
    $19,$C2,$A1,$4F,$90,$58,$0B,$10,$DB,$FF,$11,$5E,$BE,$D5,$7A,$5F,
    $87,$A8,$BD,$23,$80,$7F,$17,$24,$55,$CF,$73,$CE,$FC,$81,$4D,$A2,
    $8C,$A4,$6A,$EF,$58,$88,$A0,$7F,$06,$D4,$24,$65,$D3,$DE,$09,$41,
    $2C,$26,$A1,$43,$55,$AC,$1E,$80,$35,$1D,$B1,$D6,$30,$82,$3A,$65,
    $EE,$DE,$39,$B7,$50,$13,$3A,$A9,$3D,$8A,$78,$A9,$8C,$DA,$28,$56,
    $D4,$F9,$92,$38,$22,$D6,$DE,$1D,$A2,$56,$62,$D4,$C8,$8F,$F0,$26,
    $15,$F4,$57,$56,$F0,$25,$38,$01,$67,$BD,$B4,$F7,$47,$6A,$C1,$43,
    $58,$C1,$8D,$7F,$EC,$D3,$F5,$78,$7D,$FF,$0D,$EC,$FA,$9C,$DA,$6D,
    $DE,$DC,$8B,$4D,$DB,$FF,$FD,$2E,$DD,$A6,$6B,$DB,$2E,$5F,$AE,$B6,
    $B5,$8E,$B9,$97,$0B,$4F,$C2,$BF,$E0,$3A,$07,$A6,$5F,$06,$FF,$D0,
    $8F,$A1,$C1,$B9,$0B,$86,$04,$69,$60,$24,$1E,$F8,$1D,$89,$2B,$3B,
    $EA,$F9,$92,$C2,$8A,$37,$AE,$AB,$77,$94,$40,$E9,$E1,$E4,$3A,$C6,
    $55,$54,$0B,$42,$80,$F7,$33,$CE,$82,$3A,$FE,$A8,$11,$3C,$EC,$5E,
    $54,$0C,$BF,$1B,$73,$89,$DD,$53,$29,$3A,$8E,$48,$F4,$F7,$5F,$B2,
    $DA,$B9,$BB,$6B,$1C,$3F,$24,$B3,$FC,$4B,$A6,$94,$F1,$CE,$3F,$18,
    $C1,$4A,$78,$DC,$2B,$98,$04,$6C,$58,$15,$ED,$DD,$45,$F4,$87,$08,
    $3C,$C9,$9A,$E8,$2A,$BA,$8A,$D6,$08,$9B,$B8,$2E,$86,$8E,$F3,$A1,
    $7F,$A3,$45,$F8,$04,$3F,$30,$3A,$F5,$C6,$75,$22,$3A,$ED,$DF,$EC,
    $C0,$D2,$9D,$24,$45,$A4,$CE,$8F,$F8,$75,$E1,$2F,$AF,$B0,$D9,$27,
    $18,$99,$BA,$C0,$7D,$52,$C8,$27,$C2,$26,$0B,$1F,$76,$8A,$2E,$21,
    $73,$DB,$9F,$79,$0B,$B4,$89,$85,$9F,$DA,$A1,$09,$07,$91,$61,$0D,
    $14,$CA,$F5,$22,$96,$19,$86,$B6,$A8,$B7,$F1,$F6,$10,$7A,$E4,$A2,
    $37,$20,$49,$65,$D1,$4E,$F8,$8A,$2A,$43,$72,$51,$29,$0B,$DA,$05,
    $DF,$50,$BC,$4E,$5A,$54,$C6,$FC,$FB,$E0,$1B,$22,$BF,$E2,$66,$9E,
    $0A,$8C,$94,$3F,$AA,$66,$1E,$7C,$CA,$2C,$D4,$C5,$28,$D9,$F2,$44,
    $97,$0B,$B9,$C0,$F7,$BA,$A0,$CF,$D6,$B5,$AA,$43,$EC,$F0,$2B,$C1,
    $8B,$A5,$E5,$FC,$87,$DB,$EE,$83,$BF,$C2,$0A,$37,$F0,$A0,$5E,$84,
    $98,$6E,$4A,$A6,$4B,$21,$FB,$ED,$26,$E0,$DE,$31,$56,$90,$06,$C0,
    $28,$6A,$D9,$BE,$68,$27,$14,$A1,$02,$26,$1F,$34,$11,$3F,$0F,$BC,
    $01,$22,$F2,$60,$9E,$45,$3D,$95,$34,$61,$67,$D7,$82,$4E,$AD,$C1,
    $82,$F6,$83,$EA,$CF,$8D,$8A,$E5,$07,$97,$E0,$93,$8A,$27,$90,$22,
    $BE,$C4,$21,$D6,$C2,$DF,$13,$83,$66,$0F,$3E,$4F,$59,$F4,$76,$F0,
    $D2,$B8,$6B,$B2,$08,$5D,$72,$76,$19,$5E,$94,$86,$A9,$B5,$91,$96,
    $43,$54,$E7,$83,$95,$C1,$79,$79,$70,$4D,$2B,$48,$20,$B9,$83,$00,
    $D3,$38,$9B,$BB,$EA,$4A,$92,$61,$00,$93,$07,$7A,$40,$00,$9F,$A0,
    $CE,$F0,$43,$16,$B4,$79,$77,$D7,$4E,$B0,$59,$55,$6D,$7F,$D8,$CD,
    $E4,$FF,$5D,$A6,$84,$D5,$DC,$93,$7F,$9A,$3B,$1B,$70,$BB,$64,$5D,
    $F3,$56,$07,$EF,$F3,$44,$C8,$E5,$4F,$9F,$76,$F0,$1E,$FA,$9F,$79,
    $BF,$85,$FB,$A7,$DF,$EA,$CA,$7D,$E3,$2D,$DC,$C3,$0C,$1F,$88,$4E,
    $F8,$54,$BD,$5A,$C3,$8A,$42,$1F,$EC,$2C,$C8,$BD,$5D,$0B,$F2,$2D,
    $2B,$88,$8F,$99,$9B,$F4,$8B,$0F,$B0,$34,$D3,$DE,$C1,$DE,$CC,$F9,
    $59,$FB,$D6,$4F,$4B,$D3,$61,$3F,$74,$E1,$E7,$DA,$CE,$5B,$9B,$A3,
    $FC,$03,$CC,$5D,$2F,$4F,$D6,$73,$42,$23,$7F,$4A,$48,$1D,$27,$1D,
    $EB,$0D,$F8,$4A,$54,$D6,$9B,$90,$F7,$A3,$0E,$8B,$D0,$3D,$7C,$0E,
    $5B,$97,$4D,$5B,$B6,$44,$2F,$DC,$BA,$C9,$AD,$FE,$CE,$43,$42,$03,
    $8D,$FE,$27,$0E,$57,$8A,$26,$C9,$79,$3D,$74,$73,$B8,$79,$F4,$17,
    $F5,$30,$FA,$DB,$BF,$47,$5F,$6F,$62,$F8,$E2,$0C,$F8,$DE,$D5,$6C,
    $CF,$7C,$0C,$7A,$62,$0D,$FE,$FC,$C1,$20,$79,$B4,$09,$66,$CC,$A2,
    $30,$27,$4F,$20,$DD,$C6,$EE,$EC,$8C,$FE,$07,$76,$9C,$35,$06,$F6,
    $A3,$10,$C4,$DD,$E8,$60,$7B,$F8,$EA,$E2,$ED,$CF,$30,$90,$0E,$05,
    $AC,$9D,$2A,$45,$4E,$95,$8C,$53,$9D,$17,$FB,$E4,$47,$29,$77,$6F,
    $37,$7C,$00,$C6,$F9,$9D,$DB,$A3,$10,$0C,$70,$89,$07,$7C,$68,$88,
    $A4,$8A,$04,$B2,$60,$63,$AC,$12,$42,$AD,$68,$15,$7A,$E3,$4A,$71,
    $EA,$5D,$D2,$71,$87,$17,$67,$DF,$8D,$72,$96,$BF,$73,$91,$F5,$4C,
    $61,$B0,$19,$8B,$1A,$24,$03,$9A,$04,$C7,$E8,$47,$A8,$5B,$BB,$B9,
    $32,$FC,$DB,$A3,$DF,$C2,$DF,$DD,$39,$C4,$FA,$A5,$6C,$BD,$50,$69,
    $A5,$91,$B2,$BD,$A9,$D2,$DA,$1C,$29,$6F,$6C,$A9,$B4,$FA,$A0,$1D,
    $2F,$D8,$C0,$5E,$CC,$68,$DC,$3E,$1D,$51,$CD,$88,$3A,$A3,$11,$4A,
    $FA,$E8,$0A,$28,$A9,$DF,$CF,$5E,$8B,$EE,$B8,$25,$55,$88,$0D,$DF,
    $48,$0F,$EC,$62,$03,$2B,$FD,$68,$17,$B6,$FD,$2C,$D0,$5B,$0A,$65,
    $B6,$3F,$EA,$72,$F9,$30,$FE,$44,$D8,$13,$82,$77,$F5,$BF,$83,$E7,
    $FB,$E8,$04,$BC,$C1,$38,$43,$EF,$DC,$2F,$A2,$C1,$82,$EF,$85,$AA,
    $ED,$88,$2D,$E3,$96,$45,$56,$CF,$91,$AC,$9E,$6D,$6A,$3D,$BB,$31,
    $77,$7C,$D7,$91,$0E,$03,$2A,$F3,$F1,$DD,$66,$22,$04,$5F,$04,$9C,
    $1F,$7C,$11,$30,$5D,$7D,$11,$30,$43,$7D,$11,$70,$42,$AA,$94,$AA,
    $64,$74,$BC,$08,$98,$20,$3D,$A4,$4C,$0E,$BE,$08,$38,$46,$7D,$11,
    $70,$28,$7B,$11,$B0,$8F,$72,$BF,$FA,$22,$E0,$10,$7C,$11,$70,$90,
    $72,$67,$A9,$CE,$53,$2A,$7A,$4A,$43,$3C,$A5,$A1,$9E,$D2,$30,$4F,
    $A9,$DE,$53,$1A,$EE,$29,$8D,$F4,$94,$1A,$3C,$A5,$DD,$3C,$A5,$DD,
    $3D,$A5,$7D,$3C,$25,$F4,$29,$60,$5B,$7D,$0D,$50,$6D,$B0,$E0,$D8,
    $52,$C2,$EE,$55,$42,$39,$8A,$4A,$98,$46,$DD,$C5,$BE,$3B,$55,$ED,
    $7A,$93,$FF,$88,$43,$46,$EE,$F3,$5B,$3A,$6E,$B6,$59,$F5,$24,$D3,
    $EF,$7C,$2A,$5A,$B0,$1B,$B1,$91,$5E,$C2,$9A,$DF,$5F,$13,$6C,$33,
    $11,$BD,$EF,$E2,$32,$60,$41,$3F,$18,$A9,$AC,$8D,$36,$92,$64,$B0,
    $51,$7F,$3D,$68,$B5,$8D,$CD,$EC,$87,$30,$8A,$DE,$03,$36,$F8,$70,
    $D4,$70,$93,$4D,$68,$2E,$D8,$E8,$E9,$93,$EA,$13,$39,$B8,$30,$02,
    $49,$40,$97,$DF,$64,$BA,$1C,$BE,$21,$2E,$C6,$8A,$EB,$45,$C4,$DE,
    $83,$09,$E9,$28,$10,$12,$C2,$43,$91,$65,$5A,$85,$4B,$7B,$9C,$7B,
    $37,$4B,$59,$01,$DF,$48,$94,$9C,$A2,$6A,$E6,$3F,$8C,$7E,$F9,$FD,
    $5A,$E6,$39,$AE,$92,$2D,$63,$B7,$48,$75,$AE,$17,$B1,$C0,$DB,$C7,
    $22,$EF,$D7,$F0,$7E,$AA,$0B,$FD,$D0,$92,$2F,$E1,$42,$FF,$2E,$7C,
    $BE,$BE,$5E,$59,$C0,$B8,$7A,$81,$25,$7F,$09,$93,$33,$DA,$2F,$33,
    $FF,$36,$95,$F6,$6B,$CC,$F3,$86,$4A,$FB,$05,$46,$5B,$EB,$7A,$11,
    $2B,$76,$FB,$A3,$48,$FB,$7F,$19,$ED,$92,$2E,$B4,$33,$DB,$6F,$91,
    $D1,$FF,$85,$6A,$76,$B1,$96,$A0,$77,$BC,$8B,$23,$1F,$F2,$C1,$E6,
    $C0,$F4,$81,$77,$55,$B1,$0D,$7D,$17,$C5,$F6,$25,$D0,$3E,$CA,$E7,
    $F8,$4B,$43,$EA,$FB,$0D,$FC,$9D,$86,$84,$3A,$39,$A3,$99,$37,$D9,
    $BA,$A2,$CE,$26,$F3,$D3,$A7,$6E,$04,$DB,$BF,$D6,$59,$7E,$C3,$79,
    $51,$9F,$AF,$97,$06,$41,$97,$8E,$28,$B8,$EB,$47,$5D,$58,$6E,$63,
    $C5,$35,$67,$D0,$86,$1B,$38,$A7,$A8,$57,$46,$B1,$1B,$85,$B2,$95,
    $F7,$B9,$16,$18,$A6,$5C,$19,$CD,$DB,$7D,$6F,$42,$91,$AA,$F0,$FE,
    $E9,$8C,$66,$28,$8F,$7E,$09,$94,$67,$6B,$1B,$9F,$C7,$F6,$C6,$1D,
    $46,$3A,$E6,$FF,$98,$55,$70,$87,$FA,$CA,$03,$7C,$0B,$C7,$E2,$53,
    $B4,$F6,$6E,$AE,$24,$71,$6F,$09,$30,$48,$C9,$3B,$5D,$74,$F3,$A6,
    $22,$F5,$A1,$82,$BB,$DE,$C1,$32,$EE,$7A,$93,$0D,$32,$6C,$AD,$35,
    $B8,$D6,$8B,$3F,$B1,$9B,$14,$17,$17,$DB,$B1,$DB,$84,$55,$F3,$88,
    $8F,$BF,$3E,$4A,$8F,$82,$C6,$F1,$F0,$B1,$03,$EB,$E0,$B7,$4F,$77,
    $BE,$8B,$E0,$DF,$6E,$C1,$11,$BA,$4F,$55,$70,$17,$C7,$8F,$76,$CB,
    $5F,$F1,$47,$C7,$50,$A3,$C1,$18,$B2,$9D,$22,$C2,$0F,$78,$81,$75,
    $86,$0F,$10,$B6,$E4,$00,$C2,$EF,$10,$01,$75,$DD,$76,$61,$27,$CE,
    $04,$FC,$0E,$5C,$EB,$62,$CE,$6D,$C0,$EE,$F6,$51,$38,$B2,$33,$1B,
    $48,$8E,$DA,$BE,$92,$85,$57,$FC,$1E,$C2,$D7,$33,$E7,$6B,$D0,$A0,
    $DB,$FD,$6A,$42,$D0,$3F,$DB,$5B,$DE,$44,$67,$BF,$DF,$5B,$3A,$A7,
    $37,$EB,$9F,$EE,$32,$20,$4D,$C7,$02,$78,$F7,$EE,$C0,$01,$09,$6F,
    $85,$32,$65,$5B,$69,$31,$68,$98,$83,$BD,$94,$9C,$E0,$66,$FC,$32,
    $FD,$CB,$62,$D0,$41,$97,$BF,$CE,$1E,$34,$EC,$60,$14,$7F,$39,$8E,
    $B1,$C9,$1C,$A3,$82,$8E,$95,$41,$C7,$FA,$A0,$C3,$CF,$1D,$9E,$92,
    $C2,$8A,$95,$50,$C3,$55,$A2,$E9,$05,$01,$7F,$C7,$F4,$C9,$E3,$CC,
    $78,$7B,$08,$6F,$78,$BC,$7A,$66,$9B,$FA,$B3,$18,$AF,$36,$AA,$0E,
    $FD,$AB,$17,$54,$87,$E1,$55,$8A,$A7,$A9,$9B,$E0,$03,$56,$50,$F4,
    $1E,$5C,$0A,$A5,$CF,$BD,$83,$36,$0C,$92,$51,$F7,$B6,$48,$3B,$FE,
    $F6,$90,$94,$E3,$98,$00,$D6,$D2,$A3,$45,$01,$7B,$74,$B1,$70,$CB,
    $24,$62,$FA,$BB,$1A,$25,$95,$B4,$CE,$54,$34,$33,$8B,$AE,$6D,$E8,
    $59,$6C,$18,$55,$F8,$95,$1A,$DF,$0D,$E3,$F3,$BD,$E4,$B3,$B8,$23,
    $85,$5F,$E1,$AD,$ED,$27,$43,$A6,$38,$6B,$6E,$4E,$2A,$AA,$B1,$8B,
    $EF,$6A,$95,$5E,$C5,$E2,$D8,$5B,$28,$69,$DF,$D5,$90,$72,$F5,$4D,
    $70,$75,$4D,$38,$C1,$ED,$98,$C8,$A6,$AF,$92,$11,$D7,$A6,$A1,$F7,
    $90,$13,$53,$69,$6E,$80,$2D,$12,$97,$24,$D4,$04,$63,$C3,$D4,$BB,
    $F7,$D5,$64,$3F,$4F,$7B,$1A,$C6,$A2,$41,$D8,$61,$9A,$61,$38,$EF,
    $C9,$76,$2D,$9A,$2D,$10,$16,$CE,$4C,$74,$FB,$15,$B6,$75,$C7,$7F,
    $EF,$93,$4D,$7D,$DC,$94,$FD,$40,$40,$40,$32,$E1,$0F,$9D,$40,$C0,
    $DF,$81,$E0,$08,$4D,$7E,$6F,$49,$AB,$68,$26,$4F,$06,$9C,$2A,$FA,
    $32,$C7,$B1,$9F,$E9,$FA,$5B,$5F,$F4,$13,$E4,$DD,$B5,$D2,$24,$7E,
    $EC,$C6,$E9,$66,$68,$B8,$88,$B7,$07,$52,$C4,$70,$FC,$86,$6A,$04,
    $7A,$A6,$8E,$35,$86,$56,$0E,$CD,$C1,$A7,$06,$48,$6D,$4E,$E1,$B9,
    $80,$2E,$47,$9E,$2B,$1A,$77,$BB,$F7,$D3,$88,$1C,$39,$25,$34,$6F,
    $2A,$FD,$E8,$18,$53,$A2,$2F,$BA,$B7,$A6,$84,$E7,$0D,$A7,$6F,$73,
    $AF,$67,$EB,$62,$3D,$14,$C2,$82,$CF,$ED,$0C,$AF,$C3,$BB,$E5,$CA,
    $90,$E2,$E4,$31,$A1,$C5,$8B,$C6,$84,$0D,$AF,$CF,$EF,$93,$B4,$55,
    $34,$15,$8B,$26,$B5,$22,$DF,$0C,$BB,$29,$9A,$6E,$1E,$B2,$5F,$72,
    $56,$6A,$F1,$77,$5D,$22,$10,$33,$22,$79,$4C,$98,$FD,$B0,$B3,$A2,
    $5F,$56,$87,$7D,$B6,$07,$6D,$05,$EC,$68,$53,$EC,$6D,$E9,$D8,$D9,
    $CE,$92,$8E,$D5,$94,$21,$78,$09,$F0,$99,$4B,$F8,$3C,$A7,$5A,$BB,
    $21,$74,$6E,$33,$04,$F5,$AE,$63,$B7,$D5,$AD,$CD,$B6,$84,$9A,$BD,
    $D1,$02,$FB,$C5,$8F,$F7,$BF,$63,$B3,$B0,$32,$01,$10,$E9,$86,$B7,
    $50,$CB,$35,$D9,$F6,$B4,$00,$B1,$BD,$03,$55,$8C,$E7,$BF,$63,$8F,
    $62,$24,$D4,$D1,$A2,$F3,$81,$C0,$3F,$44,$5C,$37,$C1,$15,$10,$86,
    $13,$A3,$E2,$AC,$66,$38,$14,$70,$B2,$11,$27,$04,$70,$DE,$19,$B1,
    $D7,$A8,$46,$FE,$0D,$22,$FF,$11,$8A,$41,$F7,$ED,$ED,$AE,$06,$11,
    $0C,$0A,$63,$94,$2E,$70,$4A,$FD,$D5,$98,$21,$8C,$D2,$05,$A0,$D4,
    $17,$29,$E1,$52,$E4,$3B,$F7,$EF,$1D,$A4,$46,$CE,$C1,$64,$E1,$2C,
    $D9,$19,$DB,$1E,$E1,$19,$48,$36,$58,$8D,$B9,$84,$9B,$70,$D6,$33,
    $60,$8C,$D0,$81,$F8,$5B,$43,$19,$8D,$65,$06,$2C,$D1,$8E,$9D,$58,
    $A2,$E3,$B6,$3D,$51,$88,$1C,$AB,$22,$EF,$67,$C8,$C7,$5D,$19,$F5,
    $F4,$12,$AE,$D2,$65,$D4,$97,$45,$21,$F2,$46,$40,$7E,$67,$FC,$DE,
    $3B,$54,$AC,$6F,$01,$EB,$1F,$D1,$2C,$B3,$5A,$DB,$9E,$A1,$98,$7E,
    $A8,$1A,$53,$88,$E9,$33,$6A,$CB,$FA,$61,$A2,$54,$96,$C3,$61,$DB,
    $9E,$D1,$88,$31,$4C,$C5,$78,$84,$61,$1C,$2E,$8B,$41,$8C,$7B,$18,
    $86,$8F,$1E,$7C,$13,$61,$0B,$2D,$67,$B0,$9A,$97,$7B,$88,$9A,$62,
    $24,$E3,$A9,$1A,$CA,$3D,$F8,$9C,$3A,$A1,$86,$E1,$66,$AF,$05,$68,
    $D2,$E1,$3B,$D9,$F0,$0E,$DE,$E9,$E8,$1D,$C8,$C8,$55,$F0,$E4,$77,
    $F3,$F2,$E3,$00,$6C,$AD,$80,$E4,$8D,$5F,$B1,$E4,$0F,$BB,$AC,$6E,
    $8E,$12,$C2,$7E,$E6,$83,$1E,$62,$28,$6E,$40,$F9,$E8,$AB,$60,$0E,
    $2D,$7B,$33,$91,$64,$F5,$9B,$6A,$0E,$BE,$BD,$B9,$E8,$DD,$83,$77,
    $41,$ED,$BE,$80,$DD,$9F,$BB,$1E,$FC,$01,$7B,$4B,$59,$2C,$14,$44,
    $9D,$82,$C7,$BE,$DD,$11,$B9,$85,$47,$9A,$3A,$22,$75,$10,$09,$0D,
    $6F,$50,$99,$7A,$5D,$41,$79,$F9,$A0,$CB,$E1,$D6,$6F,$08,$6A,$5B,
    $F7,$5E,$5C,$B2,$A6,$5F,$EE,$40,$6D,$3B,$FD,$75,$D4,$B6,$EA,$28,
    $13,$9C,$87,$8F,$E2,$E3,$0D,$3E,$94,$FC,$C4,$FD,$4B,$EF,$0F,$CE,
    $D7,$91,$EE,$13,$F0,$2F,$76,$E9,$88,$D8,$AE,$73,$7B,$54,$DE,$D9,
    $4F,$74,$BA,$D7,$3C,$D1,$39,$A7,$CF,$ED,$82,$93,$9B,$AB,$BA,$71,
    $5A,$10,$3B,$69,$86,$6D,$86,$D0,$E9,$47,$6F,$AC,$D0,$B9,$7E,$30,
    $FE,$89,$27,$3A,$78,$00,$F7,$F8,$82,$02,$BE,$C7,$D9,$94,$8E,$AF,
    $DB,$B0,$43,$BC,$7D,$5C,$1D,$7D,$AE,$F0,$08,$DF,$AE,$1D,$23,$67,
    $35,$57,$5A,$5B,$60,$44,$6B,$82,$2A,$88,$B8,$C8,$3A,$0F,$4C,$F0,
    $2B,$AD,$7E,$B6,$54,$99,$A7,$21,$DD,$F4,$AA,$A5,$BA,$3E,$0F,$2A,
    $BB,$E4,$0A,$FB,$BD,$B4,$6E,$B9,$5D,$C2,$F0,$77,$CC,$E4,$4C,$03,
    $CD,$7D,$AD,$CB,$F0,$3C,$C8,$85,$75,$D7,$44,$9D,$FF,$C2,$6A,$EB,
    $FD,$1A,$0E,$CF,$C1,$F7,$A3,$D4,$2D,$40,$BA,$88,$AD,$F3,$82,$5E,
    $FB,$D0,$FD,$0F,$F6,$BB,$90,$3A,$DC,$CC,$61,$CF,$29,$50,$E9,$25,
    $75,$79,$56,$C1,$3D,$EF,$DC,$67,$F0,$05,$EE,$EF,$3E,$E5,$3C,$47,
    $E5,$BE,$8C,$5A,$97,$5E,$80,$80,$57,$A3,$B7,$E3,$2F,$2F,$E1,$57,
    $B0,$47,$94,$BD,$B1,$DA,$22,$B0,$20,$DC,$F0,$FD,$99,$F7,$42,$92,
    $57,$14,$3C,$9E,$92,$BF,$6C,$59,$FA,$9A,$EC,$25,$CB,$AC,$EB,$27,
    $81,$EE,$0E,$CE,$D1,$D2,$FE,$8E,$4B,$DD,$A4,$39,$A1,$0E,$B4,$71,
    $EF,$BF,$81,$D4,$A6,$88,$36,$DA,$F8,$29,$7B,$1C,$2D,$00,$FF,$81,
    $FD,$71,$18,$0A,$9A,$12,$93,$27,$BA,$52,$86,$B2,$ED,$16,$D2,$1B,
    $4F,$8E,$50,$E3,$1E,$F6,$6B,$01,$A4,$92,$CD,$E5,$B2,$FF,$7E,$CB,
    $5C,$AE,$92,$EF,$65,$D2,$D9,$3C,$03,$20,$9F,$C7,$56,$C0,$1C,$E7,
    $FC,$E0,$3E,$F8,$0A,$04,$A7,$C4,$D8,$68,$EF,$C3,$3C,$CF,$09,$E0,
    $D8,$D2,$B0,$29,$0C,$22,$BB,$FD,$BD,$63,$2F,$14,$D7,$FE,$9C,$9B,
    $46,$08,$D2,$F0,$84,$06,$92,$32,$94,$7E,$83,$73,$C8,$5A,$98,$E5,
    $99,$8F,$6D,$EA,$09,$01,$44,$AC,$07,$6D,$FF,$3D,$99,$39,$D4,$9C,
    $32,$42,$F2,$9A,$8F,$19,$FF,$E6,$EE,$B2,$C7,$0F,$74,$FD,$87,$F0,
    $F9,$E1,$D1,$82,$FD,$01,$3A,$1F,$4B,$92,$34,$02,$9A,$1C,$DF,$D0,
    $D9,$E2,$B6,$47,$E6,$05,$48,$12,$30,$B1,$15,$2B,$39,$29,$56,$4E,
    $32,$E1,$FB,$C6,$B1,$F8,$19,$51,$99,$34,$5A,$13,$48,$8A,$55,$7F,
    $C3,$33,$0A,$AF,$D6,$93,$72,$7A,$F7,$2B,$6C,$CE,$83,$AA,$6E,$1F,
    $B4,$9E,$00,$26,$EB,$2E,$80,$6F,$80,$5C,$EC,$04,$88,$F6,$DE,$6B,
    $00,$71,$5A,$F6,$32,$C0,$11,$00,$5F,$00,$B8,$14,$E2,$9F,$01,$F8,
    $12,$C0,$2D,$00,$EB,$01,$6F,$03,$C0,$5D,$E0,$97,$00,$56,$03,$5C,
    $09,$D0,$01,$70,$29,$C0,$2D,$00,$17,$01,$5C,$09,$E9,$E7,$00,$44,
    $D3,$78,$3A,$C0,$12,$80,$C9,$00,$9B,$21,$7E,$02,$C0,$46,$80,$A3,
    $01,$BE,$00,$E1,$23,$30,$3D,$40,$13,$E2,$41,$78,$0C,$C0,$35,$E0,
    $8F,$06,$28,$01,$34,$00,$4C,$85,$70,$11,$60,$2C,$40,$3F,$C8,$CB,
    $19,$80,$2D,$00,$A3,$20,$BE,$09,$FD,$C0,$D7,$05,$80,$B9,$E0,$C7,
    $09,$F3,$33,$10,$8F,$FA,$F4,$38,$B8,$E7,$BC,$C5,$9E,$9A,$11,$6A,
    $C1,$ED,$7F,$53,$75,$1F,$06,$B7,$9E,$87,$57,$83,$9B,$F2,$F0,$0A,
    $70,$8F,$D8,$A9,$BA,$DD,$E0,$36,$71,$37,$2E,$C8,$8B,$DC,$5D,$06,
    $EE,$AD,$DC,$BD,$0B,$DC,$4D,$DC,$5D,$0A,$EE,$A1,$DC,$BD,$13,$DC,
    $C7,$B9,$FB,$0D,$0C,$E7,$79,$BD,$06,$EE,$18,$EE,$C6,$9D,$00,$1F,
    $C7,$79,$19,$DC,$1B,$B8,$FB,$25,$70,$3F,$CA,$DD,$2F,$80,$FB,$02,
    $E7,$AD,$04,$DC,$FD,$78,$DA,$67,$C0,$ED,$E6,$38,$5B,$C1,$9D,$C9,
    $DD,$5B,$C0,$5D,$CA,$DD,$0E,$4C,$CB,$DD,$1B,$C0,$BD,$8F,$BB,$D7,
    $83,$7B,$0D,$77,$4B,$E0,$6E,$E4,$F4,$71,$97,$E3,$65,$1E,$BE,$12,
    $DC,$EB,$79,$5E,$B9,$78,$9C,$87,$BB,$97,$82,$BB,$96,$E3,$3C,$0A,
    $EE,$64,$EE,$5E,$04,$EE,$66,$4E,$27,$13,$DC,$A9,$1C,$7F,$0E,$D2,
    $E4,$6E,$1B,$B8,$A3,$39,$FE,$74,$AC,$1F,$8E,$9F,$0A,$EE,$45,$1C,
    $27,$19,$DC,$87,$39,$0E,$6E,$CC,$6C,$E5,$E1,$13,$C0,$FD,$02,$0F,
    $C7,$13,$02,$D3,$B9,$1B,$37,$62,$97,$0A,$38,$36,$08,$42,$D4,$BD,
    $2C,$15,$BF,$53,$FE,$70,$AF,$29,$33,$53,$66,$4E,$9A,$89,$5A,$B5,
    $29,$06,$CF,$50,$58,$FD,$65,$BD,$B0,$5A,$DA,$04,$7B,$5F,$62,$35,
    $38,$7D,$DA,$8D,$21,$65,$A8,$B8,$9D,$BE,$9E,$9B,$42,$D8,$7E,$A5,
    $6C,$35,$D8,$CA,$8C,$F7,$E2,$93,$3C,$51,$DA,$7C,$1D,$EE,$C4,$81,
    $0D,$41,$17,$82,$76,$20,$1B,$FD,$C6,$DD,$D6,$0B,$23,$F1,$AE,$3D,
    $24,$2D,$E8,$4B,$AA,$E9,$62,$48,$E2,$DA,$35,$E5,$CC,$9F,$2C,$EA,
    $2B,$20,$57,$5F,$53,$EE,$76,$D9,$BF,$35,$7E,$90,$15,$E5,$B8,$AE,
    $91,$E0,$23,$AE,$0B,$37,$7E,$62,$BD,$60,$B6,$1A,$36,$69,$DF,$13,
    $02,$D1,$AF,$38,$9F,$83,$4E,$59,$15,$67,$F5,$2F,$5C,$FC,$88,$BA,
    $8F,$B9,$03,$42,$0C,$CF,$5B,$84,$CD,$FC,$EF,$6B,$F8,$DB,$19,$81,
    $C7,$B8,$46,$CD,$F4,$38,$36,$7E,$23,$48,$BA,$D2,$91,$3B,$3C,$F4,
    $7B,$E8,$F9,$C6,$4F,$66,$80,$F1,$62,$9E,$61,$D8,$3C,$D8,$D9,$76,
    $63,$C3,$80,$C8,$9A,$CD,$31,$A5,$A3,$76,$38,$7E,$23,$48,$96,$6D,
    $68,$F1,$EC,$68,$3D,$55,$3A,$EA,$EA,$0E,$25,$86,$E9,$BB,$44,$A0,
    $23,$F5,$DF,$71,$CE,$87,$B0,$77,$71,$23,$43,$C9,$79,$13,$7D,$61,
    $3B,$14,$1F,$62,$46,$D6,$49,$A1,$09,$EE,$84,$1A,$25,$CE,$43,$9F,
    $45,$CB,$0E,$9F,$C5,$2E,$1E,$A2,$22,$92,$19,$86,$29,$74,$0D,$04,
    $00,$89,$5D,$71,$64,$86,$DE,$D9,$26,$E6,$6B,$13,$6A,$4A,$AD,$C5,
    $59,$DF,$1A,$3F,$C9,$B8,$30,$75,$47,$04,$FE,$78,$6A,$9D,$12,$11,
    $59,$B7,$31,$B4,$74,$64,$EB,$69,$25,$34,$E2,$82,$A4,$2B,$AE,$D8,
    $F1,$9C,$8D,$9C,$49,$A8,$6B,$1D,$E3,$86,$CA,$61,$8F,$CE,$27,$4D,
    $89,$74,$DB,$BF,$03,$8E,$BD,$D3,$8A,$75,$3B,$CC,$67,$EC,$BE,$4C,
    $0F,$3B,$E7,$40,$32,$F4,$CE,$F6,$9E,$F9,$21,$7B,$B1,$05,$B0,$84,
    $80,$13,$02,$A5,$52,$86,$26,$34,$60,$3B,$48,$11,$64,$7F,$EA,$7B,
    $BA,$6B,$57,$8B,$CF,$24,$51,$7C,$86,$6A,$C7,$14,$A9,$DB,$34,$7B,
    $CB,$36,$B4,$FA,$76,$BC,$A7,$53,$2E,$42,$21,$06,$A8,$C5,$3F,$1F,
    $0E,$09,$A7,$4A,$86,$49,$F6,$36,$BA,$1B,$51,$A7,$DA,$5B,$3D,$09,
    $0D,$C5,$83,$D0,$B0,$64,$6D,$C4,$6A,$34,$B2,$78,$10,$5A,$91,$7B,
    $8C,$60,$57,$8C,$3F,$B5,$56,$5B,$7C,$4A,$FB,$85,$EB,$E5,$BF,$CE,
    $7C,$01,$1A,$12,$47,$82,$62,$DD,$04,$8B,$74,$C7,$EC,$F4,$09,$26,
    $29,$6C,$C2,$70,$29,$62,$87,$62,$A0,$38,$3D,$55,$42,$E8,$4C,$3C,
    $49,$35,$3F,$E9,$DC,$19,$CF,$5C,$32,$06,$ED,$DA,$A2,$6B,$52,$08,
    $99,$E9,$BF,$FA,$DA,$62,$8F,$69,$B8,$C5,$62,$19,$6E,$82,$8F,$29,
    $16,$9C,$C3,$63,$C1,$39,$D4,$34,$7C,$98,$65,$24,$C6,$98,$46,$E2,
    $67,$F8,$48,$08,$1B,$6E,$82,$30,$44,$1C,$3E,$12,$3F,$26,$08,$1B,
    $89,$D8,$23,$31,$1D,$38,$46,$22,$01,$FC,$40,$92,$E1,$23,$21,$62,
    $28,$F8,$87,$0D,$85,$98,$61,$4C,$9E,$2D,$AA,$3C,$93,$76,$72,$8A,
    $ED,$93,$38,$AE,$E3,$14,$28,$2C,$72,$B2,$28,$0D,$20,$B3,$C4,$FD,
    $DE,$C1,$4A,$4F,$E3,$EE,$C9,$FA,$48,$16,$14,$66,$DC,$3D,$4B,$BF,
    $DF,$6B,$A4,$CF,$60,$8F,$9F,$4E,$DD,$02,$6E,$6C,$37,$ED,$55,$05,
    $BD,$05,$06,$E2,$38,$2B,$25,$B5,$AC,$07,$FC,$3F,$E6,$FE,$06,$3E,
    $AA,$E2,$FA,$1F,$C7,$77,$B3,$9B,$64,$93,$6C,$D8,$05,$16,$8C,$1A,
    $20,$D6,$D5,$06,$13,$6C,$68,$68,$45,$36,$6A,$42,$B2,$21,$3C,$AC,
    $04,$C2,$22,$0F,$A2,$D8,$42,$0A,$16,$10,$93,$5D,$C4,$9A,$84,$E0,
    $12,$65,$73,$5D,$45,$AB,$D5,$8A,$B6,$50,$AD,$DA,$16,$2B,$2A,$55,
    $40,$5A,$93,$2C,$26,$20,$54,$C3,$43,$35,$3C,$A8,$11,$63,$7B,$C3,
    $46,$5D,$25,$C2,$02,$21,$F7,$77,$DE,$67,$EE,$3E,$04,$50,$E9,$E7,
    $65,$BF,$FF,$3F,$BA,$B9,$77,$E6,$CE,$C3,$99,$33,$67,$CE,$9C,$73,
    $66,$E6,$0C,$16,$E1,$1B,$70,$6B,$9F,$5C,$1E,$87,$FB,$CC,$EC,$0D,
    $E5,$D7,$69,$6A,$5D,$17,$95,$5F,$A7,$AC,$70,$F5,$A7,$7A,$DC,$19,
    $E5,$D7,$0D,$D0,$D4,$5C,$C2,$19,$2D,$34,$D7,$9A,$6E,$C7,$2A,$39,
    $67,$59,$03,$6F,$D1,$97,$D5,$56,$FB,$35,$EE,$C1,$62,$FD,$E6,$12,
    $D4,$78,$D0,$E6,$0E,$92,$96,$30,$1E,$11,$5F,$D0,$1F,$95,$F4,$F5,
    $1A,$C9,$6D,$F8,$64,$C8,$86,$BC,$1F,$BA,$AC,$79,$3F,$70,$65,$10,
    $55,$9A,$F3,$6C,$EE,$2F,$8E,$7C,$56,$9F,$90,$8C,$1B,$E9,$6C,$EE,
    $14,$4A,$C1,$81,$B8,$3C,$9B,$BF,$BE,$7D,$C3,$98,$ED,$AE,$56,$1A,
    $1A,$27,$02,$FF,$29,$F3,$BA,$83,$6F,$60,$2C,$E6,$EE,$CC,$DD,$DB,
    $62,$97,$21,$4C,$AD,$76,$86,$56,$3B,$BB,$37,$E4,$5D,$EE,$BA,$32,
    $2F,$C7,$75,$45,$DE,$D5,$AE,$EC,$BC,$6C,$57,$2E,$95,$FF,$13,$2A,
    $7F,$64,$9E,$DD,$35,$26,$6F,$BE,$EB,$A7,$79,$36,$57,$31,$15,$F2,
    $7E,$20,$7F,$6C,$60,$AF,$6D,$5F,$75,$9C,$74,$70,$AC,$F4,$76,$A0,
    $C5,$53,$2D,$2B,$EE,$46,$AF,$53,$0E,$6C,$6B,$B6,$87,$B4,$81,$D7,
    $44,$85,$2F,$71,$85,$96,$0D,$79,$23,$08,$A4,$2C,$F7,$7A,$12,$BF,
    $B4,$1B,$A8,$FC,$D3,$81,$DF,$78,$9D,$5D,$9C,$49,$E7,$65,$AF,$7C,
    $59,$8D,$35,$71,$90,$DE,$DA,$F1,$EE,$AF,$E6,$F7,$8E,$D9,$7E,$60,
    $CA,$95,$C8,$0A,$4C,$60,$20,$71,$83,$06,$9B,$5D,$5E,$A1,$83,$17,
    $BF,$37,$9D,$0D,$59,$4E,$D9,$6B,$3F,$EC,$75,$B6,$49,$EE,$20,$B1,
    $18,$DF,$1C,$4A,$DE,$A4,$71,$19,$6C,$6E,$83,$1B,$E3,$1E,$AD,$F9,
    $21,$D5,$76,$39,$B5,$E6,$18,$B5,$E6,$0B,$6A,$CD,$50,$6A,$CD,$25,
    $D4,$1A,$2B,$B5,$26,$83,$5A,$53,$46,$08,$9A,$FC,$E7,$C0,$7E,$19,
    $12,$67,$E0,$9F,$02,$EC,$66,$8A,$1C,$F3,$E7,$40,$77,$FD,$95,$B5,
    $3D,$59,$AE,$C4,$DA,$9E,$11,$EE,$C3,$3F,$EE,$E0,$FD,$5F,$05,$C5,
    $B5,$D7,$E7,$B8,$4E,$62,$30,$C7,$F3,$72,$5C,$59,$FD,$1C,$BF,$0A,
    $8C,$7C,$15,$F5,$E1,$EC,$C0,$6A,$E6,$51,$7E,$4F,$75,$9B,$C6,$75,
    $69,$95,$51,$86,$3E,$A7,$38,$DA,$DC,$C7,$03,$A9,$8A,$BD,$8D,$74,
    $21,$9B,$BD,$A3,$66,$40,$A0,$A0,$5E,$57,$48,$E8,$49,$99,$C8,$31,
    $ED,$35,$23,$37,$E6,$78,$AA,$0F,$6B,$DC,$29,$11,$5E,$13,$18,$FA,
    $E7,$5A,$F8,$D0,$22,$8E,$7B,$D8,$13,$D2,$D6,$98,$5E,$D1,$1D,$FF,
    $AA,$B6,$47,$EB,$4E,$10,$C3,$57,$71,$1C,$E6,$0D,$5C,$5D,$97,$10,
    $49,$4B,$6D,$D2,$57,$C4,$9E,$49,$5F,$BF,$48,$CB,$83,$2D,$29,$4A,
    $2D,$06,$22,$C6,$62,$83,$D4,$7A,$05,$3A,$DD,$35,$F4,$3A,$3C,$DC,
    $3F,$28,$3F,$51,$9C,$40,$E4,$D9,$1F,$57,$3C,$24,$AD,$AC,$11,$7B,
    $87,$74,$F9,$B9,$7B,$9B,$0B,$75,$9A,$CE,$26,$0A,$1E,$BA,$7A,$04,
    $9C,$A2,$2C,$6C,$30,$13,$76,$1A,$43,$E6,$7C,$92,$96,$99,$D2,$B3,
    $EC,$A1,$03,$1F,$CB,$C3,$B6,$2A,$CA,$81,$9E,$43,$23,$5A,$89,$4D,
    $B5,$1D,$58,$FB,$41,$75,$CF,$DA,$F2,$13,$F6,$1E,$4D,$81,$2B,$E9,
    $20,$F3,$2E,$C5,$1E,$FA,$C8,$FD,$6F,$DF,$3D,$BA,$AD,$00,$66,$6D,
    $7D,$D1,$A0,$4F,$EB,$DB,$1B,$64,$7D,$6D,$87,$A9,$3C,$3E,$27,$A7,
    $FC,$2F,$13,$DC,$81,$1F,$37,$FC,$59,$AA,$0E,$E9,$AA,$0D,$77,$63,
    $41,$F6,$5E,$5B,$B5,$91,$E6,$8E,$6A,$A3,$47,$19,$50,$F9,$C3,$DA,
    $2A,$9B,$EE,$27,$15,$57,$34,$17,$D9,$74,$9A,$C9,$CB,$53,$7B,$E9,
    $89,$A8,$6B,$EF,$FA,$2C,$30,$AC,$BC,$A5,$50,$37,$12,$35,$04,$2C,
    $6F,$02,$24,$35,$D1,$C5,$48,$90,$E3,$FA,$B2,$5C,$9A,$6E,$90,$EC,
    $A1,$F2,$C6,$A3,$A6,$72,$AF,$6E,$75,$59,$9C,$9F,$28,$E8,$73,$29,
    $41,$9A,$AE,$97,$76,$A4,$BC,$6D,$5A,$B5,$89,$F2,$A4,$EC,$BD,$3B,
    $EC,$2F,$22,$77,$A7,$54,$6D,$48,$51,$88,$F0,$14,$8F,$A2,$AF,$1A,
    $F6,$26,$D0,$51,$30,$82,$66,$C8,$E7,$57,$1E,$7C,$F5,$B5,$F6,$D4,
    $CA,$AF,$C6,$C7,$73,$68,$2F,$42,$5E,$7B,$D0,$EB,$EC,$FE,$68,$71,
    $50,$7A,$9F,$DD,$F9,$64,$35,$B9,$12,$0F,$8E,$AA,$DB,$46,$8D,$16,
    $2D,$5E,$9B,$B2,$D3,$7D,$E9,$16,$34,$BB,$BE,$28,$55,$B4,$DA,$3D,
    $B4,$7E,$BB,$D5,$E4,$1E,$36,$DE,$DD,$15,$B8,$B6,$BE,$51,$9F,$F3,
    $E7,$BE,$DF,$29,$02,$09,$E8,$31,$DE,$7D,$54,$6A,$F1,$4D,$1A,$A8,
    $CB,$6A,$6C,$4E,$D4,$4C,$AE,$BD,$21,$C7,$75,$82,$00,$6F,$3C,$3A,
    $2C,$90,$48,$13,$CE,$DE,$D5,$85,$3A,$B5,$51,$DC,$FD,$09,$E8,$FE,
    $20,$18,$DA,$DA,$03,$D5,$A7,$D6,$1E,$3A,$72,$60,$C4,$41,$02,$E4,
    $C0,$E7,$32,$5C,$61,$D7,$5F,$5F,$AB,$64,$B9,$E2,$6B,$95,$11,$6E,
    $6D,$B1,$F4,$8E,$0C,$7F,$37,$B9,$7B,$EB,$13,$C6,$C4,$83,$CA,$DC,
    $86,$62,$99,$74,$32,$CD,$89,$83,$B6,$77,$5C,$13,$EA,$13,$AC,$1F,
    $E5,$D9,$DD,$C9,$C5,$53,$65,$17,$A4,$11,$5D,$AB,$6C,$07,$59,$5C,
    $0F,$AF,$49,$4D,$34,$2F,$BB,$75,$B8,$3D,$F6,$CA,$CD,$24,$5D,$53,
    $79,$71,$07,$DA,$C1,$3D,$F5,$1F,$DD,$10,$88,$3B,$74,$C3,$DA,$8F,
    $DA,$CB,$FF,$94,$A4,$71,$27,$6C,$D4,$06,$F4,$1F,$B4,$E5,$36,$00,
    $92,$C5,$A7,$D6,$0A,$22,$F4,$6F,$60,$BE,$94,$E1,$3A,$71,$A3,$1F,
    $6D,$D8,$90,$3D,$46,$9F,$5C,$69,$3A,$98,$0A,$42,$21,$7E,$7C,$D0,
    $DE,$33,$36,$70,$54,$7C,$AB,$EF,$57,$7B,$12,$20,$9F,$04,$C8,$F5,
    $09,$9C,$B2,$5F,$F1,$2F,$F7,$26,$EB,$5A,$57,$9E,$EA,$26,$F2,$AE,
    $38,$8A,$6F,$71,$27,$0E,$C6,$9C,$73,$FE,$C7,$DA,$E8,$B9,$4D,$03,
    $A9,$B6,$A6,$BA,$14,$38,$25,$B3,$C0,$0A,$38,$B2,$9B,$66,$E7,$5A,
    $D2,$DD,$64,$3F,$69,$BE,$9B,$CD,$24,$0D,$6F,$19,$0C,$4E,$3E,$E8,
    $70,$2D,$6C,$99,$7F,$A0,$48,$AC,$1C,$F1,$9E,$13,$69,$D0,$CD,$88,
    $9C,$8F,$48,$33,$CB,$B7,$6B,$E9,$6D,$F7,$DF,$22,$9F,$B1,$08,$24,
    $17,$E3,$F3,$B3,$67,$45,$8E,$44,$E4,$EA,$B3,$22,$D3,$11,$89,$5D,
    $33,$5B,$8C,$D1,$C8,$44,$44,$66,$9E,$15,$F9,$D5,$7A,$8A,$84,$CE,
    $2E,$8F,$46,$95,$50,$ED,$E5,$AB,$F1,$C6,$D6,$0A,$2B,$DE,$D8,$B2,
    $71,$09,$DE,$D8,$30,$62,$C6,$1B,$DB,$53,$12,$F0,$C6,$B6,$A2,$9E,
    $27,$E9,$0D,$86,$47,$F9,$2B,$BC,$B5,$E1,$4D,$7E,$32,$46,$5F,$7D,
    $6B,$2D,$0E,$B2,$2E,$7E,$AC,$AF,$7F,$8F,$9C,$A7,$A2,$FE,$3D,$80,
    $3F,$6D,$65,$FE,$E6,$E0,$83,$B0,$F3,$93,$7E,$BA,$F9,$F0,$43,$F4,
    $D6,$FC,$04,$2C,$57,$7B,$36,$B1,$D5,$90,$71,$B3,$B5,$88,$72,$C9,
    $1F,$52,$E9,$F2,$D3,$9D,$F4,$A7,$A7,$0B,$FE,$20,$8F,$62,$9D,$F7,
    $CB,$98,$1A,$AF,$79,$0A,$35,$9E,$7E,$34,$E2,$5F,$23,$AC,$F7,$E7,
    $2C,$17,$E7,$6F,$D7,$AB,$E7,$70,$FF,$A0,$3E,$9F,$89,$9E,$C7,$AD,
    $7B,$2A,$DA,$AF,$69,$B1,$26,$8B,$07,$B8,$D0,$E7,$1E,$8D,$9E,$C7,
    $C5,$67,$AD,$BF,$83,$E2,$BF,$ED,$1F,$BE,$5F,$E8,$39,$8E,$24,$FB,
    $E4,$45,$F3,$D5,$F3,$38,$79,$4F,$7F,$7B,$B9,$F8,$0E,$F3,$C9,$13,
    $4F,$5D,$C8,$79,$30,$2A,$B7,$EC,$EE,$4A,$2E,$9A,$68,$F8,$89,$98,
    $B2,$9F,$38,$4F,$3D,$AF,$50,$1C,$EE,$D8,$0D,$5E,$40,$D9,$E2,$AC,
    $07,$B0,$0B,$A2,$32,$AB,$4F,$CC,$42,$A9,$DC,$9A,$F0,$12,$01,$FA,
    $00,$0C,$A8,$60,$E9,$6D,$15,$AE,$C5,$F3,$97,$B8,$34,$D1,$FD,$18,
    $30,$1C,$68,$62,$C2,$63,$EF,$70,$C1,$5C,$23,$EC,$BF,$41,$DE,$A8,
    $D6,$49,$C4,$20,$E9,$E4,$7F,$B7,$F2,$0A,$EC,$A5,$F4,$FA,$CC,$53,
    $30,$22,$67,$B5,$92,$AA,$3D,$EF,$69,$FE,$B8,$93,$3F,$D2,$CB,$F6,
    $27,$79,$CF,$5A,$32,$0D,$E6,$CB,$2A,$F6,$67,$A7,$BA,$5A,$6F,$89,
    $FA,$D1,$EE,$52,$D7,$40,$BB,$BD,$73,$42,$61,$13,$C5,$4B,$0F,$52,
    $CE,$93,$AB,$9D,$58,$35,$71,$1B,$41,$07,$81,$DF,$45,$97,$B6,$43,
    $D2,$FB,$F2,$8B,$4F,$B0,$FB,$5E,$8D,$7B,$94,$58,$E6,$BE,$B6,$4D,
    $0D,$5B,$B1,$0C,$D3,$BD,$3E,$1D,$8B,$16,$F9,$7F,$E5,$6D,$37,$62,
    $79,$54,$E3,$73,$74,$C1,$DC,$37,$EE,$7D,$5E,$92,$2E,$95,$1C,$A1,
    $DC,$BD,$04,$AC,$ED,$63,$45,$F1,$56,$1A,$23,$84,$F5,$D5,$EF,$60,
    $CF,$E9,$16,$2B,$0F,$7B,$1F,$87,$51,$27,$FF,$11,$5E,$0A,$27,$01,
    $43,$21,$D2,$97,$17,$3E,$D8,$C7,$EE,$A1,$AE,$92,$8A,$3D,$92,$7D,
    $56,$E7,$65,$5F,$EC,$EA,$FC,$7D,$BF,$8F,$2E,$3D,$59,$78,$AF,$22,
    $4E,$D0,$34,$CB,$CF,$F5,$F2,$DA,$0B,$01,$D3,$22,$1F,$C5,$DA,$DD,
    $38,$B3,$E4,$34,$CB,$F7,$3F,$8E,$57,$8B,$E4,$34,$CA,$55,$8F,$C7,
    $8C,$26,$DF,$EF,$C5,$9E,$83,$81,$0C,$DA,$1F,$1F,$8E,$D9,$73,$D0,
    $EA,$3B,$DF,$9E,$03,$33,$EC,$22,$65,$B7,$D3,$24,$F7,$8A,$76,$3D,
    $48,$48,$5E,$85,$A5,$B4,$67,$1E,$E6,$75,$68,$B1,$1F,$BC,$E9,$EF,
    $6C,$1C,$49,$A4,$D7,$77,$15,$11,$BF,$60,$DA,$3A,$4A,$7A,$DB,$1B,
    $AA,$2D,$6A,$EE,$82,$B9,$EB,$60,$8B,$9A,$41,$11,$CF,$6C,$27,$16,
    $BA,$C0,$C5,$E1,$12,$84,$77,$20,$BC,$8A,$C3,$A3,$11,$DE,$8D,$F0,
    $53,$1C,$CE,$44,$B8,$15,$E1,$4D,$1C,$4E,$43,$78,$3F,$C2,$BB,$39,
    $6C,$40,$B8,$ED,$0F,$6C,$C8,$BA,$63,$D1,$FC,$88,$11,$AB,$F0,$8E,
    $C2,$8A,$F9,$B7,$B9,$E6,$8F,$5F,$52,$E9,$BA,$6D,$09,$6C,$58,$88,
    $1B,$BF,$64,$A1,$6B,$E1,$6D,$8B,$16,$FE,$4A,$0D,$17,$CC,$9B,$37,
    $75,$7E,$79,$D9,$FC,$8A,$65,$F3,$2B,$4A,$2B,$EE,$C0,$61,$45,$CE,
    $3B,$75,$FE,$A2,$F9,$B7,$55,$CE,$3F,$EB,$03,$E2,$2B,$DD,$8B,$E7,
    $17,$2E,$BA,$AD,$B2,$72,$F2,$CF,$6E,$9F,$FF,$73,$17,$3B,$54,$2D,
    $BC,$A3,$CC,$5D,$B9,$74,$FE,$92,$79,$67,$7D,$88,$D9,$1B,$89,$7D,
    $69,$E1,$F5,$F9,$FD,$EB,$23,$FB,$F8,$60,$71,$44,$67,$5C,$BD,$41,
    $38,$DE,$AD,$D8,$C6,$26,$DC,$42,$B6,$2B,$3F,$A9,$7A,$F7,$95,$34,
    $4A,$A9,$19,$16,$E6,$CD,$B1,$31,$16,$AC,$E9,$3D,$17,$1B,$93,$06,
    $1B,$7F,$38,$90,$3E,$BD,$CC,$87,$33,$16,$21,$B9,$E2,$71,$36,$E2,
    $43,$9F,$96,$9C,$41,$F9,$E7,$1C,$EC,$28,$85,$43,$6C,$F6,$AA,$DD,
    $2D,$97,$3E,$1E,$5E,$E2,$9F,$44,$9C,$42,$76,$C3,$25,$FB,$F6,$87,
    $62,$68,$E6,$D0,$7A,$5E,$E5,$17,$6B,$A6,$BD,$8F,$C2,$50,$1D,$14,
    $81,$EB,$9E,$14,$0B,$A8,$8B,$B1,$EF,$A2,$F3,$A6,$87,$E0,$CC,$30,
    $76,$DF,$E3,$CA,$ED,$1B,$4F,$AA,$FB,$AC,$84,$AB,$71,$9F,$7D,$A3,
    $34,$28,$7F,$0E,$55,$33,$E1,$49,$E1,$66,$BD,$F5,$D9,$3E,$E8,$C8,
    $DD,$E9,$5C,$F0,$22,$47,$8D,$9C,$E7,$BD,$8C,$BD,$8B,$C3,$D1,$78,
    $75,$50,$63,$5A,$E5,$63,$37,$CF,$46,$38,$1A,$B7,$07,$75,$0D,$BE,
    $6D,$6F,$A1,$F4,$DC,$43,$9E,$2F,$CC,$F5,$45,$43,$75,$52,$6B,$ED,
    $91,$15,$2B,$E1,$7D,$43,$43,$F2,$95,$B5,$D6,$53,$DD,$9D,$EC,$1E,
    $D0,$92,$08,$5B,$45,$CB,$38,$03,$3C,$44,$75,$E6,$53,$11,$14,$5F,
    $E2,$5E,$20,$39,$BB,$7C,$8F,$FE,$0B,$AE,$AA,$BD,$CE,$8E,$55,$0D,
    $AE,$AB,$70,$26,$45,$23,$69,$E4,$39,$BF,$C3,$B0,$EF,$F0,$C6,$89,
    $08,$7A,$1B,$AB,$6F,$49,$84,$0B,$3F,$C2,$9B,$77,$9C,$21,$70,$05,
    $7F,$90,$7F,$12,$4D,$D7,$01,$97,$AA,$48,$A4,$E1,$44,$92,$86,$92,
    $29,$F6,$2E,$76,$6C,$4F,$45,$DF,$40,$35,$1A,$DD,$3F,$E0,$6C,$7C,
    $19,$82,$7B,$B0,$28,$BB,$95,$1F,$BC,$E8,$23,$1F,$5C,$87,$8E,$E9,
    $4E,$C5,$D5,$0B,$DE,$44,$FE,$40,$A5,$74,$C2,$8F,$28,$67,$9F,$4B,
    $51,$22,$F3,$18,$EA,$3B,$DF,$AA,$B7,$18,$74,$D6,$79,$A8,$A4,$7C,
    $83,$FC,$C7,$A7,$79,$85,$04,$F0,$B4,$F7,$81,$A7,$3D,$0C,$4F,$A0,
    $40,$32,$7B,$2F,$C2,$29,$80,$9B,$F4,$52,$A9,$C1,$7B,$93,$41,$CA,
    $37,$7A,$C7,$19,$3D,$76,$D9,$88,$56,$75,$47,$EB,$A5,$2A,$E3,$AB,
    $06,$D0,$DF,$C4,$15,$F8,$AC,$57,$E3,$F9,$BD,$D0,$36,$27,$68,$AA,
    $BB,$1F,$BC,$A6,$0E,$1D,$E0,$B5,$B7,$F2,$86,$59,$BD,$D7,$BE,$9F,
    $9D,$B1,$B7,$A1,$DB,$E2,$48,$BD,$C2,$CE,$21,$33,$05,$12,$3C,$21,
    $BD,$3B,$53,$F2,$21,$F5,$CA,$8F,$15,$13,$35,$E9,$64,$92,$3B,$9E,
    $BD,$0E,$13,$23,$6D,$D1,$9E,$C1,$56,$D0,$C5,$FB,$F5,$8A,$FD,$70,
    $60,$30,$A9,$2B,$EE,$FE,$E8,$71,$77,$8A,$A7,$DA,$A0,$71,$C5,$6F,
    $06,$AD,$11,$63,$76,$6C,$C4,$1E,$F2,$29,$3E,$47,$EB,$14,$1A,$2D,
    $EB,$8D,$C4,$A4,$4B,$A7,$46,$C8,$BF,$AE,$C1,$65,$F0,$39,$37,$CA,
    $5A,$1D,$8E,$59,$74,$11,$D3,$C9,$98,$E8,$5B,$F5,$01,$D0,$44,$4D,
    $AE,$DB,$EB,$4A,$95,$0C,$52,$13,$E1,$BC,$51,$9E,$4E,$93,$4D,$DD,
    $21,$77,$7B,$84,$C2,$37,$11,$C5,$89,$3C,$03,$26,$4A,$22,$4F,$A9,
    $7C,$78,$33,$A7,$FA,$DC,$DF,$59,$F3,$00,$11,$F6,$47,$51,$8F,$5F,
    $CF,$62,$3C,$84,$09,$D9,$F1,$04,$68,$7F,$36,$92,$1C,$8D,$E5,$E5,
    $38,$E5,$66,$27,$0C,$F7,$88,$65,$82,$04,$71,$DD,$B3,$94,$9A,$F1,
    $22,$2F,$09,$60,$A6,$97,$17,$1E,$24,$56,$3A,$E3,$01,$5C,$6B,$3B,
    $47,$9C,$A7,$E9,$E0,$C1,$D2,$ED,$75,$62,$77,$8E,$34,$A7,$27,$57,
    $F1,$CE,$A7,$72,$BA,$F3,$1B,$DB,$E3,$86,$6F,$A7,$81,$47,$FC,$DF,
    $2F,$1F,$78,$1B,$73,$63,$CC,$D5,$1F,$4F,$BC,$A6,$28,$A4,$61,$75,
    $11,$69,$68,$1B,$3C,$0D,$3A,$4F,$7B,$0F,$52,$CB,$DE,$8C,$3A,$05,
    $57,$1D,$04,$25,$D2,$77,$CD,$81,$7E,$54,$52,$56,$0B,$F6,$67,$3A,
    $64,$AF,$F1,$5E,$F6,$8A,$4F,$BC,$41,$2D,$A4,$8C,$B7,$5B,$E1,$64,
    $56,$79,$4B,$51,$69,$2F,$CD,$E4,$BA,$0F,$C7,$D9,$AA,$BB,$DD,$3E,
    $4C,$37,$F2,$86,$BF,$31,$B7,$E9,$A6,$5F,$B0,$54,$60,$9F,$39,$09,
    $B8,$D1,$75,$09,$34,$BA,$DC,$49,$4E,$59,$87,$8D,$D5,$A4,$41,$7E,
    $82,$4D,$0B,$F3,$43,$91,$5D,$7F,$B0,$89,$A7,$CE,$88,$69,$FA,$8F,
    $0F,$50,$D3,$E7,$48,$62,$6F,$C1,$CA,$ED,$3D,$BC,$67,$46,$9A,$63,
    $A6,$01,$2E,$B9,$0D,$E5,$92,$B9,$DC,$73,$2A,$C9,$4D,$F8,$33,$10,
    $DB,$08,$0C,$2E,$5F,$79,$2A,$29,$9F,$5A,$92,$6F,$C0,$AE,$89,$1E,
    $AA,$E1,$45,$6C,$21,$AA,$43,$BE,$D2,$DC,$9D,$F5,$13,$E3,$0A,$88,
    $D0,$0A,$B5,$BE,$69,$3A,$1D,$F6,$66,$BC,$44,$F1,$75,$C7,$5D,$58,
    $1C,$C8,$5C,$0B,$26,$65,$29,$9D,$EE,$F3,$21,$B5,$B4,$0F,$DF,$6F,
    $3D,$AD,$6E,$95,$F7,$AF,$51,$F7,$36,$88,$BD,$71,$BC,$21,$14,$EE,
    $A1,$A7,$3C,$1F,$76,$0F,$7D,$5D,$12,$DA,$76,$13,$EC,$FE,$90,$1E,
    $CA,$F4,$F2,$D0,$47,$78,$57,$1C,$05,$BB,$71,$17,$A7,$89,$83,$84,
    $97,$42,$33,$8E,$4D,$48,$65,$06,$B9,$E7,$E1,$F0,$16,$0E,$E6,$A9,
    $97,$E1,$B2,$97,$60,$2D,$A8,$F9,$07,$D8,$C8,$C1,$84,$93,$49,$7C,
    $37,$30,$B0,$34,$76,$6A,$1D,$CE,$77,$C1,$78,$AA,$7B,$34,$2E,$A3,
    $E2,$A6,$E9,$BD,$D3,$56,$4F,$89,$D0,$8A,$1F,$D7,$C7,$70,$E4,$19,
    $CF,$8B,$ED,$B3,$CC,$84,$17,$3D,$04,$02,$3C,$E8,$85,$94,$11,$46,
    $37,$0A,$95,$2F,$57,$78,$ED,$21,$77,$27,$2F,$91,$CA,$EB,$56,$C6,
    $DC,$81,$D2,$8A,$55,$F6,$39,$C6,$91,$7B,$BD,$FF,$31,$BD,$36,$51,
    $4B,$FC,$B9,$6E,$A7,$6B,$B2,$C7,$AF,$93,$DC,$69,$A6,$D7,$74,$2F,
    $D4,$BA,$B3,$70,$6F,$D4,$E0,$DA,$50,$7C,$C5,$F0,$DA,$50,$E2,$5D,
    $56,$65,$99,$5E,$F9,$E9,$D4,$52,$4F,$B3,$21,$90,$A1,$2C,$33,$2A,
    $CB,$0C,$1C,$E3,$69,$36,$07,$CC,$B5,$ED,$2B,$98,$71,$4D,$15,$29,
    $F4,$85,$E3,$DD,$5B,$A9,$74,$EF,$FC,$A0,$E9,$B5,$42,$E2,$04,$3D,
    $7C,$8F,$9A,$DB,$A2,$B8,$EE,$EB,$29,$71,$9F,$34,$BD,$96,$E2,$39,
    $A9,$77,$0F,$BE,$FD,$8C,$62,$EF,$A9,$BD,$47,$97,$E4,$4A,$A0,$BF,
    $A9,$EE,$78,$66,$85,$DE,$F9,$DD,$53,$B1,$3A,$3B,$65,$AA,$5C,$C0,
    $C7,$B1,$14,$77,$3A,$D6,$D8,$A6,$4C,$5D,$B0,$63,$1D,$F6,$B9,$9B,
    $59,$00,$53,$C7,$7C,$3F,$9F,$B3,$F5,$65,$2D,$31,$06,$7D,$27,$EE,
    $13,$F2,$F6,$A8,$24,$97,$C6,$FB,$EE,$89,$A0,$46,$36,$94,$D2,$3F,
    $6F,$7B,$29,$68,$A0,$54,$C9,$F5,$15,$C6,$97,$2A,$6E,$A3,$FC,$35,
    $A5,$26,$E8,$F4,$D2,$1C,$83,$62,$AD,$7B,$EC,$85,$7C,$CD,$98,$3F,
    $89,$DF,$4F,$D5,$DF,$01,$8A,$FB,$88,$7E,$9F,$AA,$CF,$00,$FD,$94,
    $17,$A2,$69,$06,$FE,$29,$1A,$0E,$C7,$1D,$28,$B2,$1A,$02,$B3,$3F,
    $C0,$5F,$E7,$47,$8B,$E8,$EF,$64,$BE,$DC,$2C,$A1,$54,$F6,$6D,$52,
    $D4,$4B,$3E,$02,$36,$35,$0E,$6D,$30,$A8,$71,$3F,$F4,$B6,$C9,$35,
    $4F,$F0,$C9,$59,$AF,$0E,$DB,$42,$70,$C4,$15,$9F,$0A,$91,$C2,$88,
    $0B,$5D,$38,$8C,$1B,$42,$E6,$F8,$3D,$D7,$65,$BE,$06,$4D,$2A,$41,
    $19,$84,$17,$CF,$75,$87,$49,$06,$52,$5C,$93,$3C,$D7,$41,$98,$D2,
    $B8,$0A,$D7,$23,$82,$68,$4B,$19,$84,$08,$39,$83,$2A,$FF,$43,$36,
    $36,$B2,$8C,$DA,$C0,$1B,$6C,$DD,$83,$8F,$C7,$23,$49,$9C,$3B,$55,
    $64,$D6,$B8,$D4,$4D,$ED,$D2,$20,$24,$59,$1D,$E7,$27,$8E,$B0,$F3,
    $55,$1A,$A4,$1D,$AF,$AA,$79,$A3,$BE,$F9,$AE,$FE,$73,$54,$AF,$4A,
    $A7,$2F,$EE,$C9,$CD,$F1,$19,$50,$A0,$D6,$5B,$A1,$32,$5F,$7D,$AF,
    $A2,$AC,$CF,$79,$51,$DD,$0D,$93,$16,$DE,$16,$63,$54,$63,$6A,$AF,
    $CB,$7E,$4D,$6C,$60,$B8,$93,$8A,$DE,$DC,$0E,$8D,$1A,$8A,$82,$AA,
    $C9,$66,$FE,$3A,$86,$D2,$7F,$F2,$67,$28,$6A,$67,$EE,$53,$F5,$4D,
    $CF,$88,$74,$56,$2F,$C7,$C9,$4F,$7E,$4D,$75,$A0,$C4,$16,$8D,$F1,
    $B9,$7C,$0D,$D7,$D2,$A2,$99,$F7,$02,$B6,$0F,$71,$6C,$07,$09,$88,
    $EB,$BB,$FE,$22,$5A,$7B,$D1,$FA,$CD,$1B,$D8,$63,$3D,$B0,$C5,$EF,
    $2D,$9A,$FC,$3F,$89,$3B,$DA,$A1,$33,$3E,$AB,$EA,$8E,$7F,$54,$9F,
    $CF,$A9,$CF,$E7,$D5,$E7,$0B,$EA,$F3,$4F,$EA,$F3,$CF,$EA,$F3,$2F,
    $EA,$73,$83,$FA,$7C,$51,$7D,$FE,$55,$7D,$BE,$14,$D5,$45,$FB,$FF,
    $25,$8A,$B3,$9C,$58,$5D,$34,$ED,$2F,$68,$E2,$25,$F7,$45,$75,$D1,
    $1C,$D6,$45,$C3,$6B,$D8,$C5,$B7,$2D,$AA,$9C,$1F,$A3,$4F,$4D,$AB,
    $70,$47,$F4,$2B,$AC,$36,$5C,$AD,$89,$D4,$F1,$9B,$98,$3A,$46,$A1,
    $5F,$86,$6D,$0E,$A1,$FB,$AF,$20,$3E,$BB,$39,$F8,$07,$D5,$F7,$B3,
    $8A,$E7,$86,$87,$63,$F0,$FC,$34,$03,$F1,$58,$5D,$04,$CF,$A3,$18,
    $86,$EE,$BF,$7C,$BB,$DE,$8A,$EF,$17,$EE,$C7,$A4,$CC,$45,$42,$F9,
    $E2,$B0,$DE,$5A,$BA,$E1,$DB,$CB,$C6,$77,$94,$FD,$C2,$5F,$2E,$C4,
    $FF,$45,$B1,$10,$F8,$C3,$FE,$2F,$BE,$A3,$EC,$0D,$FF,$45,$D9,$29,
    $F6,$E2,$C9,$24,$DE,$73,$C9,$FA,$17,$BF,$BD,$5C,$7C,$FF,$2F,$CA,
    $5D,$B8,$68,$7E,$05,$97,$7B,$F3,$77,$94,$7B,$B3,$5A,$EE,$E6,$0D,
    $17,$E2,$17,$85,$1D,$33,$B0,$BF,$8B,$4D,$DF,$51,$EE,$A6,$FF,$A2,
    $DC,$14,$3B,$FB,$78,$E0,$82,$8D,$7F,$FD,$F6,$72,$F1,$FD,$42,$E9,
    $22,$D9,$3E,$69,$61,$D8,$3F,$C7,$BC,$EF,$28,$77,$DE,$7F,$51,$AE,
    $19,$F4,$B6,$70,$C9,$2F,$22,$A5,$13,$CD,$6D,$FF,$8E,$F2,$F7,$FF,
    $55,$58,$3D,$BE,$CB,$2F,$86,$E1,$6F,$F9,$9A,$19,$AF,$E5,$6B,$56,
    $BD,$9E,$AF,$C9,$A4,$F7,$67,$E9,$17,$3F,$0D,$35,$49,$0D,$99,$2F,
    $7D,$7B,$1D,$F8,$6E,$BD,$80,$3A,$0E,$53,$D9,$29,$D3,$84,$83,$0F,
    $94,$5C,$7B,$56,$B9,$1B,$62,$C2,$0F,$D0,$FB,$93,$2F,$89,$FD,$E5,
    $DF,$55,$EE,$F2,$CD,$F9,$9A,$D5,$5B,$F2,$35,$6B,$E8,$F7,$2C,$BD,
    $C7,$11,$27,$E9,$55,$8A,$B6,$E6,$6B,$1E,$DD,$82,$1A,$4B,$E7,$57,
    $54,$52,$75,$F3,$97,$50,$5B,$50,$47,$62,$6C,$14,$80,$58,$6A,$46,
    $C5,$89,$AC,$EE,$E2,$4E,$11,$C2,$EB,$7E,$8A,$36,$99,$C6,$0B,$84,
    $57,$16,$CC,$BB,$6D,$A9,$6B,$7E,$C5,$1A,$4A,$A7,$1D,$F5,$A3,$A7,
    $2A,$BB,$A6,$B6,$F6,$FF,$DD,$73,$9A,$8C,$97,$AE,$BB,$F7,$60,$34,
    $5B,$E9,$C6,$28,$FC,$0D,$F4,$DE,$BE,$B1,$6F,$FB,$F6,$6E,$14,$7D,
    $3D,$EA,$A5,$6F,$6F,$4F,$C9,$56,$D1,$9E,$19,$DB,$A8,$6D,$6F,$E4,
    $6B,$1E,$C8,$A4,$EF,$FF,$10,$CF,$0E,$7A,$E6,$BD,$49,$FD,$D4,$94,
    $AF,$D9,$44,$BF,$F4,$ED,$94,$8F,$7E,$F3,$DE,$A2,$B4,$94,$EF,$29,
    $FA,$35,$6C,$15,$69,$F1,$EB,$FE,$3B,$95,$4F,$79,$AC,$0D,$22,$BC,
    $9F,$9E,$99,$8D,$F4,$A4,$DF,$02,$3F,$A5,$A5,$DF,$B4,$ED,$B1,$3E,
    $51,$5A,$5F,$12,$7E,$36,$0D,$D3,$D4,$C6,$AF,$41,$3B,$12,$23,$41,
    $B4,$F2,$85,$97,$FA,$22,$4C,$6A,$D0,$BF,$4C,$65,$A4,$A8,$69,$C6,
    $BB,$E6,$2F,$8E,$3D,$24,$80,$7F,$84,$D3,$A5,$2F,$F7,$C5,$87,$FE,
    $95,$BE,$E1,$6E,$FA,$8E,$3D,$55,$FA,$8D,$DF,$8E,$9F,$AE,$B7,$FA,
    $E2,$67,$C6,$0E,$6A,$1B,$FD,$D6,$D0,$EF,$D1,$1D,$02,$3F,$6D,$3B,
    $A9,$AC,$B7,$A9,$FC,$5D,$02,$3F,$E9,$F4,$2C,$69,$8E,$E2,$A7,$8D,
    $DE,$CD,$2D,$F9,$1A,$57,$8B,$C0,$4F,$90,$F2,$65,$EE,$FC,$66,$FC,
    $AC,$A3,$F4,$DB,$E8,$17,$A4,$F4,$45,$54,$D6,$B4,$5D,$A0,$AC,$E8,
    $78,$44,$5B,$12,$63,$23,$D0,$D8,$C3,$1B,$CF,$A1,$2B,$D7,$59,$6D,
    $3E,$FB,$DF,$AA,$57,$2E,$8C,$E6,$C1,$0F,$DA,$76,$45,$FB,$19,$BF,
    $C4,$69,$62,$3E,$6A,$FB,$8E,$3A,$E4,$57,$44,$0F,$67,$BE,$F2,$DD,
    $75,$2C,$DF,$9D,$AF,$99,$44,$BF,$9B,$E9,$B7,$88,$7E,$A9,$D3,$4A,
    $6E,$5B,$32,$6F,$D1,$7C,$51,$93,$D4,$50,$F4,$EA,$B7,$D7,$35,$ED,
    $55,$51,$D7,$03,$DF,$51,$57,$E9,$3F,$CF,$AD,$2B,$85,$DD,$48,$8A,
    $9A,$36,$7C,$47,$3D,$DB,$5E,$15,$7C,$EE,$42,$DA,$04,$BC,$D5,$FE,
    $53,$E0,$6C,$33,$3D,$07,$4E,$2B,$74,$57,$BA,$EE,$58,$2C,$9C,$2E,
    $8A,$FA,$D2,$37,$7D,$7B,$7D,$39,$9B,$84,$15,$79,$EE,$AB,$DF,$C1,
    $F3,$A8,$FC,$92,$77,$44,$7D,$A1,$77,$44,$7D,$AE,$77,$80,$C7,$D8,
    $DA,$D4,$BD,$F9,$1D,$EC,$55,$65,$7D,$3E,$44,$4E,$1D,$51,$81,$30,
    $94,$86,$36,$45,$0C,$A5,$B7,$1A,$26,$7A,$4E,$6B,$AA,$46,$E0,$D0,
    $04,$29,$AA,$D8,$2C,$FC,$AA,$16,$57,$0C,$37,$3E,$CF,$DA,$61,$BC,
    $CD,$2D,$BB,$93,$38,$FE,$2F,$04,$1C,$25,$56,$DC,$FB,$D6,$17,$A9,
    $BB,$C2,$2D,$52,$1B,$67,$CF,$0D,$67,$17,$5F,$0C,$CA,$94,$B4,$52,
    $79,$45,$4C,$09,$C6,$98,$4F,$45,$5C,$C8,$3F,$23,$72,$95,$42,$D0,
    $08,$08,$DD,$3A,$DC,$11,$99,$5B,$45,$12,$D6,$E7,$D1,$3B,$22,$A7,
    $CB,$B7,$2D,$0F,$EF,$77,$43,$A5,$06,$75,$47,$9B,$6D,$39,$EF,$68,
    $C3,$1D,$8C,$30,$33,$B7,$6B,$B1,$F0,$46,$2F,$6B,$C5,$39,$71,$BE,
    $C1,$52,$6A,$AB,$3B,$5E,$15,$6F,$AB,$34,$54,$99,$48,$68,$C7,$B1,
    $BF,$77,$24,$9D,$5C,$4D,$2D,$C1,$65,$8F,$F2,$0E,$BC,$84,$94,$89,
    $06,$A9,$D0,$60,$0B,$56,$5F,$9C,$D5,$2C,$ED,$68,$FC,$38,$4E,$2A,
    $D4,$FB,$2C,$1B,$F1,$B7,$68,$A3,$5E,$FE,$E1,$9D,$D4,$0E,$C5,$95,
    $F2,$72,$9C,$F4,$3E,$69,$A6,$69,$4A,$99,$9E,$77,$23,$DB,$F5,$7E,
    $3E,$27,$05,$03,$B4,$FC,$B9,$82,$2B,$BE,$5D,$56,$7D,$33,$29,$20,
    $E2,$68,$DD,$ED,$1A,$69,$17,$8E,$E5,$90,$FC,$20,$FF,$67,$87,$A2,
    $74,$3E,$72,$0F,$8E,$E5,$DC,$32,$DB,$1F,$F6,$FB,$84,$9C,$E8,$0F,
    $EB,$6B,$31,$E7,$05,$08,$AC,$CE,$DF,$F0,$21,$32,$E9,$9D,$F5,$CB,
    $FF,$8A,$73,$AA,$B1,$C7,$42,$B3,$5E,$13,$D6,$69,$77,$2D,$54,$DA,
    $C4,$7B,$F8,$B0,$2F,$9C,$3D,$09,$F3,$E9,$F9,$9A,$FB,$20,$76,$B2,
    $90,$AA,$A4,$DF,$88,$BA,$A5,$52,$A3,$E7,$54,$7E,$4D,$3F,$E9,$ED,
    $BA,$9D,$77,$EB,$3C,$8D,$BA,$C6,$93,$71,$81,$FE,$9E,$53,$86,$9A,
    $44,$E1,$55,$42,$2C,$BC,$EB,$DE,$96,$F6,$C8,$A5,$9A,$C8,$79,$40,
    $71,$7A,$EA,$7C,$C5,$FF,$08,$C5,$97,$51,$F1,$AF,$78,$F3,$5E,$21,
    $A5,$0D,$88,$6A,$25,$44,$E5,$28,$D3,$F5,$C0,$5B,$EE,$CE,$3E,$78,
    $13,$70,$A2,$10,$C3,$4A,$78,$AE,$49,$AC,$A1,$C2,$DA,$36,$A8,$85,
    $61,$13,$8D,$AD,$D2,$E8,$32,$4B,$EF,$35,$1E,$89,$F3,$15,$EA,$E5,
    $DD,$4B,$78,$F9,$A0,$8F,$CF,$1F,$02,$23,$26,$F3,$B3,$E1,$CC,$7F,
    $14,$99,$6B,$92,$B8,$73,$7F,$CD,$CD,$A6,$7E,$AD,$B9,$98,$C0,$F3,
    $59,$EE,$95,$DE,$C9,$DA,$21,$35,$36,$B6,$C7,$E5,$EE,$7C,$44,$FE,
    $1B,$F5,$6A,$E0,$22,$49,$76,$48,$BD,$59,$67,$56,$F4,$9B,$2C,$FD,
    $0B,$F4,$70,$46,$51,$1C,$E3,$DC,$C7,$BC,$95,$06,$DE,$71,$2E,$DA,
    $1E,$5E,$6D,$F8,$95,$3B,$66,$5F,$E7,$75,$2E,$EC,$B1,$34,$94,$CA,
    $86,$67,$F9,$5C,$0D,$F7,$54,$A6,$0B,$DB,$3A,$F5,$CD,$C5,$19,$1A,
    $75,$0B,$E7,$EF,$DC,$E7,$6C,$E1,$0C,$DB,$17,$42,$B2,$D7,$8D,$9D,
    $21,$A7,$C5,$2D,$80,$F2,$CF,$35,$E2,$66,$D5,$EB,$37,$C7,$9C,$A0,
    $C1,$AD,$5B,$71,$54,$6A,$BD,$F3,$34,$36,$79,$52,$B2,$8E,$CA,$18,
    $6A,$B0,$6F,$E6,$3B,$B8,$64,$9B,$46,$BD,$DE,$8F,$00,$1A,$F7,$07,
    $50,$C6,$67,$34,$3A,$02,$1D,$B5,$D5,$A7,$35,$35,$7C,$D0,$34,$D5,
    $2D,$4C,$68,$6B,$78,$0F,$27,$25,$1B,$FD,$07,$A6,$0A,$86,$47,$E4,
    $7B,$86,$6D,$21,$34,$DE,$BE,$74,$45,$F7,$97,$5E,$14,$DD,$5F,$7A,
    $7B,$65,$64,$37,$E9,$9B,$2E,$1E,$7B,$75,$7B,$5D,$09,$8F,$D0,$98,
    $EE,$EF,$CF,$DD,$8B,$7D,$6E,$91,$F3,$5D,$5D,$E2,$7C,$D7,$4E,$D8,
    $8A,$54,$A3,$FE,$92,$2D,$91,$43,$77,$C7,$5D,$43,$7C,$8F,$B1,$A1,
    $29,$41,$FE,$63,$05,$0E,$53,$21,$00,$AA,$F6,$AF,$08,$6F,$F9,$5E,
    $B5,$05,$F8,$AC,$11,$A7,$F0,$EA,$BA,$F8,$88,$13,$5C,$8C,$A7,$A8,
    $39,$75,$F2,$2F,$2B,$C2,$D6,$2D,$6F,$5D,$37,$7F,$87,$1B,$7D,$BD,
    $8F,$13,$F3,$76,$E3,$0D,$62,$6B,$31,$FB,$4D,$BB,$AC,$99,$F4,$74,
    $F3,$F2,$18,$DC,$B9,$B7,$88,$91,$94,$55,$0D,$7C,$FD,$FD,$2E,$31,
    $92,$22,$FB,$B1,$D1,$9C,$25,$0B,$17,$69,$1E,$91,$AF,$82,$91,$68,
    $4D,$C4,$5E,$2F,$EC,$70,$37,$89,$C6,$A9,$07,$E9,$87,$6F,$8D,$8C,
    $E0,$70,$C3,$76,$DF,$19,$6E,$18,$F1,$CE,$00,$1A,$D2,$5C,$FE,$06,
    $C1,$D0,$5E,$C1,$67,$2A,$72,$D5,$E0,$1E,$B4,$C2,$D9,$53,$FE,$46,
    $AF,$22,$BF,$55,$81,$35,$B6,$1E,$8D,$6B,$30,$76,$99,$E7,$53,$99,
    $CA,$35,$52,$8B,$30,$61,$AD,$5F,$11,$03,$7A,$CE,$56,$01,$FA,$D2,
    $2A,$80,$1E,$77,$57,$CC,$A5,$BA,$7D,$74,$DE,$5C,$F6,$B5,$26,$5F,
    $56,$19,$43,$B8,$DB,$93,$A2,$3D,$6A,$EE,$8D,$F4,$E8,$67,$15,$51,
    $5F,$49,$EC,$B6,$C4,$2F,$18,$7C,$50,$7A,$97,$EF,$C5,$A5,$E1,$3B,
    $2D,$EA,$EB,$8B,$F9,$01,$D2,$10,$3F,$1F,$15,$9B,$C6,$1A,$49,$C3,
    $34,$DE,$AD,$22,$AA,$DB,$EB,$0C,$A9,$07,$C4,$7E,$F1,$46,$EC,$01,
    $B1,$5E,$95,$E8,$27,$C4,$C4,$86,$D4,$9A,$71,$28,$67,$44,$71,$EE,
    $21,$9F,$A3,$1B,$16,$C9,$90,$34,$5A,$B9,$C9,$C8,$56,$44,$0E,$61,
    $96,$91,$76,$50,$21,$B3,$F0,$61,$74,$E1,$8D,$EE,$F7,$22,$08,$9A,
    $F2,$86,$18,$17,$B3,$B5,$98,$51,$3E,$76,$03,$41,$91,$8F,$4B,$DE,
    $E0,$05,$48,$F9,$C7,$F7,$00,$7B,$DB,$DD,$31,$D8,$13,$70,$4F,$29,
    $93,$0E,$62,$50,$FA,$A5,$41,$90,$1C,$E5,$4F,$97,$F2,$79,$32,$3B,
    $4A,$74,$A8,$00,$EF,$89,$6D,$06,$00,$CE,$67,$AB,$29,$A0,$CA,$8B,
    $BA,$BE,$50,$C1,$D8,$8F,$A1,$D1,$39,$8B,$6B,$12,$C6,$D5,$26,$EC,
    $65,$9A,$A9,$EE,$61,$F7,$DC,$A3,$D7,$B8,$93,$5E,$D1,$0A,$7C,$E6,
    $28,$18,$95,$E2,$DC,$AF,$30,$8F,$4B,$4B,$31,$66,$46,$BC,$AA,$45,
    $B0,$59,$05,$AA,$54,$00,$F5,$43,$C4,$BD,$C7,$E9,$42,$EC,$11,$4A,
    $6A,$AB,$3D,$A6,$0D,$98,$45,$0C,$63,$B2,$AE,$C1,$F4,$7B,$3F,$0E,
    $ED,$CD,$89,$F2,$9E,$32,$36,$9F,$87,$60,$A2,$5D,$B0,$B9,$49,$DC,
    $15,$B9,$60,$01,$89,$C1,$4E,$D9,$C3,$8E,$3F,$76,$6C,$7D,$6A,$1B,
    $03,$CF,$8C,$9B,$EF,$0A,$14,$F6,$14,$6C,$BD,$50,$05,$77,$8D,$52,
    $A2,$F7,$2C,$27,$D8,$13,$89,$B2,$00,$79,$DF,$35,$67,$EA,$F7,$A0,
    $D7,$D1,$15,$ED,$7A,$C7,$DF,$C3,$38,$6B,$B6,$9F,$D0,$A8,$78,$B3,
    $C0,$35,$9A,$00,$D4,$D6,$E6,$B6,$49,$C7,$D0,$ED,$39,$DC,$ED,$02,
    $57,$6A,$B7,$07,$4B,$7D,$8E,$AE,$18,$3A,$70,$76,$CD,$90,$0F,$13,
    $FD,$BB,$0D,$D4,$F3,$FB,$A8,$40,$6D,$04,$ED,$D3,$FE,$CE,$27,$06,
    $C4,$0A,$F3,$D2,$BB,$D1,$CB,$1F,$56,$C2,$F6,$5B,$6F,$3F,$11,$91,
    $2B,$2E,$74,$FE,$4E,$03,$63,$FF,$61,$23,$CD,$DF,$7B,$2B,$CF,$9A,
    $BF,$63,$FC,$36,$76,$FC,$3D,$76,$0A,$6F,$96,$AF,$7C,$48,$4C,$E1,
    $EF,$D2,$AC,$D2,$67,$FE,$0E,$FC,$5D,$0C,$DD,$BF,$2D,$07,$58,$E3,
    $2A,$A3,$DE,$1A,$63,$EF,$BD,$66,$8F,$61,$DE,$39,$DD,$80,$4D,$45,
    $DE,$EE,$7F,$C4,$8E,$9B,$E6,$33,$62,$6D,$F0,$CF,$91,$58,$75,$94,
    $A8,$E8,$0A,$D3,$62,$1A,$75,$32,$10,$F9,$5E,$E4,$4B,$0C,$56,$33,
    $44,$B4,$3A,$90,$F6,$A9,$9D,$6D,$95,$A8,$A4,$F7,$D4,$40,$06,$5F,
    $CF,$1B,$FE,$12,$69,$C5,$CB,$FF,$10,$84,$7D,$9A,$2F,$90,$5E,$59,
    $D1,$67,$7C,$ED,$FB,$87,$30,$BD,$33,$FA,$BF,$BC,$0B,$29,$6E,$AD,
    $88,$F1,$5C,$81,$BB,$19,$A9,$B7,$FD,$E2,$5E,$09,$81,$4B,$81,$C5,
    $11,$6F,$F6,$11,$84,$00,$59,$3A,$AA,$79,$81,$46,$AA,$9C,$F2,$4A,
    $9F,$43,$AB,$A3,$DE,$14,$88,$5C,$C4,$15,$F4,$DE,$A9,$9E,$DA,$9C,
    $19,$39,$97,$2A,$AB,$34,$28,$F7,$A1,$C1,$81,$0D,$67,$8D,$5B,$8B,
    $D7,$1E,$CC,$3D,$24,$B9,$99,$DD,$0C,$2F,$56,$EF,$27,$F6,$39,$64,
    $F8,$13,$89,$50,$9F,$2C,$CF,$BD,$1B,$4E,$4F,$E2,$74,$6D,$8A,$BD,
    $FB,$46,$F7,$47,$A0,$C3,$5D,$34,$EB,$FD,$8B,$AA,$C7,$B5,$9B,$97,
    $AA,$25,$E4,$47,$4B,$E8,$EA,$53,$42,$97,$3C,$F4,$6E,$F5,$A4,$5E,
    $3F,$E0,$BA,$4B,$7A,$57,$DE,$5D,$4E,$F3,$CC,$47,$CD,$BA,$D4,$C2,
    $66,$5D,$72,$21,$17,$BC,$23,$D2,$C0,$4B,$1A,$84,$DF,$1C,$46,$E3,
    $9F,$97,$A1,$95,$69,$77,$9E,$E3,$37,$E7,$BC,$3C,$F6,$E1,$73,$1A,
    $49,$82,$7A,$DD,$A1,$AA,$CB,$0B,$73,$8F,$FB,$C2,$BD,$AB,$72,$53,
    $AC,$80,$2F,$DA,$C0,$73,$52,$62,$F1,$44,$77,$BB,$E7,$9D,$28,$B1,
    $3E,$D1,$20,$38,$A5,$81,$6B,$7F,$72,$A9,$F0,$81,$73,$16,$AF,$8C,
    $FA,$45,$72,$60,$AF,$6D,$B3,$98,$2A,$1C,$86,$F0,$BB,$F5,$56,$D5,
    $69,$8E,$B8,$5B,$74,$BA,$14,$BC,$3D,$43,$7A,$7B,$7D,$88,$F4,$AA,
    $57,$B4,$F2,$8B,$29,$D8,$DB,$CE,$50,$A7,$37,$46,$A0,$C6,$18,$42,
    $EF,$DF,$1C,$01,$E5,$F2,$46,$41,$71,$5F,$DF,$0E,$50,$4C,$4B,$C3,
    $4E,$6E,$D6,$84,$EF,$46,$05,$0A,$42,$91,$D1,$D2,$DC,$18,$3B,$5A,
    $9E,$38,$25,$46,$CB,$9F,$A2,$B1,$7E,$F9,$06,$78,$19,$C1,$45,$EC,
    $97,$D0,$4B,$56,$10,$0B,$57,$EF,$50,$87,$EA,$97,$09,$BF,$34,$EF,
    $A8,$32,$2B,$DE,$C5,$20,$C9,$8E,$00,$B3,$51,$05,$A6,$E7,$14,$80,
    $B9,$F7,$8E,$3E,$E4,$FF,$CF,$46,$3E,$59,$2B,$EF,$73,$E1,$E3,$FC,
    $3B,$54,$09,$3D,$16,$56,$1E,$DF,$A1,$98,$C1,$ED,$6E,$0A,$03,$66,
    $3B,$E6,$9A,$87,$A2,$3F,$3D,$29,$40,$9E,$D1,$14,$1D,$E0,$A1,$F3,
    $0D,$70,$29,$14,$79,$2F,$BA,$29,$3C,$5A,$E5,$9F,$F5,$C6,$F0,$9C,
    $5B,$9B,$04,$B8,$0E,$06,$77,$DF,$92,$3E,$E0,$56,$35,$09,$70,$AD,
    $0C,$EE,$6B,$4B,$C2,$0C,$49,$F8,$8F,$25,$79,$BB,$93,$7D,$1C,$BE,
    $27,$86,$23,$AA,$53,$5F,$A9,$B6,$7F,$B2,$A0,$7D,$9C,$98,$00,$8B,
    $CB,$6B,$A2,$34,$79,$16,$41,$DE,$EC,$8F,$99,$DE,$65,$5F,$3F,$E1,
    $BE,$4C,$AB,$B6,$F1,$1A,$FF,$D9,$73,$69,$60,$B0,$0F,$63,$27,$24,
    $FF,$15,$49,$C5,$30,$62,$51,$83,$A2,$9E,$49,$E5,$2D,$03,$1F,$46,
    $FD,$1F,$F9,$45,$F3,$96,$9C,$64,$FF,$47,$8B,$C5,$45,$F3,$21,$F9,
    $EA,$7E,$31,$EE,$9C,$7E,$EE,$17,$A4,$7C,$5D,$25,$12,$BD,$2B,$12,
    $A9,$6B,$9B,$A0,$C9,$05,$B8,$AB,$24,$4A,$96,$83,$93,$22,$64,$F9,
    $AA,$FF,$1C,$B2,$5C,$10,$29,$76,$AB,$5A,$F7,$2D,$0B,$50,$EC,$F2,
    $C5,$61,$B2,$8C,$F8,$41,$09,$4F,$10,$A9,$DB,$CF,$CF,$DA,$92,$DC,
    $7C,$FC,$97,$27,$8D,$21,$86,$18,$80,$2D,$DB,$05,$7F,$7B,$A0,$02,
    $25,$0F,$5D,$1C,$51,$F4,$7C,$F9,$9A,$E8,$39,$63,$CF,$3D,$06,$8D,
    $0B,$EA,$2B,$D0,$66,$26,$C1,$5E,$7A,$4F,$BE,$C4,$4B,$9C,$0A,$F1,
    $C9,$44,$19,$14,$43,$55,$19,$23,$32,$59,$2C,$4C,$8F,$47,$61,$E2,
    $6B,$EC,$0F,$54,$8A,$49,$CB,$DF,$97,$DA,$7F,$A7,$42,$12,$C7,$90,
    $3C,$BA,$28,$02,$49,$98,$9E,$FB,$0E,$BD,$19,$6F,$C5,$0E,$BD,$21,
    $27,$A8,$8F,$F7,$3A,$17,$D8,$DE,$8A,$BD,$4B,$18,$7D,$8C,$7B,$CE,
    $03,$D7,$4A,$FE,$80,$B6,$B0,$7E,$20,$E9,$58,$C9,$B5,$47,$93,$5D,
    $F1,$B5,$47,$75,$EE,$2F,$A4,$5D,$59,$3B,$7C,$CE,$D0,$23,$F2,$5D,
    $15,$62,$30,$AA,$DD,$5F,$6B,$4B,$75,$6B,$0B,$6B,$6D,$C9,$FC,$57,
    $E3,$6E,$8A,$C0,$38,$F6,$2D,$D1,$0F,$B7,$9F,$00,$8C,$C1,$5F,$F6,
    $21,$F1,$5B,$DF,$12,$24,$5E,$70,$27,$D3,$3F,$7F,$64,$02,$FF,$36,
    $1E,$FA,$E1,$5B,$B1,$24,$7B,$CA,$A4,$D1,$F4,$E5,$A5,$C3,$CE,$E1,
    $A5,$82,$62,$DB,$29,$25,$F1,$D1,$0E,$BC,$EF,$36,$C5,$74,$E8,$A7,
    $6F,$09,$0A,$7C,$63,$29,$A0,$70,$FC,$32,$46,$EC,$24,$19,$BD,$FA,
    $17,$AA,$8C,$DE,$E0,$2D,$CE,$F0,$16,$E3,$D0,$5C,$71,$A6,$B7,$38,
    $3B,$2C,$AA,$FF,$A4,$1B,$87,$FB,$CC,$B8,$CE,$56,$9A,$6E,$94,$76,
    $AC,$D7,$BC,$9C,$4F,$BA,$C9,$D0,$BB,$30,$84,$BC,$C5,$66,$C8,$F6,
    $C0,$51,$A6,$2A,$CF,$0F,$F9,$45,$54,$9E,$9F,$82,$0E,$AF,$BD,$27,
    $4D,$E3,$26,$4A,$31,$7B,$F5,$D6,$40,$96,$B4,$9B,$87,$31,$C1,$BD,
    $9C,$C6,$52,$7A,$7D,$E1,$C5,$D9,$DA,$8A,$CB,$7A,$77,$B8,$E2,$02,
    $A4,$51,$4F,$C3,$7A,$E4,$4E,$1A,$DA,$03,$B1,$DA,$FE,$8E,$64,$B1,
    $D2,$FB,$21,$F8,$CC,$54,$9D,$16,$83,$FE,$58,$F2,$EB,$5F,$EE,$59,
    $FE,$03,$50,$5A,$1B,$E9,$FC,$85,$56,$12,$18,$B8,$CE,$C8,$B7,$AB,
    $22,$DF,$B2,$95,$B2,$CC,$D9,$61,$79,$D7,$AC,$71,$8D,$10,$1A,$86,
    $4B,$2A,$34,$4A,$13,$CD,$D2,$20,$B4,$47,$9E,$BC,$8C,$9B,$53,$88,
    $E6,$30,$15,$66,$8A,$54,$4B,$67,$F7,$B1,$6F,$98,$63,$0C,$10,$7E,
    $79,$09,$7C,$EE,$44,$0A,$F3,$E9,$83,$6A,$61,$47,$A9,$30,$85,$8A,
    $2E,$34,$47,$6D,$3B,$3A,$A4,$B0,$04,$F1,$B7,$28,$68,$90,$27,$DE,
    $1A,$CE,$BA,$F4,$16,$D5,$66,$74,$F2,$9B,$AA,$49,$3C,$0E,$3B,$10,
    $C5,$DF,$13,$8D,$87,$78,$F7,$C5,$D7,$D1,$EA,$59,$0F,$E2,$F3,$38,
    $6A,$A9,$AA,$AF,$62,$69,$06,$D5,$BA,$4F,$CA,$27,$E8,$76,$48,$C9,
    $52,$9A,$F7,$12,$AF,$41,$9A,$A0,$97,$66,$E8,$BD,$B3,$F4,$DE,$12,
    $BD,$A8,$DB,$49,$84,$E8,$9D,$64,$D5,$C3,$19,$8C,$CC,$82,$68,$EE,
    $71,$A9,$DA,$3C,$D9,$D6,$5B,$35,$CA,$97,$7E,$CD,$9E,$00,$76,$7E,
    $E8,$DB,$A8,$3B,$E4,$AD,$CF,$62,$C6,$AE,$8E,$F7,$55,$6A,$03,$16,
    $E9,$F4,$E4,$BA,$06,$77,$2A,$72,$68,$6B,$AB,$2F,$D6,$BA,$E2,$A4,
    $63,$B6,$DE,$EA,$DD,$BC,$46,$9E,$53,$CF,$4B,$E2,$C6,$39,$7D,$74,
    $B7,$6F,$68,$E3,$E5,$68,$4B,$8B,$54,$66,$94,$2C,$5F,$C9,$E5,$4B,
    $84,$C3,$63,$92,$D7,$F2,$49,$5A,$CB,$37,$7F,$4B,$1F,$1C,$05,$79,
    $52,$4F,$16,$05,$F5,$94,$63,$BA,$54,$6A,$11,$46,$A6,$AF,$EA,$8E,
    $DF,$AD,$F3,$34,$EB,$1A,$7B,$C3,$46,$A6,$7F,$08,$23,$D3,$3F,$D8,
    $C8,$F4,$15,$E1,$0B,$BD,$7C,$0B,$DA,$1F,$25,$D3,$7E,$8C,$C6,$A1,
    $27,$E0,$9A,$CF,$1A,$18,$AC,$12,$2B,$CD,$C6,$CB,$57,$F5,$75,$A0,
    $AD,$FA,$42,$38,$19,$CE,$E9,$22,$98,$D6,$85,$89,$77,$7A,$37,$0C,
    $90,$0C,$6B,$4D,$2C,$AC,$D7,$03,$56,$D1,$53,$50,$66,$CE,$C6,$4B,
    $84,$94,$CC,$B6,$42,$0B,$EF,$D8,$1C,$C1,$96,$24,$50,$51,$1A,$A1,
    $C6,$37,$ED,$2B,$83,$34,$D1,$E8,$33,$7E,$99,$D5,$DC,$D8,$AE,$7B,
    $58,$4E,$98,$C3,$6D,$07,$E1,$61,$F8,$26,$60,$3C,$EA,$71,$4B,$A5,
    $6C,$25,$AE,$AD,$14,$9A,$FB,$D2,$C2,$37,$C2,$FB,$DC,$B1,$08,$BC,
    $7D,$70,$FB,$E0,$B1,$B3,$E9,$FB,$7D,$F9,$ED,$45,$11,$C2,$BD,$90,
    $7E,$9D,$D8,$A7,$08,$6F,$55,$50,$DF,$07,$A6,$B0,$DE,$11,$61,$80,
    $90,$68,$DD,$60,$67,$3A,$7B,$F7,$1E,$99,$24,$64,$62,$D2,$61,$CD,
    $41,$71,$1A,$EA,$1A,$AA,$28,$E6,$46,$49,$55,$2C,$38,$66,$45,$D0,
    $76,$AC,$2A,$03,$7E,$97,$C1,$87,$93,$49,$26,$B0,$CD,$09,$BA,$E3,
    $BD,$EE,$60,$C0,$60,$73,$07,$DD,$3A,$D2,$68,$0A,$6F,$B4,$1D,$AB,
    $7E,$DD,$E6,$0E,$D5,$F4,$57,$5D,$A1,$32,$6F,$97,$AB,$14,$76,$00,
    $67,$9B,$D3,$5D,$55,$17,$F1,$19,$2A,$7C,$2B,$BF,$D7,$78,$44,$E7,
    $2B,$34,$CA,$6F,$CD,$82,$19,$D0,$22,$DA,$4A,$B3,$45,$02,$37,$46,
    $34,$C2,$8F,$F1,$25,$19,$77,$D1,$F8,$92,$F4,$AD,$D2,$1E,$F9,$A9,
    $F5,$C2,$A7,$F8,$D6,$EC,$5D,$B8,$F0,$5D,$79,$B8,$56,$D8,$A6,$44,
    $99,$4C,$62,$3F,$20,$26,$A4,$AD,$49,$57,$91,$32,$9D,$58,$D0,$78,
    $B6,$1E,$7F,$D9,$1B,$CB,$11,$80,$D7,$F2,$2D,$5A,$18,$96,$89,$FA,
    $8C,$DC,$7F,$D4,$57,$91,$77,$C2,$79,$9B,$FA,$9D,$0D,$9E,$46,$29,
    $58,$BE,$25,$4E,$04,$79,$4E,$08,$C1,$45,$A8,$A0,$5D,$D5,$CB,$58,
    $B8,$AF,$0E,$40,$64,$A6,$39,$F0,$4A,$9C,$4F,$23,$6A,$81,$B9,$D4,
    $D6,$E6,$BA,$48,$4A,$9D,$27,$F6,$80,$99,$61,$38,$BE,$1A,$DB,$4B,
    $66,$CE,$17,$03,$71,$CD,$37,$E4,$33,$88,$7C,$DB,$85,$B9,$6B,$01,
    $F2,$1D,$7F,$05,$F7,$61,$87,$F3,$C1,$8A,$98,$B7,$9E,$EF,$48,$87,
    $8B,$72,$3F,$C2,$33,$62,$C2,$A6,$D7,$77,$22,$EA,$4E,$8A,$62,$BF,
    $DA,$20,$47,$D1,$1C,$9C,$F6,$5E,$46,$BA,$AC,$FC,$70,$83,$3A,$9F,
    $44,$E6,$CB,$B0,$59,$F4,$E7,$73,$B1,$09,$5B,$EC,$25,$AF,$36,$94,
    $E3,$94,$A6,$FB,$A7,$34,$03,$3D,$8F,$ED,$9A,$21,$EF,$3D,$FA,$3A,
    $A5,$7A,$8E,$D7,$0D,$37,$3E,$29,$C2,$8D,$8F,$94,$9A,$27,$9A,$A8,
    $DF,$40,$A0,$DE,$0F,$50,$97,$CD,$A3,$E9,$F0,$1A,$D3,$EB,$F0,$D0,
    $7E,$F5,$3A,$1C,$29,$D7,$C3,$2A,$52,$6D,$3D,$2B,$63,$91,$C8,$38,
    $17,$19,$6F,$44,$C6,$EB,$E6,$A1,$BF,$D4,$8D,$E3,$39,$73,$CF,$BB,
    $71,$9C,$F7,$D6,$D1,$1C,$7B,$F1,$5C,$D5,$AE,$59,$AC,$27,$0A,$8E,
    $97,$7D,$EB,$22,$E6,$AF,$CF,$6F,$E5,$E6,$51,$3A,$6F,$29,$31,$64,
    $83,$C0,$75,$9B,$74,$8F,$91,$58,$BE,$B5,$6E,$27,$51,$76,$A5,$21,
    $EB,$44,$DD,$F1,$9A,$8B,$6C,$EF,$54,$C7,$91,$E8,$5E,$A8,$D7,$B5,
    $48,$EF,$C8,$49,$33,$15,$45,$5B,$69,$0C,$C4,$11,$AB,$66,$D3,$57,
    $B9,$A7,$53,$5B,$91,$E4,$32,$96,$2B,$3B,$5D,$C6,$80,$D9,$5B,$6A,
    $0C,$A4,$68,$E9,$4F,$82,$AE,$D4,$40,$01,$A2,$51,$B6,$C9,$F9,$6E,
    $8D,$D8,$58,$71,$12,$31,$3C,$CD,$27,$DC,$12,$01,$69,$F6,$AD,$7D,
    $D6,$37,$8C,$6C,$78,$F2,$16,$1A,$F0,$C7,$88,$BB,$10,$30,$4D,$B4,
    $49,$FB,$C5,$44,$69,$A6,$39,$76,$A2,$81,$D2,$E5,$09,$D6,$48,$73,
    $E8,$AC,$08,$5F,$F8,$8A,$5B,$C2,$1C,$EF,$2D,$0C,$B5,$4A,$83,$ED,
    $44,$75,$6A,$84,$52,$41,$9C,$61,$FA,$F2,$8C,$D1,$D4,$98,$A5,$E4,
    $95,$8D,$CA,$30,$8D,$66,$E5,$C7,$9A,$76,$4A,$9E,$2C,$2D,$D5,$D3,
    $58,$1D,$23,$CD,$30,$DB,$4E,$BB,$A6,$53,$12,$77,$0A,$01,$38,$F8,
    $41,$9A,$AC,$77,$06,$8A,$EB,$0E,$B9,$07,$AE,$CF,$A7,$8E,$31,$BD,
    $AE,$91,$06,$C8,$FB,$B0,$29,$7F,$07,$CD,$4A,$A9,$22,$2E,$49,$1A,
    $40,$89,$FF,$C9,$B1,$75,$3B,$DD,$44,$A8,$55,$A2,$13,$B1,$03,$44,
    $76,$6C,$A4,$4E,$5C,$FE,$33,$FA,$D8,$18,$E3,$D7,$FF,$4B,$E9,$28,
    $AE,$0A,$30,$52,$37,$8D,$26,$7E,$36,$4A,$0A,$E9,$7A,$EB,$94,$9A,
    $6C,$DB,$3D,$86,$9A,$FE,$34,$01,$D7,$24,$61,$4D,$81,$EF,$4D,$F5,
    $DE,$63,$90,$CA,$F4,$3A,$1A,$5E,$6F,$51,$77,$FC,$EA,$26,$C4,$18,
    $A5,$66,$EA,$90,$86,$39,$AA,$EF,$5E,$A1,$73,$09,$CE,$E6,$B9,$6E,
    $12,$76,$56,$99,$56,$DD,$47,$F8,$5C,$8F,$77,$F9,$28,$7B,$C7,$81,
    $CC,$F7,$C9,$BB,$67,$2F,$8C,$15,$F1,$D2,$D7,$BA,$7F,$47,$36,$1D,
    $1A,$A4,$62,$83,$CD,$DE,$E3,$BE,$02,$87,$21,$88,$7D,$4F,$37,$43,
    $D0,$4B,$7C,$9A,$8D,$71,$66,$4E,$7D,$2F,$BC,$F9,$37,$CB,$13,$6F,
    $26,$E9,$03,$4B,$5D,$DB,$22,$22,$E0,$51,$2A,$5F,$D4,$59,$2F,$43,
    $08,$2C,$B9,$4D,$5D,$EA,$9A,$39,$B3,$8F,$3E,$1D,$01,$D3,$F5,$4B,
    $91,$7C,$5C,$04,$C4,$5F,$B6,$9E,$0D,$E2,$70,$AE,$F4,$CC,$A7,$7C,
    $16,$A4,$58,$0F,$E0,$04,$1C,$A7,$3A,$18,$0E,$FF,$6C,$15,$8E,$F7,
    $23,$70,$54,$B4,$86,$E1,$88,$63,$38,$1A,$E6,$86,$E1,$98,$C3,$77,
    $34,$EC,$0A,$B3,$9F,$97,$FE,$4A,$BD,$73,$70,$2E,$B8,$E9,$FA,$6E,
    $9C,$F8,$F8,$90,$6D,$E1,$EA,$39,$95,$66,$F9,$0E,$AD,$46,$33,$A6,
    $CD,$65,$52,$6E,$34,$53,$A8,$91,$24,$44,$79,$BF,$EA,$E3,$48,$9C,
    $7B,$B8,$51,$0B,$65,$CD,$F4,$68,$03,$09,$62,$E2,$FE,$07,$BF,$3C,
    $86,$E2,$38,$B8,$06,$F7,$8F,$BC,$EF,$DD,$E5,$6D,$0E,$FC,$54,$BA,
    $D1,$92,$75,$A3,$F9,$AE,$64,$6F,$50,$FE,$31,$C6,$C3,$8D,$96,$6B,
    $0F,$54,$C4,$79,$0F,$4C,$1F,$BE,$8B,$30,$AE,$2B,$36,$6B,$6F,$34,
    $7B,$9B,$BD,$6F,$37,$76,$C6,$F5,$44,$6E,$35,$B8,$25,$E9,$90,$BB,
    $79,$76,$C4,$EF,$52,$9B,$54,$86,$99,$19,$6B,$5D,$E0,$A6,$7C,$83,
    $45,$DD,$71,$F7,$59,$2C,$F5,$D0,$8B,$D4,$A6,$84,$B9,$AA,$A0,$C9,
    $34,$47,$0A,$DF,$70,$34,$8C,$D4,$FF,$CB,$14,$E6,$81,$2C,$8B,$48,
    $FB,$85,$6F,$0E,$BF,$5C,$06,$13,$DE,$CE,$7A,$A3,$55,$6A,$A6,$34,
    $1F,$CF,$67,$C4,$0E,$5D,$08,$BF,$19,$22,$DA,$2F,$E7,$60,$23,$26,
    $CB,$23,$53,$84,$7E,$45,$A2,$0B,$45,$C3,$5E,$9C,$9D,$E0,$4A,$A0,
    $DF,$80,$40,$46,$B4,$44,$2D,$25,$0F,$0C,$A2,$B0,$5E,$84,$31,$EF,
    $04,$E2,$E5,$DF,$60,$FA,$69,$96,$8C,$56,$AA,$E6,$57,$A8,$66,$B0,
    $C4,$A5,$EF,$ED,$15,$A5,$4B,$0D,$53,$D4,$32,$E4,$37,$29,$AA,$9E,
    $64,$A0,$88,$AE,$29,$94,$BA,$05,$7B,$FB,$2E,$26,$02,$2E,$50,$AE,
    $3B,$AA,$0F,$DD,$B1,$57,$28,$74,$23,$E7,$A1,$F3,$FD,$B7,$08,$7D,
    $48,$E8,$73,$65,$D2,$1C,$83,$C7,$DF,$13,$48,$94,$74,$F2,$97,$00,
    $4D,$27,$FF,$B8,$97,$89,$FB,$73,$7A,$85,$2B,$BC,$D9,$73,$FC,$51,
    $1F,$DC,$38,$BA,$52,$73,$C3,$CA,$D3,$D8,$99,$51,$33,$54,$F5,$B8,
    $CD,$46,$EB,$2D,$88,$92,$2F,$A1,$0C,$2B,$03,$78,$0D,$0C,$8A,$FD,
    $2A,$ED,$92,$15,$98,$30,$0F,$D5,$1D,$5A,$D1,$C8,$3A,$10,$68,$1F,
    $10,$8B,$CC,$EC,$55,$E7,$83,$33,$EA,$49,$22,$82,$D5,$AB,$A8,$EB,
    $57,$31,$30,$5E,$4F,$10,$FD,$89,$D2,$E8,$7B,$B3,$75,$95,$00,$38,
    $9F,$97,$C1,$0C,$A5,$C2,$2D,$1B,$FB,$C3,$E6,$86,$AC,$D1,$72,$43,
    $16,$9E,$89,$34,$64,$80,$58,$43,$BA,$49,$C4,$BC,$4E,$AF,$1A,$D1,
    $34,$55,$A7,$85,$4B,$BB,$B0,$26,$F8,$AF,$FD,$B1,$0A,$2D,$BC,$D7,
    $7B,$DA,$57,$78,$42,$03,$4D,$F7,$E3,$2C,$B0,$62,$AD,$7B,$69,$5F,
    $BE,$E6,$4D,$4A,$A4,$A7,$9F,$99,$7E,$97,$D1,$EF,$C7,$F4,$CB,$A7,
    $DF,$8D,$EA,$EF,$4D,$F5,$37,$1B,$85,$D1,$6F,$89,$1A,$BE,$8B,$7E,
    $B5,$F4,$7B,$90,$7E,$4F,$D1,$EF,$CF,$F4,$7B,$95,$7E,$9D,$6F,$50,
    $13,$9C,$F2,$ED,$70,$B0,$DD,$F9,$12,$DE,$45,$A3,$56,$72,$C4,$EF,
    $38,$42,$D8,$B7,$39,$C2,$C7,$11,$8C,$B5,$5B,$11,$11,$58,$E1,$DC,
    $8C,$53,$1D,$F2,$14,$0E,$DD,$E9,$13,$82,$D6,$E5,$70,$94,$39,$CF,
    $29,$3F,$C4,$B1,$B3,$11,$D5,$80,$A8,$29,$4E,$6E,$D7,$CC,$40,$89,
    $53,$5E,$CB,$2F,$37,$A8,$A5,$F5,$E7,$D0,$48,$27,$9F,$44,$90,$75,
    $1C,$BA,$5C,$0D,$7D,$0D,$4F,$7D,$81,$41,$4E,$39,$9F,$A3,$8D,$6A,
    $34,$EE,$53,$98,$19,$21,$B6,$C3,$FB,$85,$F2,$BD,$FD,$36,$10,$DB,
    $F4,$9B,$41,$6C,$EA,$5E,$FE,$08,$CD,$0E,$F9,$57,$5F,$9A,$AD,$82,
    $0F,$4D,$BF,$7C,$67,$AC,$11,$CB,$FA,$2F,$41,$B4,$55,$5C,$4E,$BF,
    $9B,$C3,$44,$0B,$1E,$F2,$1E,$F1,$90,$16,$E2,$21,$93,$8D,$59,$93,
    $C1,$43,$42,$82,$87,$4C,$36,$0A,$1E,$32,$7C,$D7,$4D,$D2,$38,$83,
    $6E,$9C,$59,$3B,$D9,$8C,$EB,$51,$FA,$F0,$90,$5B,$63,$79,$88,$CA,
    $42,$48,$67,$D4,$CB,$0F,$1D,$57,$59,$C4,$6C,$3F,$F1,$07,$EC,$27,
    $05,$7F,$98,$83,$67,$98,$3F,$34,$CB,$13,$7E,$CE,$3A,$CA,$CA,$3C,
    $2B,$0E,$D5,$AC,$B8,$F8,$95,$04,$82,$FB,$5A,$54,$1E,$19,$E9,$B3,
    $31,$D2,$2F,$7A,$85,$C4,$11,$39,$43,$7C,$50,$87,$3C,$EE,$CF,$A0,
    $39,$99,$C7,$F7,$4F,$95,$C8,$F8,$5E,$4D,$D3,$BA,$3A,$C4,$33,$10,
    $8B,$FD,$AE,$D7,$2D,$E0,$D9,$60,$C0,$7A,$3C,$4B,$E5,$A2,$FB,$D8,
    $ED,$1E,$02,$7E,$E1,$1F,$76,$7D,$09,$B8,$79,$C6,$91,$F0,$34,$51,
    $FD,$5E,$EC,$34,$51,$77,$A8,$6A,$50,$21,$09,$28,$EF,$D1,$AC,$B0,
    $FF,$23,$62,$7F,$2F,$39,$15,$A5,$78,$A2,$FB,$F3,$08,$76,$57,$51,
    $7A,$51,$46,$F0,$63,$E0,$F7,$AF,$B3,$30,$23,$88,$98,$7B,$9D,$2C,
    $46,$D2,$D8,$90,$9F,$FF,$20,$F6,$FE,$F1,$92,$F7,$A3,$7B,$69,$F3,
    $F8,$4C,$F0,$4A,$4C,$AA,$EC,$6C,$B8,$FA,$03,$B8,$B6,$44,$F6,$96,
    $D7,$A9,$42,$8C,$45,$B1,$C9,$63,$14,$95,$C6,$7B,$41,$E4,$AB,$9C,
    $30,$0D,$E5,$36,$C8,$33,$43,$14,$C5,$D3,$D1,$45,$4E,$6E,$18,$BF,
    $97,$DD,$4B,$8D,$A9,$65,$8A,$D2,$50,$34,$DF,$3B,$2D,$4A,$FC,$72,
    $1A,$A7,$C2,$FB,$E6,$47,$09,$70,$79,$9A,$4B,$51,$16,$94,$E2,$D3,
    $04,$4F,$0C,$C9,$4C,$7E,$1F,$3B,$76,$3F,$99,$29,$76,$EC,$62,$9D,
    $7B,$44,$1E,$EF,$8D,$5E,$28,$12,$3B,$56,$29,$8A,$28,$20,$C5,$C5,
    $8B,$F8,$73,$E1,$83,$29,$F7,$35,$45,$E1,$B2,$29,$E2,$30,$16,$7F,
    $4E,$11,$C6,$9E,$C9,$17,$11,$56,$18,$16,$0A,$A8,$FE,$67,$8A,$62,
    $52,$B4,$21,$45,$49,$4C,$44,$0B,$22,$D0,$0A,$7F,$E4,$5E,$B2,$B0,
    $6F,$AF,$58,$7F,$EC,$30,$7A,$B7,$45,$71,$B8,$08,$FB,$91,$07,$6D,
    $EE,$39,$6B,$17,$F2,$98,$F9,$31,$6D,$BA,$BC,$0D,$6D,$32,$C5,$B6,
    $69,$D1,$6B,$E1,$7B,$9E,$D7,$44,$F7,$52,$CF,$89,$29,$77,$69,$EC,
    $5E,$EA,$79,$5C,$C0,$3B,$33,$A2,$7B,$A9,$97,$72,$FE,$6D,$6D,$DF,
    $BC,$3F,$69,$37,$7D,$DB,$4F,$BF,$52,$62,$E4,$17,$BA,$1F,$2A,$76,
    $1F,$99,$96,$5A,$5E,$7A,$28,$5F,$D3,$5F,$DD,$17,$35,$6B,$D1,$C2,
    $9F,$85,$F7,$29,$8D,$3A,$F0,$CD,$F5,$E2,$5F,$D1,$01,$51,$EF,$D2,
    $B6,$6F,$AF,$77,$FB,$21,$51,$AF,$FE,$30,$31,$54,$FA,$3D,$41,$3F,
    $CB,$B4,$A2,$F9,$3F,$BF,$63,$F1,$D2,$8A,$F9,$95,$95,$0B,$EF,$58,
    $22,$AA,$24,$9C,$BD,$F0,$1D,$75,$E2,$FB,$85,$EF,$CD,$45,$6B,$C4,
    $DE,$5C,$CD,$C1,$6F,$2F,$17,$DF,$51,$EE,$CD,$07,$BE,$BB,$DC,$FE,
    $F6,$C2,$28,$E4,$EA,$9E,$ED,$B9,$DF,$51,$FE,$DC,$FF,$A2,$FC,$81,
    $F6,$3E,$B8,$E1,$1A,$88,$76,$D8,$2F,$B9,$51,$72,$98,$E5,$1F,$4D,
    $52,$14,$1A,$F3,$52,$D3,$89,$4E,$F9,$D5,$87,$79,$DC,$4B,$4D,$F2,
    $15,$13,$F1,$D6,$5A,$D7,$50,$3D,$78,$CB,$F6,$83,$B0,$95,$AF,$DF,
    $44,$B5,$C9,$3B,$9F,$A1,$21,$BA,$91,$86,$B9,$D4,$E4,$8F,$F8,$96,
    $9B,$8F,$42,$35,$F0,$FE,$CA,$E9,$BB,$45,$7A,$0B,$3D,$E4,$DF,$22,
    $7D,$ED,$37,$A4,$8F,$D1,$2E,$E3,$A7,$46,$8E,$F8,$E2,$FC,$6E,$73,
    $29,$F1,$DB,$BB,$E0,$CC,$7B,$5E,$90,$DE,$C6,$19,$5A,$C6,$8D,$5E,
    $4D,$E5,$B5,$8C,$CB,$7B,$F4,$20,$FC,$17,$F1,$AE,$9B,$CC,$A9,$E7,
    $7A,$F7,$2E,$2B,$F7,$2C,$1F,$00,$F9,$1D,$57,$90,$29,$65,$66,$A1,
    $6B,$84,$AB,$F9,$DD,$94,$98,$2D,$12,$D5,$38,$37,$55,$5C,$EA,$2D,
    $4E,$83,$29,$27,$7D,$EB,$36,$22,$2D,$5F,$71,$DA,$16,$5C,$07,$28,
    $6F,$D3,$D1,$1F,$BE,$D1,$48,$EC,$F0,$D9,$36,$E5,$9C,$1D,$3E,$9A,
    $91,$57,$E7,$5C,$3D,$4A,$B4,$43,$7E,$56,$2D,$59,$9A,$9E,$7E,$E2,
    $20,$6C,$05,$24,$A3,$B3,$6D,$80,$4A,$94,$FF,$A3,$8D,$AA,$7E,$29,
    $A5,$11,$D5,$6F,$EE,$14,$A1,$B8,$0B,$9B,$4E,$D0,$3B,$DD,$EA,$AD,
    $C9,$84,$8F,$FB,$3B,$E0,$B6,$F1,$16,$83,$CD,$EF,$9A,$4A,$22,$3E,
    $45,$2C,$A1,$88,$40,$B1,$A7,$26,$5D,$E3,$1E,$E9,$9B,$5E,$BA,$05,
    $5B,$64,$51,$01,$56,$AE,$08,$74,$D1,$0A,$24,$FC,$C9,$17,$D8,$9A,
    $84,$AD,$02,$62,$DF,$C9,$CC,$52,$B4,$31,$0D,$FE,$26,$D1,$A0,$AB,
    $20,$D5,$D4,$64,$6A,$56,$6C,$0A,$FB,$42,$97,$52,$CD,$C2,$9E,$C0,
    $DD,$F5,$DC,$1F,$B0,$57,$65,$1A,$CB,$C6,$37,$A9,$77,$D2,$08,$63,
    $93,$FB,$EA,$72,$D2,$EA,$86,$FB,$0A,$D3,$E4,$17,$81,$1F,$EC,$29,
    $F1,$15,$96,$7A,$0B,$81,$BC,$C2,$74,$42,$28,$CD,$A5,$2D,$9F,$8B,
    $B9,$D4,$10,$A8,$22,$75,$2E,$A1,$DC,$73,$52,$EB,$EA,$27,$35,$67,
    $15,$66,$D7,$35,$D4,$4C,$45,$01,$0E,$FC,$D1,$65,$55,$66,$93,$8A,
    $3D,$43,$22,$65,$EF,$EE,$84,$95,$2D,$38,$07,$D9,$A8,$90,$0A,$5E,
    $D3,$9F,$A6,$44,$8D,$F0,$E7,$F8,$26,$95,$35,$D9,$FD,$85,$F4,$0E,
    $9F,$93,$AC,$BD,$DB,$30,$7E,$E5,$4E,$0D,$C1,$53,$00,$55,$58,$5E,
    $FF,$39,$EF,$EB,$EA,$03,$7C,$E7,$7A,$02,$DE,$32,$0D,$56,$BA,$6C,
    $92,$5B,$CD,$11,$9B,$1F,$09,$7A,$34,$79,$F3,$55,$82,$49,$A4,$33,
    $7B,$96,$13,$1A,$0D,$7C,$9F,$1A,$DC,$67,$5B,$AC,$B9,$3B,$BD,$13,
    $2C,$50,$A6,$4B,$0C,$08,$35,$78,$C7,$A6,$F1,$F5,$1C,$98,$B3,$0B,
    $D2,$3D,$CB,$8D,$1A,$B7,$CE,$D3,$74,$52,$04,$7D,$B0,$DC,$9A,$61,
    $2B,$1F,$9B,$8E,$BF,$F9,$16,$79,$B7,$05,$3A,$3B,$95,$B5,$66,$CD,
    $9A,$98,$BA,$06,$A8,$75,$51,$A5,$16,$AB,$E7,$57,$D6,$BE,$95,$4A,
    $13,$D2,$3D,$77,$5B,$34,$AE,$41,$28,$90,$52,$4A,$A5,$E9,$D2,$58,
    $0B,$8C,$BE,$2F,$66,$8A,$AA,$29,$6E,$4A,$3A,$5E,$F2,$33,$95,$29,
    $56,$15,$B2,$74,$B5,$22,$D5,$3E,$13,$31,$E5,$F1,$D5,$5D,$03,$25,
    $7B,$77,$BD,$79,$CC,$20,$FD,$33,$34,$C3,$24,$78,$AA,$0D,$A3,$5D,
    $C9,$9B,$4F,$51,$95,$9D,$1D,$A0,$5B,$A8,$07,$C9,$0C,$42,$27,$B6,
    $AA,$48,$CE,$1E,$B4,$3C,$6D,$0B,$7C,$22,$60,$79,$63,$8E,$B8,$F8,
    $03,$F5,$95,$61,$15,$AC,$0E,$F5,$51,$8E,$1E,$E4,$F8,$83,$C8,$41,
    $60,$13,$18,$05,$96,$E8,$AB,$11,$2A,$72,$B5,$F9,$C4,$9C,$90,$88,
    $6B,$29,$30,$6A,$B9,$B6,$90,$A1,$8A,$60,$08,$99,$6A,$4C,$10,$40,
    $71,$87,$0C,$D7,$4D,$F2,$28,$E4,$FF,$10,$25,$E5,$EA,$BC,$05,$66,
    $AC,$67,$DA,$7B,$F6,$1D,$91,$DE,$26,$2C,$78,$7E,$65,$C4,$11,$AC,
    $BD,$81,$F8,$AD,$37,$07,$D5,$7D,$6F,$16,$1C,$8F,$25,$78,$08,$21,
    $DE,$B1,$16,$37,$17,$F8,$08,$0A,$04,$68,$81,$64,$04,$2F,$62,$29,
    $52,$35,$04,$A1,$1F,$60,$63,$37,$78,$A7,$51,$6F,$11,$22,$71,$65,
    $A2,$44,$61,$E1,$B4,$B5,$C8,$AA,$97,$DF,$C0,$50,$D8,$6E,$14,$7D,
    $16,$54,$D3,$71,$BF,$A5,$85,$FB,$CD,$84,$7E,$1B,$A3,$71,$25,$7A,
    $AA,$AC,$7A,$4D,$B5,$8A,$BA,$01,$C4,$04,$5A,$A8,$BC,$D3,$60,$0E,
    $DC,$8F,$92,$D6,$13,$4A,$35,$DD,$DF,$AD,$67,$35,$E1,$BD,$8F,$F2,
    $35,$FD,$DA,$F3,$35,$CD,$F4,$9B,$F7,$71,$BE,$E6,$45,$FA,$1D,$A7,
    $DF,$0D,$47,$68,$B6,$A2,$9F,$9F,$7E,$33,$3E,$21,$39,$8C,$7E,$47,
    $E9,$97,$DB,$91,$AF,$F9,$1B,$FD,$B6,$D1,$8F,$09,$05,$BB,$84,$00,
    $70,$E7,$0B,$7A,$EC,$75,$25,$D0,$0C,$44,$05,$CA,$78,$50,$89,$92,
    $0F,$12,$95,$92,$95,$B8,$7A,$6D,$EE,$DE,$FA,$56,$41,$93,$DE,$52,
    $BD,$E7,$88,$C9,$73,$CA,$E0,$CA,$14,$11,$2D,$1A,$5E,$9C,$B0,$58,
    $5B,$C6,$A6,$25,$13,$31,$A8,$B1,$F9,$7A,$30,$B0,$CE,$E2,$28,$E4,
    $F4,$B7,$40,$4F,$2F,$8D,$B2,$DE,$D3,$60,$B0,$15,$98,$97,$65,$0A,
    $5A,$6C,$89,$4B,$15,$23,$A0,$A5,$20,$ED,$0A,$94,$20,$62,$C7,$8A,
    $12,$F4,$28,$41,$AD,$49,$2B,$6A,$8A,$81,$3B,$A8,$FB,$16,$B8,$09,
    $6A,$6D,$7D,$2B,$7D,$34,$12,$CF,$E0,$22,$B6,$B0,$93,$DB,$7C,$7D,
    $63,$BB,$41,$57,$64,$35,$9E,$F8,$B2,$6E,$AF,$EB,$3C,$50,$5C,$7B,
    $0E,$14,$35,$D4,$1F,$C7,$29,$47,$86,$BB,$7F,$18,$18,$0C,$DB,$CE,
    $F2,$DE,$70,$FB,$5A,$B4,$2C,$60,$A1,$3F,$23,$D0,$4D,$FD,$2E,$E8,
    $28,$BA,$BE,$B5,$F1,$48,$1A,$23,$D6,$10,$2E,$48,$77,$4E,$41,$49,
    $17,$58,$90,$99,$0A,$D2,$46,$0B,$D2,$9F,$53,$50,$43,$DC,$85,$15,
    $64,$E8,$5B,$50,$FC,$39,$05,$DD,$15,$C7,$5D,$A1,$4C,$D0,$A3,$A0,
    $02,$03,$D0,$65,$56,$88,$37,$D5,$27,$53,$74,$7D,$23,$65,$D3,$8A,
    $58,$62,$36,$F4,$77,$82,$C1,$5B,$92,$C3,$FA,$65,$B8,$4C,$B8,$83,
    $ED,$CC,$89,$8B,$46,$A4,$8A,$4A,$5A,$F2,$D3,$4A,$81,$7F,$8E,$C5,
    $A8,$D7,$8B,$C1,$10,$1F,$49,$2A,$11,$4F,$A0,$01,$06,$06,$36,$AA,
    $3F,$8D,$6A,$2C,$47,$55,$59,$0D,$67,$DC,$E9,$67,$75,$25,$35,$82,
    $4F,$E5,$77,$BE,$49,$83,$17,$49,$B4,$2E,$01,$FD,$16,$6D,$04,$0D,
    $94,$C3,$C8,$40,$8E,$4F,$C7,$CD,$08,$82,$2F,$CE,$37,$C5,$B2,$64,
    $57,$FF,$30,$88,$10,$85,$3A,$2B,$7A,$D8,$1E,$CA,$15,$19,$44,$45,
    $9E,$BB,$23,$88,$B9,$45,$FB,$7F,$EA,$F3,$A4,$73,$30,$3C,$E8,$02,
    $0B,$3A,$AB,$CF,$93,$CF,$29,$68,$B7,$E6,$FF,$D4,$E7,$29,$E7,$14,
    $E4,$B9,$A0,$82,$62,$4B,$89,$0C,$7A,$5B,$81,$E1,$7C,$03,$6D,$EE,
    $39,$03,$6D,$D0,$E9,$E8,$70,$E7,$43,$72,$18,$F3,$01,$E3,$66,$78,
    $2B,$08,$C4,$33,$25,$78,$B6,$9B,$FD,$E0,$A3,$7D,$79,$2E,$51,$81,
    $91,$79,$AA,$85,$39,$04,$F1,$D4,$14,$B5,$07,$47,$27,$B8,$54,$7E,
    $0A,$0B,$2D,$53,$0E,$65,$13,$C6,$8F,$A2,$14,$26,$2A,$DB,$D8,$1C,
    $57,$A2,$A8,$63,$3E,$B3,$B2,$1C,$6D,$84,$82,$A4,$12,$33,$4F,$1E,
    $FB,$8E,$D8,$88,$93,$DC,$75,$99,$4A,$D3,$13,$CC,$5C,$C2,$BE,$F6,
    $12,$D4,$4C,$25,$1A,$B2,$E8,$B3,$96,$4A,$46,$36,$3C,$28,$EB,$24,
    $FA,$42,$B3,$F6,$23,$97,$69,$D4,$66,$E6,$36,$B4,$C4,$25,$B2,$60,
    $87,$36,$C8,$E7,$C8,$0A,$2A,$A0,$43,$B4,$61,$5A,$F7,$5C,$9B,$EA,
    $BA,$E8,$1B,$C8,$9A,$5F,$F5,$54,$BD,$BE,$AE,$81,$72,$62,$96,$E8,
    $FC,$44,$1D,$61,$C9,$40,$4F,$18,$54,$3D,$05,$8C,$81,$B1,$B9,$0D,
    $34,$06,$8C,$71,$15,$F1,$F1,$7C,$81,$02,$81,$3C,$26,$CE,$9D,$A0,
    $10,$F8,$81,$A1,$40,$4B,$ED,$B5,$24,$CD,$D2,$88,$43,$44,$2A,$BB,
    $A1,$46,$93,$C0,$3F,$29,$8D,$41,$21,$E1,$81,$67,$27,$9E,$A4,$8C,
    $FA,$8A,$8D,$92,$A8,$22,$0B,$9D,$AD,$9D,$60,$50,$83,$5E,$46,$2F,
    $C1,$86,$0B,$66,$05,$00,$54,$BB,$77,$82,$9E,$73,$85,$D1,$7C,$3D,
    $37,$CF,$40,$80,$99,$39,$91,$85,$AA,$81,$60,$24,$6F,$C5,$DA,$FB,
    $34,$8A,$45,$01,$38,$86,$8D,$FE,$A4,$99,$38,$96,$ED,$52,$43,$B6,
    $A7,$09,$9B,$E1,$3C,$92,$39,$A2,$A2,$89,$AF,$6E,$AE,$22,$9C,$63,
    $38,$5B,$49,$E0,$48,$F6,$D8,$5B,$F5,$92,$BD,$15,$07,$A0,$F9,$D5,
    $D1,$4A,$CD,$D3,$F2,$EB,$FF,$FF,$24,$E0,$5B,$61,$08,$E2,$90,$D7,
    $D9,$4E,$5F,$25,$AD,$B2,$8A,$9B,$81,$24,$8A,$A3,$DD,$1D,$90,$1E,
    $43,$D0,$E6,$0C,$B9,$07,$91,$1A,$85,$DC,$B9,$3B,$25,$A7,$91,$5E,
    $92,$3B,$57,$E1,$0C,$8E,$D3,$E8,$AB,$9B,$87,$79,$32,$D9,$EB,$D8,
    $DF,$62,$3F,$CC,$B2,$8E,$7D,$A3,$E4,$DC,$88,$95,$95,$54,$C5,$7E,
    $D8,$63,$DF,$A8,$F7,$54,$1F,$36,$2D,$0B,$48,$8E,$C3,$5E,$47,$9B,
    $64,$DF,$6F,$B3,$1F,$AE,$4C,$90,$9C,$87,$BD,$4E,$CA,$82,$3D,$26,
    $1A,$9F,$E3,$29,$AF,$63,$83,$64,$DF,$E0,$19,$8D,$5C,$8E,$76,$8F,
    $7D,$03,$49,$7B,$ED,$1A,$02,$C1,$D9,$0E,$BF,$8F,$8E,$FD,$36,$47,
    $FB,$B2,$04,$C9,$DE,$0E,$BF,$23,$B8,$A0,$68,$3F,$C1,$EF,$38,$AC,
    $0E,$05,$AF,$7D,$33,$15,$E8,$5B,$F5,$98,$E8,$85,$17,$28,$60,$73,
    $B6,$57,$66,$49,$8E,$17,$24,$FB,$E6,$2C,$2D,$7D,$27,$B5,$2D,$99,
    $29,$A0,$F3,$6D,$9A,$D3,$3C,$F6,$17,$E0,$7F,$64,$CF,$FC,$CD,$22,
    $69,$C5,$BF,$24,$47,$3B,$92,$AE,$F2,$89,$22,$62,$D2,$3F,$09,$1F,
    $23,$C0,$D0,$66,$ED,$03,$5C,$01,$7C,$D7,$1C,$F6,$D6,$2D,$38,$85,
    $6D,$F1,$68,$BE,$D7,$D9,$EA,$F3,$2D,$A2,$A0,$D7,$B1,$2D,$90,$46,
    $38,$67,$24,$9B,$B5,$CE,$C3,$92,$63,$9B,$44,$69,$09,$EB,$DB,$18,
    $A5,$9F,$08,$81,$D4,$D9,$EA,$45,$75,$6A,$3A,$AF,$F3,$30,$89,$03,
    $97,$52,$42,$E9,$81,$3A,$D0,$15,$F5,$03,$1E,$68,$ED,$2A,$DF,$B3,
    $88,$80,$F3,$9E,$76,$EA,$88,$8A,$B7,$73,$77,$FA,$EA,$9E,$E5,$AA,
    $DA,$BD,$3E,$A4,$A2,$2E,$A4,$C1,$6D,$EF,$E0,$8D,$04,$CE,$FD,$B9,
    $3B,$4F,$1C,$F4,$3A,$1B,$BC,$75,$D8,$59,$00,$DB,$EF,$6E,$AF,$63,
    $93,$64,$6F,$F3,$3D,$2A,$48,$D4,$F9,$82,$E4,$68,$B3,$39,$64,$D3,
    $43,$7F,$C5,$BC,$46,$B8,$A2,$FA,$83,$9D,$2B,$10,$70,$74,$F8,$56,
    $A9,$65,$AE,$93,$9C,$1D,$BE,$07,$1E,$43,$21,$5E,$C7,$B3,$9D,$37,
    $C0,$3C,$6C,$EF,$F0,$D8,$D7,$E9,$3D,$F6,$67,$89,$AC,$F6,$6B,$ED,
    $0D,$92,$53,$CE,$A2,$9A,$9C,$9B,$24,$C7,$26,$9B,$63,$FF,$B2,$78,
    $8A,$0E,$E8,$24,$FB,$26,$AF,$7D,$93,$B8,$00,$D7,$D9,$46,$09,$A4,
    $B7,$A9,$81,$E8,$23,$D2,$C8,$83,$63,$6D,$4D,$CB,$8A,$25,$47,$B0,
    $60,$B8,$A3,$8B,$A0,$6A,$6C,$8F,$F3,$31,$4E,$75,$4D,$5E,$FB,$36,
    $EA,$50,$9B,$63,$53,$E5,$95,$81,$8B,$F7,$CC,$87,$77,$13,$60,$4D,
    $72,$6E,$B3,$C5,$2D,$1B,$08,$44,$6A,$87,$DB,$BB,$A8,$D3,$B8,$C7,
    $36,$55,$1C,$8E,$ED,$FE,$4D,$D8,$A5,$39,$C7,$20,$39,$37,$8D,$95,
    $0A,$32,$D9,$B3,$04,$C9,$F7,$5E,$FB,$6E,$62,$50,$43,$3D,$D5,$1D,
    $1A,$D2,$D1,$9C,$06,$89,$91,$22,$E7,$11,$C3,$17,$02,$FF,$9B,$60,
    $77,$0E,$B3,$E4,$DC,$ED,$69,$32,$78,$FB,$93,$B4,$66,$DF,$CD,$BE,
    $6D,$CC,$18,$33,$BB,$0D,$92,$E3,$59,$8A,$A1,$EE,$43,$09,$D7,$4B,
    $CE,$75,$44,$25,$DE,$E4,$7A,$FB,$FE,$D5,$F6,$B7,$EA,$9D,$87,$57,
    $3B,$B7,$4B,$0E,$C2,$EF,$0E,$C9,$D1,$90,$E5,$D8,$4F,$FD,$B5,$0F,
    $8E,$46,$25,$E7,$B3,$D2,$D8,$1E,$09,$BD,$BF,$DD,$6B,$6C,$95,$1C,
    $3B,$BC,$93,$30,$14,$1B,$74,$20,$FE,$36,$D3,$03,$AF,$60,$BD,$C3,
    $D9,$76,$95,$B3,$61,$B5,$F3,$2D,$52,$0C,$1A,$3F,$8E,$13,$9D,$AA,
    $DB,$61,$73,$B4,$DE,$95,$D0,$6C,$DF,$DE,$10,$98,$46,$A3,$54,$4A,
    $B6,$39,$BA,$2B,$2F,$CB,$25,$54,$B7,$AE,$1C,$03,$31,$B4,$42,$E7,
    $69,$98,$BB,$DA,$BE,$9D,$C7,$AB,$D7,$BE,$03,$14,$14,$18,$CE,$49,
    $B3,$1C,$DD,$92,$DD,$52,$6F,$59,$5D,$DB,$54,$CA,$90,$51,$8A,$2C,
    $EC,$8A,$4D,$93,$8C,$F7,$12,$90,$82,$09,$B4,$65,$39,$1A,$22,$68,
    $EB,$22,$C0,$A3,$50,$03,$AD,$95,$97,$51,$83,$CF,$05,$BD,$4B,$1B,
    $C1,$FB,$47,$54,$C6,$F8,$48,$09,$87,$03,$49,$14,$3F,$D2,$D9,$BE,
    $67,$31,$E5,$69,$BF,$DC,$71,$98,$F4,$59,$FB,$E1,$91,$20,$58,$10,
    $10,$53,$93,$63,$5D,$80,$46,$35,$A8,$87,$94,$A2,$FD,$C3,$89,$72,
    $1C,$0D,$EA,$D4,$36,$41,$B2,$AF,$BB,$9C,$48,$DB,$EC,$FE,$90,$A8,
    $C3,$63,$0F,$2A,$75,$7B,$4D,$75,$15,$18,$78,$F6,$36,$8C,$52,$95,
    $5A,$1F,$9C,$7A,$06,$8B,$3F,$9B,$35,$3C,$DB,$B8,$48,$E9,$92,$D9,
    $C7,$64,$3C,$6B,$43,$16,$75,$BF,$79,$84,$1F,$C3,$BF,$0B,$9F,$AF,
    $70,$86,$A6,$6E,$85,$43,$6A,$F8,$12,$DA,$32,$50,$28,$81,$B2,$8D,
    $49,$1C,$8E,$A6,$CE,$B8,$8D,$92,$DD,$40,$92,$DF,$A3,$7F,$2C,$D0,
    $04,$AC,$14,$73,$DA,$3D,$14,$DB,$DF,$E2,$70,$55,$D5,$40,$1D,$67,
    $24,$79,$61,$1B,$7D,$6E,$B1,$07,$CF,$F0,$AA,$4F,$50,$55,$C0,$CE,
    $AA,$73,$C1,$0B,$24,$54,$2C,$B0,$3E,$4B,$92,$85,$DD,$4C,$35,$A7,
    $4D,$E5,$4A,$B5,$5A,$A1,$54,$DA,$BB,$65,$3F,$3B,$50,$0A,$D6,$35,
    $B8,$6C,$6A,$DD,$4E,$03,$69,$2F,$ED,$B1,$75,$83,$1A,$0D,$92,$56,
    $7E,$3C,$2E,$5C,$B7,$EE,$B9,$D8,$BA,$03,$BF,$5A,$B0,$8E,$AA,$58,
    $90,$F6,$47,$DC,$23,$6A,$A4,$3A,$2C,$53,$D4,$95,$25,$1A,$4C,$3A,
    $7B,$37,$58,$74,$48,$9E,$11,$A9,$AA,$E4,$9B,$AB,$32,$8A,$AA,$B2,
    $CF,$5F,$15,$03,$A2,$91,$FB,$31,$9B,$08,$62,$15,$5A,$A0,$FA,$5C,
    $BD,$53,$4F,$33,$25,$A9,$35,$86,$2C,$FA,$11,$1D,$EE,$10,$93,$31,
    $CD,$B3,$71,$8D,$ED,$BA,$95,$0D,$CB,$E1,$B4,$84,$D4,$50,$9E,$37,
    $33,$A8,$FF,$3C,$D7,$AD,$21,$38,$34,$11,$CC,$99,$EA,$DC,$84,$A4,
    $16,$7B,$D7,$00,$AA,$AB,$A5,$2E,$9F,$92,$B4,$7E,$86,$1B,$7E,$7C,
    $CE,$2E,$6F,$5D,$11,$2E,$2F,$7C,$AC,$E4,$34,$D6,$2D,$7D,$75,$33,
    $10,$72,$04,$E1,$17,$CC,$29,$0B,$39,$58,$A1,$AE,$B4,$CB,$FA,$95,
    $D5,$C1,$35,$14,$AA,$FA,$0F,$B1,$17,$E2,$63,$9C,$D0,$DE,$81,$4B,
    $B3,$A8,$F0,$EA,$8B,$89,$1E,$5B,$E2,$92,$C2,$C9,$3B,$F4,$EA,$87,
    $BE,$C9,$DB,$29,$36,$4D,$4D,$DE,$2E,$24,$26,$4E,$DE,$AE,$57,$3F,
    $F4,$4D,$7E,$98,$62,$33,$D4,$E4,$87,$63,$80,$39,$AC,$57,$3F,$54,
    $FD,$A7,$25,$9E,$10,$CB,$C2,$43,$94,$3E,$16,$98,$29,$6A,$01,$E2,
    $7D,$3E,$E0,$63,$8A,$68,$16,$93,$CA,$56,$64,$93,$7F,$8B,$BD,$A6,
    $0D,$BE,$C7,$44,$35,$41,$B8,$2E,$76,$B4,$09,$75,$88,$2B,$68,$A3,
    $49,$35,$38,$B4,$EA,$68,$4B,$BC,$91,$4A,$41,$74,$94,$2A,$16,$58,
    $50,$3A,$E2,$7D,$75,$28,$BD,$54,$94,$9E,$BB,$93,$AF,$45,$91,$AF,
    $A7,$A2,$5B,$E2,$D1,$01,$5A,$D5,$26,$32,$08,$90,$78,$61,$A1,$58,
    $8F,$5C,$5E,$2D,$06,$40,$2A,$60,$84,$8C,$60,$90,$06,$59,$F8,$BB,
    $E8,$7F,$3D,$FA,$BF,$4B,$ED,$7B,$96,$D9,$D0,$D3,$90,$D5,$20,$66,
    $61,$33,$24,$64,$CF,$82,$1E,$FA,$60,$86,$A4,$C7,$32,$D8,$94,$1E,
    $76,$6B,$53,$C4,$12,$B0,$39,$92,$D8,$BD,$0F,$BA,$91,$C6,$35,$D2,
    $B3,$C8,$6A,$10,$62,$1C,$8B,$95,$46,$16,$E4,$60,$33,$1A,$9B,$89,
    $32,$60,$1A,$52,$F3,$73,$06,$F7,$BB,$10,$C4,$2C,$C2,$EE,$25,$C7,
    $D2,$22,$EE,$E0,$51,$58,$33,$33,$12,$54,$8D,$47,$CD,$2B,$8F,$70,
    $98,$6A,$65,$11,$92,$A4,$55,$B4,$BA,$33,$04,$D7,$70,$28,$CA,$74,
    $DF,$11,$7A,$5D,$49,$AF,$1B,$07,$69,$34,$24,$97,$50,$75,$81,$F8,
    $AD,$08,$B0,$60,$48,$62,$E0,$70,$51,$AD,$C5,$6C,$7A,$60,$9E,$96,
    $E5,$78,$3D,$69,$9B,$5A,$AD,$80,$13,$92,$B7,$59,$8D,$2B,$38,$6F,
    $64,$DC,$F9,$22,$75,$E7,$8B,$D4,$9F,$2F,$32,$FE,$7C,$91,$09,$E7,
    $8B,$4C,$3C,$5F,$A4,$E1,$7C,$91,$49,$E7,$8B,$4C,$3E,$5F,$64,$CA,
    $F9,$22,$8D,$E7,$8B,$4C,$3D,$5F,$64,$BF,$F3,$45,$9A,$62,$23,$3D,
    $C4,$3E,$CC,$D4,$FF,$16,$B3,$C0,$B1,$0F,$17,$C2,$E1,$55,$E3,$1A,
    $1A,$8B,$6A,$05,$6C,$46,$CD,$43,$1A,$81,$C5,$7D,$64,$CB,$97,$0A,
    $DB,$B9,$8C,$B9,$7B,$4F,$7C,$09,$9A,$0A,$47,$98,$D5,$08,$B3,$E8,
    $E1,$FB,$87,$F6,$B2,$33,$26,$73,$63,$BB,$39,$05,$CA,$1A,$89,$F0,
    $6B,$CA,$CE,$62,$62,$50,$83,$46,$69,$5C,$AC,$4F,$B1,$C4,$3F,$DA,
    $1B,$C7,$A6,$31,$BD,$0B,$61,$CF,$B5,$F1,$6E,$68,$09,$4C,$94,$A5,
    $44,$DF,$99,$78,$13,$26,$4B,$CF,$98,$04,$F7,$08,$A6,$58,$FA,$9E,
    $6F,$94,$9F,$BE,$8C,$75,$1C,$A1,$25,$19,$E4,$77,$7A,$58,$AF,$50,
    $95,$26,$19,$16,$01,$61,$8F,$4D,$26,$71,$83,$18,$25,$74,$33,$E8,
    $1C,$05,$19,$E0,$98,$B0,$58,$58,$BD,$25,$39,$18,$53,$13,$B2,$C3,
    $60,$5D,$2C,$A5,$5B,$E1,$83,$3D,$B7,$41,$29,$1B,$C5,$6A,$C9,$68,
    $D4,$EF,$2D,$C8,$21,$BE,$3A,$1B,$F6,$BD,$B2,$BE,$8A,$A9,$30,$72,
    $52,$61,$E9,$D6,$2D,$79,$11,$7B,$27,$86,$05,$09,$44,$09,$40,$5A,
    $60,$A9,$F8,$CC,$16,$C3,$18,$93,$E8,$34,$24,$F1,$8E,$B5,$8A,$E6,
    $B2,$46,$69,$14,$D6,$D9,$DC,$86,$40,$1E,$87,$D0,$7B,$13,$AC,$3A,
    $D4,$56,$92,$C9,$C3,$1D,$95,$4E,$19,$45,$ED,$C1,$28,$35,$73,$14,
    $10,$DD,$38,$1A,$36,$8D,$87,$05,$FA,$8D,$70,$66,$E5,$27,$38,$9F,
    $3D,$7B,$F2,$00,$43,$48,$63,$CC,$F2,$E8,$67,$E5,$7D,$42,$46,$44,
    $43,$4B,$E7,$81,$08,$EC,$E5,$D0,$57,$40,$98,$41,$21,$DB,$94,$EC,
    $CA,$54,$FE,$9E,$4D,$CA,$62,$C6,$84,$40,$32,$92,$4C,$C9,$44,$80,
    $32,$30,$26,$0D,$9E,$93,$49,$A6,$FB,$3F,$E8,$0F,$9B,$A5,$AF,$BE,
    $3B,$5F,$F3,$0A,$FD,$D2,$4F,$E4,$6B,$1E,$0E,$E5,$6B,$8E,$9C,$CA,
    $D7,$6C,$3B,$93,$AF,$69,$D1,$16,$68,$5E,$D7,$15,$68,$FE,$AD,$2F,
    $D0,$AC,$8F,$2F,$D0,$C4,$25,$14,$80,$35,$58,$74,$26,$0F,$2E,$60,
    $A3,$D7,$F4,$B0,$76,$6A,$08,$CC,$8C,$68,$88,$19,$11,$0D,$11,$6A,
    $66,$3A,$6F,$50,$2E,$01,$85,$72,$4B,$B2,$FA,$23,$02,$E6,$08,$35,
    $C2,$8B,$88,$0C,$4E,$9F,$13,$B6,$04,$40,$EB,$5C,$33,$8C,$B8,$D1,
    $E3,$FD,$99,$AD,$58,$14,$51,$50,$5A,$3D,$FC,$28,$36,$ED,$6B,$4F,
    $22,$A2,$25,$BA,$4F,$A3,$31,$62,$31,$08,$98,$EE,$C5,$15,$73,$00,
    $C2,$73,$24,$11,$34,$2F,$68,$D2,$E8,$F9,$58,$EB,$2D,$49,$43,$EF,
    $EC,$39,$EA,$39,$8A,$2B,$D3,$8A,$27,$98,$56,$19,$A8,$5F,$E9,$71,
    $31,$3D,$3A,$71,$94,$B8,$71,$91,$D5,$AC,$C3,$58,$D3,$A1,$36,$CF,
    $C7,$89,$50,$CF,$91,$7D,$1F,$7D,$40,$17,$0D,$17,$6D,$6A,$89,$63,
    $26,$B9,$05,$EB,$1F,$45,$D6,$51,$A5,$BE,$49,$D6,$51,$BE,$69,$D6,
    $1C,$0A,$64,$CB,$3F,$0D,$31,$00,$A3,$A6,$A2,$19,$53,$E8,$CF,$68,
    $84,$28,$77,$8E,$FC,$8B,$FE,$6C,$03,$F0,$8E,$35,$32,$E1,$12,$83,
    $BF,$0D,$56,$64,$88,$DA,$92,$E8,$4D,$6F,$09,$FA,$CF,$C2,$18,$44,
    $53,$D3,$99,$74,$C6,$82,$D9,$A7,$01,$63,$59,$8C,$18,$A1,$D3,$73,
    $04,$2B,$F5,$19,$9C,$BE,$0F,$DE,$66,$D0,$5C,$D6,$79,$AB,$99,$89,
    $3C,$6C,$93,$80,$CD,$CE,$10,$D3,$46,$34,$84,$8D,$7D,$10,$68,$62,
    $E2,$8D,$56,$61,$EA,$EC,$6C,$EB,$1B,$AF,$B7,$B6,$68,$92,$84,$81,
    $42,$4F,$B2,$D2,$52,$08,$43,$04,$FE,$99,$FF,$01,$F8,$BF,$1D,$42,
    $D5,$AF,$33,$31,$79,$59,$32,$FE,$9F,$50,$DA,$95,$A8,$72,$84,$E9,
    $02,$29,$2D,$43,$A5,$B4,$49,$3C,$8B,$9B,$4F,$EC,$69,$EC,$54,$E7,
    $D2,$95,$1F,$E3,$AF,$6D,$8F,$CB,$7D,$36,$C2,$3C,$FF,$43,$84,$2D,
    $48,$27,$E8,$EF,$E8,$27,$6C,$4C,$04,$2C,$4F,$F3,$C4,$44,$C7,$C2,
    $C4,$64,$51,$79,$05,$4C,$86,$AE,$44,$3E,$66,$18,$E8,$2F,$96,$B7,
    $10,$99,$16,$59,$DB,$F2,$F6,$EF,$EC,$38,$CD,$D3,$4B,$BA,$C6,$3D,
    $13,$E5,$30,$9E,$32,$80,$12,$86,$16,$F0,$A5,$33,$16,$A7,$C0,$01,
    $1F,$46,$94,$3E,$2B,$0E,$11,$30,$2A,$AB,$11,$5E,$44,$64,$70,$FA,
    $3E,$30,$6E,$BF,$94,$60,$DC,$95,$CA,$3D,$69,$D5,$98,$EA,$4A,$B5,
    $8C,$1A,$C1,$AD,$32,$DD,$37,$84,$4D,$BE,$D9,$B6,$29,$56,$D7,$48,
    $E6,$5D,$10,$9C,$32,$D4,$D2,$6C,$25,$E0,$68,$E0,$7D,$D9,$59,$14,
    $33,$9E,$38,$1A,$25,$29,$C9,$44,$80,$1A,$68,$55,$4B,$3D,$A5,$51,
    $4B,$C5,$DC,$D1,$A7,$FE,$A2,$4B,$85,$4D,$9A,$CB,$C8,$F1,$A2,$54,
    $41,$09,$B6,$B1,$28,$19,$1C,$34,$9B,$44,$F4,$8C,$92,$40,$32,$AF,
    $ED,$65,$22,$40,$19,$AC,$DF,$37,$90,$6E,$41,$BC,$00,$F0,$7B,$EA,
    $FE,$85,$97,$10,$6A,$97,$1A,$79,$DF,$70,$B8,$85,$6C,$5C,$04,$D7,
    $B2,$51,$C1,$CB,$90,$34,$9D,$39,$22,$C5,$DA,$08,$92,$65,$E8,$2F,
    $AB,$2A,$4D,$1A,$C1,$AD,$D2,$A7,$50,$4C,$66,$A9,$DC,$FE,$11,$2F,
    $8B,$A9,$D2,$04,$06,$8D,$71,$B8,$18,$0F,$10,$6C,$78,$0A,$1C,$8E,
    $19,$64,$12,$B3,$D7,$E1,$25,$7A,$53,$DD,$5F,$49,$9D,$0A,$AF,$97,
    $7A,$EE,$0E,$13,$14,$35,$D0,$DC,$F9,$EB,$93,$42,$5E,$E9,$D7,$77,
    $14,$B3,$B9,$9A,$46,$F1,$F7,$3C,$0E,$E6,$5E,$4C,$88,$F8,$45,$CA,
    $05,$8E,$E2,$7E,$D1,$F9,$82,$06,$EF,$0D,$2C,$D3,$1A,$B9,$5F,$F4,
    $62,$D6,$18,$E6,$39,$39,$E4,$2E,$13,$5A,$DE,$28,$C7,$7B,$DA,$87,
    $79,$42,$43,$96,$B9,$99,$71,$26,$09,$93,$B5,$9E,$B4,$C2,$75,$B1,
    $E3,$FA,$7B,$1E,$33,$6B,$D2,$30,$FF,$25,$73,$5D,$DC,$23,$8D,$9D,
    $F1,$9E,$23,$C3,$08,$32,$DD,$9E,$95,$4D,$98,$87,$C2,$DA,$C2,$C0,
    $4A,$03,$01,$61,$1C,$A8,$2E,$6E,$4A,$37,$5B,$F5,$62,$FB,$99,$2A,
    $A0,$94,$81,$D2,$21,$BA,$18,$FF,$77,$B3,$CE,$91,$8B,$08,$DA,$4E,
    $42,$0D,$66,$8D,$7E,$98,$35,$FA,$A9,$F3,$8F,$81,$67,$15,$C0,$D3,
    $B9,$53,$50,$C1,$FF,$23,$01,$62,$32,$40,$9A,$9E,$F4,$5F,$0A,$10,
    $6C,$03,$57,$C6,$1A,$24,$BD,$CF,$FA,$9C,$BA,$E6,$65,$0C,$8B,$15,
    $96,$95,$7D,$26,$45,$DC,$6B,$AC,$B7,$36,$76,$26,$7B,$1A,$F5,$B6,
    $12,$83,$E9,$FE,$61,$B0,$A3,$5F,$7A,$FE,$32,$08,$17,$96,$95,$CC,
    $75,$0D,$03,$2B,$0E,$F3,$62,$8B,$39,$51,$ED,$B2,$52,$EE,$37,$58,
    $F3,$1B,$2D,$00,$DF,$D3,$64,$86,$BC,$5C,$F0,$39,$E9,$B8,$45,$61,
    $FD,$F1,$4E,$49,$98,$FE,$D5,$95,$B5,$24,$C6,$6B,$92,$28,$E1,$7B,
    $A5,$BC,$C1,$83,$09,$71,$38,$A7,$AA,$EE,$8E,$30,$F0,$74,$C6,$6B,
    $41,$03,$74,$EA,$2A,$88,$59,$65,$31,$16,$62,$31,$46,$93,$E7,$F1,
    $FF,$FD,$F8,$AE,$25,$C5,$B3,$F3,$FE,$C4,$0B,$E8,$4E,$D4,$87,$85,
    $21,$D3,$BD,$0B,$05,$A5,$1B,$59,$7F,$F0,$59,$9E,$2F,$D0,$5C,$CE,
    $DA,$8E,$4E,$37,$D6,$42,$88,$1D,$4D,$FA,$05,$49,$69,$A4,$9D,$AA,
    $CC,$70,$B4,$E0,$9D,$45,$D4,$94,$22,$73,$65,$D6,$79,$04,$40,$69,
    $2C,$77,$6C,$98,$2A,$8A,$A8,$4F,$3B,$CF,$08,$95,$B9,$68,$80,$3B,
    $71,$33,$7A,$34,$90,$48,$19,$8A,$3C,$72,$3F,$2A,$35,$6F,$6B,$8A,
    $46,$FD,$EA,$22,$CE,$18,$22,$DC,$E4,$77,$7A,$63,$B0,$B5,$13,$32,
    $7F,$E0,$7B,$9F,$71,$A7,$5A,$08,$5B,$33,$13,$62,$B0,$45,$A3,$A5,
    $1E,$4B,$82,$AD,$FB,$8E,$24,$4D,$8B,$C5,$16,$35,$92,$34,$96,$3C,
    $9A,$19,$2C,$A6,$FB,$E7,$AB,$18,$EB,$D3,$EC,$69,$D6,$3C,$49,$FF,
    $58,$18,$7D,$34,$13,$E4,$53,$92,$3C,$4E,$42,$9F,$86,$8B,$65,$22,
    $B8,$52,$47,$C2,$F0,$0A,$98,$F1,$1C,$BE,$45,$E5,$E5,$E9,$F6,$E8,
    $28,$BB,$E0,$5F,$B6,$D6,$8A,$7E,$8C,$69,$77,$15,$3D,$F2,$B4,$95,
    $E7,$F0,$D7,$ED,$FF,$43,$FE,$9A,$43,$FC,$B2,$F3,$9A,$78,$D1,$39,
    $66,$B7,$59,$ED,$53,$82,$51,$9A,$B6,$B2,$27,$10,$C7,$74,$5C,$C4,
    $A3,$5C,$8D,$E5,$DE,$26,$BC,$E5,$11,$3E,$F3,$DD,$9F,$02,$07,$52,
    $78,$DF,$50,$78,$D2,$55,$B5,$C0,$C6,$A3,$3C,$67,$1C,$19,$46,$E8,
    $D0,$35,$C5,$73,$6B,$0B,$88,$41,$34,$84,$55,$5E,$BD,$D8,$3B,$F4,
    $59,$58,$E5,$9D,$60,$A1,$76,$96,$A0,$E9,$F4,$9C,$94,$20,$04,$34,
    $D2,$2E,$4A,$E0,$A7,$9E,$0A,$9D,$42,$1A,$46,$69,$29,$A9,$1A,$33,
    $A6,$52,$EC,$5C,$CC,$D7,$96,$52,$49,$48,$1F,$16,$AA,$0D,$2C,$10,
    $58,$6E,$1F,$36,$36,$9E,$ED,$AA,$E3,$8D,$F2,$B2,$A3,$7D,$D8,$07,
    $1E,$60,$1B,$31,$B2,$29,$B3,$93,$EF,$1B,$B1,$EF,$93,$AE,$D3,$F9,
    $A1,$8E,$2B,$98,$16,$D1,$85,$66,$20,$44,$59,$4B,$E5,$D9,$7A,$16,
    $C6,$66,$90,$BE,$7D,$0F,$E7,$29,$B2,$4E,$93,$9B,$BA,$54,$C4,$20,
    $C5,$DF,$28,$10,$99,$A8,$BE,$E7,$59,$E1,$5A,$40,$97,$AF,$13,$AB,
    $B6,$E0,$BA,$53,$8C,$AC,$60,$8B,$6D,$56,$84,$5F,$16,$02,$D0,$91,
    $A5,$EA,$82,$29,$81,$C7,$C5,$88,$89,$2C,$E1,$7F,$C0,$70,$5F,$D4,
    $09,$F1,$B4,$C4,$35,$28,$36,$FA,$41,$52,$E2,$3A,$1F,$8B,$6E,$0F,
    $89,$1A,$52,$A6,$99,$FB,$18,$52,$EA,$02,$7D,$0C,$29,$CB,$C2,$41,
    $AC,$38,$33,$4F,$15,$44,$C4,$DB,$C9,$0A,$32,$BC,$02,$7A,$69,$42,
    $BA,$77,$92,$3A,$72,$73,$FE,$0B,$39,$96,$D7,$F2,$49,$CE,$33,$8A,
    $F9,$DD,$DC,$B9,$E1,$0B,$21,$E6,$25,$2E,$4B,$C5,$C4,$68,$A0,$11,
    $92,$AE,$A0,$62,$A0,$4B,$9D,$E1,$CE,$D3,$11,$1B,$4D,$AA,$4C,$FE,
    $DF,$D8,$2F,$18,$94,$6C,$86,$32,$C7,$F5,$BD,$4B,$0C,$43,$08,$A4,
    $4E,$AB,$56,$6C,$85,$D0,$1A,$C4,$60,$34,$68,$FF,$07,$3D,$FE,$2A,
    $E9,$6B,$9D,$5B,$D5,$0A,$CE,$FC,$0F,$C8,$7C,$2A,$55,$10,$B8,$19,
    $A5,$F7,$FE,$0F,$A4,$BD,$6E,$A8,$72,$DB,$6F,$9E,$2D,$F6,$CF,$F5,
    $31,$17,$C6,$A4,$7A,$25,$20,$76,$E5,$B0,$65,$D0,$1A,$63,$19,$54,
    $85,$1D,$10,$99,$6A,$3F,$8B,$EC,$C5,$3B,$77,$DF,$1E,$51,$3E,$33,
    $11,$A9,$80,$38,$C3,$0D,$FB,$84,$82,$12,$B6,$07,$0A,$53,$9B,$6A,
    $13,$44,$21,$91,$73,$CE,$D1,$63,$CE,$76,$AC,$7F,$B2,$21,$6F,$CB,
    $25,$51,$83,$1F,$AF,$00,$65,$49,$CE,$20,$EC,$8D,$F5,$94,$CC,$19,
    $5C,$3D,$D6,$5C,$8F,$BD,$88,$C1,$D5,$25,$FD,$61,$E8,$77,$04,$BD,
    $53,$06,$60,$A3,$B4,$33,$E8,$1D,$3B,$98,$E2,$D5,$5B,$2D,$00,$E7,
    $8E,$BE,$26,$52,$A9,$14,$AC,$74,$14,$B7,$4A,$AB,$D2,$B2,$5E,$CC,
    $09,$E2,$73,$06,$5B,$F2,$C4,$7E,$BD,$B0,$21,$0F,$8A,$68,$26,$14,
    $AF,$73,$14,$D1,$CC,$58,$45,$34,$93,$32,$64,$4B,$28,$3D,$99,$AD,
    $76,$5F,$A7,$B0,$D5,$2E,$DF,$80,$95,$92,$02,$CD,$DA,$A4,$02,$CD,
    $63,$29,$05,$9A,$5F,$1B,$0B,$34,$65,$FD,$0A,$34,$B9,$A6,$02,$4D,
    $4E,$FF,$02,$CD,$AB,$03,$0A,$34,$77,$0C,$2C,$D0,$B4,$D2,$6F,$65,
    $95,$35,$1B,$73,$90,$E9,$DE,$33,$42,$F4,$B0,$26,$9B,$EE,$FD,$4A,
    $13,$B6,$19,$A4,$81,$AE,$B9,$A3,$D2,$41,$D7,$93,$D8,$9E,$CC,$BC,
    $4F,$70,$E4,$0C,$26,$BD,$38,$D0,$B5,$1A,$41,$74,$CD,$E9,$33,$81,
    $7C,$80,$36,$61,$F0,$14,$21,$C8,$42,$A3,$64,$73,$27,$64,$84,$FC,
    $FA,$D2,$FE,$FC,$3A,$7E,$80,$E9,$B5,$7C,$B3,$BC,$3A,$55,$1D,$F3,
    $61,$EE,$94,$11,$E5,$4E,$D6,$08,$77,$4A,$8B,$70,$A7,$F4,$08,$77,
    $02,$ED,$64,$9E,$C3,$9D,$32,$63,$B9,$53,$26,$65,$C8,$16,$CB,$26,
    $97,$F0,$CE,$32,$56,$4B,$21,$75,$C5,$51,$2D,$A3,$88,$53,$E1,$4A,
    $56,$49,$98,$E4,$46,$E5,$EE,$AC,$27,$21,$B6,$C4,$18,$0E,$4B,$13,
    $06,$60,$26,$A7,$90,$B0,$F1,$51,$7D,$A3,$A4,$02,$A3,$2A,$18,$A6,
    $B3,$3C,$19,$16,$73,$AD,$7D,$05,$B7,$B4,$08,$67,$48,$8F,$70,$06,
    $6B,$94,$33,$64,$9C,$CD,$19,$32,$22,$9C,$21,$F3,$5C,$CE,$F0,$5B,
    $D2,$F8,$3A,$97,$08,$B5,$0F,$6C,$94,$4D,$10,$31,$82,$5B,$9A,$82,
    $99,$9E,$48,$08,$83,$34,$9D,$84,$B6,$B0,$98,$5B,$C4,$E4,$67,$24,
    $31,$2C,$2A,$EA,$A6,$41,$D4,$C5,$76,$4B,$36,$55,$D5,$4F,$D0,$E6,
    $EE,$25,$A9,$0D,$43,$DB,$5C,$5F,$AA,$CD,$6D,$18,$2E,$58,$98,$B9,
    $1E,$34,$6B,$E1,$B5,$05,$F7,$10,$66,$45,$8C,$11,$7D,$04,$23,$6C,
    $2C,$5C,$7E,$86,$77,$5C,$5A,$CC,$34,$6E,$44,$6D,$16,$CF,$C7,$26,
    $91,$26,$9A,$43,$2F,$72,$C4,$F1,$5E,$53,$35,$47,$BE,$7B,$28,$E3,
    $93,$5E,$BD,$05,$C6,$BE,$15,$74,$5E,$A6,$26,$CA,$70,$99,$44,$56,
    $DE,$C6,$99,$72,$86,$D9,$D6,$A8,$88,$8A,$A3,$6F,$C9,$4F,$6B,$8F,
    $95,$07,$C5,$80,$12,$1C,$33,$3D,$C2,$31,$AD,$51,$8E,$99,$71,$36,
    $C7,$CC,$88,$70,$CC,$CC,$73,$39,$66,$06,$D5,$D3,$F9,$B5,$21,$DC,
    $F3,$86,$FF,$E7,$3D,$FF,$7B,$AA,$BB,$D3,$65,$F8,$BF,$F4,$BC,$91,
    $61,$B6,$D4,$71,$B7,$53,$4A,$ED,$14,$BD,$2A,$C4,$A7,$A9,$42,$3C,
    $96,$52,$08,$B9,$F5,$63,$FB,$E3,$01,$3B,$34,$72,$80,$F6,$0B,$06,
    $43,$B4,$61,$4C,$EB,$04,$A6,$47,$09,$6E,$66,$8C,$54,$D3,$A7,$F5,
    $51,$6D,$FD,$7B,$45,$FF,$7A,$EA,$F5,$CE,$65,$89,$31,$AD,$A7,$D6,
    $C6,$A8,$77,$31,$AD,$0F,$77,$4A,$58,$BD,$1B,$C5,$52,$37,$21,$D8,
    $28,$74,$14,$9A,$BC,$1A,$3F,$D6,$E9,$1A,$59,$D0,$01,$A9,$97,$10,
    $A9,$33,$2E,$88,$F0,$68,$DC,$8F,$D5,$0E,$17,$73,$9F,$B9,$1E,$3C,
    $C8,$12,$A6,$69,$C1,$09,$2C,$9E,$76,$93,$C0,$88,$59,$E0,$47,$AF,
    $62,$4B,$35,$62,$54,$9C,$8A,$D2,$74,$11,$D7,$6D,$81,$BC,$18,$9B,
    $DC,$D0,$09,$2F,$5C,$E7,$50,$6F,$CF,$FF,$90,$7A,$7F,$96,$00,$6D,
    $26,$E1,$FF,$77,$D4,$FB,$31,$69,$52,$9D,$AF,$C5,$7F,$3F,$D4,$6B,
    $3C,$9B,$7A,$05,$63,$88,$0F,$D3,$27,$CD,$07,$59,$4C,$A3,$39,$6A,
    $F7,$67,$12,$AB,$26,$74,$66,$4D,$B1,$DA,$9A,$4C,$F7,$61,$B2,$57,
    $39,$54,$26,$D6,$24,$F5,$D6,$AC,$12,$6B,$D6,$1E,$9E,$60,$32,$B3,
    $9A,$08,$37,$39,$9D,$BF,$11,$4A,$7B,$76,$D4,$1A,$9D,$F9,$1D,$86,
    $DE,$FF,$62,$0A,$CA,$8E,$5A,$A3,$19,$55,$7D,$AD,$D1,$AF,$E9,$CF,
    $B2,$46,$FF,$17,$42,$C0,$F7,$0A,$A4,$5B,$8C,$E2,$B0,$35,$3A,$3D,
    $22,$18,$5A,$A3,$82,$61,$C6,$D9,$82,$61,$46,$44,$30,$CC,$3C,$57,
    $30,$3C,$44,$2C,$A4,$73,$A3,$2E,$62,$8D,$46,$0F,$11,$F0,$F5,$C9,
    $AB,$A1,$16,$E4,$D0,$2F,$93,$68,$23,$5B,$AC,$9E,$E6,$A0,$21,$C9,
    $11,$D0,$B9,$2F,$B1,$87,$99,$7A,$0E,$EB,$15,$A6,$BA,$9B,$D5,$F9,
    $1A,$22,$5A,$E7,$A9,$E3,$AC,$66,$44,$3A,$2C,$8C,$32,$E0,$C2,$08,
    $AD,$84,$B0,$66,$1B,$0B,$5C,$00,$81,$30,$6F,$67,$46,$F0,$15,$AB,
    $50,$64,$C6,$2A,$14,$99,$54,$6F,$9F,$0E,$2B,$12,$AD,$2A,$E8,$D3,
    $AA,$78,$55,$3F,$FB,$AF,$A5,$11,$B5,$FF,$6D,$A5,$00,$52,$95,$59,
    $B3,$6D,$25,$00,$D2,$C2,$CB,$D9,$17,$DE,$F7,$B1,$1D,$F6,$3D,$F2,
    $8D,$AB,$68,$9E,$EE,$C4,$79,$55,$C1,$17,$C2,$A3,$A6,$BE,$D4,$B0,
    $BA,$7F,$B8,$B7,$58,$9C,$83,$FC,$74,$D7,$D7,$CC,$D5,$CE,$33,$FA,
    $3F,$D1,$FE,$1F,$48,$3A,$06,$23,$42,$99,$FB,$5E,$5B,$06,$22,$E9,
    $BC,$42,$6C,$4B,$19,$75,$8E,$36,$F7,$BD,$F2,$BE,$4F,$35,$E7,$6A,
    $73,$DF,$6B,$5B,$56,$69,$CE,$D2,$E6,$D2,$22,$DA,$DC,$F7,$30,$68,
    $AF,$E4,$DD,$EF,$A3,$FD,$E2,$FC,$5A,$CC,$F6,$83,$58,$1D,$0D,$E7,
    $D6,$1A,$CA,$CE,$DA,$54,$C4,$C2,$BB,$D1,$2B,$74,$57,$EA,$62,$AF,
    $B0,$16,$5A,$78,$D0,$E5,$DC,$A5,$0E,$98,$40,$42,$64,$BC,$59,$BC,
    $C2,$40,$A6,$97,$4A,$CC,$98,$03,$2A,$53,$44,$19,$D1,$9D,$4F,$AE,
    $54,$C8,$EE,$A7,$DD,$09,$11,$82,$E4,$CD,$2D,$C3,$4B,$79,$93,$0C,
    $E6,$03,$6D,$81,$38,$4F,$30,$4A,$E3,$E2,$9D,$FF,$E9,$62,$3D,$0A,
    $D5,$E6,$8F,$3E,$7B,$17,$08,$32,$40,$29,$49,$83,$0E,$99,$36,$45,
    $EE,$DD,$2E,$14,$48,$B1,$A2,$85,$29,$1B,$2B,$5D,$62,$13,$45,$A6,
    $8D,$C0,$37,$D5,$BD,$15,$3E,$11,$63,$0D,$DB,$47,$C0,$67,$33,$A9,
    $41,$6C,$F3,$E0,$10,$A3,$90,$1B,$17,$69,$14,$EF,$D2,$30,$C3,$1C,
    $4E,$8D,$62,$ED,$8F,$6D,$E4,$67,$35,$2A,$CC,$16,$59,$3E,$1B,$3E,
    $C1,$1C,$6E,$9F,$B6,$D4,$C2,$0B,$68,$FF,$A7,$46,$0D,$FF,$86,$46,
    $09,$84,$99,$85,$C8,$2D,$D4,$FE,$6C,$89,$3D,$C5,$A5,$A9,$3E,$73,
    $1A,$FA,$A8,$C9,$66,$DE,$EE,$CE,$5B,$CD,$B0,$A9,$D5,$88,$BD,$26,
    $0E,$19,$1A,$70,$69,$BA,$D7,$D9,$81,$6D,$91,$05,$39,$5E,$7B,$1B,
    $7F,$CA,$B6,$39,$DA,$96,$19,$F9,$63,$76,$96,$B3,$6D,$42,$20,$09,
    $DF,$A9,$97,$9D,$6D,$5E,$E7,$7E,$EC,$9E,$33,$F2,$8C,$EE,$75,$E0,
    $5E,$4C,$75,$7A,$F7,$3A,$77,$7B,$AA,$3B,$2C,$95,$97,$49,$8E,$0E,
    $C5,$71,$58,$B2,$B7,$47,$44,$3C,$BB,$AC,$D8,$DB,$3D,$F6,$0E,$03,
    $12,$54,$7C,$24,$39,$E5,$CB,$9D,$AD,$8D,$47,$74,$3A,$27,$41,$18,
    $A4,$44,$71,$5E,$7B,$57,$5D,$83,$FB,$2A,$52,$C7,$85,$26,$B3,$18,
    $17,$A0,$92,$1E,$33,$1C,$A0,$05,$25,$67,$5B,$7D,$81,$7E,$75,$9C,
    $62,$6F,$53,$1C,$FB,$3B,$4B,$78,$87,$6A,$B0,$7E,$BC,$56,$A4,$23,
    $41,$84,$53,$1E,$B7,$77,$99,$4D,$AB,$4C,$C4,$F6,$3C,$F3,$BB,$4C,
    $D8,$B2,$EA,$E8,$22,$05,$34,$AC,$33,$D9,$65,$D2,$97,$9C,$3B,$28,
    $12,$D9,$9C,$5D,$94,$83,$E0,$31,$7D,$17,$C0,$26,$15,$E0,$DD,$0C,
    $B0,$39,$0A,$F0,$37,$83,$70,$5A,$13,$06,$A1,$C3,$66,$EF,$AA,$BC,
    $5C,$AD,$C0,$D9,$1E,$11,$9A,$9C,$E1,$0A,$E8,$93,$CD,$D1,$55,$F1,
    $C1,$37,$40,$BB,$3D,$16,$5A,$C9,$BE,$63,$B8,$7A,$10,$A0,$2D,$6B,
    $82,$D5,$E6,$D8,$5E,$31,$52,$B2,$B7,$65,$D9,$B7,$7B,$B1,$2F,$BD,
    $81,$DE,$79,$36,$B6,$37,$30,$A2,$76,$9C,$27,$2A,$30,$3E,$92,$5D,
    $B2,$6F,$CF,$6A,$E4,$FD,$E9,$D4,$E3,$99,$59,$8E,$2E,$2F,$B6,$45,
    $EF,$20,$80,$97,$59,$B9,$3E,$6C,$F0,$06,$E6,$B5,$40,$BC,$C8,$DF,
    $E5,$0E,$30,$A5,$58,$CF,$5F,$A1,$3B,$D0,$B9,$81,$98,$30,$21,$21,
    $DF,$FD,$43,$DC,$C1,$49,$A5,$4F,$D0,$87,$C5,$3F,$A7,$0C,$0C,$BE,
    $4D,$E3,$84,$10,$A7,$A5,$9A,$3B,$B7,$42,$08,$E0,$2D,$BA,$33,$28,
    $01,$A1,$A2,$B1,$53,$E7,$75,$EC,$D0,$A2,$33,$A8,$A9,$ED,$9E,$F9,
    $1D,$89,$00,$CF,$2E,$83,$9F,$03,$F0,$0E,$EF,$84,$74,$90,$B3,$F3,
    $30,$56,$73,$89,$9E,$B1,$E5,$DA,$90,$A5,$D5,$92,$54,$CF,$21,$AF,
    $96,$CF,$2F,$88,$56,$7A,$27,$E4,$74,$D6,$86,$01,$9A,$76,$1E,$80,
    $72,$1B,$18,$A4,$30,$40,$75,$0D,$A6,$BA,$67,$A0,$9C,$5E,$10,$19,
    $36,$6A,$B8,$E4,$0C,$D7,$AC,$EF,$0B,$72,$71,$7C,$20,$0C,$79,$33,
    $87,$80,$9D,$25,$FF,$2B,$EC,$04,$E6,$AF,$AC,$DE,$0F,$9B,$48,$45,
    $B2,$A7,$FA,$70,$B2,$C9,$33,$06,$8B,$18,$CE,$8E,$C6,$A3,$3A,$1A,
    $29,$38,$CA,$11,$AD,$C9,$C1,$35,$15,$5C,$70,$4D,$D8,$BF,$AF,$56,
    $03,$DB,$9A,$51,$13,$F1,$3B,$72,$ED,$A5,$05,$11,$DF,$16,$AE,$58,
    $DF,$16,$F9,$F4,$C1,$DF,$F9,$D5,$A0,$A8,$6F,$0B,$57,$C4,$37,$C6,
    $C3,$EA,$7D,$83,$8F,$A8,$CF,$5F,$AB,$CF,$47,$D5,$E7,$63,$EA,$F3,
    $37,$EA,$F3,$71,$F5,$F9,$84,$FA,$FC,$AD,$FA,$7C,$52,$7D,$AE,$55,
    $9F,$4F,$A9,$CF,$A7,$D5,$E7,$EF,$D4,$E7,$EF,$D5,$67,$AD,$FA,$5C,
    $A9,$3E,$EF,$55,$9F,$1E,$F5,$B9,$4A,$7D,$D6,$A9,$CF,$FB,$E8,$59,
    $26,$B5,$C9,$F9,$C4,$86,$AE,$BB,$98,$D4,$01,$77,$3F,$69,$DF,$E6,
    $49,$D4,$32,$79,$4F,$0E,$BB,$35,$DC,$B7,$F9,$59,$84,$FC,$39,$E1,
    $FB,$C5,$65,$4B,$9F,$B4,$D3,$F0,$F5,$8F,$E1,$B4,$1B,$10,$7A,$3C,
    $9A,$56,$D6,$C6,$A6,$BD,$19,$5F,$EF,$0E,$A7,$DD,$84,$D0,$2F,$A3,
    $69,$B7,$F5,$49,$3B,$0F,$5F,$1D,$E1,$B4,$DB,$10,$BA,$21,$9A,$76,
    $4D,$9F,$B4,$8B,$F0,$F5,$B2,$70,$DA,$ED,$08,$0D,$8C,$A6,$9D,$D7,
    $27,$AD,$0B,$5F,$BF,$FE,$91,$9A,$76,$37,$42,$FF,$F9,$51,$24,$ED,
    $E8,$3E,$69,$AB,$F0,$75,$67,$38,$ED,$7E,$84,$DE,$88,$A6,$35,$F6,
    $49,$BB,$0A,$5F,$9F,$0E,$A7,$3D,$8C,$D0,$43,$D1,$B4,$ED,$9A,$D8,
    $B4,$0F,$E0,$EB,$9D,$E1,$B4,$1D,$08,$FD,$3C,$9A,$76,$53,$9F,$B4,
    $8F,$E2,$AB,$3D,$9C,$B6,$0B,$A1,$6B,$A2,$69,$57,$F7,$49,$FB,$14,
    $BE,$5E,$1C,$4E,$DB,$8D,$50,$8A,$48,$4B,$B4,$DC,$1C,$BF,$86,$06,
    $A6,$D6,$73,$DD,$03,$CF,$C3,$BB,$CF,$4F,$41,$DB,$3F,$18,$1A,$A6,
    $ED,$F5,$88,$2D,$29,$95,$7F,$74,$7D,$8C,$FB,$97,$E1,$43,$41,$EE,
    $CF,$E0,$93,$BF,$33,$69,$20,$11,$FA,$97,$73,$FC,$6B,$B2,$B5,$95,
    $A9,$CD,$F1,$4F,$A1,$B0,$F5,$4F,$E0,$D3,$FA,$47,$F1,$77,$CD,$46,
    $AD,$FC,$B1,$C2,$17,$A6,$D3,$C4,$24,$BF,$27,$5E,$E3,$37,$03,$3A,
    $BF,$3A,$96,$1E,$18,$1A,$1D,$4B,$69,$2D,$05,$1A,$77,$BC,$FC,$B3,
    $D8,$FB,$0A,$7E,$3D,$14,$35,$FD,$7E,$40,$8C,$BF,$19,$24,$D3,$86,
    $F3,$BF,$15,$93,$3F,$BD,$25,$66,$2C,$EE,$E6,$8C,$E5,$03,$A2,$63,
    $31,$9D,$F3,$59,$87,$51,$5B,$D5,$7F,$B1,$EF,$E1,$7F,$35,$14,$07,
    $27,$04,$DF,$75,$5F,$D9,$A6,$FC,$02,$F5,$8E,$39,$9C,$A1,$85,$A3,
    $1C,$8B,$FA,$4C,$53,$9F,$79,$EA,$33,$5F,$7D,$2E,$50,$9F,$8B,$D4,
    $E7,$52,$F5,$E9,$52,$9F,$DB,$D4,$67,$03,$3D,$52,$A7,$95,$56,$DC,
    $F1,$0B,$F8,$46,$19,$BF,$A4,$FC,$8E,$35,$04,$53,$3F,$8A,$BA,$ED,
    $E7,$BF,$C4,$05,$62,$88,$9A,$4B,$89,$74,$6A,$86,$0C,$F5,$39,$49,
    $7D,$E2,$DA,$A4,$88,$AF,$77,$78,$C9,$90,$67,$DB,$70,$22,$A1,$07,
    $8E,$B0,$FD,$19,$05,$AA,$23,$6C,$1C,$B7,$C1,$95,$D7,$0B,$70,$3F,
    $5B,$D9,$ED,$04,$5F,$7F,$8D,$46,$96,$C7,$70,$2F,$19,$A5,$66,$F9,
    $E1,$C1,$8A,$D2,$F9,$1B,$0D,$16,$F9,$9C,$0B,$D6,$46,$F2,$49,$CD,
    $38,$AB,$92,$9D,$C6,$D7,$CC,$EC,$C4,$03,$4E,$D8,$06,$49,$09,$F5,
    $45,$69,$CA,$AA,$86,$8A,$14,$69,$70,$5E,$C6,$5D,$F1,$13,$EB,$0E,
    $AD,$08,$78,$4E,$6B,$6B,$06,$4A,$09,$B5,$55,$69,$CA,$D5,$A4,$4F,
    $E3,$A5,$F7,$6A,$97,$16,$DF,$FA,$49,$CD,$5B,$DB,$A8,$50,$B9,$86,
    $AA,$09,$58,$A8,$AC,$6A,$2A,$CB,$D6,$56,$9D,$44,$15,$EC,$93,$35,
    $97,$C6,$50,$C1,$1F,$32,$0A,$F8,$8A,$10,$79,$AC,$0D,$DE,$A1,$D6,
    $98,$29,$C7,$17,$91,$AF,$6F,$A3,$94,$E5,$04,$B7,$CD,$DE,$E3,$4A,
    $C2,$75,$E3,$F2,$CF,$38,$DD,$02,$A4,$FB,$54,$B8,$37,$0C,$FB,$3E,
    $02,$B2,$EA,$1A,$5C,$A9,$75,$7B,$5D,$49,$75,$3B,$6B,$E2,$E5,$96,
    $78,$F6,$2D,$53,$B7,$B7,$26,$71,$6A,$A9,$7C,$1B,$32,$4E,$BF,$C9,
    $DB,$EC,$7D,$DF,$FB,$F6,$C8,$06,$CF,$11,$DD,$9E,$CE,$3D,$9D,$C7,
    $9E,$77,$27,$7A,$F7,$1C,$7B,$CE,$AD,$CD,$BF,$F5,$16,$E1,$2B,$79,
    $8A,$74,$54,$0A,$35,$EB,$AD,$1A,$E9,$4B,$DC,$BB,$30,$B4,$38,$F7,
    $50,$BD,$7E,$98,$7C,$45,$A2,$A2,$94,$D6,$17,$0D,$D1,$C8,$97,$D2,
    $DB,$AC,$31,$AD,$7C,$3F,$C8,$A7,$94,$50,$0B,$67,$79,$73,$FA,$FA,
    $51,$2D,$BB,$A9,$4C,$7A,$87,$D7,$7F,$36,$A3,$13,$E4,$5B,$89,$A2,
    $3C,$A1,$38,$D3,$A3,$0D,$B7,$AA,$F7,$7C,$08,$0F,$2C,$34,$55,$BD,
    $A0,$75,$5D,$F2,$42,$9C,$2B,$45,$7A,$97,$7A,$E6,$0D,$85,$51,$86,
    $D7,$A5,$78,$4D,$E2,$57,$BB,$02,$B7,$2D,$AA,$BF,$D1,$29,$AB,$F5,
    $D6,$D5,$D3,$AC,$DA,$72,$49,$F8,$E8,$9B,$52,$4E,$5A,$51,$2D,$8E,
    $0F,$53,$3F,$59,$B5,$B3,$FC,$84,$3E,$8C,$27,$C2,$45,$DC,$6A,$B3,
    $7F,$8D,$AD,$C9,$AD,$CB,$6D,$F0,$D7,$35,$54,$E9,$EB,$F6,$56,$1B,
    $EA,$1A,$AA,$2D,$F4,$34,$DB,$9A,$6A,$12,$C5,$A9,$EA,$81,$9E,$1D,
    $4A,$A0,$1F,$C5,$AB,$61,$1D,$85,$A9,$5C,$B8,$CB,$3C,$5A,$F7,$59,
    $95,$55,$FA,$7A,$25,$66,$FC,$5A,$EF,$97,$52,$C8,$76,$62,$45,$42,
    $D6,$19,$EF,$C9,$C0,$8F,$B2,$4E,$DC,$B8,$99,$C0,$5A,$91,$D5,$EC,
    $6D,$0C,$5C,$86,$34,$08,$89,$34,$55,$22,$4D,$4A,$56,$EF,$E4,$95,
    $2D,$9C,$F5,$A4,$D4,$48,$18,$F2,$0B,$9F,$E1,$D0,$E2,$9A,$B7,$B2,
    $03,$AE,$63,$69,$F0,$D5,$47,$24,$32,$6B,$30,$3C,$8C,$49,$7E,$5D,
    $43,$56,$88,$5A,$7C,$69,$1A,$36,$3B,$8F,$56,$4A,$71,$63,$8A,$E9,
    $35,$7D,$9A,$A7,$DD,$24,$DF,$47,$E0,$CD,$5A,$1D,$47,$A9,$B3,$FB,
    $A6,$FE,$EC,$22,$4E,$DD,$1B,$49,$DD,$28,$EB,$E5,$19,$22,$75,$A1,
    $E7,$B4,$DE,$FD,$BB,$59,$61,$1F,$A0,$C2,$BD,$A0,$70,$C2,$28,$F9,
    $E5,$DF,$27,$50,$60,$3F,$15,$F1,$07,$9A,$DB,$E9,$1B,$E5,$41,$FF,
    $AC,$D6,$92,$4A,$4E,$E9,$6B,$47,$6B,$5C,$7A,$29,$5F,$EF,$67,$04,
    $BA,$92,$57,$ED,$74,$E9,$B5,$E6,$40,$9C,$D7,$1C,$F6,$E7,$77,$A0,
    $BA,$B7,$5C,$B2,$F7,$96,$A7,$6A,$74,$E5,$AA,$5B,$BF,$83,$97,$87,
    $39,$17,$7D,$E9,$29,$B7,$D9,$7B,$5D,$BA,$03,$8B,$7B,$0E,$2D,$36,
    $C8,$41,$3D,$86,$6B,$88,$5E,$DB,$86,$74,$51,$B2,$8F,$DA,$7F,$57,
    $91,$76,$C8,$1E,$6A,$8B,$0F,$52,$88,$A2,$3F,$3C,$80,$A8,$4B,$15,
    $7B,$28,$30,$18,$F1,$57,$C4,$C6,$DF,$A5,$53,$1C,$A1,$C8,$E0,$F8,
    $98,$BE,$C4,$56,$D0,$EB,$EF,$9C,$92,$8A,$6B,$3C,$68,$3C,$D1,$B8,
    $68,$32,$46,$59,$DF,$0D,$B6,$1D,$D5,$71,$52,$A3,$AD,$B5,$26,$4E,
    $6A,$02,$6D,$48,$AD,$B5,$4D,$AD,$B5,$47,$93,$2B,$06,$D4,$36,$9D,
    $AC,$3D,$9A,$50,$31,$B0,$B6,$E9,$DF,$78,$5E,$14,$B8,$EC,$0A,$9C,
    $0A,$F7,$C8,$39,$7E,$F5,$A5,$C0,$D3,$90,$1C,$7E,$BF,$0D,$EF,$F0,
    $F3,$DB,$EA,$A1,$CC,$89,$1E,$CA,$91,$10,$48,$F1,$34,$E4,$F8,$3D,
    $72,$B2,$A7,$A1,$C0,$BF,$31,$C7,$1F,$F1,$E3,$2B,$7D,$A9,$BA,$3A,
    $C4,$3D,$26,$EC,$51,$34,$9B,$C0,$D5,$F9,$EB,$CD,$AB,$F6,$BA,$2E,
    $81,$42,$43,$DD,$44,$1C,$C9,$50,$28,$9D,$D6,$29,$93,$03,$FD,$F8,
    $19,$48,$9C,$58,$02,$A7,$A2,$07,$6C,$27,$08,$E6,$13,$75,$C7,$57,
    $C4,$FF,$43,$1C,$8D,$C2,$15,$04,$7E,$74,$BC,$3D,$44,$FD,$1E,$F4,
    $BA,$BB,$E1,$82,$A6,$3A,$1E,$07,$80,$BB,$25,$77,$77,$DD,$F1,$9A,
    $C1,$6F,$A8,$49,$E5,$83,$D4,$9F,$CD,$C4,$B6,$72,$68,$90,$7E,$81,
    $14,$A1,$5C,$F6,$10,$A9,$91,$83,$03,$C1,$D8,$28,$7D,$71,$D6,$B1,
    $15,$CE,$1B,$EB,$14,$D2,$08,$B0,$14,$1B,$22,$C2,$31,$83,$CC,$B0,
    $A1,$AE,$14,$65,$FC,$86,$CA,$98,$B5,$7A,$5A,$9A,$F2,$26,$8F,$8B,
    $2B,$A2,$C9,$40,$5F,$F0,$11,$CB,$C9,$EE,$08,$27,$CB,$55,$A8,$DF,
    $26,$16,$BB,$37,$DC,$1A,$F5,$35,$7D,$13,$BB,$68,$F2,$13,$E8,$4B,
    $FB,$93,$C2,$6C,$C3,$EC,$ED,$DF,$DA,$7D,$05,$31,$B6,$5B,$29,$22,
    $30,$5D,$D2,$C9,$B7,$0C,$14,$F7,$B7,$D4,$8C,$17,$2D,$D5,$D5,$17,
    $E5,$28,$79,$39,$15,$09,$52,$4A,$DE,$B5,$CB,$72,$28,$3C,$2D,$47,
    $A9,$3D,$55,$50,$91,$28,$E9,$6A,$4F,$15,$2F,$1B,$4A,$8F,$AA,$1C,
    $E5,$B6,$8A,$24,$F1,$52,$BE,$0C,$3E,$00,$65,$0B,$5A,$9C,$A3,$E4,
    $14,$4F,$76,$6F,$03,$B9,$6B,$A2,$7E,$E1,$E0,$23,$8E,$FD,$22,$86,
    $FF,$53,$2F,$57,$51,$EF,$6B,$C8,$F9,$61,$41,$C4,$4D,$22,$8D,$2A,
    $E6,$37,$B8,$27,$A3,$59,$B6,$F1,$D9,$C3,$90,$FC,$C6,$00,$46,$9A,
    $BD,$5B,$7E,$79,$00,$F3,$F2,$64,$BC,$FF,$51,$8D,$0D,$C9,$6B,$F1,
    $B6,$2F,$AB,$D5,$E7,$08,$6E,$CC,$91,$EF,$4E,$85,$82,$C0,$37,$9F,
    $38,$42,$F2,$2E,$7C,$A3,$D4,$77,$45,$D2,$74,$51,$1A,$27,$A7,$E9,
    $F2,$51,$D7,$39,$BA,$E5,$E7,$39,$4D,$0F,$4D,$0F,$1F,$5B,$98,$23,
    $D0,$3B,$C9,$42,$88,$0D,$79,$14,$6D,$D5,$78,$AA,$A4,$9E,$F8,$81,
    $3C,$F6,$0C,$BB,$A3,$B5,$77,$73,$68,$14,$85,$74,$50,$7B,$FD,$BA,
    $A0,$A7,$D7,$6C,$7A,$DA,$BF,$EA,$90,$4B,$E7,$F9,$1C,$4E,$63,$67,
    $9C,$E1,$FE,$E9,$91,$DF,$1D,$C8,$FD,$33,$5A,$99,$4C,$7D,$FD,$3A,
    $25,$18,$80,$0B,$65,$30,$9D,$6C,$2D,$A1,$86,$CB,$59,$03,$62,$26,
    $A4,$6B,$28,$06,$57,$3C,$B1,$8F,$4A,$9F,$09,$93,$CD,$E9,$A4,$98,
    $CB,$71,$FA,$FA,$DA,$23,$B9,$8C,$68,$B9,$BF,$6C,$19,$A5,$28,$57,
    $80,$FF,$FD,$F6,$C4,$69,$A9,$69,$B6,$7F,$FD,$AA,$17,$49,$10,$1F,
    $AD,$71,$5F,$22,$BF,$4C,$19,$22,$C1,$14,$7E,$53,$3D,$D8,$F8,$E5,
    $3F,$69,$21,$B1,$9D,$73,$3F,$93,$74,$52,$5C,$DE,$87,$AE,$F9,$7D,
    $66,$B8,$6B,$A4,$16,$F9,$40,$3F,$E1,$72,$D5,$F4,$20,$44,$09,$A9,
    $45,$72,$F6,$C8,$2F,$53,$EB,$D4,$01,$D2,$B3,$05,$AB,$98,$BF,$3D,
    $71,$52,$5C,$24,$31,$A9,$B0,$DE,$79,$7A,$33,$24,$07,$79,$1A,$9F,
    $A2,$EF,$F6,$E1,$B2,$2B,$7B,$37,$27,$13,$2D,$9C,$0C,$B5,$AA,$45,
    $DE,$30,$00,$0C,$34,$87,$D8,$AD,$3D,$28,$43,$26,$E3,$24,$B3,$E4,
    $55,$BD,$BD,$8A,$A7,$39,$71,$A2,$FB,$6F,$B1,$A5,$1F,$24,$A9,$60,
    $6C,$A4,$6C,$F6,$95,$7C,$BE,$B2,$8F,$9D,$E6,$B2,$4B,$63,$CB,$2E,
    $44,$8F,$EE,$9A,$25,$67,$51,$C1,$11,$9C,$3F,$97,$09,$9C,$07,$E5,
    $53,$A9,$40,$F7,$03,$86,$BE,$F7,$A6,$95,$49,$3B,$A4,$C6,$2B,$48,
    $24,$AA,$BD,$3B,$BE,$C4,$B3,$A3,$27,$9F,$58,$46,$BA,$D4,$F8,$C6,
    $3C,$86,$E6,$74,$DD,$5E,$F7,$00,$A9,$71,$0B,$B4,$04,$82,$8D,$26,
    $7F,$7D,$6E,$C3,$6C,$FF,$46,$ED,$EC,$E8,$5D,$26,$B9,$0D,$24,$AD,
    $54,$0D,$F5,$9C,$36,$AE,$B8,$98,$08,$E3,$2F,$0A,$3B,$5A,$F5,$E9,
    $F3,$7D,$FA,$B7,$D6,$3D,$0F,$57,$D2,$45,$33,$7A,$C3,$3E,$A2,$D9,
    $41,$26,$4D,$F9,$07,$7D,$E9,$B3,$7D,$E9,$1F,$88,$EF,$37,$4F,$EC,
    $B5,$F9,$AB,$13,$48,$22,$28,$0E,$4C,$7B,$D3,$78,$BE,$14,$F7,$50,
    $8A,$AA,$04,$E9,$04,$A5,$F8,$B1,$6F,$94,$69,$4F,$EF,$DD,$3A,$CF,
    $7B,$E7,$26,$AB,$44,$41,$7A,$A9,$37,$10,$27,$BD,$23,$7D,$94,$75,
    $60,$E2,$8A,$BD,$C8,$23,$5C,$7C,$87,$EF,$C5,$C1,$9D,$47,$1F,$10,
    $92,$B5,$13,$25,$7F,$B8,$65,$0B,$77,$BC,$3C,$26,$8E,$88,$66,$4A,
    $38,$62,$A6,$D4,$34,$65,$8B,$40,$C2,$C9,$99,$0B,$1B,$36,$3C,$48,
    $72,$E3,$0E,$7C,$0F,$C7,$D5,$ED,$25,$10,$9A,$74,$8D,$A7,$E2,$16,
    $36,$FD,$2D,$1E,$5F,$57,$7E,$22,$D0,$38,$D1,$B3,$AB,$A7,$70,$A1,
    $7F,$B1,$96,$B3,$1C,$A0,$01,$56,$63,$94,$5A,$4A,$A4,$7F,$C9,$BB,
    $A8,$33,$75,$6D,$C4,$49,$75,$37,$EA,$3E,$94,$FC,$E1,$BB,$1D,$22,
    $77,$AF,$79,$1D,$21,$AF,$B3,$07,$DE,$96,$B7,$00,$1C,$AA,$C6,$6B,
    $0F,$46,$03,$C4,$EC,$FC,$5B,$00,$09,$DE,$43,$31,$EF,$07,$3D,$8A,
    $BE,$2A,$F9,$4D,$08,$B6,$6F,$20,$8E,$3E,$01,$24,$CE,$DF,$15,$0D,
    $70,$FE,$C5,$A2,$7D,$60,$9B,$91,$F7,$83,$9E,$5E,$CA,$FF,$0F,$CE,
    $8F,$B8,$85,$F6,$20,$D0,$F0,$CB,$F7,$E7,$E9,$9A,$88,$8B,$34,$1E,
    $89,$D3,$35,$E9,$9A,$B7,$F4,$E2,$18,$CA,$5E,$39,$F5,$A4,$A2,$E4,
    $B3,$70,$55,$EE,$CD,$A1,$1E,$DF,$42,$AC,$60,$B5,$FD,$44,$BD,$F3,
    $04,$0D,$BA,$B4,$5E,$C1,$41,$42,$F4,$CD,$D3,$AB,$AD,$19,$4C,$EC,
    $C3,$7E,$A2,$0F,$35,$2C,$ED,$C9,$6A,$2B,$C4,$D4,$EA,$4D,$8B,$B0,
    $72,$F8,$EC,$22,$19,$6A,$28,$6C,$A9,$87,$8A,$D8,$1C,$6D,$A4,$A7,
    $B1,$ED,$27,$B5,$59,$05,$9A,$0F,$1B,$3F,$48,$B7,$AE,$0D,$A4,$7F,
    $C3,$D7,$4E,$7C,$FD,$40,$6F,$85,$BF,$97,$DA,$5D,$CF,$4E,$8A,$E0,
    $93,$C8,$93,$66,$74,$6F,$22,$AE,$77,$F8,$C0,$6E,$38,$54,$1D,$5C,
    $7B,$68,$71,$B0,$6D,$88,$25,$5B,$08,$07,$66,$0A,$1D,$1A,$91,$46,
    $21,$96,$00,$2A,$F5,$B9,$87,$02,$71,$AF,$6A,$89,$89,$15,$D0,$17,
    $79,$5D,$4F,$2F,$8D,$BD,$AE,$43,$F4,$FF,$E2,$E0,$87,$1F,$23,$BB,
    $37,$11,$05,$A4,$5A,$B3,$71,$CA,$BB,$FB,$50,$9E,$75,$AD,$3C,$F5,
    $84,$A2,$FC,$36,$B7,$29,$AB,$69,$8B,$32,$FB,$CA,$78,$C2,$CF,$67,
    $B8,$00,$23,$21,$E2,$C6,$1E,$92,$98,$E6,$5D,$FC,$81,$A5,$7F,$08,
    $A9,$35,$80,$11,$3E,$DB,$B7,$87,$A4,$36,$D3,$EB,$85,$86,$5F,$36,
    $E4,$99,$5E,$2F,$4B,$D6,$35,$89,$17,$A3,$AE,$69,$61,$10,$F7,$72,
    $D2,$B7,$7E,$BA,$60,$B9,$64,$2B,$27,$D6,$3A,$A4,$DC,$73,$4F,$9C,
    $C6,$3D,$98,$1E,$09,$1A,$B7,$49,$7A,$8F,$54,$C3,$16,$2A,$91,$31,
    $33,$D1,$F4,$FA,$BB,$94,$33,$8E,$72,$24,$C8,$83,$A8,$3F,$46,$CC,
    $7A,$2C,$59,$83,$B1,$7C,$25,$51,$5B,$7F,$4E,$FC,$24,$25,$3E,$D0,
    $2E,$10,$D9,$A2,$B7,$AE,$6B,$0A,$F4,$B6,$90,$40,$37,$B1,$64,$D3,
    $B5,$81,$14,$9A,$41,$7F,$A5,$16,$46,$88,$9C,$39,$2B,$2C,$47,$43,
    $17,$02,$3D,$E6,$EE,$DC,$8A,$0B,$40,$E4,$9F,$E0,$66,$4C,$B7,$51,
    $71,$1B,$68,$2E,$83,$5F,$DF,$35,$EC,$65,$DA,$B4,$0A,$FE,$8F,$56,
    $56,$F7,$3C,$77,$FB,$D7,$2B,$4C,$0F,$BD,$29,$02,$CF,$DF,$FE,$B5,
    $62,$7A,$E0,$15,$C1,$3D,$E3,$01,$51,$89,$B8,$34,$35,$3F,$CC,$EC,
    $CA,$BD,$65,$7A,$EA,$98,$B6,$21,$AD,$23,$44,$8F,$5C,$C6,$A1,$FD,
    $22,$54,$39,$B0,$BC,$85,$D0,$50,$DE,$52,$18,$C7,$7F,$13,$48,$4C,
    $30,$95,$F9,$26,$C6,$F9,$CA,$12,$30,$F5,$6C,$EF,$E1,$E9,$73,$0B,
    $70,$25,$0A,$EB,$17,$13,$14,$F7,$24,$F2,$89,$50,$F1,$D1,$18,$13,
    $3C,$E7,$63,$72,$9F,$60,$A1,$01,$CA,$8F,$E8,$3A,$FC,$AB,$BD,$21,
    $7C,$37,$9D,$70,$20,$4C,$E8,$60,$01,$FB,$CA,$D3,$BD,$CA,$74,$15,
    $1F,$76,$99,$C7,$37,$3D,$4B,$E5,$AB,$AE,$E6,$9B,$D9,$86,$10,$25,
    $5D,$0C,$5D,$71,$BA,$BC,$79,$04,$C7,$A4,$50,$35,$5E,$00,$EF,$2D,
    $D6,$87,$C9,$03,$E7,$59,$DB,$55,$D7,$E3,$44,$E1,$FA,$55,$7B,$A9,
    $7B,$75,$BC,$AA,$50,$C8,$DB,$AE,$03,$E9,$3E,$EC,$9B,$2B,$93,$CB,
    $B2,$59,$C9,$4C,$ED,$F3,$95,$BE,$99,$21,$9A,$1B,$4B,$65,$1B,$7F,
    $77,$A5,$22,$4A,$7E,$F2,$4C,$A4,$3F,$3D,$DB,$F9,$7E,$9F,$DC,$9D,
    $F4,$B1,$7F,$20,$B1,$36,$CF,$A0,$71,$25,$15,$D8,$F6,$AC,$F8,$BA,
    $6E,$6F,$D5,$97,$52,$A3,$B8,$63,$83,$45,$29,$31,$B9,$6C,$35,$B2,
    $27,$E7,$63,$29,$44,$C9,$39,$91,$FB,$4F,$D8,$9F,$27,$0D,$F8,$8D,
    $A4,$A2,$11,$FF,$1C,$56,$A7,$B8,$2E,$65,$A5,$53,$32,$B2,$67,$F5,
    $ED,$29,$F0,$AC,$4E,$13,$E7,$2E,$F9,$4F,$27,$7A,$CF,$BA,$FB,$82,
    $8A,$5B,$9E,$C8,$57,$4B,$8F,$A1,$7C,$3F,$C5,$35,$73,$F2,$2F,$15,
    $CE,$E0,$97,$27,$18,$D9,$AF,$F7,$AB,$49,$80,$BF,$E6,$62,$7A,$7D,
    $21,$09,$F2,$85,$5F,$5E,$2A,$CA,$6C,$9E,$29,$4F,$57,$8B,$E4,$BB,
    $88,$E8,$CB,$7D,$22,$71,$12,$EE,$84,$4B,$C1,$4C,$8F,$99,$69,$8D,
    $DA,$43,$7E,$F9,$17,$49,$22,$A3,$FC,$79,$0A,$B7,$E5,$26,$91,$3C,
    $97,$5E,$27,$71,$D9,$CD,$B2,$25,$45,$D4,$A1,$A1,$E7,$AC,$99,$F2,
    $D7,$C7,$7B,$A1,$9A,$5F,$AD,$7E,$3D,$9E,$4C,$B1,$72,$FA,$97,$C2,
    $2F,$7E,$E4,$6E,$C2,$98,$E5,$95,$6E,$70,$57,$BB,$D1,$6B,$97,$21,
    $4B,$2C,$1B,$19,$91,$25,$48,$FF,$AB,$36,$D4,$E8,$A4,$6A,$03,$CD,
    $3E,$A4,$E5,$2E,$2C,$86,$CC,$D5,$55,$9B,$97,$86,$F5,$5E,$BB,$CC,
    $2F,$24,$3D,$75,$D9,$EC,$DD,$EE,$8B,$25,$BB,$59,$5E,$FC,$35,$B3,
    $1A,$62,$B6,$B8,$DB,$CF,$61,$96,$17,$00,$18,$BB,$6C,$B3,$1B,$91,
    $C0,$20,$4F,$E2,$04,$F0,$03,$C1,$7E,$5E,$0D,$F2,$38,$4E,$D0,$D5,
    $AC,$4F,$CB,$A0,$74,$78,$90,$2C,$FE,$A4,$F4,$91,$E4,$36,$DF,$98,
    $75,$AC,$EA,$A7,$C5,$E1,$0A,$33,$63,$EB,$89,$3F,$BB,$1E,$4D,$B4,
    $18,$CA,$BF,$0B,$F9,$0D,$E1,$FC,$72,$38,$7F,$14,$8C,$B7,$BA,$CF,
    $02,$A3,$E1,$6B,$86,$33,$92,$9F,$BD,$73,$C8,$A5,$EC,$15,$C4,$DE,
    $55,$0A,$EB,$03,$5B,$16,$F2,$87,$B3,$73,$87,$88,$54,$52,$3D,$B2,
    $80,$2F,$64,$5D,$12,$C5,$1A,$83,$49,$23,$C4,$69,$C6,$B5,$8B,$95,
    $DD,$31,$32,$8C,$7B,$24,$0C,$19,$00,$03,$DF,$0D,$B8,$D8,$B1,$8C,
    $BE,$FB,$3B,$FF,$AE,$F4,$2A,$81,$4F,$FD,$9D,$7F,$C3,$F3,$25,$C9,
    $AE,$4A,$36,$A4,$9E,$45,$E4,$13,$F8,$F2,$4E,$14,$5D,$7A,$91,$DA,
    $B5,$13,$13,$45,$C7,$27,$82,$46,$76,$C4,$18,$12,$06,$E3,$3C,$BE,
    $1C,$27,$EE,$9F,$08,$5F,$CD,$33,$C7,$B0,$0A,$03,$17,$5A,$46,$72,
    $3C,$5B,$0D,$FC,$D2,$FB,$B2,$A2,$17,$EE,$B5,$69,$F2,$A2,$CF,$3A,
    $D2,$FC,$D4,$71,$84,$71,$72,$0A,$B6,$1D,$DC,$B6,$41,$09,$DF,$D3,
    $73,$1E,$8C,$93,$5D,$22,$4F,$CC,$9D,$11,$D0,$E2,$7A,$F8,$06,$16,
    $4E,$DF,$42,$75,$3C,$87,$F4,$19,$75,$C7,$39,$B8,$4F,$7E,$1C,$C1,
    $FE,$65,$8A,$BB,$67,$7A,$F8,$52,$E1,$49,$89,$5C,$CC,$4C,$55,$07,
    $62,$A7,$E6,$B0,$94,$50,$CB,$EE,$84,$C6,$DD,$BA,$E7,$14,$C9,$26,
    $7B,$35,$13,$68,$74,$0F,$1A,$9B,$DB,$E0,$CB,$D3,$8C,$49,$BF,$BE,
    $22,$61,$CC,$CD,$D7,$6B,$97,$65,$E5,$4F,$70,$7F,$4E,$29,$C7,$51,
    $4A,$AC,$A5,$0B,$B9,$AF,$37,$BF,$84,$D8,$4A,$B3,$3C,$92,$62,$C7,
    $DC,$9C,$A0,$B8,$F4,$B0,$D1,$D4,$47,$EF,$0D,$0B,$DF,$71,$41,$D0,
    $06,$59,$0D,$24,$65,$7D,$68,$A0,$3F,$C9,$C8,$F5,$45,$43,$15,$D9,
    $AD,$B0,$47,$7E,$63,$21,$EC,$05,$F1,$D0,$61,$6A,$3A,$E8,$F5,$48,
    $3C,$54,$8C,$DA,$6A,$A3,$C6,$75,$B1,$ED,$A3,$15,$83,$EA,$8B,$AE,
    $C7,$55,$75,$72,$B1,$48,$1E,$3F,$D9,$F6,$51,$0D,$8C,$5D,$EE,$8B,
    $28,$F1,$DF,$90,$2F,$C4,$4E,$6A,$08,$0D,$BF,$D7,$51,$BB,$07,$30,
    $3D,$BD,$9B,$B5,$AB,$40,$DA,$47,$29,$D6,$46,$1A,$6E,$88,$F6,$EF,
    $ED,$DA,$E9,$2F,$6B,$B7,$AE,$C9,$2D,$80,$CC,$EF,$54,$78,$B8,$0A,
    $3D,$02,$1B,$16,$61,$B8,$52,$D3,$69,$90,$6E,$B3,$48,$37,$E2,$FC,
    $E9,$6E,$62,$4E,$05,$91,$AD,$CA,$44,$F5,$5D,$CE,$10,$AD,$D0,$D7,
    $DF,$4C,$60,$FB,$23,$FC,$4C,$F4,$AF,$52,$1D,$97,$AB,$70,$0F,$3F,
    $90,$C8,$36,$BD,$AF,$F5,$CC,$61,$A0,$1D,$6D,$45,$37,$EC,$A2,$4F,
    $18,$6F,$D1,$B9,$34,$46,$C6,$E3,$6B,$49,$E0,$F8,$14,$6D,$7D,$35,
    $4E,$51,$3A,$D7,$13,$56,$71,$C1,$6E,$AE,$22,$D4,$EC,$66,$F9,$59,
    $BD,$AA,$63,$AD,$A5,$97,$59,$59,$AD,$63,$79,$11,$92,$86,$6F,$E0,
    $E7,$B6,$39,$C1,$15,$37,$D7,$DB,$2D,$FC,$B9,$2A,$9C,$EE,$1A,$EE,
    $7D,$1F,$75,$C8,$4C,$F9,$44,$17,$A3,$F8,$1A,$E8,$8F,$B3,$29,$81,
    $8E,$6F,$12,$98,$82,$B7,$36,$5C,$BB,$AB,$D8,$BB,$3C,$D5,$66,$4D,
    $4D,$1A,$8F,$3B,$73,$15,$C0,$CE,$A5,$AF,$59,$FE,$7C,$5D,$28,$90,
    $5A,$38,$0E,$ED,$D7,$73,$4F,$3E,$52,$5B,$7D,$22,$02,$6B,$22,$60,
    $FD,$5A,$35,$19,$BC,$2F,$AF,$A1,$2A,$59,$81,$67,$A0,$19,$3A,$BE,
    $03,$81,$00,$34,$3D,$B4,$8E,$5E,$C2,$40,$BE,$AF,$53,$81,$7C,$24,
    $3E,$0A,$E4,$54,$01,$E4,$3D,$00,$F2,$35,$1D,$A3,$EF,$0A,$B0,$99,
    $5F,$C5,$AB,$06,$2A,$7C,$78,$5A,$E4,$0C,$C9,$33,$E2,$E1,$6C,$57,
    $76,$7C,$D9,$CB,$5A,$73,$9D,$2E,$DC,$AA,$7B,$F0,$D6,$16,$6E,$D1,
    $0D,$6A,$8B,$AE,$41,$49,$39,$91,$92,$9A,$E5,$69,$3A,$0C,$77,$22,
    $26,$54,$3E,$4B,$1E,$11,$20,$0A,$BB,$0C,$89,$52,$28,$51,$FD,$B4,
    $A1,$0A,$D4,$58,$6E,$F8,$55,$3A,$34,$DC,$F4,$20,$FC,$FB,$C3,$C7,
    $10,$D8,$BC,$3C,$F3,$33,$A6,$3E,$B0,$17,$73,$F4,$FE,$C1,$D5,$0E,
    $85,$2F,$DE,$26,$6C,$EC,$93,$8F,$6A,$14,$D5,$0E,$22,$C7,$B1,$DE,
    $46,$1A,$DA,$87,$71,$B0,$B0,$76,$93,$4E,$DF,$22,$EF,$55,$63,$D9,
    $9C,$92,$C5,$28,$AB,$AD,$1A,$A6,$5C,$65,$5A,$F5,$77,$F5,$F5,$06,
    $17,$EE,$80,$96,$EF,$D6,$03,$A2,$61,$0A,$0C,$1F,$C4,$57,$0F,$F2,
    $A2,$5B,$B7,$FC,$03,$02,$14,$97,$26,$99,$56,$F9,$58,$45,$95,$57,
    $C6,$09,$1B,$01,$AA,$74,$C7,$71,$6F,$2D,$E3,$89,$29,$24,$CD,$E9,
    $2E,$A4,$04,$73,$91,$20,$48,$0C,$DD,$52,$5C,$5F,$34,$4C,$C9,$BB,
    $C1,$95,$98,$77,$95,$4B,$A7,$D8,$43,$54,$EC,$67,$5C,$6C,$88,$F9,
    $52,$9F,$5C,$57,$85,$73,$0D,$2F,$16,$40,$0D,$61,$30,$5D,$83,$15,
    $C8,$4D,$06,$F9,$20,$30,$E9,$0C,$D5,$4F,$22,$08,$27,$99,$01,$61,
    $5B,$44,$94,$57,$F7,$EB,$87,$D4,$BB,$19,$43,$61,$33,$C8,$C3,$D7,
    $84,$39,$7D,$B3,$5D,$61,$0B,$BA,$B8,$64,$4B,$7E,$B9,$97,$C5,$38,
    $42,$9F,$9F,$AA,$75,$8F,$96,$DE,$DB,$BC,$81,$D2,$CA,$9F,$E9,$84,
    $19,$52,$7E,$8A,$14,$79,$E9,$FD,$09,$B6,$A6,$AA,$74,$12,$84,$2D,
    $14,$53,$AF,$E5,$66,$37,$CB,$2B,$B5,$68,$B3,$5B,$4F,$45,$46,$2F,
    $92,$7E,$E2,$9A,$02,$BE,$BB,$C2,$A0,$60,$8A,$78,$F2,$24,$4D,$0D,
    $C1,$7A,$BB,$A2,$5E,$D8,$13,$B5,$31,$5C,$25,$EC,$36,$B9,$3B,$A7,
    $88,$7F,$EA,$F8,$07,$B0,$A5,$D7,$86,$81,$CD,$3D,$04,$23,$CA,$FB,
    $72,$19,$15,$06,$93,$0B,$F5,$42,$09,$BD,$AE,$9B,$4B,$29,$4A,$C5,
    $5A,$40,$57,$E9,$96,$45,$14,$DA,$BA,$FC,$5A,$CC,$52,$DD,$B2,$99,
    $57,$53,$61,$7C,$91,$87,$28,$4C,$AB,$C8,$F5,$6F,$02,$D5,$FD,$77,
    $D2,$C4,$69,$10,$25,$20,$DA,$D9,$BD,$19,$D9,$E4,$78,$9D,$30,$50,
    $B9,$70,$AF,$AF,$FC,$92,$06,$3C,$A7,$2A,$8D,$EF,$A5,$0C,$CA,$1B,
    $55,$F9,$FA,$00,$C1,$DA,$B9,$97,$FE,$40,$BE,$94,$DE,$1D,$2F,$DC,
    $98,$50,$82,$FB,$D1,$55,$98,$91,$BB,$E5,$55,$6A,$DA,$17,$39,$59,
    $B0,$14,$9F,$E7,$6A,$98,$E6,$DF,$2D,$20,$81,$8B,$82,$33,$E3,$84,
    $B5,$68,$BC,$A8,$45,$3B,$19,$37,$74,$21,$62,$B4,$9A,$CE,$77,$93,
    $16,$C1,$91,$71,$B0,$85,$04,$35,$EE,$FE,$2A,$1C,$99,$E2,$36,$19,
    $67,$60,$0A,$C6,$78,$0F,$A2,$E2,$91,$25,$48,$84,$3C,$9A,$19,$80,
    $CF,$DE,$C1,$35,$7E,$8E,$B6,$45,$6B,$FC,$0F,$BA,$CA,$DE,$01,$F8,
    $84,$AE,$E0,$8A,$F7,$56,$F7,$04,$F4,$E3,$6E,$74,$FF,$13,$3C,$B0,
    $86,$14,$AE,$48,$CF,$DD,$74,$2D,$7A,$AE,$63,$2B,$36,$A7,$CB,$8B,
    $CF,$A0,$FB,$0E,$91,$D8,$17,$08,$84,$B5,$29,$98,$DD,$FA,$F4,$5F,
    $98,$7F,$5F,$75,$15,$F7,$E5,$CA,$ED,$41,$AA,$44,$98,$7A,$9E,$C6,
    $AB,$77,$4E,$C8,$3B,$A7,$5B,$5C,$75,$DC,$26,$61,$41,$CD,$B9,$60,
    $D7,$98,$70,$E7,$D2,$A4,$6B,$44,$A7,$BE,$2F,$BB,$A8,$B2,$80,$95,
    $C8,$8B,$C3,$FB,$E4,$79,$08,$5B,$CA,$16,$74,$50,$DA,$9B,$28,$4A,
    $CC,$BC,$7B,$99,$08,$BA,$E5,$BF,$92,$1A,$44,$92,$6C,$21,$66,$36,
    $F7,$10,$DF,$63,$DD,$7C,$FF,$8F,$FC,$D2,$17,$F4,$99,$03,$48,$F4,
    $62,$2F,$15,$91,$E1,$7B,$2C,$28,$3E,$DE,$82,$CB,$A0,$38,$00,$43,
    $4E,$90,$CA,$95,$4D,$54,$1C,$AC,$AC,$EE,$54,$D0,$18,$CD,$8B,$9F,
    $53,$B9,$81,$A1,$7C,$63,$55,$1A,$CD,$F8,$0B,$7A,$28,$95,$E2,$EE,
    $A6,$AF,$A2,$FE,$A9,$9C,$21,$44,$19,$54,$86,$70,$37,$32,$E4,$88,
    $32,$D4,$C1,$5C,$8E,$A8,$21,$8A,$3B,$B4,$C0,$60,$E3,$DC,$0B,$2C,
    $36,$D0,$A5,$41,$88,$F6,$A8,$33,$82,$EF,$BD,$63,$E0,$38,$0B,$30,
    $C9,$87,$4E,$73,$D3,$C4,$BD,$D5,$5F,$9D,$06,$EA,$E7,$92,$6C,$18,
    $68,$8F,$48,$54,$11,$5C,$8F,$C9,$88,$F6,$C1,$82,$98,$3E,$C8,$CE,
    $88,$BE,$67,$64,$46,$D3,$0C,$17,$E3,$6C,$4A,$C4,$2C,$0A,$1E,$92,
    $7B,$88,$9B,$79,$35,$B1,$FC,$AB,$3C,$37,$68,$5C,$57,$78,$AE,$D7,
    $D4,$64,$48,$6D,$B6,$A1,$35,$71,$D2,$50,$52,$2F,$D8,$25,$79,$22,
    $E9,$12,$73,$02,$44,$50,$89,$3A,$BF,$37,$71,$F8,$50,$A6,$83,$99,
    $91,$BB,$E1,$48,$F6,$E1,$CB,$13,$6F,$D7,$B3,$D7,$75,$70,$93,$5F,
    $C3,$FE,$14,$D2,$57,$EB,$BC,$79,$D8,$8B,$38,$2B,$D6,$C6,$12,$8A,
    $1A,$66,$49,$E2,$F2,$D8,$34,$AE,$78,$CF,$F5,$FA,$EA,$8B,$85,$AD,
    $6F,$04,$35,$FA,$15,$2D,$A4,$E4,$61,$FF,$A6,$39,$EE,$69,$D0,$B4,
    $33,$24,$E9,$C4,$AD,$46,$EF,$1F,$15,$A8,$AF,$4A,$96,$12,$3C,$B2,
    $DE,$66,$0F,$55,$0F,$16,$F9,$BE,$3E,$15,$CE,$F7,$9F,$4F,$69,$46,
    $59,$C0,$E2,$8E,$95,$84,$35,$CE,$77,$07,$86,$43,$8B,$FC,$02,$11,
    $03,$CD,$7A,$A4,$64,$72,$AC,$97,$4A,$0B,$5C,$89,$FC,$21,$D9,$A1,
    $76,$6A,$0D,$95,$27,$D7,$72,$3A,$49,$E7,$69,$D0,$C3,$BA,$7B,$DB,
    $51,$E6,$1F,$08,$0D,$D4,$B5,$7A,$07,$0E,$4F,$80,$DF,$46,$B3,$5C,
    $FD,$A9,$A2,$F2,$33,$EA,$18,$6E,$5B,$87,$6A,$DF,$94,$57,$3B,$4E,
    $B3,$80,$41,$38,$26,$75,$4F,$8F,$03,$7D,$20,$FA,$3D,$D7,$47,$05,
    $6D,$B3,$67,$B4,$B6,$3A,$89,$9E,$AA,$AD,$94,$38,$FA,$61,$E2,$92,
    $90,$FF,$7A,$C0,$98,$CC,$B6,$B8,$6A,$DC,$27,$51,$3B,$5A,$E3,$4E,
    $26,$49,$34,$B9,$B6,$DA,$02,$1F,$EE,$0D,$81,$B8,$8D,$DA,$D5,$F6,
    $53,$B5,$D5,$A7,$70,$97,$9C,$DD,$D8,$AC,$D1,$76,$BE,$85,$AD,$A6,
    $87,$E0,$42,$4F,$03,$6B,$15,$C9,$7F,$A7,$59,$C7,$10,$0B,$07,$D5,
    $66,$E9,$06,$8A,$3B,$40,$71,$B6,$50,$8D,$8D,$5E,$DF,$A1,$D7,$7C,
    $AA,$C3,$1B,$27,$0A,$58,$75,$C8,$54,$C7,$AE,$78,$21,$EA,$D1,$18,
    $3A,$CD,$EC,$C3,$11,$2C,$C0,$C6,$9D,$66,$F9,$79,$1A,$88,$9D,$B7,
    $D1,$77,$C8,$8E,$63,$EC,$A7,$4D,$75,$30,$8C,$AE,$3A,$E4,$BE,$84,
    $AA,$B4,$8D,$76,$25,$30,$6C,$A9,$AF,$6A,$C7,$71,$85,$DE,$EA,$60,
    $E0,$21,$2A,$72,$55,$A3,$90,$A1,$E6,$72,$C5,$D5,$95,$F5,$FA,$EB,
    $29,$B3,$3B,$C5,$D3,$12,$A7,$D8,$BB,$3B,$79,$9F,$3A,$C9,$AE,$FA,
    $EB,$E5,$AD,$DD,$CC,$95,$06,$4A,$2D,$25,$04,$35,$7D,$A7,$72,$BD,
    $A3,$3B,$EB,$31,$21,$A3,$E8,$7B,$22,$1F,$02,$C9,$2A,$0C,$2E,$23,
    $84,$84,$78,$D1,$A6,$00,$A7,$A7,$30,$E8,$80,$C2,$D3,$44,$B3,$02,
    $93,$44,$BE,$71,$E2,$B3,$88,$1B,$CD,$F2,$F2,$F5,$8A,$6C,$17,$95,
    $0E,$A3,$76,$5C,$AA,$CA,$B8,$D8,$68,$84,$06,$BF,$46,$5D,$20,$32,
    $05,$16,$8F,$03,$AC,$7F,$17,$56,$05,$9E,$FF,$CF,$F4,$B2,$47,$D6,
    $6E,$42,$78,$35,$B6,$35,$65,$B5,$54,$5D,$97,$EF,$B5,$77,$84,$01,
    $D3,$C3,$42,$5F,$7B,$4C,$AB,$86,$DD,$08,$D3,$A4,$DD,$0D,$EB,$C4,
    $15,$DC,$B7,$DD,$F5,$93,$AE,$E7,$49,$7B,$9C,$E2,$E8,$70,$B7,$30,
    $D3,$90,$E5,$91,$A1,$18,$AE,$D0,$76,$3D,$B8,$B0,$2C,$EF,$38,$01,
    $2E,$30,$EB,$2B,$31,$7F,$9E,$8A,$C8,$3E,$91,$7B,$E4,$74,$A7,$7A,
    $85,$FE,$5E,$8F,$A2,$75,$F2,$31,$22,$22,$1A,$CF,$A3,$E8,$55,$A6,
    $57,$A8,$58,$1B,$09,$49,$B9,$3B,$67,$C9,$3D,$9D,$9C,$62,$8F,$1A,
    $FD,$DB,$D3,$BD,$2C,$92,$D5,$E1,$29,$4F,$1C,$22,$EE,$4C,$8C,$DC,
    $EB,$D1,$FC,$59,$6F,$F4,$5E,$0F,$6F,$17,$37,$BA,$58,$8F,$3F,$38,
    $AD,$52,$6C,$E4,$BB,$93,$7D,$C5,$16,$F9,$0A,$02,$11,$37,$72,$0C,
    $39,$21,$D2,$E0,$0E,$E6,$72,$6F,$71,$26,$DE,$73,$BC,$C5,$A3,$E8,
    $7D,$B4,$AF,$38,$4F,$3E,$73,$1C,$E9,$F2,$59,$C7,$C7,$B7,$22,$FC,
    $29,$C1,$9F,$49,$F8,$53,$DA,$5C,$3C,$0D,$C2,$6B,$F1,$0C,$FC,$B9,
    $19,$7F,$E6,$E2,$CF,$3C,$5F,$F1,$02,$B9,$91,$F3,$2E,$92,$B7,$F0,
    $73,$A9,$FC,$32,$3F,$5D,$F2,$9F,$D4,$B2,$96,$E3,$4F,$15,$FD,$B9,
    $AF,$56,$88,$C0,$F7,$AD,$52,$9F,$AB,$D5,$E7,$03,$EA,$73,$8D,$FA,
    $84,$AB,$8C,$E6,$FB,$9E,$D0,$F0,$E3,$B7,$1A,$35,$16,$D2,$B2,$F7,
    $BE,$67,$E9,$6F,$B9,$F7,$BE,$17,$D4,$C8,$8D,$1C,$B9,$49,$44,$82,
    $F2,$7D,$F7,$61,$C3,$83,$9C,$0D,$20,$EE,$C3,$42,$85,$7C,$99,$80,
    $E3,$BE,$ED,$6A,$96,$1D,$EA,$73,$B7,$FA,$6C,$E5,$91,$C0,$B7,$9E,
    $34,$13,$2A,$CF,$BA,$F5,$24,$C2,$1B,$E5,$97,$E9,$A3,$58,$1A,$21,
    $99,$BA,$76,$F9,$34,$8D,$CB,$85,$85,$A2,$FC,$52,$62,$23,$39,$D8,
    $CB,$A0,$2D,$08,$EF,$65,$90,$AF,$08,$C4,$D0,$8B,$A1,$00,$F3,$4B,
    $0F,$5C,$83,$94,$FA,$3B,$AF,$0A,$F6,$F2,$4D,$EE,$94,$73,$52,$38,
    $A7,$2D,$9A,$33,$70,$34,$26,$E7,$D8,$68,$CE,$49,$FE,$CE,$E0,$17,
    $4C,$69,$CE,$D3,$B8,$59,$85,$C4,$FA,$8D,$94,$B4,$B6,$FA,$B4,$A6,
    $C6,$80,$50,$1C,$81,$37,$33,$7C,$47,$BB,$67,$7B,$7B,$19,$B8,$5D,
    $BB,$77,$4E,$07,$F1,$BC,$88,$E1,$DC,$DE,$13,$E6,$79,$C4,$35,$63,
    $D9,$5F,$60,$6C,$41,$CC,$6D,$70,$9F,$77,$0B,$15,$E2,$DF,$F4,$84,
    $CE,$D5,$62,$0F,$B2,$FA,$B2,$73,$AB,$BA,$76,$F4,$E5,$97,$8A,$92,
    $F7,$03,$F7,$25,$F4,$01,$B3,$19,$14,$A6,$C0,$C5,$24,$CE,$D4,$56,
    $E9,$94,$0C,$B7,$49,$81,$59,$5E,$D6,$13,$D1,$D9,$EC,$C1,$EA,$FF,
    $E0,$4E,$4B,$EA,$84,$7C,$B6,$07,$05,$41,$DF,$9D,$30,$AB,$B4,$CE,
    $C8,$6A,$AD,$1A,$3A,$16,$79,$7E,$E0,$4A,$E5,$AC,$77,$A5,$B0,$2E,
    $15,$0F,$25,$4E,$4F,$9A,$F8,$27,$2C,$CE,$39,$BA,$D4,$D1,$EF,$97,
    $37,$87,$D0,$66,$83,$C6,$F5,$63,$4F,$B5,$AC,$71,$65,$FB,$B0,$FF,
    $53,$96,$61,$C1,$87,$63,$5E,$F7,$A5,$3E,$47,$FB,$56,$7D,$21,$9B,
    $43,$E4,$4A,$F6,$4B,$DD,$8E,$B1,$BA,$89,$5B,$D4,$83,$B1,$3C,$1F,
    $AF,$7E,$B9,$FC,$38,$A0,$EB,$A2,$59,$C5,$DE,$C5,$20,$40,$B3,$EE,
    $AA,$CD,$D3,$65,$DC,$45,$E2,$7F,$17,$A5,$28,$52,$53,$5C,$CA,$56,
    $1A,$BF,$3C,$EA,$B8,$60,$BD,$30,$0F,$8D,$A5,$70,$76,$2C,$53,$F8,
    $6A,$2C,$98,$42,$BB,$2A,$07,$1D,$03,$67,$C8,$FF,$1C,$A2,$99,$2A,
    $F6,$AB,$72,$00,$5E,$AE,$9E,$BF,$1C,$F7,$AE,$C5,$AE,$89,$46,$AE,
    $39,$46,$5F,$1C,$28,$8C,$C8,$5F,$C7,$5D,$4B,$A3,$48,$AF,$0A,$02,
    $E9,$AE,$5B,$B0,$38,$EA,$97,$7F,$DC,$C5,$A2,$6A,$A9,$8F,$B9,$A2,
    $B5,$0B,$4C,$30,$B8,$35,$48,$79,$E5,$5F,$B3,$D1,$29,$38,$4B,$7E,
    $FB,$04,$A6,$9A,$1E,$96,$23,$D3,$6F,$82,$FD,$03,$5F,$76,$E8,$1C,
    $3D,$E3,$C3,$85,$FE,$02,$F2,$E3,$0F,$D9,$94,$32,$89,$A0,$0E,$A4,
    $DF,$AE,$85,$6E,$D0,$F5,$15,$18,$50,$8B,$DC,$F1,$95,$60,$61,$33,
    $E5,$E7,$CE,$C4,$2C,$54,$B6,$17,$F2,$A2,$99,$68,$2D,$D2,$F8,$3B,
    $A7,$7E,$D6,$1B,$B3,$50,$19,$BB,$2F,$A6,$CF,$DA,$6F,$6C,$7B,$C1,
    $25,$ED,$C6,$58,$32,$FC,$A3,$3D,$56,$09,$82,$56,$F9,$73,$2A,$DC,
    $47,$0A,$66,$B3,$3C,$02,$B7,$04,$D9,$BB,$A8,$BD,$F2,$4F,$49,$35,
    $F5,$9C,$D6,$56,$C7,$B3,$8A,$28,$0F,$FC,$84,$80,$0C,$DA,$3E,$5A,
    $A1,$E7,$65,$FB,$5E,$E9,$58,$56,$AF,$E9,$81,$4B,$E9,$DB,$38,$9F,
    $53,$A6,$AC,$53,$3F,$61,$2B,$1C,$21,$4E,$36,$7D,$21,$24,$FC,$5F,
    $10,$15,$94,$54,$0D,$C7,$5A,$AE,$26,$EF,$47,$2E,$7D,$DE,$08,$77,
    $7A,$58,$D8,$9F,$08,$0A,$D9,$31,$9E,$65,$3D,$84,$0B,$D9,$08,$D8,
    $2D,$E7,$22,$BE,$0D,$52,$FB,$70,$7A,$23,$05,$F8,$81,$97,$58,$B0,
    $6F,$67,$C1,$7E,$10,$E7,$52,$15,$8F,$6E,$B9,$1F,$67,$6A,$27,$02,
    $95,$EF,$3F,$AA,$CA,$F8,$41,$59,$43,$1D,$E0,$AE,$42,$F2,$7F,$1F,
    $43,$DF,$90,$46,$19,$C2,$85,$2E,$DD,$B5,$79,$69,$19,$77,$A5,$16,
    $22,$E7,$EE,$63,$28,$BC,$EA,$28,$94,$36,$84,$B7,$71,$B8,$FA,$72,
    $C0,$AA,$4F,$CB,$BB,$CE,$95,$48,$D3,$54,$DE,$18,$B7,$AE,$30,$60,
    $E2,$B1,$90,$00,$64,$05,$74,$54,$14,$DF,$18,$3C,$84,$F0,$C6,$ED,
    $F0,$1C,$63,$82,$DD,$E5,$2B,$E3,$72,$AA,$A8,$EE,$80,$A1,$78,$B2,
    $A9,$EE,$DF,$B1,$57,$10,$6E,$B0,$0B,$CA,$65,$A5,$22,$ED,$4B,$F4,
    $E5,$7D,$01,$F4,$A5,$D0,$09,$85,$11,$3E,$6C,$FF,$26,$E5,$EC,$8A,
    $2F,$79,$AA,$BA,$F2,$18,$4F,$66,$E9,$F4,$7A,$29,$EA,$19,$58,$FB,
    $FF,$B1,$F7,$2E,$70,$51,$55,$5D,$E3,$F0,$19,$18,$71,$52,$14,$52,
    $54,$32,$D4,$A9,$AC,$2C,$CD,$E6,$7E,$3B,$73,$01,$61,$14,$15,$74,
    $54,$50,$52,$34,$10,$06,$41,$11,$08,$66,$14,$0D,$94,$02,$0C,$1C,
    $C7,$AC,$B4,$2C,$CD,$A8,$2C,$CD,$CC,$F0,$1A,$9A,$17,$54,$42,$4D,
    $4B,$54,$54,$54,$54,$32,$B2,$43,$90,$F2,$18,$8F,$A2,$12,$F3,$AD,
    $B5,$CF,$99,$0B,$A4,$F5,$BC,$DF,$FB,$7F,$FF,$DF,$EF,$FB,$FD,$5E,
    $74,$CD,$39,$FB,$BE,$F7,$DA,$6B,$AD,$BD,$F6,$DE,$6B,$EF,$93,$E3,
    $E5,$88,$85,$49,$DA,$E1,$3D,$6D,$90,$23,$D3,$13,$3C,$3B,$DA,$01,
    $C4,$52,$94,$67,$3E,$97,$9B,$49,$3E,$57,$A0,$83,$C3,$17,$29,$E1,
    $AD,$FA,$96,$2B,$1B,$EB,$B3,$E0,$AE,$70,$BA,$DB,$63,$2D,$FD,$26,
    $E1,$FA,$F7,$2D,$D2,$2F,$36,$6F,$82,$64,$66,$73,$4B,$BB,$73,$ED,
    $79,$B6,$6B,$B3,$35,$3A,$F9,$C4,$48,$97,$28,$3B,$CC,$E4,$41,$92,
    $FC,$56,$AF,$45,$32,$BB,$B1,$8D,$AC,$97,$13,$7A,$1E,$C3,$7E,$88,
    $EE,$30,$93,$C2,$8A,$85,$3D,$75,$90,$86,$49,$84,$1A,$93,$45,$C9,
    $33,$4C,$08,$0A,$E9,$47,$88,$C2,$3C,$C6,$D3,$6E,$F0,$CC,$C8,$10,
    $F2,$B9,$C6,$1F,$6E,$22,$9A,$5E,$46,$2D,$B5,$99,$7C,$5F,$D6,$A5,
    $FB,$C7,$52,$AE,$B5,$0F,$14,$C0,$2D,$CE,$F5,$2C,$AC,$59,$C6,$28,
    $57,$CD,$2A,$99,$EB,$88,$C6,$1A,$DC,$1B,$56,$E1,$12,$A1,$36,$D6,
    $22,$D2,$6A,$2C,$C3,$B4,$C3,$AD,$4F,$11,$3A,$3C,$CE,$B1,$68,$25,
    $53,$F1,$07,$51,$4C,$70,$9E,$1C,$D9,$C6,$DC,$83,$74,$8D,$BD,$C6,
    $C2,$D4,$EC,$28,$EB,$03,$A8,$C4,$BC,$5C,$75,$9C,$3F,$0A,$EB,$D8,
    $C2,$3C,$47,$EA,$F8,$6D,$03,$5B,$47,$E7,$7E,$36,$B7,$86,$77,$84,
    $E9,$76,$93,$68,$B4,$2F,$BB,$AA,$F1,$24,$57,$0D,$3E,$90,$D6,$A3,
    $53,$6C,$C7,$9D,$C5,$1B,$51,$2C,$A0,$DD,$9D,$F5,$8A,$FB,$5B,$EF,
    $24,$0F,$28,$39,$90,$CD,$E5,$31,$57,$2E,$CF,$79,$E4,$12,$88,$22,
    $A7,$BD,$D9,$4D,$84,$95,$4C,$EB,$2D,$67,$66,$E7,$5D,$EB,$85,$6C,
    $7D,$16,$DE,$20,$39,$9D,$6C,$76,$E6,$F4,$02,$97,$D3,$D3,$80,$96,
    $27,$00,$2D,$24,$B7,$52,$2E,$37,$76,$C1,$73,$93,$2B,$B7,$33,$EE,
    $EF,$C5,$47,$93,$AF,$2C,$1F,$66,$70,$DE,$06,$5D,$9F,$D3,$3F,$EF,
    $55,$9E,$C6,$1A,$10,$4D,$FA,$DC,$29,$F6,$90,$0E,$1A,$67,$C0,$CB,
    $CB,$5C,$AC,$B1,$79,$74,$AC,$75,$24,$44,$8D,$B5,$06,$4B,$1D,$64,
    $AF,$B7,$B1,$67,$5E,$8E,$14,$68,$91,$37,$2A,$DF,$E1,$95,$CB,$1B,
    $09,$B1,$C5,$10,$9B,$6E,$CE,$ED,$02,$1E,$39,$D7,$B8,$D0,$71,$D1,
    $9C,$B1,$1D,$84,$3F,$86,$D9,$76,$B5,$7D,$C7,$6C,$06,$69,$E8,$B1,
    $7F,$3D,$81,$4C,$6B,$50,$F2,$8D,$B6,$DE,$7D,$23,$B2,$8D,$5B,$18,
    $BB,$C5,$7D,$A0,$79,$B4,$93,$2E,$B6,$A3,$F0,$05,$B4,$76,$B9,$D1,
    $4E,$16,$B2,$2C,$12,$14,$F6,$47,$18,$63,$BB,$A7,$B0,$57,$92,$03,
    $02,$CD,$31,$CC,$36,$A8,$8E,$DF,$4A,$34,$3B,$E9,$86,$53,$B1,$4A,
    $26,$1E,$97,$10,$2E,$59,$E2,$ED,$91,$4D,$38,$11,$6A,$65,$32,$C8,
    $C7,$66,$9B,$4C,$38,$4E,$1E,$61,$46,$90,$6C,$EA,$ED,$91,$8C,$F4,
    $34,$13,$4D,$82,$98,$A9,$4C,$E0,$0D,$A2,$6C,$3F,$63,$8F,$AE,$C3,
    $24,$29,$24,$52,$1D,$24,$A9,$85,$24,$D3,$88,$AB,$76,$2A,$73,$EB,
    $77,$8C,$65,$E5,$F6,$80,$DD,$1F,$7F,$1E,$8D,$D4,$56,$CB,$EE,$F7,
    $5D,$6C,$42,$92,$0B,$FF,$B5,$C3,$92,$84,$8B,$3F,$09,$77,$AE,$19,
    $E3,$E6,$CE,$3D,$69,$78,$BF,$F5,$5C,$A0,$9D,$64,$DC,$56,$07,$0E,
    $C7,$F9,$BF,$89,$99,$F4,$28,$D9,$24,$F7,$66,$0E,$DD,$40,$74,$2F,
    $7A,$C2,$3E,$99,$87,$E3,$31,$2B,$78,$BE,$BA,$81,$43,$93,$37,$93,
    $42,$E2,$3E,$FB,$28,$BB,$CA,$92,$D3,$1D,$BC,$DE,$66,$E3,$E3,$57,
    $CB,$51,$C2,$F4,$FE,$17,$8E,$1D,$6D,$10,$A0,$BB,$4F,$E6,$33,$38,
    $DE,$35,$79,$B0,$CA,$27,$63,$58,$76,$6E,$6F,$C4,$7A,$AF,$B8,$EE,
    $62,$E7,$8E,$75,$1E,$3F,$B6,$73,$9D,$77,$B3,$B2,$EB,$3A,$50,$BF,
    $89,$D4,$9D,$59,$EC,$CF,$D5,$B9,$67,$87,$3A,$AF,$60,$23,$EE,$BB,
    $C9,$D6,$F9,$5F,$BF,$93,$F6,$F9,$7B,$D4,$F9,$CA,$EF,$1D,$EA,$8C,
    $F4,$C8,$D6,$B9,$F8,$9E,$B3,$CE,$DB,$3D,$B5,$C9,$C9,$63,$D9,$3A,
    $8F,$21,$75,$AE,$FD,$A5,$43,$9D,$DD,$6B,$75,$6C,$CD,$95,$11,$1E,
    $35,$8F,$00,$07,$33,$AB,$11,$D7,$31,$DA,$98,$49,$02,$72,$15,$7D,
    $59,$0C,$7A,$7E,$72,$13,$65,$B9,$75,$11,$8A,$0D,$2F,$62,$74,$D5,
    $02,$F4,$C4,$7C,$DD,$E6,$5C,$79,$FC,$F3,$2E,$6B,$3E,$16,$6B,$37,
    $36,$31,$C3,$DA,$5D,$03,$B1,$BD,$8D,$BD,$04,$FF,$0C,$73,$89,$8B,
    $A1,$21,$0B,$F7,$81,$A8,$73,$65,$E3,$D9,$76,$18,$75,$23,$DB,$F6,
    $90,$52,$A8,$EB,$A8,$A3,$D4,$E3,$1C,$AF,$17,$23,$6D,$42,$A1,$56,
    $6F,$3B,$BC,$3B,$11,$C3,$06,$FF,$EE,$D1,$44,$7D,$04,$BB,$CC,$85,
    $BB,$E0,$CC,$92,$DF,$B0,$9D,$2D,$F5,$4E,$5D,$8A,$D5,$2D,$90,$3F,
    $43,$41,$D8,$3A,$C7,$96,$50,$8F,$75,$16,$4E,$06,$BF,$56,$B1,$B9,
    $9D,$7C,$CB,$F9,$88,$11,$AF,$55,$72,$14,$C2,$AC,$77,$2D,$B2,$E9,
    $99,$32,$51,$24,$14,$89,$74,$84,$47,$5B,$8A,$58,$3F,$2D,$FA,$BD,
    $4F,$FC,$AC,$D9,$F6,$C2,$CD,$ED,$EC,$1E,$98,$37,$52,$1B,$F3,$68,
    $4F,$62,$3A,$99,$9F,$DB,$EA,$B0,$4C,$43,$C4,$06,$46,$BA,$8C,$D6,
    $90,$BB,$0A,$CB,$31,$3A,$73,$BA,$07,$D9,$60,$7E,$1C,$05,$B8,$DD,
    $78,$DB,$84,$61,$CC,$4E,$D6,$D3,$87,$AC,$20,$B7,$B9,$1A,$39,$28,
    $92,$33,$3E,$FE,$8A,$18,$1E,$F5,$C6,$06,$DE,$84,$B1,$A8,$A3,$FE,
    $F4,$BC,$C7,$F8,$69,$A0,$28,$A7,$AD,$16,$D9,$0E,$87,$66,$71,$A6,
    $06,$30,$BA,$30,$0B,$EB,$1C,$0E,$A2,$5C,$79,$E3,$2F,$AE,$3B,$05,
    $23,$CF,$10,$82,$BB,$E7,$EB,$AA,$BE,$B5,$1B,$B3,$BE,$07,$31,$DB,
    $6E,$8C,$C4,$86,$9C,$F1,$68,$08,$DA,$50,$B1,$40,$2A,$96,$DA,$93,
    $6C,$A7,$0B,$98,$2C,$36,$81,$AB,$EA,$17,$9D,$55,$7F,$DD,$17,$AB,
    $1E,$F3,$B3,$47,$D5,$51,$57,$20,$E2,$F7,$FB,$26,$2C,$59,$D4,$83,
    $1C,$12,$70,$8E,$19,$D2,$4B,$28,$C4,$BF,$26,$41,$7F,$12,$BC,$58,
    $BB,$32,$01,$3D,$C8,$6A,$F5,$61,$EE,$BB,$F6,$AF,$55,$94,$B1,$FD,
    $86,$5A,$4D,$E1,$25,$CB,$AB,$D0,$39,$E5,$E3,$A0,$73,$DA,$9A,$48,
    $E7,$CC,$C1,$E3,$14,$E8,$6E,$62,$DD,$D3,$EC,$85,$65,$5C,$67,$4D,
    $26,$19,$27,$BA,$5B,$6B,$D1,$63,$1B,$37,$8E,$73,$71,$01,$89,$9A,
    $5F,$E7,$9F,$DF,$EA,$6F,$E9,$B8,$2A,$FE,$F5,$38,$AE,$51,$03,$48,
    $A3,$F2,$AF,$61,$A3,$40,$05,$FA,$C7,$FE,$20,$72,$82,$8C,$EF,$E3,
    $C7,$BB,$57,$C5,$41,$75,$8F,$B0,$9D,$2B,$4B,$06,$2F,$26,$94,$AD,
    $A8,$16,$DC,$16,$74,$4B,$59,$F7,$30,$FC,$DE,$27,$2E,$D6,$E0,$F6,
    $69,$25,$83,$77,$45,$DA,$6A,$1A,$FB,$22,$F7,$57,$32,$CF,$DE,$21,
    $36,$89,$8C,$14,$A4,$74,$B0,$DF,$AA,$C3,$6E,$FE,$1F,$CF,$F1,$FF,
    $AF,$84,$FF,$7F,$22,$B3,$C9,$C3,$44,$02,$3C,$60,$ED,$D7,$59,$4F,
    $52,$C5,$4B,$F8,$6D,$FB,$06,$76,$BC,$D3,$C2,$7B,$02,$79,$F7,$5E,
    $2C,$CA,$5B,$04,$23,$E4,$F3,$E0,$33,$81,$F5,$B1,$FA,$E4,$2D,$F2,
    $8A,$B5,$06,$2E,$F5,$D1,$C6,$67,$F2,$B5,$0B,$E7,$F9,$2E,$ED,$4B,
    $4C,$40,$F3,$EE,$4D,$9D,$0F,$D2,$1F,$CB,$23,$E7,$42,$66,$E3,$A0,
    $57,$F7,$1B,$62,$7D,$49,$37,$87,$E3,$4E,$CD,$E3,$E5,$77,$6A,$A6,
    $75,$FA,$76,$BB,$C1,$E4,$36,$F0,$44,$71,$16,$71,$9B,$6D,$DA,$46,
    $92,$AE,$67,$77,$5C,$90,$74,$58,$04,$CE,$5E,$E9,$34,$C0,$8C,$34,
    $B1,$ED,$9D,$7A,$1D,$DB,$DB,$54,$C7,$B6,$77,$1A,$FB,$AD,$6D,$56,
    $DE,$4D,$9A,$5C,$14,$ED,$60,$BB,$20,$62,$42,$C7,$8D,$89,$73,$CC,
    $9E,$EB,$AC,$F2,$3E,$8F,$21,$EC,$5E,$F0,$25,$59,$B7,$44,$23,$4E,
    $26,$FD,$DF,$64,$1C,$45,$A9,$B7,$F2,$3A,$8A,$DD,$56,$F4,$BD,$70,
    $9B,$9D,$21,$18,$19,$9C,$21,$3C,$86,$AF,$C3,$C9,$7E,$2C,$2E,$21,
    $93,$AD,$0A,$1A,$B0,$64,$E5,$6F,$E7,$35,$CE,$04,$8F,$3D,$89,$50,
    $24,$33,$04,$BD,$04,$38,$73,$DA,$F6,$0B,$BB,$5C,$69,$E9,$B7,$34,
    $9A,$4C,$A2,$A3,$D9,$CD,$5C,$12,$B8,$8A,$0B,$B4,$0E,$21,$A3,$7B,
    $00,$66,$FE,$08,$FB,$B5,$76,$01,$29,$93,$9B,$3C,$7C,$CC,$6E,$05,
    $78,$E2,$61,$D2,$04,$8F,$29,$D7,$2B,$BF,$20,$32,$AE,$5E,$65,$07,
    $DA,$4E,$73,$AE,$58,$A7,$9C,$40,$79,$53,$69,$BC,$47,$BE,$73,$32,
    $AB,$8D,$6C,$AD,$E5,$E7,$B6,$38,$2C,$66,$28,$22,$BF,$4E,$90,$DF,
    $2A,$B0,$4C,$25,$AF,$04,$F1,$E3,$F1,$F5,$A8,$B0,$07,$AE,$D2,$F4,
    $C0,$85,$CF,$1E,$94,$00,$7F,$FC,$29,$4A,$57,$F2,$18,$45,$59,$86,
    $43,$DB,$F3,$AF,$09,$5F,$BB,$86,$31,$5E,$BB,$86,$51,$E0,$57,$40,
    $7E,$FD,$D9,$AF,$A9,$F4,$69,$23,$3C,$0D,$9C,$75,$8F,$57,$69,$BC,
    $4F,$4C,$18,$D4,$13,$3D,$97,$16,$B6,$33,$D8,$E9,$AF,$09,$9C,$C4,
    $52,$64,$BC,$EF,$3E,$E8,$06,$31,$71,$41,$C3,$FA,$28,$AE,$A0,$A2,
    $29,$43,$0B,$F9,$96,$FB,$7D,$64,$C8,$5B,$57,$A0,$B1,$3F,$2D,$35,
    $DE,$77,$EA,$14,$A8,$63,$E3,$47,$8D,$5A,$58,$2A,$7B,$69,$92,$9B,
    $CA,$70,$7E,$FC,$F6,$1F,$0E,$47,$A5,$B1,$9D,$A0,$73,$F6,$7D,$B7,
    $44,$98,$83,$EB,$C5,$6C,$E3,$E3,$C8,$2B,$36,$DE,$1A,$8D,$AF,$47,
    $85,$F9,$47,$FD,$1F,$D8,$FE,$52,$6C,$BF,$D8,$16,$DD,$0A,$ED,$CF,
    $BF,$E6,$FF,$70,$14,$B4,$30,$BD,$EE,$3B,$51,$D0,$CE,$43,$09,$86,
    $75,$D3,$4E,$72,$A3,$A0,$85,$29,$FD,$15,$51,$70,$C3,$03,$05,$EE,
    $A1,$2F,$74,$12,$A2,$C0,$41,$50,$D0,$4E,$50,$40,$68,$72,$DF,$3D,
    $44,$C1,$CD,$CB,$88,$02,$57,$DC,$B8,$49,$AC,$A2,$1F,$FC,$33,$12,
    $C3,$E9,$CB,$DC,$3E,$1E,$21,$06,$72,$96,$84,$BD,$A9,$8B,$11,$42,
    $38,$73,$00,$37,$E1,$19,$A9,$43,$7A,$7B,$7B,$FF,$C2,$DB,$D6,$AE,
    $C4,$6A,$B7,$D1,$C7,$56,$E9,$5D,$0E,$AA,$C8,$0D,$0B,$6F,$54,$FB,
    $71,$EB,$75,$3C,$88,$7D,$9E,$B9,$04,$15,$24,$31,$43,$1E,$14,$B3,
    $C7,$28,$CC,$F4,$0E,$30,$4C,$51,$AC,$CA,$11,$9A,$77,$7F,$9A,$B5,
    $66,$AA,$87,$AE,$EB,$B6,$F1,$66,$8D,$88,$77,$47,$B9,$47,$98,$56,
    $26,$01,$A7,$53,$84,$2F,$7E,$A9,$6F,$67,$F7,$C7,$C2,$BF,$65,$F7,
    $C7,$5A,$70,$CB,$34,$AA,$BF,$83,$E9,$57,$CF,$EE,$B5,$54,$41,$4A,
    $A6,$B2,$9E,$E5,$DF,$85,$D7,$11,$6B,$55,$3E,$28,$2D,$BC,$2D,$7E,
    $98,$57,$16,$78,$A1,$99,$BD,$B0,$91,$37,$2A,$74,$9C,$75,$1F,$2E,
    $F0,$9C,$67,$06,$90,$DA,$63,$09,$F9,$CE,$12,$9E,$E5,$2C,$F3,$5B,
    $F1,$C4,$90,$D0,$12,$30,$0A,$C9,$4A,$8E,$82,$81,$2D,$91,$6C,$6C,
    $8F,$B3,$5E,$71,$A1,$B6,$3C,$8A,$A0,$96,$DD,$ED,$E1,$5F,$43,$FC,
    $66,$D6,$76,$5E,$DF,$F0,$D0,$35,$1E,$B8,$8E,$93,$13,$ED,$EE,$75,
    $01,$F3,$01,$48,$6A,$7B,$64,$EB,$52,$3C,$9A,$EA,$CF,$14,$9D,$66,
    $8D,$DC,$0F,$33,$9F,$34,$43,$56,$D6,$96,$C9,$0E,$6B,$EB,$14,$90,
    $73,$EC,$AE,$48,$31,$69,$74,$1B,$F3,$E1,$5D,$A7,$E0,$11,$E0,$56,
    $CA,$26,$94,$F6,$03,$EC,$91,$CD,$7B,$56,$46,$93,$D1,$8A,$59,$5F,
    $C5,$89,$B0,$56,$E6,$14,$06,$7E,$E9,$6A,$42,$7E,$34,$2B,$2F,$48,
    $7E,$21,$3F,$61,$13,$BE,$BE,$E4,$6E,$C2,$21,$DF,$CE,$DF,$6D,$77,
    $9E,$9B,$B0,$5D,$C4,$25,$CE,$5C,$01,$28,$FF,$D7,$EB,$DA,$89,$C9,
    $B7,$95,$0F,$53,$2C,$D7,$FE,$C6,$7D,$E4,$51,$8B,$3F,$D4,$FD,$7A,
    $3D,$F6,$49,$53,$17,$4E,$3D,$88,$4E,$DE,$3B,$D9,$D9,$E4,$C9,$EC,
    $22,$44,$9B,$89,$F9,$85,$CF,$9E,$E5,$F2,$2B,$C0,$15,$DD,$49,$C4,
    $EF,$09,$1F,$56,$03,$F6,$5B,$5E,$E0,$F2,$FB,$AA,$8B,$53,$42,$51,
    $96,$57,$30,$B3,$B7,$27,$7B,$70,$8D,$89,$F9,$AC,$0B,$9B,$0F,$7B,
    $A2,$D0,$E2,$0E,$3C,$49,$E6,$E9,$0B,$6B,$3C,$E6,$E9,$AF,$4E,$66,
    $B7,$9A,$1F,$F3,$41,$BE,$F9,$E6,$22,$B2,$86,$2B,$F0,$7D,$36,$D0,
    $C4,$24,$F0,$31,$F4,$7D,$0C,$75,$1F,$FB,$3A,$3C,$99,$15,$42,$16,
    $3F,$B2,$01,$C7,$1E,$FC,$12,$93,$98,$E9,$18,$F3,$67,$D7,$9A,$C8,
    $44,$13,$33,$1A,$FD,$25,$87,$C8,$01,$15,$1B,$BF,$B0,$7A,$43,$08,
    $75,$F0,$37,$01,$5E,$8E,$0F,$8C,$7F,$E8,$B0,$6B,$AF,$1F,$D5,$1B,
    $5B,$9F,$65,$83,$80,$9E,$C7,$80,$E8,$AE,$F4,$A6,$F0,$03,$1E,$CC,
    $96,$EF,$1D,$8E,$A4,$E2,$50,$1E,$71,$7C,$CC,$3A,$BC,$C9,$17,$A5,
    $F1,$C7,$17,$C8,$85,$84,$34,$1E,$27,$7A,$78,$71,$68,$00,$5A,$46,
    $72,$9F,$A0,$B6,$87,$0A,$99,$91,$57,$C9,$D2,$76,$E8,$90,$E2,$D0,
    $61,$F8,$14,$E1,$8F,$0C,$7F,$54,$F8,$A3,$AD,$0C,$C5,$2F,$27,$15,
    $87,$86,$25,$1D,$09,$0D,$07,$16,$0B,$8D,$60,$7A,$43,$12,$7B,$A8,
    $89,$E9,$CE,$25,$8D,$C2,$9F,$18,$B2,$F3,$EF,$B4,$07,$03,$D1,$B8,
    $58,$E1,$57,$D0,$8A,$AB,$E0,$AD,$5D,$FD,$DE,$98,$C7,$23,$1F,$FA,
    $3D,$30,$25,$84,$7A,$31,$26,$84,$D2,$03,$44,$02,$C4,$02,$CC,$01,
    $58,$08,$50,$0C,$B0,$1A,$20,$BF,$B5,$D7,$E2,$17,$D8,$8F,$4D,$E4,
    $33,$8F,$F8,$15,$A0,$4A,$12,$EE,$57,$70,$1C,$B3,$62,$BC,$FC,$0A,
    $4E,$39,$5F,$CE,$53,$78,$E3,$32,$89,$D6,$DB,$AF,$E0,$57,$E2,$3D,
    $DE,$AF,$E0,$77,$36,$3E,$DA,$CF,$34,$10,$9C,$56,$EE,$09,$7B,$09,
    $90,$B6,$F5,$0A,$59,$EA,$01,$67,$14,$3A,$3F,$71,$39,$13,$D1,$F9,
    $8E,$CB,$59,$80,$CE,$02,$97,$73,$3D,$3A,$AD,$2E,$67,$05,$3A,$93,
    $5C,$CE,$7A,$74,$4E,$71,$39,$5B,$D1,$19,$EE,$72,$FA,$4E,$05,$A7,
    $DA,$E5,$14,$A2,$F3,$79,$97,$33,$18,$9D,$8F,$BB,$9C,$71,$E8,$F4,
    $75,$39,$33,$D0,$F9,$E7,$65,$57,$AD,$D0,$79,$C3,$E5,$5C,$8B,$CE,
    $AB,$2E,$67,$19,$3A,$AB,$5C,$CE,$A3,$E8,$3C,$C8,$39,$91,$B0,$BF,
    $3B,$E6,$61,$8B,$85,$8B,$74,$93,$2C,$E9,$99,$E6,$44,$0F,$77,$72,
    $A6,$35,$6D,$0E,$EB,$C6,$D3,$A2,$A1,$E9,$73,$33,$F0,$8C,$67,$4A,
    $7A,$9A,$70,$64,$7C,$02,$C4,$16,$8A,$9D,$EB,$CF,$0F,$09,$97,$FC,
    $43,$B8,$F4,$1F,$C2,$65,$CE,$70,$5C,$06,$18,$3D,$37,$23,$35,$3D,
    $11,$6B,$C8,$FA,$E1,$49,$D6,$A8,$F4,$39,$E6,$B4,$94,$85,$29,$69,
    $B3,$DC,$F1,$C2,$CC,$49,$A9,$F1,$16,$77,$BC,$3E,$F0,$34,$A6,$25,
    $C7,$A7,$25,$98,$13,$85,$6C,$20,$C4,$17,$2A,$64,$5C,$78,$3F,$57,
    $DE,$E8,$3D,$3E,$35,$51,$38,$7A,$44,$A4,$30,$CA,$38,$71,$92,$91,
    $84,$E3,$BE,$CD,$88,$A9,$29,$19,$12,$8F,$72,$23,$A6,$46,$86,$08,
    $87,$18,$47,$4E,$7A,$8E,$F5,$C3,$AF,$97,$8E,$33,$CF,$F7,$48,$C9,
    $FA,$A3,$F5,$36,$FA,$45,$4C,$55,$2A,$85,$0B,$85,$43,$4C,$24,$85,
    $7B,$CD,$DE,$64,$8A,$74,$D5,$13,$F3,$08,$31,$4E,$12,$1A,$D3,$12,
    $32,$17,$64,$B0,$0D,$E0,$CE,$0D,$F7,$9C,$E6,$3E,$37,$2C,$C4,$73,
    $C7,$7E,$F9,$BA,$2A,$72,$0C,$DA,$C7,$D1,$07,$5F,$5C,$62,$A6,$CF,
    $34,$3C,$48,$3C,$E0,$5C,$3B,$39,$48,$BC,$22,$FF,$05,$A1,$E7,$F9,
    $63,$A3,$47,$3E,$83,$3D,$CF,$1F,$47,$90,$64,$D7,$CF,$B6,$BB,$CE,
    $1F,$0F,$26,$E9,$D6,$4F,$73,$9F,$39,$F6,$7C,$77,$FE,$ED,$07,$3F,
    $3C,$41,$AC,$8A,$FF,$FB,$F3,$C7,$14,$BC,$B3,$E7,$8F,$89,$D5,$9F,
    $7F,$30,$F9,$00,$AE,$F3,$1C,$72,$0F,$E3,$38,$EB,$5C,$53,$66,$7A,
    $82,$31,$33,$33,$3D,$33,$30,$D6,$5D,$8E,$E7,$BB,$F3,$EF,$79,$F0,
    $0B,$82,$67,$0C,$94,$FD,$9F,$95,$C9,$E3,$CA,$C2,$9A,$FA,$1A,$A7,
    $A4,$A4,$85,$98,$46,$93,$A2,$56,$14,$78,$E4,$BF,$F2,$01,$65,$7D,
    $0E,$7E,$42,$78,$0E,$D9,$F6,$CF,$ED,$AB,$39,$0E,$AD,$4A,$0D,$A1,
    $4C,$00,$AA,$B9,$21,$9D,$CA,$46,$CA,$F4,$8D,$0A,$8D,$4F,$48,$36,
    $4F,$B2,$64,$9A,$E3,$E7,$AE,$A0,$A6,$FF,$B5,$BC,$0E,$7F,$10,$DE,
    $04,$8F,$9A,$81,$7F,$DF,$4E,$3C,$DB,$DD,$DB,$75,$02,$1B,$D1,$88,
    $4C,$94,$36,$2B,$EE,$1F,$F2,$C7,$70,$C4,$E3,$89,$FF,$00,$8F,$3D,
    $8C,$5C,$BE,$04,$6D,$B6,$F2,$BD,$FF,$90,$37,$86,$63,$0F,$FF,$27,
    $74,$F1,$88,$31,$74,$62,$28,$97,$6F,$C0,$8C,$BF,$CF,$17,$C3,$FF,
    $F3,$7C,$81,$69,$B9,$7C,$53,$FF,$21,$DF,$D4,$FF,$42,$BE,$DD,$8D,
    $D1,$69,$0B,$B9,$9C,$2B,$FE,$21,$DF,$1A,$08,$C7,$73,$8A,$AA,$D8,
    $BF,$C7,$71,$8D,$3D,$84,$D0,$4F,$DD,$9B,$21,$54,$C0,$0A,$96,$7E,
    $96,$0D,$09,$A6,$FC,$A3,$42,$AD,$59,$96,$F4,$B9,$D0,$12,$96,$6A,
    $40,$17,$56,$BD,$FC,$F7,$65,$46,$BC,$CC,$96,$99,$3D,$E3,$BF,$5E,
    $66,$38,$3C,$7D,$A3,$48,$FB,$5C,$E5,$75,$B2,$EF,$9A,$DE,$C6,$19,
    $77,$11,$43,$2F,$76,$BB,$0D,$65,$4B,$48,$9C,$C7,$A1,$3E,$FE,$79,
    $5C,$75,$B7,$F5,$41,$7C,$32,$67,$4E,$B4,$E3,$AC,$B3,$9B,$ED,$88,
    $6D,$32,$9F,$D1,$41,$50,$C1,$25,$5C,$F2,$6B,$33,$A1,$39,$22,$67,
    $C6,$E5,$C3,$1C,$3D,$EE,$69,$C6,$75,$BD,$A6,$9D,$5D,$9A,$66,$ED,
    $A4,$42,$F7,$42,$1C,$F2,$BA,$27,$06,$0A,$7A,$89,$91,$9C,$66,$17,
    $11,$FD,$F6,$24,$82,$9B,$79,$EA,$34,$BB,$AA,$79,$84,$B9,$0C,$B2,
    $2F,$DF,$40,$59,$BB,$C2,$FB,$4F,$DF,$7A,$28,$6F,$E1,$71,$2E,$AB,
    $2B,$F3,$39,$76,$26,$40,$26,$BD,$39,$E7,$50,$89,$FD,$AD,$CA,$6D,
    $75,$D5,$71,$9F,$D1,$D3,$FE,$CA,$76,$D4,$76,$68,$1B,$8F,$79,$64,
    $20,$E8,$67,$9E,$F6,$E7,$1D,$75,$75,$A7,$B9,$D5,$74,$5F,$44,$4C,
    $7C,$BC,$6B,$DF,$D5,$61,$ED,$86,$2A,$F5,$27,$50,$AD,$C6,$6E,$AC,
    $05,$5C,$26,$5B,$15,$E6,$F4,$59,$62,$DB,$D6,$8D,$3D,$A2,$DA,$B4,
    $DF,$41,$F6,$A3,$AD,$C2,$C9,$B8,$71,$DA,$6C,$C2,$0D,$19,$B2,$57,
    $C3,$D8,$6B,$5C,$AA,$B9,$02,$D2,$82,$06,$ED,$63,$1B,$80,$3C,$6C,
    $8B,$6C,$DD,$86,$6B,$C3,$A9,$03,$50,$A1,$B5,$87,$FA,$42,$EE,$55,
    $90,$6B,$71,$96,$BF,$3D,$14,$CD,$BA,$98,$43,$67,$71,$8B,$DA,$D6,
    $07,$63,$33,$BA,$E3,$A4,$57,$BA,$DB,$43,$D1,$E8,$91,$F9,$FC,$AC,
    $C7,$4A,$69,$72,$BC,$C7,$A2,$40,$EC,$59,$C4,$CF,$F7,$27,$3D,$57,
    $DF,$F1,$FC,$8C,$CB,$FE,$A9,$38,$B2,$15,$17,$4A,$6A,$8E,$A0,$79,
    $0D,$20,$FC,$36,$DA,$03,$FB,$7D,$58,$9E,$5F,$B7,$D8,$36,$C9,$DF,
    $36,$51,$30,$66,$68,$55,$71,$74,$13,$6D,$6D,$5A,$84,$7B,$88,$47,
    $08,$46,$49,$9C,$95,$24,$4E,$B4,$A0,$D8,$AB,$A1,$2F,$5E,$24,$05,
    $7E,$39,$5D,$68,$AB,$7F,$2E,$37,$29,$80,$50,$EF,$CA,$62,$5C,$DB,
    $AD,$B7,$85,$FA,$33,$23,$A3,$B8,$8F,$AA,$06,$50,$39,$DD,$6D,$C6,
    $66,$DA,$18,$90,$E3,$ED,$30,$36,$93,$45,$0F,$3F,$68,$3F,$D9,$CC,
    $B7,$A9,$1C,$53,$F8,$8D,$3D,$6C,$91,$81,$2E,$A7,$00,$66,$CE,$8F,
    $43,$02,$34,$8D,$C2,$6B,$A8,$EB,$D1,$50,$41,$40,$9E,$0D,$1F,$F2,
    $F0,$8A,$05,$DC,$AF,$AF,$0F,$B7,$45,$FB,$A2,$7D,$14,$17,$92,$CF,
    $E3,$AA,$24,$60,$4D,$9B,$3D,$6B,$65,$6C,$72,$57,$EB,$EB,$49,$FF,
    $03,$D5,$F2,$21,$D5,$CA,$ED,$EB,$0E,$A8,$0F,$66,$31,$85,$63,$02,
    $54,$C8,$BB,$F2,$54,$EB,$02,$EF,$FC,$2A,$AA,$D8,$C8,$D0,$56,$06,
    $2D,$C7,$18,$DA,$D8,$94,$63,$78,$20,$16,$71,$47,$BC,$58,$F4,$F0,
    $D6,$B0,$59,$BF,$45,$B9,$5B,$CC,$74,$8E,$C3,$B8,$5B,$BC,$6F,$E2,
    $7F,$A3,$C5,$81,$0F,$6E,$71,$63,$3F,$E8,$85,$EE,$78,$EB,$91,$B1,
    $A9,$21,$08,$77,$0B,$AC,$4C,$43,$00,$BB,$6B,$C0,$11,$5D,$00,$BB,
    $06,$6C,$F3,$77,$4C,$F4,$B5,$85,$0A,$D8,$B5,$42,$CE,$BD,$34,$D4,
    $D7,$E3,$1C,$12,$1B,$E5,$30,$53,$CB,$AE,$B0,$75,$85,$57,$33,$7E,
    $64,$F6,$1C,$D6,$DE,$31,$81,$B3,$7B,$EA,$18,$B7,$D4,$1D,$57,$0D,
    $71,$27,$CF,$76,$CC,$86,$29,$4D,$A0,$C9,$1E,$1A,$64,$CA,$3F,$E6,
    $90,$9E,$86,$00,$BC,$94,$D0,$79,$A6,$15,$26,$B6,$B6,$0B,$EC,$C5,
    $0F,$F0,$1F,$33,$39,$E2,$8D,$94,$7D,$24,$94,$CF,$3E,$04,$EC,$C3,
    $17,$1F,$50,$32,$7F,$30,$53,$EC,$20,$1F,$92,$20,$DF,$9A,$77,$F8,
    $15,$7C,$41,$B1,$5F,$50,$0C,$66,$AF,$B8,$EF,$4D,$7E,$27,$F1,$61,
    $9E,$06,$B3,$34,$0C,$C8,$0E,$1C,$9F,$EF,$A0,$72,$E4,$B6,$F3,$98,
    $7A,$90,$83,$EC,$05,$B1,$26,$97,$10,$3A,$C4,$11,$8D,$57,$0D,$F4,
    $2B,$7E,$55,$40,$4B,$73,$BD,$8A,$A5,$74,$16,$7F,$91,$77,$71,$16,
    $1F,$12,$39,$AC,$C7,$D9,$0C,$C8,$AA,$CA,$77,$20,$F4,$C2,$87,$1E,
    $C9,$A1,$83,$C9,$09,$36,$92,$DB,$A9,$F6,$07,$E6,$16,$58,$FC,$AA,
    $6F,$C7,$DC,$46,$39,$22,$06,$0B,$AC,$DF,$E7,$57,$F8,$4E,$77,$9F,
    $A9,$68,$21,$A7,$52,$C8,$81,$AC,$E9,$6D,$36,$6B,$AB,$9D,$3F,$D0,
    $45,$8E,$2D,$8D,$BC,$50,$EC,$D5,$E0,$36,$5B,$B0,$3F,$CA,$96,$E5,
    $26,$F6,$56,$01,$CE,$E7,$0C,$93,$6B,$22,$A7,$C4,$88,$CF,$4B,$84,
    $4C,$0A,$CB,$73,$8E,$37,$F2,$C6,$75,$48,$36,$A5,$63,$B2,$73,$CC,
    $C8,$07,$24,$5B,$7C,$9C,$FE,$23,$67,$AA,$67,$E6,$42,$13,$31,$60,
    $F7,$48,$D7,$13,$7D,$8E,$7A,$C6,$89,$31,$B1,$27,$06,$58,$F7,$49,
    $2E,$6F,$7A,$7A,$8B,$B5,$4B,$B1,$B5,$A5,$51,$40,$5B,$5B,$AC,$DE,
    $30,$C8,$85,$8E,$A3,$FF,$F0,$B3,$BF,$08,$88,$A7,$AD,$6D,$8B,$FC,
    $88,$CD,$E0,$39,$5C,$41,$B9,$03,$D8,$7B,$09,$C6,$42,$7A,$7A,$AB,
    $DF,$B2,$BB,$ED,$CE,$23,$0A,$1D,$6D,$5E,$89,$49,$17,$A1,$0C,$5C,
    $B4,$24,$E6,$5D,$BE,$94,$85,$98,$55,$75,$25,$9F,$3C,$6E,$CB,$CF,
    $F6,$A7,$AC,$BD,$B6,$F1,$3E,$CE,$DE,$02,$03,$65,$DF,$EF,$70,$E9,
    $A8,$AD,$78,$84,$3F,$09,$0A,$F0,$08,$BA,$5F,$C1,$05,$05,$A0,$61,
    $D7,$86,$64,$D7,$F5,$36,$A4,$80,$5E,$C4,$06,$AB,$38,$46,$60,$3B,
    $43,$2C,$C0,$80,$C6,$C7,$B3,$77,$0F,$40,$EB,$32,$04,$78,$18,$AE,
    $EF,$48,$F6,$02,$02,$F0,$38,$0E,$08,$98,$02,$E1,$78,$14,$81,$AC,
    $8B,$3E,$C5,$05,$04,$0B,$F2,$5B,$79,$7E,$CB,$75,$3C,$9C,$78,$54,
    $8D,$91,$96,$33,$FE,$D8,$CC,$86,$61,$3C,$F6,$2B,$BE,$10,$C5,$24,
    $20,$2F,$01,$CC,$BA,$87,$16,$10,$20,$3D,$06,$05,$DC,$1E,$C7,$16,
    $C0,$2D,$14,$B3,$F1,$F2,$6F,$78,$15,$DE,$F6,$5B,$86,$06,$F5,$AE,
    $D8,$10,$37,$0D,$E2,$C2,$F4,$7C,$3B,$78,$13,$9B,$12,$D2,$82,$97,
    $C6,$B1,$27,$57,$D8,$0E,$1B,$3B,$8E,$ED,$7A,$57,$BF,$E3,$81,$0B,
    $2E,$EC,$45,$0C,$6B,$75,$A7,$1C,$34,$8E,$ED,$6E,$2E,$38,$15,$9C,
    $AE,$40,$DB,$49,$26,$76,$1C,$39,$47,$09,$41,$63,$9C,$F5,$65,$C2,
    $C7,$B9,$5A,$03,$48,$60,$BC,$E8,$9A,$5C,$7F,$67,$1A,$0C,$1F,$32,
    $0E,$57,$7D,$EF,$F1,$F0,$68,$14,$7A,$91,$03,$F5,$90,$B7,$3F,$69,
    $A5,$5F,$A1,$D8,$81,$E3,$F5,$3D,$CA,$AF,$D0,$D7,$D3,$AE,$63,$4B,
    $72,$08,$C5,$B5,$12,$A8,$40,$70,$B8,$A1,$E0,$28,$8C,$A2,$BF,$83,
    $57,$65,$B0,$2F,$8F,$3B,$19,$01,$32,$2C,$EF,$55,$A0,$8B,$FE,$20,
    $9B,$0A,$CB,$2D,$5D,$48,$D4,$CA,$50,$5F,$B2,$C4,$C2,$2E,$CA,$38,
    $6D,$10,$F2,$2B,$9A,$89,$41,$FD,$24,$BE,$2D,$54,$C6,$28,$23,$91,
    $83,$97,$86,$F6,$09,$1F,$E6,$95,$15,$6C,$3B,$41,$0E,$77,$CE,$BC,
    $EF,$70,$4C,$B6,$5B,$06,$F3,$ED,$AF,$06,$12,$EB,$80,$3F,$3E,$9B,
    $61,$0B,$0D,$CC,$7B,$B5,$0F,$CF,$DA,$D3,$36,$49,$58,$3C,$39,$90,
    $FC,$06,$35,$F6,$B3,$4D,$1A,$4C,$5C,$83,$D1,$F5,$08,$49,$CD,$DC,
    $C3,$0B,$30,$FD,$09,$9F,$4F,$28,$0E,$18,$6C,$AB,$66,$0A,$A1,$41,
    $53,$5D,$74,$FD,$20,$FB,$13,$47,$8A,$7B,$25,$16,$17,$5B,$99,$5B,
    $A7,$D8,$B5,$D5,$A9,$A0,$33,$E0,$FD,$09,$CC,$13,$A7,$DA,$D9,$E3,
    $A4,$B6,$40,$07,$D4,$9D,$DC,$B9,$A1,$3B,$89,$E6,$47,$8B,$C8,$9D,
    $1B,$E2,$93,$ED,$EC,$BD,$4C,$01,$18,$FB,$8F,$2A,$12,$FB,$38,$39,
    $5B,$35,$93,$DD,$35,$F1,$23,$B1,$73,$BF,$70,$A1,$D6,$67,$36,$BB,
    $4A,$FD,$C1,$09,$D4,$4E,$86,$1D,$71,$9B,$A3,$B8,$CE,$F8,$D9,$EE,
    $A1,$91,$1A,$A8,$82,$68,$C2,$EA,$03,$DA,$98,$CB,$C8,$5D,$83,$83,
    $9C,$45,$48,$AC,$9C,$7A,$DA,$FA,$A1,$15,$F5,$71,$26,$75,$2F,$E4,
    $E1,$8B,$E7,$20,$D1,$FC,$7D,$06,$B8,$E8,$81,$30,$AA,$12,$13,$F8,
    $46,$CC,$A2,$EB,$73,$03,$1B,$BD,$A4,$97,$E8,$E9,$BE,$B9,$2F,$93,
    $0C,$64,$24,$83,$7E,$B6,$48,$DF,$A1,$50,$59,$7F,$7B,$40,$20,$76,
    $B6,$C8,$31,$59,$E0,$5D,$D3,$A8,$FD,$AB,$37,$1F,$BC,$9F,$4E,$02,
    $DA,$41,$23,$0A,$E2,$E3,$0B,$12,$38,$DA,$77,$E8,$19,$F4,$44,$2F,
    $A0,$6D,$DF,$A1,$95,$DE,$35,$4E,$83,$7B,$5F,$CA,$F5,$1D,$0E,$76,
    $09,$98,$08,$5C,$BC,$7E,$AA,$FD,$07,$A8,$5F,$D7,$DC,$6E,$F0,$FA,
    $C7,$0F,$68,$04,$D9,$15,$DE,$1A,$E0,$CD,$D6,$6F,$CC,$D0,$43,$38,
    $BE,$7A,$D3,$C6,$96,$45,$5D,$71,$7B,$D8,$BB,$B1,$8B,$CD,$1B,$D7,
    $40,$F5,$68,$7A,$4F,$83,$6E,$8C,$DB,$BC,$CD,$8D,$78,$F8,$6C,$09,
    $A2,$BE,$9F,$3D,$CC,$1F,$07,$74,$F6,$FC,$A8,$AF,$69,$29,$CA,$B9,
    $E3,$64,$3B,$AB,$8D,$D9,$DC,$CE,$ED,$72,$34,$B3,$A9,$17,$F7,$23,
    $9A,$69,$57,$48,$3C,$E0,$38,$59,$ED,$C3,$EC,$BC,$1B,$7B,$92,$12,
    $73,$B1,$C4,$A1,$DE,$3C,$78,$B4,$BA,$4C,$97,$57,$B0,$E7,$3A,$9D,
    $76,$C6,$33,$0E,$42,$99,$E4,$58,$33,$20,$E2,$08,$33,$A8,$1C,$94,
    $D4,$F9,$7C,$FB,$28,$50,$04,$02,$49,$9E,$36,$63,$40,$F1,$28,$5C,
    $D0,$2E,$1E,$E5,$8F,$8A,$CB,$A8,$00,$A8,$51,$D1,$28,$64,$86,$51,
    $41,$B6,$23,$C4,$A8,$F6,$95,$83,$1D,$8C,$6A,$8F,$90,$53,$A1,$01,
    $14,$BB,$27,$5C,$63,$CB,$0A,$00,$99,$D4,$BB,$F0,$18,$08,$ED,$57,
    $21,$89,$F7,$41,$BA,$39,$97,$6F,$FB,$71,$E8,$C9,$C2,$63,$8B,$51,
    $AB,$79,$CC,$1E,$EA,$6F,$9A,$38,$61,$36,$48,$1C,$81,$7D,$2C,$A8,
    $13,$7C,$E6,$1D,$68,$28,$2F,$34,$88,$DB,$2F,$46,$5A,$77,$9D,$3A,
    $C6,$D5,$E3,$C5,$D0,$CC,$86,$C3,$44,$F9,$02,$41,$1E,$48,$59,$9E,
    $47,$29,$5D,$EE,$CF,$9D,$B6,$6D,$31,$CD,$46,$79,$61,$0F,$F7,$C5,
    $5F,$4E,$4E,$F2,$19,$3D,$64,$DA,$98,$CA,$CA,$16,$90,$5A,$13,$50,
    $7C,$B7,$A4,$BA,$C4,$77,$D5,$9D,$8B,$6C,$44,$42,$01,$C0,$1D,$BE,
    $2E,$0A,$BF,$9F,$4A,$84,$47,$7E,$B9,$80,$D9,$79,$8C,$AC,$DB,$A3,
    $C1,$AE,$2F,$F7,$F4,$3F,$DC,$A0,$84,$31,$A1,$F1,$32,$D9,$CA,$C1,
    $1C,$6C,$91,$2D,$98,$01,$AE,$E8,$F3,$46,$04,$E1,$64,$68,$62,$40,
    $E1,$E9,$9C,$00,$98,$3A,$D0,$13,$82,$72,$7D,$89,$4F,$10,$B8,$8A,
    $27,$04,$FC,$65,$AC,$72,$AE,$CF,$57,$26,$E5,$33,$BC,$CC,$AE,$49,
    $8E,$A3,$96,$80,$C6,$E1,$24,$E3,$20,$BA,$26,$67,$F0,$D0,$9A,$A4,
    $FD,$3C,$AA,$31,$88,$95,$66,$30,$5A,$F7,$F2,$06,$7E,$CD,$F5,$22,
    $52,$7C,$68,$4C,$10,$86,$26,$E5,$B7,$F3,$AC,$33,$0A,$2F,$E5,$4C,
    $C5,$55,$F9,$AB,$14,$37,$68,$90,$D8,$5C,$E1,$DF,$7B,$1F,$A7,$0F,
    $42,$3F,$D4,$0C,$BD,$08,$71,$96,$7F,$CB,$C6,$41,$24,$CE,$C6,$4B,
    $DD,$1E,$80,$BF,$76,$72,$AA,$0B,$5B,$D4,$80,$87,$EF,$50,$DE,$A4,
    $A7,$79,$EC,$FC,$71,$A8,$03,$42,$42,$DE,$81,$98,$43,$61,$F4,$C4,
    $DF,$20,$B4,$82,$64,$9B,$C3,$B7,$74,$6D,$EC,$EE,$3D,$BD,$B5,$D1,
    $87,$54,$D6,$9F,$C3,$D7,$8F,$30,$5A,$22,$C6,$87,$E2,$F6,$2B,$0C,
    $AD,$41,$2E,$D4,$CF,$4B,$73,$A1,$5E,$73,$F4,$41,$A8,$DF,$7B,$88,
    $A0,$9E,$A0,$87,$BD,$D4,$80,$13,$E6,$AE,$33,$BB,$4E,$5A,$CF,$DC,
    $0F,$C4,$0D,$93,$37,$62,$94,$DA,$C6,$DC,$27,$1C,$13,$9D,$DC,$27,
    $DD,$B5,$A1,$8C,$C6,$F6,$D9,$55,$30,$46,$8D,$24,$93,$B4,$01,$A4,
    $40,$7F,$D6,$AC,$FD,$C8,$92,$1A,$8A,$72,$9E,$16,$29,$5E,$52,$47,
    $5E,$7C,$8B,$97,$D4,$E3,$C4,$2C,$AB,$09,$B2,$5E,$C2,$10,$AC,$70,
    $15,$0F,$4A,$67,$77,$B5,$0B,$8E,$A0,$54,$EC,$7B,$88,$EC,$6A,$B3,
    $46,$E8,$21,$FB,$3B,$1B,$A1,$7B,$CA,$97,$D6,$49,$AC,$B6,$92,$94,
    $5F,$76,$0D,$A3,$10,$23,$F4,$A5,$79,$B8,$B5,$42,$B6,$52,$A3,$93,
    $CB,$D3,$3D,$B0,$5E,$49,$42,$D8,$F1,$31,$1B,$91,$F7,$3A,$31,$77,
    $01,$55,$10,$FA,$39,$1F,$6B,$E7,$78,$07,$2B,$CB,$9C,$6C,$64,$F5,
    $96,$D7,$3B,$54,$F3,$48,$3A,$C1,$EF,$D2,$E8,$FB,$45,$2B,$30,$A3,
    $C3,$0D,$73,$80,$9B,$1B,$9B,$9C,$FB,$05,$CD,$D2,$4B,$49,$F9,$FB,
    $D9,$8A,$CC,$CD,$DF,$8F,$38,$A0,$72,$12,$B9,$17,$62,$99,$66,$7D,
    $82,$B1,$60,$D6,$EF,$62,$BE,$CC,$D3,$DB,$80,$48,$DE,$C5,$50,$E6,
    $DA,$56,$DC,$27,$CD,$61,$EF,$13,$11,$83,$B2,$46,$70,$E5,$78,$97,
    $D4,$26,$A4,$D1,$89,$31,$1B,$39,$25,$C0,$9E,$0D,$B0,$91,$93,$02,
    $EC,$F9,$00,$62,$82,$60,$2B,$77,$E4,$61,$30,$F3,$0A,$8C,$7D,$87,
    $1F,$8C,$9F,$C5,$04,$3F,$EF,$73,$F8,$01,$A6,$6E,$CC,$F0,$D0,$C9,
    $2A,$49,$08,$C1,$4F,$1E,$F6,$23,$A0,$80,$1E,$91,$9D,$F3,$C8,$DF,
    $A1,$6A,$FD,$6F,$0F,$42,$D5,$AD,$0C,$37,$AA,$DE,$27,$A8,$0A,$2E,
    $77,$A1,$6A,$05,$B1,$01,$94,$53,$2E,$1B,$C0,$09,$AC,$11,$60,$52,
    $71,$E4,$3D,$62,$99,$6F,$2F,$C4,$D3,$89,$B6,$3E,$81,$B8,$0E,$F3,
    $2C,$47,$7B,$47,$E7,$7B,$9C,$49,$CA,$53,$81,$D2,$32,$DA,$07,$2F,
    $D7,$BD,$E7,$65,$E9,$06,$BF,$FE,$7E,$05,$6A,$1F,$72,$B0,$90,$D1,
    $7D,$87,$1B,$75,$01,$30,$48,$12,$03,$AB,$00,$DB,$C4,$64,$E6,$E0,
    $77,$6C,$2E,$85,$AE,$5C,$D8,$18,$20,$B3,$F3,$CB,$93,$91,$82,$A7,
    $7D,$87,$46,$0F,$68,$56,$3F,$A0,$DA,$41,$AC,$AC,$81,$22,$2F,$9E,
    $75,$38,$B0,$08,$BF,$42,$35,$90,$B3,$DD,$8E,$F5,$DA,$F3,$2C,$CB,
    $FF,$CC,$87,$6D,$EC,$F8,$EF,$57,$18,$C4,$63,$79,$FC,$5A,$A6,$DB,
    $B6,$66,$99,$CB,$B6,$C6,$AF,$60,$03,$CB,$01,$0E,$98,$A6,$82,$04,
    $56,$D9,$0B,$F3,$D0,$46,$07,$32,$E6,$F9,$AD,$2A,$27,$B7,$06,$37,
    $31,$DF,$1C,$80,$52,$49,$80,$6D,$15,$1E,$7E,$64,$2E,$56,$42,$F6,
    $AB,$88,$87,$31,$D0,$26,$70,$4C,$90,$91,$2A,$0F,$CC,$DF,$57,$04,
    $7E,$54,$4E,$9F,$4B,$85,$45,$24,$30,$E0,$52,$B2,$F0,$CA,$41,$7C,
    $66,$0B,$D7,$40,$A6,$C1,$96,$3E,$80,$A2,$4A,$8A,$C7,$7C,$7A,$A0,
    $DD,$C1,$AC,$83,$9F,$86,$01,$E4,$4C,$80,$80,$5A,$34,$08,$67,$B0,
    $14,$6D,$14,$E4,$38,$23,$2D,$C2,$48,$0B,$30,$52,$2B,$68,$5E,$2C,
    $EE,$99,$47,$49,$DB,$48,$81,$FD,$21,$67,$96,$B2,$C8,$CB,$32,$F6,
    $85,$C1,$2F,$F4,$A0,$C4,$EC,$E5,$A9,$3A,$36,$64,$86,$38,$73,$F8,
    $83,$1C,$0B,$1C,$BD,$1F,$55,$47,$EC,$1F,$2B,$F6,$12,$DF,$AF,$60,
    $36,$9F,$3D,$FA,$5D,$8B,$08,$8B,$75,$75,$07,$06,$5A,$FC,$60,$E2,
    $30,$78,$2B,$74,$FA,$A1,$32,$B4,$07,$AF,$65,$8F,$2F,$C1,$4F,$1D,
    $A9,$09,$68,$24,$01,$B6,$E0,$38,$B2,$2F,$5A,$4B,$76,$23,$C1,$69,
    $82,$50,$CC,$6A,$85,$B5,$43,$CF,$3E,$06,$81,$47,$82,$E3,$78,$64,
    $6D,$C0,$19,$19,$AF,$22,$46,$B4,$0B,$2C,$3D,$D0,$16,$1E,$FA,$50,
    $07,$7D,$DD,$D8,$C3,$6E,$64,$F6,$D4,$41,$55,$98,$0F,$0E,$03,$11,
    $14,$E6,$20,$5A,$23,$F1,$46,$6D,$E6,$7D,$9C,$DC,$10,$0F,$AE,$F3,
    $95,$48,$F4,$9F,$DE,$73,$F6,$FC,$87,$5C,$CF,$4F,$B7,$3E,$B0,$E7,
    $0B,$35,$38,$09,$29,$C4,$FE,$DC,$D3,$84,$05,$F4,$80,$4E,$F5,$2B,
    $18,$EC,$F6,$6D,$45,$DF,$3B,$DF,$A1,$6F,$4F,$B2,$72,$03,$75,$F7,
    $43,$7C,$91,$1A,$B3,$78,$27,$B8,$19,$44,$9A,$F1,$18,$BC,$E7,$59,
    $7B,$B3,$24,$62,$33,$D6,$12,$BA,$68,$A8,$26,$91,$EE,$F3,$AC,$5D,
    $08,$95,$91,$E4,$29,$84,$D6,$12,$EC,$85,$96,$BF,$D2,$DA,$D8,$7D,
    $D0,$69,$3B,$31,$C0,$B1,$13,$33,$B2,$17,$66,$70,$91,$84,$10,$49,
    $7A,$6C,$0F,$3F,$1B,$6A,$F5,$34,$89,$95,$41,$C2,$B3,$B1,$AE,$64,
    $61,$8D,$CC,$E9,$56,$65,$7B,$90,$25,$56,$C9,$32,$88,$A3,$26,$D1,
    $3E,$A0,$A6,$A1,$F8,$F3,$0C,$FE,$3C,$01,$3F,$0D,$25,$5E,$5C,$F5,
    $5E,$24,$24,$F8,$9C,$8B,$04,$9D,$89,$EE,$83,$DA,$CA,$DC,$C6,$9F,
    $7F,$E1,$4F,$13,$FC,$34,$CC,$F1,$72,$11,$63,$C1,$5D,$17,$31,$0A,
    $90,$F4,$56,$DC,$63,$49,$EF,$2D,$4F,$CB,$FD,$44,$AB,$8B,$F4,$B2,
    $EF,$22,$E9,$FD,$F8,$2D,$92,$9E,$2B,$FC,$3D,$08,$77,$53,$51,$74,
    $4B,$B1,$29,$CE,$83,$30,$EA,$C8,$71,$A4,$35,$98,$E4,$62,$47,$C9,
    $50,$CF,$84,$80,$94,$67,$69,$D7,$C6,$63,$A9,$C9,$AF,$E0,$35,$14,
    $07,$2C,$09,$DD,$3B,$C5,$F6,$04,$4C,$80,$02,$6C,$CD,$E3,$70,$AA,
    $98,$C0,$23,$53,$C5,$CE,$5D,$B2,$80,$74,$49,$96,$BD,$30,$F9,$AF,
    $5D,$52,$86,$F7,$8D,$EE,$4C,$26,$84,$96,$88,$C8,$3D,$83,$79,$A2,
    $76,$E0,$D8,$99,$48,$BA,$20,$EE,$01,$5D,$F4,$3A,$49,$15,$47,$C2,
    $53,$5D,$5D,$14,$73,$18,$BB,$28,$B5,$43,$17,$41,$4D,$9E,$7E,$88,
    $00,$C8,$85,$56,$33,$D9,$F0,$D3,$70,$87,$F0,$76,$10,$E8,$85,$81,
    $00,$01,$26,$A7,$66,$8D,$2B,$08,$0E,$6B,$93,$DD,$1E,$D3,$A9,$66,
    $E8,$4E,$C6,$9A,$38,$AC,$8C,$9D,$7C,$B0,$85,$35,$B1,$38,$77,$08,
    $D9,$06,$DD,$90,$AE,$D9,$6E,$37,$75,$4A,$67,$72,$A6,$B3,$17,$46,
    $B9,$AA,$FD,$31,$49,$84,$EE,$24,$5B,$E4,$BD,$A9,$CC,$D9,$BB,$30,
    $8D,$67,$85,$BD,$C5,$97,$39,$BF,$07,$6A,$79,$1A,$7E,$1A,$A3,$70,
    $EE,$5A,$E2,$D9,$F7,$09,$F3,$43,$58,$2E,$07,$F2,$A8,$65,$76,$EE,
    $C0,$EE,$3F,$B9,$1B,$A2,$FE,$E6,$8A,$B2,$6C,$3E,$D7,$FD,$1E,$1D,
    $9B,$7C,$00,$23,$7E,$8E,$11,$EB,$5D,$11,$4F,$CE,$C7,$5A,$61,$05,
    $F7,$E0,$DE,$26,$D3,$FB,$00,$8A,$04,$8F,$01,$69,$26,$0E,$14,$C6,
    $7A,$B6,$A1,$FF,$DE,$8F,$59,$24,$60,$16,$DF,$BB,$D6,$FB,$9C,$36,
    $B9,$CF,$0F,$7F,$DE,$B5,$26,$3F,$DC,$63,$4D,$7E,$F8,$70,$EA,$AF,
    $F6,$69,$30,$57,$B2,$FD,$2B,$A9,$38,$BA,$9D,$35,$67,$6D,$25,$D7,
    $7B,$94,$93,$6B,$70,$A2,$93,$8F,$65,$BB,$2E,$32,$CD,$CF,$ED,$49,
    $59,$C2,$66,$3B,$1C,$56,$7F,$87,$D5,$77,$77,$3D,$84,$80,$D4,$DC,
    $11,$0B,$D4,$A0,$BA,$ED,$60,$E7,$43,$CD,$F9,$E5,$5A,$98,$E7,$17,
    $ED,$27,$47,$9F,$8A,$33,$22,$E0,$F7,$48,$5E,$01,$57,$05,$3C,$70,
    $B3,$0F,$A2,$46,$4F,$B6,$11,$0B,$D7,$3B,$64,$47,$03,$FB,$18,$F0,
    $DE,$6E,$3B,$23,$2D,$67,$A6,$B6,$02,$EA,$C9,$DC,$49,$80,$B1,$BF,
    $BE,$E3,$81,$EC,$AA,$6C,$C4,$A4,$33,$28,$7C,$3B,$22,$60,$66,$19,
    $22,$1B,$14,$CA,$0E,$E7,$BF,$71,$F7,$70,$E4,$E8,$08,$63,$C4,$E8,
    $49,$51,$14,$DB,$CE,$09,$BB,$BB,$51,$7F,$B1,$FD,$BF,$C7,$9D,$24,
    $B4,$0A,$C8,$CE,$43,$AE,$FB,$D8,$D3,$5D,$1E,$37,$9D,$2B,$3E,$E1,
    $20,$87,$59,$19,$FC,$A9,$27,$43,$02,$37,$88,$14,$1B,$89,$7D,$D1,
    $8B,$AE,$54,$CE,$31,$64,$D1,$36,$1C,$43,$EA,$09,$C2,$FC,$0A,$3E,
    $85,$62,$9D,$21,$89,$24,$A4,$CE,$E9,$8C,$26,$CE,$5A,$17,$4A,$73,
    $72,$DD,$28,$FD,$A5,$05,$51,$CA,$90,$95,$13,$62,$00,$B5,$D4,$78,
    $8F,$51,$95,$E1,$B2,$8E,$F4,$D8,$52,$E3,$7D,$66,$58,$19,$46,$A8,
    $BA,$64,$AC,$B2,$19,$19,$1C,$80,$E1,$81,$D8,$07,$8D,$E2,$91,$7D,
    $ED,$EC,$6D,$0B,$F5,$C5,$A6,$30,$F2,$02,$52,$26,$82,$BC,$E0,$38,
    $44,$22,$5A,$6C,$E7,$98,$9F,$F6,$92,$78,$CC,$73,$FF,$76,$70,$55,
    $C0,$8B,$22,$4E,$EC,$5E,$01,$F5,$C0,$63,$52,$7D,$0E,$60,$F8,$09,
    $5B,$64,$7D,$92,$AD,$CF,$4A,$F0,$64,$8E,$FF,$89,$5B,$11,$0C,$65,
    $79,$14,$4F,$52,$11,$C1,$13,$CD,$14,$BF,$4E,$74,$36,$A7,$47,$0D,
    $DE,$F3,$EA,$B7,$0C,$0F,$63,$14,$DE,$B6,$24,$E4,$E7,$D6,$50,$D6,
    $E9,$CE,$26,$CF,$DC,$8A,$4D,$AE,$A9,$34,$B6,$52,$47,$8C,$2D,$C4,
    $A6,$2D,$C8,$1E,$7D,$14,$EF,$52,$FA,$75,$07,$4E,$5D,$E0,$B5,$86,
    $48,$8E,$3C,$34,$D0,$7C,$1A,$2B,$D4,$C2,$6E,$7C,$41,$94,$5A,$90,
    $15,$A6,$AD,$4F,$EE,$29,$C1,$0A,$56,$32,$5F,$1C,$24,$4B,$D0,$07,
    $20,$37,$9E,$3D,$B2,$02,$F9,$BC,$9E,$9D,$D7,$44,$56,$D8,$71,$91,
    $BE,$99,$99,$48,$28,$B1,$89,$69,$DF,$47,$EC,$4E,$97,$1F,$65,$77,
    $03,$98,$1B,$88,$A2,$E8,$26,$F6,$98,$13,$4D,$2C,$8D,$BA,$B1,$2B,
    $52,$9F,$E3,$B2,$1A,$7E,$3E,$A2,$89,$39,$FB,$3D,$B6,$B6,$1C,$3A,
    $F1,$2D,$2E,$59,$F7,$F3,$E4,$F2,$8A,$C2,$D7,$28,$3C,$6E,$D9,$4A,
    $35,$BE,$8A,$CD,$B3,$BC,$8C,$95,$C6,$C6,$87,$83,$2E,$3D,$31,$B8,
    $D8,$58,$0D,$8D,$43,$C2,$B3,$47,$EE,$25,$FB,$50,$35,$6C,$B5,$8C,
    $7B,$4D,$F6,$C8,$1D,$1E,$F5,$34,$EE,$B0,$47,$97,$31,$BF,$6F,$47,
    $DE,$28,$DB,$CA,$9B,$CA,$4C,$FE,$81,$98,$9C,$FA,$90,$CC,$05,$0E,
    $63,$8B,$23,$B2,$DA,$BA,$1B,$71,$61,$21,$17,$4E,$6D,$3A,$CB,$9E,
    $FF,$C0,$70,$E2,$0B,$4A,$47,$1D,$6A,$76,$91,$A5,$1E,$D9,$46,$97,
    $E2,$37,$0F,$10,$8B,$78,$4F,$03,$88,$A7,$40,$7B,$E4,$66,$CF,$F0,
    $CD,$CE,$11,$9C,$74,$26,$B9,$AA,$4A,$05,$04,$07,$3D,$E7,$F0,$2B,
    $1C,$D9,$EE,$20,$27,$5A,$AD,$7D,$89,$ED,$15,$CE,$FF,$98,$5E,$E7,
    $9C,$E5,$DE,$A5,$DC,$69,$FC,$5B,$3C,$D8,$53,$9D,$CB,$5E,$96,$35,
    $38,$D7,$AD,$0F,$D5,$90,$88,$35,$CC,$9A,$AF,$3D,$B6,$CB,$86,$73,
    $11,$83,$3C,$22,$3A,$45,$68,$A6,$67,$C4,$A7,$B8,$88,$01,$1E,$11,
    $EB,$48,$C4,$3A,$66,$B4,$67,$C4,$C7,$B9,$88,$BE,$1E,$11,$EB,$49,
    $C4,$7A,$46,$E8,$19,$B1,$77,$6E,$88,$47,$F5,$BB,$7C,$8D,$22,$64,
    $D0,$0E,$14,$21,$87,$1B,$FA,$E1,$73,$F7,$E1,$06,$3F,$7C,$16,$1D,
    $6E,$E8,$0A,$CF,$06,$BC,$35,$F5,$70,$43,$1B,$C8,$9A,$06,$A1,$A7,
    $BE,$99,$9C,$8B,$33,$C7,$CD,$7B,$F0,$33,$7B,$4C,$CA,$6E,$14,$CC,
    $4D,$AC,$9D,$62,$EC,$6E,$B2,$FF,$07,$29,$1A,$AF,$2C,$35,$DE,$ED,
    $60,$E7,$87,$B1,$C3,$8C,$11,$C6,$28,$63,$D8,$E8,$89,$9C,$50,$74,
    $CA,$6B,$A7,$7D,$0D,$F2,$04,$ED,$94,$CD,$1B,$B9,$4D,$E4,$B2,$E2,
    $E9,$9B,$8B,$A7,$6F,$74,$5B,$35,$16,$2D,$72,$2F,$22,$EE,$85,$41,
    $39,$0C,$8B,$D6,$7D,$D9,$EE,$38,$62,$DC,$8B,$EF,$47,$8C,$F8,$2D,
    $06,$2A,$A9,$D8,$DA,$34,$05,$62,$98,$3C,$8F,$7D,$E2,$59,$16,$E0,
    $7C,$F0,$63,$D2,$6B,$89,$0D,$7C,$14,$D3,$F7,$32,$1A,$69,$7E,$1C,
    $30,$9D,$DC,$17,$63,$37,$96,$01,$A1,$6E,$26,$7B,$38,$B5,$15,$48,
    $9C,$9B,$8B,$8D,$A5,$95,$C6,$1D,$DD,$ED,$C6,$52,$E0,$C4,$8D,$8C,
    $66,$1D,$FA,$6E,$C4,$43,$F3,$1F,$DD,$41,$16,$2B,$DB,$5D,$02,$55,
    $02,$A1,$22,$BC,$06,$8A,$90,$F7,$76,$0F,$A4,$BF,$B9,$08,$71,$B5,
    $91,$45,$8F,$AE,$0C,$71,$55,$C6,$3C,$5A,$86,$68,$FA,$74,$9B,$DB,
    $96,$EF,$B0,$DB,$AE,$27,$34,$D3,$1C,$6F,$31,$73,$36,$14,$E0,$9E,
    $34,$81,$BB,$79,$70,$B6,$C3,$E6,$6D,$62,$8A,$B1,$B2,$D5,$36,$6F,
    $86,$AA,$61,$BF,$3A,$40,$C2,$F0,$1E,$0D,$6E,$8F,$0B,$E2,$CC,$BD,
    $04,$71,$42,$F9,$26,$26,$11,$5E,$A6,$39,$6D,$00,$19,$D7,$5D,$48,
    $CD,$B6,$E9,$02,$32,$DC,$D9,$41,$DF,$C6,$B5,$DC,$65,$64,$5C,$8F,
    $4E,$9E,$BC,$D8,$7D,$EF,$8A,$A5,$0B,$8E,$62,$DE,$64,$9F,$AE,$3B,
    $1E,$A6,$C9,$72,$90,$C5,$3D,$57,$D3,$A6,$2F,$66,$2F,$21,$78,$83,
    $90,$C9,$D9,$AD,$EC,$A1,$72,$E7,$4A,$1E,$B9,$FF,$83,$94,$BB,$92,
    $EB,$C7,$95,$C5,$D3,$57,$17,$4F,$5F,$5B,$3C,$BD,$A4,$78,$7A,$5D,
    $51,$E4,$7D,$B2,$8A,$84,$A5,$2E,$2E,$76,$96,$BA,$34,$D4,$79,$79,
    $85,$5F,$E1,$00,$DC,$F6,$70,$9A,$2C,$26,$A0,$5A,$2B,$39,$8F,$77,
    $3D,$B9,$17,$44,$C9,$40,$8D,$E7,$46,$07,$05,$03,$72,$37,$7E,$8B,
    $13,$D0,$66,$7F,$BF,$37,$0F,$F2,$C8,$91,$58,$E6,$1C,$E8,$2D,$76,
    $D3,$A0,$DD,$F8,$A1,$02,$E7,$B2,$2A,$67,$DE,$99,$4B,$96,$35,$5B,
    $1A,$FD,$5F,$03,$07,$04,$2F,$EA,$8A,$42,$2B,$98,$22,$63,$AC,$75,
    $22,$44,$E1,$E7,$44,$60,$1E,$6F,$43,$1E,$F9,$E5,$83,$5E,$53,$99,
    $C6,$76,$F1,$B1,$AA,$B7,$F1,$4A,$79,$CC,$C2,$8F,$39,$9B,$49,$5C,
    $6F,$47,$61,$E1,$57,$30,$0E,$8B,$0C,$35,$C1,$60,$C3,$14,$ED,$02,
    $42,$0C,$8D,$12,$12,$A9,$D9,$52,$1C,$1A,$D3,$20,$E6,$B1,$F9,$FA,
    $AD,$2C,$DF,$8D,$14,$BF,$07,$C3,$98,$E4,$AD,$DC,$4D,$CE,$F9,$E5,
    $5E,$43,$2B,$FD,$96,$A1,$85,$22,$48,$CF,$5A,$2C,$35,$08,$6B,$9E,
    $23,$72,$BC,$66,$30,$8D,$F5,$E6,$FB,$15,$7E,$86,$E4,$9C,$BF,$58,
    $D0,$7B,$5E,$60,$92,$6D,$94,$20,$29,$BF,$75,$A6,$DF,$EB,$2B,$88,
    $67,$6B,$82,$DF,$1B,$4B,$E0,$2D,$EF,$D5,$00,$CA,$FA,$0C,$11,$5D,
    $C4,$CA,$7D,$F7,$18,$72,$89,$57,$E4,$7A,$A8,$F0,$0B,$9F,$20,$C1,
    $AE,$27,$D6,$9B,$1B,$8B,$71,$85,$1F,$E7,$6A,$F6,$D0,$00,$E6,$71,
    $08,$F1,$FB,$66,$4A,$FF,$FC,$43,$03,$FD,$BE,$19,$1F,$E4,$7D,$8A,
    $3E,$B4,$88,$26,$8D,$5C,$55,$C2,$36,$12,$88,$E0,$60,$5D,$4F,$5B,
    $7B,$FE,$4D,$A1,$F7,$11,$AE,$BD,$96,$27,$B9,$B6,$AE,$DD,$89,$36,
    $03,$51,$B8,$8C,$0B,$61,$31,$8D,$DD,$46,$3A,$22,$6B,$61,$DA,$0E,
    $14,$C1,$21,$36,$47,$99,$F7,$2A,$8F,$B2,$8A,$C9,$71,$46,$6C,$5A,
    $08,$CA,$8B,$77,$49,$97,$44,$D6,$2D,$8D,$7A,$D4,$51,$14,$25,$72,
    $8C,$CC,$6F,$17,$5A,$7F,$72,$E0,$36,$31,$74,$E0,$72,$03,$0A,$61,
    $4C,$16,$20,$3D,$0D,$55,$E9,$C6,$55,$65,$BB,$57,$C3,$9A,$AE,$6C,
    $2E,$27,$41,$3E,$E5,$D1,$94,$A5,$AB,$F4,$52,$C3,$1B,$5D,$B1,$F5,
    $DE,$40,$32,$63,$F1,$B6,$3C,$42,$3C,$21,$E4,$0D,$7A,$A6,$30,$90,
    $C7,$E1,$86,$60,$E5,$D3,$D1,$6E,$AC,$F4,$FB,$B8,$23,$56,$2A,$43,
    $FD,$79,$48,$4D,$E4,$9E,$C1,$A9,$58,$4D,$40,$D0,$BD,$12,$EC,$A5,
    $23,$C6,$E6,$1B,$D0,$00,$DA,$DA,$9C,$CB,$97,$DE,$6E,$F4,$1E,$6A,
    $05,$AF,$A6,$60,$5C,$7C,$39,$46,$36,$F9,$C8,$D0,$82,$15,$43,$9D,
    $CC,$56,$85,$D3,$0B,$D6,$B3,$33,$C1,$81,$22,$DC,$42,$1B,$9B,$17,
    $F9,$70,$3B,$DB,$B9,$2D,$F9,$37,$7B,$E3,$6D,$76,$6A,$4C,$3D,$18,
    $05,$44,$98,$CA,$C1,$91,$9B,$90,$34,$BF,$FB,$47,$AC,$55,$2E,$46,
    $F0,$66,$23,$F8,$D9,$A8,$E2,$50,$DF,$C6,$2E,$78,$A3,$F7,$91,$C2,
    $DB,$8B,$86,$63,$FB,$AD,$43,$5E,$6B,$FF,$1D,$6A,$99,$DB,$2D,$BF,
    $B2,$77,$B1,$B5,$19,$2A,$DA,$E3,$B5,$1B,$E8,$03,$D5,$C7,$46,$39,
    $22,$9B,$00,$47,$0E,$34,$9A,$A9,$63,$EC,$20,$A5,$48,$AA,$C7,$08,
    $CD,$F4,$20,$9D,$5E,$B2,$8E,$2D,$CA,$16,$1A,$84,$DB,$CA,$59,$BE,
    $85,$B7,$73,$BB,$6E,$E7,$37,$0C,$F6,$61,$51,$6C,$E9,$8D,$38,$B9,
    $0E,$15,$A2,$9B,$17,$75,$DD,$EE,$DD,$D0,$DD,$19,$F0,$98,$6D,$92,
    $2F,$E0,$82,$E3,$4C,$3A,$D4,$D7,$32,$12,$D2,$35,$75,$61,$3B,$C4,
    $A2,$46,$E4,$77,$0B,$77,$38,$86,$86,$C6,$40,$4C,$34,$F2,$68,$B1,
    $87,$C6,$98,$66,$13,$33,$68,$10,$BA,$63,$A3,$EC,$93,$C8,$E5,$73,
    $EA,$5F,$C9,$65,$6C,$16,$2C,$F6,$2B,$FC,$B4,$69,$A8,$2F,$70,$39,
    $29,$E3,$D1,$24,$5B,$A8,$37,$E3,$BB,$8E,$BD,$43,$6B,$1D,$E1,$F2,
    $2D,$20,$FF,$87,$13,$D9,$FA,$19,$30,$AA,$B1,$99,$8F,$8C,$46,$EA,
    $9C,$D1,$05,$59,$32,$06,$24,$F6,$16,$D3,$6C,$BE,$67,$11,$E7,$AE,
    $BB,$CC,$BC,$17,$8D,$47,$56,$27,$85,$05,$77,$C1,$2B,$71,$B7,$98,
    $C6,$76,$15,$58,$D5,$90,$93,$AF,$2B,$A7,$67,$B8,$9C,$60,$FC,$F0,
    $F5,$CC,$67,$B9,$2B,$1F,$5F,$4B,$01,$C4,$6B,$E7,$23,$9F,$B7,$50,
    $7E,$CB,$7F,$43,$8E,$37,$36,$F7,$77,$65,$F1,$33,$9F,$D0,$ED,$9E,
    $81,$58,$D5,$F6,$5D,$48,$5B,$58,$B3,$3A,$46,$B2,$0B,$E5,$0B,$DF,
    $34,$BB,$BF,$67,$CE,$B2,$EB,$78,$C6,$A0,$BF,$5F,$E1,$FB,$1C,$D7,
    $74,$87,$68,$4B,$83,$F9,$45,$A0,$33,$81,$EB,$CF,$9D,$E8,$EA,$52,
    $64,$DC,$89,$AE,$9B,$E0,$4A,$B2,$05,$FB,$24,$15,$1B,$77,$A1,$FB,
    $2A,$EB,$16,$80,$BB,$8C,$F0,$0A,$B8,$6D,$C1,$DD,$8A,$8D,$7B,$D0,
    $75,$90,$B8,$7A,$16,$1B,$F7,$A3,$6B,$3B,$71,$F5,$2A,$36,$1E,$42,
    $D7,$67,$C4,$D5,$B7,$D8,$58,$89,$AE,$F7,$D8,$7C,$FA,$43,$3E,$DF,
    $A3,$FB,$0D,$D6,$1D,$04,$EE,$13,$0D,$02,$B2,$CF,$BB,$45,$87,$74,
    $EA,$57,$80,$9F,$F1,$84,$57,$9E,$97,$5F,$C1,$4D,$78,$85,$06,$DF,
    $F2,$26,$18,$18,$EE,$C2,$C0,$4F,$DE,$A8,$5A,$6E,$D9,$3D,$9C,$FA,
    $8B,$30,$F6,$5B,$BE,$87,$2C,$18,$B5,$0C,$27,$1D,$F1,$8D,$B7,$33,
    $6B,$CC,$EF,$23,$36,$6B,$2C,$65,$25,$11,$73,$FE,$20,$6E,$F3,$31,
    $93,$D0,$A0,$C2,$F2,$45,$61,$3C,$A0,$53,$27,$E9,$11,$FD,$2E,$CB,
    $97,$AE,$24,$F9,$A4,$63,$15,$2A,$87,$03,$27,$3C,$B8,$5C,$B6,$B4,
    $D1,$1E,$A5,$59,$E4,$A4,$24,$CB,$70,$C2,$0C,$EF,$AC,$E9,$C0,$0C,
    $67,$96,$C2,$90,$05,$7D,$33,$E4,$2E,$DA,$4C,$35,$3C,$0A,$E9,$80,
    $01,$BA,$C1,$03,$04,$07,$C5,$EE,$FA,$6C,$E7,$35,$DC,$F5,$E2,$C8,
    $08,$F2,$09,$22,$64,$DB,$83,$90,$6D,$F4,$1A,$A2,$DC,$FA,$93,$30,
    $9E,$97,$15,$E3,$FE,$E0,$C5,$71,$0F,$1B,$45,$E2,$19,$C5,$1B,$A9,
    $D2,$AB,$61,$93,$17,$DE,$32,$6D,$FC,$1E,$AA,$0C,$12,$95,$0F,$58,
    $CF,$C1,$A1,$CA,$9B,$A0,$BF,$85,$47,$24,$26,$8B,$E0,$3C,$2F,$42,
    $2A,$68,$0D,$F1,$E1,$0E,$F6,$D6,$B2,$45,$2F,$38,$C9,$EC,$F8,$76,
    $3C,$FD,$DB,$89,$D5,$7E,$FC,$D9,$CD,$6A,$23,$88,$91,$41,$1D,$73,
    $7A,$2B,$B9,$53,$E1,$69,$18,$88,$B8,$5B,$F5,$EB,$F0,$13,$0B,$2F,
    $E2,$05,$68,$75,$4C,$C1,$F6,$76,$F2,$8D,$85,$58,$94,$F3,$D6,$9F,
    $31,$C1,$C7,$5B,$49,$CE,$75,$4C,$EC,$76,$3C,$5D,$52,$32,$95,$F9,
    $72,$03,$CE,$65,$4A,$30,$7E,$F9,$D7,$78,$88,$7C,$7B,$77,$AB,$6F,
    $5E,$EE,$B6,$80,$79,$3E,$F0,$FB,$58,$66,$5F,$7B,$F4,$5A,$4C,$30,
    $E5,$1B,$8C,$B7,$16,$E3,$AD,$86,$78,$D0,$CA,$B2,$E2,$50,$81,$3D,
    $54,$88,$23,$CB,$88,$AF,$51,$B1,$AA,$CE,$AF,$33,$14,$87,$8A,$6C,
    $C6,$CA,$E2,$50,$99,$CD,$78,$A8,$38,$54,$65,$33,$EE,$2F,$0E,$D5,
    $E2,$55,$76,$76,$E3,$9E,$24,$1B,$C5,$3E,$82,$BD,$4C,$CC,$37,$A7,
    $B1,$EA,$16,$7F,$08,$93,$9E,$66,$46,$7F,$EE,$70,$5C,$9E,$36,$64,
    $4D,$A3,$C0,$79,$3C,$21,$C9,$66,$DC,$95,$94,$5F,$C7,$4B,$42,$CB,
    $85,$95,$E5,$45,$A1,$C1,$30,$99,$84,$19,$C9,$C1,$FD,$38,$3B,$96,
    $9E,$BE,$73,$DB,$D6,$7C,$F0,$BA,$C0,$76,$70,$37,$E7,$FE,$97,$F7,
    $AD,$E2,$2C,$72,$70,$41,$48,$25,$D9,$AC,$27,$92,$0A,$6F,$CF,$D3,
    $FA,$7D,$53,$E9,$89,$F5,$6E,$3C,$A7,$6C,$80,$80,$0E,$D8,$CD,$B8,
    $86,$43,$6B,$F4,$09,$FA,$10,$41,$F0,$4F,$38,$5A,$DB,$8C,$3F,$26,
    $C1,$4C,$6C,$09,$5A,$F3,$F8,$7D,$43,$AE,$DF,$EA,$D8,$89,$DF,$52,
    $AE,$4E,$AC,$D9,$E6,$96,$12,$BE,$DB,$1E,$D0,$7D,$7E,$D7,$DC,$DD,
    $97,$CF,$76,$15,$D3,$BB,$94,$EB,$8D,$1F,$B7,$62,$6F,$AC,$9E,$CA,
    $0C,$F8,$1C,$B1,$BC,$9A,$C8,$9A,$2D,$0F,$EE,$8D,$95,$98,$E0,$D8,
    $4E,$8C,$B7,$12,$E3,$75,$DB,$82,$25,$47,$60,$37,$7C,$FB,$15,$3B,
    $4A,$70,$14,$BA,$62,$35,$4B,$A1,$D0,$15,$CE,$5A,$F3,$B7,$F3,$1B,
    $71,$4D,$02,$58,$44,$7A,$C9,$A5,$1B,$2E,$29,$46,$DD,$70,$25,$BB,
    $5C,$33,$F2,$AB,$76,$32,$E4,$F4,$FF,$0A,$D5,$DE,$CD,$1B,$50,$ED,
    $ED,$70,$36,$3F,$BF,$A2,$8C,$D3,$11,$AB,$8A,$A7,$EF,$25,$1A,$7F,
    $75,$F1,$F4,$9A,$E2,$E9,$B5,$C5,$D3,$9B,$40,$59,$74,$6E,$90,$4D,
    $F8,$14,$37,$83,$DD,$1F,$87,$28,$B1,$BB,$77,$27,$7C,$F3,$B2,$83,
    $29,$CB,$58,$5B,$8F,$A3,$A0,$C6,$DB,$FA,$08,$67,$84,$50,$4B,$8D,
    $02,$E6,$75,$98,$BB,$91,$43,$D0,$B8,$00,$17,$2C,$2C,$36,$D6,$57,
    $1A,$99,$EE,$2C,$F9,$D4,$31,$2D,$6F,$93,$8B,$06,$50,$93,$3F,$DB,
    $48,$26,$CB,$53,$99,$30,$48,$C1,$18,$36,$A0,$CB,$97,$58,$78,$F0,
    $32,$BB,$E5,$33,$5D,$2D,$BA,$86,$0D,$84,$47,$C0,$D3,$C4,$E6,$16,
    $C5,$3E,$62,$D8,$87,$0C,$B7,$C2,$65,$3C,$93,$ED,$47,$A2,$A1,$32,
    $B2,$9F,$D8,$C5,$93,$96,$86,$B3,$C8,$E6,$B9,$02,$90,$5B,$9B,$C8,
    $76,$8E,$AF,$6D,$5A,$54,$FE,$7D,$EF,$1C,$2D,$A4,$CB,$2F,$37,$31,
    $C3,$4B,$DB,$C9,$97,$FF,$26,$46,$55,$86,$F9,$FF,$99,$CD,$F9,$06,
    $7A,$FA,$B6,$AF,$45,$DF,$E4,$28,$BC,$91,$2D,$3F,$38,$C6,$AB,$31,
    $C1,$96,$EB,$6B,$5B,$1C,$53,$E8,$58,$34,$DC,$6E,$AC,$25,$35,$38,
    $89,$3F,$67,$D8,$0A,$32,$BD,$30,$35,$7E,$90,$10,$F3,$DA,$53,$6D,
    $C7,$33,$C0,$D0,$AD,$8D,$FE,$9E,$3E,$97,$BF,$24,$AD,$3C,$12,$1C,
    $C5,$B2,$3A,$49,$59,$F5,$15,$29,$B7,$78,$44,$8C,$DD,$58,$63,$22,
    $35,$30,$ED,$C6,$E8,$88,$CE,$37,$90,$9A,$9C,$DE,$51,$64,$81,$06,
    $BD,$D7,$7E,$8E,$06,$38,$E8,$17,$B3,$DB,$8B,$F3,$2B,$72,$F9,$A9,
    $F2,$0F,$79,$E5,$1F,$73,$A0,$67,$16,$7A,$2E,$9D,$2E,$C8,$FB,$83,
    $37,$C9,$F6,$E3,$36,$DE,$C7,$68,$ED,$CC,$3C,$52,$47,$06,$52,$EC,
    $D2,$85,$CB,$3C,$37,$6C,$A9,$A5,$91,$78,$89,$A2,$C3,$E4,$CF,$2D,
    $C9,$0D,$5D,$E6,$9E,$FA,$55,$9B,$F0,$D3,$87,$A3,$4D,$D2,$D3,$98,
    $F3,$EF,$9F,$61,$CD,$38,$BF,$28,$D6,$AF,$0B,$A9,$02,$7A,$C4,$B0,
    $1E,$2D,$9F,$39,$EB,$24,$E3,$2A,$74,$0D,$7D,$26,$81,$BE,$C6,$76,
    $DA,$E2,$AB,$EE,$79,$6E,$E3,$88,$86,$88,$4F,$D8,$0D,$AC,$58,$8F,
    $5A,$35,$33,$DF,$7F,$E4,$31,$C1,$4B,$58,$E6,$BA,$20,$8B,$7F,$B8,
    $E1,$E4,$7A,$9C,$05,$31,$41,$A0,$8C,$30,$73,$3E,$73,$47,$6B,$C0,
    $63,$47,$0D,$7F,$7E,$CC,$66,$77,$DA,$95,$1D,$B1,$0A,$79,$8E,$ED,
    $13,$5C,$2C,$99,$28,$60,$C2,$37,$11,$8B,$18,$5B,$B0,$2F,$E9,$85,
    $28,$F2,$EE,$CF,$F6,$88,$AB,$D4,$0B,$CB,$D8,$D3,$65,$86,$8F,$90,
    $A5,$5E,$62,$4B,$FD,$1C,$1E,$CC,$BF,$F1,$3D,$A9,$33,$1B,$BC,$7A,
    $86,$B0,$41,$95,$C9,$1E,$BD,$97,$A5,$6B,$66,$C5,$F7,$88,$B0,$BD,
    $C5,$C6,$F2,$4A,$63,$45,$77,$27,$7B,$1C,$AD,$34,$9E,$00,$F6,$28,
    $37,$E1,$3C,$35,$F7,$4D,$B2,$36,$43,$BA,$79,$2A,$39,$37,$6B,$33,
    $56,$4D,$65,$9E,$84,$CC,$98,$01,$EB,$59,$0E,$C1,$DD,$70,$21,$D9,
    $75,$14,$14,$99,$06,$C3,$CB,$91,$E0,$21,$EC,$7A,$67,$1B,$59,$EF,
    $1F,$E6,$AA,$F3,$06,$3B,$CA,$84,$32,$76,$2A,$2C,$F9,$02,$65,$42,
    $D5,$9E,$2E,$64,$4F,$96,$38,$9A,$98,$BB,$1B,$B1,$35,$36,$E0,$F2,
    $46,$54,$AA,$D9,$33,$70,$CC,$F6,$8F,$3A,$EC,$46,$1B,$DB,$DC,$9F,
    $6D,$70,$AE,$ED,$66,$AF,$E5,$D6,$0C,$6A,$27,$4D,$C6,$2B,$6D,$99,
    $E2,$C8,$5A,$26,$FF,$23,$E7,$6D,$69,$E4,$7B,$7A,$6F,$76,$B0,$04,
    $10,$92,$25,$5B,$78,$19,$42,$84,$70,$9B,$2D,$86,$4F,$9C,$C3,$F0,
    $22,$41,$5C,$67,$4D,$85,$19,$70,$32,$31,$DF,$C0,$2F,$8B,$E5,$E7,
    $36,$51,$D6,$E7,$C8,$1A,$AF,$89,$D8,$27,$08,$98,$92,$8D,$EC,$7D,
    $5E,$D8,$4F,$CD,$A4,$9F,$58,$63,$44,$78,$8F,$E1,$D2,$91,$2F,$2B,
    $31,$BD,$75,$EC,$44,$AF,$B9,$38,$43,$46,$F2,$21,$BA,$7F,$06,$8C,
    $64,$2D,$77,$AA,$48,$7C,$AD,$FB,$46,$B5,$19,$1F,$E2,$D0,$DD,$04,
    $B2,$62,$3D,$C5,$6E,$72,$8D,$7E,$D3,$63,$4E,$8E,$16,$A7,$63,$3F,
    $F4,$20,$3F,$D3,$9B,$EC,$EA,$4F,$C8,$9B,$EE,$D5,$1F,$A8,$BD,$D1,
    $59,$F3,$A1,$CE,$3A,$37,$61,$9D,$9B,$88,$58,$6B,$F2,$A8,$73,$93,
    $AB,$CE,$8D,$8F,$E2,$1A,$5B,$92,$96,$DC,$AF,$4E,$BC,$54,$6E,$7B,
    $F8,$37,$43,$C8,$12,$60,$D5,$5A,$62,$FF,$FE,$31,$92,$DB,$E1,$86,
    $6B,$F8,$7C,$DD,$59,$D2,$38,$52,$70,$B8,$B3,$55,$F4,$08,$AD,$85,
    $26,$77,$A7,$01,$A2,$11,$DD,$75,$95,$C6,$FA,$EE,$78,$53,$15,$C8,
    $2B,$66,$BC,$9D,$6C,$DF,$A0,$E0,$8D,$BD,$CE,$2E,$D8,$F6,$C9,$98,
    $8E,$67,$6D,$AB,$80,$B6,$0E,$7E,$EC,$D1,$C2,$13,$6F,$92,$EB,$5D,
    $98,$DA,$CF,$91,$48,$18,$A6,$FA,$73,$AC,$43,$12,$96,$CD,$B8,$EF,
    $9E,$5B,$F2,$21,$1E,$57,$73,$9E,$3B,$26,$26,$14,$78,$3D,$CF,$E3,
    $B5,$78,$E6,$D8,$F6,$27,$4C,$94,$72,$7A,$8D,$B2,$4D,$1E,$B2,$D4,
    $9B,$39,$59,$09,$D2,$66,$E4,$90,$D0,$F1,$D6,$9B,$B6,$EF,$5C,$DF,
    $AD,$73,$A7,$19,$FA,$80,$34,$6B,$FE,$9A,$C6,$F6,$FD,$C7,$4C,$4D,
    $30,$B5,$8D,$C7,$F4,$84,$39,$D5,$61,$D6,$6E,$C9,$39,$52,$6D,$58,
    $CB,$5E,$8F,$88,$EB,$FB,$B3,$79,$C4,$6E,$23,$00,$F5,$46,$D6,$BE,
    $E2,$A7,$B5,$9D,$ED,$2B,$DC,$EB,$25,$13,$76,$3F,$F6,$97,$3D,$7A,
    $DB,$5D,$CE,$7E,$D6,$1A,$E0,$71,$69,$9E,$CD,$18,$E8,$7C,$B5,$1B,
    $F3,$B8,$85,$92,$B4,$2F,$59,$11,$53,$BC,$CA,$4D,$EE,$AD,$4C,$C9,
    $67,$AC,$F1,$55,$F1,$28,$A0,$F2,$20,$2E,$31,$B3,$14,$7D,$2F,$B1,
    $09,$21,$07,$A6,$1D,$D2,$32,$3F,$7C,$C7,$1E,$27,$F0,$2B,$34,$12,
    $1D,$D3,$DF,$46,$31,$2F,$AC,$73,$90,$6F,$12,$10,$47,$E9,$06,$5C,
    $C5,$06,$9D,$BA,$19,$58,$56,$7A,$8C,$09,$DC,$84,$16,$99,$2B,$0F,
    $13,$9D,$F9,$E5,$15,$A8,$33,$1B,$5F,$73,$85,$DE,$FB,$02,$93,$2E,
    $03,$56,$47,$B1,$DB,$8B,$D9,$F2,$19,$D9,$F0,$67,$03,$2F,$93,$C0,
    $6A,$97,$FB,$07,$E2,$AE,$C1,$CB,$41,$71,$AD,$BA,$F0,$B6,$5F,$41,
    $39,$59,$91,$E6,$C2,$BF,$22,$E1,$45,$E4,$4E,$E7,$C2,$1C,$07,$8A,
    $34,$67,$D0,$FE,$2F,$70,$0B,$3F,$87,$4C,$6E,$4B,$98,$70,$28,$65,
    $B6,$C0,$1E,$B9,$91,$0D,$67,$84,$5F,$38,$DC,$A5,$CE,$22,$B9,$94,
    $BA,$DC,$53,$88,$7B,$87,$CB,$3D,$8A,$B8,$CB,$5C,$6E,$25,$71,$EF,
    $75,$B9,$9F,$FD,$82,$34,$B8,$BC,$C8,$58,$CE,$D6,$24,$BB,$43,$4D,
    $64,$A4,$26,$D9,$A4,$26,$27,$98,$FD,$44,$4C,$FA,$33,$03,$D7,$E3,
    $51,$16,$4B,$8F,$C2,$DB,$96,$47,$F0,$AE,$C2,$86,$2A,$D2,$B0,$BC,
    $AD,$68,$F8,$C1,$54,$37,$91,$4F,$32,$E5,$B7,$F2,$FD,$DE,$C0,$EF,
    $52,$3A,$06,$17,$7E,$F9,$76,$08,$75,$00,$E0,$28,$C0,$29,$80,$16,
    $80,$7E,$EF,$84,$90,$8B,$0E,$1B,$DE,$A1,$D8,$9B,$E8,$C9,$1D,$A8,
    $F6,$42,$0B,$14,$C6,$44,$2D,$C5,$63,$2F,$F8,$CA,$8A,$7D,$E6,$D5,
    $1F,$C0,$77,$DE,$3A,$E0,$93,$59,$F6,$42,$FC,$9A,$22,$33,$9D,$44,
    $C9,$70,$47,$89,$C1,$28,$93,$30,$4A,$98,$BD,$30,$15,$A3,$24,$91,
    $28,$A9,$EE,$28,$72,$8C,$22,$C2,$28,$4F,$D8,$0B,$93,$31,$4A,$3A,
    $89,$92,$EC,$8E,$D2,$0B,$A3,$F4,$58,$87,$CA,$E5,$1D,$10,$5C,$CD,
    $84,$6E,$5A,$61,$0A,$C0,$E4,$A0,$C2,$66,$DC,$58,$DC,$15,$17,$51,
    $09,$ED,$D9,$A2,$4B,$09,$F1,$D9,$A2,$4F,$30,$33,$3E,$65,$39,$DA,
    $EB,$53,$94,$79,$25,$94,$E5,$71,$FB,$AA,$44,$32,$74,$94,$30,$FD,
    $77,$00,$46,$F6,$A1,$0B,$72,$1C,$C6,$6E,$A7,$80,$E4,$C8,$C3,$D3,
    $2D,$A0,$36,$34,$61,$B9,$4B,$C9,$85,$12,$F5,$48,$EE,$FC,$95,$4E,
    $72,$67,$57,$FB,$CE,$E1,$EA,$F7,$BC,$B3,$1E,$8B,$D6,$3F,$AF,$44,
    $11,$56,$CF,$F4,$58,$8D,$E2,$E3,$D9,$0F,$51,$84,$D9,$57,$C5,$91,
    $E2,$8A,$98,$8F,$3E,$20,$5B,$BA,$5C,$E1,$3F,$AC,$C7,$E3,$45,$B1,
    $D8,$D8,$25,$24,$00,$5F,$1D,$D6,$12,$BB,$3D,$86,$74,$EB,$46,$F6,
    $AE,$A9,$A5,$24,$8C,$78,$AD,$8A,$22,$49,$4B,$99,$C9,$C4,$2F,$8A,
    $F8,$99,$88,$DF,$0E,$66,$04,$F1,$33,$11,$BF,$08,$E2,$57,$C6,$0C,
    $27,$7E,$11,$C4,$2F,$9C,$F8,$ED,$65,$FA,$13,$BF,$70,$E2,$17,$46,
    $16,$DC,$97,$1A,$CB,$19,$3E,$F1,$0D,$23,$71,$4E,$30,$12,$52,$B5,
    $60,$AC,$5A,$E3,$FB,$18,$10,$4C,$AA,$76,$02,$8D,$29,$BA,$63,$A5,
    $4E,$AD,$6F,$27,$BB,$54,$7E,$AB,$F0,$C0,$8C,$7D,$95,$16,$A3,$96,
    $93,$A8,$5A,$92,$B3,$8A,$E4,$B4,$8C,$D9,$4C,$FC,$54,$C4,$4F,$46,
    $FC,$AA,$99,$D5,$C4,$4F,$46,$FC,$44,$C4,$AF,$86,$29,$20,$7E,$22,
    $52,$0C,$03,$A4,$CC,$0E,$D9,$B3,$9D,$C3,$7F,$15,$F3,$9E,$A7,$B4,
    $5E,$B1,$0A,$37,$72,$31,$F6,$1E,$3C,$AE,$C9,$8C,$F9,$18,$FB,$D8,
    $29,$9D,$D6,$6E,$60,$7B,$DC,$FF,$63,$EC,$84,$4F,$D6,$40,$27,$80,
    $5E,$76,$87,$1B,$D0,$03,$59,$F9,$D7,$BD,$93,$FC,$43,$FB,$61,$76,
    $0C,$CF,$5D,$ED,$B2,$84,$2B,$27,$73,$F8,$36,$D6,$44,$BE,$D8,$58,
    $D1,$D8,$7B,$36,$05,$12,$B9,$75,$1B,$91,$C8,$A5,$0A,$A4,$8C,$0A,
    $4C,$33,$6E,$B5,$7B,$63,$F3,$0F,$1E,$C8,$21,$E6,$9D,$92,$76,$C2,
    $9A,$36,$F2,$3C,$CA,$E4,$97,$20,$C6,$7C,$41,$E2,$5D,$22,$F6,$05,
    $78,$A9,$1D,$F3,$C1,$56,$87,$A3,$E1,$38,$F9,$E0,$C3,$1F,$30,$B9,
    $3F,$4A,$59,$FA,$90,$FD,$B9,$5A,$26,$7C,$8D,$83,$5C,$DA,$B4,$05,
    $02,$1B,$27,$60,$42,$CB,$58,$D0,$94,$6D,$D1,$B5,$CC,$A9,$12,$54,
    $9D,$6B,$F0,$D2,$C8,$DF,$F0,$90,$59,$0D,$7E,$C8,$F1,$59,$7B,$74,
    $19,$C1,$E3,$D7,$A4,$E7,$41,$01,$63,$EE,$96,$E2,$5C,$6B,$2F,$A4,
    $62,$D6,$91,$C2,$6B,$28,$EB,$91,$50,$BF,$82,$69,$3C,$6E,$A2,$50,
    $A8,$E4,$6C,$1E,$2C,$0A,$7B,$F4,$0E,$2C,$B5,$DB,$56,$DC,$8E,$DB,
    $41,$59,$9F,$B6,$E3,$06,$57,$2B,$F3,$FB,$16,$A4,$C4,$52,$2C,$F6,
    $99,$4F,$B0,$2F,$4A,$61,$D2,$9B,$BA,$1B,$6A,$4D,$3E,$72,$8F,$35,
    $7E,$D2,$8E,$7B,$5D,$AD,$CC,$D2,$52,$B2,$8B,$01,$E1,$11,$BB,$31,
    $51,$0D,$1A,$5E,$3F,$0D,$05,$37,$8E,$B4,$47,$6F,$24,$E3,$03,$C9,
    $6C,$23,$08,$B1,$F5,$58,$D8,$4B,$A4,$7E,$EB,$63,$98,$13,$1F,$13,
    $FE,$85,$94,$BD,$30,$65,$74,$09,$46,$CE,$DA,$C2,$CD,$EF,$6B,$60,
    $82,$C1,$FC,$0E,$51,$40,$16,$E0,$72,$6E,$0D,$30,$26,$76,$00,$23,
    $96,$23,$FA,$CB,$89,$29,$E0,$7B,$1D,$6E,$A9,$02,$1A,$0B,$F8,$88,
    $4C,$51,$CB,$59,$75,$D4,$78,$02,$A6,$4D,$7F,$10,$9D,$E0,$FE,$3A,
    $72,$01,$77,$64,$9D,$CD,$58,$C1,$DC,$6A,$F5,$E0,$DD,$23,$EF,$21,
    $EF,$96,$33,$13,$56,$22,$D9,$CC,$79,$9F,$EC,$34,$A0,$AD,$58,$0D,
    $F3,$CC,$2E,$A4,$CB,$7A,$87,$B5,$0E,$5D,$71,$3B,$D9,$D3,$62,$78,
    $6B,$49,$2D,$0E,$57,$B8,$CD,$E7,$40,$4A,$39,$4A,$59,$55,$CE,$1A,
    $BC,$BD,$8E,$6C,$00,$75,$2E,$FF,$55,$CF,$F2,$33,$5B,$D9,$CD,$CE,
    $3F,$3D,$EF,$1C,$8D,$5E,$8D,$3B,$68,$6D,$94,$55,$80,$51,$0E,$BF,
    $83,$B5,$B9,$BC,$BA,$83,$C5,$43,$C1,$6A,$1C,$4B,$4B,$58,$01,$11,
    $B9,$8E,$50,$18,$7B,$AF,$65,$F0,$3A,$8C,$BE,$05,$A3,$5F,$01,$25,
    $69,$9A,$C7,$B7,$D7,$3D,$B7,$E7,$71,$22,$8C,$9F,$8F,$5E,$E3,$26,
    $F5,$E8,$64,$EF,$35,$6E,$2C,$36,$33,$A7,$3F,$24,$F5,$C7,$AD,$90,
    $B2,$F5,$10,$C2,$0C,$F8,$12,$BF,$EF,$E6,$48,$C6,$43,$F6,$64,$BB,
    $38,$9A,$91,$96,$33,$57,$97,$23,$35,$32,$EC,$6A,$46,$39,$B3,$76,
    $AF,$83,$BB,$99,$DE,$35,$29,$89,$06,$DD,$39,$F9,$09,$92,$08,$2F,
    $F6,$03,$49,$CA,$6C,$22,$89,$EA,$9D,$89,$66,$91,$44,$2D,$9E,$89,
    $84,$64,$36,$EB,$A0,$AC,$B9,$C9,$83,$C4,$EC,$67,$0C,$EC,$D1,$75,
    $10,$37,$9D,$24,$AD,$73,$26,$1D,$B6,$97,$FB,$40,$41,$37,$AC,$F3,
    $70,$A0,$DF,$C6,$67,$F1,$42,$3F,$70,$5C,$D8,$82,$41,$B5,$94,$B5,
    $2F,$B2,$C0,$11,$DC,$08,$89,$AE,$C1,$EF,$2E,$44,$36,$33,$1F,$02,
    $79,$CC,$F6,$C1,$DE,$A9,$36,$49,$8F,$ED,$D9,$B1,$26,$84,$7C,$44,
    $A1,$FF,$B7,$18,$A9,$1A,$B3,$9A,$83,$B2,$FB,$71,$92,$75,$1F,$7B,
    $74,$15,$14,$F5,$6F,$3B,$99,$99,$E0,$75,$70,$EB,$BE,$42,$3A,$3D,
    $81,$49,$8E,$7F,$89,$49,$4E,$60,$12,$15,$AA,$CC,$A7,$D1,$73,$CC,
    $2E,$76,$A7,$EB,$D6,$07,$1E,$96,$0B,$55,$DB,$81,$68,$2B,$DE,$E2,
    $2E,$45,$8F,$4E,$CE,$F9,$C0,$AD,$3C,$B5,$30,$07,$D6,$71,$47,$13,
    $96,$94,$90,$B5,$7D,$63,$D3,$4B,$CC,$71,$B1,$83,$64,$D8,$C4,$18,
    $C5,$DC,$A5,$67,$14,$37,$89,$6C,$62,$14,$F7,$3D,$68,$26,$FF,$03,
    $56,$75,$5E,$F5,$16,$B9,$FF,$E4,$5D,$A4,$5D,$82,$BE,$41,$D8,$C6,
    $A3,$EC,$01,$38,$66,$03,$D2,$9E,$F1,$E8,$56,$DE,$1E,$C4,$1E,$13,
    $51,$EF,$91,$C3,$DD,$0F,$B8,$0B,$79,$14,$E4,$5A,$B5,$81,$04,$E9,
    $15,$80,$74,$60,$30,$E6,$DE,$32,$44,$7A,$B9,$13,$E9,$DF,$EC,$41,
    $56,$AF,$30,$B1,$DB,$64,$CD,$8C,$E3,$32,$EE,$CD,$A9,$B1,$D4,$BD,
    $AE,$79,$6D,$7C,$43,$09,$30,$12,$4E,$EA,$F0,$5B,$E0,$01,$80,$E1,
    $E2,$C3,$B3,$FD,$41,$D0,$60,$FF,$63,$7E,$EC,$CE,$FC,$7B,$9B,$59,
    $81,$15,$B9,$17,$F8,$7F,$D3,$97,$EC,$18,$35,$0F,$B9,$D7,$1E,$59,
    $4A,$8E,$8F,$F6,$A8,$60,$07,$BD,$F8,$8F,$D8,$1D,$D5,$01,$07,$41,
    $81,$B4,$BC,$EB,$31,$1C,$BC,$B3,$06,$D9,$A1,$74,$8F,$1F,$B6,$4A,
    $BF,$A6,$DD,$E1,$3A,$2A,$2A,$5E,$83,$F8,$F8,$68,$15,$B2,$43,$87,
    $3D,$50,$64,$96,$E8,$B4,$8C,$F8,$84,$39,$EE,$F9,$5D,$4C,$8C,$EB,
    $7E,$83,$CB,$2E,$56,$70,$74,$19,$E2,$79,$2F,$41,$FD,$1A,$BC,$97,
    $60,$DC,$2A,$F7,$BD,$04,$43,$3C,$EF,$33,$F0,$5B,$EB,$66,$28,$2E,
    $45,$DF,$B5,$98,$22,$88,$4B,$81,$77,$3B,$08,$C1,$27,$62,$6A,$30,
    $15,$04,$C0,$4C,$09,$A6,$F2,$00,$A8,$E9,$C1,$54,$55,$6C,$30,$A5,
    $82,$A7,$00,$DF,$01,$4A,$F0,$7D,$46,$30,$55,$03,$CF,$60,$78,$FA,
    $03,$50,$F1,$10,$16,$17,$4C,$1D,$5D,$13,$4C,$15,$7D,$10,$4C,$AD,
    $58,$1B,$4C,$C5,$01,$A8,$36,$05,$53,$65,$5F,$40,$9E,$5F,$06,$53,
    $4D,$F0,$5E,$02,$4F,$13,$40,$D4,$F9,$60,$6A,$ED,$B9,$60,$6A,$08,
    $4C,$22,$EA,$E0,$3D,$19,$9E,$2A,$80,$B0,$C7,$43,$A8,$00,$80,$D5,
    $03,$43,$A8,$38,$80,$2A,$80,$12,$80,$C0,$69,$21,$54,$CD,$D4,$10,
    $CA,$04,$4F,$21,$9E,$CA,$85,$F6,$96,$AD,$61,$CF,$77,$37,$C3,$93,
    $3D,$87,$50,$16,$B8,$16,$EF,$39,$C4,$ED,$D2,$4F,$81,$0C,$99,$34,
    $90,$37,$B6,$72,$EA,$7F,$FF,$5C,$7F,$92,$DE,$B6,$72,$2F,$90,$BB,
    $38,$DF,$72,$42,$5E,$08,$0B,$CE,$3F,$66,$50,$30,$95,$F1,$44,$30,
    $55,$3F,$38,$98,$92,$0C,$B2,$95,$4F,$B4,$A6,$59,$52,$E6,$9A,$85,
    $66,$3C,$C8,$2F,$C4,$BF,$78,$8B,$50,$C4,$FD,$41,$5E,$E4,$80,$3F,
    $3C,$45,$62,$89,$54,$26,$57,$28,$55,$EA,$90,$11,$A1,$61,$C6,$91,
    $C2,$FF,$E6,$5F,$8F,$6E,$FF,$F3,$7D,$A7,$9A,$E3,$6A,$77,$1E,$00,
    $3A,$5C,$65,$A2,$8C,$40,$FE,$43,$8E,$15,$BC,$0C,$74,$0E,$50,$02,
    $B0,$11,$A0,$14,$A0,$0C,$A0,$1C,$E0,$28,$40,$15,$40,$0D,$40,$1D,
    $00,$03,$D0,$0C,$D0,$0A,$40,$01,$4F,$08,$00,$FC,$01,$02,$01,$84,
    $00,$43,$00,$44,$00,$2A,$80,$60,$80,$70,$00,$13,$40,$0C,$40,$1C,
    $40,$32,$40,$06,$40,$36,$40,$1E,$40,$11,$C0,$0A,$80,$D5,$00,$25,
    $00,$1B,$01,$4A,$01,$CA,$00,$CA,$91,$E7,$00,$BC,$B8,$3A,$7B,$73,
    $4F,$3E,$F7,$EC,$C2,$3D,$13,$B9,$A7,$99,$7B,$CE,$E6,$9E,$BE,$89,
    $6C,$FB,$13,$B9,$E7,$5E,$EE,$99,$61,$66,$9F,$47,$B9,$A7,$30,$89,
    $7D,$66,$73,$CF,$61,$B3,$D8,$67,$3D,$F7,$0C,$4B,$66,$9F,$AD,$DC,
    $73,$2D,$F7,$34,$A5,$FC,$D7,$9E,$9B,$B9,$67,$54,$02,$FB,$4C,$9E,
    $CD,$3E,$83,$DC,$FD,$F4,$D0,$3F,$94,$97,$A4,$CE,$1F,$06,$53,$B5,
    $00,$4D,$00,$C3,$40,$D6,$68,$01,$22,$00,$AA,$40,$CE,$D4,$02,$88,
    $87,$8B,$86,$CB,$28,$6B,$DA,$9C,$B4,$F4,$F9,$69,$C2,$04,$8F,$DB,
    $74,$E6,$9A,$2D,$C9,$E9,$89,$54,$4A,$DA,$BC,$F8,$D4,$94,$44,$E1,
    $FC,$94,$B4,$C4,$F4,$F9,$C2,$AC,$94,$85,$66,$F0,$4B,$48,$CF,$CC,
    $34,$27,$58,$84,$C9,$E6,$F8,$44,$73,$A6,$30,$21,$D9,$0C,$42,$3A,
    $CD,$6C,$4E,$14,$26,$A6,$24,$58,$20,$79,$7C,$E6,$02,$8F,$68,$89,
    $F1,$96,$78,$2E,$12,$E2,$2F,$25,$8D,$5C,$B6,$23,$24,$85,$0B,$43,
    $D3,$33,$16,$64,$A6,$CC,$4A,$B6,$08,$C5,$6A,$B5,$FC,$05,$F8,$51,
    $08,$23,$E3,$33,$E7,$08,$43,$12,$53,$21,$6F,$B6,$1F,$B1,$0F,$B1,
    $FF,$70,$4C,$C0,$AB,$58,$51,$AB,$42,$3B,$22,$1C,$ED,$70,$9A,$80,
    $F6,$32,$38,$B4,$3C,$0A,$D0,$1B,$00,$65,$F8,$E3,$00,$83,$00,$9E,
    $02,$18,$0A,$80,$17,$07,$A1,$4D,$11,$DE,$CF,$3A,$09,$20,$01,$00,
    $ED,$6A,$70,$CB,$04,$ED,$13,$F1,$98,$D6,$CF,$00,$5E,$BC,$7F,$44,
    $AF,$EB,$8F,$D7,$09,$BC,$3A,$81,$77,$27,$E0,$77,$82,$2E,$9D,$00,
    $FF,$CA,$39,$F0,$E4,$39,$67,$DC,$AE,$5C,$BB,$7B,$70,$6D,$C5,$25,
    $A2,$27,$28,$F6,$DE,$34,$1C,$01,$E2,$01,$D0,$2C,$0F,$3F,$A9,$C2,
    $C3,$1B,$01,$01,$78,$90,$09,$0F,$32,$E1,$41,$26,$3C,$40,$20,$0F,
    $90,$C7,$F3,$05,$F0,$07,$08,$04,$00,$1C,$F3,$44,$00,$C1,$00,$71,
    $0F,$6F,$63,$E7,$36,$75,$6E,$83,$0F,$E5,$EE,$1F,$67,$1F,$39,$FB,
    $C9,$D9,$57,$CE,$FE,$42,$F0,$E5,$A0,$07,$07,$F8,$97,$3E,$CF,$9C,
    $99,$65,$9D,$99,$95,$90,$99,$32,$13,$A9,$69,$41,$5A,$FC,$DC,$94,
    $04,$E1,$CC,$14,$8B,$30,$D5,$9C,$36,$CB,$92,$9C,$25,$B4,$64,$9A,
    $59,$12,$9C,$9B,$91,$6A,$06,$2A,$7A,$68,$9C,$4E,$79,$A5,$A6,$58,
    $CC,$99,$F1,$A9,$2F,$B2,$71,$FE,$92,$CD,$83,$82,$29,$BC,$48,$91,
    $E0,$B9,$17,$57,$3F,$81,$47,$1F,$F8,$70,$ED,$E9,$C2,$B5,$87,$CF,
    $B5,$C7,$9B,$6B,$0F,$E2,$AA,$27,$87,$3B,$A4,$4D,$27,$2B,$CD,$4C,
    $4D,$4F,$98,$23,$B4,$2C,$C8,$30,$BB,$BC,$B2,$C8,$35,$5A,$5C,$08,
    $D7,$08,$CA,$92,$9E,$2E,$9C,$1B,$9F,$B6,$80,$F3,$10,$C2,$80,$93,
    $98,$92,$65,$C1,$3B,$A9,$84,$59,$0B,$E6,$CE,$4C,$4F,$CD,$72,$E7,
    $E9,$6A,$BC,$30,$D3,$9C,$61,$8E,$B7,$78,$94,$D7,$A9,$65,$09,$E9,
    $89,$EE,$82,$5D,$19,$12,$5F,$77,$7F,$7B,$73,$ED,$C4,$7A,$23,$0F,
    $E1,$BD,$AD,$8B,$01,$50,$A8,$A0,$C2,$88,$06,$7B,$0E,$88,$E0,$80,
    $08,$0E,$88,$E0,$80,$08,$8E,$C5,$28,$77,$A8,$87,$E4,$FD,$77,$B5,
    $E1,$FE,$70,$0C,$46,$9A,$E6,$B3,$EF,$83,$80,$5B,$A7,$52,$D9,$D4,
    $7B,$D4,$4E,$AA,$9A,$FA,$83,$7A,$94,$27,$E2,$8D,$E3,$CD,$E5,$0D,
    $A2,$B4,$D4,$34,$6A,$01,$B5,$9A,$DA,$45,$9D,$A5,$5A,$A8,$5E,$3C,
    $31,$6F,$3C,$2F,$CD,$C5,$B5,$EF,$8A,$BA,$CE,$1F,$16,$DF,$F3,$C6,
    $9E,$09,$8F,$BC,$FF,$58,$C5,$DC,$AE,$6F,$B6,$CC,$CE,$90,$7F,$96,
    $D0,$F0,$E9,$AA,$C4,$75,$92,$A2,$4B,$3D,$D7,$97,$D5,$2E,$18,$D8,
    $70,$B6,$AE,$E8,$C2,$E9,$F7,$86,$46,$EC,$7A,$64,$5F,$CE,$D6,$45,
    $5D,$5F,$28,$FB,$F5,$AD,$01,$07,$56,$24,$FA,$7F,$33,$E0,$96,$B0,
    $74,$76,$F8,$2B,$BB,$FF,$B8,$12,$B2,$BF,$20,$B7,$FA,$62,$FF,$C6,
    $FA,$CB,$73,$27,$EC,$AC,$6E,$39,$52,$78,$26,$7F,$F2,$EA,$D4,$DE,
    $E5,$1B,$E7,$24,$2E,$BC,$3B,$F3,$CF,$A6,$63,$E6,$A5,$E3,$63,$79,
    $01,$17,$52,$7D,$12,$12,$74,$7E,$F7,$FE,$DD,$43,$60,$3F,$2A,$4C,
    $A3,$67,$F8,$A7,$44,$D4,$87,$C4,$9D,$CD,$7C,$65,$D6,$27,$A7,$EA,
    $BD,$B5,$A3,$AA,$F9,$63,$FF,$2C,$EC,$71,$7A,$CE,$CE,$6E,$9F,$DD,
    $DB,$B8,$53,$9E,$BA,$7A,$DB,$88,$73,$C7,$BE,$BD,$14,$7C,$77,$EF,
    $E6,$9F,$53,$6B,$24,$D6,$D8,$AB,$C6,$93,$3D,$CE,$D5,$BE,$A4,$3B,
    $F5,$E5,$66,$D1,$85,$67,$34,$D4,$95,$09,$79,$13,$CE,$1F,$ED,$1B,
    $5F,$75,$60,$67,$CB,$8E,$27,$9E,$AA,$D8,$3E,$F9,$FD,$55,$7B,$4E,
    $FA,$7D,$B6,$AF,$6C,$5D,$99,$D7,$10,$41,$51,$97,$97,$B7,$5D,$F0,
    $AD,$1C,$DC,$D0,$7D,$EB,$1B,$39,$E9,$2F,$3E,$1A,$91,$1C,$F3,$E5,
    $80,$F8,$83,$BA,$17,$92,$76,$AD,$08,$A9,$9D,$E7,$F3,$CA,$25,$DE,
    $5E,$E1,$E9,$D5,$CF,$FB,$9F,$BD,$59,$5C,$B8,$F5,$95,$41,$3B,$77,
    $F9,$7C,$56,$7F,$E0,$23,$69,$75,$19,$F3,$C9,$B1,$AE,$D9,$B2,$BB,
    $94,$DF,$F2,$8D,$8F,$BC,$1B,$B8,$BA,$E7,$4F,$DF,$F6,$98,$BD,$F8,
    $05,$DD,$5C,$C1,$7B,$A9,$89,$6F,$F1,$62,$13,$AE,$B7,$4C,$98,$33,
    $67,$66,$7C,$6A,$50,$8D,$C8,$5C,$38,$8E,$9A,$79,$EB,$F7,$55,$3E,
    $A9,$AF,$7E,$C6,$7B,$FC,$60,$8B,$E0,$F5,$29,$15,$7E,$FF,$AE,$BC,
    $50,$6A,$36,$35,$7C,$D3,$EB,$B7,$B2,$FD,$B6,$9C,$A2,$DD,$6D,$57,
    $07,$5C,$9E,$39,$FA,$85,$8B,$7D,$FE,$C8,$39,$B3,$CC,$1C,$51,$7D,
    $3F,$26,$7E,$5B,$E4,$8F,$13,$76,$6A,$2C,$D4,$DE,$4F,$AF,$89,$BE,
    $AD,$0E,$F9,$EC,$EA,$98,$F3,$AB,$6A,$74,$73,$2B,$4E,$AD,$BF,$DF,
    $72,$EE,$CC,$EC,$86,$94,$D0,$B6,$0B,$69,$B2,$91,$45,$B3,$BE,$AA,
    $2A,$8B,$BB,$98,$F5,$02,$3F,$EC,$97,$01,$DE,$D2,$97,$23,$BA,$6D,
    $3A,$96,$D3,$E3,$B2,$F6,$95,$2E,$A6,$4D,$21,$5E,$CF,$FA,$FB,$77,
    $DF,$BF,$44,$E8,$7B,$EC,$E9,$9D,$C9,$53,$B6,$17,$A6,$0B,$1F,$A9,
    $4E,$DA,$FD,$51,$7D,$FC,$8F,$3D,$EF,$5E,$99,$B1,$FA,$D8,$85,$E7,
    $9E,$5C,$5D,$55,$BA,$63,$E3,$F9,$23,$FD,$74,$DB,$5F,$7A,$AD,$C7,
    $8E,$E1,$74,$EC,$BE,$6F,$BE,$4A,$DD,$53,$2E,$CC,$2F,$FB,$7D,$D7,
    $F6,$03,$1F,$F8,$5E,$DB,$E5,$FD,$C1,$E9,$AD,$16,$F5,$A8,$B3,$BF,
    $7D,$3D,$FF,$F4,$87,$7D,$9E,$B9,$C4,$CF,$EF,$5B,$9B,$D5,$AB,$7B,
    $C2,$CF,$05,$74,$E2,$4A,$FD,$EC,$B9,$3D,$36,$4E,$9D,$BD,$B0,$FB,
    $C9,$9E,$F5,$1F,$3A,$1E,$79,$E7,$D9,$2D,$54,$B7,$AD,$EB,$BA,$E6,
    $86,$BD,$E3,$D7,$7C,$FA,$53,$C1,$1B,$C9,$B7,$78,$03,$DB,$0F,$F9,
    $A4,$4C,$9F,$32,$F3,$CE,$F1,$59,$E6,$BC,$57,$14,$A9,$8F,$FD,$EA,
    $33,$27,$6D,$DE,$E3,$D5,$ED,$75,$43,$CF,$14,$4F,$5D,$78,$D1,$FF,
    $C4,$98,$CB,$B3,$D2,$AF,$EE,$BE,$7B,$F7,$E6,$FE,$E5,$A1,$FB,$BF,
    $E9,$77,$76,$79,$69,$1C,$F3,$E9,$B9,$73,$8B,$DE,$39,$F5,$71,$C5,
    $A1,$1A,$D5,$C4,$5B,$57,$C7,$FF,$6B,$D6,$B7,$A7,$66,$4D,$D9,$FB,
    $F9,$65,$9F,$9D,$86,$B1,$8A,$6D,$E1,$17,$87,$F6,$A8,$89,$78,$BC,
    $DB,$D7,$B7,$C7,$78,$2B,$E2,$16,$F2,$43,$0E,$DF,$8C,$BB,$1A,$7D,
    $75,$D6,$C6,$9B,$CB,$D3,$C4,$0B,$F6,$A7,$8C,$5C,$B6,$3D,$FE,$78,
    $FF,$FC,$A4,$BD,$25,$A7,$D3,$9F,$56,$5C,$4B,$9E,$B8,$6A,$BE,$EF,
    $09,$EF,$51,$DD,$BF,$DD,$DD,$D7,$EB,$C9,$17,$9F,$E9,$12,$BD,$9F,
    $DE,$F3,$DD,$90,$EE,$FB,$B6,$BD,$3D,$75,$C7,$50,$FE,$EC,$ED,$B1,
    $1B,$1C,$E7,$0F,$89,$4F,$56,$ED,$B4,$AD,$BB,$30,$6C,$C0,$96,$2B,
    $D3,$4A,$0F,$25,$AE,$79,$E6,$56,$42,$D3,$DA,$4F,$67,$5B,$BB,$BD,
    $33,$D7,$EB,$0B,$9F,$47,$D6,$1A,$14,$3D,$1B,$0B,$67,$75,$CD,$EC,
    $3D,$85,$EA,$F2,$FA,$98,$03,$AB,$02,$16,$96,$5D,$DB,$32,$74,$EB,
    $AB,$AA,$C7,$77,$F9,$AE,$59,$7E,$FA,$ED,$1E,$FB,$CF,$FE,$F2,$CD,
    $CD,$DA,$9C,$27,$AE,$5E,$EA,$5E,$7D,$FA,$CC,$92,$11,$D7,$AA,$FF,
    $D5,$BA,$FD,$72,$72,$5A,$FE,$C5,$41,$3F,$F4,$DD,$FF,$DA,$B4,$67,
    $76,$DF,$FE,$69,$7E,$69,$FA,$FC,$51,$DF,$04,$5E,$9F,$2A,$28,$CA,
    $98,$ED,$E7,$F8,$9E,$F6,$49,$8A,$ED,$CE,$7B,$D4,$B1,$CE,$FC,$66,
    $CA,$96,$99,$AD,$67,$1C,$73,$E2,$8D,$27,$53,$FB,$66,$5F,$EB,$56,
    $72,$E3,$74,$8F,$F3,$51,$F9,$FC,$71,$87,$B6,$7B,$AB,$E3,$9F,$99,
    $B5,$E1,$4E,$DF,$B8,$AA,$C8,$51,$29,$A3,$2F,$CD,$4F,$D3,$8F,$99,
    $7D,$6A,$4B,$ED,$D4,$73,$17,$92,$BA,$5F,$0D,$6E,$A6,$6B,$94,$93,
    $B6,$EC,$FD,$E2,$BB,$75,$DF,$5E,$59,$7C,$72,$DB,$A8,$06,$C7,$4E,
    $51,$D0,$AD,$7D,$FB,$96,$1E,$DA,$F3,$BD,$E8,$9D,$ED,$93,$3E,$FF,
    $74,$C7,$E0,$2E,$8A,$AA,$3D,$EF,$F8,$9C,$FF,$E1,$B9,$29,$57,$A2,
    $0E,$CC,$BA,$F0,$D4,$F0,$85,$49,$DB,$CB,$C6,$C4,$57,$78,$3D,$9E,
    $3C,$7D,$E5,$D0,$F4,$E7,$95,$FB,$BB,$EF,$F8,$78,$B9,$EF,$E1,$C7,
    $AF,$76,$99,$6A,$BF,$E9,$F5,$02,$EA,$A1,$81,$00,$C9,$33,$58,$5D,
    $33,$9C,$D3,$0F,$87,$94,$86,$10,$9D,$34,$08,$9E,$31,$2F,$B3,$BA,
    $22,$1F,$DE,$51,$8F,$5C,$81,$7A,$6B,$49,$08,$25,$AA,$61,$75,$D8,
    $40,$78,$0F,$87,$F9,$5A,$DE,$0C,$56,$C7,$CC,$E3,$F4,$4C,$7F,$88,
    $3F,$1A,$C0,$84,$73,$3C,$88,$17,$3E,$83,$D5,$71,$8B,$B0,$2C,$78,
    $E6,$01,$D4,$6E,$62,$F5,$D9,$A0,$6D,$21,$44,$8F,$35,$81,$DF,$6A,
    $00,$01,$A4,$43,$BD,$97,$82,$A7,$2F,$D6,$01,$DE,$EB,$20,$1D,$33,
    $83,$D5,$67,$63,$B0,$AC,$19,$AC,$5E,$2D,$E2,$74,$E5,$6A,$C8,$EB,
    $04,$40,$32,$B8,$97,$6D,$62,$75,$E5,$70,$78,$97,$41,$FA,$40,$4E,
    $67,$DE,$0C,$FE,$C1,$9C,$1E,$8E,$BA,$36,$EA,$C9,$15,$E0,$97,$0D,
    $79,$95,$CD,$60,$75,$EC,$A3,$33,$58,$BD,$B9,$1C,$9E,$F5,$9B,$58,
    $BD,$3A,$10,$F2,$C8,$80,$F8,$43,$5E,$66,$75,$E7,$00,$68,$73,$06,
    $84,$C7,$BD,$CC,$EA,$E1,$A8,$77,$9B,$00,$07,$E1,$18,$0F,$CB,$02,
    $FF,$00,$78,$DF,$0B,$E9,$8B,$E0,$7D,$25,$3C,$F9,$90,$66,$ED,$26,
    $56,$DF,$CF,$E6,$F4,$7C,$D4,$BF,$63,$D6,$B2,$73,$82,$1A,$C8,$6F,
    $3D,$96,$07,$CF,$66,$80,$D5,$D8,$D6,$19,$EC,$5C,$60,$07,$F8,$6F,
    $84,$F7,$30,$C8,$13,$E7,$11,$AD,$F0,$5E,$05,$50,$8A,$75,$E6,$E6,
    $11,$FF,$37,$FF,$04,$67,$78,$D4,$D1,$AA,$8E,$8A,$5F,$F5,$59,$1E,
    $95,$71,$AA,$A3,$5F,$FF,$73,$3C,$AA,$A0,$93,$DF,$54,$F0,$5B,$D9,
    $C9,$EF,$37,$F0,$DB,$D1,$C9,$2F,$E2,$3C,$8F,$3A,$D1,$C9,$AF,$E5,
    $12,$8F,$AA,$3E,$DD,$D1,$2F,$B1,$96,$47,$35,$77,$F2,$5B,$01,$7E,
    $6D,$A7,$1F,$AC,$98,$F6,$85,$BA,$0F,$03,$08,$03,$88,$05,$B0,$00,
    $AC,$00,$58,$07,$B0,$05,$60,$0F,$B6,$0D,$A0,$06,$E0,$06,$00,$BF,
    $9A,$47,$F9,$03,$04,$01,$0C,$01,$D0,$00,$44,$00,$CC,$00,$C8,$00,
    $28,$00,$F8,$00,$60,$33,$C0,$5E,$80,$1F,$01,$6A,$01,$6E,$00,$DC,
    $03,$10,$00,$5E,$02,$00,$44,$00,$23,$00,$26,$02,$CC,$00,$98,$0D,
    $90,$03,$B0,$0C,$E0,$03,$80,$4D,$00,$65,$00,$95,$67,$D9,$7A,$D7,
    $C1,$F3,$16,$BE,$03,$6E,$7A,$9E,$63,$FD,$86,$C0,$53,$0B,$10,$C1,
    $B9,$93,$E1,$B9,$08,$60,$05,$40,$09,$40,$29,$40,$39,$C0,$39,$2E,
    $BC,$15,$9E,$3E,$80,$C7,$00,$80,$27,$01,$14,$E7,$59,$FF,$A9,$F0,
    $4C,$02,$C8,$01,$58,$06,$F0,$2E,$C0,$16,$80,$72,$80,$2A,$80,$2B,
    $00,$CD,$00,$3E,$35,$3C,$AA,$2F,$C0,$F3,$00,$0A,$80,$08,$80,$58,
    $80,$64,$80,$D7,$01,$DE,$06,$F8,$04,$60,$0F,$C0,$39,$80,$EB,$00,
    $B7,$01,$7C,$2E,$40,$99,$00,$4F,$02,$88,$00,$C2,$01,$62,$00,$92,
    $01,$16,$02,$2C,$05,$58,$0B,$50,$0A,$50,$09,$70,$11,$A0,$09,$A0,
    $0D,$A0,$D7,$45,$C0,$33,$80,$0A,$20,$02,$60,$26,$40,$1A,$C0,$22,
    $80,$65,$00,$EB,$00,$B6,$00,$EC,$07,$A8,$02,$A8,$05,$68,$01,$E8,
    $09,$B4,$F1,$0C,$80,$06,$60,$22,$C0,$6C,$80,$6C,$80,$15,$00,$9F,
    $00,$94,$02,$94,$23,$FD,$00,$5C,$BF,$C4,$D1,$06,$D0,$49,$2F,$00,
    $21,$C0,$70,$80,$11,$00,$13,$6B,$D9,$B0,$34,$78,$E6,$71,$EF,$EB,
    $E0,$B9,$85,$7B,$9F,$63,$CE,$4C,$33,$A7,$4A,$25,$C3,$13,$53,$53,
    $D1,$3D,$CA,$6C,$09,$B5,$C2,$C4,$2D,$CD,$12,$95,$9C,$09,$13,$BC,
    $D1,$64,$C2,$1C,$66,$46,$35,$39,$34,$33,$C5,$92,$92,$10,$9F,$3A,
    $C9,$4C,$A6,$79,$48,$D5,$E6,$F8,$79,$0F,$F0,$A6,$8C,$69,$A0,$E7,
    $3D,$C0,$7F,$74,$1A,$78,$81,$26,$B8,$F0,$01,$89,$26,$A7,$64,$5A,
    $AC,$F1,$A9,$23,$59,$DD,$9B,$73,$85,$A4,$82,$56,$4C,$F8,$27,$3D,
    $C1,$15,$46,$DE,$5D,$21,$5C,$CC,$09,$56,$33,$4C,$3B,$E1,$6F,$4A,
    $4A,$A2,$39,$34,$39,$3E,$33,$2A,$3D,$D2,$9A,$6A,$49,$19,$B1,$C0,
    $82,$69,$5C,$EF,$51,$E9,$CE,$08,$E0,$9B,$9A,$65,$C9,$04,$5D,$94,
    $2C,$9F,$E1,$7B,$42,$C6,$02,$E2,$E0,$DE,$43,$D8,$92,$E3,$13,$23,
    $52,$66,$66,$C2,$AC,$D6,$98,$1D,$C2,$E1,$88,$45,$0E,$A9,$88,$99,
    $F5,$99,$64,$89,$87,$7A,$64,$8C,$4E,$4B,$4A,$0F,$61,$7D,$F0,$F0,
    $46,$48,$62,$62,$26,$7B,$80,$03,$7D,$22,$D3,$13,$AD,$A9,$E6,$F0,
    $F8,$34,$98,$DC,$86,$74,$F0,$1B,$99,$92,$6A,$1E,$17,$3F,$D7,$E5,
    $CB,$E6,$EC,$CC,$8C,$F8,$C4,$67,$59,$D8,$05,$26,$AE,$97,$D2,$E7,
    $C2,$FC,$00,$6A,$96,$46,$12,$21,$6A,$B8,$5A,$A2,$0B,$26,$EC,$23,
    $53,$32,$B3,$2C,$98,$2F,$C9,$01,$7D,$42,$53,$D3,$B3,$B0,$B6,$C6,
    $EC,$14,$8B,$FB,$64,$C9,$14,$E8,$09,$52,$3E,$85,$2B,$AE,$C9,$A4,
    $72,$89,$C6,$EC,$04,$73,$06,$76,$0C,$04,$40,$57,$62,$0E,$93,$CC,
    $24,$37,$53,$7A,$4A,$9A,$DB,$C7,$98,$96,$38,$3E,$89,$4B,$4C,$4D,
    $B4,$A4,$46,$A7,$E1,$5A,$01,$BE,$03,$7A,$5C,$FE,$F1,$29,$59,$66,
    $57,$8E,$94,$13,$5F,$89,$2C,$22,$38,$37,$46,$9E,$84,$0B,$0C,$6C,
    $E8,$82,$2C,$8B,$79,$6E,$54,$CA,$5C,$B3,$3B,$34,$0A,$27,$4D,$CE,
    $93,$31,$CE,$86,$91,$36,$71,$19,$59,$B3,$CC,$99,$1D,$28,$79,$AC,
    $79,$C1,$CC,$F4,$F8,$CC,$44,$2E,$25,$F6,$E4,$24,$4B,$66,$4A,$DA,
    $2C,$4C,$19,$09,$CD,$8F,$9F,$65,$1E,$91,$4E,$3A,$15,$09,$62,$9C,
    $39,$DB,$12,$42,$C5,$27,$CE,$8B,$CF,$48,$71,$E7,$33,$D1,$3C,$8B,
    $D0,$D6,$E4,$F8,$54,$AB,$99,$A3,$00,$F0,$1B,$9F,$61,$4E,$83,$FC,
    $59,$0F,$70,$93,$8A,$80,$07,$95,$9E,$6A,$8E,$B7,$5A,$DC,$E9,$27,
    $C7,$67,$A6,$C4,$A7,$59,$A0,$80,$B4,$59,$A4,$0D,$C6,$6C,$0F,$DF,
    $F4,$8C,$05,$A3,$09,$C2,$5C,$3E,$90,$9C,$C5,$EE,$82,$2C,$B6,$B2,
    $11,$E6,$34,$CE,$8D,$9D,$CC,$FA,$B1,$EE,$89,$66,$C2,$05,$9E,$D1,
    $C0,$B7,$93,$5F,$67,$0E,$8F,$4A,$CD,$82,$8E,$23,$AD,$61,$5D,$A3,
    $DC,$AE,$8E,$9C,$F5,$9F,$52,$6C,$E7,$12,$3C,$29,$6A,$4A,$7C,$8A,
    $65,$64,$7A,$E6,$24,$A8,$4C,$AA,$79,$FC,$CC,$D9,$C0,$EE,$0F,$E0,
    $59,$A8,$05,$C7,$DB,$EE,$8E,$8F,$4A,$27,$9D,$CE,$92,$00,$85,$A4,
    $91,$9E,$34,$D1,$9C,$95,$6E,$CD,$4C,$30,$73,$D4,$D7,$81,$27,$38,
    $FA,$E4,$12,$3C,$90,$5A,$09,$D1,$58,$00,$33,$33,$AD,$16,$73,$56,
    $C8,$03,$69,$D8,$3C,$37,$7D,$9E,$39,$2C,$05,$97,$AE,$D2,$33,$17,
    $70,$BD,$ED,$A6,$E5,$07,$CB,$11,$C0,$DB,$1C,$CF,$BA,$FD,$45,$5A,
    $39,$6B,$D6,$A1,$51,$48,$8F,$1D,$53,$B9,$24,$0D,$2B,$79,$1E,$22,
    $5D,$FF,$4E,$8A,$8E,$4A,$4D,$87,$29,$5C,$74,$1A,$2E,$26,$50,$2E,
    $37,$47,$28,$2E,$B7,$07,$E7,$11,$77,$44,$87,$D8,$5C,$C5,$39,$97,
    $2B,$A5,$D9,$32,$85,$AC,$03,$66,$75,$C4,$0E,$92,$8F,$39,$13,$97,
    $0D,$59,$5E,$40,$E9,$98,$92,$30,$27,$34,$DD,$9A,$66,$79,$A8,$B4,
    $8C,$32,$CF,$CD,$30,$C5,$5B,$92,$9D,$39,$FC,$F7,$64,$E5,$2C,$C4,
    $41,$58,$66,$CA,$3C,$73,$96,$CB,$EF,$9F,$E4,$E7,$03,$68,$01,$7C,
    $51,$34,$86,$A6,$27,$7A,$1C,$BC,$43,$5F,$92,$35,$B2,$2E,$D7,$BE,
    $B0,$94,$AC,$39,$84,$17,$33,$E2,$13,$9C,$7E,$0F,$18,$35,$D1,$D7,
    $84,$75,$E0,$E4,$B3,$67,$5F,$77,$92,$D7,$E9,$99,$73,$E3,$2D,$9C,
    $44,$72,$C9,$6B,$67,$FC,$10,$CE,$8D,$F2,$C9,$29,$F7,$FE,$5E,$C2,
    $BB,$C9,$AD,$83,$20,$F5,$F0,$EF,$40,$95,$1D,$42,$C2,$D2,$B3,$C2,
    $40,$C0,$72,$FE,$C6,$34,$EB,$DC,$50,$40,$65,$5A,$62,$7C,$A6,$13,
    $9D,$0F,$1B,$DD,$3D,$52,$76,$A0,$73,$56,$7B,$70,$56,$F4,$61,$BA,
    $44,$87,$13,$8F,$A4,$45,$9D,$24,$3D,$71,$19,$E7,$01,$92,$3D,$42,
    $3B,$D2,$22,$DE,$08,$1F,$9F,$69,$76,$0B,$F9,$BF,$19,$1F,$C6,$03,
    $5A,$D2,$91,$7F,$47,$58,$93,$92,$48,$DC,$8E,$23,$42,$C7,$D1,$C2,
    $35,$26,$45,$9A,$C1,$2F,$81,$50,$46,$98,$19,$D4,$84,$F4,$05,$2C,
    $57,$50,$EC,$18,$12,$9D,$91,$61,$76,$E6,$08,$23,$81,$AB,$B8,$D0,
    $F4,$E8,$B4,$14,$17,$DF,$B2,$75,$1D,$ED,$E1,$EE,$3C,$6A,$20,$2D,
    $22,$B5,$72,$E4,$F3,$17,$E9,$FF,$BF,$7F,$FF,$CD,$BF,$3A,$98,$8B,
    $03,$54,$EF,$80,$B9,$79,$73,$C8,$FF,$D7,$B5,$F9,$DF,$BF,$FF,$DB,
    $7F,$FE,$C0,$E1,$38,$05,$12,$F9,$8A,$82,$44,$5A,$51,$B8,$28,$42,
    $64,$12,$45,$89,$62,$44,$B1,$A2,$38,$51,$A2,$28,$43,$94,$2B,$5A,
    $21,$DA,$2F,$AA,$14,$FD,$28,$3A,$27,$BA,$22,$BA,$2E,$BA,$21,$BA,
    $2D,$6A,$17,$F9,$88,$7B,$8A,$FB,$8A,$07,$8A,$9F,$11,$0F,$17,$2B,
    $C4,$7A,$F1,$48,$F1,$38,$F1,$64,$F1,$0C,$71,$92,$38,$4D,$3C,$4F,
    $BC,$48,$BC,$44,$BC,$5C,$FC,$AE,$78,$9D,$F8,$73,$F1,$16,$F1,$2E,
    $F1,$7E,$71,$A5,$F8,$47,$F1,$39,$F1,$15,$F1,$75,$F1,$0D,$F1,$6D,
    $71,$BB,$D8,$47,$D2,$53,$D2,$57,$32,$50,$32,$46,$32,$51,$32,$55,
    $32,$53,$32,$5B,$92,$29,$59,$28,$79,$5D,$62,$93,$6C,$96,$EC,$90,
    $04,$49,$9F,$92,$CE,$91,$5D,$93,$89,$E5,$F3,$E5,$4B,$E5,$94,$22,
    $4C,$51,$A8,$D8,$AD,$F8,$4E,$51,$A7,$C8,$52,$1E,$52,$B5,$AB,$1E,
    $57,$3F,$A3,$16,$AB,$D5,$EA,$50,$75,$A4,$7A,$8A,$7A,$AE,$3A,$4B,
    $FD,$9A,$7A,$A5,$7A,$9D,$7A,$BD,$7A,$9B,$BA,$4C,$5D,$AE,$3E,$AD,
    $BE,$A2,$FE,$5D,$7D,$57,$CD,$D3,$F8,$6A,$7A,$69,$06,$69,$9E,$D6,
    $18,$34,$23,$35,$26,$CD,$54,$4D,$A2,$26,$43,$F3,$AA,$66,$99,$E6,
    $6D,$CD,$07,$9A,$F5,$9A,$6F,$35,$95,$9A,$5F,$35,$0E,$CD,$40,$5A,
    $41,$EB,$E9,$45,$F4,$4A,$FA,$67,$DA,$5B,$FB,$84,$56,$AA,$0B,$D6,
    $65,$E9,$16,$E8,$DE,$D6,$AD,$D1,$AD,$D7,$7D,$AD,$2B,$D3,$1D,$D0,
    $FD,$A8,$3B,$AB,$BB,$A3,$33,$E9,$63,$F4,$97,$F5,$F7,$F5,$94,$C1,
    $C7,$90,$69,$C8,$36,$14,$19,$DE,$32,$9C,$33,$5C,$35,$FC,$1B,$37,
    $07,$84,$30,$F5,$84,$47,$6F,$D1,$20,$D1,$B3,$A2,$A9,$A2,$02,$D1,
    $3A,$D1,$51,$D1,$29,$D1,$4F,$A2,$06,$D1,$4D,$51,$AB,$C8,$21,$E2,
    $8B,$BB,$89,$07,$00,$CE,$C2,$C4,$63,$C4,$13,$C5,$39,$E2,$D7,$C5,
    $2B,$C5,$9B,$C5,$65,$E2,$72,$F1,$79,$C0,$CC,$6D,$71,$5F,$C9,$70,
    $82,$8F,$38,$49,$92,$64,$B5,$64,$AF,$E4,$A2,$E4,$37,$49,$B3,$A4,
    $55,$32,$51,$3A,$5D,$9A,$24,$4D,$95,$E6,$48,$0B,$A5,$E7,$A4,$97,
    $A5,$BF,$4B,$EF,$48,$FF,$94,$76,$91,$75,$97,$3D,$2A,$0B,$94,$3D,
    $29,$3B,$26,$FB,$97,$CC,$4F,$FE,$B8,$FC,$29,$79,$AE,$3C,$5F,$6E,
    $93,$6F,$91,$57,$CA,$7F,$05,$BC,$3D,$A6,$78,$41,$41,$2B,$E6,$2B,
    $4B,$95,$53,$54,$0B,$55,$CB,$55,$EF,$A9,$34,$6A,$A3,$7A,$A9,$E6,
    $98,$E6,$82,$E6,$A6,$A6,$07,$FD,$14,$AD,$A1,$C7,$D3,$C5,$F4,$50,
    $DD,$EB,$BA,$75,$BA,$D3,$BA,$EB,$BA,$FE,$FA,$11,$FA,$38,$FD,$A7,
    $FA,$2A,$FD,$05,$7D,$77,$43,$80,$61,$B4,$E1,$15,$C3,$31,$6C,$9B,
    $08,$66,$83,$F0,$88,$06,$9A,$98,$2B,$7A,$57,$F4,$11,$B4,$EB,$8E,
    $68,$94,$D8,$26,$BE,$2A,$E9,$2A,$7D,$5A,$3A,$4A,$9A,$2D,$7D,$4D,
    $BA,$4C,$FA,$8D,$F4,$84,$B4,$9F,$EC,$79,$99,$5E,$96,$29,$5B,$28,
    $CB,$93,$15,$CB,$56,$CA,$AE,$CA,$EA,$65,$7F,$CA,$04,$72,$7F,$A8,
    $E1,$0B,$72,$A9,$5C,$2D,$9F,$28,$37,$CB,$67,$CB,$D3,$E5,$6F,$C9,
    $3F,$92,$6F,$90,$6F,$96,$EF,$97,$1F,$95,$FF,$20,$BF,$24,$7F,$5D,
    $B1,$5C,$71,$40,$83,$BB,$EE,$31,$50,$D6,$5E,$31,$5F,$32,$42,$F2,
    $91,$64,$8B,$E4,$88,$44,$2B,$8B,$95,$7D,$2A,$3B,$28,$FB,$44,$79,
    $43,$D9,$AE,$DC,$AA,$3E,$A9,$FE,$45,$3D,$44,$A3,$D7,$AC,$A1,$3F,
    $A3,$4B,$E9,$72,$FA,$08,$FD,$98,$F6,$79,$ED,$6C,$ED,$2B,$DA,$7C,
    $ED,$C7,$DA,$4D,$DA,$5D,$DA,$7D,$DA,$79,$BA,$27,$F5,$63,$F5,$13,
    $F5,$2F,$E9,$03,$0D,$93,$0C,$9F,$18,$28,$13,$45,$1D,$05,$5A,$8F,
    $14,$31,$A2,$FE,$E2,$6C,$F1,$76,$71,$B0,$24,$46,$92,$22,$29,$90,
    $AC,$95,$7C,$25,$D9,$25,$79,$43,$F9,$8E,$F2,$03,$E5,$7A,$E5,$76,
    $E5,$3E,$E5,$11,$E5,$05,$E5,$4D,$E5,$7D,$E5,$23,$2A,$7F,$55,$3F,
    $D5,$00,$D5,$60,$D5,$50,$95,$54,$A5,$55,$19,$55,$91,$AA,$29,$AA,
    $69,$AA,$78,$95,$59,$35,$47,$95,$AE,$7A,$43,$B5,$4C,$F5,$AE,$6A,
    $8D,$6A,$93,$6A,$87,$6A,$BF,$EA,$B8,$EA,$9A,$EA,$37,$D5,$2D,$D5,
    $3D,$95,$97,$3A,$00,$30,$3D,$41,$3D,$55,$1D,$A7,$5E,$A8,$B6,$A9,
    $B7,$A8,$0F,$AB,$4F,$A8,$4F,$A9,$CF,$A9,$FF,$A5,$6E,$55,$3F,$A5,
    $79,$51,$A3,$D5,$8C,$D3,$4C,$D6,$CC,$D0,$24,$69,$D2,$34,$F3,$34,
    $8B,$34,$4B,$34,$CB,$35,$EF,$6A,$D6,$69,$3E,$D7,$6C,$D1,$EC,$D2,
    $EC,$07,$CA,$FC,$51,$73,$4E,$73,$45,$73,$5D,$73,$43,$73,$5B,$D3,
    $AE,$F1,$A1,$7B,$D2,$7D,$E9,$81,$F4,$33,$F4,$70,$42,$AD,$23,$E9,
    $71,$F4,$64,$7A,$06,$9D,$44,$A7,$D1,$F3,$80,$76,$97,$D0,$CB,$E9,
    $77,$E9,$75,$F4,$E7,$F4,$16,$7A,$17,$BD,$9F,$AE,$A4,$7F,$A4,$CF,
    $D1,$57,$E8,$EB,$F4,$0D,$FA,$36,$DD,$4E,$FB,$68,$7B,$6A,$FB,$6A,
    $07,$6A,$9F,$D1,$0E,$D7,$2A,$B4,$7A,$ED,$48,$ED,$38,$ED,$64,$ED,
    $0C,$6D,$92,$36,$4D,$3B,$4F,$BB,$48,$BB,$44,$7B,$5E,$FB,$B3,$B6,
    $59,$EB,$A5,$F3,$D3,$3D,$AE,$1B,$A2,$D3,$00,$0F,$4C,$D5,$CD,$D4,
    $CD,$D6,$CD,$D3,$2D,$D2,$2D,$D1,$2D,$D7,$6D,$D0,$6D,$D7,$95,$03,
    $95,$5C,$D5,$35,$EA,$5A,$75,$DD,$F4,$FD,$F4,$4F,$E9,$45,$40,$2F,
    $E1,$7A,$E4,$8A,$38,$7D,$B2,$3E,$43,$9F,$AD,$CF,$D3,$17,$E9,$57,
    $E8,$57,$EB,$4B,$F4,$1B,$F5,$A5,$FA,$32,$7D,$B9,$FE,$28,$50,$53,
    $8D,$BE,$4E,$CF,$E8,$9B,$F5,$AD,$C0,$39,$02,$83,$BF,$21,$D0,$20,
    $34,$0C,$31,$88,$0C,$2A,$43,$B0,$21,$DC,$60,$32,$C4,$18,$E2,$0C,
    $C9,$86,$0C,$E0,$A8,$3C,$E0,$A9,$15,$86,$D5,$86,$12,$C3,$46,$43,
    $A9,$A1,$CC,$50,$6E,$38,$6A,$A8,$32,$D4,$18,$EA,$0C,$8C,$A1,$D9,
    $D0,$8A,$B4,$18,$07,$C3,$16,$6E,$2C,$8A,$04,$22,$7F,$51,$A0,$48,
    $28,$1A,$22,$12,$89,$54,$A2,$60,$90,$5E,$26,$90,$5C,$71,$A2,$64,
    $90,$5B,$D9,$A2,$3C,$51,$11,$C8,$AE,$D5,$A2,$12,$D1,$46,$51,$A9,
    $A8,$4C,$54,$0E,$DC,$78,$5E,$F4,$B3,$A8,$59,$E4,$25,$16,$88,$03,
    $C5,$22,$B1,$0A,$38,$31,$46,$1C,$27,$4E,$14,$27,$8B,$53,$C5,$19,
    $62,$0B,$50,$45,$8E,$38,$0F,$64,$57,$09,$F0,$E4,$51,$F1,$09,$71,
    $95,$B8,$5A,$5C,$23,$AE,$15,$D7,$89,$EB,$C5,$8C,$B8,$4D,$1C,$24,
    $19,$2C,$19,$22,$19,$26,$11,$49,$64,$12,$95,$44,$2B,$09,$96,$84,
    $01,$0D,$65,$4B,$F2,$80,$8A,$8A,$24,$CB,$24,$2B,$24,$2B,$81,$73,
    $D7,$4A,$4A,$24,$A5,$92,$2A,$49,$8D,$A4,$56,$52,$27,$A9,$97,$30,
    $92,$26,$E0,$E3,$16,$E0,$64,$81,$74,$88,$54,$24,$95,$49,$55,$52,
    $AD,$34,$58,$1A,$26,$0D,$97,$46,$48,$4D,$D2,$64,$69,$91,$74,$85,
    $74,$A5,$74,$B5,$74,$AD,$B4,$44,$BA,$5E,$BA,$51,$BA,$59,$5A,$2A,
    $2D,$97,$D6,$49,$19,$69,$93,$B4,$59,$DA,$22,$6D,$95,$B6,$49,$29,
    $19,$5F,$26,$00,$7E,$57,$C9,$82,$65,$61,$B2,$70,$59,$84,$CC,$24,
    $8B,$92,$C5,$00,$67,$C4,$C9,$32,$64,$2B,$64,$AB,$65,$6B,$65,$25,
    $B2,$F5,$B2,$8D,$B2,$CD,$B2,$52,$D9,$0E,$59,$99,$EC,$84,$AC,$49,
    $D6,$22,$6B,$95,$B5,$C9,$28,$39,$5F,$2E,$90,$FB,$02,$0F,$06,$C8,
    $07,$CB,$C3,$E4,$11,$72,$93,$3C,$4A,$1E,$23,$8F,$95,$C7,$C9,$13,
    $E5,$C9,$F2,$54,$79,$8E,$7C,$AD,$7C,$BD,$7C,$23,$70,$63,$A9,$7C,
    $87,$BC,$4C,$BE,$57,$5E,$2E,$AF,$90,$57,$CB,$5B,$E4,$6D,$20,$49,
    $F8,$0A,$81,$C2,$57,$E1,$AF,$08,$50,$04,$2A,$82,$14,$C3,$14,$11,
    $8A,$28,$45,$8C,$22,$56,$11,$A7,$48,$54,$24,$2B,$52,$15,$19,$0A,
    $8B,$A2,$40,$B1,$5E,$B1,$59,$51,$AA,$D8,$A1,$28,$53,$EC,$55,$94,
    $2B,$2A,$14,$47,$15,$27,$40,$66,$53,$4A,$81,$D2,$57,$E9,$AF,$0C,
    $50,$06,$2A,$83,$94,$42,$E5,$60,$E5,$10,$A5,$56,$19,$AB,$4C,$54,
    $26,$2B,$53,$95,$19,$4A,$8B,$32,$5B,$99,$A3,$CC,$53,$16,$28,$57,
    $2B,$CB,$94,$E5,$CA,$0A,$E5,$51,$E5,$09,$65,$95,$B2,$5A,$59,$A3,
    $AC,$55,$D6,$29,$5B,$95,$81,$2A,$21,$70,$E0,$10,$D5,$30,$95,$48,
    $25,$53,$A9,$80,$0F,$83,$55,$26,$55,$86,$2A,$5B,$95,$A3,$CA,$53,
    $15,$A8,$8A,$80,$0B,$57,$A8,$56,$AA,$56,$AB,$36,$AB,$4E,$A8,$AA,
    $55,$35,$AA,$5A,$55,$9D,$AA,$5E,$C5,$A8,$9A,$54,$CD,$AA,$16,$15,
    $5F,$3D,$58,$3D,$4C,$2D,$52,$CB,$D4,$2A,$B5,$56,$1D,$AC,$0E,$53,
    $87,$AB,$23,$80,$33,$F3,$D4,$45,$EA,$65,$EA,$15,$30,$76,$AC,$56,
    $AF,$55,$97,$C0,$F8,$B1,$11,$46,$8F,$3A,$35,$A3,$6E,$52,$37,$AB,
    $5B,$80,$53,$DB,$D4,$94,$86,$AF,$11,$68,$82,$80,$5F,$C3,$34,$E1,
    $9A,$08,$18,$45,$A2,$34,$31,$9A,$58,$4D,$1C,$8C,$25,$D9,$9A,$D5,
    $9A,$12,$18,$47,$36,$6A,$36,$6B,$4A,$35,$3B,$34,$65,$9A,$BD,$9A,
    $72,$4D,$95,$A6,$59,$D3,$AA,$69,$D3,$50,$34,$9F,$16,$D0,$BE,$B4,
    $3F,$1D,$40,$07,$D2,$5A,$3A,$8E,$4E,$A5,$F3,$E8,$22,$7A,$19,$BD,
    $02,$46,$9A,$D5,$F4,$5A,$BA,$84,$5E,$4F,$6F,$04,$6E,$BD,$4D,$F7,
    $D2,$3E,$A7,$1D,$A3,$8B,$D6,$2D,$44,$FA,$CE,$A0,$28,$BC,$DC,$F3,
    $6D,$71,$2F,$69,$5F,$69,$7F,$E9,$40,$E9,$93,$D2,$67,$A4,$CF,$4B,
    $87,$4B,$25,$52,$85,$54,$23,$D5,$4B,$47,$48,$47,$4A,$C7,$48,$C7,
    $49,$27,$4A,$27,$4B,$B7,$CB,$F6,$C8,$B2,$E4,$17,$95,$B7,$94,$77,
    $94,$DE,$AA,$67,$54,$93,$54,$31,$AA,$4C,$90,$F4,$C7,$54,$DE,$EA,
    $1E,$6A,$A9,$7A,$BC,$3A,$0D,$DA,$B9,$49,$BD,$5F,$7D,$53,$DD,$AE,
    $0E,$D4,$3C,$0F,$F5,$2E,$D0,$7C,$A5,$79,$8C,$0E,$A3,$A7,$D3,$B3,
    $E9,$7C,$FA,$6D,$FA,$4B,$90,$16,$94,$F6,$8C,$B6,$B7,$2E,$50,$27,
    $D4,$8D,$D1,$4D,$D3,$25,$EA,$1E,$D3,$3F,$AB,$0F,$D3,$47,$EA,$CF,
    $E9,$BB,$18,$56,$1A,$7E,$C4,$7A,$E5,$51,$D4,$32,$90,$9F,$B1,$A2,
    $2C,$D1,$2A,$D1,$A7,$A2,$4D,$A2,$43,$A2,$63,$A2,$5A,$51,$8B,$C8,
    $5F,$DC,$4F,$2C,$14,$4F,$13,$2F,$10,$AF,$07,$A9,$7A,$44,$FC,$BC,
    $44,$2C,$39,$25,$E1,$43,$CD,$5F,$90,$36,$48,$EF,$4B,$8D,$B2,$29,
    $B2,$39,$B2,$6F,$64,$3F,$CB,$02,$E5,$CF,$CA,$15,$40,$77,$B3,$E5,
    $DF,$CA,$8F,$C9,$6B,$E4,$D7,$E4,$BF,$C9,$EF,$CA,$BD,$81,$BA,$7A,
    $2A,$7A,$C3,$78,$35,$50,$31,$58,$31,$54,$21,$56,$28,$14,$5A,$45,
    $88,$62,$14,$D0,$D9,$44,$C5,$CB,$8A,$5C,$C5,$12,$C5,$DB,$8A,$F7,
    $14,$25,$40,$5F,$5B,$15,$7B,$14,$87,$81,$AE,$CE,$2A,$AE,$28,$F8,
    $CA,$1E,$CA,$BE,$CA,$41,$40,$51,$33,$94,$8B,$94,$1B,$95,$87,$80,
    $5A,$12,$55,$73,$55,$43,$D4,$7A,$F5,$2C,$B5,$15,$7A,$F6,$7D,$F5,
    $0E,$F5,$11,$F5,$45,$F5,$CF,$D0,$F6,$47,$35,$FD,$35,$6A,$CD,$28,
    $90,$B8,$8B,$34,$6F,$68,$D6,$68,$BE,$D0,$EC,$D3,$5C,$D2,$FC,$A9,
    $F1,$A5,$FB,$D3,$3A,$FA,$65,$90,$A3,$28,$45,$D7,$D0,$9F,$C2,$78,
    $F2,$03,$BD,$56,$5B,$AD,$BD,$A4,$65,$B4,$37,$B5,$8F,$E8,$14,$BA,
    $C9,$BA,$24,$DD,$2B,$BA,$F9,$BA,$C5,$BA,$02,$5D,$B3,$AE,$05,$E4,
    $58,$1B,$48,$32,$3E,$C8,$32,$5F,$90,$66,$01,$20,$CF,$82,$40,$A2,
    $0D,$06,$99,$36,$0C,$A4,$9A,$0C,$E4,$9A,$16,$24,$5B,$18,$C8,$B6,
    $08,$90,$6E,$51,$20,$DF,$62,$41,$C2,$25,$82,$8C,$4B,$05,$29,$67,
    $01,$39,$97,$03,$92,$AE,$00,$64,$DD,$32,$90,$76,$2B,$41,$DE,$AD,
    $05,$89,$B7,$1E,$64,$DE,$66,$90,$7A,$3B,$40,$EE,$ED,$05,$C9,$57,
    $01,$B2,$EF,$04,$48,$BF,$6A,$22,$FF,$EA,$0D,$4D,$44,$02,$B6,$61,
    $5F,$AC,$80,$EE,$80,$BE,$E0,$13,$19,$18,$00,$BA,$1B,$4A,$C1,$61,
    $22,$19,$91,$83,$61,$44,$8B,$43,$1D,$2E,$91,$C8,$42,$8B,$28,$87,
    $48,$C3,$65,$A2,$95,$44,$1E,$AE,$17,$6D,$26,$12,$71,$AF,$A8,$02,
    $64,$62,$95,$A8,$1A,$7A,$B1,$0E,$46,$C5,$26,$E8,$CB,$56,$11,$25,
    $E6,$8B,$7D,$C5,$FE,$20,$21,$83,$C4,$83,$C5,$43,$40,$4E,$CA,$C4,
    $5A,$71,$B0,$38,$5C,$1C,$21,$8E,$E2,$E4,$25,$4A,$4B,$94,$95,$05,
    $E2,$22,$F1,$0A,$D0,$62,$D6,$82,$C4,$DC,$08,$BA,$CC,$0E,$D0,$66,
    $8C,$92,$57,$24,$F9,$92,$37,$40,$97,$7B,$53,$F2,$8E,$E4,$84,$E4,
    $A6,$24,$50,$3A,$53,$BA,$4F,$7A,$1C,$68,$E1,$9E,$B4,$A7,$CC,$20,
    $9B,$06,$FC,$FE,$88,$6A,$A0,$AA,$37,$70,$DD,$41,$F5,$28,$CD,$9B,
    $D0,$1B,$9F,$6B,$F6,$68,$BE,$D3,$9C,$D4,$5C,$D4,$D4,$C3,$88,$77,
    $57,$E3,$0D,$E3,$5D,$20,$68,$28,$2F,$D0,$2A,$7A,$04,$1D,$49,$4F,
    $A1,$E3,$E9,$39,$B4,$95,$5E,$0C,$FA,$CA,$3B,$F4,$87,$F4,$06,$7A,
    $37,$7D,$92,$BE,$04,$1A,$DB,$EF,$74,$2B,$50,$6F,$17,$ED,$50,$6D,
    $B8,$D6,$A4,$8D,$D1,$CE,$D2,$66,$69,$F3,$B4,$6F,$6B,$57,$6B,$CB,
    $B4,$E5,$DA,$0A,$ED,$51,$ED,$09,$6D,$15,$F4,$66,$8D,$B6,$56,$5B,
    $07,$23,$9C,$3F,$50,$79,$10,$D0,$F9,$60,$18,$E5,$86,$E9,$44,$3A,
    $99,$4E,$A5,$8B,$D0,$C5,$E8,$52,$75,$16,$5D,$B6,$2E,$47,$97,$07,
    $7D,$5C,$A4,$5B,$A6,$5B,$A1,$5B,$A9,$FB,$44,$B7,$49,$97,$AE,$FF,
    $08,$B4,$21,$89,$61,$81,$E1,$1B,$C3,$35,$C3,$2D,$C3,$9F,$88,$FF,
    $12,$8A,$C2,$A3,$3D,$5E,$A2,$1E,$A2,$5E,$A2,$01,$A2,$27,$45,$2F,
    $88,$24,$22,$9D,$68,$84,$28,$52,$74,$5F,$F4,$AE,$F8,$2B,$F1,$9F,
    $E2,$6E,$92,$01,$92,$30,$D9,$9B,$B2,$7D,$B2,$4A,$D9,$7D,$99,$97,
    $FC,$90,$FC,$B6,$FC,$4F,$F9,$27,$8A,$DF,$14,$0E,$45,$2F,$A5,$41,
    $A9,$54,$BD,$A5,$5A,$A5,$7A,$5F,$F5,$A1,$EA,$63,$D5,$67,$AA,$2F,
    $54,$5F,$A9,$B6,$AA,$76,$AA,$76,$AB,$F6,$A9,$0E,$AA,$BE,$03,$FE,
    $FD,$41,$75,$4A,$75,$56,$35,$42,$3D,$96,$E8,$11,$33,$D5,$73,$80,
    $A2,$17,$AA,$0B,$D5,$CB,$D5,$1F,$AA,$B7,$AA,$0F,$A8,$8F,$AB,$CF,
    $A8,$2F,$00,$65,$37,$A9,$FF,$AD,$76,$A8,$7D,$35,$FD,$34,$CF,$69,
    $34,$40,$DF,$91,$9A,$89,$20,$A1,$A6,$6B,$12,$34,$C9,$9A,$4C,$CD,
    $02,$A0,$F6,$02,$D0,$78,$57,$6A,$D6,$82,$A4,$DA,$0C,$52,$6A,$AF,
    $A6,$42,$73,$42,$53,$AD,$A9,$05,$4C,$FF,$01,$DA,$AF,$2F,$68,$15,
    $53,$E8,$04,$90,$05,$16,$C0,$EE,$5B,$F4,$27,$20,$93,$8E,$D2,$55,
    $74,$35,$5D,$43,$D7,$D2,$75,$74,$3D,$CD,$D0,$4D,$74,$33,$CD,$D7,
    $0E,$D6,$0E,$D3,$8A,$B4,$32,$AD,$4A,$AB,$D5,$06,$6B,$C3,$00,$DF,
    $11,$DA,$38,$C0,$75,$91,$76,$99,$76,$85,$76,$25,$60,$7C,$AD,$B6,
    $44,$BB,$5E,$BB,$11,$30,$5F,$03,$B8,$AE,$07,$FE,$69,$02,$8C,$B7,
    $68,$5B,$B5,$6D,$5A,$4A,$E7,$0F,$D8,$56,$E9,$B4,$A0,$59,$84,$E9,
    $C2,$01,$E7,$26,$5D,$14,$E0,$3D,$19,$B0,$8D,$B8,$5E,$AD,$5B,$AB,
    $2B,$01,$7D,$7B,$A3,$6E,$B3,$AE,$14,$34,$8D,$3A,$1D,$A3,$6B,$42,
    $6E,$03,$6D,$A3,$4D,$47,$E9,$F9,$7A,$81,$3E,$50,$AF,$D2,$07,$83,
    $5C,$0A,$D7,$47,$80,$D6,$11,$05,$7A,$47,$2C,$68,$1E,$D9,$44,$DF,
    $58,$0F,$1A,$C7,$66,$D0,$39,$76,$80,$D6,$B1,$17,$F4,$8E,$0A,$D0,
    $3C,$4E,$80,$EE,$51,$0B,$BC,$FA,$57,$4E,$95,$01,$77,$22,$67,$3E,
    $8C,$2F,$DF,$36,$BC,$0B,$DC,$B8,$DB,$B0,$0F,$F8,$EF,$17,$03,$55,
    $4A,$51,$15,$84,$DF,$90,$DB,$06,$03,$A7,$89,$08,$AF,$69,$09,$B7,
    $75,$9E,$35,$25,$8B,$52,$09,$D7,$65,$13,$BE,$2B,$20,$9C,$B7,$82,
    $F0,$DE,$5A,$C2,$7D,$1B,$09,$FF,$ED,$20,$1C,$F8,$3D,$F0,$DE,$6F,
    $30,$AB,$A2,$C4,$8F,$01,$B7,$C9,$40,$23,$89,$10,$9B,$08,$9F,$C5,
    $3E,$40,$33,$41,$7E,$5B,$46,$38,$6E,$35,$E1,$B9,$F5,$84,$EB,$4A,
    $09,$DF,$ED,$05,$9D,$A5,$E2,$01,$5A,$4B,$93,$B8,$59,$4C,$49,$1E,
    $95,$F4,$01,$CD,$25,$5C,$62,$92,$44,$81,$C6,$12,$0B,$73,$8C,$44,
    $49,$B2,$24,$55,$92,$21,$B1,$80,$FE,$92,$03,$1A,$CC,$32,$32,$F7,
    $2A,$83,$79,$47,$B9,$A4,$42,$72,$14,$38,$B7,$4A,$52,$ED,$D2,$61,
    $5A,$81,$8B,$85,$D2,$C1,$A0,$BF,$0C,$7B,$80,$06,$13,$27,$CD,$03,
    $1D,$66,$D9,$03,$B4,$98,$1D,$D2,$32,$69,$15,$E8,$30,$6E,$0D,$C6,
    $57,$E6,$2F,$0B,$00,$3D,$26,$48,$26,$94,$0D,$96,$0D,$91,$0D,$03,
    $4D,$66,$1A,$E8,$2E,$BB,$64,$A7,$64,$0D,$B2,$1B,$B2,$89,$30,$1B,
    $68,$94,$77,$51,$F4,$83,$11,$A0,$44,$F1,$BB,$E2,$79,$E5,$D7,$CA,
    $BB,$CA,$A7,$55,$55,$2A,$87,$2A,$54,$3D,$46,$1D,$AF,$FE,$0A,$66,
    $76,$41,$9A,$1A,$90,$13,$3A,$7A,$2A,$C8,$EC,$8F,$E8,$0A,$FA,$71,
    $D0,$FE,$B3,$B4,$AF,$C1,$28,$46,$03,$3D,$6D,$D1,$9D,$D7,$F9,$EB,
    $9F,$D1,$7F,$A8,$DF,$A3,$6F,$D1,$0B,$0D,$53,$90,$67,$CB,$29,$0A,
    $EF,$B2,$E5,$41,$AF,$15,$80,$BC,$BB,$25,$F2,$83,$99,$6B,$14,$E0,
    $71,$B7,$F8,$77,$71,$57,$C9,$58,$C0,$C7,$0F,$92,$46,$C9,$F3,$D2,
    $F1,$D2,$F9,$D2,$62,$E9,$E7,$D2,$93,$50,$E3,$04,$D9,$52,$D9,$6E,
    $D9,$49,$D9,$70,$F9,$58,$79,$9E,$FC,$94,$5C,$A8,$C8,$51,$34,$2B,
    $9E,$50,$EA,$94,$45,$CA,$12,$65,$2A,$70,$AE,$1A,$F8,$B3,$01,$6A,
    $14,$A6,$31,$D2,$F7,$68,$9E,$56,$A2,$55,$6B,$2F,$03,$ED,$F7,$D5,
    $0D,$D0,$7D,$AD,$3F,$AC,$BF,$A4,$BF,$A6,$7F,$C9,$60,$06,$EA,$AA,
    $36,$5C,$C0,$7A,$54,$81,$0A,$CB,$63,$F5,$D7,$7E,$40,$31,$F1,$40,
    $23,$6F,$89,$22,$A1,$26,$2A,$C9,$34,$C9,$52,$E9,$97,$D2,$AF,$A5,
    $DB,$61,$26,$F5,$AD,$F4,$80,$F4,$B0,$F4,$08,$C8,$CD,$93,$D2,$33,
    $D2,$F3,$D2,$4B,$D2,$AB,$D2,$9F,$A5,$BF,$4A,$1B,$A5,$37,$A5,$7F,
    $C0,$0C,$F0,$BE,$F4,$28,$E8,$77,$FE,$F2,$9E,$8A,$BE,$8A,$A7,$14,
    $2F,$2A,$F4,$8A,$34,$45,$16,$CC,$94,$3F,$55,$7C,$0D,$63,$64,$85,
    $E2,$8C,$E2,$32,$D4,$B4,$4D,$D1,$57,$F9,$A4,$F2,$59,$A5,$58,$19,
    $AA,$9C,$0C,$E3,$64,$32,$E8,$5B,$8B,$94,$85,$CA,$37,$95,$EF,$42,
    $FD,$37,$28,$B7,$82,$CE,$75,$48,$F9,$AB,$F2,$0F,$E5,$3D,$65,$17,
    $98,$EB,$3C,$0F,$3A,$96,$41,$35,$16,$B4,$88,$D9,$A0,$61,$A1,$5E,
    $B5,$5A,$B5,$56,$55,$A2,$5A,$AF,$DA,$08,$DA,$55,$29,$CC,$73,$CA,
    $54,$7B,$55,$E5,$AA,$0A,$D5,$51,$E8,$11,$46,$25,$50,$FB,$C3,$5C,
    $27,$50,$1D,$A4,$16,$82,$96,$35,$A4,$83,$9E,$15,$AB,$CE,$51,$17,
    $FC,$45,$C7,$DA,$A1,$AE,$56,$D7,$82,$96,$55,$DF,$41,$CF,$0A,$D0,
    $C8,$40,$C7,$0A,$EE,$A4,$65,$7D,$AA,$D9,$A4,$39,$03,$63,$C2,$F3,
    $B4,$98,$B6,$D1,$AF,$6B,$8B,$B5,$06,$DD,$48,$5D,$B4,$7E,$80,$E1,
    $34,$CC,$BB,$2F,$1A,$AE,$80,$44,$BE,$6E,$F8,$CD,$70,$03,$E4,$F2,
    $6D,$C3,$3D,$43,$3B,$E2,$B7,$8E,$C2,$A9,$1E,$C8,$66,$1F,$51,$37,
    $D1,$4C,$E0,$B7,$E7,$C5,$9B,$24,$EF,$C8,$D6,$6B,$0F,$83,$3C,$FA,
    $5D,$2B,$D4,$19,$40,$F2,$44,$EB,$6C,$20,$DB,$29,$7D,$6F,$BD,$4C,
    $EF,$D0,$0B,$0C,$3D,$0C,$BD,$0C,$FD,$0C,$D3,$0D,$49,$86,$39,$20,
    $09,$AC,$30,$26,$7F,$6C,$F8,$D2,$B0,$CB,$70,$D0,$40,$35,$53,$D4,
    $30,$C8,$6F,$09,$50,$C2,$72,$D9,$DB,$B2,$77,$65,$1F,$C8,$D6,$C9,
    $3E,$91,$7D,$2E,$DB,$24,$DB,$22,$FB,$46,$C1,$28,$CB,$E9,$75,$BA,
    $6B,$BA,$34,$2C,$9B,$E2,$91,$6F,$C8,$7D,$25,$12,$8A,$51,$4B,$0D,
    $53,$85,$AB,$22,$40,$57,$8D,$02,$7C,$C6,$AA,$E2,$54,$89,$AA,$97,
    $34,$22,$DA,$A4,$9D,$A0,$BB,$A1,$EB,$89,$F1,$FD,$79,$48,$0E,$54,
    $1D,$D0,$B9,$5D,$49,$AB,$7A,$A8,$87,$AB,$D7,$A9,$23,$34,$8F,$D3,
    $CF,$D2,$32,$98,$E3,$45,$D0,$51,$74,$2C,$9D,$08,$9A,$A3,$85,$CE,
    $A1,$0B,$40,$77,$5C,$09,$7A,$E3,$7A,$7A,$33,$BD,$83,$DE,$0B,$54,
    $7F,$02,$A4,$74,$2D,$48,$E8,$26,$BA,$85,$EE,$A9,$0D,$D2,$6A,$40,
    $26,$27,$69,$2D,$30,$FA,$95,$68,$F7,$C3,$B8,$F7,$1B,$48,$DE,$BE,
    $30,$D2,$8D,$80,$16,$A7,$C1,$D8,$F6,$01,$48,$D7,$4A,$5D,$B5,$EE,
    $17,$90,$AC,$77,$74,$5E,$FA,$BE,$FA,$01,$7A,$09,$C8,$54,$BD,$7E,
    $96,$3E,$4B,$FF,$86,$FE,$03,$FD,$06,$FD,$76,$90,$9D,$A7,$61,$C6,
    $56,$4F,$66,$6B,$9D,$25,$E7,$70,$83,$C2,$A0,$37,$8C,$34,$8C,$33,
    $4C,$36,$CC,$00,$6C,$A5,$19,$E6,$81,$0E,$B3,$C1,$F0,$35,$8C,$8E,
    $35,$06,$4A,$C8,$A3,$C2,$B1,$59,$22,$B3,$C8,$2E,$FA,$52,$14,$0F,
    $52,$E1,$5D,$E9,$16,$E9,$51,$69,$81,$BC,$B7,$C2,$57,$39,$50,$69,
    $26,$F4,$B7,$45,$F9,$B6,$AA,$27,$B4,$D5,$A4,$9E,$AF,$0E,$A2,$27,
    $D0,$E9,$30,$8F,$DF,$0E,$73,$55,$A5,$CE,$A8,$BB,$47,$D6,$1B,$78,
    $94,$0A,$1E,$A8,$7D,$4C,$16,$67,$83,$3C,$E9,$AF,$1C,$09,$33,$84,
    $23,$CA,$06,$D0,$73,$DB,$94,$C3,$55,$7A,$A0,$A4,$2A,$F5,$10,$98,
    $45,$E3,$D8,$B6,$45,$F3,$BE,$B6,$42,$0F,$09,$82,$79,$C4,$B6,$1D,
    $B5,$D2,$BE,$E2,$E1,$20,$25,$CD,$92,$0B,$92,$C1,$20,$9F,$8E,$48,
    $07,$C9,$DE,$91,$FF,$22,$4F,$00,$3D,$F2,$80,$E2,$4F,$45,$82,$B2,
    $0F,$CC,$C7,$79,$30,$EB,$DE,$A9,$19,$01,$E5,$E7,$C0,$C8,$77,$87,
    $EE,$AD,$7D,$1A,$66,$C2,$1F,$80,$CE,$D0,$4D,$F7,$96,$EE,$3B,$9D,
    $52,$3F,$4A,$6F,$05,$AC,$5C,$86,$B9,$2B,$65,$18,$61,$68,$C1,$BA,
    $99,$78,$D4,$0A,$E0,$5F,$09,$C8,$FA,$33,$22,$8D,$F8,$0F,$F1,$00,
    $C9,$54,$C9,$6D,$89,$10,$24,$E1,$1F,$D2,$17,$64,$1B,$80,$2B,$C3,
    $41,$C3,$BD,$2A,$1F,$A6,$18,$AD,$98,$05,$F3,$A2,$4F,$40,$57,$FD,
    $53,$F1,$AD,$F2,$80,$F2,$30,$B4,$E0,$B8,$F2,$A4,$F2,$8C,$F2,$BC,
    $F2,$92,$52,$A2,$0A,$01,$DA,$78,$59,$95,$A6,$CA,$05,$4E,$C3,$55,
    $84,$DD,$C0,$55,$E7,$55,$D7,$55,$FF,$86,$39,$4B,$6F,$F5,$93,$EA,
    $AB,$9A,$46,$18,$A3,$DB,$34,$8F,$80,$8E,$FA,$2C,$2D,$A5,$83,$E9,
    $89,$74,$0C,$D0,$43,$36,$CC,$24,$0A,$3A,$CD,$25,$70,$DE,$7F,$02,
    $C6,$6C,$A4,$85,$56,$BA,$0D,$74,$22,$BE,$56,$A0,$F5,$D5,$FA,$6B,
    $03,$B4,$4F,$C2,$98,$1D,$06,$BA,$51,$9C,$36,$51,$9B,$AC,$4D,$D5,
    $66,$00,$8D,$64,$6B,$73,$60,$EC,$2E,$E0,$46,$EF,$75,$DA,$1D,$A0,
    $23,$D5,$FE,$65,$D4,$0E,$00,$FD,$A8,$F3,$88,$1D,$AB,$CB,$80,$11,
    $BB,$E3,$78,$BD,$43,$57,$A6,$3B,$0A,$23,$76,$C7,$F1,$DA,$57,$EF,
    $AF,$17,$C2,$88,$DD,$71,$BC,$4E,$D4,$27,$FF,$C3,$98,$5D,$AD,$6F,
    $D2,$FB,$FE,$AD,$5E,$9D,$0F,$3A,$73,$13,$AB,$0B,$C7,$B1,$3C,$37,
    $18,$46,$57,$0A,$FA,$7C,$BC,$F8,$A0,$A2,$56,$71,$53,$F1,$9E,$2A,
    $57,$7D,$4B,$BD,$05,$5A,$F5,$BB,$6E,$BC,$7E,$2B,$F0,$78,$02,$50,
    $29,$CE,$AF,$78,$54,$0E,$3C,$F2,$45,$17,$81,$4B,$5F,$10,$67,$89,
    $4F,$89,$4F,$4B,$BC,$A4,$7D,$A4,$91,$52,$3B,$48,$DB,$1B,$52,$3E,
    $70,$78,$A4,$7C,$AE,$5C,$A7,$38,$02,$BA,$DA,$68,$98,$A5,$AE,$02,
    $39,$F9,$3C,$70,$F3,$58,$D5,$2E,$55,$5F,$98,$3B,$BE,$A4,$CE,$52,
    $BF,$AE,$7E,$0F,$78,$75,$10,$C8,$2D,$2B,$CC,$FA,$A2,$B5,$D3,$C9,
    $2A,$CA,$06,$ED,$D7,$A0,$6D,$D6,$68,$EF,$6A,$47,$E8,$0E,$C1,$2C,
    $2A,$5A,$9F,$A6,$0F,$32,$8C,$06,$7D,$A2,$94,$CC,$A1,$58,$BA,$36,
    $83,$F6,$56,$A7,$BE,$AE,$6E,$D1,$F8,$D0,$72,$7A,$39,$BD,$8E,$DE,
    $47,$CB,$B4,$E3,$B5,$F9,$DA,$EF,$B4,$BF,$82,$8C,$5A,$00,$DC,$59,
    $AA,$FF,$11,$66,$5F,$32,$C3,$FB,$98,$12,$08,$0E,$86,$2F,$6A,$AC,
    $E8,$82,$E8,$BA,$A8,$97,$78,$83,$E4,$4B,$C9,$D7,$92,$ED,$92,$6F,
    $24,$DF,$C2,$D8,$DC,$15,$66,$87,$91,$D2,$EF,$A4,$67,$61,$54,$98,
    $21,$9F,$0F,$73,$AB,$CB,$F2,$9B,$F2,$19,$CA,$34,$E5,$76,$90,$29,
    $33,$54,$9F,$83,$D4,$FE,$51,$B5,$45,$ED,$A3,$E9,$AD,$79,$4A,$93,
    $AE,$D9,$AA,$C1,$59,$E9,$5C,$FA,$00,$7D,$1C,$E8,$E5,$37,$A0,$FB,
    $6E,$20,$3B,$84,$A0,$DF,$0D,$79,$80,$86,$67,$D2,$46,$01,$E5,$C4,
    $FE,$0D,$ED,$78,$6A,$7E,$9B,$B5,$A5,$40,$49,$65,$DA,$BD,$2E,$DD,
    $BB,$5A,$7B,$55,$4B,$95,$F0,$A8,$22,$E0,$99,$00,$51,$20,$68,$4F,
    $38,$53,$F1,$17,$AB,$C8,$AC,$22,$8C,$CC,$2B,$FE,$4F,$68,$3C,$FE,
    $92,$40,$89,$10,$74,$1C,$91,$44,$25,$09,$26,$9A,$4E,$0C,$68,$39,
    $C9,$A0,$E1,$E0,$FA,$4C,$91,$64,$85,$64,$B5,$A4,$44,$B2,$51,$52,
    $0A,$3A,$8E,$E7,$9A,$4C,$9B,$84,$92,$76,$D6,$75,$FF,$CA,$41,$81,
    $FF,$83,$18,$72,$CF,$4E,$3A,$6B,$CC,$7C,$9D,$40,$E7,$0B,$7A,$73,
    $C0,$03,$E6,$2C,$7F,$E5,$CA,$38,$98,$B7,$27,$C3,$3C,$26,$E3,$01,
    $33,$19,$E4,$56,$8A,$4C,$5A,$F0,$28,$3A,$25,$C2,$99,$A3,$AF,$E8,
    $FF,$F8,$7E,$C2,$FF,$FE,$FD,$FF,$EE,$2F,$31,$7B,$BC,$86,$7D,$F3,
    $22,$E7,$39,$84,$20,$A5,$F0,$4C,$47,$06,$7B,$06,$CE,$23,$5C,$40,
    $DD,$F5,$63,$97,$1E,$EE,$C1,$73,$23,$3C,$EF,$FB,$11,$B5,$3A,$AF,
    $0D,$9E,$35,$F0,$FC,$13,$9E,$A0,$2E,$E5,$B5,$C3,$53,$C0,$A3,$F2,
    $F0,$6C,$04,$A8,$04,$79,$B8,$CF,$A4,$E2,$75,$CC,$0F,$97,$70,$85,
    $5E,$54,$1E,$0C,$A7,$79,$C3,$E1,$99,$CC,$EB,$5C,$1E,$6B,$9B,$97,
    $C7,$EB,$5C,$4F,$D6,$63,$C5,$43,$FC,$4B,$1E,$E2,$5F,$FA,$10,$FF,
    $F2,$87,$F8,$57,$3D,$C4,$BF,$EE,$21,$FE,$CD,$0F,$F1,$77,$1E,$C6,
    $EB,$EC,$EF,$0F,$FE,$E1,$4F,$7A,$51,$E1,$CE,$C3,$7A,$D8,$A6,$C1,
    $5E,$C0,$9A,$6E,$77,$F9,$10,$2F,$6A,$47,$57,$B7,$DB,$22,$F2,$22,
    $DF,$B6,$76,$FE,$C5,$89,$BD,$88,$FE,$E8,$FC,$13,$49,$BC,$A8,$C0,
    $2E,$6E,$77,$B8,$D2,$8B,$4A,$F5,$48,$BF,$43,$EF,$45,$55,$78,$84,
    $67,$87,$79,$91,$F3,$3D,$CE,$BF,$22,$70,$B7,$7A,$B8,$7D,$A8,$30,
    $6A,$32,$15,$4A,$45,$50,$21,$00,$DD,$41,$AF,$0E,$01,$D7,$58,$F8,
    $1D,$45,$19,$A9,$D1,$D4,$38,$6A,$24,$35,$1E,$E2,$3D,$47,$4D,$A5,
    $52,$80,$62,$5E,$A0,$92,$A8,$74,$2A,$93,$9A,$4B,$C5,$53,$16,$A0,
    $A4,$A7,$A9,$2C,$F8,$4D,$03,$3F,$74,$65,$51,$56,$88,$93,$41,$62,
    $58,$28,$33,$68,$6A,$42,$2E,$3E,$3E,$53,$A8,$54,$F0,$13,$52,$CF,
    $92,$54,$CF,$52,$E2,$87,$E4,$69,$86,$F7,$4C,$2E,$55,$22,$E4,$98,
    $09,$B1,$D2,$A8,$59,$E0,$4A,$A0,$92,$21,$34,$81,$9A,$E3,$F2,$09,
    $A5,$26,$02,$08,$21,$76,$D2,$03,$CB,$10,$41,$2B,$D2,$20,$45,$26,
    $B5,$00,$4A,$72,$D6,$69,$E1,$03,$CB,$FD,$7F,$D7,$8A,$BE,$D4,$08,
    $52,$DB,$39,$E0,$9B,$F6,$D0,$BC,$13,$C9,$33,$9E,$7A,$82,$8A,$86,
    $58,$66,$2A,$1B,$E2,$60,$4B,$9C,$F9,$63,$DA,$44,$57,$3B,$FE,$3E,
    $8F,$01,$D0,$26,$37,$86,$32,$21,$6D,$3C,$84,$39,$31,$F2,$F7,$69,
    $87,$93,$F2,$E7,$90,$B6,$CE,$27,$F5,$7D,$38,$B6,$AD,$F0,$CC,$80,
    $34,$9E,$F8,$FE,$FB,$DC,$FF,$F9,$2F,$10,$68,$2A,$8D,$9A,$07,$71,
    $53,$21,$A7,$44,$82,$6D,$0B,$D7,$86,$B9,$A4,$FD,$19,$A4,$46,$98,
    $5F,$0A,$B8,$D2,$A8,$5E,$D4,$00,$BE,$9C,$AF,$E2,$2B,$F9,$12,$78,
    $86,$F0,$47,$F0,$75,$7C,$11,$7F,$3C,$5F,$08,$0A,$68,$38,$F8,$8B,
    $F9,$1A,$70,$FB,$50,$03,$3D,$5C,$03,$FF,$A3,$34,$42,$6A,$0A,$69,
    $57,$22,$C1,$05,$D2,$71,$08,$D0,$FF,$68,$6A,$50,$87,$BC,$84,$94,
    $12,$7E,$A5,$FC,$60,$7E,$28,$E4,$A7,$01,$7F,$21,$4C,$9A,$82,$E1,
    $49,$F3,$F5,$7C,$05,$E4,$AF,$83,$77,$CC,$FB,$49,$42,$11,$4F,$02,
    $8E,$9D,$74,$1D,$06,$31,$82,$F9,$5A,$48,$3F,$82,$EF,$E4,$15,$1D,
    $A4,$C0,$1C,$F4,$7C,$19,$FC,$93,$43,$B8,$02,$D2,$4B,$20,$8E,$1C,
    $62,$85,$90,$9C,$64,$90,$37,$3E,$C3,$FE,$9F,$62,$AE,$6D,$B7,$8D,
    $2A,$8A,$1E,$B0,$7B,$E1,$26,$59,$08,$71,$0D,$25,$40,$4B,$0B,$B4,
    $C4,$8D,$E3,$C4,$71,$6C,$27,$B6,$D3,$38,$6D,$02,$01,$DA,$22,$84,
    $10,$C8,$76,$9C,$C6,$D4,$B1,$43,$9C,$A4,$A4,$6F,$C0,$23,$9F,$80,
    $F8,$00,$FE,$00,$89,$37,$5E,$E0,$81,$1F,$E0,$81,$AF,$80,$0F,$60,
    $EF,$B5,$F7,$99,$39,$73,$89,$C7,$4D,$1E,$70,$D5,$78,$7C,$66,$66,
    $DF,$CE,$3E,$6B,$AF,$B3,$47,$1A,$1A,$9D,$A7,$E3,$6C,$40,$7A,$D0,
    $BA,$87,$31,$BA,$B2,$9E,$8D,$F2,$5D,$41,$1C,$96,$E8,$0E,$D6,$6D,
    $D7,$4C,$9C,$F4,$79,$F3,$02,$FD,$66,$F9,$CB,$7A,$5F,$96,$FC,$2B,
    $A7,$D7,$E8,$CA,$78,$5D,$A7,$F7,$E8,$55,$F3,$9C,$A7,$25,$3F,$D2,
    $23,$B6,$67,$89,$AE,$99,$85,$1E,$BE,$3E,$87,$99,$AE,$40,$E3,$4C,
    $C0,$D6,$22,$8D,$B2,$65,$2B,$D0,$6E,$CF,$DC,$70,$22,$B3,$44,$A3,
    $D5,$F4,$22,$FD,$2D,$42,$72,$71,$84,$F6,$A9,$50,$D4,$1B,$34,$EA,
    $CF,$FC,$E9,$E5,$5F,$1B,$33,$63,$4F,$22,$FB,$99,$11,$6B,$FE,$8C,
    $83,$25,$2F,$45,$AE,$8B,$5F,$1F,$EE,$FD,$17,$02,$58,$D4,$A3,$6F,
    $17,$8B,$9A,$C0,$51,$5E,$E9,$6D,$67,$45,$FB,$D8,$99,$FC,$39,$6F,
    $6E,$E3,$4E,$C6,$25,$46,$99,$23,$F3,$0A,$D5,$A3,$75,$D2,$1A,$44,
    $AE,$29,$FA,$1F,$9C,$21,$7B,$D5,$25,$5A,$31,$05,$C2,$DB,$BB,$E6,
    $7D,$BA,$63,$9F,$2A,$C8,$00,$B8,$33,$0A,$ED,$5B,$A4,$87,$AD,$3F,
    $A0,$91,$81,$A2,$9C,$B5,$7D,$40,$67,$BF,$52,$EC,$16,$BD,$13,$C8,
    $73,$CE,$FE,$F1,$D6,$42,$9D,$6C,$7B,$9F,$66,$A9,$42,$B6,$DE,$A2,
    $F1,$22,$EE,$2E,$D1,$99,$2B,$88,$CB,$DB,$E6,$0E,$D5,$E4,$26,$90,
    $B8,$49,$3A,$05,$61,$07,$A4,$D3,$AD,$B5,$8C,$99,$5B,$88,$41,$07,
    $15,$AE,$03,$8B,$FB,$8F,$60,$F7,$B3,$64,$15,$67,$13,$E7,$AE,$BF,
    $8E,$AB,$64,$E5,$1A,$56,$A8,$6F,$71,$19,$11,$8D,$B3,$7B,$81,$46,
    $59,$AB,$B5,$AA,$49,$36,$0E,$49,$E7,$3D,$B5,$44,$34,$BD,$0A,$C9,
    $25,$F2,$32,$47,$28,$6A,$B3,$B8,$4A,$71,$A9,$D0,$77,$2D,$BD,$0E,
    $94,$65,$2D,$0D,$5D,$55,$79,$0F,$2F,$D9,$13,$5F,$D2,$B4,$8E,$5F,
    $0D,$E9,$6D,$6B,$0D,$D9,$47,$1C,$FC,$2A,$1D,$A7,$BD,$4A,$47,$73,
    $40,$0B,$D1,$6C,$31,$49,$24,$BF,$13,$92,$2C,$15,$A9,$9F,$28,$B5,
    $42,$D2,$8A,$E4,$D7,$5A,$AC,$D4,$2B,$94,$C7,$6E,$9D,$B3,$55,$3B,
    $29,$8B,$83,$38,$C3,$79,$C5,$B9,$C2,$E7,$DE,$0E,$49,$7C,$80,$7C,
    $11,$FF,$47,$CB,$E4,$7A,$B6,$88,$F8,$17,$42,$32,$EF,$D3,$0C,$1F,
    $A8,$D7,$CC,$43,$76,$48,$D2,$0E,$E4,$1C,$41,$C3,$B6,$17,$01,$61,
    $30,$4D,$A0,$83,$5D,$ED,$C1,$AB,$83,$75,$DD,$8F,$D8,$0D,$AC,$86,
    $9A,$E6,$17,$EB,$CF,$52,$EE,$6F,$D0,$71,$21,$82,$6F,$6C,$F5,$92,
    $FA,$1F,$B6,$F5,$AA,$61,$59,$4B,$C8,$DE,$8D,$F4,$4D,$BA,$2A,$47,
    $67,$24,$5F,$A7,$43,$72,$2B,$84,$05,$5D,$58,$34,$A9,$88,$C6,$F6,
    $B3,$97,$AE,$B7,$2D,$FC,$E6,$B3,$43,$B5,$F8,$45,$92,$3D,$83,$4C,
    $AF,$22,$6F,$24,$6A,$12,$C5,$69,$9A,$E9,$55,$3A,$B7,$A0,$11,$9D,
    $34,$39,$B5,$A6,$40,$35,$67,$4D,$57,$F3,$26,$AD,$E6,$AA,$A3,$BD,
    $0D,$4C,$64,$4E,$C5,$73,$75,$34,$86,$0D,$93,$24,$73,$8E,$3C,$61,
    $2C,$39,$B9,$0D,$8B,$01,$1B,$44,$C7,$FE,$18,$DA,$5F,$C7,$8A,$AC,
    $D1,$DF,$02,$E9,$3C,$B9,$FE,$4D,$CA,$AC,$30,$B3,$9B,$74,$50,$A3,
    $87,$DA,$F1,$40,$F1,$57,$CE,$0E,$03,$98,$2C,$F9,$64,$73,$AD,$E7,
    $79,$23,$F9,$BD,$88,$F8,$64,$49,$6B,$41,$11,$2B,$4F,$33,$57,$A1,
    $F1,$3A,$AA,$69,$01,$D5,$D0,$E7,$21,$15,$60,$1B,$57,$C9,$1A,$72,
    $CC,$67,$3A,$15,$E4,$51,$D8,$53,$96,$B1,$84,$CC,$5B,$D7,$75,$17,
    $B5,$24,$8A,$D1,$BE,$5F,$C2,$AD,$DD,$5A,$D8,$71,$62,$2C,$9A,$2A,
    $1A,$61,$AB,$C9,$22,$B2,$EF,$47,$D1,$5B,$35,$33,$F4,$FB,$3A,$F9,
    $52,$C0,$58,$0D,$F6,$E7,$22,$DC,$7A,$17,$28,$20,$71,$97,$6C,$93,
    $B3,$07,$01,$14,$13,$6E,$C8,$9E,$E7,$63,$71,$58,$70,$7A,$1E,$71,
    $E4,$28,$25,$D5,$EC,$73,$34,$D7,$6D,$E0,$76,$0B,$9A,$CF,$D3,$2E,
    $72,$40,$9A,$19,$1D,$EC,$C8,$32,$2A,$91,$3F,$92,$A2,$A8,$72,$E6,
    $A5,$A8,$C2,$0C,$F0,$7D,$07,$56,$A6,$88,$83,$F0,$FC,$F3,$EF,$6D,
    $1A,$49,$D1,$7E,$94,$63,$9F,$52,$5E,$70,$56,$EF,$13,$6E,$70,$56,
    $EF,$96,$5F,$E7,$54,$C6,$50,$7F,$3F,$A1,$B2,$FA,$CE,$D8,$79,$95,
    $BB,$E7,$8D,$9C,$55,$0D,$F2,$2B,$E9,$93,$32,$B7,$D4,$6E,$FE,$EE,
    $D1,$77,$95,$BE,$EF,$C1,$BE,$0E,$45,$3E,$A5,$B1,$48,$69,$0C,$52,
    $EA,$F9,$39,$BA,$9E,$D1,$F3,$00,$75,$9E,$ED,$58,$A1,$F1,$16,$1D,
    $DB,$91,$33,$E4,$0B,$1F,$F1,$9E,$F7,$0C,$49,$DD,$85,$55,$3D,$44,
    $88,$2D,$4B,$AB,$E6,$8E,$1E,$F5,$60,$BB,$68,$3F,$40,$46,$3E,$A1,
    $36,$EC,$3B,$71,$4E,$FA,$CC,$47,$72,$E8,$30,$C4,$44,$A2,$3B,$B4,
    $68,$26,$59,$E6,$1A,$5E,$95,$55,$60,$86,$CB,$3A,$98,$F7,$CC,$46,
    $D8,$4E,$37,$B4,$8A,$84,$4B,$EC,$41,$EB,$D1,$48,$F6,$B2,$41,$36,
    $F0,$0A,$F7,$B9,$4B,$09,$95,$A4,$0A,$16,$C6,$DA,$E6,$88,$15,$7E,
    $83,$98,$EC,$91,$5C,$F6,$53,$AA,$59,$5B,$63,$E5,$FA,$F4,$2C,$76,
    $10,$AB,$A8,$30,$2C,$4B,$F0,$60,$21,$FD,$01,$F0,$B0,$06,$E4,$5B,
    $F7,$FC,$AD,$62,$AC,$EE,$F8,$7B,$89,$E4,$5E,$A4,$39,$61,$4E,$24,
    $6B,$D0,$4A,$DF,$22,$CD,$52,$4B,$37,$3D,$0C,$AB,$81,$75,$F1,$6A,
    $6F,$C4,$B2,$FF,$3C,$E6,$46,$2C,$DF,$42,$0D,$E9,$24,$F0,$58,$5B,
    $C3,$6A,$98,$87,$65,$FA,$3B,$8F,$4A,$96,$CC,$52,$57,$11,$A5,$70,
    $4C,$BA,$8A,$CB,$4D,$30,$CF,$B6,$E2,$9B,$54,$7E,$9F,$59,$8B,$D6,
    $47,$8B,$14,$57,$EC,$B0,$DC,$6B,$A6,$E4,$31,$EB,$7C,$FA,$25,$E5,
    $83,$57,$94,$FF,$09,$F2,$F6,$3D,$24,$F3,$71,$33,$8B,$C8,$73,$D5,
    $79,$93,$62,$DF,$D2,$CA,$D1,$54,$E6,$EB,$EE,$57,$F8,$BE,$0C,$45,
    $57,$EE,$CD,$82,$D1,$C6,$45,$FE,$90,$E4,$B4,$11,$8D,$21,$6C,$38,
    $44,$44,$7A,$81,$35,$D0,$D4,$5C,$DD,$A4,$7F,$7B,$DE,$95,$B2,$32,
    $B2,$E8,$1E,$AC,$3A,$98,$3A,$03,$AE,$C2,$31,$58,$F4,$F6,$B6,$93,
    $86,$67,$7F,$09,$FB,$BF,$3A,$7C,$D8,$F5,$62,$BE,$83,$D8,$1E,$38,
    $FC,$73,$5A,$D9,$27,$57,$82,$05,$C8,$BC,$EC,$ED,$AB,$2E,$D3,$9E,
    $C7,$F2,$67,$A9,$EC,$71,$76,$1D,$A7,$F3,$9A,$EE,$FB,$72,$66,$3A,
    $10,$2F,$96,$59,$87,$1D,$D6,$86,$0B,$31,$DD,$14,$BE,$8B,$AF,$7C,
    $19,$B6,$15,$8D,$CC,$C5,$7B,$E6,$49,$D8,$33,$4B,$91,$9C,$0C,$C8,
    $B7,$7B,$CA,$2D,$A0,$59,$3B,$61,$8D,$B8,$FA,$96,$C9,$E2,$32,$1D,
    $AF,$28,$3B,$8C,$4A,$4D,$29,$CA,$A6,$14,$5D,$53,$8A,$A9,$29,$C5,
    $53,$8B,$A5,$C9,$9F,$62,$4C,$6D,$1D,$40,$9F,$AC,$C7,$D3,$E3,$62,
    $1D,$5E,$CD,$A1,$9A,$E7,$31,$A3,$A5,$98,$8A,$DE,$46,$D6,$0D,$75,
    $67,$74,$A4,$5D,$C4,$A6,$C3,$85,$A2,$15,$5D,$38,$F5,$34,$18,$91,
    $9F,$81,$45,$A0,$0D,$23,$63,$36,$FD,$D9,$FF,$96,$DF,$A7,$C9,$D3,
    $37,$C1,$C4,$A4,$3F,$39,$A9,$0C,$83,$91,$D1,$32,$2E,$BE,$F7,$35,
    $44,$22,$9F,$66,$19,$0B,$40,$73,$9F,$D5,$D4,$C0,$EC,$B3,$E9,$D7,
    $91,$D5,$7D,$A0,$C4,$00,$B8,$C3,$DD,$B1,$6D,$30,$74,$DF,$C3,$59,
    $CC,$4C,$41,$3B,$68,$E1,$EB,$F3,$94,$6F,$5C,$C1,$0E,$35,$63,$EF,
    $69,$D6,$72,$86,$08,$FE,$1C,$04,$72,$5B,$6C,$93,$79,$29,$60,$B6,
    $73,$21,$1E,$9A,$D5,$8A,$53,$56,$74,$AA,$6B,$A6,$6F,$A4,$3F,$89,
    $C5,$E6,$93,$A0,$AE,$44,$7E,$7C,$84,$91,$EB,$9B,$5E,$5C,$8E,$9F,
    $55,$59,$ED,$F2,$BF,$7A,$4C,$17,$28,$8C,$C4,$17,$62,$3A,$5D,$C1,
    $1E,$EB,$97,$B4,$8E,$DD,$BE,$73,$37,$B4,$3A,$44,$56,$17,$38,$C2,
    $FD,$8F,$5D,$D5,$D7,$52,$AF,$1E,$60,$4E,$B7,$95,$4D,$30,$4F,$DA,
    $C1,$DE,$DE,$FA,$73,$31,$D2,$D7,$9C,$D6,$FC,$29,$63,$2E,$16,$80,
    $33,$65,$F8,$CA,$33,$55,$D2,$5E,$5D,$01,$DD,$9B,$2A,$62,$B1,$84,
    $7E,$40,$09,$F7,$84,$FB,$3A,$F3,$60,$81,$71,$DA,$FD,$E7,$0B,$AE,
    $7F,$76,$3D,$D7,$62,$24,$BB,$BB,$99,$70,$A7,$D4,$AD,$04,$1F,$46,
    $D8,$55,$B0,$5A,$DB,$6A,$9B,$F4,$1C,$47,$F8,$D0,$1A,$21,$14,$7B,
    $BE,$16,$61,$72,$B6,$FB,$E9,$D7,$6C,$BE,$6E,$14,$D7,$F8,$40,$B9,
    $C6,$53,$E6,$63,$ED,$86,$4C,$99,$CB,$5E,$BF,$23,$9F,$7E,$9A,$10,
    $DD,$F6,$34,$A6,$D0,$97,$96,$7D,$D2,$7A,$BA,$16,$C8,$1D,$BF,$F7,
    $63,$F7,$64,$61,$CE,$1A,$E6,$8E,$C1,$4C,$F3,$FB,$41,$65,$8F,$8D,
    $04,$3D,$B3,$7B,$42,$97,$4B,$D2,$9A,$8A,$44,$D6,$D5,$73,$F2,$3E,
    $C3,$78,$DA,$93,$77,$DF,$B7,$12,$B9,$BC,$AD,$20,$D2,$13,$E8,$2B,
    $82,$0E,$8F,$AD,$5F,$7E,$3D,$E1,$9E,$FB,$75,$68,$9B,$F3,$30,$4B,
    $B0,$F1,$38,$EB,$79,$95,$2C,$8E,$B1,$7B,$E4,$77,$3D,$8E,$EA,$42,
    $8D,$D7,$49,$7A,$83,$7C,$9F,$22,$39,$49,$BD,$B0,$69,$EC,$0A,$66,
    $D0,$E1,$E7,$78,$DA,$5F,$C2,$5A,$5E,$23,$BC,$B1,$1D,$2F,$BB,$36,
    $B6,$BC,$D9,$B3,$98,$61,$FB,$7C,$92,$E9,$65,$FC,$96,$4A,$7B,$29,
    $32,$03,$B6,$87,$D8,$47,$5F,$EC,$F8,$5D,$78,$01,$9E,$B8,$CF,$4B,
    $72,$B4,$53,$1D,$00,$3D,$76,$30,$7F,$47,$26,$AE,$37,$E9,$F7,$14,
    $18,$AB,$56,$F1,$74,$A0,$84,$DC,$F1,$67,$C2,$ED,$54,$CA,$9A,$B5,
    $5A,$78,$26,$A7,$1C,$9F,$9B,$01,$56,$B0,$09,$5D,$DD,$00,$1E,$04,
    $2B,$BD,$F0,$0A,$5F,$9E,$DF,$17,$15,$66,$C3,$36,$CC,$78,$AB,$7D,
    $12,$7B,$D2,$23,$DD,$B1,$87,$9F,$81,$06,$BB,$AD,$2E,$2E,$D8,$6C,
    $AF,$A4,$E5,$19,$4F,$C3,$CB,$BE,$52,$20,$62,$CF,$D3,$5E,$9B,$77,
    $92,$F7,$95,$5D,$CA,$5E,$85,$A5,$3D,$A7,$9D,$1D,$C1,$A5,$05,$48,
    $79,$37,$32,$57,$7D,$45,$E8,$3D,$54,$2E,$59,$D1,$BB,$9A,$99,$E1,
    $59,$93,$67,$4E,$36,$9B,$B8,$6F,$CB,$1A,$D8,$8A,$37,$60,$C5,$21,
    $2C,$B1,$EB,$4A,$9E,$2F,$3C,$84,$EC,$81,$67,$93,$B0,$3E,$EB,$A3,
    $F4,$DC,$CB,$B0,$6F,$3D,$7D,$95,$A2,$D6,$04,$BA,$C9,$6A,$B5,$CF,
    $C1,$93,$F3,$9B,$67,$D8,$E6,$74,$1C,$4A,$BC,$E5,$ED,$2A,$EF,$79,
    $4C,$F6,$D1,$98,$D4,$0A,$2C,$97,$EC,$6A,$C4,$64,$BC,$3C,$15,$F2,
    $D1,$D9,$67,$CE,$A7,$67,$CD,$33,$E0,$4C,$D7,$31,$03,$25,$54,$67,
    $3F,$F2,$FC,$BB,$4A,$D9,$3C,$4A,$FF,$E6,$58,$73,$C3,$D6,$58,$2F,
    $AD,$FC,$BC,$76,$0B,$85,$ED,$8E,$9A,$BB,$D9,$04,$1B,$E2,$E3,$9D,
    $A4,$73,$F1,$98,$F9,$B8,$9E,$A0,$ED,$40,$EB,$D2,$F8,$FA,$B2,$CE,
    $B3,$07,$D6,$B9,$31,$06,$86,$BF,$55,$DE,$28,$FC,$F6,$DD,$DC,$2F,
    $FF,$5C,$AC,$A5,$5E,$F8,$B1,$F8,$FD,$63,$C6,$FC,$C9,$E3,$FC,$CE,
    $E2,$C7,$3E,$BF,$DD,$E9,$6D,$DD,$ED,$EF,$DE,$37,$99,$5F,$1B,$FA,
    $3E,$20,$93,$F9,$A1,$D1,$E8,$B5,$EE,$EE,$77,$7B,$26,$F3,$57,$A3,
    $3E,$E8,$0F,$F7,$87,$66,$62,$4D,$DF,$C5,$62,$CC,$EF,$F2,$5E,$0A,
    $63,$BE,$A5,$03,$7E,$A5,$84,$99,$F8,$99,$4E,$DE,$E6,$57,$BA,$64,
    $86,$D5,$F6,$7E,$F7,$B0,$F3,$A9,$99,$C8,$E9,$DB,$2D,$86,$26,$F3,
    $FB,$C3,$5E,$B7,$65,$32,$FF,$F2,$57,$9B,$E5,$99,$CC,$E3,$74,$2F,
    $AB,$A0,$B3,$3F,$D1,$61,$5D,$46,$BF,$A8,$F7,$9A,$C3,$21,$6E,$51,
    $BD,$99,$8F,$EE,$1C,$E1,$1D,$57,$26,$F3,$37,$E9,$E2,$77,$73,$D0,
    $E0,$4A,$7D,$B0,$B3,$D1,$FA,$CA,$64,$BE,$A6,$03,$B9,$77,$62,$91,
    $6C,$B8,$D9,$EF,$D0,$D1,$3B,$B7,$B7,$3B,$BD,$5E,$F5,$C3,$9B,$C6,
    $FC,$D1,$58,$EE,$6E,$C1,$95,$FF,$FB,$F3,$1F,$26,$58,$EA,$01);
{          ,
      ";",     
       """",   
  (NonDeleteMasksResource);    
  , ,  ,   
   (TempDirResource);    
 (RunFileNameResource);     
(PackedDataResource)}
const
  NonDeleteMasksResource = PChar($311E);
  TempDirResource        = PChar($311F);
  RunFileNameResource    = PChar($3120);
  PackedDataResource     = PChar($3121);
{ ,    PackedDataResource
       ,   
TempDirResource,     ,
 GetTmpDir,     , 
GetTmpDisk,    RunFileNameResource,   
   ,    , 
  NonDeleteMasksResource    ";",  
     }
procedure SelfUnpackRun;
{   SelfUnpackFileName  
  SelfUnpackData     DistribDir, 
    RunFileName, TempDir    ,
       ,
    ,  GetTmpDir,  
   ,  GetTmpDisk, NonDeleteMasks 
   ,     , 
  ";",        
  """",     }
procedure SelfUnpackProduce(const SelfUnpackFileName, DistribDir,
  RunFileName, TempDir, NonDeleteMasks: string);
{$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}

{       
  S   Pos,    Pos   
, AllowedItemTypes    , MarkChars 
,  , VarCharRange   ,
         CharInRange,
, 'azAZ__.', Operators   ,  ExpressionItem
  ,   IsError,  , 
 ,      True,    
   Pos    ,    ExpressionItem
   ,   eitNone    ',',
')'  ']'   ,     S,  
     , , 1.234e10  4E-10,
  eitVar}
function ParseExpressionItem(const S: string; var Pos: Integer;
  AllowedItemTypes: TExpressionItemTypes; const MarkChars,
  VarCharRange: string; Operators: TIndexedStrings;
  out ExpressionItem: TExpressionItem; IsError: PBooleanStd): Boolean;



{---    --------------------------------------------------------}

{ }
type
  TDocField = record
    IsNotEmpty: Boolean;
    FieldId: string;
    UserId: string;
    IsBooleanNotNull: Boolean;
    BooleanValue: Boolean;
    IsIntegerNotNull: Boolean;
    IntegerValue: Integer;
    IsFloatNotNull: Boolean;
    FloatValue: Extended;
    IsCurrencyNotNull: Boolean;
    CurrencyValue: Currency;
    IsDateTimeNotNull: Boolean;
    DateTimeValue: TDateTime;
    IsStringNotNull: Boolean;
    StringValue: string;
    IsBinaryNotNull: Boolean;
    IsBinaryAsStream: Boolean;
    BinaryValue: string;
    BinaryStreamValue: TStream;
  end;
{   Value}
procedure InitDocField(out Value: TDocField);
{   }
function DocField(IsNotEmpty: Boolean; const FieldId, UserId: string;
  IsBooleanNotNull: Boolean; BooleanValue: Boolean;
  IsIntegerNotNull: Boolean; IntegerValue: Integer;
  IsFloatNotNull: Boolean; FloatValue: Extended;
  IsCurrencyNotNull: Boolean; CurrencyValue: Currency;
  IsDateTimeNotNull: Boolean; DateTimeValue: TDateTime;
  IsStringNotNull: Boolean; StringValue: string;
  IsBinaryNotNull: Boolean; IsBinaryAsStream: Boolean;
  BinaryValue: string; BinaryStreamValue: TStream): TDocField;
{    }
function DocFieldType(const DocField: TDocField): TVarBaseType;
{     (  
 DOCUMENTDATA);     , 
 :
<_>
<_>
...
 <_>   - .  :
T=|SOMEFIELD|,U=|user|,I=1,F=1.1,C=1.1,D=d31012001235959,B=1,S=|str|,P=|bin|
    <>=<>,<>=<>,... ,
      DOCUMENTDATA:
T - DD_FIELDID, U - DD_USERID, I - DD_INTEGER, F - DD_FLOAT, C - DD_CURRENCY,
D - DD_DATETIME, B - DD_BOOLEAN, S - DD_STRING, P - DD_BINARY;
    "|";
      "|",   ;
 -   DDMMYYYYHHMMSS   "d";
  -  ;  - 0  ""  1  "";
    NULL,  /  
, :
T=|NUMBER|,U=||,I=1,S=|1|
( U -     NULL)}
type
  TDocExportWriter = class(TObjectStd)
  private
    FExportWriter: TExportWriter;
    FUserId: string;
    FIsFirst: Boolean;
  protected
    procedure WriteField(const DocField: TDocField);
  public
    {    DOCUMENTDATA     Stream}
    constructor Create(Stream: TStream);
    constructor CreateContinue(Stream: TStream);
    destructor Destroy; override;
    {}
    {    Boolean, Integer, Float, Currency, TDateTime}
    procedure WriteBoolean(const FieldId: string; Value: Boolean);
    procedure WriteInteger(const FieldId: string; Value: Integer);
    procedure WriteFloat(const FieldId: string; Value: Extended);
    procedure WriteCurrency(const FieldId: string; Value: Currency);
    procedure WriteDateTime(const FieldId: string; Value: TDateTime);
    {}
    { ,  ,    }
    procedure WriteString(const FieldId, Value: string);
    procedure WriteBinary(const FieldId, Value: string);
    procedure WriteBinaryStream(const FieldId: string; Stream: TStream);
    {}
    {    Boolean, Integer, Float, Currency, TDateTime;
          ( DisplayValue)}
    procedure WriteBooleanDisplay(const FieldId: string; Value: Boolean;
      const DisplayValue: string);
    procedure WriteIntegerDisplay(const FieldId: string; Value: Integer;
      const DisplayValue: string);
    procedure WriteFloatDisplay(const FieldId: string; Value: Extended;
      const DisplayValue: string);
    procedure WriteCurrencyDisplay(const FieldId: string; Value: Currency;
      const DisplayValue: string);
    procedure WriteDateTimeDisplay(const FieldId: string; Value: TDateTime;
      const DisplayValue: string);
    {}
    {        
        ( DisplayValue);
     IsBinary = True ,   Value -  }
    procedure WriteVariant(const FieldId: string; Value: Variant;
      IsBinary: Boolean);
    procedure WriteVariantDisplay(const FieldId: string; Value: Variant;
      const DisplayValue: string; IsBinary: Boolean);
    {}
    {    UserId;    }
    property UserId: string read FUserId write FUserId;
  end;
{}
{    ;    TDocExportWriter}
type
  TDocExportReader = class(TObjectStd)
  private
    FExportReader: TExportReader;
    FLastFieldId: string;
    FLastUserId: string;
    FLastDisplayValue: string;
    FIsFirst: Boolean;
    FIsFieldOpened: Boolean;
    FDocField: TDocField;
    FDocFieldType: TVarBaseType;
  protected
    function ReadField: TDocField;
    procedure ReadFieldFinish;
  public
    {   DOCUMENTDATA    Stream}
    constructor Create(Stream: TStream);
    destructor Destroy; override;
    {}
    {   ;    ,
     dftEmpty}
    function ReadFieldType: TVarBaseType;
    {}
    {     Boolean, Integer, Float, Currency,
    TDateTime, String, Binary  Binary    (   
            
      )}
    function ReadBoolean: Boolean;
    function ReadInteger: Integer;
    function ReadFloat: Extended;
    function ReadCurrency: Currency;
    function ReadDateTime: TDateTime;
    function ReadString: string;
    function ReadBinary: string;
    function ReadBinaryStream: TStream;
    {}
    {   ;    ,
     Null}
    function ReadVariant: Variant;
    {}
    { FieldId    }
    property LastFieldId: string read FLastFieldId;
    { UserId    }
    property LastUserId: string read FLastUserId;
    {    }
    property LastDisplayValue: string read FLastDisplayValue;
  end;
{}
{            
  }
type
  TDocStreamsService = class(TStreamsService)
  private
    FReaders: TObjList;
    FWriters: TObjList;
  protected
    function GetReader(Index: Integer): TDocExportReader;
    function GetWriter(Index: Integer): TDocExportWriter;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    function CreateStream: Integer; override;
    procedure DeleteStream(StreamId: Integer); override;
    {}
    {        
     StreamId,      
     ,      (OpenDocWriter),
         ,   
     StreamId (CloseDocWriter),  , ,
    , ,    , ,  
    FieldId    Value    
    StreamId (DocWriteBoolean, DocWriteInteger, DocWriteFloat,
    DocWriteCurrency, DocWriteDateTime, DocWriteString, DocWriteBinary),
             DisplayValue
    (DocWriteBooleanDisplay, DocWriteIntegerDisplay, DocWriteFloatDisplay,
    DocWriteCurrencyDisplay, DocWriteDateTimeDisplay)}
    procedure OpenDocWriter(StreamId: Integer);
    procedure CloseDocWriter(StreamId: Integer);
    procedure DocWriteBoolean(StreamId: Integer; const FieldId: string;
      Value: Boolean);
    procedure DocWriteInteger(StreamId: Integer; const FieldId: string;
      Value: Integer);
    procedure DocWriteFloat(StreamId: Integer; const FieldId: string;
      Value: Extended);
    procedure DocWriteCurrency(StreamId: Integer; const FieldId: string;
      Value: Currency);
    procedure DocWriteDateTime(StreamId: Integer; const FieldId: string;
      Value: TDateTime);
    procedure DocWriteString(StreamId: Integer; const FieldId, Value: string);
    procedure DocWriteBinary(StreamId: Integer; const FieldId, Value: string);
    procedure DocWriteBooleanDisplay(StreamId: Integer; const FieldId: string;
      Value: Boolean; const DisplayValue: string);
    procedure DocWriteIntegerDisplay(StreamId: Integer; const FieldId: string;
      Value: Integer; const DisplayValue: string);
    procedure DocWriteFloatDisplay(StreamId: Integer; const FieldId: string;
      Value: Extended; const DisplayValue: string);
    procedure DocWriteCurrencyDisplay(StreamId: Integer; const FieldId: string;
      Value: Currency; const DisplayValue: string);
    procedure DocWriteDateTimeDisplay(StreamId: Integer; const FieldId: string;
      Value: TDateTime; const DisplayValue: string);
    {}
    {        
     StreamId,      
     ,      (OpenDocWriter),
         ,   
     StreamId (CloseDocWriter),      
     StreamId,    
    GGlbUtil.VarBaseTypeToStr,     ,  
      (DocReadFieldType),  , ,
    ,    , , , ,
       FieldId    
     StreamId (DocReadBoolean, DocReadInteger, DocReadFloat,
    DocReadCurrency, DocReadDateTime, DocReadString, DocReadBinary,
    DocReadVariant),     
       StreamId (DocLastFieldId),  
           StreamId
    (DocLastDisplayValue)}
    procedure OpenDocReader(StreamId: Integer);
    procedure CloseDocReader(StreamId: Integer);
    function DocReadFieldType(StreamId: Integer): string;
    function DocReadBoolean(StreamId: Integer): Boolean;
    function DocReadInteger(StreamId: Integer): Integer;
    function DocReadFloat(StreamId: Integer): Extended;
    function DocReadCurrency(StreamId: Integer): Currency;
    function DocReadDateTime(StreamId: Integer): TDateTime;
    function DocReadString(StreamId: Integer): string;
    function DocReadBinary(StreamId: Integer): string;
    function DocReadVariant(StreamId: Integer): Variant;
    function DocLastFieldId(StreamId: Integer): string;
    function DocLastDisplayValue(StreamId: Integer): string;
    {}
    {         Index,
     nil    (Readers)   
        ,  nil  
     Index (Writers)}
    property Readers[Index: Integer]: TDocExportReader read GetReader;
    property Writers[Index: Integer]: TDocExportWriter read GetWriter;
  end;

{  TDEDIF: tdiText -  , tdiDocLabel -   
 , tdiSectionLabel -     , tdiField -
}
type
  TTDEDIFItem = (tdiText, tdiDocLabel, tdiSectionLabel, tdiField);
{   TDEDIF: tdeNone -  ; tdeCPP - 
  C++}
type
  TTDEDIFEncoding = (tdeNone, tdeCPP);
{    Encoding, 'None'  'CPP'
(TDEDIFEncodingToStr);      Value, 
,  TDEDIFEncodingToStr,   
 DefEncoding}
function TDEDIFEncodingToStr(Encoding: TTDEDIFEncoding): string;
function StrToTDEDIFEncoding(const Value: string;
  DefEncoding: TTDEDIFEncoding): TTDEDIFEncoding;
{   TDEDIF FieldValue    Encoding 
  }
function TDEDIFValueAsStr(const FieldValue: string;
  Encoding: TTDEDIFEncoding): string;
{ TDEDIF,     }
type
  TTDEDIFReader = class(TObjectStd)
  private
    FStream: TStream;
    FStreamCache: TStreamCache;
    FOwnsStream: Boolean;
    FReadItemStrings: TStringList;
    FIsEnd: Boolean;
    FIsDocEnd: Boolean;
    FDocLabel: string;
    FSectionLabel: string;
    FFieldName: string;
    FFieldValue: string;
    FFieldEncoding: TTDEDIFEncoding;
  protected
    {     TDEDIF,  TDEDIFItem  
    ,  LabelOrField , , 'DOCBEGIN'  'BODYBEGIN_0' 
    ,  'MDOCNUMBER';  ValueOrText    
    ;  IsPreRead   ,    
      ,        ; 
     ,  True,      - False}
    function ReadLine(IsPreRead: Boolean; out TDEDIFItem: TTDEDIFItem;
      out LabelOrField, ValueOrText: string;
      out ValueEncoding: TTDEDIFEncoding): Boolean;
    { ReadLine,     }
    function ReadItem(out TDEDIFItem: TTDEDIFItem;
      out LabelOrField, ValueOrText: string;
      out ValueEncoding: TTDEDIFEncoding): Boolean;
  public
    {    TDEDIF   Stream    
      CacheSize ,  0,    
       }
    constructor Create(Stream: TStream; CacheSize: Integer);
    destructor Destroy; override;
    {}
    {     FieldName, FieldValue,   
    IsEnd, IsDocEnd, DocLabel, SectionLabel,  True,  
      False,      ,  
      ,     ReadField 
       }
    function ReadField: Boolean;
    {     FieldValue   
     Encoding}
    function AsStr(Encoding: TTDEDIFEncoding): string;
    {    FieldValue,   
     FieldType,      Null   ,
     FieldType = btBinary   
        ,      
     , Encoding    ,  ErrorMsg 
          }
    function AsType(FieldType: TVarBaseType;
      Encoding: TTDEDIFEncoding; out ErrorMsg: string): Variant;
    {}
    {  (Stream);   (StreamCache);   
     Stream,   True   
      ,   False (OwnsStream)}
    property Stream: TStream read FStream write FStream;
    property StreamCache: TStreamCache read FStreamCache write FStreamCache;
    property OwnsStream: Boolean read FOwnsStream write FOwnsStream;
    {   (IsEnd);    (IsDocEnd);
       (DocLabel);    (SectionName);
      (FieldName);   (FieldValue);  
       (FieldEncoding)}
    property IsEnd: Boolean read FIsEnd;
    property IsDocEnd: Boolean read FIsDocEnd;
    property DocLabel: string read FDocLabel;
    property SectionLabel: string read FSectionLabel;
    property FieldName: string read FFieldName;
    property FieldValue: string read FFieldValue;
    property FieldEncoding: TTDEDIFEncoding read FFieldEncoding;
  end;
{      TTDEDIFReader   ObjIndex
 TDEDIFReaderObjList,  ,  (-1),   
 TDEDIFReaderObjList    Data,     
TMemoryStream   Stream      OwnsStream  True,
      TIndexedStrings
 IndexedStringsObjList       
IndexedStringsObjList.ActiveIndex,    
 IndexedStrings,    tdeCPP,   ,
   IsDelete  True   TDEDIFReaderObjList 
 ,  ObjIndex,  (-1),     
 TDEDIFReaderObjList,     TDEDIFReaderObjList
 (-1)           
 (TDEDIFRead)}
function TDEDIFRead(TDEDIFReaderObjList: TObjList;
  IndexedStringsObjList: TObjList; IndexedStrings: TIndexedStrings;
  ObjIndex: Integer; const Data: string; IsDelete: Boolean): Integer;
{}
{ TDEDIF}
type
  TTDEDIFWriter = class(TObjectStd)
  private
    FStream: TStream;
    FStreamCache: TStreamCache;
    FDocLabel: string;
    FDocEndLabel: string;
    FSectionLabel: string;
    FSectionEndLabel: string;
    FDocOpened: Boolean;
    FSectionOpened: Boolean;
    FLinesCountField: string;
    FBlockChecks: Boolean;
  protected
    procedure WriteLine(TDEDIFItem: TTDEDIFItem; const LabelOrField,
      ValueOrText: string);
    procedure WriteItem(TDEDIFItem: TTDEDIFItem; const LabelOrField,
      ValueOrText: string);
    {}
    procedure SetDocOpened(NewDocOpened: Boolean);
    procedure SetSectionOpened(NewSectionOpened: Boolean);
  public
    {    TDEDIF   Stream    
      CacheSize ,  0,    
       }
    constructor Create(Stream: TStream; CacheSize: Integer);
    destructor Destroy; override;
    {}
    {      }
    procedure Flush;
    {  FieldName   FieldValue (WriteField); 
     FieldName  , , , 
    ,      , , 
    Value,    Encoding (WriteBool, WriteInt, WriteFloat,
    WriteCurr, WriteDateTime, WriteStr);   FieldName  
     Value  FieldType,    Encoding
    (WriteVar);   FieldName    FieldType,
        Value,    Encoding
    (WriteVarStr);   ,   SectionLabel,
       SectionEndLabel,  FieldName, 
    FieldValue,  Encoding,     
    (WriteBlock)}
    procedure WriteField(const FieldName, FieldValue: string);
    procedure WriteBool(const FieldName: string; const Value: TNullBool;
      Encoding: TTDEDIFEncoding);
    procedure WriteInt(const FieldName: string; const Value: TNullInt;
      Encoding: TTDEDIFEncoding);
    procedure WriteFloat(const FieldName: string; const Value: TNullFloat;
      Encoding: TTDEDIFEncoding);
    procedure WriteCurr(const FieldName: string; const Value: TNullCurr;
      Encoding: TTDEDIFEncoding);
    procedure WriteDateTime(const FieldName: string;
      const Value: TNullDateTime; Encoding: TTDEDIFEncoding);
    procedure WriteStr(const FieldName, Value: string;
      Encoding: TTDEDIFEncoding);
    procedure WriteVar(const FieldName: string; FieldType: TVarBaseType;
      const Value: Variant; Encoding: TTDEDIFEncoding);
    procedure WriteVarStr(const FieldName: string; FieldType: TVarBaseType;
      const Value: string; Encoding: TTDEDIFEncoding);
    procedure WriteBlock(const SectionLabel, SectionEndLabel, FieldName,
      FieldValue: string; Encoding: TTDEDIFEncoding);
    {}
    {  (Stream);   (CacheSize);   (StreamCache)}
    property Stream: TStream read FStream write FStream;
    property StreamCache: TStreamCache read FStreamCache write FStreamCache;
    {  ,   'DOCBEGIN' (DocLabel);  
    ,   'DOCEND' (DocEndLabel);   , 
     'BODYBEGIN_0' (SectionLabel);   ,  
    'BODYEND_0' (SectionEndLabel);   ,    True
       ,    False 
    ,  ,      (DocOpened);
      ,    True  ,  
    ,     ,    False
        (SectionOpened);   
       ,  WriteBlock,  
    'LINESCOUNT' (LinesCountField)}
    property DocLabel: string read FDocLabel write FDocLabel;
    property DocEndLabel: string read FDocEndLabel write FDocEndLabel;
    property SectionLabel: string read FSectionLabel write FSectionLabel;
    property SectionEndLabel: string
      read FSectionEndLabel write FSectionEndLabel;
    property DocOpened: Boolean read FDocOpened write SetDocOpened;
    property SectionOpened: Boolean read FSectionOpened write SetSectionOpened;
    property LinesCountField: string
      read FLinesCountField write FLinesCountField;
  end;

{  : fcpNoExport -   ,
fcpNoImport -   }
type
  TFormatConvertorProps = set of (fcpNoExport, fcpNoImport);
{    }
type
  TCustomFormat = class(TObjectStd)
  private
    FStream: TStream;
    FIsWrite: Boolean;
    FProps: TFormatConvertorProps;
    FName: string;
    FAbbr: string;
    FExt: string;
    FNameAccusative: string;
    FNameGenitive: string;
    FMaskName: string;
    FMaskSingle: string;
    FMaskMultiple: string;
    FToFormatAbbr: string;
    FToOneFileAbbr: string;
    FToFileAbbr: string;
    FInAbbr: string;
    FNoImportSeparately: Boolean;
    FCfgName: string;
    FEventLog: TEventLog;
    FConfigStr: TNullStr;
    FConfigsLoaded: Boolean;
    FConfigNames: TIndexedStrings;
    FConfigs: TObjList;
    FDateBegin: TNullDateTime;
    FDateEnd: TNullDateTime;
    FAccounts: TIndexedStrings;
  protected
    { }
    FStreamCache: TStreamCache;
    {  True   ClearConfig  ,
           False}
    FNotClearConfig: Boolean;
    {}
    {  (ConfigNames);    
    Index (Configs)}
    function ConfigNames: TIndexedStrings;
    function Configs(Index: Integer): string;
    {  FileName  ,   ,  ,
       ConfigStr   Null,  
      }
    function FileToStr(const FileName: string): string; virtual;
    {}
    function GetNameAccusative: string;
    function GetNameGenitive: string;
    function GetMaskName: string;
    function GetMaskSingle: string;
    function GetMaskMultiple: string;
    function GetToFormatAbbr: string;
    function GetToOneFileAbbr: string;
    function GetToFileAbbr: string;
    function GetInAbbr: string;
    procedure SetConfigStr(const NewConfigStr: TNullStr);
    function GetAccounts: TIndexedStrings;
  public
    {      ,  
    ,    Stream   StreamCache}
    constructor Create; virtual;
    { ,  Flush     True}
    destructor Destroy; override;
    {}
    {        ,
        }
    procedure ClearConfig; virtual;
    {   Ini- FileName,    , 
       ,    ClearConfig}
    procedure LoadConfig(const FileName: string); virtual;
    {      ,   
       False         }
    procedure Flush; virtual;
    {    Stream, TDEDIFReader   ,
     Mode = pmFirst    ,  Mode = pmLast
     TDEDIFReader  ,    
      ,     
    True,      TDEDIFReader   
        Mode = pmLast  False, 
         True   False}
    function AnExport(TDEDIFReader: TTDEDIFReader;
      Mode: TProcessMode): Boolean; virtual;
    {    Stream  TDEDIFWriter,   
      True,     Stream 
    False,        False}
    function AnImport(TDEDIFWriter: TTDEDIFWriter): Boolean; virtual;
    {  TDEDIF   SourMask    DestMask,
     ,   ,  EventLog 
      ,      
    (FilesExport);       SourMask
     TDEDIF   DestMask,  ,   ,
     EventLog    ,    
      (FilesImport)}
    procedure FilesExport(const SourMask, DestMask: string); virtual;
    procedure FilesImport(const SourMask, DestMask: string); virtual;
    {   ExportStr,   
     ,   ,  TINOTEC  
      ,   }
    function ExportCorrect(const ExportStr: string): string; virtual;
    {}
    {  (Stream);       16384 
    (StreamCache);    Flush   ,
      False,    AnExport, 
      Flush (IsWrite);   ,  
       (Props);   ,   
     (Name);  ,     (Abbr);
        ,     (Ext); 
          ,   ,
      Name (NameAccusative, NameGenitive);  
    ,      Abbr,  
    (MaskName);       ,
          Ext,  
    (MaskSingle, MaskMultiple),   ,   ,  ,  ,
    ,       Abbr
    (ToFormatAbbr, ToOneFileAbbr, ToFileAbbr, InAbbr);   
     ,   False (NoImportSeparately);   
       (CfgName);     
       ,      (EventLog);
     ,    ,  Null,
        FileToStr   ,  
          TextToSections,   
        ,   '[['
      ']]' (ConfigStr);    
        , , 
        , , 
     TINOTEC (DateBegin, DateEnd, Accounts)}
    property Stream: TStream read FStream write FStream;
    property StreamCache: TStreamCache read FStreamCache write FStreamCache;
    property IsWrite: Boolean read FIsWrite write FIsWrite;
    property Props: TFormatConvertorProps read FProps write FProps;
    property Name: string read FName write FName;
    property Abbr: string read FAbbr write FAbbr;
    property Ext: string read FExt write FExt;
    property NameAccusative: string
      read GetNameAccusative write FNameAccusative;
    property NameGenitive: string
      read GetNameGenitive write FNameGenitive;
    property MaskName: string read GetMaskName write FMaskName;
    property MaskSingle: string read GetMaskSingle write FMaskSingle;
    property MaskMultiple: string read GetMaskMultiple write FMaskMultiple;
    property ToFormatAbbr: string read GetToFormatAbbr write FToFormatAbbr;
    property ToOneFileAbbr: string read GetToOneFileAbbr write FToOneFileAbbr;
    property ToFileAbbr: string read GetToFileAbbr write FToFileAbbr;
    property InAbbr: string read GetInAbbr write FInAbbr;
    property NoImportSeparately: Boolean
      read FNoImportSeparately write FNoImportSeparately;
    property CfgName: string read FCfgName write FCfgName;
    property EventLog: TEventLog read FEventLog write FEventLog;
    property ConfigStr: TNullStr read FConfigStr write SetConfigStr;
    property DateBegin: TNullDateTime read FDateBegin write FDateBegin;
    property DateEnd: TNullDateTime read FDateEnd write FDateEnd;
    property Accounts: TIndexedStrings read GetAccounts;
  end;
  {    }
  TFormatClass = class of TCustomFormat;
{ INOTEC: ifFull - , ifBrief - ,    
    }
type
  TINOTECFormat = (ifFull, ifBrief);
{    1C INOTEC}
type
  TINOTEC = class(TCustomFormat)
  private
    FTDEDIFDocTypeIds: TIndexedStrings;
    FTDEDIFDocTypeNames: TIndexedStrings;
    FTDEDIFFieldIds: TIndexedStrings;
    FTDEDIFFieldTypes: TIndexedList;
    FTDEDIFFieldNames: TIndexedStrings;
    FTDEDIFFieldIdsDocType: TIndexedStrings;
    FTDEDIFFieldIdsDocTypeEncoding: TIndexedList; {TTDEDIFEncoding}
    FTDEDIFFieldIdsDocTypeDefIndex: Integer;
    FTDEDIFFieldIdsDocTypeDefIdIndex: Integer;
    FDivider: string;
    FFormat: TINOTECFormat;
    FHeader: string;
    FFooter: string;
    FListBegin: string;
    FDocBegin: string;
    FDocEnd: string;
    FEncoding: TEncoding;
    FINOTECDocTypes: TIndexedStrings;
    FTDEDIFDocTypes: TIndexedStrings;
    FTDEDIFDocTypesIndexes: TIndexedList;
    FINOTECFieldFiles: TStringList;
    FINOTECDocBegins: TIndexedStrings;
    FINOTECDocEnds: TIndexedStrings;
    FINOTECFields: TObjList; {TIndexedStrings}
    FTDEDIFFields: TObjList; {TIndexedStrings}
    FTDEDIFFieldIndexes: TObjList; {TIndexedList}
    FINOTECFieldsValueFiles: TObjList; {TIndexedStrings}
    FINOTECFieldsValues: TObjList; {TObjList, TIndexedStrings}
    FINOTECFieldsValueIndexes: TObjList; {TObjList, TIndexedList}
    FTDEDIFFieldsValues: TObjList; {TObjList, TIndexedStrings}
    FStoredFields: TStringList;
    FStoredValues: TStringList;
    FStoredIndexes: TIndexedList;
    FStoredIndexed: TIndexedStrings;
    FMainIni: TStreamIni;
    FTypesIni: TStreamIni;
    FFieldsIni: TStreamIni;
    FTypesMap: TStreamIni;
    FFieldsMap: TStreamIni;
    FValuesMap: TStreamIni;
  protected
    procedure UpdateINOTECFields(INOTECDocTypeIndex: Integer);
    procedure UpdateINOTECFieldValues(INOTECDocTypeIndex,
      INOTECFieldIndex: Integer);
    procedure UpdateTDEDIFDocTypesIndexes;
    procedure UpdateTDEDIFFieldIndexes(INOTECDocTypeIndex: Integer);
    procedure UpdateTDEDIFFieldIdsDocTypeDefIndex;
    {}
    function GetINOTECFields(INOTECDocTypeIndex: Integer): TIndexedStrings;
    function GetTDEDIFFields(INOTECDocTypeIndex: Integer): TIndexedStrings;
    function GetINOTECFieldsValueFiles(INOTECDocTypeIndex: Integer;
      ReturnAssigned: Boolean): TIndexedStrings;
    function GetINOTECFieldsValues(INOTECDocTypeIndex,
      INOTECFieldIndex: Integer; ReturnAssigned: Boolean): TIndexedStrings;
    function GetINOTECFieldsValueIndexes(INOTECDocTypeIndex,
      INOTECFieldIndex: Integer; ReturnAssigned: Boolean): TIndexedList;
    function GetTDEDIFFieldsValues(INOTECDocTypeIndex,
      INOTECFieldIndex: Integer; ReturnAssigned: Boolean): TIndexedStrings;
  public
    constructor Create; override;
    destructor Destroy; override;
    {}
    procedure ClearConfig; override;
    procedure LoadConfig(const FileName: string); override;
    function AnExport(TDEDIFReader: TTDEDIFReader;
      Mode: TProcessMode): Boolean; override;
    function AnImport(TDEDIFWriter: TTDEDIFWriter): Boolean; override;
    {       ExportStr 
    '%DATENOW%',    '%TIMENOW%', DateBegin
     '%DATEBEGIN%', DateEnd  '%DATEEND%',   Accounts
     '%ACCOUNTS%',     Accounts  
    ,     }
    function ExportCorrect(const ExportStr: string): string; override;
    {   TDEDIF Value    INOTEC  
    INOTECFieldIndex      INOTECDocTypeIndex, 
      ,   Found  True, 
      ,  False,      Value
    (FromTDEDIFValue);    INOTEC   TDEDIF
    (ToTDEDIFValue)}
    function FromTDEDIFValue(INOTECDocTypeIndex, INOTECFieldIndex: Integer;
      const Value: string; Found: PBooleanStd): string;
    function ToTDEDIFValue(INOTECDocTypeIndex, INOTECFieldIndex: Integer;
      const Value: string; Found: PBooleanStd): string;
    {}
    {       
    TDEDIF (TDEDIFDocTypeIds, TDEDIFDocTypeNames);   
       TVarBaseType    (TDEDIFFieldIds,
    TDEDIFFieldTypes, TDEDIFFieldNames);   ,
        TDEDIF   
      TTDEDIFEncoding,   'DOCTYPE'  
     tdeCPP  'MTYD'    tdeNone
    (TDEDIFFieldIdsDocType, TDEDIFFieldIdsDocTypeEncoding);  ,
      ,  ,   (-1),  
           TDEDIFFieldIds, 
        ,   0 (TDEDIFFieldIdsDocTypeDefIndex);
        TDEDIFFieldIds
    (TDEDIFFieldIdsDocTypeDefIdIndex)}
    property TDEDIFDocTypeIds: TIndexedStrings read FTDEDIFDocTypeIds;
    property TDEDIFDocTypeNames: TIndexedStrings read FTDEDIFDocTypeNames;
    property TDEDIFFieldIds: TIndexedStrings read FTDEDIFFieldIds;
    property TDEDIFFieldTypes: TIndexedList read FTDEDIFFieldTypes;
    property TDEDIFFieldNames: TIndexedStrings read FTDEDIFFieldNames;
    property TDEDIFFieldIdsDocType: TIndexedStrings
      read FTDEDIFFieldIdsDocType;
    property TDEDIFFieldIdsDocTypeEncoding: TIndexedList
      read FTDEDIFFieldIdsDocTypeEncoding;
    property TDEDIFFieldIdsDocTypeDefIndex: Integer
      read FTDEDIFFieldIdsDocTypeDefIndex write FTDEDIFFieldIdsDocTypeDefIndex;
    property TDEDIFFieldIdsDocTypeDefIdIndex: Integer
      read FTDEDIFFieldIdsDocTypeDefIdIndex
      write FTDEDIFFieldIdsDocTypeDefIdIndex;
    {,   "=", ,   ifFull, ,
    ,   ,   "",  
    ,   "",    INOTEC,
      "",  ,  
    enWindows,  (Divider, Format, Header, Footer, ListBegin,
    DocBegin, DocEnd, Encoding);   INOTEC   
      TDEDIF (INOTECDocTypes, TDEDIFDocTypes);  
          INOTEC   TDEDIF
        INOTEC,      
     ,       (INOTECFieldFiles);
         , ,   
     INOTEC,      
    (INOTECDocBegins, INOTECDocEnds);     INOTEC
      INOTECDocTypeIndex      TDEDIF
    (INOTECFields, TDEDIFFields);    , 
       INOTEC   INOTECFieldIndex  
    INOTEC   INOTECDocTypeIndex,  
     INOTECFieldsValues     TDEDIF
    TDEDIFFieldsValues,  ReturnAssigned = False    nil
       (INOTECFieldsValueFiles, INOTECFieldsValues,
    INOTECFieldsValueIndexes, TDEDIFFieldsValues)}
    property Divider: string read FDivider write FDivider;
    property Format: TINOTECFormat read FFormat write FFormat;
    property Header: string read FHeader write FHeader;
    property Footer: string read FFooter write FFooter;
    property ListBegin: string read FListBegin write FListBegin;
    property DocBegin: string read FDocBegin write FDocBegin;
    property DocEnd: string read FDocEnd write FDocEnd;
    property Encoding: TEncoding read FEncoding write FEncoding;
    property INOTECDocTypes: TIndexedStrings read FINOTECDocTypes;
    property TDEDIFDocTypes: TIndexedStrings read FTDEDIFDocTypes;
    property INOTECFieldFiles: TStringList read FINOTECFieldFiles;
    property INOTECDocBegins: TIndexedStrings read FINOTECDocBegins;
    property INOTECDocEnds: TIndexedStrings read FINOTECDocEnds;
    property INOTECFields[INOTECDocTypeIndex: Integer]: TIndexedStrings
      read GetINOTECFields;
    property TDEDIFFields[INOTECDocTypeIndex: Integer]: TIndexedStrings
      read GetTDEDIFFields;
    property INOTECFieldsValueFiles[INOTECDocTypeIndex: Integer;
      ReturnAssigned: Boolean]: TIndexedStrings read GetINOTECFieldsValueFiles;
    property INOTECFieldsValues[INOTECDocTypeIndex, INOTECFieldIndex: Integer;
      ReturnAssigned: Boolean]: TIndexedStrings read GetINOTECFieldsValues;
    property INOTECFieldsValueIndexes[INOTECDocTypeIndex,
      INOTECFieldIndex: Integer; ReturnAssigned: Boolean]: TIndexedList
      read GetINOTECFieldsValueIndexes;
    property TDEDIFFieldsValues[INOTECDocTypeIndex, INOTECFieldIndex: Integer;
      ReturnAssigned: Boolean]: TIndexedStrings read GetTDEDIFFieldsValues;
  end;
{   }
type
  TCommaSeparated = class(TCustomFormat)
  private
    FDivideChar: Char;
    FBorderChar: Char;
    FEncoding: TEncoding;
    FDefaultFields: TIndexedStrings;
    FDocTypes: TIndexedStrings;
    FFields: TObjList; {TIndexedStrings}
    FTDEDIFFieldIdsDocType: TIndexedStrings;
    FTDEDIFFieldIdsDocTypeEncoding: TIndexedList; {TTDEDIFEncoding}
    FMainIni: TStreamIni;
    FStoredFields: TIndexedStrings;
    FStoredValues: TStringList;
  protected
    function GetFields(DocTypeIndex: Integer): TIndexedStrings;
  public
    constructor Create; override;
    destructor Destroy; override;
    {}
    procedure ClearConfig; override;
    procedure LoadConfig(const FileName: string); override;
    {,    Mode  }
    function AnExport(TDEDIFReader: TTDEDIFReader;
      Mode: TProcessMode): Boolean; override;
    function AnImport(TDEDIFWriter: TTDEDIFWriter): Boolean; override;
    {}
    {,   "," (DivideChar);  ,
      """" (Border Char);  ,  
    enWindows (Encoding)}
    property DivideChar: Char read FDivideChar write FDivideChar;
    property BorderChar: Char read FBorderChar write FBorderChar;
    property Encoding: TEncoding read FEncoding write FEncoding;
    { ,     
    (DefaultFields);      
      (DocTypes);      
    DocTypeIndex,       (Fields)}
    property DefaultFields: TIndexedStrings read FDefaultFields;
    property DocTypes: TIndexedStrings read FDocTypes;
    property Fields[DocTypeIndex: Integer]: TIndexedStrings read GetFields;
    {  ,    
    TDEDIF      TTDEDIFEncoding,  
    'DOCTYPE'    tdeCPP  'MTYD'    tdeNone
    (TDEDIFFieldIdsDocType, TDEDIFFieldIdsDocTypeEncoding)}
    property TDEDIFFieldIdsDocType: TIndexedStrings
      read FTDEDIFFieldIdsDocType;
    property TDEDIFFieldIdsDocTypeEncoding: TIndexedList
      read FTDEDIFFieldIdsDocTypeEncoding;
  end;
{       ADO}
type
  TTableFormat = class(TCustomFormat)
  private
    FDatabaseAccess: TCustomDatabaseAccess;
    FRecordset: TRecordsetAccess;
    FTableName: string;
    FNotClearConfig: Boolean;
    FConnectionString: string;
    FLogin: string;
    FPassword: string;
    FDatabase: string;
    FClearTable: Boolean;
    FCreateTable: Boolean;
    FAlterTable: Boolean;
    FFieldIds: TIndexedStrings;
    FFieldColumns: TIndexedStrings;
    FTDEDIFFieldIds: TIndexedStrings;
    FTDEDIFFieldTypes: TList;
    FTDEDIFFieldSizes: TList;
    FTableTDEDIFFieldIds: TIndexedStrings;
    FTableFieldValues: TObjList; {TIndexedStrings}
    FTableTDEDIFFieldValues: TObjList; {TIndexedStrings}
    FTDEDIFFieldIdsDocType: TIndexedStrings;
    FTDEDIFFieldIdsDocTypeEncoding: TIndexedList;
    FMainIni: TStreamIni;
    FFieldsIni: TStreamIni;
    FValuesIni: TStreamIni;
    FStoredFields: TStringList;
    FStoredIds: TStringList;
    FStoredValues: TStringList;
    FStoredVariants: TVariants;
    FStoredTypes: TList;
    FStoredSizes: TList;
  protected
    function GetTableFieldValues(TableTDEDIFFieldIndex:
      Integer): TIndexedStrings;
    function GetTableTDEDIFFieldValues(TableTDEDIFFieldIndex:
      Integer): TIndexedStrings;
    {}
    {  }
    procedure ResetRecordset;
    {  FieldValue    TDEDIF FieldId,
     ToTDEDIFValue = True FieldValue    
        TDEDIF,  FieldValue   TDEDIF
         }
    function ConvertFieldValue(const FieldId: string;
      const FieldValue: Variant; ToTDEDIFValue: Boolean): Variant;
  public
    { ,       
       TableName     DatabaseAccess, 
           Recordset}
    constructor Create; override;
    destructor Destroy; override;
    {}
    procedure ClearConfig; override;
    procedure LoadConfig(const FileName: string); override;
    procedure Flush; override;
    { Stream  StreamCache     AnExport   
      AnImport     TableName  
      DatabaseAccess,      
      Recordset,     , DestMask  FilesExport
     SourMask  FilesImport      
    ,    , FilesExport  FilesImport
         TADODatabaseAccess,  
     ConnectionString,     
    DatabaseAccess, Recordset, TableName}
    function AnExport(TDEDIFReader: TTDEDIFReader;
      Mode: TProcessMode): Boolean; override;
    function AnImport(TDEDIFWriter: TTDEDIFWriter): Boolean; override;
    procedure FilesExport(const SourMask, DestMask: string); override;
    procedure FilesImport(const SourMask, DestMask: string); override;
    {}
    { ,     AnExport   
     AnImport   Stream  StreamCache (DatabaseAccess); 
        DatabaseAccess   TableName (Recordset);
      DatabaseAccess (TableName)}
    property DatabaseAccess: TCustomDatabaseAccess
      read FDatabaseAccess write FDatabaseAccess;
    property Recordset: TRecordsetAccess read FRecordset write FRecordset;
    property TableName: string read FTableName write FTableName;
    {}
    {     (ConnectionString);    
       ,     (Login, Password,
    Database);       ,  
    True (ClearTable);    ,   True
    (CreateTable);      ,  
    True (AlterTable)}
    property ConnectionString: string
      read FConnectionString write FConnectionString;
    property Login: string read FLogin write FLogin;
    property Password: string read FPassword write FPassword;
    property Database: string read FDatabase write FDatabase;
    property ClearTable: Boolean read FClearTable write FClearTable;
    property CreateTable: Boolean read FCreateTable write FCreateTable;
    property AlterTable: Boolean read FAlterTable write FAlterTable;
    {  (FieldIds);     ,
        FieldIds (FieldColumns)}
    property FieldIds: TIndexedStrings read FFieldIds;
    property FieldColumns: TIndexedStrings read FFieldColumns;
    {   TDEDIF (TDEDIFFieldIds); 
        TVarBaseType   TDEDIFFieldIds
    (TDEDIFFieldTypes);     , 
          
      254  (TDEDIFFieldSizes)}
    property TDEDIFFieldIds: TIndexedStrings read FTDEDIFFieldIds;
    property TDEDIFFieldTypes: TList read FTDEDIFFieldTypes;
    property TDEDIFFieldSizes: TList read FTDEDIFFieldSizes;
    {   TDEDIF,    
     (TableTDEDIFFieldIds);       
    TableTDEDIFFieldIndex  TableTDEDIFFieldIds (TableFieldValues);
          TDEDIF  
      TableTDEDIFFieldIndex  TableTDEDIFFieldIds,  
    TIndexedStrings.SearchMode      
     ismFirstIndex    (TableTDEDIFFieldValues)}
    property TableTDEDIFFieldIds: TIndexedStrings read FTableTDEDIFFieldIds;
    property TableFieldValues[TableTDEDIFFieldIndex: Integer]: TIndexedStrings
      read GetTableFieldValues;
    property TableTDEDIFFieldValues[TableTDEDIFFieldIndex: Integer]:
      TIndexedStrings read GetTableTDEDIFFieldValues;
    {  ,    
    TDEDIF      TTDEDIFEncoding,  
    'DOCTYPE'    tdeCPP  'MTYD'    tdeNone
    (TDEDIFFieldIdsDocType, TDEDIFFieldIdsDocTypeEncoding)}
    property TDEDIFFieldIdsDocType: TIndexedStrings
      read FTDEDIFFieldIdsDocType;
    property TDEDIFFieldIdsDocTypeEncoding: TIndexedList
      read FTDEDIFFieldIdsDocTypeEncoding;
  end;
{   MT940/MT103: mfmDefault - , mfmSum -
     }
type
  TMT940FieldMode = (mfmDefault, mfmSum);
{    MT940/MT103}
type
  TMT940 = class(TCustomFormat)
  private
    FEncoding: TEncoding;
    FTDEDIFDocTypeIds: TIndexedStrings;
    FTDEDIFDocTypeNames: TIndexedStrings;
    FTDEDIFFieldIds: TIndexedStrings;
    FTDEDIFFieldTypes: TIndexedList;
    FTDEDIFFieldNames: TIndexedStrings;
    FTDEDIFFieldIdsDocType: TIndexedStrings;
    FTDEDIFFieldIdsDocTypeEncoding: TIndexedList; {TTDEDIFEncoding}
    FTDEDIFFieldIdsDocTypeDefIndex: Integer;
    FTDEDIFFieldIdsDocTypeDefIdIndex: Integer;
    FMT940FindDocTypes: TIndexedStrings;
    FMT940DocTypeIndexes: TIndexedList;
    FTDEDIFDocTypes: TIndexedStrings;
    FTDEDIFFields: TObjList; {TIndexedStrings}
    FMT940FieldTags: TObjList; {TObjList, TIndexedStrings}
    FMT940FieldBeginPositions: TObjList; {TObjList, TList}
    FMT940FieldBeginStrings: TObjList; {TObjList, TStringList}
    FMT940FieldBeginCharRanges: TObjList; {TObjList, TStringList}
    FMT940FieldEndPositions: TObjList; {TObjList, TList}
    FMT940FieldEndStrings: TObjList; {TObjList, TStringList}
    FMT940FieldEndCharRanges: TObjList; {TObjList, TStringList}
    FMT940FieldModes: TObjList; {TObjList, TList}
    FMT940FieldCaseBeginPositions: TObjList; {TObjList, TList}
    FMT940FieldCaseBeginStrings: TObjList; {TObjList, TStringList}
    FMT940FieldCaseBeginCharRanges: TObjList; {TObjList, TStringList}
    FMT940FieldCaseEndPositions: TObjList; {TObjList, TList}
    FMT940FieldCaseEndStrings: TObjList; {TObjList, TStringList}
    FMT940FieldCaseEndCharRanges: TObjList; {TObjList, TStringList}
    FMT940FieldCaseValues: TObjList; {TObjList, TStringList}
    FStoredFields: TIndexedStrings;
    FStoredValues: TStringList;
    FMainIni: TStreamIni;
    FTypesIni: TStreamIni;
    FFieldsIni: TStreamIni;
    FFieldsMap: TStreamIni;
  protected
    procedure UpdateTDEDIFFieldIdsDocTypeDefIndex;
    {}
    function GetTDEDIFFields(DocTypeIndex: Integer): TIndexedStrings;
    function GetMT940FieldTags(DocTypeIndex,
      FieldIndex: Integer): TIndexedStrings;
    function GetMT940FieldBeginPositions(DocTypeIndex,
      FieldIndex: Integer): TList;
    function GetMT940FieldBeginStrings(DocTypeIndex,
      FieldIndex: Integer): TStringList;
    function GetMT940FieldBeginCharRanges(DocTypeIndex,
      FieldIndex: Integer): TStringList;
    function GetMT940FieldEndPositions(DocTypeIndex,
      FieldIndex: Integer): TList;
    function GetMT940FieldEndStrings(DocTypeIndex,
      FieldIndex: Integer): TStringList;
    function GetMT940FieldEndCharRanges(DocTypeIndex,
      FieldIndex: Integer): TStringList;
    function GetMT940FieldModes(DocTypeIndex, FieldIndex: Integer): TList;
    function GetMT940FieldCaseBeginPositions(DocTypeIndex,
      FieldIndex: Integer): TList;
    function GetMT940FieldCaseBeginStrings(DocTypeIndex,
      FieldIndex: Integer): TStringList;
    function GetMT940FieldCaseBeginCharRanges(DocTypeIndex,
      FieldIndex: Integer): TStringList;
    function GetMT940FieldCaseEndPositions(DocTypeIndex,
      FieldIndex: Integer): TList;
    function GetMT940FieldCaseEndStrings(DocTypeIndex,
      FieldIndex: Integer): TStringList;
    function GetMT940FieldCaseEndCharRanges(DocTypeIndex,
      FieldIndex: Integer): TStringList;
    function GetMT940FieldCaseValues(DocTypeIndex,
      FieldIndex: Integer): TStringList;
  public
    constructor Create; override;
    destructor Destroy; override;
    {}
    procedure ClearConfig; override;
    procedure LoadConfig(const FileName: string); override;
    function AnImport(TDEDIFWriter: TTDEDIFWriter): Boolean; override;
    {}
    { ,   enWindows (Encodig)}
    property Encodig: TEncoding read FEncoding write FEncoding;
    {       
    TDEDIF (TDEDIFDocTypeIds, TDEDIFDocTypeNames);   
       TVarBaseType    (TDEDIFFieldIds,
    TDEDIFFieldTypes, TDEDIFFieldNames);   ,
        TDEDIF   
      TTDEDIFEncoding,   'DOCTYPE'  
     tdeCPP  'MTYD'    tdeNone
    (TDEDIFFieldIdsDocType, TDEDIFFieldIdsDocTypeEncoding);  ,
      ,  ,   (-1),  
           TDEDIFFieldIds, 
        ,   0 (TDEDIFFieldIdsDocTypeDefIndex);
        TDEDIFFieldIds
    (TDEDIFFieldIdsDocTypeDefIdIndex)}
    property TDEDIFDocTypeIds: TIndexedStrings read FTDEDIFDocTypeIds;
    property TDEDIFDocTypeNames: TIndexedStrings read FTDEDIFDocTypeNames;
    property TDEDIFFieldIds: TIndexedStrings read FTDEDIFFieldIds;
    property TDEDIFFieldTypes: TIndexedList read FTDEDIFFieldTypes;
    property TDEDIFFieldNames: TIndexedStrings read FTDEDIFFieldNames;
    property TDEDIFFieldIdsDocType: TIndexedStrings
      read FTDEDIFFieldIdsDocType;
    property TDEDIFFieldIdsDocTypeEncoding: TIndexedList
      read FTDEDIFFieldIdsDocTypeEncoding;
    property TDEDIFFieldIdsDocTypeDefIndex: Integer
      read FTDEDIFFieldIdsDocTypeDefIndex write FTDEDIFFieldIdsDocTypeDefIndex;
    property TDEDIFFieldIdsDocTypeDefIdIndex: Integer
      read FTDEDIFFieldIdsDocTypeDefIdIndex
      write FTDEDIFFieldIdsDocTypeDefIdIndex;
    {   MT940/103,     
     (MT940FindDocTypes);     TDEDIFDocTypes
    (MT940DocTypeIndexes);     
     TDEDIF (TDEDIFDocTypes);  TDEDIF   
      DocTypeIndex (TDEDIFFields); ,  ,
      ,     
    CharInRange?  ,  ,  ,
      TMT940FieldMode,   ,  
     ,    ,  
    ,    ,   
    ,         ,
    ,  MT940/103,    
    FieldIndex      DocTypeIndex (MT940FieldTags,
    MT940FieldBeginPositions, MT940FieldBeginStrings,
    MT940FieldBeginCharRanges, MT940FieldEndPositions, MT940FieldEndStrings,
    MT940FieldEndCharRanges, MT940FieldModes, MT940FieldCaseBeginPositions,
    MT940FieldCaseBeginStrings, MT940FieldCaseBeginCharRanges,
    MT940FieldCaseEndPositions, MT940FieldCaseEndStrings,
    MT940FieldCaseEndCharRanges, MT940FieldCaseValues)}
    property MT940FindDocTypes: TIndexedStrings read FMT940FindDocTypes;
    property MT940DocTypeIndexes: TIndexedList read FMT940DocTypeIndexes;
    property TDEDIFDocTypes: TIndexedStrings read FTDEDIFDocTypes;
    property TDEDIFFields[DocTypeIndex: Integer]: TIndexedStrings
      read GetTDEDIFFields;
    property MT940FieldTags[DocTypeIndex, FieldIndex: Integer]: TIndexedStrings
      read GetMT940FieldTags;
    property MT940FieldBeginPositions[DocTypeIndex, FieldIndex: Integer]: TList
     read GetMT940FieldBeginPositions;
    property MT940FieldBeginStrings[DocTypeIndex,
      FieldIndex: Integer]: TStringList read GetMT940FieldBeginStrings;
    property MT940FieldBeginCharRanges[DocTypeIndex,
      FieldIndex: Integer]: TStringList read GetMT940FieldBeginCharRanges;
    property MT940FieldEndPositions[DocTypeIndex, FieldIndex: Integer]: TList
      read GetMT940FieldEndPositions;
    property MT940FieldEndStrings[DocTypeIndex,
      FieldIndex: Integer]: TStringList read GetMT940FieldEndStrings;
    property MT940FieldEndCharRanges[DocTypeIndex,
      FieldIndex: Integer]: TStringList read GetMT940FieldEndCharRanges;
    property MT940FieldModes[DocTypeIndex, FieldIndex: Integer]: TList
      read GetMT940FieldModes;
    property MT940FieldCaseBeginPositions[DocTypeIndex,
      FieldIndex: Integer]: TList read GetMT940FieldCaseBeginPositions;
    property MT940FieldCaseBeginStrings[DocTypeIndex,
      FieldIndex: Integer]: TStringList read GetMT940FieldCaseBeginStrings;
    property MT940FieldCaseBeginCharRanges[DocTypeIndex,
      FieldIndex: Integer]: TStringList read GetMT940FieldCaseBeginCharRanges;
    property MT940FieldCaseEndPositions[DocTypeIndex,
      FieldIndex: Integer]: TList read GetMT940FieldCaseEndPositions;
    property MT940FieldCaseEndStrings[DocTypeIndex,
      FieldIndex: Integer]: TStringList read GetMT940FieldCaseEndStrings;
    property MT940FieldCaseEndCharRanges[DocTypeIndex,
      FieldIndex: Integer]: TStringList read GetMT940FieldCaseEndCharRanges;
    property MT940FieldCaseValues[DocTypeIndex,
      FieldIndex: Integer]: TStringList read GetMT940FieldCaseValues;
  end;
{    FormatClass}
procedure ConvertRun(FormatClass: TFormatClass);

{ : tcUnknown - , tcUpload -   
   , tcUploadReply -    
    , tcDownload -   
  , tcDownloadReply -     
  }
type
  TTransportCommand = (tcUnknown, tcUpload, tcUploadReply, tcDownload,
    tcDownloadReply);
{}
{   .  :  
  (Command, Count, Ids  ),  
     MessageText.   -
     MessageText   
 .      :  
 (   MsgLavel,   TMSG), CRC , 
(  " ini-").  .
  1.  (Send)    :
)       - 
Command = tcUpload   -   ( 
 Count),   (Ids)   (Bodies), 
 -   (SenderIds)  
(ReceiverIds);
*          
TTransportStorage.PrepareOutgoing(ClientAllowOverflow = True);
)   ,   
Command = tcUploadReply   -    (Count),
  (Ids)       (Errors);
   ,       (
)      ; 
,      ,    
,   -   (SenderIds) 
 (ReceiverIds);
*          
TTransportStorage.AcceptIncoming(ServerRequestResult = True);
)  ,     (  
;   ) -  Command = tcUpload 
 -    (ConfirmCount)  
 (ConfirmIds),   - 
 (ConfirmSenderIds)   (ConfirmReceiverIds);
*         
TTransportStorage.AcceptNotify(AType =
tntClientOutgoingJustDelivered/tntOutgoingError);
*     `     
TTransportStorage.ClientPrepareNotify(IsOutgoing = True);
)       Command = tcUploadReply 
 -    (ConfirmCount)  
 (ConfirmIds),   - 
 (ConfirmSenderIds)   (ConfirmReceiverIds);
*         
TTransportStorage.AcceptNotify(AType = tntIncomingConfirm)
)    ;
*         
TTransportStorage.AcceptNotify(AType = tntOutgoingConfirm).
            
  ( ))  "",     
    (       
   ).      
 ,        ,  
    ,   
( ), )).       ,  
,     )       
        .    ), )
    ,     
    ()),       ,  
   .     
(  ),      , ,
       ,   
   .
  2.  (Receive)    :
)        - 
Command = tcDownload c  -  () 
 ,    (Count)      
,     (MaxSize),   
  MaxSize,      ();
*       ;
)      Command = tdDownloadReply 
 -    (Count),  
(Ids)   (Bodies),   - 
 (SenderIds)   (ReceiverIds);
*          
TTransportStorage.PrepareOutgoing(ClientAllowOverflow = False);
)         -
 Command = tcDownload c  -  
 (ConfirmCount),   (ConfirmIds),   
 (ConfirmError);      ,  
       ;
 ,      ,    
 ,   -  
(ConfirmSenderIds)   (ConfirmReceiverIds);
*         
TTransportStorage.AcceptIncoming(ServerRequestResult = False);
*          
TTransportStorage.ClientPrepareNotify(IsOutgoing = False);
)     ,    (  
) -  Command = tdDownloadReply c  - 
  (ConfirmCount),   (ConfirmIds), 
        (RemainCount);
         
    )      
,   -  
(ConfirmSenderIds)   (ConfirmReceiverIds);
*         
TTransportStorage.AcceptNotify(AType = tntOutgoingConfirm/tntOutgoingError);
)    ;
*         
TTransportStorage.AcceptNotify(AType = tntIncomingConfirm).
           
      ( ) . ,
,  1 )  1 ) Command = tcUpload -     , 
  : Count, Ids, Bodies  ConfirmCount, ConfirmIds
.       ,  
 (   Count -    , 
ConfirmCount -      - 
 ,  )}
type
  TTransportMessage = class(TObjectStd)
  private
    FBinIni: TStreamBinIni;
    FMsgLabel: string;
    FMsgMaxCount: Integer;
    FCommand: TTransportCommand;
    FCount: Integer;
    FCountChanged: Boolean;
    FMaxSize: Integer;
    FRemainCount: Integer;
    FIds: TIndexedStrings;
    FBodies: TStringList;
    FErrors: TList;
    FSenderIds: TIndexedStrings;
    FReceiverIds: TIndexedStrings;
    FWorkPlaceIds: TIndexedStrings;
    FWorkPlaceTypes: TIndexedStrings;
    FSRecipientBranches: TIndexedStrings;
    FRRecipientBranches: TIndexedStrings;
    FConfirmCount: Integer;
    FConfirmCountChanged: Boolean;
    FConfirmIds: TIndexedStrings;
    FConfirmErrors: TList;
    FConfirmSenderIds: TIndexedStrings;
    FConfirmReceiverIds: TIndexedStrings;
    FConfirmWorkPlaceIds: TIndexedStrings;
    FConfirmWorkPlaceTypes: TIndexedStrings;
    FConfirmSRecipientBranches: TIndexedStrings;
    FConfirmRRecipientBranches: TIndexedStrings;
  protected
    procedure SetCount(NewCount: Integer);
    procedure SetConfirmCount(NewConfirmCount: Integer);
    function GetId(Index: Integer): string;
    procedure SetId(Index: Integer; const NewId: string);
    function GetBody(Index: Integer): string;
    procedure SetBody(Index: Integer; const NewBody: string);
    function GetError(Index: Integer): Integer;
    procedure SetError(Index, NewError: Integer);
    function GetSenderId(Index: Integer): string;
    procedure SetSenderId(Index: Integer; const NewSenderId: string);
    function GetReceiverId(Index: Integer): string;
    procedure SetReceiverId(Index: Integer; const NewReceiverId: string);
    function GetWorkPlaceId(Index: Integer): string;
    procedure SetWorkPlaceId(Index: Integer; const NewWorkPlaceId: string);
    function GetWorkPlaceType(Index: Integer): string;
    procedure SetWorkPlaceType(Index: Integer; const NewWorkPlaceType: string);
    function GetSRecipientBranch(Index: Integer): string;
    procedure SetSRecipientBranch(Index: Integer;
      const NewSRecipientBranch: string);
    function GetRRecipientBranch(Index: Integer): string;
    procedure SetRRecipientBranch(Index: Integer;
      const NewRRecipientBranch: string);
    function GetConfirmId(Index: Integer): string;
    procedure SetConfirmId(Index: Integer; const NewConfirmId: string);
    function GetConfirmError(Index: Integer): Integer;
    procedure SetConfirmError(Index, NewConfirmError: Integer);
    function GetConfirmSenderId(Index: Integer): string;
    procedure SetConfirmSenderId(Index: Integer;
      const NewConfirmSenderId: string);
    function GetConfirmReceiverId(Index: Integer): string;
    procedure SetConfirmReceiverId(Index: Integer;
      const NewConfirmReceiverId: string);
    function GetConfirmWorkPlaceId(Index: Integer): string;
    procedure SetConfirmWorkPlaceId(Index: Integer;
      const NewConfirmWorkPlaceId: string);
    function GetConfirmWorkPlaceType(Index: Integer): string;
    procedure SetConfirmWorkPlaceType(Index: Integer;
      const NewConfirmWorkPlaceType: string);
    function GetConfirmSRecipientBranch(Index: Integer): string;
    procedure SetConfirmSRecipientBranch(Index: Integer;
      const NewConfirmSRecipientBranch: string);
    function GetConfirmRRecipientBranch(Index: Integer): string;
    procedure SetConfirmRRecipientBranch(Index: Integer;
      const NewConfirmRRecipientBranch: string);
    function GetMessageText: string;
    procedure SetMessageText(const NewMessageText: string);
    {}
    procedure FixCount;
    procedure FixConfirmCount;
    {}
    procedure InitVars; virtual;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  ,  MsgLabel  MaxCount}
    procedure Clear;
    {}
    { ,      ,   'TMSG'
    (MsgLabel);   ,   32760, 
     (-1)    (MsgMaxCount)}
    property MsgLabel: string read FMsgLabel write FMsgLabel;
    property MsgMaxCount: Integer read FMsgMaxCount write FMsgMaxCount;
    { (Command);    (Count); 
      (ConfirmCount);  
       (RemainCount);   (Ids);
      (Bodies);    (Errors); 
    ,  (SenderIds);  ,
     (ReceiverIds);    (WorkPlaceIds);
       (WorkPlaceTypes);  -
    (SRecipientBranches);  -
    (RRecipientBranches);    (ConfirmIds);
        (ConfirmErrors); 
     ,  (ConfirmSenderIds);
      , 
    (ConfirmReceiverIds);    
    (ConfirmWorkPlaceIds);    
    (ConfirmWorkPlaceTypes);  - 
    (ConfirmSRecipientBranch);  -
     (ConfirmRRecipientBranch)}
    property Command: TTransportCommand read FCommand write FCommand;
    property Count: Integer read FCount write SetCount;
    property MaxSize: Integer read FMaxSize write FMaxSize;
    property ConfirmCount: Integer read FConfirmCount write SetConfirmCount;
    property RemainCount: Integer read FRemainCount write FRemainCount;
    property Ids[Index: Integer]: string read GetId write SetId;
    property Bodies[Index: Integer]: string read GetBody write SetBody;
    property Errors[Index: Integer]: Integer read GetError write SetError;
    property SenderIds[Index: Integer]: string
      read GetSenderId write SetSenderId;
    property ReceiverIds[Index: Integer]: string
      read GetReceiverId write SetReceiverId;
    property WorkPlaceIds[Index: Integer]: string
      read GetWorkPlaceId write SetWorkPlaceId;
    property WorkPlaceTypes[Index: Integer]: string
      read GetWorkPlaceType write SetWorkPlaceType;
    property SRecipientBranches[Index: Integer]: string
      read GetSRecipientBranch write SetSRecipientBranch;
    property RRecipientBranches[Index: Integer]: string
      read GetRRecipientBranch write SetRRecipientBranch;
    property ConfirmIds[Index: Integer]: string read GetConfirmId
      write SetConfirmId;
    property ConfirmErrors[Index: Integer]: Integer
      read GetConfirmError write SetConfirmError;
    property ConfirmSenderIds[Index: Integer]: string
      read GetConfirmSenderId write SetConfirmSenderId;
    property ConfirmReceiverIds[Index: Integer]: string
      read GetConfirmReceiverId write SetConfirmReceiverId;
    property ConfirmWorkPlaceIds[Index: Integer]: string
      read GetConfirmWorkPlaceId write SetConfirmWorkPlaceId;
    property ConfirmWorkPlaceTypes[Index: Integer]: string
      read GetConfirmWorkPlaceType write SetConfirmWorkPlaceType;
    property ConfirmSRecipientBranches[Index: Integer]: string
      read GetConfirmSRecipientBranch write SetConfirmSRecipientBranch;
    property ConfirmRRecipientBranches[Index: Integer]: string
      read GetConfirmRRecipientBranch write SetConfirmRRecipientBranch;
    {      ,  
          , ,
        ,     
      ,     }
    property MessageText: string read GetMessageText write SetMessageText;
  end;
{}
{ }
const
  TRANSPORTERROR_DOUBLED      = 1; { }
  TRANSPORTERROR_EXCEEDEDSIZE = 2; {  }
{     }
function TransportErrorToStr(ErrorCode: Integer): string;
{ : tntOutgoingConfirm -    ,
tntClientOutgoingJustDelivered -      
 , tntOutgoingError -   
      , tntIncomingConfirm -
   }
type
  TTransportNotifyType = (tntOutgoingConfirm, tntClientOutgoingJustDelivered,
    tntOutgoingError, tntIncomingConfirm);
{  }
type
  TMailFieldNames = record
    DOCID: string;             { }
    OWNERORGID: string;        { }
    OPPOSITEORGID: string;     { }
    OUTGOING: string;          {}
    DATE: string;              {}
    SENT: string;              { }
    CONFIRMED: string;         {}
    ERROR: string;             {}
    REPEATED: string;          { }
    PROCESSED: string;         {}
    ARCDOCID: string;          {   }
    ARCOPPOSITEORGID: string;  {   }
    BODY: string;              {}
    DOCPACKID: string;         { }
    WORKPLACEID: string;       {  }
    WORKPLACETYPE: string;     {  }
    TRANSPORT: string;         {}
    SRECIPIENT_BRANCH: string; {-}
    RRECIPIENT_BRANCH: string; {-}
  end;
{   Value (InitMailFieldNames);  
TMailFieldNames    DOCID,  
OWNERORGID,   OPPOSITEORGID,   OUTGOING,
 DATE,   SENT,   CONFIRMED,
  ERROR,   REPEATED, 
 PROCESSED,     ARCDOCID, 
   ARCOPPOSITEORGID,  BODY, 
 DOCPACKID,    WORKPLACEID,   
WORKPLACETYPE,  TRANSPORT, - SRECIPIENTBRANCH,
- RRECIPIENTBRANCH (MailFieldNames)}
procedure InitMailFieldNames(out Value: TMailFieldNames);
function MailFieldNames(const DOCID, OWNERORGID, OPPOSITEORGID, OUTGOING, DATE,
  SENT, CONFIRMED, ERROR, REPEATED, PROCESSED, ARCDOCID, ARCOPPOSITEORGID,
  BODY, DOCPACKID, WORKPLACEID, WORKPLACETYPE, TRANSPORT, SRECIPIENT_BRANCH,
  RRECIPIENT_BRANCH: string): TMailFieldNames;
{     }
type
  TTransportStorage = class(TObjectStd)
  private
    FOwnerId: string;
    FOwnerPrefix: string;
    FOppositeId: string;
    FOppositePrefix: string;
    FIsMulti: Boolean;
    FPacksNotSupported: Boolean;
    FWorkPlaceId: string;
    FWorkPlaceType: string;
    FTransport: string;
    FIsArchived: Boolean;
    FMailTableNamesInited: Boolean;
    FMailTableIn: string;
    FMailTableOut: string;
    FMailFieldsPrefixIn: string;
    FMailFieldsPrefixOut: string;
    FMailFieldNames: TMailFieldNames;
    FIsServer: Boolean;
    FActiveLogin: string;
    FActiveLoginOriginal: string;
  protected
  public
    constructor Create;
    {}
    {        , MaxCount
       ,   (-1) ,
    MaxSize      ,    
          MaxSize,  
    MaxSize = -1    ,  
      Ids,   Bodies,  ClientAllowOverflow = True
         ,   
       ,   MaxSize, 
       ClientIsOverflow = True, 
        ClientOverflowId,   ClientOverflowBody,
           , 
    RetrieveCount = True     RetrievedCount 
       ,     , 
      ,  BodyExceeded  True, 
       ,  IsMulti = True 
    OwnerId  OppositeId    ,  SenderIds
      ,  ReceiverIds 
     ,  ClientSenderId, ClientReceiverId -
        ,  ClientWorkPlaceId,
    ClientWorkPlaceType -      
      ,  ClientSRecipientBranch, ClientRRecipientBranch -
      -  -
      }
    procedure PrepareOutgoing(RetrieveCount: Boolean; MaxCount,
      MaxSize: Integer; ClientAllowOverflow: Boolean;
      out RetrievedCount: Integer; Ids: TIndexedStrings; Bodies, SenderIds,
      ReceiverIds, WorkPlaceIds, WorkPlaceTypes, SRecipientBranches,
      RRecipientBranches: TStrings; out BodyExceeded,
      ClientIsOverflow: Boolean; out ClientOverflowId, ClientOverflowBody,
      ClientSenderId, ClientReceiverId, ClientWorkPlaceId, ClientWorkPlaceType,
      ClientSRecipientBranch, ClientRRecipientBranch: string);
      virtual; abstract;
    {        , 
    IsOutgoing = True     
            ,
     IsOutgoing = False -     
      , MaxCount    
      ,   (-1) ,  Ids 
     ,  IncomingErrors -    
     ,    IncomingErrors  
    nil -       
       ,  ,   
      Ids,  RetrieveCount = True   
          ,  
     ,  IsMulti = True  OwnerId  OppositeId 
      ,  SenderIds  
    ,  ReceiverIds   }
    procedure ClientPrepareNotify(RetrieveCount: Boolean; IsOutgoing: Boolean;
      MaxCount: Integer; out RetrievedCount: Integer; Ids: TIndexedStrings;
      IncomingErrors: TList; SenderIds, ReceiverIds, WorkPlaceIds,
      WorkPlaceTypes, SRecipientBranches, RRecipientBranches: TStrings);
      virtual; abstract;
    {       Id,  Body,
     ServerRequestResult = True     
        ,    ServerError,
      ServerError = True ,    
            
     , ServerIsError = False  , 
    ServerRequestResult = False     , 
    ,       ,
      SenderId  ReceiverId   
    ,     IsMulti = True, WorkPlaceId
     WorkPlaceType       ,
    SRecipientBranch  RRecipientBranch   
    -  -,  Confirmed  True
      ,      
        }
    procedure AcceptIncoming(Ids: TIndexedStrings; Bodies, SenderIds,
      ReceiverIds, WorkPlaceIds, WorkPlaceTypes, SRecipientBranches,
      RRecipientBranches: TStrings; ServerRequestResult: Boolean;
      {out} ServerErrors: TList; ForceConfirmed: Boolean); virtual; abstract;
    {      Id  AType, 
     SenderId  ReceiverId    , 
       IsMulti = True, WorkPlaceId  WorkPlaceType 
         , SRecipientBranch 
    RRecipientBranch    -
     -}
    procedure AcceptNotify(IsOutgoing: Boolean; Ids: TIndexedStrings;
      SenderIds, ReceiverIds, WorkPlaceIds, WorkPlaceTypes, SRecipientBranches,
      RRecipientBranches: TStrings; ATypes {TTransportNotifyType},
      OutgoingErrors: TList); virtual; abstract;
    {       ServerId}
    procedure ProcessMail(const ServerId: string); virtual; abstract;
    {   }
    procedure RestoreArchived; virtual; abstract;
    {}
    { ,     (OwnerId); 
      , ,   
       IsMulti = True (OwnerPrefix);  
    ,     (OppositeId);  
      , ,   
       IsMulti = True (OppositePrefix);  
    ,   ,  , 
        SenderIds, ReceiverIds, ,
     ,    
      SenderId, ReceiverId,     
        ,    
    OwnerPrefix  OppositePrefix (IsMulti);   ,
      False,       
         True (PacksNotSupported); 
      (WorkPlaceId);    (WorkPlaceType); 
     (Transport);   (IsArchived);  
         (MailTableNamesInited);  
      ,   'MAILDOCUMENTS' (MailTableIn);
        ,   'MAILDOCUMENTS'
    (MailTableOut);       ,
      'MD_' (MailFieldsPrefixIn);    
      ,   'MD_' (MailFieldsPrefixOut); 
       ,     
      (MailFieldNames);    ,
       ,   False (IsServer);
           (ActiveLogin);
     ,      
     (ActiveLoginOriginal)}
    property OwnerId: string read FOwnerId write FOwnerId;
    property OwnerPrefix: string read FOwnerPrefix write FOwnerPrefix;
    property OppositeId: string read FOppositeId write FOppositeId;
    property OppositePrefix: string read FOppositePrefix write FOppositePrefix;
    property IsMulti: Boolean read FIsMulti write FIsMulti;
    property PacksNotSupported: Boolean
      read FPacksNotSupported write FPacksNotSupported;
    property WorkPlaceId: string read FWorkPlaceId write FWorkPlaceId;
    property WorkPlaceType: string read FWorkPlaceType write FWorkPlaceType;
    property Transport: string read FTransport write FTransport;
    property IsArchived: Boolean read FIsArchived write FIsArchived;
    property MailTableNamesInited: Boolean
      read FMailTableNamesInited write FMailTableNamesInited;
    property MailTableIn: string read FMailTableIn write FMailTableIn;
    property MailTableOut: string read FMailTableOut write FMailTableOut;
    property MailFieldsPrefixIn: string
      read FMailFieldsPrefixIn write FMailFieldsPrefixIn;
    property MailFieldsPrefixOut: string
      read FMailFieldsPrefixOut write FMailFieldsPrefixOut;
    property MailFieldNames: TMailFieldNames
      read FMailFieldNames write FMailFieldNames;
    property IsServer: Boolean read FIsServer write FIsServer;
    property ActiveLogin: string read FActiveLogin write FActiveLogin;
    property ActiveLoginOriginal: string
      read FActiveLoginOriginal write FActiveLoginOriginal;
  end;
{       ,  
   MAILDOCUMENTS,    
:
- MD_DOCID char[40],     -  ;
- MD_OWNERORGID char[40],     -  
 (     -   
,   - );
- MD_OPPOSITEORGID char[40],     - 
,     (     -
   ,   - );
- MD_OUTGOING int,     - 1 - , 0  
 -  ;
- MD_DATE datetime -     (   
  -  ;   
          
    );
- MD_SENT int -    -   
(,   ), 0  NULL -    , 
        
;         
;
- MD_CONFIRMED int - 1 -   , 0, NULL  
 -   ,     
 2   ,      
  ,        
         ;
- MD_ERROR int - 1 -      , 0,
NULL    - ,     MD_CONFIRMED = 1 
MD_ERROR   ,     ,
   ,    
,        , 
 MD_ERROR ,    ;
- MD_REPEATED int -     MD_CONFIRMED = 1  MD_REPEATED
  ,     , 
         , 
     ,  
,   ,   MD_REPEATED , 
  ;
- MD_PROCESSED int - 1    -   
   (   )   , 0,
NULL    -   ;
- MD_ARCDOCID varchar[40] - . ;
- MD_ARCOPPOSITEORGID varchar[40] - . ;
- MD_BODY image -   (   );
           
 MD_ARCDOCID  MD_ARCOPPOSITEORGID -   , , 
       MD_BODY  ,   MD_BODY
  ,  MD_ARCDOCID,  , 
MD_ARCOPPOSITEORGID (      ).
MD_DOCID, MD_OWNERORGID, MD_OPPOSITEORGID, MD_OUTGOING   Primary Key.
(     -   ,  MD_BODY)
   ,      ,   MD_DOCID
     ,   
   -     
, ,      .
    :     
    MAILDOCUMENTS ( 
MD_BODY).   /   MAILDOCUMENTS  
.       
MAILDOCUMENTS (  MD_BODY)   .  
   (  MD_BODY, 
      
   ),    - 
 ( )  ,      
(   )      (
         
  ).
        : 
       ,
   (      
    )     (
   ,   ).  
       MD_CONFIRMED = 1. 
     ,    ,
  MD_CONFIRMED = 1  .     
  MD_CONFIRMED = 2,   
,         (   
          
).
  ,       ,  
     (   ,  
   ),      
 .       MD_ERROR = 1. 
     (MD_CONFIRMED = 1),    
(MD_ERROR = 1).      , 
      ,   
          
  -    MD_CONFIRMED = 1  MD_ERROR  ,
    ,    .
   ()   
(     MD_PROCESSED = 1).
    =>  .            <=  .
 MD_CONFIRMED = 0 -->\                                 -->\
                 /<--/ MD_CONFIRMED = 0                  /<--/ MD_CONFIRMED = 0
MD_CONFIRMED = 2 \-->\                  MD_CONFIRMED = 0 \-->\
 MD_CONFIRMED = 1 <--/ MD_CONFIRMED = 1  MD_CONFIRMED = 1 <--/ MD_CONFIRMED = 1
   HTTP-     ?
      (    )
,       (  
          ,
 ,  ,       ,  
 );   ,       
 .   ,   ASP  ,   
 ( "http-") ;   , 
 ,    ,  ,   
 TCP/IP,       (,     ).
  ,     ,   :
-  ,    (  MAILDOCUMENTS);
-     (MD_CONFIRMED = 1)  
 -   (MD_ERROR = 1  MD_CONFIRMED = 0)
     ""  " 
-  ";
-     (   MAILDOCUMENTS);
-        
   (,   )    
 MD_BODY -  (  MAILDOCUMENTS) -
    -    
  ( ),       
  ;
-      (  MD_SENT, 
 )       
      "   
     ";
-          , 
   (    ,  
     );
-        ,
,   ,   -      
 ;  ,     (, 
)    ,      
   ;    ( 
)        ,  
    ,     }
type
  TTransportDBStorage = class(TTransportStorage)
  private
    FSQLBlocks: array[0..2] of TStringList;
    FDatabaseAccess: TCustomDatabaseAccess;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    {}
    procedure PrepareOutgoing(RetrieveCount: Boolean; MaxCount,
      MaxSize: Integer; ClientAllowOverflow: Boolean;
      out RetrievedCount: Integer; Ids: TIndexedStrings; Bodies, SenderIds,
      ReceiverIds, WorkPlaceIds, WorkPlaceTypes, SRecipientBranches,
      RRecipientBranches: TStrings; out BodyExceeded,
      ClientIsOverflow: Boolean; out ClientOverflowId, ClientOverflowBody,
      ClientSenderId, ClientReceiverId, ClientWorkPlaceId,
      ClientWorkPlaceType, ClientSRecipientBranch,
      ClientRRecipientBranch: string); override;
    procedure ClientPrepareNotify(RetrieveCount: Boolean; IsOutgoing: Boolean;
      MaxCount: Integer; out RetrievedCount: Integer; Ids: TIndexedStrings;
      IncomingErrors: TList; SenderIds, ReceiverIds, WorkPlaceIds,
      WorkPlaceTypes, SRecipientBranches, RRecipientBranches: TStrings);
      override;
    procedure AcceptIncoming(Ids: TIndexedStrings; Bodies, SenderIds,
      ReceiverIds, WorkPlaceIds, WorkPlaceTypes, SRecipientBranches,
      RRecipientBranches: TStrings; ServerRequestResult: Boolean;
      {out} ServerErrors: TList; ForceConfirmed: Boolean); override;
    procedure AcceptNotify(IsOutgoing: Boolean; Ids: TIndexedStrings;
      SenderIds, ReceiverIds, WorkPlaceIds, WorkPlaceTypes, SRecipientBranches,
      RRecipientBranches: TStrings; ATypes {TTransportNotifyType},
      OutgoingErrors: TList); override;
    procedure ProcessMail(const ServerId: string); override;
    procedure RestoreArchived; override;
    {}
    {   }
    property DatabaseAccess: TCustomDatabaseAccess
      read FDatabaseAccess write FDatabaseAccess;
  end;
{}
{    (ETransportError),    
 (ETransportServerError);     
(ETransportClientError)}
type
  ETransportError = class(ExceptionStd);
  ETransportServerError = class(ETransportError);
  ETransportClientError = class(ETransportError);
{}
type
  { : tsNone -   , tsInit - ,
  tsSend -   , tsReceive -   ,
  tsDone - }
  TTransportStatus = (tsNone, tsInit, tsSend, tsReceive, tsDone);
  {}
  TTransportDirectionProgress = record
    Delivered: Integer;     {   .  - }
    Total: Integer;         {    , (-1) - .}
    NotifiesSent: Integer;  { }
    NotifiesTotal: Integer; {   , (-1) - }
    BytesSent: Integer;     { }
    BytesReceived: Integer; { }
  end;
  {  }
  TTransportMessageProgress = record
    Status: TTransportStatus;   {  }
    BytesSent: Integer;         { }
    BytesSendTotal: Integer;    {   }
    BytesReceived: Integer;     { }
    BytesReceiveTotal: Integer; {   }
  end;
  {   }
  TTransportProgress = record
    Status: TTransportStatus;                      {}
    OutgoingProgress: TTransportDirectionProgress; { }
    IncomingProgress: TTransportDirectionProgress; { }
    PacketMessages: Integer;                       { .  }
    PacketDelivering: Boolean;                     {.  }
    PacketProgress: TTransportMessageProgress;     {  }
  end;
{   Value (InitTransportDirectionProgress,
InitTransportMessageProgress, InitTransportProgress)}
procedure InitTransportDirectionProgress(out Value:
  TTransportDirectionProgress);
procedure InitTransportMessageProgress(out Value: TTransportMessageProgress);
procedure InitTransportProgress(out Value: TTransportProgress);
{  Value, Value.Total,  , 
  Value.Delivered, Value.NotifiesTotal,  , 
  Value.NotifiesSent (CorrectTransportDirectionProgress); 
   Value, Value.BytesSendTotal,  ,
   Value.BytesSent, Value.BytesReceiveTotal, 
,    Value.BytesReceived
(CorrectTransportMessageProgress);    
 Value, Value.OutgoingProgress  Value.IncomingProgress
   CorrectTransportDirectionProgress,
Value.PacketProgress    CorrectTransportMessageProgress
(CorrectTransportProgress);     Value 
 AddValue   SumCounts,  NotIncreaseTotal  True 
   (AddTransportDirectionProgress,
AddTransportMessageProgress, AddTransportProgress)}
procedure CorrectTransportDirectionProgress(var Value:
  TTransportDirectionProgress);
procedure CorrectTransportMessageProgress(var Value:
  TTransportMessageProgress);
procedure CorrectTransportProgress(var Value: TTransportProgress);
procedure AddTransportDirectionProgress(var Value: TTransportDirectionProgress;
  const AddValue: TTransportDirectionProgress; NotIncreaseTotal: Boolean);
procedure AddTransportMessageProgress(var Value: TTransportMessageProgress;
  const AddValue: TTransportMessageProgress);
procedure AddTransportProgress(var Value: TTransportProgress;
  const AddValue: TTransportProgress; NotIncreaseTotal: Boolean);
{       Progress, 
  MaxValue,   Mode,   , 
  ,  ,     50%, 
    ,   -
    }
function TransportAggregateProgress(Progress: TTransportProgress;
  MaxValue: Integer; Mode: TDeliveryMode): Integer;
{       }
type
  TTransport = class(TObjectStd)
  private
    FMaxCount: Integer;
    FMaxSize: Integer;
    FIsBinary: Boolean;
    {$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
    FCompressionLevel: TCompressionLevel;
    FCompressExceededOnly: Boolean;
    {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}
    FStorage: TTransportStorage;
    FProgress: TTransportProgress;
    FLastProgressPercent: Integer;
    FLastTotalProgress: TTransportProgress;
    FProgressCleaned: Boolean;
    FLastMode: TDeliveryMode;
    FLastBodyExceeded: Boolean;
    {$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
    FLastCompressionLevel: TCompressionLevel;
    FLastCompressExceededOnly: Boolean;
    {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}
    FReceiveErrors: Integer;
    FSendErrors: Integer;
    FDeliveryCount: Integer;
    FMaxDeliveryCount: Integer;
    FNotIncreaseTotal: Boolean;
    FDict: Variant;
    FOnProcessMessages: TNotifyEventStd;
  protected
    function GetTotalProgress: TTransportProgress;
    function GetProgressPercent: Integer;
    function GetTotalProgressPercent: Integer;
    {}
    {  Data    IsEncode  True 
        IsEncode  False,  
     }
    function DataConvert(const Data: string; IsEncode: Boolean): string;
      virtual;
    {  Data   Mode,    , ,
      ,     ,
       OriginalResult,    
      ProcessMessages,      
      TProgressInfo     , 
        :    , ,
        ,      
    : ,       , }
    function DataDelivery(Mode: TDeliveryMode; const Data: string;
      out OriginalResult: string): string; virtual; abstract;
    {      Windows 
     ,  Progress  ,    
     ProcessMessages   TProgressInfo,   
     LastProgress, LastSubProgress, IsBeg, IsEnd,  :
    Name -  'TRNONE'      , 'TRINIT' 
    , 'TRSEND'   , 'TRRECV' - 
    , 'TRDONE'   ( 'TPNONE', 'TPINIT', 'TPSEND',
    'TPRECV', 'TPDONE' -    ),
    Source -  ,
    Data -     ,     1,
    Step -   ,
    SubStep -   ,
    MaxValue - (-1),     ( ),
    SubMaxValue - (-1),    ,   
      ,
    Progress -       
    ( ),
    SubProgress -   }
    procedure ProcessMessages(Sender: TObject); virtual;
    {       Mode}
    procedure MsgDelivery(Mode: TDeliveryMode); virtual; abstract;
  public
    constructor Create;
    {}
    {     }
    procedure ResetProgress;
    {       Mode,  LastMode  
    MsgDelivery}
    procedure Delivery(Mode: TDeliveryMode);
    {}
    {    True     ,
          DataConvert, 
        EncodeStr  Base64,   True
    (IsBinary);        
     ,    32760 (MaxCount);  
      ,      ,  
       ,   3/4  (MaxSize);
     ,   clDefault (CompressionLevel);  
    ,    ,   False
    (CompressExceededOnly)}
    property IsBinary: Boolean read FIsBinary write FIsBinary;
    property MaxCount: Integer read FMaxCount write FMaxCount;
    property MaxSize: Integer read FMaxSize write FMaxSize;
    {$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
    property CompressionLevel: TCompressionLevel
      read FCompressionLevel write FCompressionLevel;
    property CompressExceededOnly: Boolean
      read FCompressExceededOnly write FCompressExceededOnly;
    {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}
    {       () 
             }
    property Storage: TTransportStorage read FStorage write FStorage;
    {   (Progress);   
    ,   Progress  LastTotalProgress, 
          
    CorrectTransportProgress (TotalProgress);  
    (ProgressPercent);    (TotalProgressPercent); 
           Progress
       (LastTotalProgress);  
    ,   True      
    ResetProgress,   False   Delivery
    (ProgressCleaned)}
    property Progress: TTransportProgress read FProgress;
    property TotalProgress: TTransportProgress read GetTotalProgress;
    property ProgressPercent: Integer read GetProgressPercent;
    property TotalProgressPercent: Integer read GetTotalProgressPercent;
    property LastTotalProgress: TTransportProgress read FLastTotalProgress;
    property ProgressCleaned: Boolean read FProgressCleaned;
    {    Delivery,   [] (LastMode);
            
    (LastBodyExceeded);      
       DataConvert (LastCompressionLevel); 
          DataConvert, 
      ,    
    (LastCompressExceededOnly);     
            (ReceiveErrors);
     ,     (SendErrors); 
        Delivery (DeliveryCount); 
          Delivery, 
        (MaxDeliveryCount);
           TotalProgress,
      False (NotIncreaseTotal);  ,  
       ,  ,   
           ,   
    Unassigned (Dict)}
    property LastMode: TDeliveryMode read FLastMode;
    property LastBodyExceeded: Boolean read FLastBodyExceeded;
    {$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
    property LastCompressionLevel: TCompressionLevel
      read FLastCompressionLevel;
    property LastCompressExceededOnly: Boolean
      read FLastCompressExceededOnly;
    {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}
    property ReceiveErrors: Integer read FReceiveErrors write FReceiveErrors;
    property SendErrors: Integer read FSendErrors write FSendErrors;
    property DeliveryCount: Integer read FDeliveryCount write FDeliveryCount;
    property MaxDeliveryCount: Integer
      read FMaxDeliveryCount write FMaxDeliveryCount;
    property NotIncreaseTotal: Boolean
      read FNotIncreaseTotal write FNotIncreaseTotal;
    property Dict: Variant read FDict write FDict;
    {   ,    Sender 
     TProgressInfo,    ProcessMessages}
    property OnProcessMessages: TNotifyEventStd
      read FOnProcessMessages write FOnProcessMessages;
  end;
{}
{  }
type
  TTransportServer = class(TTransport)
  private
    FTransportMessage: TTransportMessage;
    FTransportAnswer: TTransportMessage;
    FDataStr: string;
    FResultStr: string;
  protected
    function TransportMessage: TTransportMessage;
    function TransportAnswer: TTransportMessage;
    {}
    {   CompressionLevel  LastCompressExceededOnly
      LastCompressionLevel  LastCompressExceededOnly }
    function DataConvert(const Data: string; IsEncode: Boolean): string;
      override;
    {   Mode = [dmSend]   DataStr  
    Data,    Mode = [dmReceive]    
     ResultStr}
    function DataDelivery(Mode: TDeliveryMode; const Data: string;
      out OriginalResult: string): string; override;
    {       Mode}
    procedure MsgDelivery(Mode: TDeliveryMode); override;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {   ,     (DataStr);
     , ,     
    (ResultStr)}
    property DataStr: string read FDataStr write FDataStr;
    property ResultStr: string read FResultStr write FResultStr;
  end;
{    TTransportServer  Data  
 OwnerId,   OppositeId, 
  WorkPlaceId,    WorkPlaceType, 
 ,     TTransportDBStorage,
       ConnectionString, ProcessMessages
  }
function TransportServerDelivery(const ConnectionString, OwnerId, OppositeId,
  WorkPlaceId, WorkPlaceType, Data: string;
  ProcessMessages: TNotifyEventStd): string;
{}
{  }
type
  TTransportClient = class(TTransport)
  private
    FTransportMessage: TTransportMessage;
    FProgress: TProgressProcessing;
  protected
    function TransportMessage: TTransportMessage;
    {}
    {        
    ServerAnswer,       StrToWritable,
           }
    function ExtractErrorMessage(const ServerAnswer: string): string; virtual;
    {       Mode}
    procedure MsgDelivery(Mode: TDeliveryMode); override;
  public
    constructor Create;
    destructor Destroy; override;
  end;
{-  }
type
  TTransportWebClient = class(TTransportClient)
  private
    FLink: string;
    FConfigName: string;
    FBlockSize: Integer;
    FProxy: TNullStr;
    FTimeout: Integer;
    FSrvDatabase: string;
    FSrvConnectionString: string;
    FSrvMaxBLOBSize: Integer;
    FSrvConnectionTimeout: Integer;
    FSrvCommandTimeout: Integer;
    FLogin: string;
    FPassword: string;
    FSODLogin: string;
    FSODPassword: string;
    FParentHandle: HWND;
    FOnClientCertRetrieve: TCertContextRetrieveEvent;
    FTransportServer: TTransportServer;
    FProgress: TProgressProcessing;
  protected
    {  ,    
    TProgressInfo(Sender).Name  'S'}
    procedure ServerProcessMessages(Sender: TObject); virtual;
    {     SrvConnectionString, 
    }
    function DataConvert(const Data: string; IsEncode: Boolean): string;
      override;
    {      Link}
    function DataDelivery(Mode: TDeliveryMode; const Data: string;
      out OriginalResult: string): string; override;
    {       -,
       HTTPExtractText, FromHStr,   
     }
    function ExtractErrorMessage(const ServerAnswer: string): string; override;
    {  -   }
    procedure ProcessMessages(Sender: TObject); override;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {        }
    function TransportServer: TTransportServer; virtual;
    {}
    {  (Link);   (ConfigName);  
     ,   2048  (BlockSize); ,  ,
     Null,      (Proxy);
        ,   0,  
        (Timeout);    ,
        ,   SQL, 
    'INTERBASE' (SrvDatabase);     , 
       ,   ,  
      Link   HTTP (SrvConnectionString);  
    BLOB-    ,     ,
      0,     (SrvMaxBLOBSize);
           ,  
      ,   0,    
      15  (SrvConnectionTimeout);    
       ,     ,
      0,       30 
    (SrvCommandTimeout); - (Login); - (Password); 
          (SODLogin); 
          (SODPassword); 
      (ParentHandle);    
     (OnClientCertRetrieve)}
    property Link: string read FLink write FLink;
    property ConfigName: string read FConfigName write FConfigName;
    property BlockSize: Integer read FBlockSize write FBlockSize;
    property Proxy: TNullStr read FProxy write FProxy;
    property Timeout: Integer read FTimeout write FTimeout;
    property SrvDatabase: string read FSrvDatabase write FSrvDatabase;
    property SrvConnectionString: string
      read FSrvConnectionString write FSrvConnectionString;
    property SrvMaxBLOBSize: Integer
      read FSrvMaxBLOBSize write FSrvMaxBLOBSize;
    property SrvConnectionTimeout: Integer
      read FSrvConnectionTimeout write FSrvConnectionTimeout;
    property SrvCommandTimeout: Integer
      read FSrvCommandTimeout write FSrvCommandTimeout;
    property Login: string read FLogin write FLogin;
    property Password: string read FPassword write FPassword;
    property SODLogin: string read FSODLogin write FSODLogin;
    property SODPassword: string read FSODPassword write FSODPassword;
    property ParentHandle: HWND read FParentHandle write FParentHandle;
    property OnClientCertRetrieve: TCertContextRetrieveEvent
      read FOnClientCertRetrieve write FOnClientCertRetrieve;
  end;

{      }
type
  TDocTypesFieldsNames = class(TObjectStd)
  private
    FDocTypes: TParamValues;
    FFieldsDocTypes: TIndexedStrings;
    FDocTypesFields: TObjList; {TParamValues}
    FExportFormat: TFieldsExportFormat;
    FExportStrings: TStringList;
  protected
    function GetDocTypes: TParamValues;
    function GetFieldsDocTypes: TIndexedStrings;
    function GetDocTypesFields(Index: Integer): TParamValues;
    function GetExportStr: string;
    procedure SetExportStr(const NewExportStr: string);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    procedure Clear;
    {  Fields       '.',
     ,   ,     
    'DOCTYPE',   'DOCTYPE'  'TYPE'   Value 
          , Mode  ,
    Params  ,  ,  AType  
    ,  Amount  ,  ACurrency  }
    procedure PrepareFields(Fields, Values: TStrings;
      const Mode, Params: string; out AType, Amount, ACurrency: string);
    {}
    {     (DocTypes);  , 
       DocTypesFields (FieldsDocTypes);   
    FieldsDocTypes   Index (DocTypesFields);  ,
      fefBinary (ExportFormat);     
    (ExportStr)}
    property DocTypes: TParamValues read GetDocTypes;
    property FieldsDocTypes: TIndexedStrings read GetFieldsDocTypes;
    property DocTypesFields[Index: Integer]: TParamValues
      read GetDocTypesFields;
    property ExportFormat: TFieldsExportFormat
      read FExportFormat write FExportFormat;
    property ExportStr: string read GetExportStr write SetExportStr;
  end;

{ XML}
type
  EXMLError = class(ENumProcError)
  private
    FTypeArray: string; {TErrorType}
    FLineNumberArray: string;
    FColumnNumberArray: string;
    FCodeArray: string;
    FMessageStrArray: string;
  protected
  public
    { 4-     TTypeError (TypeArray); 
    4-      
    (LineNumberArray);  4-    
       (ColumnNumberArray);  4- 
        (CodeArray);  
    GetStrFromArray c c   
    (MessageStrArray)}
    property TypeArray: string read FTypeArray write FTypeArray;
    property LineNumberArray: string
      read FLineNumberArray write FLineNumberArray;
    property ColumnNumberArray: string
      read FColumnNumberArray write FColumnNumberArray;
    property CodeArray: string read FCodeArray write FCodeArray;
    property MessageStrArray: string
      read FMessageStrArray write FMessageStrArray;
  end;
  EXMLErrorClass = class of EXMLError;
{  XML    Msg,  ErrorCode,  
 ProcName,  4-     TTypeError
TypeArray,      LineNumberArray, 
   ColumnNumberArray,   CodeArray,  
GetStrFromArray      MessageStrArray,
  XMLErrorClass,   nil,  MsgOnly = True 
    Msg}
function XMLErrorCreate(const Msg: string; ErrorCode: Integer; const ProcName,
  TypeArray, LineNumberArray, ColumnNumberArray, CodeArray,
  MessageStrArray: string; XMLErrorClass: EXMLErrorClass;
  MsgOnly: Boolean): EXMLError;
{  SAX- XML}
type
  TSAXContentHandler = class(TInterfacedObjectStd, ISAXContentHandler)
  private
    FNames: TStringList;
    FValues: TStringList;
    FOnElement: TNotifyEventStd;
  protected
    function putDocumentLocator(const pLocator: ISAXLocator): HRESULT; stdcall;
    function startDocument: HRESULT; stdcall;
    function endDocument: HRESULT; stdcall;
    function startPrefixMapping(pwchPrefix: PWideChar; cchPrefix: Integer;
      pwchUri: PWideChar; cchUri: Integer): HRESULT; stdcall;
    function endPrefixMapping(pwchPrefix: PWideChar;
      cchPrefix: Integer): HRESULT; stdcall;
    function startElement(pwchNamespaceUri: PWideChar;
      cchNamespaceUri: Integer; pwchLocalName: PWideChar;
      cchLocalName: Integer; pwchQName: PWideChar; cchQName: Integer;
      const pAttributes: ISAXAttributes): HRESULT; stdcall;
    function endElement(pwchNamespaceUri: PWideChar; cchNamespaceUri: Integer;
      pwchLocalName: PWideChar; cchLocalName: Integer; pwchQName: PWideChar;
      cchQName: Integer): HRESULT; stdcall;
    function characters(pwchChars: PWideChar;
      cchChars: Integer): HRESULT; stdcall;
    function ignorableWhitespace(pwchChars: PWideChar;
      cchChars: Integer): HRESULT; stdcall;
    function processingInstruction(pwchTarget: PWideChar; cchTarget: Integer;
      pwchData: PWideChar; cchData: Integer): HRESULT; stdcall;
    function skippedEntity(pwchName: PWideChar;
      cchName: Integer): HRESULT; stdcall;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  ,   ,  ,    ,
        (Names);    ,
      ,    , ,  
      ,    ,    
    (Values)}
    property Names: TStringList read FNames;
    property Values: TStringList read FValues;
    {,         
      }
    property OnElement: TNotifyEventStd read FOnElement write FOnElement;
  end;
{    SAX    XML}
type
  TSAXErrorHandler = class(TInterfacedObjectStd, ISAXErrorHandler)
  private
    FTypes: TList; {TErrorType}
    FLineNumbers: TList;
    FColumnNumbers: TList;
    FCodes: TList;
    FMessages: TStringList;
    FIndexes: array[etFatalError..etWarning] of TList;
    {}
    function GetCount(ErrorType: TErrorType): Integer;
    function GetType(ErrorIndex: Integer): TErrorType;
    function GetLineNumber(ErrorType: TErrorType;
      ErrorIndex: Integer): Integer;
    function GetColumnNumber(ErrorType: TErrorType;
      ErrorIndex: Integer): Integer;
    function GetCode(ErrorType: TErrorType; ErrorIndex: Integer): Integer;
    function GetMessage(ErrorType: TErrorType; ErrorIndex: Integer): string;
  protected
    function error(const pLocator: ISAXLocator; pwchErrorMessage: PWideChar;
      hrErrorCode: HRESULT): HRESULT; stdcall;
    function fatalError(const pLocator: ISAXLocator;
      pwchErrorMessage: PWideChar; hrErrorCode: HRESULT): HRESULT; stdcall;
    function ignorableWarning(const pLocator: ISAXLocator;
      pwchErrorMessage: PWideChar; hrErrorCode: HRESULT): HRESULT; stdcall;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { (Clear);     ErrorType, 
     etUndefined  etFatalError,   LineNumber,
      ColumnNumber,  Code,  Msg (Add)}
    procedure Clear;
    procedure Add(ErrorType: TErrorType; LineNumber, ColumnNumber,
      Code: Integer; const Msg: string);
    function ErrorCreate(const Msg: string; ErrorCode: Integer;
      const ProcName: string; XMLErrorClass: EXMLErrorClass;
      MsgOnly: Boolean): EXMLError;
    {}
    {    ErrorType,  etUndefined 
        (Count);     ErrorIndex
        (Types);  ,   ,  
     ,    , ,  
    ErrorType,  etUndefined     
     , ErrorIndex      
    (LineNumbers, ColumnNumbers, Codes, Messages)}
    property Count[ErrorType: TErrorType]: Integer read GetCount;
    property Types[ErrorIndex: Integer]: TErrorType read GetType;
    property LineNumbers[ErrorType: TErrorType; ErrorIndex: Integer]: Integer
      read GetLineNumber;
    property ColumnNumbers[ErrorType: TErrorType; ErrorIndex: Integer]: Integer
      read GetColumnNumber;
    property Codes[ErrorType: TErrorType; ErrorIndex: Integer]: Integer
      read GetCode;
    property Messages[ErrorType: TErrorType; ErrorIndex: Integer]: string
      read GetMessage;
  end;
{ XML   SAX,  , 
 Internet Explorer 4.0  ,  XML    Stream,
  nil   FileName,     
XML      IStream, ISequentialStream
 IXMLDOMDocument  Value,       ,
      ,  
TSAXContentHandler,   nil,     
   TSAXContentHandler,    
 EXMLError}
procedure SAXXMLReaderParse(Stream: TStream; const FileName: string;
  const Value: OleVariant; OnElement: TNotifyEventStd);
{ XML    ,      SAX, 
,   Internet Explorer 4.0  ,   
  EXMLError}
type
  TSAXXMLWriter = class
  private
    FEncoding: string;
    FNoDeclaration: Boolean;
    FInterfacedStream: TInterfacedStream;
    FXMLWriter: IMXWriter;
    FContentHandler: ISAXContentHandler;
    FIsFlushed: Boolean;
    FDocumentStarted: Boolean;
    FNames: TStringList;
  protected
    function GetValue: string;
    function GetOutput: OleVariant;
    procedure SetDocumentStarted(NewDocumentStarted: Boolean);
    function GetNames: TStringList;
  public
    {    XML   Stream,   nil
         FileName,      Value,
        ,   Value,
      Null   ,   Output,
       'UTF-16',    Encoding 
    ,     'windows-1251',
     NoDeclaration  True    XML}
    constructor Create(Stream: TStream; const FileName: string;
      Value: OleVariant; const Encoding: string; NoDeclaration: Boolean);
    destructor Destroy; override;
    {}
    {  }
    procedure Flush;
    {   (StartDocument);   
    (EndDocument);      Name   Attributes,
         nil (StartElement);  
       Name (EndElement);   Value (Characters)}
    procedure StartDocument;
    procedure EndDocument;
    procedure StartElement(const Name: string; Attributes: ISAXAttributes);
    procedure EndElement(const Name: string);
    procedure Characters(const Value: string);
    {    Name,  Attributes,   nil, 
    Value,  ,  Name     
     ,           
    Names,        ,
     NotEnd  True    ,   
      ,    , 
          
      }
    procedure Write(const Name, Value: string; Attributes: ISAXAttributes;
      NotEnd: Boolean);
    {}
    {    XML   (Value);  
       XML    (Output);  
       True,       
           False,  
      (DocumentStarted);    
       (Names)}
    property Value: string read GetValue;
    property Output: OleVariant read GetOutput;
    property DocumentStarted: Boolean
      read FDocumentStarted write SetDocumentStarted;
    property Names: TStringList read GetNames;
  end;
{    XML}
type
  TXML = class(TCustomFormat)
  private
    FTDEDIFDocTypeIds: TIndexedStrings;
    FTDEDIFDocTypeNames: TIndexedStrings;
    FTDEDIFFieldIds: TIndexedStrings;
    FTDEDIFFieldTypes: TIndexedList;
    FTDEDIFFieldNames: TIndexedStrings;
    FTDEDIFFieldIdsDocType: TIndexedStrings;
    FTDEDIFFieldIdsDocTypeEncoding: TIndexedList; {TTDEDIFEncoding}
    FTDEDIFFieldIdsDocTypeDefIndex: Integer;
    FTDEDIFFieldIdsDocTypeDefIdIndex: Integer;
    FTagBegin: string;
    FXMLDocTypes: TIndexedStrings;
    FTDEDIFDocTypes: TIndexedStrings;
    FTDEDIFDocTypesIndexes: TIndexedList;
    FXMLFieldFiles: TStringList;
    FXMLFields: TObjList; {TIndexedStrings}
    FTDEDIFFields: TObjList; {TIndexedStrings}
    FTDEDIFAltFields: TObjList; {TIndexedStrings}
    FTDEDIFAltFieldPositions: TObjList; {TList}
    FTDEDIFAltFieldCounts: TObjList; {TList}
    FTDEDIFFieldIndexes: TObjList; {TIndexedList}
    FXMLFieldsValueFiles: TObjList; {TIndexedStrings}
    FXMLFieldsValues: TObjList; {TObjList, TIndexedStrings}
    FXMLFieldsValueIndexes: TObjList; {TObjList, TIndexedList}
    FTDEDIFFieldsValues: TObjList; {TObjList, TIndexedStrings}
    FStoredFields: TStringList;
    FStoredValues: TStringList;
    FStoredIndexes: TIndexedList;
    FStoredFieldIndexes: TIndexedList;
    FStoredIndexed: TIndexedStrings;
    FMainIni: TStreamIni;
    FTypesIni: TStreamIni;
    FFieldsIni: TStreamIni;
    FTypesMap: TStreamIni;
    FFieldsMap: TStreamIni;
    FValuesMap: TStreamIni;
    FTDEDIFWriter: TTDEDIFWriter;
    FXMLDocTypeIndex: TNullInt;
    FTDEDIFEncoding: TTDEDIFEncoding;
    FCacheStream: TCacheStream;
    FSAXXMLWriter: TSAXXMLWriter;
  protected
    procedure UpdateXMLFields(XMLDocTypeIndex: Integer);
    procedure UpdateXMLFieldValues(XMLDocTypeIndex,
      XMLFieldIndex: Integer);
    procedure UpdateTDEDIFDocTypesIndexes;
    procedure UpdateTDEDIFFieldIndexes(XMLDocTypeIndex: Integer);
    procedure UpdateTDEDIFFieldIdsDocTypeDefIndex;
    procedure WhenImportElement(Sender: TObject);
    {}
    function GetXMLFields(XMLDocTypeIndex: Integer): TIndexedStrings;
    function GetTDEDIFFields(XMLDocTypeIndex: Integer): TIndexedStrings;
    function GetTDEDIFAltFields(XMLDocTypeIndex: Integer): TIndexedStrings;
    function GetTDEDIFAltFieldPositions(XMLDocTypeIndex: Integer): TList;
    function GetTDEDIFAltFieldCounts(XMLDocTypeIndex: Integer): TList;
    function GetXMLFieldsValueFiles(XMLDocTypeIndex: Integer;
      ReturnAssigned: Boolean): TIndexedStrings;
    function GetXMLFieldsValues(XMLDocTypeIndex,
      XMLFieldIndex: Integer; ReturnAssigned: Boolean): TIndexedStrings;
    function GetXMLFieldsValueIndexes(XMLDocTypeIndex,
      XMLFieldIndex: Integer; ReturnAssigned: Boolean): TIndexedList;
    function GetTDEDIFFieldsValues(XMLDocTypeIndex,
      XMLFieldIndex: Integer; ReturnAssigned: Boolean): TIndexedStrings;
  public
    constructor Create; override;
    destructor Destroy; override;
    {}
    procedure ClearConfig; override;
    procedure LoadConfig(const FileName: string); override;
    function AnExport(TDEDIFReader: TTDEDIFReader;
      Mode: TProcessMode): Boolean; override;
    function AnImport(TDEDIFWriter: TTDEDIFWriter): Boolean; override;
    {   TDEDIF Value    XML  
    XMLFieldIndex      XMLDocTypeIndex, 
      ,   Found  True, 
      ,  False,      Value
    (FromTDEDIFValue);    XML   TDEDIF
    (ToTDEDIFValue)}
    function FromTDEDIFValue(XMLDocTypeIndex, XMLFieldIndex: Integer;
      const Value: string; Found: PBooleanStd): string;
    function ToTDEDIFValue(XMLDocTypeIndex, XMLFieldIndex: Integer;
      const Value: string; Found: PBooleanStd): string;
    {}
    {       
    TDEDIF (TDEDIFDocTypeIds, TDEDIFDocTypeNames);   
       TVarBaseType    (TDEDIFFieldIds,
    TDEDIFFieldTypes, TDEDIFFieldNames);   ,
        TDEDIF   
      TTDEDIFEncoding,   'DOCTYPE'  
     tdeCPP  'MTYD'    tdeNone
    (TDEDIFFieldIdsDocType, TDEDIFFieldIdsDocTypeEncoding);  ,
      ,  ,   (-1),  
           TDEDIFFieldIds, 
        ,   0 (TDEDIFFieldIdsDocTypeDefIndex);
        TDEDIFFieldIds
    (TDEDIFFieldIdsDocTypeDefIdIndex)}
    property TDEDIFDocTypeIds: TIndexedStrings read FTDEDIFDocTypeIds;
    property TDEDIFDocTypeNames: TIndexedStrings read FTDEDIFDocTypeNames;
    property TDEDIFFieldIds: TIndexedStrings read FTDEDIFFieldIds;
    property TDEDIFFieldTypes: TIndexedList read FTDEDIFFieldTypes;
    property TDEDIFFieldNames: TIndexedStrings read FTDEDIFFieldNames;
    property TDEDIFFieldIdsDocType: TIndexedStrings
      read FTDEDIFFieldIdsDocType;
    property TDEDIFFieldIdsDocTypeEncoding: TIndexedList
      read FTDEDIFFieldIdsDocTypeEncoding;
    property TDEDIFFieldIdsDocTypeDefIndex: Integer
      read FTDEDIFFieldIdsDocTypeDefIndex write FTDEDIFFieldIdsDocTypeDefIndex;
    property TDEDIFFieldIdsDocTypeDefIdIndex: Integer
      read FTDEDIFFieldIdsDocTypeDefIdIndex
      write FTDEDIFFieldIdsDocTypeDefIdIndex;
    { ,        'S'  
    (TagBegin);   XML      TDEDIF
    (XMLDocTypes, TDEDIFDocTypes);     
       XML   TDEDIF     XML,
           ,    
      (XMLFieldFiles);     XML
      XMLDocTypeIndex      TDEDIF,
       TDEDIF     
      XML,      ,  
      ,      
          (XMLFields, TDEDIFFields,
    TDEDIFAltFields, TDEDIFAltFieldPositions, TDEDIFAltFieldCounts); 
      ,     XML  
    XMLFieldIndex   XML   XMLDocTypeIndex, 
      XMLFieldsValues     TDEDIF
    TDEDIFFieldsValues,  ReturnAssigned = False    nil
       (XMLFieldsValueFiles, XMLFieldsValues,
    XMLFieldsValueIndexes, TDEDIFFieldsValues)}
    property TagBegin: string read FTagBegin;
    property XMLDocTypes: TIndexedStrings read FXMLDocTypes;
    property TDEDIFDocTypes: TIndexedStrings read FTDEDIFDocTypes;
    property XMLFieldFiles: TStringList read FXMLFieldFiles;
    property XMLFields[XMLDocTypeIndex: Integer]: TIndexedStrings
      read GetXMLFields;
    property TDEDIFFields[XMLDocTypeIndex: Integer]: TIndexedStrings
      read GetTDEDIFFields;
    property TDEDIFAltFields[XMLDocTypeIndex: Integer]: TIndexedStrings
      read GetTDEDIFAltFields;
    property TDEDIFAltFieldPositions[XMLDocTypeIndex: Integer]: TList
      read GetTDEDIFAltFieldPositions;
    property TDEDIFAltFieldCounts[XMLDocTypeIndex: Integer]: TList
      read GetTDEDIFAltFieldCounts;
    property XMLFieldsValueFiles[XMLDocTypeIndex: Integer;
      ReturnAssigned: Boolean]: TIndexedStrings read GetXMLFieldsValueFiles;
    property XMLFieldsValues[XMLDocTypeIndex, XMLFieldIndex: Integer;
      ReturnAssigned: Boolean]: TIndexedStrings read GetXMLFieldsValues;
    property XMLFieldsValueIndexes[XMLDocTypeIndex,
      XMLFieldIndex: Integer; ReturnAssigned: Boolean]: TIndexedList
      read GetXMLFieldsValueIndexes;
    property TDEDIFFieldsValues[XMLDocTypeIndex, XMLFieldIndex: Integer;
      ReturnAssigned: Boolean]: TIndexedStrings read GetTDEDIFFieldsValues;
  end;

{   Commtask.exe}
type
  TCommtask = class
  private
    FHeaderIni: TStreamIni;
    FBodyStrings: TStringList;
    FConfigIniFileName: string;
    FConfigIni: TStreamIni;
    FExchangeIniFileName: string;
    FExchangeIni: TStreamIni;
    FNullExchangeIniInfo: TNullExchangeIniInfo;
    FDatabaseAccess: TCustomDatabaseAccess;
    FDatabaseAccessAddrBook: TCustomDatabaseAccess;
    FCACertificate: string;
    FCertificate: string;
    FCertStore: string;
    FWebLogDays: Integer;
    FConvertCount: Integer;
    FMaxConvertCount: Integer;
    FProcessMessages: TNotifyEventStd;
    FMailSODColumns: string;
    FMailSODCreateSQL: string;
  protected
    function HeaderIni: TStreamIni;
    function BodyStrings: TStringList;
    procedure DeleteAttaches(const Path: string);
    procedure MakeNotify(IsConfirmed: Boolean; ErrorCode: Integer;
      DateTime: TDateTime; const InPath, NSNReason: string);
    {}
    function GetConfigIni: TStreamIni;
    function GetExchangeIni: TStreamIni;
    function GetExchangeIniInfo: TExchangeIniInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {       ,
            
    (ImportAddrBookFromDatabase);     
    (ImportOutgingToDatabase);     
    (ExportNotifiesFromDatabase);     
    (ExportIncomingFromDatabase);   
       (ClearProcessedInDatabase);   Commtask,
       , CmdLine     
     (RunCommtask)}
    procedure InitDatabase;
    procedure ImportAddrBookFromDatabase;
    procedure ImportOutgingToDatabase;
    procedure ExportNotifiesFromDatabase;
    procedure ExportIncomingFromDatabase;
    procedure ClearProcessedInDatabase;
    procedure RunCommtask(CmdLine: string);
    {}
    {    ,     
      '.ini' (ConfigIniFileName);    ,
        ConfigIniFileName   
      (ConfigIni);      ,  
    'exchange.ini'     
    (ExchangeIniFileName);     ,  
       ExchangeIniFileName     
    (ExchangeIni);      
    (ExchangeIniInfo);     (DatabaseAccess);  
            
    (DatabaseAccessAddrBook);    
    (CACertificate);   (Certificate);   
     ,   'CA' (CertStore);  ,
        WEBLOG,   90 (WebLogDays); 
         
    ImportOutgingToDatabase (ConvertCount);  
      ,   
    ImportOutgingToDatabase  (MaxConvertCount); 
        (ProcessMessages)}
    property ConfigIniFileName: string
      read FConfigIniFileName write FConfigIniFileName;
    property ConfigIni: TStreamIni read GetConfigIni;
    property ExchangeIniFileName: string
      read FExchangeIniFileName write FExchangeIniFileName;
    property ExchangeIni: TStreamIni read GetExchangeIni;
    property ExchangeIniInfo: TExchangeIniInfo read GetExchangeIniInfo;
    property DatabaseAccess: TCustomDatabaseAccess
      read FDatabaseAccess write FDatabaseAccess;
    property DatabaseAccessAddrBook: TCustomDatabaseAccess
      read FDatabaseAccessAddrBook write FDatabaseAccessAddrBook;
    property CACertificate: string read FCACertificate write FCACertificate;
    property Certificate: string read FCertificate write FCertificate;
    property CertStore: string read FCertStore write FCertStore;
    property WebLogDays: Integer read FWebLogDays write FWebLogDays;
    property ConvertCount: Integer read FConvertCount write FConvertCount;
    property MaxConvertCount: Integer
      read FMaxConvertCount write FMaxConvertCount;
    property ProcessMessages: TNotifyEventStd
      read FProcessMessages write FProcessMessages;
  end;
{ True,     Commtask.exe,
     "I", 'U"  "P"   ,
    RetrieveCmdPrm,   
 True,       exchange.ini,
  ExchangeIniFileName    exchange.ini  ,
   "I"     }
function UseCommtask(out ExchangeIniFileName: string): Boolean;

